#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 12
#define STATE_COUNT 3235
#define LARGE_STATE_COUNT 639
#define SYMBOL_COUNT 320
#define ALIAS_COUNT 7
#define TOKEN_COUNT 147
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 36
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_typeof = 12,
  anon_sym_type = 13,
  anon_sym_interface = 14,
  anon_sym_declare = 15,
  anon_sym_global = 16,
  anon_sym_module = 17,
  anon_sym_DOT = 18,
  anon_sym_COLON = 19,
  anon_sym_import = 20,
  anon_sym_const = 21,
  anon_sym_enum = 22,
  anon_sym_from = 23,
  anon_sym_var = 24,
  anon_sym_let = 25,
  anon_sym_BANG = 26,
  anon_sym_else = 27,
  anon_sym_if = 28,
  anon_sym_switch = 29,
  anon_sym_for = 30,
  anon_sym_LPAREN = 31,
  anon_sym_RPAREN = 32,
  anon_sym_await = 33,
  anon_sym_in = 34,
  anon_sym_of = 35,
  anon_sym_while = 36,
  anon_sym_do = 37,
  anon_sym_try = 38,
  anon_sym_with = 39,
  anon_sym_break = 40,
  anon_sym_continue = 41,
  anon_sym_debugger = 42,
  anon_sym_return = 43,
  anon_sym_throw = 44,
  anon_sym_SEMI = 45,
  anon_sym_case = 46,
  anon_sym_catch = 47,
  anon_sym_finally = 48,
  anon_sym_yield = 49,
  anon_sym_LBRACK = 50,
  anon_sym_RBRACK = 51,
  anon_sym_class = 52,
  anon_sym_async = 53,
  anon_sym_function = 54,
  anon_sym_EQ_GT = 55,
  anon_sym_abstract = 56,
  anon_sym_get = 57,
  anon_sym_set = 58,
  anon_sym_QMARK = 59,
  anon_sym_implements = 60,
  anon_sym_extends = 61,
  anon_sym_QMARK_DOT = 62,
  anon_sym_new = 63,
  anon_sym_PLUS_EQ = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_STAR_EQ = 66,
  anon_sym_SLASH_EQ = 67,
  anon_sym_PERCENT_EQ = 68,
  anon_sym_CARET_EQ = 69,
  anon_sym_AMP_EQ = 70,
  anon_sym_PIPE_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_GT_GT_GT_EQ = 73,
  anon_sym_LT_LT_EQ = 74,
  anon_sym_STAR_STAR_EQ = 75,
  anon_sym_AMP_AMP_EQ = 76,
  anon_sym_PIPE_PIPE_EQ = 77,
  anon_sym_QMARK_QMARK_EQ = 78,
  anon_sym_DOT_DOT_DOT = 79,
  anon_sym_AMP_AMP = 80,
  anon_sym_PIPE_PIPE = 81,
  anon_sym_GT_GT = 82,
  anon_sym_GT_GT_GT = 83,
  anon_sym_LT_LT = 84,
  anon_sym_AMP = 85,
  anon_sym_CARET = 86,
  anon_sym_PIPE = 87,
  anon_sym_PLUS = 88,
  anon_sym_DASH = 89,
  anon_sym_SLASH = 90,
  anon_sym_PERCENT = 91,
  anon_sym_STAR_STAR = 92,
  anon_sym_LT = 93,
  anon_sym_LT_EQ = 94,
  anon_sym_EQ_EQ = 95,
  anon_sym_EQ_EQ_EQ = 96,
  anon_sym_BANG_EQ = 97,
  anon_sym_BANG_EQ_EQ = 98,
  anon_sym_GT_EQ = 99,
  anon_sym_GT = 100,
  anon_sym_QMARK_QMARK = 101,
  anon_sym_instanceof = 102,
  anon_sym_TILDE = 103,
  anon_sym_void = 104,
  anon_sym_delete = 105,
  anon_sym_PLUS_PLUS = 106,
  anon_sym_DASH_DASH = 107,
  anon_sym_DQUOTE = 108,
  aux_sym_string_token1 = 109,
  anon_sym_SQUOTE = 110,
  aux_sym_string_token2 = 111,
  sym_escape_sequence = 112,
  sym_comment = 113,
  anon_sym_BQUOTE = 114,
  anon_sym_DOLLAR_LBRACE = 115,
  anon_sym_SLASH2 = 116,
  sym_regex_pattern = 117,
  sym_regex_flags = 118,
  sym_number = 119,
  anon_sym_target = 120,
  sym_this = 121,
  sym_super = 122,
  sym_true = 123,
  sym_false = 124,
  sym_null = 125,
  anon_sym_AT = 126,
  anon_sym_static = 127,
  anon_sym_require = 128,
  anon_sym_public = 129,
  anon_sym_private = 130,
  anon_sym_protected = 131,
  anon_sym_any = 132,
  anon_sym_number = 133,
  anon_sym_boolean = 134,
  anon_sym_string = 135,
  anon_sym_symbol = 136,
  anon_sym_LBRACE_PIPE = 137,
  anon_sym_PIPE_RBRACE = 138,
  anon_sym_DASH_QMARK_COLON = 139,
  anon_sym_QMARK_COLON = 140,
  anon_sym_is = 141,
  anon_sym_asserts = 142,
  sym_readonly = 143,
  anon_sym_keyof = 144,
  sym__automatic_semicolon = 145,
  sym__template_chars = 146,
  sym_program = 147,
  sym_export_statement = 148,
  sym_export_clause = 149,
  sym__import_export_specifier = 150,
  sym__declaration = 151,
  sym_type_alias_declaration = 152,
  sym_interface_declaration = 153,
  sym_ambient_declaration = 154,
  sym_import_alias = 155,
  sym_enum_declaration = 156,
  sym_enum_body = 157,
  sym_enum_assignment = 158,
  sym_import = 159,
  sym_import_statement = 160,
  sym_import_clause = 161,
  sym__from_clause = 162,
  sym_namespace_import = 163,
  sym_named_imports = 164,
  sym_expression_statement = 165,
  sym_variable_declaration = 166,
  sym_lexical_declaration = 167,
  sym_variable_declarator = 168,
  sym_statement_block = 169,
  sym_else_clause = 170,
  sym_if_statement = 171,
  sym_switch_statement = 172,
  sym_for_statement = 173,
  sym_for_in_statement = 174,
  sym__for_header = 175,
  sym_while_statement = 176,
  sym_do_statement = 177,
  sym_try_statement = 178,
  sym_with_statement = 179,
  sym_break_statement = 180,
  sym_continue_statement = 181,
  sym_debugger_statement = 182,
  sym_return_statement = 183,
  sym_throw_statement = 184,
  sym_empty_statement = 185,
  sym_labeled_statement = 186,
  sym_switch_body = 187,
  sym_switch_case = 188,
  sym_switch_default = 189,
  sym_catch_clause = 190,
  sym_finally_clause = 191,
  sym_parenthesized_expression = 192,
  sym__expression = 193,
  sym_yield_expression = 194,
  sym_object = 195,
  sym_assignment_pattern = 196,
  sym_array = 197,
  sym_nested_identifier = 198,
  sym_class = 199,
  sym_class_declaration = 200,
  sym_class_heritage = 201,
  sym_function = 202,
  sym_function_declaration = 203,
  sym_generator_function = 204,
  sym_generator_function_declaration = 205,
  sym_arrow_function = 206,
  sym_as_expression = 207,
  sym_non_null_expression = 208,
  sym_module = 209,
  sym_internal_module = 210,
  sym__module = 211,
  sym_abstract_class_declaration = 212,
  sym_abstract_method_signature = 213,
  sym_implements_clause = 214,
  sym_extends_clause = 215,
  sym_function_signature = 216,
  sym__call_signature = 217,
  sym_call_expression = 218,
  sym_new_expression = 219,
  sym_await_expression = 220,
  sym_member_expression = 221,
  sym_subscript_expression = 222,
  sym_assignment_expression = 223,
  sym__augmented_assignment_lhs = 224,
  sym_augmented_assignment_expression = 225,
  sym__initializer = 226,
  sym_spread_element = 227,
  sym_ternary_expression = 228,
  sym_binary_expression = 229,
  sym_unary_expression = 230,
  sym_update_expression = 231,
  sym_sequence_expression = 232,
  sym_string = 233,
  sym_template_string = 234,
  sym_template_substitution = 235,
  sym_regex = 236,
  sym_meta_property = 237,
  sym_arguments = 238,
  sym_decorator = 239,
  sym_decorator_member_expression = 240,
  sym_decorator_call_expression = 241,
  sym_class_body = 242,
  sym_public_field_definition = 243,
  sym_import_require_clause = 244,
  sym_labeled_tuple_type_member = 245,
  sym__number = 246,
  sym_optional_parameter = 247,
  sym_formal_parameters = 248,
  sym_rest_parameter = 249,
  sym_method_definition = 250,
  sym_pair = 251,
  sym__property_name = 252,
  sym_computed_property_name = 253,
  sym_required_parameter = 254,
  sym__parameter_name = 255,
  sym_type_assertion = 256,
  sym_type_arguments = 257,
  sym__type = 258,
  sym_type_annotation = 259,
  sym__primary_type = 260,
  sym_parenthesized_type = 261,
  sym_predefined_type = 262,
  sym_nested_type_identifier = 263,
  sym_generic_type = 264,
  sym_object_type = 265,
  sym_call_signature = 266,
  sym__rest_identifier = 267,
  sym_rest_identifier = 268,
  sym_index_signature = 269,
  sym_omitting_type_annotation = 270,
  sym_opting_type_annotation = 271,
  sym_mapped_type_clause = 272,
  sym_construct_signature = 273,
  sym_method_signature = 274,
  sym_type_predicate = 275,
  sym_type_predicate_annotation = 276,
  sym_asserts = 277,
  sym_property_signature = 278,
  sym_accessibility_modifier = 279,
  sym_array_type = 280,
  sym_tuple_type = 281,
  sym__tuple_type_body = 282,
  sym__tuple_type_member = 283,
  sym__tuple_type_identifier = 284,
  sym_optional_identifier = 285,
  sym_flow_maybe_type = 286,
  sym_type_query = 287,
  sym_index_type_query = 288,
  sym_existential_type = 289,
  sym_literal_type = 290,
  sym_lookup_type = 291,
  sym_conditional_type = 292,
  sym_union_type = 293,
  sym_intersection_type = 294,
  sym_function_type = 295,
  sym_type_parameters = 296,
  sym_type_parameter = 297,
  sym_constraint = 298,
  sym_default_type = 299,
  sym_constructor_type = 300,
  aux_sym_program_repeat1 = 301,
  aux_sym_export_statement_repeat1 = 302,
  aux_sym_export_clause_repeat1 = 303,
  aux_sym_enum_body_repeat1 = 304,
  aux_sym_named_imports_repeat1 = 305,
  aux_sym_variable_declaration_repeat1 = 306,
  aux_sym_switch_body_repeat1 = 307,
  aux_sym_object_repeat1 = 308,
  aux_sym_array_repeat1 = 309,
  aux_sym_implements_clause_repeat1 = 310,
  aux_sym_extends_clause_repeat1 = 311,
  aux_sym_string_repeat1 = 312,
  aux_sym_string_repeat2 = 313,
  aux_sym_template_string_repeat1 = 314,
  aux_sym_class_body_repeat1 = 315,
  aux_sym_formal_parameters_repeat1 = 316,
  aux_sym_object_type_repeat1 = 317,
  aux_sym__tuple_type_body_repeat1 = 318,
  aux_sym_type_parameters_repeat1 = 319,
  alias_sym_array_pattern = 320,
  alias_sym_import_specifier = 321,
  alias_sym_object_pattern = 322,
  alias_sym_property_identifier = 323,
  alias_sym_shorthand_property_identifier = 324,
  alias_sym_statement_identifier = 325,
  alias_sym_type_identifier = 326,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_type] = "type",
  [anon_sym_interface] = "interface",
  [anon_sym_declare] = "declare",
  [anon_sym_global] = "global",
  [anon_sym_module] = "module",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON] = ":",
  [anon_sym_import] = "import",
  [anon_sym_const] = "const",
  [anon_sym_enum] = "enum",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_implements] = "implements",
  [anon_sym_extends] = "extends",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_require] = "require",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_is] = "is",
  [anon_sym_asserts] = "asserts",
  [sym_readonly] = "readonly",
  [anon_sym_keyof] = "keyof",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym__declaration] = "_declaration",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_import_alias] = "import_alias",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym_as_expression] = "as_expression",
  [sym_non_null_expression] = "non_null_expression",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_implements_clause] = "implements_clause",
  [sym_extends_clause] = "extends_clause",
  [sym_function_signature] = "function_signature",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_import_require_clause] = "import_require_clause",
  [sym_labeled_tuple_type_member] = "labeled_tuple_type_member",
  [sym__number] = "unary_expression",
  [sym_optional_parameter] = "optional_parameter",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_required_parameter] = "required_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_assertion] = "type_assertion",
  [sym_type_arguments] = "type_arguments",
  [sym__type] = "_type",
  [sym_type_annotation] = "type_annotation",
  [sym__primary_type] = "_primary_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_generic_type] = "generic_type",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym__rest_identifier] = "_rest_identifier",
  [sym_rest_identifier] = "rest_identifier",
  [sym_index_signature] = "index_signature",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_construct_signature] = "construct_signature",
  [sym_method_signature] = "method_signature",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym_asserts] = "asserts",
  [sym_property_signature] = "property_signature",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym__tuple_type_body] = "_tuple_type_body",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym__tuple_type_identifier] = "_tuple_type_identifier",
  [sym_optional_identifier] = "optional_identifier",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_existential_type] = "existential_type",
  [sym_literal_type] = "literal_type",
  [sym_lookup_type] = "lookup_type",
  [sym_conditional_type] = "conditional_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_constraint] = "constraint",
  [sym_default_type] = "default_type",
  [sym_constructor_type] = "constructor_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym__tuple_type_body_repeat1] = "_tuple_type_body_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_asserts] = anon_sym_asserts,
  [sym_readonly] = sym_readonly,
  [anon_sym_keyof] = anon_sym_keyof,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_import_alias] = sym_import_alias,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym_as_expression] = sym_as_expression,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_implements_clause] = sym_implements_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym_function_signature] = sym_function_signature,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_labeled_tuple_type_member] = sym_labeled_tuple_type_member,
  [sym__number] = sym_unary_expression,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_required_parameter] = sym_required_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_type_assertion] = sym_type_assertion,
  [sym_type_arguments] = sym_type_arguments,
  [sym__type] = sym__type,
  [sym_type_annotation] = sym_type_annotation,
  [sym__primary_type] = sym__primary_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_generic_type] = sym_generic_type,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym__rest_identifier] = sym__rest_identifier,
  [sym_rest_identifier] = sym_rest_identifier,
  [sym_index_signature] = sym_index_signature,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_construct_signature] = sym_construct_signature,
  [sym_method_signature] = sym_method_signature,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym_asserts] = sym_asserts,
  [sym_property_signature] = sym_property_signature,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym__tuple_type_body] = sym__tuple_type_body,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym__tuple_type_identifier] = sym__tuple_type_identifier,
  [sym_optional_identifier] = sym_optional_identifier,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_existential_type] = sym_existential_type,
  [sym_literal_type] = sym_literal_type,
  [sym_lookup_type] = sym_lookup_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_constraint] = sym_constraint,
  [sym_default_type] = sym_default_type,
  [sym_constructor_type] = sym_constructor_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym__tuple_type_body_repeat1] = aux_sym__tuple_type_body_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_tuple_type_member] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__rest_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_rest_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_body] = {
    .visible = false,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym__tuple_type_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tuple_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_sign = 31,
  field_source = 32,
  field_type = 33,
  field_type_arguments = 34,
  field_type_parameters = 35,
  field_value = 36,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[200] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [14] = {.index = 9, .length = 1},
  [15] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [18] = {.index = 12, .length = 2},
  [19] = {.index = 14, .length = 2},
  [20] = {.index = 16, .length = 2},
  [21] = {.index = 18, .length = 2},
  [22] = {.index = 20, .length = 2},
  [23] = {.index = 22, .length = 2},
  [24] = {.index = 24, .length = 1},
  [25] = {.index = 25, .length = 2},
  [26] = {.index = 27, .length = 2},
  [27] = {.index = 29, .length = 2},
  [29] = {.index = 31, .length = 2},
  [30] = {.index = 33, .length = 2},
  [31] = {.index = 35, .length = 2},
  [32] = {.index = 33, .length = 2},
  [33] = {.index = 35, .length = 2},
  [34] = {.index = 33, .length = 2},
  [35] = {.index = 35, .length = 2},
  [36] = {.index = 31, .length = 2},
  [37] = {.index = 37, .length = 2},
  [38] = {.index = 39, .length = 2},
  [39] = {.index = 41, .length = 3},
  [43] = {.index = 44, .length = 1},
  [44] = {.index = 45, .length = 2},
  [45] = {.index = 47, .length = 2},
  [46] = {.index = 49, .length = 2},
  [47] = {.index = 51, .length = 2},
  [48] = {.index = 53, .length = 1},
  [50] = {.index = 54, .length = 1},
  [51] = {.index = 55, .length = 2},
  [52] = {.index = 57, .length = 4},
  [53] = {.index = 61, .length = 2},
  [54] = {.index = 63, .length = 2},
  [55] = {.index = 61, .length = 2},
  [56] = {.index = 63, .length = 2},
  [57] = {.index = 65, .length = 1},
  [58] = {.index = 66, .length = 3},
  [59] = {.index = 22, .length = 2},
  [60] = {.index = 27, .length = 2},
  [61] = {.index = 20, .length = 2},
  [62] = {.index = 25, .length = 2},
  [63] = {.index = 69, .length = 3},
  [64] = {.index = 72, .length = 3},
  [65] = {.index = 20, .length = 2},
  [66] = {.index = 20, .length = 2},
  [67] = {.index = 75, .length = 4},
  [68] = {.index = 79, .length = 3},
  [69] = {.index = 82, .length = 2},
  [70] = {.index = 84, .length = 1},
  [71] = {.index = 85, .length = 1},
  [72] = {.index = 86, .length = 1},
  [73] = {.index = 87, .length = 1},
  [74] = {.index = 88, .length = 2},
  [75] = {.index = 90, .length = 3},
  [76] = {.index = 20, .length = 2},
  [77] = {.index = 93, .length = 2},
  [78] = {.index = 95, .length = 5},
  [79] = {.index = 100, .length = 2},
  [80] = {.index = 102, .length = 3},
  [81] = {.index = 105, .length = 2},
  [82] = {.index = 107, .length = 2},
  [83] = {.index = 109, .length = 1},
  [84] = {.index = 110, .length = 2},
  [85] = {.index = 112, .length = 3},
  [86] = {.index = 112, .length = 3},
  [87] = {.index = 112, .length = 3},
  [88] = {.index = 115, .length = 3},
  [89] = {.index = 118, .length = 3},
  [90] = {.index = 121, .length = 1},
  [94] = {.index = 122, .length = 3},
  [95] = {.index = 125, .length = 4},
  [96] = {.index = 129, .length = 2},
  [97] = {.index = 131, .length = 2},
  [98] = {.index = 133, .length = 4},
  [99] = {.index = 131, .length = 2},
  [100] = {.index = 137, .length = 4},
  [101] = {.index = 141, .length = 4},
  [102] = {.index = 145, .length = 5},
  [103] = {.index = 107, .length = 2},
  [104] = {.index = 150, .length = 3},
  [105] = {.index = 150, .length = 3},
  [106] = {.index = 153, .length = 2},
  [107] = {.index = 155, .length = 2},
  [108] = {.index = 88, .length = 2},
  [109] = {.index = 90, .length = 3},
  [110] = {.index = 157, .length = 3},
  [111] = {.index = 160, .length = 2},
  [112] = {.index = 162, .length = 3},
  [113] = {.index = 165, .length = 2},
  [114] = {.index = 105, .length = 2},
  [115] = {.index = 167, .length = 2},
  [116] = {.index = 169, .length = 5},
  [117] = {.index = 174, .length = 2},
  [118] = {.index = 176, .length = 3},
  [119] = {.index = 179, .length = 1},
  [120] = {.index = 180, .length = 1},
  [121] = {.index = 181, .length = 1},
  [122] = {.index = 182, .length = 1},
  [123] = {.index = 183, .length = 2},
  [124] = {.index = 185, .length = 1},
  [125] = {.index = 186, .length = 2},
  [126] = {.index = 188, .length = 2},
  [127] = {.index = 190, .length = 2},
  [128] = {.index = 192, .length = 4},
  [129] = {.index = 196, .length = 4},
  [130] = {.index = 200, .length = 4},
  [131] = {.index = 204, .length = 5},
  [132] = {.index = 209, .length = 2},
  [133] = {.index = 211, .length = 3},
  [134] = {.index = 167, .length = 2},
  [135] = {.index = 214, .length = 3},
  [136] = {.index = 217, .length = 2},
  [137] = {.index = 219, .length = 3},
  [138] = {.index = 222, .length = 4},
  [139] = {.index = 226, .length = 3},
  [140] = {.index = 229, .length = 3},
  [141] = {.index = 232, .length = 2},
  [142] = {.index = 234, .length = 5},
  [143] = {.index = 239, .length = 3},
  [145] = {.index = 242, .length = 2},
  [146] = {.index = 242, .length = 2},
  [147] = {.index = 244, .length = 3},
  [148] = {.index = 242, .length = 2},
  [149] = {.index = 242, .length = 2},
  [150] = {.index = 247, .length = 2},
  [151] = {.index = 249, .length = 4},
  [152] = {.index = 253, .length = 2},
  [153] = {.index = 255, .length = 2},
  [154] = {.index = 257, .length = 2},
  [155] = {.index = 259, .length = 2},
  [156] = {.index = 261, .length = 3},
  [157] = {.index = 264, .length = 3},
  [158] = {.index = 267, .length = 1},
  [159] = {.index = 268, .length = 5},
  [160] = {.index = 273, .length = 3},
  [161] = {.index = 276, .length = 4},
  [162] = {.index = 280, .length = 3},
  [163] = {.index = 283, .length = 4},
  [164] = {.index = 287, .length = 5},
  [165] = {.index = 292, .length = 2},
  [166] = {.index = 292, .length = 2},
  [167] = {.index = 292, .length = 2},
  [168] = {.index = 292, .length = 2},
  [169] = {.index = 294, .length = 4},
  [170] = {.index = 298, .length = 2},
  [171] = {.index = 298, .length = 2},
  [172] = {.index = 298, .length = 2},
  [173] = {.index = 300, .length = 4},
  [174] = {.index = 304, .length = 2},
  [175] = {.index = 306, .length = 2},
  [176] = {.index = 308, .length = 3},
  [177] = {.index = 311, .length = 3},
  [178] = {.index = 314, .length = 4},
  [179] = {.index = 318, .length = 2},
  [180] = {.index = 320, .length = 2},
  [181] = {.index = 322, .length = 4},
  [182] = {.index = 326, .length = 5},
  [183] = {.index = 331, .length = 5},
  [184] = {.index = 336, .length = 3},
  [185] = {.index = 339, .length = 1},
  [186] = {.index = 340, .length = 4},
  [187] = {.index = 344, .length = 4},
  [188] = {.index = 348, .length = 2},
  [189] = {.index = 350, .length = 2},
  [190] = {.index = 352, .length = 3},
  [191] = {.index = 355, .length = 4},
  [192] = {.index = 359, .length = 5},
  [193] = {.index = 364, .length = 5},
  [194] = {.index = 369, .length = 4},
  [195] = {.index = 373, .length = 3},
  [196] = {.index = 376, .length = 4},
  [197] = {.index = 380, .length = 5},
  [198] = {.index = 339, .length = 1},
  [199] = {.index = 385, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_argument, 0},
    {field_operator, 1},
  [12] =
    {field_arguments, 1},
    {field_function, 0},
  [14] =
    {field_parameters, 0},
    {field_return_type, 1},
  [16] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [18] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_object, 0},
    {field_property, 2},
  [24] =
    {field_label, 0},
  [25] =
    {field_body, 2},
    {field_parameter, 0},
  [27] =
    {field_arguments, 2},
    {field_function, 0},
  [29] =
    {field_body, 1},
    {field_name, 0},
  [31] =
    {field_body, 2},
    {field_name, 1},
  [33] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [35] =
    {field_name, 0},
    {field_type, 1},
  [37] =
    {field_condition, 1},
    {field_consequence, 2},
  [39] =
    {field_body, 2},
    {field_value, 1},
  [41] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [44] =
    {field_value, 1, .inherited = true},
  [45] =
    {field_body, 2},
    {field_condition, 1},
  [47] =
    {field_body, 1},
    {field_handler, 2},
  [49] =
    {field_body, 1},
    {field_finalizer, 2},
  [51] =
    {field_body, 2},
    {field_object, 1},
  [53] =
    {field_label, 1},
  [54] =
    {field_body, 2},
  [55] =
    {field_body, 2},
    {field_type_parameters, 1},
  [57] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [61] =
    {field_arguments, 2},
    {field_constructor, 1},
  [63] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [65] =
    {field_pattern, 1},
  [66] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [69] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [72] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [75] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [79] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [82] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [84] =
    {field_source, 1},
  [85] =
    {field_source, 2, .inherited = true},
  [86] =
    {field_value, 2},
  [87] =
    {field_name, 1},
  [88] =
    {field_index, 2},
    {field_object, 0},
  [90] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [93] =
    {field_key, 0},
    {field_value, 2},
  [95] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [100] =
    {field_body, 3},
    {field_name, 1},
  [102] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [105] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [107] =
    {field_body, 3},
    {field_name, 2},
  [109] =
    {field_value, 1},
  [110] =
    {field_name, 0},
    {field_type, 2},
  [112] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [115] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [118] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [121] =
    {field_value, 2, .inherited = true},
  [122] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [125] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [129] =
    {field_body, 3},
    {field_type_parameters, 1},
  [131] =
    {field_body, 3},
    {field_parameter, 1},
  [133] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [137] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [141] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [145] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [150] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [153] =
    {field_flags, 3},
    {field_pattern, 1},
  [155] =
    {field_module, 0},
    {field_name, 2},
  [157] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [160] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [162] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [165] =
    {field_alias, 2},
    {field_name, 0},
  [167] =
    {field_index, 3},
    {field_object, 0},
  [169] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [174] =
    {field_name, 1},
    {field_value, 3},
  [176] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [179] =
    {field_source, 3, .inherited = true},
  [180] =
    {field_decorator, 1, .inherited = true},
  [181] =
    {field_decorator, 2, .inherited = true},
  [182] =
    {field_value, 3, .inherited = true},
  [183] =
    {field_body, 1},
    {field_condition, 3},
  [185] =
    {field_name, 2},
  [186] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [188] =
    {field_name, 1},
    {field_type, 2},
  [190] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [192] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [196] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [200] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [204] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [209] =
    {field_body, 4},
    {field_name, 2},
  [211] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [214] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [217] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [219] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [222] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [226] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [229] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [232] =
    {field_alias, 3},
    {field_name, 1},
  [234] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [239] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [242] =
    {field_left, 1},
    {field_right, 3},
  [244] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [247] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [249] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [253] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [255] =
    {field_name, 2},
    {field_type, 3},
  [257] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [259] =
    {field_name, 1},
    {field_type, 3},
  [261] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [264] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [267] =
    {field_name, 3},
  [268] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [273] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [276] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [280] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [283] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [287] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [292] =
    {field_left, 2},
    {field_right, 4},
  [294] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [298] =
    {field_body, 4},
    {field_parameter, 2},
  [300] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [304] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [306] =
    {field_name, 2},
    {field_type, 4},
  [308] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [311] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [314] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [318] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [320] =
    {field_name, 3},
    {field_type, 4},
  [322] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [326] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [331] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [336] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [339] =
    {field_sign, 0},
  [340] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [344] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [348] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [350] =
    {field_name, 3},
    {field_type, 5},
  [352] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [355] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [359] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [364] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [369] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [373] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [376] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [380] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [385] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[200][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [1] = sym_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [22] = {
    [0] = sym_identifier,
  },
  [23] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [29] = {
    [1] = alias_sym_type_identifier,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_object_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [35] = {
    [0] = alias_sym_array_pattern,
  },
  [40] = {
    [1] = sym_identifier,
  },
  [41] = {
    [1] = alias_sym_object_pattern,
  },
  [42] = {
    [1] = alias_sym_array_pattern,
  },
  [48] = {
    [1] = alias_sym_statement_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = sym_identifier,
  },
  [54] = {
    [1] = sym_identifier,
  },
  [59] = {
    [2] = alias_sym_property_identifier,
  },
  [65] = {
    [0] = alias_sym_object_pattern,
  },
  [66] = {
    [0] = alias_sym_array_pattern,
  },
  [74] = {
    [0] = sym_identifier,
  },
  [75] = {
    [0] = sym_identifier,
  },
  [76] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [79] = {
    [1] = alias_sym_type_identifier,
  },
  [80] = {
    [1] = alias_sym_type_identifier,
  },
  [81] = {
    [1] = alias_sym_import_specifier,
  },
  [86] = {
    [0] = alias_sym_object_pattern,
  },
  [87] = {
    [0] = alias_sym_array_pattern,
  },
  [91] = {
    [2] = sym_identifier,
  },
  [92] = {
    [2] = alias_sym_object_pattern,
  },
  [93] = {
    [2] = alias_sym_array_pattern,
  },
  [97] = {
    [1] = sym_identifier,
  },
  [103] = {
    [2] = alias_sym_type_identifier,
  },
  [104] = {
    [1] = sym_identifier,
  },
  [107] = {
    [2] = alias_sym_type_identifier,
  },
  [110] = {
    [2] = alias_sym_type_identifier,
  },
  [115] = {
    [0] = sym_identifier,
  },
  [117] = {
    [1] = alias_sym_type_identifier,
  },
  [118] = {
    [1] = alias_sym_type_identifier,
  },
  [132] = {
    [2] = alias_sym_type_identifier,
  },
  [133] = {
    [2] = alias_sym_type_identifier,
  },
  [137] = {
    [2] = alias_sym_type_identifier,
  },
  [138] = {
    [2] = alias_sym_type_identifier,
  },
  [140] = {
    [3] = alias_sym_type_identifier,
  },
  [143] = {
    [1] = alias_sym_type_identifier,
  },
  [144] = {
    [3] = alias_sym_property_identifier,
  },
  [145] = {
    [1] = sym_identifier,
  },
  [148] = {
    [1] = alias_sym_object_pattern,
  },
  [149] = {
    [1] = alias_sym_array_pattern,
  },
  [160] = {
    [2] = alias_sym_type_identifier,
  },
  [161] = {
    [2] = alias_sym_type_identifier,
  },
  [162] = {
    [3] = alias_sym_type_identifier,
  },
  [163] = {
    [3] = alias_sym_type_identifier,
  },
  [165] = {
    [2] = sym_identifier,
  },
  [167] = {
    [2] = alias_sym_object_pattern,
  },
  [168] = {
    [2] = alias_sym_array_pattern,
  },
  [171] = {
    [2] = alias_sym_object_pattern,
  },
  [172] = {
    [2] = alias_sym_array_pattern,
  },
  [181] = {
    [3] = alias_sym_type_identifier,
  },
  [198] = {
    [3] = sym_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_object, 2,
    sym_object,
    alias_sym_object_pattern,
  sym_array, 2,
    sym_array,
    alias_sym_array_pattern,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t lookahead) {
  return
    lookahead == 0 ||
    (0 <= lookahead && lookahead <= '#') ||
    ('%' <= lookahead && lookahead <= '/') ||
    (':' <= lookahead && lookahead <= '@') ||
    ('[' <= lookahead && lookahead <= '^') ||
    lookahead == '`' ||
    ('{' <= lookahead && lookahead <= '~') ||
    lookahead == 160 ||
    lookahead == 8203 ||
    lookahead == 8288 ||
    lookahead == 65279;
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(202);
      if (lookahead == '%') ADVANCE(144);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == '/') ADVANCE(188);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(203);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(21)
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(176);
      if (lookahead != 0) ADVANCE(177);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(172);
      if (lookahead == '\r') ADVANCE(179);
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(169);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(165);
      if (lookahead == '\r') ADVANCE(180);
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(27)
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(189);
      if (lookahead != 0) ADVANCE(190);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(144);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(83);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(144);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(83);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == '<') ADVANCE(149);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(203);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(149);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(149);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '<') ADVANCE(149);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(81);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '<') ADVANCE(149);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(70);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(123);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(203);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(123);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(134);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '.') ADVANCE(25);
      if (lookahead == '/') ADVANCE(188);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(156);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '&') ADVANCE(123);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(134);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '.') ADVANCE(25);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(156);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(203);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(36);
      if (lookahead == '-') ADVANCE(31);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == '?') ADVANCE(29);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 20:
      if (lookahead == '$') ADVANCE(36);
      if (lookahead == '-') ADVANCE(31);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == '?') ADVANCE(29);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(184);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(112);
      END_STATE();
    case 27:
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(27)
      END_STATE();
    case 28:
      if (lookahead == ':') ADVANCE(207);
      END_STATE();
    case 29:
      if (lookahead == ':') ADVANCE(208);
      END_STATE();
    case 30:
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 31:
      if (lookahead == '?') ADVANCE(28);
      END_STATE();
    case 32:
      if (lookahead == '\\') ADVANCE(64);
      if (lookahead == ']') ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(37);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(38);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(187);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == '{') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(206);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 45:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(195);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(196);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(203);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(197);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 64:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 65:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(190);
      END_STATE();
    case 66:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(202);
      if (lookahead == '%') ADVANCE(144);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(148);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(203);
      END_STATE();
    case 67:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(86);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '%') ADVANCE(143);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(73);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(83);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(149);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(67)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead)) ADVANCE(203);
      END_STATE();
    case 68:
      if (eof) ADVANCE(69);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '&') ADVANCE(123);
      if (lookahead == '\'') ADVANCE(171);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(88);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(193);
      if (lookahead == ':') ADVANCE(84);
      if (lookahead == ';') ADVANCE(89);
      if (lookahead == '<') ADVANCE(147);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(156);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '@') ADVANCE(204);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(186);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(80);
      if (lookahead == '~') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(68)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead) &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(203);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(70);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(145);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(205);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '?') ADVANCE(159);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(114);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(113);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '|') ADVANCE(116);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(206);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(115);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(206);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(206);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(162);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(163);
      if (lookahead == '=') ADVANCE(98);
      if (lookahead == '?') ADVANCE(28);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(121);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(117);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(168);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(167);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(168);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(175);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(172);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(165);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(34);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(203);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(182);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(185);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(190);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(32);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(34);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(191);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(203);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(201);
      if (lookahead == '0') ADVANCE(198);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(45);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(53);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(201);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(192);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(200);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '{') ADVANCE(187);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(34);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'v') ADVANCE(18);
      if (lookahead == 'w') ADVANCE(19);
      if (lookahead == 'y') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(21);
      if (lookahead == 'n') ADVANCE(22);
      if (lookahead == 's') ADVANCE(23);
      if (lookahead == 'w') ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(25);
      if (lookahead == 'r') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(27);
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(42);
      if (lookahead == 'm') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'u') ADVANCE(51);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(52);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(53);
      if (lookahead == 'u') ADVANCE(54);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(56);
      if (lookahead == 't') ADVANCE(57);
      if (lookahead == 'u') ADVANCE(58);
      if (lookahead == 'w') ADVANCE(59);
      if (lookahead == 'y') ADVANCE(60);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(61);
      if (lookahead == 'h') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 'y') ADVANCE(64);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(70);
      END_STATE();
    case 22:
      if (lookahead == 'y') ADVANCE(71);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(72);
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(77);
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'b') ADVANCE(81);
      if (lookahead == 'c') ADVANCE(82);
      if (lookahead == 'f') ADVANCE(83);
      if (lookahead == 'l') ADVANCE(84);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 32:
      if (lookahead == 's') ADVANCE(85);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'p') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 35:
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(95);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(96);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(97);
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 46:
      if (lookahead == 'y') ADVANCE(99);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 'd') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'm') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'w') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'm') ADVANCE(105);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(106);
      if (lookahead == 'o') ADVANCE(107);
      END_STATE();
    case 54:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(109);
      if (lookahead == 'q') ADVANCE(110);
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(113);
      if (lookahead == 'r') ADVANCE(114);
      END_STATE();
    case 58:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(119);
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(121);
      if (lookahead == 'y') ADVANCE(122);
      END_STATE();
    case 64:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(131);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'c') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 81:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'm') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 92:
      if (lookahead == 'm') ADVANCE(150);
      END_STATE();
    case 93:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 95:
      if (lookahead == 'b') ADVANCE(152);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(153);
      if (lookahead == 'o') ADVANCE(154);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'o') ADVANCE(157);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(158);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 105:
      if (lookahead == 'b') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'v') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'u') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 'b') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'g') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 's') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 'o') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 125:
      if (lookahead == 'd') ADVANCE(178);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(179);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'c') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'k') ADVANCE(187);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 136:
      if (lookahead == 'h') ADVANCE(188);
      END_STATE();
    case 137:
      if (lookahead == 's') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 't') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'g') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'u') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(195);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 146:
      if (lookahead == 'r') ADVANCE(196);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'l') ADVANCE(199);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 152:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'r') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'a') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'f') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 's') ADVANCE(208);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'o') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'i') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'i') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'r') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'c') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'o') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 175:
      if (lookahead == 'w') ADVANCE(222);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 179:
      if (lookahead == 'e') ADVANCE(224);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 181:
      if (lookahead == 'd') ADVANCE(225);
      END_STATE();
    case 182:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 183:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 191:
      if (lookahead == 'n') ADVANCE(229);
      END_STATE();
    case 192:
      if (lookahead == 'g') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'l') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 'd') ADVANCE(235);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 199:
      if (lookahead == 'l') ADVANCE(236);
      END_STATE();
    case 200:
      if (lookahead == 'i') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'm') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'f') ADVANCE(242);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 208:
      if (lookahead == 'p') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 'c') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'r') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'c') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'g') ADVANCE(253);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 219:
      if (lookahead == 'h') ADVANCE(254);
      END_STATE();
    case 220:
      if (lookahead == 'l') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 223:
      if (lookahead == 'f') ADVANCE(257);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 226:
      if (lookahead == 'c') ADVANCE(258);
      END_STATE();
    case 227:
      if (lookahead == 's') ADVANCE(259);
      END_STATE();
    case 228:
      if (lookahead == 'n') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'u') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 235:
      if (lookahead == 's') ADVANCE(265);
      END_STATE();
    case 236:
      if (lookahead == 'y') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'o') ADVANCE(267);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 241:
      if (lookahead == 'c') ADVANCE(269);
      END_STATE();
    case 242:
      if (lookahead == 'a') ADVANCE(270);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 244:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 246:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 249:
      if (lookahead == 'l') ADVANCE(274);
      END_STATE();
    case 250:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(276);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(277);
      END_STATE();
    case 262:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 270:
      if (lookahead == 'c') ADVANCE(282);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(283);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 274:
      if (lookahead == 'y') ADVANCE(285);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(286);
      END_STATE();
    case 281:
      if (lookahead == 'o') ADVANCE(287);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 284:
      if (lookahead == 'd') ADVANCE(290);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 286:
      if (lookahead == 's') ADVANCE(291);
      END_STATE();
    case 287:
      if (lookahead == 'f') ADVANCE(292);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 68},
  [2] = {.lex_state = 68},
  [3] = {.lex_state = 68},
  [4] = {.lex_state = 68},
  [5] = {.lex_state = 68},
  [6] = {.lex_state = 68},
  [7] = {.lex_state = 68},
  [8] = {.lex_state = 68},
  [9] = {.lex_state = 68},
  [10] = {.lex_state = 68},
  [11] = {.lex_state = 68},
  [12] = {.lex_state = 68},
  [13] = {.lex_state = 68},
  [14] = {.lex_state = 68},
  [15] = {.lex_state = 68},
  [16] = {.lex_state = 68},
  [17] = {.lex_state = 68},
  [18] = {.lex_state = 68},
  [19] = {.lex_state = 68},
  [20] = {.lex_state = 68},
  [21] = {.lex_state = 68},
  [22] = {.lex_state = 68},
  [23] = {.lex_state = 68},
  [24] = {.lex_state = 68},
  [25] = {.lex_state = 68},
  [26] = {.lex_state = 68},
  [27] = {.lex_state = 68},
  [28] = {.lex_state = 68},
  [29] = {.lex_state = 68},
  [30] = {.lex_state = 68},
  [31] = {.lex_state = 68},
  [32] = {.lex_state = 68},
  [33] = {.lex_state = 68},
  [34] = {.lex_state = 68},
  [35] = {.lex_state = 68},
  [36] = {.lex_state = 68},
  [37] = {.lex_state = 68},
  [38] = {.lex_state = 68},
  [39] = {.lex_state = 68},
  [40] = {.lex_state = 68},
  [41] = {.lex_state = 68},
  [42] = {.lex_state = 68},
  [43] = {.lex_state = 68},
  [44] = {.lex_state = 68},
  [45] = {.lex_state = 68},
  [46] = {.lex_state = 68},
  [47] = {.lex_state = 68},
  [48] = {.lex_state = 14},
  [49] = {.lex_state = 14},
  [50] = {.lex_state = 14},
  [51] = {.lex_state = 14},
  [52] = {.lex_state = 67, .external_lex_state = 2},
  [53] = {.lex_state = 14},
  [54] = {.lex_state = 67, .external_lex_state = 3},
  [55] = {.lex_state = 14},
  [56] = {.lex_state = 14},
  [57] = {.lex_state = 14},
  [58] = {.lex_state = 14},
  [59] = {.lex_state = 6, .external_lex_state = 2},
  [60] = {.lex_state = 14},
  [61] = {.lex_state = 14},
  [62] = {.lex_state = 67, .external_lex_state = 3},
  [63] = {.lex_state = 67, .external_lex_state = 2},
  [64] = {.lex_state = 8, .external_lex_state = 2},
  [65] = {.lex_state = 67, .external_lex_state = 2},
  [66] = {.lex_state = 67, .external_lex_state = 3},
  [67] = {.lex_state = 67, .external_lex_state = 3},
  [68] = {.lex_state = 67, .external_lex_state = 3},
  [69] = {.lex_state = 6, .external_lex_state = 2},
  [70] = {.lex_state = 67, .external_lex_state = 3},
  [71] = {.lex_state = 67, .external_lex_state = 3},
  [72] = {.lex_state = 67, .external_lex_state = 3},
  [73] = {.lex_state = 67, .external_lex_state = 3},
  [74] = {.lex_state = 67, .external_lex_state = 3},
  [75] = {.lex_state = 6, .external_lex_state = 3},
  [76] = {.lex_state = 67, .external_lex_state = 3},
  [77] = {.lex_state = 67, .external_lex_state = 3},
  [78] = {.lex_state = 67, .external_lex_state = 3},
  [79] = {.lex_state = 67, .external_lex_state = 3},
  [80] = {.lex_state = 67, .external_lex_state = 3},
  [81] = {.lex_state = 67, .external_lex_state = 3},
  [82] = {.lex_state = 67, .external_lex_state = 3},
  [83] = {.lex_state = 67, .external_lex_state = 3},
  [84] = {.lex_state = 67, .external_lex_state = 3},
  [85] = {.lex_state = 67, .external_lex_state = 3},
  [86] = {.lex_state = 67, .external_lex_state = 3},
  [87] = {.lex_state = 67, .external_lex_state = 3},
  [88] = {.lex_state = 67, .external_lex_state = 3},
  [89] = {.lex_state = 67, .external_lex_state = 3},
  [90] = {.lex_state = 67, .external_lex_state = 3},
  [91] = {.lex_state = 67, .external_lex_state = 3},
  [92] = {.lex_state = 67, .external_lex_state = 3},
  [93] = {.lex_state = 67, .external_lex_state = 3},
  [94] = {.lex_state = 67, .external_lex_state = 3},
  [95] = {.lex_state = 6, .external_lex_state = 2},
  [96] = {.lex_state = 6, .external_lex_state = 2},
  [97] = {.lex_state = 6, .external_lex_state = 3},
  [98] = {.lex_state = 6, .external_lex_state = 2},
  [99] = {.lex_state = 6, .external_lex_state = 2},
  [100] = {.lex_state = 68},
  [101] = {.lex_state = 68},
  [102] = {.lex_state = 68},
  [103] = {.lex_state = 68},
  [104] = {.lex_state = 68},
  [105] = {.lex_state = 68},
  [106] = {.lex_state = 68},
  [107] = {.lex_state = 68},
  [108] = {.lex_state = 68},
  [109] = {.lex_state = 68},
  [110] = {.lex_state = 68},
  [111] = {.lex_state = 68},
  [112] = {.lex_state = 68},
  [113] = {.lex_state = 68},
  [114] = {.lex_state = 68},
  [115] = {.lex_state = 68},
  [116] = {.lex_state = 68},
  [117] = {.lex_state = 68},
  [118] = {.lex_state = 7, .external_lex_state = 3},
  [119] = {.lex_state = 7, .external_lex_state = 3},
  [120] = {.lex_state = 68, .external_lex_state = 4},
  [121] = {.lex_state = 7, .external_lex_state = 3},
  [122] = {.lex_state = 6, .external_lex_state = 3},
  [123] = {.lex_state = 68},
  [124] = {.lex_state = 68},
  [125] = {.lex_state = 68},
  [126] = {.lex_state = 7, .external_lex_state = 3},
  [127] = {.lex_state = 6, .external_lex_state = 3},
  [128] = {.lex_state = 68},
  [129] = {.lex_state = 7, .external_lex_state = 3},
  [130] = {.lex_state = 6, .external_lex_state = 3},
  [131] = {.lex_state = 68},
  [132] = {.lex_state = 68},
  [133] = {.lex_state = 68},
  [134] = {.lex_state = 68},
  [135] = {.lex_state = 68},
  [136] = {.lex_state = 68},
  [137] = {.lex_state = 68},
  [138] = {.lex_state = 68},
  [139] = {.lex_state = 68},
  [140] = {.lex_state = 68},
  [141] = {.lex_state = 68},
  [142] = {.lex_state = 68},
  [143] = {.lex_state = 68},
  [144] = {.lex_state = 68},
  [145] = {.lex_state = 68},
  [146] = {.lex_state = 68},
  [147] = {.lex_state = 68},
  [148] = {.lex_state = 68},
  [149] = {.lex_state = 6, .external_lex_state = 3},
  [150] = {.lex_state = 68},
  [151] = {.lex_state = 6, .external_lex_state = 3},
  [152] = {.lex_state = 68},
  [153] = {.lex_state = 68},
  [154] = {.lex_state = 68},
  [155] = {.lex_state = 68},
  [156] = {.lex_state = 68},
  [157] = {.lex_state = 68},
  [158] = {.lex_state = 68},
  [159] = {.lex_state = 68},
  [160] = {.lex_state = 68},
  [161] = {.lex_state = 68, .external_lex_state = 4},
  [162] = {.lex_state = 68},
  [163] = {.lex_state = 68},
  [164] = {.lex_state = 68},
  [165] = {.lex_state = 68},
  [166] = {.lex_state = 68},
  [167] = {.lex_state = 6, .external_lex_state = 3},
  [168] = {.lex_state = 68},
  [169] = {.lex_state = 6, .external_lex_state = 3},
  [170] = {.lex_state = 6, .external_lex_state = 3},
  [171] = {.lex_state = 68},
  [172] = {.lex_state = 68},
  [173] = {.lex_state = 68},
  [174] = {.lex_state = 68},
  [175] = {.lex_state = 68},
  [176] = {.lex_state = 68},
  [177] = {.lex_state = 68},
  [178] = {.lex_state = 68},
  [179] = {.lex_state = 68},
  [180] = {.lex_state = 68},
  [181] = {.lex_state = 68},
  [182] = {.lex_state = 68},
  [183] = {.lex_state = 68},
  [184] = {.lex_state = 68},
  [185] = {.lex_state = 68},
  [186] = {.lex_state = 68},
  [187] = {.lex_state = 68},
  [188] = {.lex_state = 68},
  [189] = {.lex_state = 68},
  [190] = {.lex_state = 68},
  [191] = {.lex_state = 68},
  [192] = {.lex_state = 68},
  [193] = {.lex_state = 68},
  [194] = {.lex_state = 68},
  [195] = {.lex_state = 68},
  [196] = {.lex_state = 68},
  [197] = {.lex_state = 68},
  [198] = {.lex_state = 68},
  [199] = {.lex_state = 68},
  [200] = {.lex_state = 68},
  [201] = {.lex_state = 68},
  [202] = {.lex_state = 68},
  [203] = {.lex_state = 68},
  [204] = {.lex_state = 68},
  [205] = {.lex_state = 68},
  [206] = {.lex_state = 68},
  [207] = {.lex_state = 68},
  [208] = {.lex_state = 68},
  [209] = {.lex_state = 68},
  [210] = {.lex_state = 68},
  [211] = {.lex_state = 68},
  [212] = {.lex_state = 68},
  [213] = {.lex_state = 68},
  [214] = {.lex_state = 68},
  [215] = {.lex_state = 68},
  [216] = {.lex_state = 68},
  [217] = {.lex_state = 68},
  [218] = {.lex_state = 68},
  [219] = {.lex_state = 68},
  [220] = {.lex_state = 68},
  [221] = {.lex_state = 68},
  [222] = {.lex_state = 68},
  [223] = {.lex_state = 68},
  [224] = {.lex_state = 68},
  [225] = {.lex_state = 68},
  [226] = {.lex_state = 68},
  [227] = {.lex_state = 68},
  [228] = {.lex_state = 68},
  [229] = {.lex_state = 68},
  [230] = {.lex_state = 68},
  [231] = {.lex_state = 68},
  [232] = {.lex_state = 68},
  [233] = {.lex_state = 68},
  [234] = {.lex_state = 68},
  [235] = {.lex_state = 68},
  [236] = {.lex_state = 68},
  [237] = {.lex_state = 68},
  [238] = {.lex_state = 68},
  [239] = {.lex_state = 68},
  [240] = {.lex_state = 68},
  [241] = {.lex_state = 68},
  [242] = {.lex_state = 68},
  [243] = {.lex_state = 68},
  [244] = {.lex_state = 68},
  [245] = {.lex_state = 68},
  [246] = {.lex_state = 68},
  [247] = {.lex_state = 68},
  [248] = {.lex_state = 68},
  [249] = {.lex_state = 68},
  [250] = {.lex_state = 68},
  [251] = {.lex_state = 68},
  [252] = {.lex_state = 68},
  [253] = {.lex_state = 68},
  [254] = {.lex_state = 68},
  [255] = {.lex_state = 68},
  [256] = {.lex_state = 68},
  [257] = {.lex_state = 68},
  [258] = {.lex_state = 68},
  [259] = {.lex_state = 68},
  [260] = {.lex_state = 68},
  [261] = {.lex_state = 68},
  [262] = {.lex_state = 68},
  [263] = {.lex_state = 68},
  [264] = {.lex_state = 68},
  [265] = {.lex_state = 68},
  [266] = {.lex_state = 68},
  [267] = {.lex_state = 68},
  [268] = {.lex_state = 68},
  [269] = {.lex_state = 68},
  [270] = {.lex_state = 68},
  [271] = {.lex_state = 68},
  [272] = {.lex_state = 68},
  [273] = {.lex_state = 68},
  [274] = {.lex_state = 68},
  [275] = {.lex_state = 68},
  [276] = {.lex_state = 68},
  [277] = {.lex_state = 68},
  [278] = {.lex_state = 68},
  [279] = {.lex_state = 68},
  [280] = {.lex_state = 68},
  [281] = {.lex_state = 68},
  [282] = {.lex_state = 68},
  [283] = {.lex_state = 68},
  [284] = {.lex_state = 68},
  [285] = {.lex_state = 68},
  [286] = {.lex_state = 68},
  [287] = {.lex_state = 68},
  [288] = {.lex_state = 68},
  [289] = {.lex_state = 68},
  [290] = {.lex_state = 68},
  [291] = {.lex_state = 68},
  [292] = {.lex_state = 68},
  [293] = {.lex_state = 68},
  [294] = {.lex_state = 68},
  [295] = {.lex_state = 68},
  [296] = {.lex_state = 68},
  [297] = {.lex_state = 68},
  [298] = {.lex_state = 68},
  [299] = {.lex_state = 68},
  [300] = {.lex_state = 68},
  [301] = {.lex_state = 68},
  [302] = {.lex_state = 68},
  [303] = {.lex_state = 68},
  [304] = {.lex_state = 68},
  [305] = {.lex_state = 68},
  [306] = {.lex_state = 68},
  [307] = {.lex_state = 68},
  [308] = {.lex_state = 68},
  [309] = {.lex_state = 68},
  [310] = {.lex_state = 68},
  [311] = {.lex_state = 68},
  [312] = {.lex_state = 68},
  [313] = {.lex_state = 68},
  [314] = {.lex_state = 68},
  [315] = {.lex_state = 68},
  [316] = {.lex_state = 68},
  [317] = {.lex_state = 68},
  [318] = {.lex_state = 68},
  [319] = {.lex_state = 68},
  [320] = {.lex_state = 68},
  [321] = {.lex_state = 68},
  [322] = {.lex_state = 68},
  [323] = {.lex_state = 68},
  [324] = {.lex_state = 68},
  [325] = {.lex_state = 68},
  [326] = {.lex_state = 68},
  [327] = {.lex_state = 68},
  [328] = {.lex_state = 68},
  [329] = {.lex_state = 68},
  [330] = {.lex_state = 68},
  [331] = {.lex_state = 68},
  [332] = {.lex_state = 68},
  [333] = {.lex_state = 68},
  [334] = {.lex_state = 68},
  [335] = {.lex_state = 68},
  [336] = {.lex_state = 68},
  [337] = {.lex_state = 68},
  [338] = {.lex_state = 68},
  [339] = {.lex_state = 68},
  [340] = {.lex_state = 68},
  [341] = {.lex_state = 68},
  [342] = {.lex_state = 68},
  [343] = {.lex_state = 68},
  [344] = {.lex_state = 68},
  [345] = {.lex_state = 68},
  [346] = {.lex_state = 68},
  [347] = {.lex_state = 68},
  [348] = {.lex_state = 68},
  [349] = {.lex_state = 68},
  [350] = {.lex_state = 68},
  [351] = {.lex_state = 68},
  [352] = {.lex_state = 68},
  [353] = {.lex_state = 68},
  [354] = {.lex_state = 68},
  [355] = {.lex_state = 68},
  [356] = {.lex_state = 68},
  [357] = {.lex_state = 68},
  [358] = {.lex_state = 68},
  [359] = {.lex_state = 68},
  [360] = {.lex_state = 68},
  [361] = {.lex_state = 68},
  [362] = {.lex_state = 68},
  [363] = {.lex_state = 68},
  [364] = {.lex_state = 68},
  [365] = {.lex_state = 68},
  [366] = {.lex_state = 68},
  [367] = {.lex_state = 68},
  [368] = {.lex_state = 68},
  [369] = {.lex_state = 68},
  [370] = {.lex_state = 68},
  [371] = {.lex_state = 68},
  [372] = {.lex_state = 68},
  [373] = {.lex_state = 68},
  [374] = {.lex_state = 68},
  [375] = {.lex_state = 68},
  [376] = {.lex_state = 68},
  [377] = {.lex_state = 68},
  [378] = {.lex_state = 68},
  [379] = {.lex_state = 68},
  [380] = {.lex_state = 68},
  [381] = {.lex_state = 68},
  [382] = {.lex_state = 68},
  [383] = {.lex_state = 68},
  [384] = {.lex_state = 68},
  [385] = {.lex_state = 68},
  [386] = {.lex_state = 68},
  [387] = {.lex_state = 68},
  [388] = {.lex_state = 68},
  [389] = {.lex_state = 68},
  [390] = {.lex_state = 68},
  [391] = {.lex_state = 68},
  [392] = {.lex_state = 68},
  [393] = {.lex_state = 68},
  [394] = {.lex_state = 68},
  [395] = {.lex_state = 68},
  [396] = {.lex_state = 68},
  [397] = {.lex_state = 68},
  [398] = {.lex_state = 68},
  [399] = {.lex_state = 68},
  [400] = {.lex_state = 68},
  [401] = {.lex_state = 68},
  [402] = {.lex_state = 68},
  [403] = {.lex_state = 68},
  [404] = {.lex_state = 68},
  [405] = {.lex_state = 68},
  [406] = {.lex_state = 68},
  [407] = {.lex_state = 68},
  [408] = {.lex_state = 68},
  [409] = {.lex_state = 68},
  [410] = {.lex_state = 68},
  [411] = {.lex_state = 68},
  [412] = {.lex_state = 68},
  [413] = {.lex_state = 68},
  [414] = {.lex_state = 68},
  [415] = {.lex_state = 68},
  [416] = {.lex_state = 68},
  [417] = {.lex_state = 68},
  [418] = {.lex_state = 68},
  [419] = {.lex_state = 68},
  [420] = {.lex_state = 68},
  [421] = {.lex_state = 68},
  [422] = {.lex_state = 68},
  [423] = {.lex_state = 68},
  [424] = {.lex_state = 68},
  [425] = {.lex_state = 68},
  [426] = {.lex_state = 68},
  [427] = {.lex_state = 68},
  [428] = {.lex_state = 68},
  [429] = {.lex_state = 68},
  [430] = {.lex_state = 68},
  [431] = {.lex_state = 68},
  [432] = {.lex_state = 68},
  [433] = {.lex_state = 68},
  [434] = {.lex_state = 68},
  [435] = {.lex_state = 68},
  [436] = {.lex_state = 68},
  [437] = {.lex_state = 68},
  [438] = {.lex_state = 68},
  [439] = {.lex_state = 68},
  [440] = {.lex_state = 68},
  [441] = {.lex_state = 68},
  [442] = {.lex_state = 68},
  [443] = {.lex_state = 68},
  [444] = {.lex_state = 68},
  [445] = {.lex_state = 68},
  [446] = {.lex_state = 68},
  [447] = {.lex_state = 68},
  [448] = {.lex_state = 68},
  [449] = {.lex_state = 68},
  [450] = {.lex_state = 6, .external_lex_state = 3},
  [451] = {.lex_state = 6, .external_lex_state = 3},
  [452] = {.lex_state = 6, .external_lex_state = 3},
  [453] = {.lex_state = 6, .external_lex_state = 3},
  [454] = {.lex_state = 6, .external_lex_state = 3},
  [455] = {.lex_state = 6, .external_lex_state = 3},
  [456] = {.lex_state = 6, .external_lex_state = 3},
  [457] = {.lex_state = 6, .external_lex_state = 3},
  [458] = {.lex_state = 6, .external_lex_state = 3},
  [459] = {.lex_state = 6, .external_lex_state = 2},
  [460] = {.lex_state = 6, .external_lex_state = 3},
  [461] = {.lex_state = 6, .external_lex_state = 2},
  [462] = {.lex_state = 7, .external_lex_state = 2},
  [463] = {.lex_state = 6, .external_lex_state = 2},
  [464] = {.lex_state = 6, .external_lex_state = 3},
  [465] = {.lex_state = 6, .external_lex_state = 3},
  [466] = {.lex_state = 6, .external_lex_state = 3},
  [467] = {.lex_state = 6, .external_lex_state = 3},
  [468] = {.lex_state = 15},
  [469] = {.lex_state = 6, .external_lex_state = 3},
  [470] = {.lex_state = 15},
  [471] = {.lex_state = 15},
  [472] = {.lex_state = 6, .external_lex_state = 2},
  [473] = {.lex_state = 6, .external_lex_state = 3},
  [474] = {.lex_state = 6, .external_lex_state = 3},
  [475] = {.lex_state = 15},
  [476] = {.lex_state = 15},
  [477] = {.lex_state = 6, .external_lex_state = 3},
  [478] = {.lex_state = 6, .external_lex_state = 2},
  [479] = {.lex_state = 7, .external_lex_state = 2},
  [480] = {.lex_state = 7, .external_lex_state = 2},
  [481] = {.lex_state = 6, .external_lex_state = 2},
  [482] = {.lex_state = 6, .external_lex_state = 2},
  [483] = {.lex_state = 7, .external_lex_state = 2},
  [484] = {.lex_state = 68},
  [485] = {.lex_state = 6, .external_lex_state = 2},
  [486] = {.lex_state = 68},
  [487] = {.lex_state = 68},
  [488] = {.lex_state = 68},
  [489] = {.lex_state = 68},
  [490] = {.lex_state = 6, .external_lex_state = 2},
  [491] = {.lex_state = 68, .external_lex_state = 4},
  [492] = {.lex_state = 68},
  [493] = {.lex_state = 6, .external_lex_state = 3},
  [494] = {.lex_state = 68},
  [495] = {.lex_state = 6, .external_lex_state = 2},
  [496] = {.lex_state = 68},
  [497] = {.lex_state = 68, .external_lex_state = 4},
  [498] = {.lex_state = 6, .external_lex_state = 2},
  [499] = {.lex_state = 6, .external_lex_state = 2},
  [500] = {.lex_state = 68},
  [501] = {.lex_state = 68},
  [502] = {.lex_state = 68},
  [503] = {.lex_state = 68},
  [504] = {.lex_state = 68, .external_lex_state = 4},
  [505] = {.lex_state = 68},
  [506] = {.lex_state = 68, .external_lex_state = 4},
  [507] = {.lex_state = 6, .external_lex_state = 2},
  [508] = {.lex_state = 68, .external_lex_state = 4},
  [509] = {.lex_state = 7, .external_lex_state = 2},
  [510] = {.lex_state = 7, .external_lex_state = 2},
  [511] = {.lex_state = 68},
  [512] = {.lex_state = 68, .external_lex_state = 4},
  [513] = {.lex_state = 68, .external_lex_state = 4},
  [514] = {.lex_state = 68, .external_lex_state = 4},
  [515] = {.lex_state = 68},
  [516] = {.lex_state = 68},
  [517] = {.lex_state = 68, .external_lex_state = 4},
  [518] = {.lex_state = 68, .external_lex_state = 4},
  [519] = {.lex_state = 68, .external_lex_state = 4},
  [520] = {.lex_state = 68},
  [521] = {.lex_state = 68},
  [522] = {.lex_state = 68},
  [523] = {.lex_state = 68},
  [524] = {.lex_state = 68, .external_lex_state = 4},
  [525] = {.lex_state = 68, .external_lex_state = 4},
  [526] = {.lex_state = 68, .external_lex_state = 4},
  [527] = {.lex_state = 68, .external_lex_state = 4},
  [528] = {.lex_state = 68, .external_lex_state = 4},
  [529] = {.lex_state = 68},
  [530] = {.lex_state = 68, .external_lex_state = 4},
  [531] = {.lex_state = 68},
  [532] = {.lex_state = 68},
  [533] = {.lex_state = 68, .external_lex_state = 4},
  [534] = {.lex_state = 68},
  [535] = {.lex_state = 68, .external_lex_state = 4},
  [536] = {.lex_state = 68, .external_lex_state = 4},
  [537] = {.lex_state = 68},
  [538] = {.lex_state = 68},
  [539] = {.lex_state = 68},
  [540] = {.lex_state = 68},
  [541] = {.lex_state = 68},
  [542] = {.lex_state = 68},
  [543] = {.lex_state = 68},
  [544] = {.lex_state = 68},
  [545] = {.lex_state = 68},
  [546] = {.lex_state = 68},
  [547] = {.lex_state = 68},
  [548] = {.lex_state = 68},
  [549] = {.lex_state = 68},
  [550] = {.lex_state = 68},
  [551] = {.lex_state = 68},
  [552] = {.lex_state = 68},
  [553] = {.lex_state = 68},
  [554] = {.lex_state = 68},
  [555] = {.lex_state = 68},
  [556] = {.lex_state = 68},
  [557] = {.lex_state = 68},
  [558] = {.lex_state = 68},
  [559] = {.lex_state = 68},
  [560] = {.lex_state = 68},
  [561] = {.lex_state = 68},
  [562] = {.lex_state = 68},
  [563] = {.lex_state = 68},
  [564] = {.lex_state = 68},
  [565] = {.lex_state = 68},
  [566] = {.lex_state = 68},
  [567] = {.lex_state = 68},
  [568] = {.lex_state = 68},
  [569] = {.lex_state = 68},
  [570] = {.lex_state = 68},
  [571] = {.lex_state = 68},
  [572] = {.lex_state = 68},
  [573] = {.lex_state = 68},
  [574] = {.lex_state = 68},
  [575] = {.lex_state = 68},
  [576] = {.lex_state = 68},
  [577] = {.lex_state = 68},
  [578] = {.lex_state = 68},
  [579] = {.lex_state = 68},
  [580] = {.lex_state = 68},
  [581] = {.lex_state = 68},
  [582] = {.lex_state = 68},
  [583] = {.lex_state = 68},
  [584] = {.lex_state = 68},
  [585] = {.lex_state = 68},
  [586] = {.lex_state = 68},
  [587] = {.lex_state = 68},
  [588] = {.lex_state = 68},
  [589] = {.lex_state = 68},
  [590] = {.lex_state = 68},
  [591] = {.lex_state = 68},
  [592] = {.lex_state = 68},
  [593] = {.lex_state = 68},
  [594] = {.lex_state = 68},
  [595] = {.lex_state = 68},
  [596] = {.lex_state = 68},
  [597] = {.lex_state = 68},
  [598] = {.lex_state = 68},
  [599] = {.lex_state = 68},
  [600] = {.lex_state = 68},
  [601] = {.lex_state = 68},
  [602] = {.lex_state = 68},
  [603] = {.lex_state = 68},
  [604] = {.lex_state = 68},
  [605] = {.lex_state = 68},
  [606] = {.lex_state = 68},
  [607] = {.lex_state = 68},
  [608] = {.lex_state = 68},
  [609] = {.lex_state = 68},
  [610] = {.lex_state = 68},
  [611] = {.lex_state = 68},
  [612] = {.lex_state = 68},
  [613] = {.lex_state = 68},
  [614] = {.lex_state = 68},
  [615] = {.lex_state = 68},
  [616] = {.lex_state = 68},
  [617] = {.lex_state = 68},
  [618] = {.lex_state = 68},
  [619] = {.lex_state = 68},
  [620] = {.lex_state = 15},
  [621] = {.lex_state = 68},
  [622] = {.lex_state = 68},
  [623] = {.lex_state = 68},
  [624] = {.lex_state = 68},
  [625] = {.lex_state = 68},
  [626] = {.lex_state = 68},
  [627] = {.lex_state = 68},
  [628] = {.lex_state = 68},
  [629] = {.lex_state = 68},
  [630] = {.lex_state = 68},
  [631] = {.lex_state = 6, .external_lex_state = 2},
  [632] = {.lex_state = 6, .external_lex_state = 3},
  [633] = {.lex_state = 6, .external_lex_state = 3},
  [634] = {.lex_state = 6, .external_lex_state = 3},
  [635] = {.lex_state = 6, .external_lex_state = 3},
  [636] = {.lex_state = 6, .external_lex_state = 3},
  [637] = {.lex_state = 6, .external_lex_state = 3},
  [638] = {.lex_state = 6, .external_lex_state = 3},
  [639] = {.lex_state = 7, .external_lex_state = 2},
  [640] = {.lex_state = 6, .external_lex_state = 2},
  [641] = {.lex_state = 6, .external_lex_state = 2},
  [642] = {.lex_state = 6, .external_lex_state = 3},
  [643] = {.lex_state = 6, .external_lex_state = 2},
  [644] = {.lex_state = 6, .external_lex_state = 3},
  [645] = {.lex_state = 6, .external_lex_state = 3},
  [646] = {.lex_state = 6, .external_lex_state = 3},
  [647] = {.lex_state = 6, .external_lex_state = 3},
  [648] = {.lex_state = 6, .external_lex_state = 3},
  [649] = {.lex_state = 6, .external_lex_state = 3},
  [650] = {.lex_state = 7, .external_lex_state = 2},
  [651] = {.lex_state = 6, .external_lex_state = 2},
  [652] = {.lex_state = 6, .external_lex_state = 2},
  [653] = {.lex_state = 6, .external_lex_state = 2},
  [654] = {.lex_state = 6, .external_lex_state = 2},
  [655] = {.lex_state = 6, .external_lex_state = 2},
  [656] = {.lex_state = 6, .external_lex_state = 2},
  [657] = {.lex_state = 6, .external_lex_state = 3},
  [658] = {.lex_state = 7, .external_lex_state = 2},
  [659] = {.lex_state = 6, .external_lex_state = 2},
  [660] = {.lex_state = 6, .external_lex_state = 2},
  [661] = {.lex_state = 6, .external_lex_state = 3},
  [662] = {.lex_state = 6, .external_lex_state = 2},
  [663] = {.lex_state = 7, .external_lex_state = 2},
  [664] = {.lex_state = 6, .external_lex_state = 3},
  [665] = {.lex_state = 7, .external_lex_state = 2},
  [666] = {.lex_state = 6, .external_lex_state = 2},
  [667] = {.lex_state = 7, .external_lex_state = 2},
  [668] = {.lex_state = 6, .external_lex_state = 3},
  [669] = {.lex_state = 7, .external_lex_state = 2},
  [670] = {.lex_state = 7, .external_lex_state = 2},
  [671] = {.lex_state = 7, .external_lex_state = 2},
  [672] = {.lex_state = 6, .external_lex_state = 2},
  [673] = {.lex_state = 6, .external_lex_state = 3},
  [674] = {.lex_state = 7, .external_lex_state = 2},
  [675] = {.lex_state = 7, .external_lex_state = 2},
  [676] = {.lex_state = 6, .external_lex_state = 3},
  [677] = {.lex_state = 7, .external_lex_state = 2},
  [678] = {.lex_state = 6, .external_lex_state = 2},
  [679] = {.lex_state = 6, .external_lex_state = 2},
  [680] = {.lex_state = 7, .external_lex_state = 2},
  [681] = {.lex_state = 7, .external_lex_state = 2},
  [682] = {.lex_state = 6, .external_lex_state = 3},
  [683] = {.lex_state = 6, .external_lex_state = 3},
  [684] = {.lex_state = 6, .external_lex_state = 3},
  [685] = {.lex_state = 6, .external_lex_state = 3},
  [686] = {.lex_state = 6, .external_lex_state = 2},
  [687] = {.lex_state = 6, .external_lex_state = 3},
  [688] = {.lex_state = 6, .external_lex_state = 3},
  [689] = {.lex_state = 6, .external_lex_state = 3},
  [690] = {.lex_state = 6, .external_lex_state = 3},
  [691] = {.lex_state = 6, .external_lex_state = 3},
  [692] = {.lex_state = 6, .external_lex_state = 3},
  [693] = {.lex_state = 6, .external_lex_state = 3},
  [694] = {.lex_state = 6, .external_lex_state = 3},
  [695] = {.lex_state = 17},
  [696] = {.lex_state = 7, .external_lex_state = 2},
  [697] = {.lex_state = 6, .external_lex_state = 3},
  [698] = {.lex_state = 6, .external_lex_state = 3},
  [699] = {.lex_state = 17},
  [700] = {.lex_state = 6, .external_lex_state = 2},
  [701] = {.lex_state = 6, .external_lex_state = 2},
  [702] = {.lex_state = 17},
  [703] = {.lex_state = 6, .external_lex_state = 3},
  [704] = {.lex_state = 6, .external_lex_state = 3},
  [705] = {.lex_state = 6, .external_lex_state = 2},
  [706] = {.lex_state = 6, .external_lex_state = 2},
  [707] = {.lex_state = 17},
  [708] = {.lex_state = 7, .external_lex_state = 2},
  [709] = {.lex_state = 6, .external_lex_state = 2},
  [710] = {.lex_state = 6, .external_lex_state = 2},
  [711] = {.lex_state = 6, .external_lex_state = 3},
  [712] = {.lex_state = 6, .external_lex_state = 2},
  [713] = {.lex_state = 7, .external_lex_state = 2},
  [714] = {.lex_state = 17},
  [715] = {.lex_state = 6, .external_lex_state = 2},
  [716] = {.lex_state = 17},
  [717] = {.lex_state = 15},
  [718] = {.lex_state = 7, .external_lex_state = 2},
  [719] = {.lex_state = 6, .external_lex_state = 2},
  [720] = {.lex_state = 6, .external_lex_state = 2},
  [721] = {.lex_state = 17},
  [722] = {.lex_state = 6, .external_lex_state = 3},
  [723] = {.lex_state = 6, .external_lex_state = 2},
  [724] = {.lex_state = 7, .external_lex_state = 2},
  [725] = {.lex_state = 6, .external_lex_state = 3},
  [726] = {.lex_state = 6, .external_lex_state = 3},
  [727] = {.lex_state = 6, .external_lex_state = 2},
  [728] = {.lex_state = 6, .external_lex_state = 3},
  [729] = {.lex_state = 6, .external_lex_state = 2},
  [730] = {.lex_state = 7, .external_lex_state = 2},
  [731] = {.lex_state = 6, .external_lex_state = 2},
  [732] = {.lex_state = 6, .external_lex_state = 2},
  [733] = {.lex_state = 6, .external_lex_state = 3},
  [734] = {.lex_state = 6, .external_lex_state = 3},
  [735] = {.lex_state = 6, .external_lex_state = 3},
  [736] = {.lex_state = 6, .external_lex_state = 3},
  [737] = {.lex_state = 6, .external_lex_state = 3},
  [738] = {.lex_state = 6, .external_lex_state = 3},
  [739] = {.lex_state = 6, .external_lex_state = 3},
  [740] = {.lex_state = 6, .external_lex_state = 2},
  [741] = {.lex_state = 6, .external_lex_state = 2},
  [742] = {.lex_state = 6, .external_lex_state = 3},
  [743] = {.lex_state = 6, .external_lex_state = 2},
  [744] = {.lex_state = 6, .external_lex_state = 3},
  [745] = {.lex_state = 6, .external_lex_state = 3},
  [746] = {.lex_state = 7, .external_lex_state = 2},
  [747] = {.lex_state = 6, .external_lex_state = 2},
  [748] = {.lex_state = 6, .external_lex_state = 3},
  [749] = {.lex_state = 6, .external_lex_state = 3},
  [750] = {.lex_state = 6, .external_lex_state = 3},
  [751] = {.lex_state = 6, .external_lex_state = 3},
  [752] = {.lex_state = 6, .external_lex_state = 3},
  [753] = {.lex_state = 6, .external_lex_state = 3},
  [754] = {.lex_state = 6, .external_lex_state = 3},
  [755] = {.lex_state = 6, .external_lex_state = 3},
  [756] = {.lex_state = 6, .external_lex_state = 3},
  [757] = {.lex_state = 6, .external_lex_state = 2},
  [758] = {.lex_state = 6, .external_lex_state = 3},
  [759] = {.lex_state = 6, .external_lex_state = 3},
  [760] = {.lex_state = 6, .external_lex_state = 2},
  [761] = {.lex_state = 6, .external_lex_state = 3},
  [762] = {.lex_state = 6, .external_lex_state = 3},
  [763] = {.lex_state = 6, .external_lex_state = 2},
  [764] = {.lex_state = 6, .external_lex_state = 3},
  [765] = {.lex_state = 6, .external_lex_state = 2},
  [766] = {.lex_state = 15},
  [767] = {.lex_state = 6, .external_lex_state = 2},
  [768] = {.lex_state = 7, .external_lex_state = 2},
  [769] = {.lex_state = 6, .external_lex_state = 2},
  [770] = {.lex_state = 6, .external_lex_state = 2},
  [771] = {.lex_state = 15},
  [772] = {.lex_state = 6, .external_lex_state = 3},
  [773] = {.lex_state = 7, .external_lex_state = 2},
  [774] = {.lex_state = 6, .external_lex_state = 2},
  [775] = {.lex_state = 15},
  [776] = {.lex_state = 15},
  [777] = {.lex_state = 6, .external_lex_state = 3},
  [778] = {.lex_state = 6, .external_lex_state = 2},
  [779] = {.lex_state = 6, .external_lex_state = 2},
  [780] = {.lex_state = 6, .external_lex_state = 3},
  [781] = {.lex_state = 6, .external_lex_state = 2},
  [782] = {.lex_state = 6, .external_lex_state = 2},
  [783] = {.lex_state = 6, .external_lex_state = 2},
  [784] = {.lex_state = 6, .external_lex_state = 2},
  [785] = {.lex_state = 6, .external_lex_state = 3},
  [786] = {.lex_state = 6, .external_lex_state = 2},
  [787] = {.lex_state = 6, .external_lex_state = 3},
  [788] = {.lex_state = 15},
  [789] = {.lex_state = 6, .external_lex_state = 2},
  [790] = {.lex_state = 6, .external_lex_state = 2},
  [791] = {.lex_state = 15},
  [792] = {.lex_state = 15},
  [793] = {.lex_state = 15},
  [794] = {.lex_state = 15},
  [795] = {.lex_state = 15},
  [796] = {.lex_state = 15},
  [797] = {.lex_state = 15},
  [798] = {.lex_state = 6, .external_lex_state = 2},
  [799] = {.lex_state = 15},
  [800] = {.lex_state = 7, .external_lex_state = 2},
  [801] = {.lex_state = 15},
  [802] = {.lex_state = 15},
  [803] = {.lex_state = 6, .external_lex_state = 3},
  [804] = {.lex_state = 15},
  [805] = {.lex_state = 7, .external_lex_state = 2},
  [806] = {.lex_state = 6, .external_lex_state = 2},
  [807] = {.lex_state = 6, .external_lex_state = 2},
  [808] = {.lex_state = 15},
  [809] = {.lex_state = 7, .external_lex_state = 2},
  [810] = {.lex_state = 15},
  [811] = {.lex_state = 15},
  [812] = {.lex_state = 6, .external_lex_state = 2},
  [813] = {.lex_state = 6, .external_lex_state = 2},
  [814] = {.lex_state = 15},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 6, .external_lex_state = 2},
  [817] = {.lex_state = 6, .external_lex_state = 2},
  [818] = {.lex_state = 6, .external_lex_state = 2},
  [819] = {.lex_state = 15},
  [820] = {.lex_state = 15},
  [821] = {.lex_state = 15},
  [822] = {.lex_state = 6, .external_lex_state = 2},
  [823] = {.lex_state = 15},
  [824] = {.lex_state = 15},
  [825] = {.lex_state = 17},
  [826] = {.lex_state = 15},
  [827] = {.lex_state = 6, .external_lex_state = 2},
  [828] = {.lex_state = 6, .external_lex_state = 3},
  [829] = {.lex_state = 6, .external_lex_state = 2},
  [830] = {.lex_state = 15},
  [831] = {.lex_state = 6, .external_lex_state = 2},
  [832] = {.lex_state = 6, .external_lex_state = 2},
  [833] = {.lex_state = 6, .external_lex_state = 2},
  [834] = {.lex_state = 6, .external_lex_state = 3},
  [835] = {.lex_state = 6, .external_lex_state = 2},
  [836] = {.lex_state = 6, .external_lex_state = 2},
  [837] = {.lex_state = 6, .external_lex_state = 2},
  [838] = {.lex_state = 6, .external_lex_state = 2},
  [839] = {.lex_state = 6, .external_lex_state = 2},
  [840] = {.lex_state = 17},
  [841] = {.lex_state = 6, .external_lex_state = 2},
  [842] = {.lex_state = 15},
  [843] = {.lex_state = 15},
  [844] = {.lex_state = 15},
  [845] = {.lex_state = 15},
  [846] = {.lex_state = 15},
  [847] = {.lex_state = 15},
  [848] = {.lex_state = 15},
  [849] = {.lex_state = 15},
  [850] = {.lex_state = 15},
  [851] = {.lex_state = 15},
  [852] = {.lex_state = 15},
  [853] = {.lex_state = 15},
  [854] = {.lex_state = 15},
  [855] = {.lex_state = 15},
  [856] = {.lex_state = 15},
  [857] = {.lex_state = 15},
  [858] = {.lex_state = 15},
  [859] = {.lex_state = 15},
  [860] = {.lex_state = 15},
  [861] = {.lex_state = 6, .external_lex_state = 2},
  [862] = {.lex_state = 6, .external_lex_state = 2},
  [863] = {.lex_state = 15},
  [864] = {.lex_state = 15},
  [865] = {.lex_state = 15},
  [866] = {.lex_state = 15},
  [867] = {.lex_state = 15},
  [868] = {.lex_state = 15},
  [869] = {.lex_state = 6, .external_lex_state = 2},
  [870] = {.lex_state = 15},
  [871] = {.lex_state = 15},
  [872] = {.lex_state = 6, .external_lex_state = 2},
  [873] = {.lex_state = 6, .external_lex_state = 3},
  [874] = {.lex_state = 6, .external_lex_state = 3},
  [875] = {.lex_state = 15},
  [876] = {.lex_state = 15},
  [877] = {.lex_state = 15},
  [878] = {.lex_state = 15},
  [879] = {.lex_state = 15},
  [880] = {.lex_state = 15},
  [881] = {.lex_state = 15},
  [882] = {.lex_state = 15},
  [883] = {.lex_state = 15},
  [884] = {.lex_state = 15},
  [885] = {.lex_state = 15},
  [886] = {.lex_state = 6, .external_lex_state = 2},
  [887] = {.lex_state = 15},
  [888] = {.lex_state = 15},
  [889] = {.lex_state = 15},
  [890] = {.lex_state = 15},
  [891] = {.lex_state = 15},
  [892] = {.lex_state = 15},
  [893] = {.lex_state = 15},
  [894] = {.lex_state = 15},
  [895] = {.lex_state = 15},
  [896] = {.lex_state = 15},
  [897] = {.lex_state = 15},
  [898] = {.lex_state = 15},
  [899] = {.lex_state = 15},
  [900] = {.lex_state = 15},
  [901] = {.lex_state = 15},
  [902] = {.lex_state = 15},
  [903] = {.lex_state = 15},
  [904] = {.lex_state = 15},
  [905] = {.lex_state = 15},
  [906] = {.lex_state = 15},
  [907] = {.lex_state = 15},
  [908] = {.lex_state = 15},
  [909] = {.lex_state = 15},
  [910] = {.lex_state = 15},
  [911] = {.lex_state = 15},
  [912] = {.lex_state = 15},
  [913] = {.lex_state = 15},
  [914] = {.lex_state = 15},
  [915] = {.lex_state = 15},
  [916] = {.lex_state = 15},
  [917] = {.lex_state = 15},
  [918] = {.lex_state = 15},
  [919] = {.lex_state = 15},
  [920] = {.lex_state = 15},
  [921] = {.lex_state = 15},
  [922] = {.lex_state = 15},
  [923] = {.lex_state = 15},
  [924] = {.lex_state = 15},
  [925] = {.lex_state = 15},
  [926] = {.lex_state = 15},
  [927] = {.lex_state = 15},
  [928] = {.lex_state = 15},
  [929] = {.lex_state = 15},
  [930] = {.lex_state = 6, .external_lex_state = 2},
  [931] = {.lex_state = 15},
  [932] = {.lex_state = 15},
  [933] = {.lex_state = 15},
  [934] = {.lex_state = 15},
  [935] = {.lex_state = 15},
  [936] = {.lex_state = 15},
  [937] = {.lex_state = 15},
  [938] = {.lex_state = 15},
  [939] = {.lex_state = 15},
  [940] = {.lex_state = 15},
  [941] = {.lex_state = 15},
  [942] = {.lex_state = 15},
  [943] = {.lex_state = 15},
  [944] = {.lex_state = 15},
  [945] = {.lex_state = 15},
  [946] = {.lex_state = 15},
  [947] = {.lex_state = 15},
  [948] = {.lex_state = 15},
  [949] = {.lex_state = 15},
  [950] = {.lex_state = 15},
  [951] = {.lex_state = 15},
  [952] = {.lex_state = 15},
  [953] = {.lex_state = 15},
  [954] = {.lex_state = 15},
  [955] = {.lex_state = 15},
  [956] = {.lex_state = 15},
  [957] = {.lex_state = 6, .external_lex_state = 2},
  [958] = {.lex_state = 6, .external_lex_state = 2},
  [959] = {.lex_state = 6, .external_lex_state = 2},
  [960] = {.lex_state = 6, .external_lex_state = 2},
  [961] = {.lex_state = 67, .external_lex_state = 3},
  [962] = {.lex_state = 68, .external_lex_state = 4},
  [963] = {.lex_state = 15},
  [964] = {.lex_state = 15},
  [965] = {.lex_state = 15},
  [966] = {.lex_state = 68, .external_lex_state = 4},
  [967] = {.lex_state = 68, .external_lex_state = 4},
  [968] = {.lex_state = 15},
  [969] = {.lex_state = 15},
  [970] = {.lex_state = 68, .external_lex_state = 4},
  [971] = {.lex_state = 68, .external_lex_state = 4},
  [972] = {.lex_state = 68, .external_lex_state = 4},
  [973] = {.lex_state = 15},
  [974] = {.lex_state = 15},
  [975] = {.lex_state = 15},
  [976] = {.lex_state = 15},
  [977] = {.lex_state = 15},
  [978] = {.lex_state = 15},
  [979] = {.lex_state = 15},
  [980] = {.lex_state = 15},
  [981] = {.lex_state = 15},
  [982] = {.lex_state = 15},
  [983] = {.lex_state = 15},
  [984] = {.lex_state = 15},
  [985] = {.lex_state = 15},
  [986] = {.lex_state = 15},
  [987] = {.lex_state = 15},
  [988] = {.lex_state = 67, .external_lex_state = 2},
  [989] = {.lex_state = 67, .external_lex_state = 3},
  [990] = {.lex_state = 67, .external_lex_state = 2},
  [991] = {.lex_state = 67, .external_lex_state = 2},
  [992] = {.lex_state = 67, .external_lex_state = 2},
  [993] = {.lex_state = 67, .external_lex_state = 3},
  [994] = {.lex_state = 67, .external_lex_state = 2},
  [995] = {.lex_state = 15},
  [996] = {.lex_state = 67, .external_lex_state = 2},
  [997] = {.lex_state = 67, .external_lex_state = 2},
  [998] = {.lex_state = 15},
  [999] = {.lex_state = 15},
  [1000] = {.lex_state = 67, .external_lex_state = 2},
  [1001] = {.lex_state = 67, .external_lex_state = 2},
  [1002] = {.lex_state = 15},
  [1003] = {.lex_state = 67, .external_lex_state = 2},
  [1004] = {.lex_state = 67, .external_lex_state = 2},
  [1005] = {.lex_state = 67, .external_lex_state = 2},
  [1006] = {.lex_state = 67, .external_lex_state = 2},
  [1007] = {.lex_state = 67, .external_lex_state = 2},
  [1008] = {.lex_state = 67, .external_lex_state = 2},
  [1009] = {.lex_state = 67, .external_lex_state = 2},
  [1010] = {.lex_state = 67, .external_lex_state = 2},
  [1011] = {.lex_state = 15},
  [1012] = {.lex_state = 15},
  [1013] = {.lex_state = 67, .external_lex_state = 3},
  [1014] = {.lex_state = 67, .external_lex_state = 2},
  [1015] = {.lex_state = 67, .external_lex_state = 2},
  [1016] = {.lex_state = 67, .external_lex_state = 2},
  [1017] = {.lex_state = 67, .external_lex_state = 3},
  [1018] = {.lex_state = 67, .external_lex_state = 2},
  [1019] = {.lex_state = 67, .external_lex_state = 2},
  [1020] = {.lex_state = 67, .external_lex_state = 3},
  [1021] = {.lex_state = 67, .external_lex_state = 2},
  [1022] = {.lex_state = 67, .external_lex_state = 2},
  [1023] = {.lex_state = 67, .external_lex_state = 2},
  [1024] = {.lex_state = 67, .external_lex_state = 2},
  [1025] = {.lex_state = 67, .external_lex_state = 2},
  [1026] = {.lex_state = 67, .external_lex_state = 2},
  [1027] = {.lex_state = 67, .external_lex_state = 2},
  [1028] = {.lex_state = 67, .external_lex_state = 2},
  [1029] = {.lex_state = 67, .external_lex_state = 2},
  [1030] = {.lex_state = 67, .external_lex_state = 2},
  [1031] = {.lex_state = 67, .external_lex_state = 2},
  [1032] = {.lex_state = 67, .external_lex_state = 2},
  [1033] = {.lex_state = 67, .external_lex_state = 2},
  [1034] = {.lex_state = 67, .external_lex_state = 2},
  [1035] = {.lex_state = 67, .external_lex_state = 2},
  [1036] = {.lex_state = 67, .external_lex_state = 2},
  [1037] = {.lex_state = 67, .external_lex_state = 2},
  [1038] = {.lex_state = 67, .external_lex_state = 2},
  [1039] = {.lex_state = 67, .external_lex_state = 3},
  [1040] = {.lex_state = 67, .external_lex_state = 3},
  [1041] = {.lex_state = 67, .external_lex_state = 2},
  [1042] = {.lex_state = 67, .external_lex_state = 2},
  [1043] = {.lex_state = 67, .external_lex_state = 2},
  [1044] = {.lex_state = 67, .external_lex_state = 2},
  [1045] = {.lex_state = 67, .external_lex_state = 2},
  [1046] = {.lex_state = 67, .external_lex_state = 2},
  [1047] = {.lex_state = 67, .external_lex_state = 2},
  [1048] = {.lex_state = 67, .external_lex_state = 2},
  [1049] = {.lex_state = 67, .external_lex_state = 2},
  [1050] = {.lex_state = 67, .external_lex_state = 2},
  [1051] = {.lex_state = 67, .external_lex_state = 2},
  [1052] = {.lex_state = 67, .external_lex_state = 3},
  [1053] = {.lex_state = 67, .external_lex_state = 2},
  [1054] = {.lex_state = 67, .external_lex_state = 2},
  [1055] = {.lex_state = 67, .external_lex_state = 3},
  [1056] = {.lex_state = 67, .external_lex_state = 2},
  [1057] = {.lex_state = 67, .external_lex_state = 2},
  [1058] = {.lex_state = 67, .external_lex_state = 2},
  [1059] = {.lex_state = 67, .external_lex_state = 2},
  [1060] = {.lex_state = 67, .external_lex_state = 2},
  [1061] = {.lex_state = 67, .external_lex_state = 2},
  [1062] = {.lex_state = 67, .external_lex_state = 2},
  [1063] = {.lex_state = 67, .external_lex_state = 2},
  [1064] = {.lex_state = 67, .external_lex_state = 2},
  [1065] = {.lex_state = 67, .external_lex_state = 2},
  [1066] = {.lex_state = 67, .external_lex_state = 2},
  [1067] = {.lex_state = 67, .external_lex_state = 2},
  [1068] = {.lex_state = 67, .external_lex_state = 2},
  [1069] = {.lex_state = 67, .external_lex_state = 2},
  [1070] = {.lex_state = 67, .external_lex_state = 2},
  [1071] = {.lex_state = 67, .external_lex_state = 2},
  [1072] = {.lex_state = 67, .external_lex_state = 2},
  [1073] = {.lex_state = 67, .external_lex_state = 2},
  [1074] = {.lex_state = 67, .external_lex_state = 2},
  [1075] = {.lex_state = 67, .external_lex_state = 2},
  [1076] = {.lex_state = 67, .external_lex_state = 2},
  [1077] = {.lex_state = 67, .external_lex_state = 2},
  [1078] = {.lex_state = 67, .external_lex_state = 2},
  [1079] = {.lex_state = 67, .external_lex_state = 2},
  [1080] = {.lex_state = 67, .external_lex_state = 2},
  [1081] = {.lex_state = 67, .external_lex_state = 2},
  [1082] = {.lex_state = 67, .external_lex_state = 2},
  [1083] = {.lex_state = 67, .external_lex_state = 2},
  [1084] = {.lex_state = 67, .external_lex_state = 2},
  [1085] = {.lex_state = 67, .external_lex_state = 2},
  [1086] = {.lex_state = 67, .external_lex_state = 2},
  [1087] = {.lex_state = 67, .external_lex_state = 2},
  [1088] = {.lex_state = 67, .external_lex_state = 2},
  [1089] = {.lex_state = 67, .external_lex_state = 2},
  [1090] = {.lex_state = 67, .external_lex_state = 2},
  [1091] = {.lex_state = 67, .external_lex_state = 2},
  [1092] = {.lex_state = 67, .external_lex_state = 2},
  [1093] = {.lex_state = 67, .external_lex_state = 2},
  [1094] = {.lex_state = 67, .external_lex_state = 2},
  [1095] = {.lex_state = 67, .external_lex_state = 2},
  [1096] = {.lex_state = 67, .external_lex_state = 2},
  [1097] = {.lex_state = 67, .external_lex_state = 2},
  [1098] = {.lex_state = 67, .external_lex_state = 2},
  [1099] = {.lex_state = 67, .external_lex_state = 3},
  [1100] = {.lex_state = 67, .external_lex_state = 3},
  [1101] = {.lex_state = 67, .external_lex_state = 2},
  [1102] = {.lex_state = 67, .external_lex_state = 3},
  [1103] = {.lex_state = 67, .external_lex_state = 2},
  [1104] = {.lex_state = 67, .external_lex_state = 3},
  [1105] = {.lex_state = 67, .external_lex_state = 2},
  [1106] = {.lex_state = 67, .external_lex_state = 2},
  [1107] = {.lex_state = 67, .external_lex_state = 2},
  [1108] = {.lex_state = 67, .external_lex_state = 2},
  [1109] = {.lex_state = 67, .external_lex_state = 3},
  [1110] = {.lex_state = 67, .external_lex_state = 3},
  [1111] = {.lex_state = 67, .external_lex_state = 2},
  [1112] = {.lex_state = 67, .external_lex_state = 2},
  [1113] = {.lex_state = 67, .external_lex_state = 3},
  [1114] = {.lex_state = 67, .external_lex_state = 3},
  [1115] = {.lex_state = 67, .external_lex_state = 2},
  [1116] = {.lex_state = 67, .external_lex_state = 3},
  [1117] = {.lex_state = 67, .external_lex_state = 3},
  [1118] = {.lex_state = 67, .external_lex_state = 2},
  [1119] = {.lex_state = 67, .external_lex_state = 3},
  [1120] = {.lex_state = 67, .external_lex_state = 3},
  [1121] = {.lex_state = 67, .external_lex_state = 2},
  [1122] = {.lex_state = 67, .external_lex_state = 3},
  [1123] = {.lex_state = 67, .external_lex_state = 2},
  [1124] = {.lex_state = 67, .external_lex_state = 3},
  [1125] = {.lex_state = 67, .external_lex_state = 2},
  [1126] = {.lex_state = 67, .external_lex_state = 2},
  [1127] = {.lex_state = 67, .external_lex_state = 2},
  [1128] = {.lex_state = 67, .external_lex_state = 3},
  [1129] = {.lex_state = 67, .external_lex_state = 3},
  [1130] = {.lex_state = 67, .external_lex_state = 3},
  [1131] = {.lex_state = 67, .external_lex_state = 3},
  [1132] = {.lex_state = 67, .external_lex_state = 2},
  [1133] = {.lex_state = 67, .external_lex_state = 3},
  [1134] = {.lex_state = 67, .external_lex_state = 2},
  [1135] = {.lex_state = 67, .external_lex_state = 2},
  [1136] = {.lex_state = 67, .external_lex_state = 2},
  [1137] = {.lex_state = 67, .external_lex_state = 3},
  [1138] = {.lex_state = 67, .external_lex_state = 3},
  [1139] = {.lex_state = 67, .external_lex_state = 2},
  [1140] = {.lex_state = 67, .external_lex_state = 3},
  [1141] = {.lex_state = 67, .external_lex_state = 2},
  [1142] = {.lex_state = 67, .external_lex_state = 3},
  [1143] = {.lex_state = 67, .external_lex_state = 2},
  [1144] = {.lex_state = 67, .external_lex_state = 2},
  [1145] = {.lex_state = 67, .external_lex_state = 3},
  [1146] = {.lex_state = 67, .external_lex_state = 2},
  [1147] = {.lex_state = 67, .external_lex_state = 3},
  [1148] = {.lex_state = 67, .external_lex_state = 2},
  [1149] = {.lex_state = 67, .external_lex_state = 2},
  [1150] = {.lex_state = 67, .external_lex_state = 3},
  [1151] = {.lex_state = 67, .external_lex_state = 3},
  [1152] = {.lex_state = 67, .external_lex_state = 2},
  [1153] = {.lex_state = 67, .external_lex_state = 2},
  [1154] = {.lex_state = 67, .external_lex_state = 2},
  [1155] = {.lex_state = 67, .external_lex_state = 3},
  [1156] = {.lex_state = 67, .external_lex_state = 2},
  [1157] = {.lex_state = 67, .external_lex_state = 3},
  [1158] = {.lex_state = 67, .external_lex_state = 2},
  [1159] = {.lex_state = 8, .external_lex_state = 2},
  [1160] = {.lex_state = 67, .external_lex_state = 3},
  [1161] = {.lex_state = 67, .external_lex_state = 3},
  [1162] = {.lex_state = 67, .external_lex_state = 3},
  [1163] = {.lex_state = 67, .external_lex_state = 2},
  [1164] = {.lex_state = 67, .external_lex_state = 3},
  [1165] = {.lex_state = 67, .external_lex_state = 3},
  [1166] = {.lex_state = 67, .external_lex_state = 2},
  [1167] = {.lex_state = 67, .external_lex_state = 2},
  [1168] = {.lex_state = 67, .external_lex_state = 2},
  [1169] = {.lex_state = 67, .external_lex_state = 3},
  [1170] = {.lex_state = 67, .external_lex_state = 2},
  [1171] = {.lex_state = 67, .external_lex_state = 2},
  [1172] = {.lex_state = 67, .external_lex_state = 2},
  [1173] = {.lex_state = 67, .external_lex_state = 2},
  [1174] = {.lex_state = 67, .external_lex_state = 2},
  [1175] = {.lex_state = 67, .external_lex_state = 3},
  [1176] = {.lex_state = 67, .external_lex_state = 2},
  [1177] = {.lex_state = 67, .external_lex_state = 2},
  [1178] = {.lex_state = 67, .external_lex_state = 2},
  [1179] = {.lex_state = 67, .external_lex_state = 2},
  [1180] = {.lex_state = 67, .external_lex_state = 2},
  [1181] = {.lex_state = 67, .external_lex_state = 3},
  [1182] = {.lex_state = 67, .external_lex_state = 2},
  [1183] = {.lex_state = 67, .external_lex_state = 2},
  [1184] = {.lex_state = 67, .external_lex_state = 2},
  [1185] = {.lex_state = 67, .external_lex_state = 3},
  [1186] = {.lex_state = 67, .external_lex_state = 3},
  [1187] = {.lex_state = 67, .external_lex_state = 2},
  [1188] = {.lex_state = 67, .external_lex_state = 2},
  [1189] = {.lex_state = 67, .external_lex_state = 2},
  [1190] = {.lex_state = 67, .external_lex_state = 2},
  [1191] = {.lex_state = 67, .external_lex_state = 2},
  [1192] = {.lex_state = 67, .external_lex_state = 2},
  [1193] = {.lex_state = 67, .external_lex_state = 2},
  [1194] = {.lex_state = 67, .external_lex_state = 3},
  [1195] = {.lex_state = 67, .external_lex_state = 2},
  [1196] = {.lex_state = 67, .external_lex_state = 2},
  [1197] = {.lex_state = 67, .external_lex_state = 3},
  [1198] = {.lex_state = 67, .external_lex_state = 2},
  [1199] = {.lex_state = 67, .external_lex_state = 3},
  [1200] = {.lex_state = 67, .external_lex_state = 3},
  [1201] = {.lex_state = 67, .external_lex_state = 2},
  [1202] = {.lex_state = 67, .external_lex_state = 2},
  [1203] = {.lex_state = 67, .external_lex_state = 2},
  [1204] = {.lex_state = 67, .external_lex_state = 3},
  [1205] = {.lex_state = 67, .external_lex_state = 2},
  [1206] = {.lex_state = 67, .external_lex_state = 2},
  [1207] = {.lex_state = 67, .external_lex_state = 2},
  [1208] = {.lex_state = 67, .external_lex_state = 2},
  [1209] = {.lex_state = 67, .external_lex_state = 2},
  [1210] = {.lex_state = 67, .external_lex_state = 2},
  [1211] = {.lex_state = 8, .external_lex_state = 2},
  [1212] = {.lex_state = 67, .external_lex_state = 3},
  [1213] = {.lex_state = 67, .external_lex_state = 3},
  [1214] = {.lex_state = 67, .external_lex_state = 2},
  [1215] = {.lex_state = 67, .external_lex_state = 2},
  [1216] = {.lex_state = 8, .external_lex_state = 2},
  [1217] = {.lex_state = 67, .external_lex_state = 2},
  [1218] = {.lex_state = 67, .external_lex_state = 2},
  [1219] = {.lex_state = 67, .external_lex_state = 2},
  [1220] = {.lex_state = 67, .external_lex_state = 2},
  [1221] = {.lex_state = 67, .external_lex_state = 3},
  [1222] = {.lex_state = 67, .external_lex_state = 2},
  [1223] = {.lex_state = 67, .external_lex_state = 2},
  [1224] = {.lex_state = 67, .external_lex_state = 2},
  [1225] = {.lex_state = 67, .external_lex_state = 3},
  [1226] = {.lex_state = 67, .external_lex_state = 3},
  [1227] = {.lex_state = 67, .external_lex_state = 2},
  [1228] = {.lex_state = 67, .external_lex_state = 2},
  [1229] = {.lex_state = 67, .external_lex_state = 2},
  [1230] = {.lex_state = 67, .external_lex_state = 3},
  [1231] = {.lex_state = 67, .external_lex_state = 2},
  [1232] = {.lex_state = 67, .external_lex_state = 2},
  [1233] = {.lex_state = 67, .external_lex_state = 3},
  [1234] = {.lex_state = 8, .external_lex_state = 2},
  [1235] = {.lex_state = 67, .external_lex_state = 3},
  [1236] = {.lex_state = 67, .external_lex_state = 2},
  [1237] = {.lex_state = 67, .external_lex_state = 2},
  [1238] = {.lex_state = 67, .external_lex_state = 3},
  [1239] = {.lex_state = 67, .external_lex_state = 3},
  [1240] = {.lex_state = 8, .external_lex_state = 2},
  [1241] = {.lex_state = 67, .external_lex_state = 2},
  [1242] = {.lex_state = 67, .external_lex_state = 3},
  [1243] = {.lex_state = 8, .external_lex_state = 2},
  [1244] = {.lex_state = 67, .external_lex_state = 2},
  [1245] = {.lex_state = 8, .external_lex_state = 2},
  [1246] = {.lex_state = 67, .external_lex_state = 3},
  [1247] = {.lex_state = 67, .external_lex_state = 2},
  [1248] = {.lex_state = 67, .external_lex_state = 3},
  [1249] = {.lex_state = 8, .external_lex_state = 2},
  [1250] = {.lex_state = 8, .external_lex_state = 2},
  [1251] = {.lex_state = 67, .external_lex_state = 2},
  [1252] = {.lex_state = 67, .external_lex_state = 3},
  [1253] = {.lex_state = 67, .external_lex_state = 3},
  [1254] = {.lex_state = 8, .external_lex_state = 2},
  [1255] = {.lex_state = 67, .external_lex_state = 3},
  [1256] = {.lex_state = 67, .external_lex_state = 2},
  [1257] = {.lex_state = 67, .external_lex_state = 2},
  [1258] = {.lex_state = 67, .external_lex_state = 3},
  [1259] = {.lex_state = 67, .external_lex_state = 2},
  [1260] = {.lex_state = 8, .external_lex_state = 2},
  [1261] = {.lex_state = 8, .external_lex_state = 2},
  [1262] = {.lex_state = 67, .external_lex_state = 2},
  [1263] = {.lex_state = 9, .external_lex_state = 2},
  [1264] = {.lex_state = 67, .external_lex_state = 2},
  [1265] = {.lex_state = 67, .external_lex_state = 2},
  [1266] = {.lex_state = 8, .external_lex_state = 2},
  [1267] = {.lex_state = 67, .external_lex_state = 3},
  [1268] = {.lex_state = 8, .external_lex_state = 2},
  [1269] = {.lex_state = 8, .external_lex_state = 2},
  [1270] = {.lex_state = 67, .external_lex_state = 3},
  [1271] = {.lex_state = 67, .external_lex_state = 3},
  [1272] = {.lex_state = 67, .external_lex_state = 3},
  [1273] = {.lex_state = 67, .external_lex_state = 3},
  [1274] = {.lex_state = 67, .external_lex_state = 2},
  [1275] = {.lex_state = 67, .external_lex_state = 2},
  [1276] = {.lex_state = 67, .external_lex_state = 2},
  [1277] = {.lex_state = 67, .external_lex_state = 2},
  [1278] = {.lex_state = 67, .external_lex_state = 2},
  [1279] = {.lex_state = 67, .external_lex_state = 3},
  [1280] = {.lex_state = 8, .external_lex_state = 2},
  [1281] = {.lex_state = 8, .external_lex_state = 2},
  [1282] = {.lex_state = 8, .external_lex_state = 2},
  [1283] = {.lex_state = 67, .external_lex_state = 2},
  [1284] = {.lex_state = 8, .external_lex_state = 2},
  [1285] = {.lex_state = 67, .external_lex_state = 3},
  [1286] = {.lex_state = 67, .external_lex_state = 2},
  [1287] = {.lex_state = 67, .external_lex_state = 3},
  [1288] = {.lex_state = 67, .external_lex_state = 2},
  [1289] = {.lex_state = 67, .external_lex_state = 2},
  [1290] = {.lex_state = 67, .external_lex_state = 2},
  [1291] = {.lex_state = 8, .external_lex_state = 2},
  [1292] = {.lex_state = 8, .external_lex_state = 2},
  [1293] = {.lex_state = 8, .external_lex_state = 2},
  [1294] = {.lex_state = 8, .external_lex_state = 2},
  [1295] = {.lex_state = 8, .external_lex_state = 2},
  [1296] = {.lex_state = 67, .external_lex_state = 2},
  [1297] = {.lex_state = 8, .external_lex_state = 2},
  [1298] = {.lex_state = 8, .external_lex_state = 2},
  [1299] = {.lex_state = 8, .external_lex_state = 2},
  [1300] = {.lex_state = 67, .external_lex_state = 2},
  [1301] = {.lex_state = 67, .external_lex_state = 2},
  [1302] = {.lex_state = 67, .external_lex_state = 2},
  [1303] = {.lex_state = 67, .external_lex_state = 2},
  [1304] = {.lex_state = 67, .external_lex_state = 2},
  [1305] = {.lex_state = 67, .external_lex_state = 3},
  [1306] = {.lex_state = 8, .external_lex_state = 2},
  [1307] = {.lex_state = 67, .external_lex_state = 3},
  [1308] = {.lex_state = 67, .external_lex_state = 3},
  [1309] = {.lex_state = 8, .external_lex_state = 2},
  [1310] = {.lex_state = 8, .external_lex_state = 2},
  [1311] = {.lex_state = 8, .external_lex_state = 2},
  [1312] = {.lex_state = 67, .external_lex_state = 3},
  [1313] = {.lex_state = 67, .external_lex_state = 2},
  [1314] = {.lex_state = 67, .external_lex_state = 2},
  [1315] = {.lex_state = 67, .external_lex_state = 2},
  [1316] = {.lex_state = 67, .external_lex_state = 2},
  [1317] = {.lex_state = 67, .external_lex_state = 2},
  [1318] = {.lex_state = 67, .external_lex_state = 2},
  [1319] = {.lex_state = 67, .external_lex_state = 2},
  [1320] = {.lex_state = 67, .external_lex_state = 2},
  [1321] = {.lex_state = 67, .external_lex_state = 2},
  [1322] = {.lex_state = 67, .external_lex_state = 2},
  [1323] = {.lex_state = 67, .external_lex_state = 2},
  [1324] = {.lex_state = 67, .external_lex_state = 2},
  [1325] = {.lex_state = 67, .external_lex_state = 2},
  [1326] = {.lex_state = 67, .external_lex_state = 2},
  [1327] = {.lex_state = 67, .external_lex_state = 2},
  [1328] = {.lex_state = 67, .external_lex_state = 3},
  [1329] = {.lex_state = 67, .external_lex_state = 3},
  [1330] = {.lex_state = 67, .external_lex_state = 3},
  [1331] = {.lex_state = 67, .external_lex_state = 3},
  [1332] = {.lex_state = 67, .external_lex_state = 3},
  [1333] = {.lex_state = 67, .external_lex_state = 2},
  [1334] = {.lex_state = 67, .external_lex_state = 3},
  [1335] = {.lex_state = 67, .external_lex_state = 3},
  [1336] = {.lex_state = 67, .external_lex_state = 3},
  [1337] = {.lex_state = 67, .external_lex_state = 3},
  [1338] = {.lex_state = 67, .external_lex_state = 3},
  [1339] = {.lex_state = 67, .external_lex_state = 3},
  [1340] = {.lex_state = 67, .external_lex_state = 2},
  [1341] = {.lex_state = 67, .external_lex_state = 3},
  [1342] = {.lex_state = 67, .external_lex_state = 2},
  [1343] = {.lex_state = 67, .external_lex_state = 3},
  [1344] = {.lex_state = 67, .external_lex_state = 2},
  [1345] = {.lex_state = 67, .external_lex_state = 2},
  [1346] = {.lex_state = 67, .external_lex_state = 2},
  [1347] = {.lex_state = 67, .external_lex_state = 3},
  [1348] = {.lex_state = 67, .external_lex_state = 3},
  [1349] = {.lex_state = 67, .external_lex_state = 3},
  [1350] = {.lex_state = 67, .external_lex_state = 3},
  [1351] = {.lex_state = 67, .external_lex_state = 2},
  [1352] = {.lex_state = 67, .external_lex_state = 3},
  [1353] = {.lex_state = 67, .external_lex_state = 2},
  [1354] = {.lex_state = 67, .external_lex_state = 3},
  [1355] = {.lex_state = 67, .external_lex_state = 2},
  [1356] = {.lex_state = 67, .external_lex_state = 3},
  [1357] = {.lex_state = 67, .external_lex_state = 2},
  [1358] = {.lex_state = 67, .external_lex_state = 3},
  [1359] = {.lex_state = 67, .external_lex_state = 3},
  [1360] = {.lex_state = 67, .external_lex_state = 3},
  [1361] = {.lex_state = 67, .external_lex_state = 3},
  [1362] = {.lex_state = 67, .external_lex_state = 3},
  [1363] = {.lex_state = 8, .external_lex_state = 2},
  [1364] = {.lex_state = 67, .external_lex_state = 3},
  [1365] = {.lex_state = 67, .external_lex_state = 3},
  [1366] = {.lex_state = 67, .external_lex_state = 3},
  [1367] = {.lex_state = 67, .external_lex_state = 3},
  [1368] = {.lex_state = 67, .external_lex_state = 3},
  [1369] = {.lex_state = 67, .external_lex_state = 3},
  [1370] = {.lex_state = 8, .external_lex_state = 2},
  [1371] = {.lex_state = 67, .external_lex_state = 3},
  [1372] = {.lex_state = 67, .external_lex_state = 3},
  [1373] = {.lex_state = 67, .external_lex_state = 2},
  [1374] = {.lex_state = 67, .external_lex_state = 2},
  [1375] = {.lex_state = 67, .external_lex_state = 3},
  [1376] = {.lex_state = 67, .external_lex_state = 3},
  [1377] = {.lex_state = 67, .external_lex_state = 2},
  [1378] = {.lex_state = 8, .external_lex_state = 2},
  [1379] = {.lex_state = 67, .external_lex_state = 3},
  [1380] = {.lex_state = 67, .external_lex_state = 3},
  [1381] = {.lex_state = 67, .external_lex_state = 3},
  [1382] = {.lex_state = 67, .external_lex_state = 3},
  [1383] = {.lex_state = 67, .external_lex_state = 2},
  [1384] = {.lex_state = 67, .external_lex_state = 2},
  [1385] = {.lex_state = 67, .external_lex_state = 3},
  [1386] = {.lex_state = 9, .external_lex_state = 3},
  [1387] = {.lex_state = 8, .external_lex_state = 2},
  [1388] = {.lex_state = 67, .external_lex_state = 2},
  [1389] = {.lex_state = 8, .external_lex_state = 3},
  [1390] = {.lex_state = 67, .external_lex_state = 3},
  [1391] = {.lex_state = 67, .external_lex_state = 2},
  [1392] = {.lex_state = 67, .external_lex_state = 2},
  [1393] = {.lex_state = 8, .external_lex_state = 2},
  [1394] = {.lex_state = 67, .external_lex_state = 2},
  [1395] = {.lex_state = 67, .external_lex_state = 2},
  [1396] = {.lex_state = 67, .external_lex_state = 3},
  [1397] = {.lex_state = 67, .external_lex_state = 3},
  [1398] = {.lex_state = 67, .external_lex_state = 2},
  [1399] = {.lex_state = 67, .external_lex_state = 3},
  [1400] = {.lex_state = 67, .external_lex_state = 2},
  [1401] = {.lex_state = 67, .external_lex_state = 2},
  [1402] = {.lex_state = 67, .external_lex_state = 2},
  [1403] = {.lex_state = 67, .external_lex_state = 2},
  [1404] = {.lex_state = 67, .external_lex_state = 2},
  [1405] = {.lex_state = 67, .external_lex_state = 2},
  [1406] = {.lex_state = 67, .external_lex_state = 2},
  [1407] = {.lex_state = 67, .external_lex_state = 3},
  [1408] = {.lex_state = 67, .external_lex_state = 2},
  [1409] = {.lex_state = 67, .external_lex_state = 3},
  [1410] = {.lex_state = 67, .external_lex_state = 3},
  [1411] = {.lex_state = 67, .external_lex_state = 2},
  [1412] = {.lex_state = 67, .external_lex_state = 3},
  [1413] = {.lex_state = 8, .external_lex_state = 2},
  [1414] = {.lex_state = 67, .external_lex_state = 3},
  [1415] = {.lex_state = 67, .external_lex_state = 3},
  [1416] = {.lex_state = 67, .external_lex_state = 3},
  [1417] = {.lex_state = 67, .external_lex_state = 3},
  [1418] = {.lex_state = 67, .external_lex_state = 3},
  [1419] = {.lex_state = 67, .external_lex_state = 3},
  [1420] = {.lex_state = 67, .external_lex_state = 3},
  [1421] = {.lex_state = 67, .external_lex_state = 3},
  [1422] = {.lex_state = 67, .external_lex_state = 3},
  [1423] = {.lex_state = 67, .external_lex_state = 2},
  [1424] = {.lex_state = 67, .external_lex_state = 3},
  [1425] = {.lex_state = 67, .external_lex_state = 3},
  [1426] = {.lex_state = 67, .external_lex_state = 2},
  [1427] = {.lex_state = 67, .external_lex_state = 3},
  [1428] = {.lex_state = 67, .external_lex_state = 3},
  [1429] = {.lex_state = 67, .external_lex_state = 3},
  [1430] = {.lex_state = 67, .external_lex_state = 3},
  [1431] = {.lex_state = 67, .external_lex_state = 3},
  [1432] = {.lex_state = 67, .external_lex_state = 3},
  [1433] = {.lex_state = 67, .external_lex_state = 3},
  [1434] = {.lex_state = 67, .external_lex_state = 3},
  [1435] = {.lex_state = 67, .external_lex_state = 3},
  [1436] = {.lex_state = 8, .external_lex_state = 2},
  [1437] = {.lex_state = 67, .external_lex_state = 3},
  [1438] = {.lex_state = 67, .external_lex_state = 3},
  [1439] = {.lex_state = 67, .external_lex_state = 3},
  [1440] = {.lex_state = 67, .external_lex_state = 3},
  [1441] = {.lex_state = 67, .external_lex_state = 2},
  [1442] = {.lex_state = 67, .external_lex_state = 2},
  [1443] = {.lex_state = 67, .external_lex_state = 3},
  [1444] = {.lex_state = 67, .external_lex_state = 3},
  [1445] = {.lex_state = 67, .external_lex_state = 3},
  [1446] = {.lex_state = 67, .external_lex_state = 3},
  [1447] = {.lex_state = 67, .external_lex_state = 3},
  [1448] = {.lex_state = 67, .external_lex_state = 3},
  [1449] = {.lex_state = 8, .external_lex_state = 2},
  [1450] = {.lex_state = 67, .external_lex_state = 2},
  [1451] = {.lex_state = 8, .external_lex_state = 2},
  [1452] = {.lex_state = 67, .external_lex_state = 3},
  [1453] = {.lex_state = 67, .external_lex_state = 3},
  [1454] = {.lex_state = 67, .external_lex_state = 3},
  [1455] = {.lex_state = 67, .external_lex_state = 3},
  [1456] = {.lex_state = 67, .external_lex_state = 3},
  [1457] = {.lex_state = 67, .external_lex_state = 2},
  [1458] = {.lex_state = 67, .external_lex_state = 3},
  [1459] = {.lex_state = 67, .external_lex_state = 3},
  [1460] = {.lex_state = 67, .external_lex_state = 2},
  [1461] = {.lex_state = 67, .external_lex_state = 2},
  [1462] = {.lex_state = 67, .external_lex_state = 2},
  [1463] = {.lex_state = 67, .external_lex_state = 2},
  [1464] = {.lex_state = 67, .external_lex_state = 3},
  [1465] = {.lex_state = 67, .external_lex_state = 3},
  [1466] = {.lex_state = 67, .external_lex_state = 3},
  [1467] = {.lex_state = 67, .external_lex_state = 2},
  [1468] = {.lex_state = 67, .external_lex_state = 3},
  [1469] = {.lex_state = 67, .external_lex_state = 3},
  [1470] = {.lex_state = 67, .external_lex_state = 3},
  [1471] = {.lex_state = 67, .external_lex_state = 2},
  [1472] = {.lex_state = 67, .external_lex_state = 3},
  [1473] = {.lex_state = 67, .external_lex_state = 3},
  [1474] = {.lex_state = 67, .external_lex_state = 2},
  [1475] = {.lex_state = 67, .external_lex_state = 2},
  [1476] = {.lex_state = 67, .external_lex_state = 3},
  [1477] = {.lex_state = 15},
  [1478] = {.lex_state = 8, .external_lex_state = 2},
  [1479] = {.lex_state = 8, .external_lex_state = 2},
  [1480] = {.lex_state = 68},
  [1481] = {.lex_state = 15},
  [1482] = {.lex_state = 15},
  [1483] = {.lex_state = 8, .external_lex_state = 2},
  [1484] = {.lex_state = 67, .external_lex_state = 3},
  [1485] = {.lex_state = 8, .external_lex_state = 2},
  [1486] = {.lex_state = 67, .external_lex_state = 3},
  [1487] = {.lex_state = 8, .external_lex_state = 2},
  [1488] = {.lex_state = 8, .external_lex_state = 2},
  [1489] = {.lex_state = 67, .external_lex_state = 2},
  [1490] = {.lex_state = 67, .external_lex_state = 3},
  [1491] = {.lex_state = 67, .external_lex_state = 2},
  [1492] = {.lex_state = 8, .external_lex_state = 2},
  [1493] = {.lex_state = 8, .external_lex_state = 2},
  [1494] = {.lex_state = 67, .external_lex_state = 3},
  [1495] = {.lex_state = 67, .external_lex_state = 3},
  [1496] = {.lex_state = 67, .external_lex_state = 3},
  [1497] = {.lex_state = 67, .external_lex_state = 3},
  [1498] = {.lex_state = 67, .external_lex_state = 3},
  [1499] = {.lex_state = 68},
  [1500] = {.lex_state = 67, .external_lex_state = 3},
  [1501] = {.lex_state = 67, .external_lex_state = 2},
  [1502] = {.lex_state = 67, .external_lex_state = 2},
  [1503] = {.lex_state = 67, .external_lex_state = 3},
  [1504] = {.lex_state = 67, .external_lex_state = 3},
  [1505] = {.lex_state = 8, .external_lex_state = 2},
  [1506] = {.lex_state = 67, .external_lex_state = 2},
  [1507] = {.lex_state = 67, .external_lex_state = 3},
  [1508] = {.lex_state = 67, .external_lex_state = 3},
  [1509] = {.lex_state = 67, .external_lex_state = 3},
  [1510] = {.lex_state = 67, .external_lex_state = 3},
  [1511] = {.lex_state = 9, .external_lex_state = 2},
  [1512] = {.lex_state = 67, .external_lex_state = 3},
  [1513] = {.lex_state = 67, .external_lex_state = 3},
  [1514] = {.lex_state = 15},
  [1515] = {.lex_state = 8, .external_lex_state = 2},
  [1516] = {.lex_state = 8, .external_lex_state = 2},
  [1517] = {.lex_state = 8, .external_lex_state = 2},
  [1518] = {.lex_state = 67, .external_lex_state = 2},
  [1519] = {.lex_state = 67, .external_lex_state = 3},
  [1520] = {.lex_state = 8, .external_lex_state = 2},
  [1521] = {.lex_state = 67, .external_lex_state = 3},
  [1522] = {.lex_state = 67, .external_lex_state = 3},
  [1523] = {.lex_state = 67, .external_lex_state = 3},
  [1524] = {.lex_state = 67, .external_lex_state = 3},
  [1525] = {.lex_state = 8, .external_lex_state = 3},
  [1526] = {.lex_state = 67, .external_lex_state = 3},
  [1527] = {.lex_state = 8, .external_lex_state = 2},
  [1528] = {.lex_state = 67, .external_lex_state = 2},
  [1529] = {.lex_state = 68},
  [1530] = {.lex_state = 8, .external_lex_state = 2},
  [1531] = {.lex_state = 8, .external_lex_state = 2},
  [1532] = {.lex_state = 8, .external_lex_state = 2},
  [1533] = {.lex_state = 67, .external_lex_state = 3},
  [1534] = {.lex_state = 67, .external_lex_state = 3},
  [1535] = {.lex_state = 15},
  [1536] = {.lex_state = 67, .external_lex_state = 2},
  [1537] = {.lex_state = 67, .external_lex_state = 3},
  [1538] = {.lex_state = 8, .external_lex_state = 2},
  [1539] = {.lex_state = 67, .external_lex_state = 3},
  [1540] = {.lex_state = 67, .external_lex_state = 3},
  [1541] = {.lex_state = 67, .external_lex_state = 3},
  [1542] = {.lex_state = 8, .external_lex_state = 2},
  [1543] = {.lex_state = 15},
  [1544] = {.lex_state = 67, .external_lex_state = 3},
  [1545] = {.lex_state = 8, .external_lex_state = 2},
  [1546] = {.lex_state = 67, .external_lex_state = 3},
  [1547] = {.lex_state = 8, .external_lex_state = 2},
  [1548] = {.lex_state = 8, .external_lex_state = 2},
  [1549] = {.lex_state = 67, .external_lex_state = 2},
  [1550] = {.lex_state = 67, .external_lex_state = 2},
  [1551] = {.lex_state = 8, .external_lex_state = 2},
  [1552] = {.lex_state = 67, .external_lex_state = 2},
  [1553] = {.lex_state = 67, .external_lex_state = 2},
  [1554] = {.lex_state = 67, .external_lex_state = 3},
  [1555] = {.lex_state = 8, .external_lex_state = 2},
  [1556] = {.lex_state = 8, .external_lex_state = 2},
  [1557] = {.lex_state = 67, .external_lex_state = 3},
  [1558] = {.lex_state = 67, .external_lex_state = 3},
  [1559] = {.lex_state = 68},
  [1560] = {.lex_state = 8, .external_lex_state = 2},
  [1561] = {.lex_state = 8, .external_lex_state = 2},
  [1562] = {.lex_state = 67, .external_lex_state = 3},
  [1563] = {.lex_state = 8, .external_lex_state = 2},
  [1564] = {.lex_state = 8, .external_lex_state = 2},
  [1565] = {.lex_state = 8, .external_lex_state = 2},
  [1566] = {.lex_state = 15},
  [1567] = {.lex_state = 8, .external_lex_state = 2},
  [1568] = {.lex_state = 67, .external_lex_state = 3},
  [1569] = {.lex_state = 67, .external_lex_state = 3},
  [1570] = {.lex_state = 8, .external_lex_state = 2},
  [1571] = {.lex_state = 67, .external_lex_state = 3},
  [1572] = {.lex_state = 67, .external_lex_state = 3},
  [1573] = {.lex_state = 67, .external_lex_state = 3},
  [1574] = {.lex_state = 8, .external_lex_state = 2},
  [1575] = {.lex_state = 67, .external_lex_state = 3},
  [1576] = {.lex_state = 8, .external_lex_state = 2},
  [1577] = {.lex_state = 67, .external_lex_state = 2},
  [1578] = {.lex_state = 67, .external_lex_state = 3},
  [1579] = {.lex_state = 67, .external_lex_state = 3},
  [1580] = {.lex_state = 8, .external_lex_state = 2},
  [1581] = {.lex_state = 67, .external_lex_state = 2},
  [1582] = {.lex_state = 67, .external_lex_state = 3},
  [1583] = {.lex_state = 67, .external_lex_state = 2},
  [1584] = {.lex_state = 8, .external_lex_state = 2},
  [1585] = {.lex_state = 8, .external_lex_state = 3},
  [1586] = {.lex_state = 67, .external_lex_state = 3},
  [1587] = {.lex_state = 8, .external_lex_state = 2},
  [1588] = {.lex_state = 8, .external_lex_state = 2},
  [1589] = {.lex_state = 8, .external_lex_state = 2},
  [1590] = {.lex_state = 15},
  [1591] = {.lex_state = 67, .external_lex_state = 3},
  [1592] = {.lex_state = 67, .external_lex_state = 3},
  [1593] = {.lex_state = 67, .external_lex_state = 2},
  [1594] = {.lex_state = 67, .external_lex_state = 2},
  [1595] = {.lex_state = 67, .external_lex_state = 3},
  [1596] = {.lex_state = 8, .external_lex_state = 2},
  [1597] = {.lex_state = 8, .external_lex_state = 2},
  [1598] = {.lex_state = 15},
  [1599] = {.lex_state = 8, .external_lex_state = 2},
  [1600] = {.lex_state = 67, .external_lex_state = 3},
  [1601] = {.lex_state = 67, .external_lex_state = 3},
  [1602] = {.lex_state = 8, .external_lex_state = 2},
  [1603] = {.lex_state = 8, .external_lex_state = 2},
  [1604] = {.lex_state = 8, .external_lex_state = 2},
  [1605] = {.lex_state = 8, .external_lex_state = 2},
  [1606] = {.lex_state = 8, .external_lex_state = 2},
  [1607] = {.lex_state = 8, .external_lex_state = 2},
  [1608] = {.lex_state = 15},
  [1609] = {.lex_state = 8, .external_lex_state = 2},
  [1610] = {.lex_state = 8, .external_lex_state = 2},
  [1611] = {.lex_state = 67, .external_lex_state = 2},
  [1612] = {.lex_state = 67, .external_lex_state = 3},
  [1613] = {.lex_state = 67, .external_lex_state = 2},
  [1614] = {.lex_state = 15},
  [1615] = {.lex_state = 67, .external_lex_state = 2},
  [1616] = {.lex_state = 67, .external_lex_state = 3},
  [1617] = {.lex_state = 8, .external_lex_state = 2},
  [1618] = {.lex_state = 8, .external_lex_state = 2},
  [1619] = {.lex_state = 8, .external_lex_state = 2},
  [1620] = {.lex_state = 67, .external_lex_state = 3},
  [1621] = {.lex_state = 8, .external_lex_state = 2},
  [1622] = {.lex_state = 8, .external_lex_state = 2},
  [1623] = {.lex_state = 11, .external_lex_state = 2},
  [1624] = {.lex_state = 8, .external_lex_state = 2},
  [1625] = {.lex_state = 8, .external_lex_state = 2},
  [1626] = {.lex_state = 67, .external_lex_state = 3},
  [1627] = {.lex_state = 15},
  [1628] = {.lex_state = 15},
  [1629] = {.lex_state = 67, .external_lex_state = 3},
  [1630] = {.lex_state = 68},
  [1631] = {.lex_state = 67, .external_lex_state = 3},
  [1632] = {.lex_state = 67, .external_lex_state = 2},
  [1633] = {.lex_state = 8, .external_lex_state = 2},
  [1634] = {.lex_state = 8, .external_lex_state = 2},
  [1635] = {.lex_state = 8, .external_lex_state = 2},
  [1636] = {.lex_state = 68, .external_lex_state = 4},
  [1637] = {.lex_state = 8, .external_lex_state = 2},
  [1638] = {.lex_state = 68, .external_lex_state = 4},
  [1639] = {.lex_state = 8, .external_lex_state = 2},
  [1640] = {.lex_state = 8, .external_lex_state = 2},
  [1641] = {.lex_state = 8, .external_lex_state = 2},
  [1642] = {.lex_state = 8, .external_lex_state = 2},
  [1643] = {.lex_state = 67, .external_lex_state = 2},
  [1644] = {.lex_state = 67, .external_lex_state = 2},
  [1645] = {.lex_state = 68, .external_lex_state = 4},
  [1646] = {.lex_state = 68, .external_lex_state = 4},
  [1647] = {.lex_state = 8, .external_lex_state = 2},
  [1648] = {.lex_state = 8, .external_lex_state = 2},
  [1649] = {.lex_state = 8, .external_lex_state = 2},
  [1650] = {.lex_state = 8, .external_lex_state = 2},
  [1651] = {.lex_state = 8, .external_lex_state = 2},
  [1652] = {.lex_state = 68, .external_lex_state = 4},
  [1653] = {.lex_state = 8, .external_lex_state = 2},
  [1654] = {.lex_state = 8, .external_lex_state = 2},
  [1655] = {.lex_state = 67, .external_lex_state = 2},
  [1656] = {.lex_state = 8, .external_lex_state = 2},
  [1657] = {.lex_state = 8, .external_lex_state = 2},
  [1658] = {.lex_state = 8, .external_lex_state = 2},
  [1659] = {.lex_state = 8, .external_lex_state = 2},
  [1660] = {.lex_state = 67, .external_lex_state = 3},
  [1661] = {.lex_state = 8, .external_lex_state = 2},
  [1662] = {.lex_state = 68, .external_lex_state = 4},
  [1663] = {.lex_state = 8, .external_lex_state = 2},
  [1664] = {.lex_state = 8, .external_lex_state = 2},
  [1665] = {.lex_state = 8, .external_lex_state = 2},
  [1666] = {.lex_state = 8, .external_lex_state = 2},
  [1667] = {.lex_state = 8, .external_lex_state = 2},
  [1668] = {.lex_state = 8, .external_lex_state = 2},
  [1669] = {.lex_state = 8, .external_lex_state = 2},
  [1670] = {.lex_state = 8, .external_lex_state = 2},
  [1671] = {.lex_state = 8, .external_lex_state = 2},
  [1672] = {.lex_state = 8, .external_lex_state = 2},
  [1673] = {.lex_state = 68, .external_lex_state = 4},
  [1674] = {.lex_state = 68},
  [1675] = {.lex_state = 8, .external_lex_state = 2},
  [1676] = {.lex_state = 8, .external_lex_state = 2},
  [1677] = {.lex_state = 8, .external_lex_state = 2},
  [1678] = {.lex_state = 8, .external_lex_state = 2},
  [1679] = {.lex_state = 8, .external_lex_state = 2},
  [1680] = {.lex_state = 68, .external_lex_state = 4},
  [1681] = {.lex_state = 8, .external_lex_state = 2},
  [1682] = {.lex_state = 8, .external_lex_state = 2},
  [1683] = {.lex_state = 8, .external_lex_state = 2},
  [1684] = {.lex_state = 8, .external_lex_state = 2},
  [1685] = {.lex_state = 68, .external_lex_state = 4},
  [1686] = {.lex_state = 8, .external_lex_state = 2},
  [1687] = {.lex_state = 8, .external_lex_state = 2},
  [1688] = {.lex_state = 68, .external_lex_state = 4},
  [1689] = {.lex_state = 8, .external_lex_state = 2},
  [1690] = {.lex_state = 8, .external_lex_state = 2},
  [1691] = {.lex_state = 68, .external_lex_state = 4},
  [1692] = {.lex_state = 8, .external_lex_state = 2},
  [1693] = {.lex_state = 8, .external_lex_state = 2},
  [1694] = {.lex_state = 8, .external_lex_state = 2},
  [1695] = {.lex_state = 8, .external_lex_state = 2},
  [1696] = {.lex_state = 67, .external_lex_state = 3},
  [1697] = {.lex_state = 8, .external_lex_state = 2},
  [1698] = {.lex_state = 8, .external_lex_state = 2},
  [1699] = {.lex_state = 8, .external_lex_state = 2},
  [1700] = {.lex_state = 8, .external_lex_state = 2},
  [1701] = {.lex_state = 8, .external_lex_state = 2},
  [1702] = {.lex_state = 68, .external_lex_state = 4},
  [1703] = {.lex_state = 8, .external_lex_state = 2},
  [1704] = {.lex_state = 8, .external_lex_state = 2},
  [1705] = {.lex_state = 8, .external_lex_state = 2},
  [1706] = {.lex_state = 8, .external_lex_state = 2},
  [1707] = {.lex_state = 8, .external_lex_state = 2},
  [1708] = {.lex_state = 67, .external_lex_state = 2},
  [1709] = {.lex_state = 67, .external_lex_state = 2},
  [1710] = {.lex_state = 8, .external_lex_state = 2},
  [1711] = {.lex_state = 8, .external_lex_state = 2},
  [1712] = {.lex_state = 8, .external_lex_state = 2},
  [1713] = {.lex_state = 67, .external_lex_state = 2},
  [1714] = {.lex_state = 68, .external_lex_state = 4},
  [1715] = {.lex_state = 67, .external_lex_state = 2},
  [1716] = {.lex_state = 68, .external_lex_state = 4},
  [1717] = {.lex_state = 68, .external_lex_state = 4},
  [1718] = {.lex_state = 68, .external_lex_state = 4},
  [1719] = {.lex_state = 68, .external_lex_state = 4},
  [1720] = {.lex_state = 68, .external_lex_state = 4},
  [1721] = {.lex_state = 68, .external_lex_state = 4},
  [1722] = {.lex_state = 67, .external_lex_state = 2},
  [1723] = {.lex_state = 68, .external_lex_state = 4},
  [1724] = {.lex_state = 67, .external_lex_state = 2},
  [1725] = {.lex_state = 68, .external_lex_state = 4},
  [1726] = {.lex_state = 68, .external_lex_state = 4},
  [1727] = {.lex_state = 68, .external_lex_state = 4},
  [1728] = {.lex_state = 68, .external_lex_state = 4},
  [1729] = {.lex_state = 68, .external_lex_state = 4},
  [1730] = {.lex_state = 68, .external_lex_state = 4},
  [1731] = {.lex_state = 68, .external_lex_state = 4},
  [1732] = {.lex_state = 68, .external_lex_state = 4},
  [1733] = {.lex_state = 68, .external_lex_state = 4},
  [1734] = {.lex_state = 68, .external_lex_state = 4},
  [1735] = {.lex_state = 68, .external_lex_state = 4},
  [1736] = {.lex_state = 68, .external_lex_state = 4},
  [1737] = {.lex_state = 68, .external_lex_state = 4},
  [1738] = {.lex_state = 68, .external_lex_state = 4},
  [1739] = {.lex_state = 68, .external_lex_state = 4},
  [1740] = {.lex_state = 68, .external_lex_state = 4},
  [1741] = {.lex_state = 68, .external_lex_state = 4},
  [1742] = {.lex_state = 68, .external_lex_state = 4},
  [1743] = {.lex_state = 68, .external_lex_state = 4},
  [1744] = {.lex_state = 68, .external_lex_state = 4},
  [1745] = {.lex_state = 68, .external_lex_state = 4},
  [1746] = {.lex_state = 68, .external_lex_state = 4},
  [1747] = {.lex_state = 68, .external_lex_state = 4},
  [1748] = {.lex_state = 68, .external_lex_state = 4},
  [1749] = {.lex_state = 68, .external_lex_state = 4},
  [1750] = {.lex_state = 68, .external_lex_state = 4},
  [1751] = {.lex_state = 68, .external_lex_state = 4},
  [1752] = {.lex_state = 68},
  [1753] = {.lex_state = 68, .external_lex_state = 4},
  [1754] = {.lex_state = 68, .external_lex_state = 4},
  [1755] = {.lex_state = 68, .external_lex_state = 4},
  [1756] = {.lex_state = 17},
  [1757] = {.lex_state = 68},
  [1758] = {.lex_state = 68, .external_lex_state = 4},
  [1759] = {.lex_state = 68, .external_lex_state = 4},
  [1760] = {.lex_state = 68, .external_lex_state = 4},
  [1761] = {.lex_state = 68},
  [1762] = {.lex_state = 68},
  [1763] = {.lex_state = 68},
  [1764] = {.lex_state = 68},
  [1765] = {.lex_state = 68},
  [1766] = {.lex_state = 68},
  [1767] = {.lex_state = 68},
  [1768] = {.lex_state = 68},
  [1769] = {.lex_state = 68},
  [1770] = {.lex_state = 68},
  [1771] = {.lex_state = 68, .external_lex_state = 4},
  [1772] = {.lex_state = 68, .external_lex_state = 4},
  [1773] = {.lex_state = 68, .external_lex_state = 4},
  [1774] = {.lex_state = 68},
  [1775] = {.lex_state = 68},
  [1776] = {.lex_state = 68, .external_lex_state = 4},
  [1777] = {.lex_state = 68, .external_lex_state = 4},
  [1778] = {.lex_state = 68, .external_lex_state = 4},
  [1779] = {.lex_state = 68},
  [1780] = {.lex_state = 68},
  [1781] = {.lex_state = 68},
  [1782] = {.lex_state = 68, .external_lex_state = 4},
  [1783] = {.lex_state = 68},
  [1784] = {.lex_state = 68},
  [1785] = {.lex_state = 68, .external_lex_state = 4},
  [1786] = {.lex_state = 68, .external_lex_state = 4},
  [1787] = {.lex_state = 68, .external_lex_state = 4},
  [1788] = {.lex_state = 68, .external_lex_state = 4},
  [1789] = {.lex_state = 68},
  [1790] = {.lex_state = 68, .external_lex_state = 4},
  [1791] = {.lex_state = 68},
  [1792] = {.lex_state = 68},
  [1793] = {.lex_state = 68},
  [1794] = {.lex_state = 68},
  [1795] = {.lex_state = 17},
  [1796] = {.lex_state = 68},
  [1797] = {.lex_state = 68},
  [1798] = {.lex_state = 68},
  [1799] = {.lex_state = 68},
  [1800] = {.lex_state = 68},
  [1801] = {.lex_state = 68},
  [1802] = {.lex_state = 68},
  [1803] = {.lex_state = 68},
  [1804] = {.lex_state = 68},
  [1805] = {.lex_state = 68, .external_lex_state = 4},
  [1806] = {.lex_state = 68},
  [1807] = {.lex_state = 68},
  [1808] = {.lex_state = 68},
  [1809] = {.lex_state = 68},
  [1810] = {.lex_state = 68},
  [1811] = {.lex_state = 68},
  [1812] = {.lex_state = 68},
  [1813] = {.lex_state = 68},
  [1814] = {.lex_state = 68},
  [1815] = {.lex_state = 68},
  [1816] = {.lex_state = 17},
  [1817] = {.lex_state = 68},
  [1818] = {.lex_state = 68},
  [1819] = {.lex_state = 68},
  [1820] = {.lex_state = 17},
  [1821] = {.lex_state = 17},
  [1822] = {.lex_state = 17},
  [1823] = {.lex_state = 17},
  [1824] = {.lex_state = 68},
  [1825] = {.lex_state = 68},
  [1826] = {.lex_state = 68},
  [1827] = {.lex_state = 15, .external_lex_state = 4},
  [1828] = {.lex_state = 15, .external_lex_state = 4},
  [1829] = {.lex_state = 15, .external_lex_state = 4},
  [1830] = {.lex_state = 15, .external_lex_state = 4},
  [1831] = {.lex_state = 15, .external_lex_state = 4},
  [1832] = {.lex_state = 15, .external_lex_state = 4},
  [1833] = {.lex_state = 68},
  [1834] = {.lex_state = 68},
  [1835] = {.lex_state = 68},
  [1836] = {.lex_state = 68},
  [1837] = {.lex_state = 15, .external_lex_state = 4},
  [1838] = {.lex_state = 15, .external_lex_state = 4},
  [1839] = {.lex_state = 15, .external_lex_state = 4},
  [1840] = {.lex_state = 15, .external_lex_state = 4},
  [1841] = {.lex_state = 15, .external_lex_state = 4},
  [1842] = {.lex_state = 15, .external_lex_state = 4},
  [1843] = {.lex_state = 15, .external_lex_state = 4},
  [1844] = {.lex_state = 68},
  [1845] = {.lex_state = 15, .external_lex_state = 4},
  [1846] = {.lex_state = 15, .external_lex_state = 4},
  [1847] = {.lex_state = 15, .external_lex_state = 4},
  [1848] = {.lex_state = 68},
  [1849] = {.lex_state = 68},
  [1850] = {.lex_state = 15, .external_lex_state = 4},
  [1851] = {.lex_state = 68},
  [1852] = {.lex_state = 68},
  [1853] = {.lex_state = 68},
  [1854] = {.lex_state = 68},
  [1855] = {.lex_state = 68},
  [1856] = {.lex_state = 68},
  [1857] = {.lex_state = 68},
  [1858] = {.lex_state = 68},
  [1859] = {.lex_state = 68},
  [1860] = {.lex_state = 68},
  [1861] = {.lex_state = 68},
  [1862] = {.lex_state = 68},
  [1863] = {.lex_state = 68},
  [1864] = {.lex_state = 68},
  [1865] = {.lex_state = 68},
  [1866] = {.lex_state = 68},
  [1867] = {.lex_state = 68},
  [1868] = {.lex_state = 68},
  [1869] = {.lex_state = 68},
  [1870] = {.lex_state = 68},
  [1871] = {.lex_state = 68},
  [1872] = {.lex_state = 68},
  [1873] = {.lex_state = 68},
  [1874] = {.lex_state = 68},
  [1875] = {.lex_state = 68},
  [1876] = {.lex_state = 68},
  [1877] = {.lex_state = 15},
  [1878] = {.lex_state = 68},
  [1879] = {.lex_state = 68},
  [1880] = {.lex_state = 68},
  [1881] = {.lex_state = 68},
  [1882] = {.lex_state = 68},
  [1883] = {.lex_state = 68},
  [1884] = {.lex_state = 68},
  [1885] = {.lex_state = 68},
  [1886] = {.lex_state = 68},
  [1887] = {.lex_state = 68},
  [1888] = {.lex_state = 68},
  [1889] = {.lex_state = 68},
  [1890] = {.lex_state = 68},
  [1891] = {.lex_state = 68},
  [1892] = {.lex_state = 68},
  [1893] = {.lex_state = 68},
  [1894] = {.lex_state = 68},
  [1895] = {.lex_state = 68},
  [1896] = {.lex_state = 68},
  [1897] = {.lex_state = 68},
  [1898] = {.lex_state = 68},
  [1899] = {.lex_state = 68},
  [1900] = {.lex_state = 68},
  [1901] = {.lex_state = 68},
  [1902] = {.lex_state = 68},
  [1903] = {.lex_state = 68},
  [1904] = {.lex_state = 68},
  [1905] = {.lex_state = 68},
  [1906] = {.lex_state = 68},
  [1907] = {.lex_state = 68},
  [1908] = {.lex_state = 68},
  [1909] = {.lex_state = 68},
  [1910] = {.lex_state = 68},
  [1911] = {.lex_state = 68},
  [1912] = {.lex_state = 68},
  [1913] = {.lex_state = 68},
  [1914] = {.lex_state = 68},
  [1915] = {.lex_state = 68},
  [1916] = {.lex_state = 68},
  [1917] = {.lex_state = 68},
  [1918] = {.lex_state = 68},
  [1919] = {.lex_state = 68, .external_lex_state = 4},
  [1920] = {.lex_state = 68, .external_lex_state = 4},
  [1921] = {.lex_state = 6},
  [1922] = {.lex_state = 6},
  [1923] = {.lex_state = 6},
  [1924] = {.lex_state = 68},
  [1925] = {.lex_state = 68},
  [1926] = {.lex_state = 6},
  [1927] = {.lex_state = 6},
  [1928] = {.lex_state = 68},
  [1929] = {.lex_state = 6},
  [1930] = {.lex_state = 68, .external_lex_state = 4},
  [1931] = {.lex_state = 68, .external_lex_state = 4},
  [1932] = {.lex_state = 68, .external_lex_state = 4},
  [1933] = {.lex_state = 68, .external_lex_state = 4},
  [1934] = {.lex_state = 68, .external_lex_state = 4},
  [1935] = {.lex_state = 68, .external_lex_state = 4},
  [1936] = {.lex_state = 68, .external_lex_state = 4},
  [1937] = {.lex_state = 68, .external_lex_state = 4},
  [1938] = {.lex_state = 68, .external_lex_state = 4},
  [1939] = {.lex_state = 68, .external_lex_state = 4},
  [1940] = {.lex_state = 68, .external_lex_state = 4},
  [1941] = {.lex_state = 68, .external_lex_state = 4},
  [1942] = {.lex_state = 68},
  [1943] = {.lex_state = 68, .external_lex_state = 4},
  [1944] = {.lex_state = 68, .external_lex_state = 4},
  [1945] = {.lex_state = 68, .external_lex_state = 4},
  [1946] = {.lex_state = 68, .external_lex_state = 4},
  [1947] = {.lex_state = 68, .external_lex_state = 4},
  [1948] = {.lex_state = 68, .external_lex_state = 4},
  [1949] = {.lex_state = 68, .external_lex_state = 4},
  [1950] = {.lex_state = 68, .external_lex_state = 4},
  [1951] = {.lex_state = 68, .external_lex_state = 4},
  [1952] = {.lex_state = 68, .external_lex_state = 4},
  [1953] = {.lex_state = 68, .external_lex_state = 4},
  [1954] = {.lex_state = 68, .external_lex_state = 4},
  [1955] = {.lex_state = 68, .external_lex_state = 4},
  [1956] = {.lex_state = 68, .external_lex_state = 4},
  [1957] = {.lex_state = 68},
  [1958] = {.lex_state = 68, .external_lex_state = 4},
  [1959] = {.lex_state = 68, .external_lex_state = 4},
  [1960] = {.lex_state = 68},
  [1961] = {.lex_state = 68, .external_lex_state = 4},
  [1962] = {.lex_state = 68, .external_lex_state = 4},
  [1963] = {.lex_state = 68, .external_lex_state = 4},
  [1964] = {.lex_state = 68, .external_lex_state = 4},
  [1965] = {.lex_state = 68, .external_lex_state = 4},
  [1966] = {.lex_state = 68, .external_lex_state = 4},
  [1967] = {.lex_state = 68, .external_lex_state = 4},
  [1968] = {.lex_state = 68, .external_lex_state = 4},
  [1969] = {.lex_state = 68, .external_lex_state = 4},
  [1970] = {.lex_state = 68, .external_lex_state = 4},
  [1971] = {.lex_state = 68, .external_lex_state = 4},
  [1972] = {.lex_state = 68, .external_lex_state = 4},
  [1973] = {.lex_state = 68, .external_lex_state = 4},
  [1974] = {.lex_state = 68, .external_lex_state = 4},
  [1975] = {.lex_state = 68, .external_lex_state = 4},
  [1976] = {.lex_state = 68, .external_lex_state = 4},
  [1977] = {.lex_state = 68, .external_lex_state = 4},
  [1978] = {.lex_state = 68, .external_lex_state = 4},
  [1979] = {.lex_state = 68, .external_lex_state = 4},
  [1980] = {.lex_state = 68, .external_lex_state = 4},
  [1981] = {.lex_state = 68, .external_lex_state = 4},
  [1982] = {.lex_state = 68, .external_lex_state = 4},
  [1983] = {.lex_state = 68, .external_lex_state = 4},
  [1984] = {.lex_state = 68, .external_lex_state = 4},
  [1985] = {.lex_state = 68, .external_lex_state = 4},
  [1986] = {.lex_state = 68, .external_lex_state = 4},
  [1987] = {.lex_state = 68, .external_lex_state = 4},
  [1988] = {.lex_state = 68, .external_lex_state = 4},
  [1989] = {.lex_state = 68, .external_lex_state = 4},
  [1990] = {.lex_state = 68, .external_lex_state = 4},
  [1991] = {.lex_state = 68, .external_lex_state = 4},
  [1992] = {.lex_state = 68, .external_lex_state = 4},
  [1993] = {.lex_state = 68, .external_lex_state = 4},
  [1994] = {.lex_state = 68, .external_lex_state = 4},
  [1995] = {.lex_state = 68, .external_lex_state = 4},
  [1996] = {.lex_state = 68, .external_lex_state = 4},
  [1997] = {.lex_state = 68, .external_lex_state = 4},
  [1998] = {.lex_state = 68, .external_lex_state = 4},
  [1999] = {.lex_state = 68, .external_lex_state = 4},
  [2000] = {.lex_state = 68, .external_lex_state = 4},
  [2001] = {.lex_state = 68, .external_lex_state = 4},
  [2002] = {.lex_state = 68, .external_lex_state = 4},
  [2003] = {.lex_state = 68, .external_lex_state = 4},
  [2004] = {.lex_state = 68, .external_lex_state = 4},
  [2005] = {.lex_state = 68, .external_lex_state = 4},
  [2006] = {.lex_state = 68, .external_lex_state = 4},
  [2007] = {.lex_state = 68, .external_lex_state = 4},
  [2008] = {.lex_state = 68, .external_lex_state = 4},
  [2009] = {.lex_state = 68, .external_lex_state = 4},
  [2010] = {.lex_state = 68, .external_lex_state = 4},
  [2011] = {.lex_state = 68, .external_lex_state = 4},
  [2012] = {.lex_state = 68, .external_lex_state = 4},
  [2013] = {.lex_state = 68, .external_lex_state = 4},
  [2014] = {.lex_state = 68},
  [2015] = {.lex_state = 68},
  [2016] = {.lex_state = 68, .external_lex_state = 4},
  [2017] = {.lex_state = 68, .external_lex_state = 4},
  [2018] = {.lex_state = 68},
  [2019] = {.lex_state = 68},
  [2020] = {.lex_state = 68, .external_lex_state = 4},
  [2021] = {.lex_state = 68},
  [2022] = {.lex_state = 68, .external_lex_state = 4},
  [2023] = {.lex_state = 68},
  [2024] = {.lex_state = 68},
  [2025] = {.lex_state = 68},
  [2026] = {.lex_state = 68},
  [2027] = {.lex_state = 68},
  [2028] = {.lex_state = 68},
  [2029] = {.lex_state = 68},
  [2030] = {.lex_state = 68},
  [2031] = {.lex_state = 68},
  [2032] = {.lex_state = 68},
  [2033] = {.lex_state = 68},
  [2034] = {.lex_state = 68},
  [2035] = {.lex_state = 68},
  [2036] = {.lex_state = 68},
  [2037] = {.lex_state = 68},
  [2038] = {.lex_state = 68},
  [2039] = {.lex_state = 68},
  [2040] = {.lex_state = 68},
  [2041] = {.lex_state = 68},
  [2042] = {.lex_state = 68},
  [2043] = {.lex_state = 68},
  [2044] = {.lex_state = 68},
  [2045] = {.lex_state = 68},
  [2046] = {.lex_state = 68},
  [2047] = {.lex_state = 68, .external_lex_state = 4},
  [2048] = {.lex_state = 68, .external_lex_state = 4},
  [2049] = {.lex_state = 68},
  [2050] = {.lex_state = 68},
  [2051] = {.lex_state = 68},
  [2052] = {.lex_state = 68},
  [2053] = {.lex_state = 68},
  [2054] = {.lex_state = 68},
  [2055] = {.lex_state = 68},
  [2056] = {.lex_state = 68},
  [2057] = {.lex_state = 68},
  [2058] = {.lex_state = 68, .external_lex_state = 4},
  [2059] = {.lex_state = 68},
  [2060] = {.lex_state = 68},
  [2061] = {.lex_state = 68},
  [2062] = {.lex_state = 68},
  [2063] = {.lex_state = 68},
  [2064] = {.lex_state = 68},
  [2065] = {.lex_state = 68},
  [2066] = {.lex_state = 68},
  [2067] = {.lex_state = 68, .external_lex_state = 4},
  [2068] = {.lex_state = 68},
  [2069] = {.lex_state = 68},
  [2070] = {.lex_state = 68, .external_lex_state = 4},
  [2071] = {.lex_state = 68, .external_lex_state = 4},
  [2072] = {.lex_state = 68},
  [2073] = {.lex_state = 68, .external_lex_state = 4},
  [2074] = {.lex_state = 68, .external_lex_state = 4},
  [2075] = {.lex_state = 0, .external_lex_state = 4},
  [2076] = {.lex_state = 68, .external_lex_state = 4},
  [2077] = {.lex_state = 68},
  [2078] = {.lex_state = 0, .external_lex_state = 4},
  [2079] = {.lex_state = 68, .external_lex_state = 4},
  [2080] = {.lex_state = 68, .external_lex_state = 4},
  [2081] = {.lex_state = 68, .external_lex_state = 4},
  [2082] = {.lex_state = 68},
  [2083] = {.lex_state = 68},
  [2084] = {.lex_state = 68},
  [2085] = {.lex_state = 68},
  [2086] = {.lex_state = 68},
  [2087] = {.lex_state = 68},
  [2088] = {.lex_state = 68},
  [2089] = {.lex_state = 68},
  [2090] = {.lex_state = 0, .external_lex_state = 4},
  [2091] = {.lex_state = 14},
  [2092] = {.lex_state = 68},
  [2093] = {.lex_state = 68, .external_lex_state = 4},
  [2094] = {.lex_state = 68, .external_lex_state = 4},
  [2095] = {.lex_state = 68, .external_lex_state = 4},
  [2096] = {.lex_state = 68},
  [2097] = {.lex_state = 68},
  [2098] = {.lex_state = 68},
  [2099] = {.lex_state = 68},
  [2100] = {.lex_state = 68},
  [2101] = {.lex_state = 68},
  [2102] = {.lex_state = 68},
  [2103] = {.lex_state = 0, .external_lex_state = 4},
  [2104] = {.lex_state = 68, .external_lex_state = 4},
  [2105] = {.lex_state = 68},
  [2106] = {.lex_state = 68},
  [2107] = {.lex_state = 68, .external_lex_state = 4},
  [2108] = {.lex_state = 68},
  [2109] = {.lex_state = 68},
  [2110] = {.lex_state = 68},
  [2111] = {.lex_state = 68, .external_lex_state = 4},
  [2112] = {.lex_state = 68},
  [2113] = {.lex_state = 68},
  [2114] = {.lex_state = 68},
  [2115] = {.lex_state = 68, .external_lex_state = 4},
  [2116] = {.lex_state = 68, .external_lex_state = 4},
  [2117] = {.lex_state = 68, .external_lex_state = 4},
  [2118] = {.lex_state = 68},
  [2119] = {.lex_state = 68},
  [2120] = {.lex_state = 0, .external_lex_state = 4},
  [2121] = {.lex_state = 68, .external_lex_state = 4},
  [2122] = {.lex_state = 0, .external_lex_state = 4},
  [2123] = {.lex_state = 68},
  [2124] = {.lex_state = 68},
  [2125] = {.lex_state = 68, .external_lex_state = 4},
  [2126] = {.lex_state = 68},
  [2127] = {.lex_state = 68},
  [2128] = {.lex_state = 14},
  [2129] = {.lex_state = 68},
  [2130] = {.lex_state = 68},
  [2131] = {.lex_state = 68, .external_lex_state = 4},
  [2132] = {.lex_state = 68, .external_lex_state = 4},
  [2133] = {.lex_state = 68},
  [2134] = {.lex_state = 68},
  [2135] = {.lex_state = 0, .external_lex_state = 4},
  [2136] = {.lex_state = 68},
  [2137] = {.lex_state = 0, .external_lex_state = 4},
  [2138] = {.lex_state = 68},
  [2139] = {.lex_state = 68},
  [2140] = {.lex_state = 68},
  [2141] = {.lex_state = 68},
  [2142] = {.lex_state = 68},
  [2143] = {.lex_state = 68, .external_lex_state = 4},
  [2144] = {.lex_state = 68},
  [2145] = {.lex_state = 68},
  [2146] = {.lex_state = 68},
  [2147] = {.lex_state = 68, .external_lex_state = 4},
  [2148] = {.lex_state = 68, .external_lex_state = 4},
  [2149] = {.lex_state = 68},
  [2150] = {.lex_state = 0, .external_lex_state = 4},
  [2151] = {.lex_state = 68},
  [2152] = {.lex_state = 68},
  [2153] = {.lex_state = 68},
  [2154] = {.lex_state = 68},
  [2155] = {.lex_state = 68},
  [2156] = {.lex_state = 0, .external_lex_state = 4},
  [2157] = {.lex_state = 0, .external_lex_state = 4},
  [2158] = {.lex_state = 68},
  [2159] = {.lex_state = 68},
  [2160] = {.lex_state = 0, .external_lex_state = 4},
  [2161] = {.lex_state = 68},
  [2162] = {.lex_state = 68},
  [2163] = {.lex_state = 68},
  [2164] = {.lex_state = 68, .external_lex_state = 4},
  [2165] = {.lex_state = 68},
  [2166] = {.lex_state = 68},
  [2167] = {.lex_state = 0, .external_lex_state = 4},
  [2168] = {.lex_state = 0, .external_lex_state = 4},
  [2169] = {.lex_state = 68},
  [2170] = {.lex_state = 68},
  [2171] = {.lex_state = 0, .external_lex_state = 4},
  [2172] = {.lex_state = 68},
  [2173] = {.lex_state = 68},
  [2174] = {.lex_state = 0, .external_lex_state = 4},
  [2175] = {.lex_state = 68},
  [2176] = {.lex_state = 68},
  [2177] = {.lex_state = 19},
  [2178] = {.lex_state = 68},
  [2179] = {.lex_state = 0, .external_lex_state = 4},
  [2180] = {.lex_state = 0, .external_lex_state = 4},
  [2181] = {.lex_state = 0, .external_lex_state = 4},
  [2182] = {.lex_state = 19},
  [2183] = {.lex_state = 0, .external_lex_state = 4},
  [2184] = {.lex_state = 68},
  [2185] = {.lex_state = 0, .external_lex_state = 4},
  [2186] = {.lex_state = 68},
  [2187] = {.lex_state = 68},
  [2188] = {.lex_state = 68},
  [2189] = {.lex_state = 19, .external_lex_state = 5},
  [2190] = {.lex_state = 19},
  [2191] = {.lex_state = 0, .external_lex_state = 4},
  [2192] = {.lex_state = 68},
  [2193] = {.lex_state = 68},
  [2194] = {.lex_state = 68},
  [2195] = {.lex_state = 68},
  [2196] = {.lex_state = 0},
  [2197] = {.lex_state = 68},
  [2198] = {.lex_state = 19, .external_lex_state = 5},
  [2199] = {.lex_state = 14},
  [2200] = {.lex_state = 19, .external_lex_state = 5},
  [2201] = {.lex_state = 68},
  [2202] = {.lex_state = 68},
  [2203] = {.lex_state = 68},
  [2204] = {.lex_state = 0, .external_lex_state = 4},
  [2205] = {.lex_state = 19, .external_lex_state = 5},
  [2206] = {.lex_state = 68},
  [2207] = {.lex_state = 68},
  [2208] = {.lex_state = 68},
  [2209] = {.lex_state = 0, .external_lex_state = 4},
  [2210] = {.lex_state = 68},
  [2211] = {.lex_state = 68},
  [2212] = {.lex_state = 68},
  [2213] = {.lex_state = 19},
  [2214] = {.lex_state = 68},
  [2215] = {.lex_state = 68},
  [2216] = {.lex_state = 68},
  [2217] = {.lex_state = 68},
  [2218] = {.lex_state = 0, .external_lex_state = 4},
  [2219] = {.lex_state = 68},
  [2220] = {.lex_state = 68},
  [2221] = {.lex_state = 68},
  [2222] = {.lex_state = 68},
  [2223] = {.lex_state = 68},
  [2224] = {.lex_state = 68},
  [2225] = {.lex_state = 68, .external_lex_state = 4},
  [2226] = {.lex_state = 68},
  [2227] = {.lex_state = 68, .external_lex_state = 4},
  [2228] = {.lex_state = 19},
  [2229] = {.lex_state = 68},
  [2230] = {.lex_state = 68},
  [2231] = {.lex_state = 68},
  [2232] = {.lex_state = 19},
  [2233] = {.lex_state = 68},
  [2234] = {.lex_state = 19},
  [2235] = {.lex_state = 0, .external_lex_state = 4},
  [2236] = {.lex_state = 19, .external_lex_state = 5},
  [2237] = {.lex_state = 68},
  [2238] = {.lex_state = 68},
  [2239] = {.lex_state = 0, .external_lex_state = 4},
  [2240] = {.lex_state = 68},
  [2241] = {.lex_state = 19, .external_lex_state = 5},
  [2242] = {.lex_state = 68},
  [2243] = {.lex_state = 68},
  [2244] = {.lex_state = 68},
  [2245] = {.lex_state = 68},
  [2246] = {.lex_state = 19, .external_lex_state = 5},
  [2247] = {.lex_state = 68},
  [2248] = {.lex_state = 19},
  [2249] = {.lex_state = 68},
  [2250] = {.lex_state = 68},
  [2251] = {.lex_state = 19},
  [2252] = {.lex_state = 68},
  [2253] = {.lex_state = 68, .external_lex_state = 4},
  [2254] = {.lex_state = 68},
  [2255] = {.lex_state = 68},
  [2256] = {.lex_state = 68},
  [2257] = {.lex_state = 68},
  [2258] = {.lex_state = 0, .external_lex_state = 4},
  [2259] = {.lex_state = 68},
  [2260] = {.lex_state = 68},
  [2261] = {.lex_state = 0, .external_lex_state = 4},
  [2262] = {.lex_state = 68},
  [2263] = {.lex_state = 68},
  [2264] = {.lex_state = 68},
  [2265] = {.lex_state = 68},
  [2266] = {.lex_state = 68},
  [2267] = {.lex_state = 14},
  [2268] = {.lex_state = 0},
  [2269] = {.lex_state = 68},
  [2270] = {.lex_state = 0},
  [2271] = {.lex_state = 68},
  [2272] = {.lex_state = 68},
  [2273] = {.lex_state = 68},
  [2274] = {.lex_state = 0, .external_lex_state = 4},
  [2275] = {.lex_state = 68, .external_lex_state = 4},
  [2276] = {.lex_state = 0, .external_lex_state = 4},
  [2277] = {.lex_state = 68},
  [2278] = {.lex_state = 0, .external_lex_state = 4},
  [2279] = {.lex_state = 68, .external_lex_state = 4},
  [2280] = {.lex_state = 0, .external_lex_state = 4},
  [2281] = {.lex_state = 68},
  [2282] = {.lex_state = 68},
  [2283] = {.lex_state = 68},
  [2284] = {.lex_state = 68},
  [2285] = {.lex_state = 68},
  [2286] = {.lex_state = 68, .external_lex_state = 4},
  [2287] = {.lex_state = 0, .external_lex_state = 4},
  [2288] = {.lex_state = 68},
  [2289] = {.lex_state = 0, .external_lex_state = 4},
  [2290] = {.lex_state = 68},
  [2291] = {.lex_state = 0},
  [2292] = {.lex_state = 0, .external_lex_state = 4},
  [2293] = {.lex_state = 68, .external_lex_state = 4},
  [2294] = {.lex_state = 68},
  [2295] = {.lex_state = 68},
  [2296] = {.lex_state = 68},
  [2297] = {.lex_state = 68},
  [2298] = {.lex_state = 68},
  [2299] = {.lex_state = 0, .external_lex_state = 4},
  [2300] = {.lex_state = 68},
  [2301] = {.lex_state = 68},
  [2302] = {.lex_state = 68},
  [2303] = {.lex_state = 68},
  [2304] = {.lex_state = 0, .external_lex_state = 4},
  [2305] = {.lex_state = 68},
  [2306] = {.lex_state = 0, .external_lex_state = 4},
  [2307] = {.lex_state = 68},
  [2308] = {.lex_state = 68},
  [2309] = {.lex_state = 0, .external_lex_state = 4},
  [2310] = {.lex_state = 0, .external_lex_state = 4},
  [2311] = {.lex_state = 68},
  [2312] = {.lex_state = 68},
  [2313] = {.lex_state = 0, .external_lex_state = 4},
  [2314] = {.lex_state = 0, .external_lex_state = 4},
  [2315] = {.lex_state = 0, .external_lex_state = 4},
  [2316] = {.lex_state = 0, .external_lex_state = 4},
  [2317] = {.lex_state = 0, .external_lex_state = 4},
  [2318] = {.lex_state = 68},
  [2319] = {.lex_state = 0, .external_lex_state = 4},
  [2320] = {.lex_state = 0},
  [2321] = {.lex_state = 0, .external_lex_state = 4},
  [2322] = {.lex_state = 0, .external_lex_state = 4},
  [2323] = {.lex_state = 0, .external_lex_state = 4},
  [2324] = {.lex_state = 68},
  [2325] = {.lex_state = 0, .external_lex_state = 4},
  [2326] = {.lex_state = 0, .external_lex_state = 4},
  [2327] = {.lex_state = 0, .external_lex_state = 4},
  [2328] = {.lex_state = 68},
  [2329] = {.lex_state = 68},
  [2330] = {.lex_state = 68},
  [2331] = {.lex_state = 68},
  [2332] = {.lex_state = 68},
  [2333] = {.lex_state = 0, .external_lex_state = 4},
  [2334] = {.lex_state = 68, .external_lex_state = 4},
  [2335] = {.lex_state = 0, .external_lex_state = 4},
  [2336] = {.lex_state = 68},
  [2337] = {.lex_state = 14},
  [2338] = {.lex_state = 68},
  [2339] = {.lex_state = 68},
  [2340] = {.lex_state = 0, .external_lex_state = 4},
  [2341] = {.lex_state = 68},
  [2342] = {.lex_state = 0, .external_lex_state = 4},
  [2343] = {.lex_state = 68},
  [2344] = {.lex_state = 0, .external_lex_state = 4},
  [2345] = {.lex_state = 68},
  [2346] = {.lex_state = 68},
  [2347] = {.lex_state = 0},
  [2348] = {.lex_state = 68},
  [2349] = {.lex_state = 68},
  [2350] = {.lex_state = 68},
  [2351] = {.lex_state = 0, .external_lex_state = 4},
  [2352] = {.lex_state = 68},
  [2353] = {.lex_state = 0, .external_lex_state = 4},
  [2354] = {.lex_state = 68},
  [2355] = {.lex_state = 68},
  [2356] = {.lex_state = 0},
  [2357] = {.lex_state = 0, .external_lex_state = 4},
  [2358] = {.lex_state = 0, .external_lex_state = 4},
  [2359] = {.lex_state = 68},
  [2360] = {.lex_state = 0, .external_lex_state = 4},
  [2361] = {.lex_state = 68},
  [2362] = {.lex_state = 68},
  [2363] = {.lex_state = 68, .external_lex_state = 4},
  [2364] = {.lex_state = 0, .external_lex_state = 4},
  [2365] = {.lex_state = 68},
  [2366] = {.lex_state = 14},
  [2367] = {.lex_state = 68, .external_lex_state = 4},
  [2368] = {.lex_state = 0, .external_lex_state = 4},
  [2369] = {.lex_state = 68},
  [2370] = {.lex_state = 68},
  [2371] = {.lex_state = 0, .external_lex_state = 4},
  [2372] = {.lex_state = 0, .external_lex_state = 4},
  [2373] = {.lex_state = 68},
  [2374] = {.lex_state = 68},
  [2375] = {.lex_state = 0, .external_lex_state = 4},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 0, .external_lex_state = 4},
  [2378] = {.lex_state = 0, .external_lex_state = 4},
  [2379] = {.lex_state = 68},
  [2380] = {.lex_state = 0, .external_lex_state = 4},
  [2381] = {.lex_state = 0, .external_lex_state = 4},
  [2382] = {.lex_state = 0, .external_lex_state = 4},
  [2383] = {.lex_state = 68},
  [2384] = {.lex_state = 0},
  [2385] = {.lex_state = 0},
  [2386] = {.lex_state = 68},
  [2387] = {.lex_state = 0, .external_lex_state = 4},
  [2388] = {.lex_state = 0, .external_lex_state = 4},
  [2389] = {.lex_state = 0, .external_lex_state = 4},
  [2390] = {.lex_state = 68},
  [2391] = {.lex_state = 0, .external_lex_state = 4},
  [2392] = {.lex_state = 0, .external_lex_state = 4},
  [2393] = {.lex_state = 0, .external_lex_state = 4},
  [2394] = {.lex_state = 0, .external_lex_state = 4},
  [2395] = {.lex_state = 0, .external_lex_state = 4},
  [2396] = {.lex_state = 0, .external_lex_state = 4},
  [2397] = {.lex_state = 0, .external_lex_state = 4},
  [2398] = {.lex_state = 0, .external_lex_state = 4},
  [2399] = {.lex_state = 68},
  [2400] = {.lex_state = 0, .external_lex_state = 4},
  [2401] = {.lex_state = 68},
  [2402] = {.lex_state = 0, .external_lex_state = 4},
  [2403] = {.lex_state = 68},
  [2404] = {.lex_state = 0, .external_lex_state = 4},
  [2405] = {.lex_state = 0, .external_lex_state = 4},
  [2406] = {.lex_state = 68},
  [2407] = {.lex_state = 68},
  [2408] = {.lex_state = 68, .external_lex_state = 4},
  [2409] = {.lex_state = 0, .external_lex_state = 4},
  [2410] = {.lex_state = 68, .external_lex_state = 4},
  [2411] = {.lex_state = 0, .external_lex_state = 4},
  [2412] = {.lex_state = 68},
  [2413] = {.lex_state = 68},
  [2414] = {.lex_state = 68, .external_lex_state = 4},
  [2415] = {.lex_state = 0},
  [2416] = {.lex_state = 0, .external_lex_state = 4},
  [2417] = {.lex_state = 0, .external_lex_state = 4},
  [2418] = {.lex_state = 0, .external_lex_state = 4},
  [2419] = {.lex_state = 0, .external_lex_state = 4},
  [2420] = {.lex_state = 0, .external_lex_state = 4},
  [2421] = {.lex_state = 0},
  [2422] = {.lex_state = 68},
  [2423] = {.lex_state = 68},
  [2424] = {.lex_state = 0, .external_lex_state = 4},
  [2425] = {.lex_state = 0, .external_lex_state = 4},
  [2426] = {.lex_state = 0, .external_lex_state = 4},
  [2427] = {.lex_state = 68},
  [2428] = {.lex_state = 0, .external_lex_state = 4},
  [2429] = {.lex_state = 0, .external_lex_state = 4},
  [2430] = {.lex_state = 0, .external_lex_state = 4},
  [2431] = {.lex_state = 0, .external_lex_state = 4},
  [2432] = {.lex_state = 0, .external_lex_state = 4},
  [2433] = {.lex_state = 0, .external_lex_state = 4},
  [2434] = {.lex_state = 0, .external_lex_state = 4},
  [2435] = {.lex_state = 0, .external_lex_state = 4},
  [2436] = {.lex_state = 0, .external_lex_state = 4},
  [2437] = {.lex_state = 0, .external_lex_state = 4},
  [2438] = {.lex_state = 0, .external_lex_state = 4},
  [2439] = {.lex_state = 0, .external_lex_state = 4},
  [2440] = {.lex_state = 0, .external_lex_state = 4},
  [2441] = {.lex_state = 68},
  [2442] = {.lex_state = 68},
  [2443] = {.lex_state = 0, .external_lex_state = 4},
  [2444] = {.lex_state = 0, .external_lex_state = 4},
  [2445] = {.lex_state = 68},
  [2446] = {.lex_state = 0, .external_lex_state = 4},
  [2447] = {.lex_state = 0, .external_lex_state = 4},
  [2448] = {.lex_state = 68},
  [2449] = {.lex_state = 0, .external_lex_state = 4},
  [2450] = {.lex_state = 0, .external_lex_state = 4},
  [2451] = {.lex_state = 0, .external_lex_state = 4},
  [2452] = {.lex_state = 0, .external_lex_state = 4},
  [2453] = {.lex_state = 68},
  [2454] = {.lex_state = 0, .external_lex_state = 4},
  [2455] = {.lex_state = 68, .external_lex_state = 4},
  [2456] = {.lex_state = 0, .external_lex_state = 4},
  [2457] = {.lex_state = 14},
  [2458] = {.lex_state = 68},
  [2459] = {.lex_state = 0, .external_lex_state = 4},
  [2460] = {.lex_state = 68, .external_lex_state = 4},
  [2461] = {.lex_state = 68, .external_lex_state = 4},
  [2462] = {.lex_state = 0, .external_lex_state = 4},
  [2463] = {.lex_state = 68},
  [2464] = {.lex_state = 0, .external_lex_state = 4},
  [2465] = {.lex_state = 68},
  [2466] = {.lex_state = 0, .external_lex_state = 4},
  [2467] = {.lex_state = 68, .external_lex_state = 4},
  [2468] = {.lex_state = 0, .external_lex_state = 4},
  [2469] = {.lex_state = 0, .external_lex_state = 4},
  [2470] = {.lex_state = 68},
  [2471] = {.lex_state = 0, .external_lex_state = 4},
  [2472] = {.lex_state = 68},
  [2473] = {.lex_state = 0, .external_lex_state = 4},
  [2474] = {.lex_state = 0, .external_lex_state = 4},
  [2475] = {.lex_state = 0, .external_lex_state = 4},
  [2476] = {.lex_state = 68, .external_lex_state = 4},
  [2477] = {.lex_state = 68},
  [2478] = {.lex_state = 68},
  [2479] = {.lex_state = 68, .external_lex_state = 4},
  [2480] = {.lex_state = 0, .external_lex_state = 4},
  [2481] = {.lex_state = 0, .external_lex_state = 4},
  [2482] = {.lex_state = 0, .external_lex_state = 4},
  [2483] = {.lex_state = 0, .external_lex_state = 4},
  [2484] = {.lex_state = 0, .external_lex_state = 4},
  [2485] = {.lex_state = 0, .external_lex_state = 4},
  [2486] = {.lex_state = 68},
  [2487] = {.lex_state = 68},
  [2488] = {.lex_state = 0, .external_lex_state = 4},
  [2489] = {.lex_state = 0, .external_lex_state = 4},
  [2490] = {.lex_state = 0},
  [2491] = {.lex_state = 68},
  [2492] = {.lex_state = 68},
  [2493] = {.lex_state = 1},
  [2494] = {.lex_state = 3},
  [2495] = {.lex_state = 68},
  [2496] = {.lex_state = 68},
  [2497] = {.lex_state = 68},
  [2498] = {.lex_state = 1},
  [2499] = {.lex_state = 3},
  [2500] = {.lex_state = 68},
  [2501] = {.lex_state = 1},
  [2502] = {.lex_state = 68, .external_lex_state = 4},
  [2503] = {.lex_state = 68},
  [2504] = {.lex_state = 68, .external_lex_state = 4},
  [2505] = {.lex_state = 68},
  [2506] = {.lex_state = 19, .external_lex_state = 5},
  [2507] = {.lex_state = 68},
  [2508] = {.lex_state = 68},
  [2509] = {.lex_state = 0, .external_lex_state = 4},
  [2510] = {.lex_state = 68},
  [2511] = {.lex_state = 68},
  [2512] = {.lex_state = 68},
  [2513] = {.lex_state = 68},
  [2514] = {.lex_state = 68},
  [2515] = {.lex_state = 68},
  [2516] = {.lex_state = 0, .external_lex_state = 4},
  [2517] = {.lex_state = 68},
  [2518] = {.lex_state = 68},
  [2519] = {.lex_state = 0},
  [2520] = {.lex_state = 3},
  [2521] = {.lex_state = 68, .external_lex_state = 4},
  [2522] = {.lex_state = 68},
  [2523] = {.lex_state = 1},
  [2524] = {.lex_state = 3},
  [2525] = {.lex_state = 68},
  [2526] = {.lex_state = 68},
  [2527] = {.lex_state = 68},
  [2528] = {.lex_state = 68},
  [2529] = {.lex_state = 68, .external_lex_state = 4},
  [2530] = {.lex_state = 68},
  [2531] = {.lex_state = 68},
  [2532] = {.lex_state = 68},
  [2533] = {.lex_state = 68},
  [2534] = {.lex_state = 1},
  [2535] = {.lex_state = 3},
  [2536] = {.lex_state = 3},
  [2537] = {.lex_state = 1},
  [2538] = {.lex_state = 68, .external_lex_state = 4},
  [2539] = {.lex_state = 68},
  [2540] = {.lex_state = 68},
  [2541] = {.lex_state = 68},
  [2542] = {.lex_state = 68},
  [2543] = {.lex_state = 0},
  [2544] = {.lex_state = 68},
  [2545] = {.lex_state = 0},
  [2546] = {.lex_state = 68, .external_lex_state = 4},
  [2547] = {.lex_state = 3},
  [2548] = {.lex_state = 68},
  [2549] = {.lex_state = 0},
  [2550] = {.lex_state = 1},
  [2551] = {.lex_state = 1},
  [2552] = {.lex_state = 0},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 3},
  [2555] = {.lex_state = 68},
  [2556] = {.lex_state = 1},
  [2557] = {.lex_state = 3},
  [2558] = {.lex_state = 68},
  [2559] = {.lex_state = 68},
  [2560] = {.lex_state = 0, .external_lex_state = 4},
  [2561] = {.lex_state = 68},
  [2562] = {.lex_state = 68},
  [2563] = {.lex_state = 68},
  [2564] = {.lex_state = 68},
  [2565] = {.lex_state = 68, .external_lex_state = 4},
  [2566] = {.lex_state = 3},
  [2567] = {.lex_state = 1},
  [2568] = {.lex_state = 1},
  [2569] = {.lex_state = 68},
  [2570] = {.lex_state = 3},
  [2571] = {.lex_state = 68},
  [2572] = {.lex_state = 0},
  [2573] = {.lex_state = 68},
  [2574] = {.lex_state = 68},
  [2575] = {.lex_state = 0},
  [2576] = {.lex_state = 68},
  [2577] = {.lex_state = 68},
  [2578] = {.lex_state = 68},
  [2579] = {.lex_state = 68},
  [2580] = {.lex_state = 68},
  [2581] = {.lex_state = 0, .external_lex_state = 4},
  [2582] = {.lex_state = 68},
  [2583] = {.lex_state = 0, .external_lex_state = 4},
  [2584] = {.lex_state = 3},
  [2585] = {.lex_state = 1},
  [2586] = {.lex_state = 0, .external_lex_state = 4},
  [2587] = {.lex_state = 68},
  [2588] = {.lex_state = 68},
  [2589] = {.lex_state = 68},
  [2590] = {.lex_state = 68, .external_lex_state = 4},
  [2591] = {.lex_state = 68},
  [2592] = {.lex_state = 0},
  [2593] = {.lex_state = 0, .external_lex_state = 4},
  [2594] = {.lex_state = 68},
  [2595] = {.lex_state = 0},
  [2596] = {.lex_state = 68, .external_lex_state = 4},
  [2597] = {.lex_state = 68},
  [2598] = {.lex_state = 0},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 68},
  [2601] = {.lex_state = 68},
  [2602] = {.lex_state = 68, .external_lex_state = 4},
  [2603] = {.lex_state = 68},
  [2604] = {.lex_state = 68},
  [2605] = {.lex_state = 68},
  [2606] = {.lex_state = 1},
  [2607] = {.lex_state = 3},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 0},
  [2610] = {.lex_state = 68},
  [2611] = {.lex_state = 68},
  [2612] = {.lex_state = 0},
  [2613] = {.lex_state = 0, .external_lex_state = 4},
  [2614] = {.lex_state = 0},
  [2615] = {.lex_state = 68},
  [2616] = {.lex_state = 0},
  [2617] = {.lex_state = 68},
  [2618] = {.lex_state = 68},
  [2619] = {.lex_state = 68},
  [2620] = {.lex_state = 68},
  [2621] = {.lex_state = 0},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 0},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 68},
  [2628] = {.lex_state = 68},
  [2629] = {.lex_state = 68, .external_lex_state = 4},
  [2630] = {.lex_state = 68},
  [2631] = {.lex_state = 68},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 0},
  [2634] = {.lex_state = 0},
  [2635] = {.lex_state = 68},
  [2636] = {.lex_state = 0},
  [2637] = {.lex_state = 14},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 0, .external_lex_state = 4},
  [2640] = {.lex_state = 0},
  [2641] = {.lex_state = 0},
  [2642] = {.lex_state = 0},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 0},
  [2645] = {.lex_state = 68},
  [2646] = {.lex_state = 68},
  [2647] = {.lex_state = 68},
  [2648] = {.lex_state = 68},
  [2649] = {.lex_state = 0},
  [2650] = {.lex_state = 0},
  [2651] = {.lex_state = 68, .external_lex_state = 4},
  [2652] = {.lex_state = 0},
  [2653] = {.lex_state = 0},
  [2654] = {.lex_state = 0},
  [2655] = {.lex_state = 0},
  [2656] = {.lex_state = 68},
  [2657] = {.lex_state = 68},
  [2658] = {.lex_state = 0},
  [2659] = {.lex_state = 0, .external_lex_state = 4},
  [2660] = {.lex_state = 0, .external_lex_state = 4},
  [2661] = {.lex_state = 0, .external_lex_state = 4},
  [2662] = {.lex_state = 68},
  [2663] = {.lex_state = 0, .external_lex_state = 4},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0, .external_lex_state = 4},
  [2666] = {.lex_state = 0, .external_lex_state = 4},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 0, .external_lex_state = 4},
  [2669] = {.lex_state = 0},
  [2670] = {.lex_state = 0},
  [2671] = {.lex_state = 0},
  [2672] = {.lex_state = 0},
  [2673] = {.lex_state = 0},
  [2674] = {.lex_state = 0, .external_lex_state = 4},
  [2675] = {.lex_state = 0},
  [2676] = {.lex_state = 68},
  [2677] = {.lex_state = 0},
  [2678] = {.lex_state = 0},
  [2679] = {.lex_state = 0},
  [2680] = {.lex_state = 0},
  [2681] = {.lex_state = 0},
  [2682] = {.lex_state = 0, .external_lex_state = 4},
  [2683] = {.lex_state = 0, .external_lex_state = 4},
  [2684] = {.lex_state = 0, .external_lex_state = 4},
  [2685] = {.lex_state = 68},
  [2686] = {.lex_state = 68},
  [2687] = {.lex_state = 0, .external_lex_state = 4},
  [2688] = {.lex_state = 0},
  [2689] = {.lex_state = 68},
  [2690] = {.lex_state = 68},
  [2691] = {.lex_state = 14},
  [2692] = {.lex_state = 0},
  [2693] = {.lex_state = 0, .external_lex_state = 4},
  [2694] = {.lex_state = 0, .external_lex_state = 4},
  [2695] = {.lex_state = 0, .external_lex_state = 4},
  [2696] = {.lex_state = 0},
  [2697] = {.lex_state = 0},
  [2698] = {.lex_state = 0},
  [2699] = {.lex_state = 0},
  [2700] = {.lex_state = 68},
  [2701] = {.lex_state = 0},
  [2702] = {.lex_state = 68},
  [2703] = {.lex_state = 68},
  [2704] = {.lex_state = 68, .external_lex_state = 4},
  [2705] = {.lex_state = 0},
  [2706] = {.lex_state = 0},
  [2707] = {.lex_state = 68, .external_lex_state = 4},
  [2708] = {.lex_state = 68},
  [2709] = {.lex_state = 0},
  [2710] = {.lex_state = 68},
  [2711] = {.lex_state = 0, .external_lex_state = 4},
  [2712] = {.lex_state = 0},
  [2713] = {.lex_state = 0, .external_lex_state = 4},
  [2714] = {.lex_state = 0},
  [2715] = {.lex_state = 0},
  [2716] = {.lex_state = 0},
  [2717] = {.lex_state = 0},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 0},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 0},
  [2723] = {.lex_state = 0},
  [2724] = {.lex_state = 68, .external_lex_state = 4},
  [2725] = {.lex_state = 0},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 68},
  [2728] = {.lex_state = 0},
  [2729] = {.lex_state = 68},
  [2730] = {.lex_state = 68},
  [2731] = {.lex_state = 0, .external_lex_state = 4},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 0, .external_lex_state = 4},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 0, .external_lex_state = 4},
  [2736] = {.lex_state = 0},
  [2737] = {.lex_state = 0},
  [2738] = {.lex_state = 68},
  [2739] = {.lex_state = 0},
  [2740] = {.lex_state = 68},
  [2741] = {.lex_state = 0, .external_lex_state = 4},
  [2742] = {.lex_state = 0},
  [2743] = {.lex_state = 0},
  [2744] = {.lex_state = 0},
  [2745] = {.lex_state = 0},
  [2746] = {.lex_state = 0, .external_lex_state = 4},
  [2747] = {.lex_state = 0},
  [2748] = {.lex_state = 0, .external_lex_state = 4},
  [2749] = {.lex_state = 0},
  [2750] = {.lex_state = 0},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 0},
  [2754] = {.lex_state = 0, .external_lex_state = 4},
  [2755] = {.lex_state = 68},
  [2756] = {.lex_state = 0, .external_lex_state = 4},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 0},
  [2759] = {.lex_state = 0},
  [2760] = {.lex_state = 0},
  [2761] = {.lex_state = 0},
  [2762] = {.lex_state = 14},
  [2763] = {.lex_state = 0},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 68},
  [2766] = {.lex_state = 68},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 0},
  [2769] = {.lex_state = 68},
  [2770] = {.lex_state = 68},
  [2771] = {.lex_state = 68},
  [2772] = {.lex_state = 68},
  [2773] = {.lex_state = 0, .external_lex_state = 4},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 68},
  [2776] = {.lex_state = 68},
  [2777] = {.lex_state = 0},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 68},
  [2780] = {.lex_state = 0},
  [2781] = {.lex_state = 68},
  [2782] = {.lex_state = 0, .external_lex_state = 4},
  [2783] = {.lex_state = 0, .external_lex_state = 4},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 0, .external_lex_state = 4},
  [2786] = {.lex_state = 0},
  [2787] = {.lex_state = 68},
  [2788] = {.lex_state = 68},
  [2789] = {.lex_state = 68, .external_lex_state = 4},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 0, .external_lex_state = 4},
  [2792] = {.lex_state = 68},
  [2793] = {.lex_state = 0, .external_lex_state = 4},
  [2794] = {.lex_state = 0},
  [2795] = {.lex_state = 0},
  [2796] = {.lex_state = 68},
  [2797] = {.lex_state = 68},
  [2798] = {.lex_state = 0},
  [2799] = {.lex_state = 68},
  [2800] = {.lex_state = 68},
  [2801] = {.lex_state = 68},
  [2802] = {.lex_state = 68},
  [2803] = {.lex_state = 0},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 68},
  [2806] = {.lex_state = 68},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 68},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 68},
  [2811] = {.lex_state = 0},
  [2812] = {.lex_state = 0},
  [2813] = {.lex_state = 68},
  [2814] = {.lex_state = 0, .external_lex_state = 4},
  [2815] = {.lex_state = 68},
  [2816] = {.lex_state = 0, .external_lex_state = 4},
  [2817] = {.lex_state = 0},
  [2818] = {.lex_state = 68},
  [2819] = {.lex_state = 0, .external_lex_state = 4},
  [2820] = {.lex_state = 0, .external_lex_state = 4},
  [2821] = {.lex_state = 68},
  [2822] = {.lex_state = 68},
  [2823] = {.lex_state = 0, .external_lex_state = 4},
  [2824] = {.lex_state = 0},
  [2825] = {.lex_state = 68},
  [2826] = {.lex_state = 68},
  [2827] = {.lex_state = 68},
  [2828] = {.lex_state = 0, .external_lex_state = 4},
  [2829] = {.lex_state = 68},
  [2830] = {.lex_state = 68},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 68},
  [2833] = {.lex_state = 68},
  [2834] = {.lex_state = 68},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 68},
  [2837] = {.lex_state = 68},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 68},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 68},
  [2842] = {.lex_state = 68},
  [2843] = {.lex_state = 0},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 0, .external_lex_state = 4},
  [2846] = {.lex_state = 0, .external_lex_state = 4},
  [2847] = {.lex_state = 68},
  [2848] = {.lex_state = 0, .external_lex_state = 4},
  [2849] = {.lex_state = 68},
  [2850] = {.lex_state = 68},
  [2851] = {.lex_state = 68},
  [2852] = {.lex_state = 0, .external_lex_state = 4},
  [2853] = {.lex_state = 68},
  [2854] = {.lex_state = 0},
  [2855] = {.lex_state = 68},
  [2856] = {.lex_state = 68},
  [2857] = {.lex_state = 68},
  [2858] = {.lex_state = 68},
  [2859] = {.lex_state = 0},
  [2860] = {.lex_state = 0},
  [2861] = {.lex_state = 68},
  [2862] = {.lex_state = 0},
  [2863] = {.lex_state = 0},
  [2864] = {.lex_state = 68},
  [2865] = {.lex_state = 0, .external_lex_state = 4},
  [2866] = {.lex_state = 0},
  [2867] = {.lex_state = 68},
  [2868] = {.lex_state = 68},
  [2869] = {.lex_state = 68},
  [2870] = {.lex_state = 68},
  [2871] = {.lex_state = 0},
  [2872] = {.lex_state = 68},
  [2873] = {.lex_state = 0, .external_lex_state = 4},
  [2874] = {.lex_state = 68},
  [2875] = {.lex_state = 68},
  [2876] = {.lex_state = 68},
  [2877] = {.lex_state = 0},
  [2878] = {.lex_state = 68},
  [2879] = {.lex_state = 0},
  [2880] = {.lex_state = 0},
  [2881] = {.lex_state = 68},
  [2882] = {.lex_state = 68},
  [2883] = {.lex_state = 68},
  [2884] = {.lex_state = 0},
  [2885] = {.lex_state = 0, .external_lex_state = 4},
  [2886] = {.lex_state = 0},
  [2887] = {.lex_state = 68},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 68},
  [2890] = {.lex_state = 68},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 0},
  [2893] = {.lex_state = 0},
  [2894] = {.lex_state = 68},
  [2895] = {.lex_state = 0},
  [2896] = {.lex_state = 68},
  [2897] = {.lex_state = 68},
  [2898] = {.lex_state = 68},
  [2899] = {.lex_state = 68},
  [2900] = {.lex_state = 68},
  [2901] = {.lex_state = 68},
  [2902] = {.lex_state = 68},
  [2903] = {.lex_state = 68},
  [2904] = {.lex_state = 68},
  [2905] = {.lex_state = 68},
  [2906] = {.lex_state = 68},
  [2907] = {.lex_state = 68},
  [2908] = {.lex_state = 0, .external_lex_state = 4},
  [2909] = {.lex_state = 68},
  [2910] = {.lex_state = 0},
  [2911] = {.lex_state = 68},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 68},
  [2914] = {.lex_state = 68},
  [2915] = {.lex_state = 0},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 68},
  [2918] = {.lex_state = 68},
  [2919] = {.lex_state = 0, .external_lex_state = 4},
  [2920] = {.lex_state = 68},
  [2921] = {.lex_state = 68},
  [2922] = {.lex_state = 68},
  [2923] = {.lex_state = 68},
  [2924] = {.lex_state = 68},
  [2925] = {.lex_state = 68},
  [2926] = {.lex_state = 68},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 68},
  [2929] = {.lex_state = 68},
  [2930] = {.lex_state = 68},
  [2931] = {.lex_state = 68},
  [2932] = {.lex_state = 68},
  [2933] = {.lex_state = 68},
  [2934] = {.lex_state = 0},
  [2935] = {.lex_state = 68},
  [2936] = {.lex_state = 68},
  [2937] = {.lex_state = 68},
  [2938] = {.lex_state = 68},
  [2939] = {.lex_state = 0},
  [2940] = {.lex_state = 68},
  [2941] = {.lex_state = 68},
  [2942] = {.lex_state = 68},
  [2943] = {.lex_state = 68},
  [2944] = {.lex_state = 0},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 0},
  [2948] = {.lex_state = 68},
  [2949] = {.lex_state = 68},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 68},
  [2952] = {.lex_state = 68},
  [2953] = {.lex_state = 68},
  [2954] = {.lex_state = 68},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 68},
  [2957] = {.lex_state = 68},
  [2958] = {.lex_state = 68},
  [2959] = {.lex_state = 68},
  [2960] = {.lex_state = 0},
  [2961] = {.lex_state = 68},
  [2962] = {.lex_state = 68},
  [2963] = {.lex_state = 68},
  [2964] = {.lex_state = 0, .external_lex_state = 4},
  [2965] = {.lex_state = 0, .external_lex_state = 4},
  [2966] = {.lex_state = 0},
  [2967] = {.lex_state = 68},
  [2968] = {.lex_state = 68},
  [2969] = {.lex_state = 68},
  [2970] = {.lex_state = 68},
  [2971] = {.lex_state = 0},
  [2972] = {.lex_state = 0},
  [2973] = {.lex_state = 0, .external_lex_state = 4},
  [2974] = {.lex_state = 0},
  [2975] = {.lex_state = 0, .external_lex_state = 4},
  [2976] = {.lex_state = 0},
  [2977] = {.lex_state = 0},
  [2978] = {.lex_state = 68},
  [2979] = {.lex_state = 0},
  [2980] = {.lex_state = 68},
  [2981] = {.lex_state = 0},
  [2982] = {.lex_state = 68},
  [2983] = {.lex_state = 68},
  [2984] = {.lex_state = 68},
  [2985] = {.lex_state = 68},
  [2986] = {.lex_state = 68},
  [2987] = {.lex_state = 68},
  [2988] = {.lex_state = 68},
  [2989] = {.lex_state = 68},
  [2990] = {.lex_state = 0},
  [2991] = {.lex_state = 68},
  [2992] = {.lex_state = 68},
  [2993] = {.lex_state = 68},
  [2994] = {.lex_state = 68},
  [2995] = {.lex_state = 68},
  [2996] = {.lex_state = 0},
  [2997] = {.lex_state = 68},
  [2998] = {.lex_state = 0},
  [2999] = {.lex_state = 68},
  [3000] = {.lex_state = 68},
  [3001] = {.lex_state = 68},
  [3002] = {.lex_state = 0},
  [3003] = {.lex_state = 68},
  [3004] = {.lex_state = 68},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 0},
  [3007] = {.lex_state = 0},
  [3008] = {.lex_state = 68},
  [3009] = {.lex_state = 0},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 0},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 68},
  [3016] = {.lex_state = 0},
  [3017] = {.lex_state = 0},
  [3018] = {.lex_state = 68},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 68},
  [3021] = {.lex_state = 0},
  [3022] = {.lex_state = 68},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 15},
  [3025] = {.lex_state = 68},
  [3026] = {.lex_state = 68},
  [3027] = {.lex_state = 0},
  [3028] = {.lex_state = 0},
  [3029] = {.lex_state = 0},
  [3030] = {.lex_state = 0},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 0},
  [3034] = {.lex_state = 0},
  [3035] = {.lex_state = 0},
  [3036] = {.lex_state = 0},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 0},
  [3039] = {.lex_state = 68},
  [3040] = {.lex_state = 0},
  [3041] = {.lex_state = 0},
  [3042] = {.lex_state = 0},
  [3043] = {.lex_state = 5},
  [3044] = {.lex_state = 0},
  [3045] = {.lex_state = 68},
  [3046] = {.lex_state = 0},
  [3047] = {.lex_state = 0},
  [3048] = {.lex_state = 68},
  [3049] = {.lex_state = 0},
  [3050] = {.lex_state = 0},
  [3051] = {.lex_state = 68},
  [3052] = {.lex_state = 68},
  [3053] = {.lex_state = 0},
  [3054] = {.lex_state = 0},
  [3055] = {.lex_state = 0},
  [3056] = {.lex_state = 68},
  [3057] = {.lex_state = 68},
  [3058] = {.lex_state = 68},
  [3059] = {.lex_state = 0},
  [3060] = {.lex_state = 68},
  [3061] = {.lex_state = 0},
  [3062] = {.lex_state = 0},
  [3063] = {.lex_state = 68},
  [3064] = {.lex_state = 0},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 0},
  [3067] = {.lex_state = 0},
  [3068] = {.lex_state = 0},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 0},
  [3071] = {.lex_state = 68},
  [3072] = {.lex_state = 68},
  [3073] = {.lex_state = 68},
  [3074] = {.lex_state = 68},
  [3075] = {.lex_state = 68},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 68},
  [3078] = {.lex_state = 0},
  [3079] = {.lex_state = 0},
  [3080] = {.lex_state = 15},
  [3081] = {.lex_state = 0},
  [3082] = {.lex_state = 68},
  [3083] = {.lex_state = 68},
  [3084] = {.lex_state = 0},
  [3085] = {.lex_state = 68},
  [3086] = {.lex_state = 0},
  [3087] = {.lex_state = 0},
  [3088] = {.lex_state = 68},
  [3089] = {.lex_state = 0},
  [3090] = {.lex_state = 0},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 0},
  [3093] = {.lex_state = 68},
  [3094] = {.lex_state = 68},
  [3095] = {.lex_state = 68},
  [3096] = {.lex_state = 0},
  [3097] = {.lex_state = 68},
  [3098] = {.lex_state = 0},
  [3099] = {.lex_state = 0},
  [3100] = {.lex_state = 68},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 68},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 68},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 68},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 0},
  [3110] = {.lex_state = 0},
  [3111] = {.lex_state = 0},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 0},
  [3114] = {.lex_state = 0},
  [3115] = {.lex_state = 0},
  [3116] = {.lex_state = 68},
  [3117] = {.lex_state = 68},
  [3118] = {.lex_state = 0},
  [3119] = {.lex_state = 68},
  [3120] = {.lex_state = 68},
  [3121] = {.lex_state = 0},
  [3122] = {.lex_state = 0},
  [3123] = {.lex_state = 5},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 0},
  [3126] = {.lex_state = 68},
  [3127] = {.lex_state = 0},
  [3128] = {.lex_state = 0},
  [3129] = {.lex_state = 68},
  [3130] = {.lex_state = 68},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 68},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 68},
  [3135] = {.lex_state = 68},
  [3136] = {.lex_state = 68},
  [3137] = {.lex_state = 0},
  [3138] = {.lex_state = 0},
  [3139] = {.lex_state = 0},
  [3140] = {.lex_state = 68},
  [3141] = {.lex_state = 0},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 0},
  [3144] = {.lex_state = 68},
  [3145] = {.lex_state = 68},
  [3146] = {.lex_state = 15},
  [3147] = {.lex_state = 68},
  [3148] = {.lex_state = 68},
  [3149] = {.lex_state = 68},
  [3150] = {.lex_state = 0},
  [3151] = {.lex_state = 0},
  [3152] = {.lex_state = 0},
  [3153] = {.lex_state = 0},
  [3154] = {.lex_state = 0},
  [3155] = {.lex_state = 68},
  [3156] = {.lex_state = 68},
  [3157] = {.lex_state = 0},
  [3158] = {.lex_state = 68},
  [3159] = {.lex_state = 0},
  [3160] = {.lex_state = 68},
  [3161] = {.lex_state = 0},
  [3162] = {.lex_state = 5},
  [3163] = {.lex_state = 0},
  [3164] = {.lex_state = 68},
  [3165] = {.lex_state = 0},
  [3166] = {.lex_state = 68},
  [3167] = {.lex_state = 0},
  [3168] = {.lex_state = 68},
  [3169] = {.lex_state = 68},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 68},
  [3172] = {.lex_state = 0},
  [3173] = {.lex_state = 68},
  [3174] = {.lex_state = 68},
  [3175] = {.lex_state = 68},
  [3176] = {.lex_state = 68},
  [3177] = {.lex_state = 68},
  [3178] = {.lex_state = 68},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 68},
  [3181] = {.lex_state = 68},
  [3182] = {.lex_state = 68},
  [3183] = {.lex_state = 68},
  [3184] = {.lex_state = 68},
  [3185] = {.lex_state = 0},
  [3186] = {.lex_state = 68},
  [3187] = {.lex_state = 68},
  [3188] = {.lex_state = 68},
  [3189] = {.lex_state = 68},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 68},
  [3192] = {.lex_state = 0},
  [3193] = {.lex_state = 0},
  [3194] = {.lex_state = 0},
  [3195] = {.lex_state = 68},
  [3196] = {.lex_state = 68},
  [3197] = {.lex_state = 0},
  [3198] = {.lex_state = 68},
  [3199] = {.lex_state = 68},
  [3200] = {.lex_state = 68},
  [3201] = {.lex_state = 68},
  [3202] = {.lex_state = 0},
  [3203] = {.lex_state = 68},
  [3204] = {.lex_state = 15},
  [3205] = {.lex_state = 68},
  [3206] = {.lex_state = 68},
  [3207] = {.lex_state = 68},
  [3208] = {.lex_state = 68},
  [3209] = {.lex_state = 68},
  [3210] = {.lex_state = 68},
  [3211] = {.lex_state = 0},
  [3212] = {.lex_state = 68},
  [3213] = {.lex_state = 0},
  [3214] = {.lex_state = 68},
  [3215] = {.lex_state = 68},
  [3216] = {.lex_state = 0},
  [3217] = {.lex_state = 0},
  [3218] = {.lex_state = 5},
  [3219] = {.lex_state = 68},
  [3220] = {.lex_state = 68},
  [3221] = {.lex_state = 0},
  [3222] = {.lex_state = 0},
  [3223] = {.lex_state = 68},
  [3224] = {.lex_state = 0},
  [3225] = {.lex_state = 68},
  [3226] = {.lex_state = 0},
  [3227] = {.lex_state = 68},
  [3228] = {.lex_state = 0},
  [3229] = {.lex_state = 68},
  [3230] = {.lex_state = 0},
  [3231] = {.lex_state = 68},
  [3232] = {.lex_state = 0},
  [3233] = {.lex_state = 68},
  [3234] = {.lex_state = 68},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3213),
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [2] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1600),
    [sym_assignment_pattern] = STATE(2734),
    [sym_array] = STATE(1601),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_spread_element] = STATE(2734),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1534),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_method_definition] = STATE(2734),
    [sym_pair] = STATE(2734),
    [sym__property_name] = STATE(2141),
    [sym_computed_property_name] = STATE(2141),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_accessibility_modifier] = STATE(1879),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [aux_sym_object_repeat1] = STATE(2736),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_export] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(119),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_module] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(127),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(135),
    [anon_sym_public] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(139),
    [sym_readonly] = ACTIONS(141),
  },
  [3] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1600),
    [sym_assignment_pattern] = STATE(2701),
    [sym_array] = STATE(1601),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_spread_element] = STATE(2701),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1534),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_method_definition] = STATE(2701),
    [sym_pair] = STATE(2701),
    [sym__property_name] = STATE(2141),
    [sym_computed_property_name] = STATE(2141),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_accessibility_modifier] = STATE(1879),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [aux_sym_object_repeat1] = STATE(2692),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(147),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(151),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(153),
    [anon_sym_module] = ACTIONS(155),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(159),
    [anon_sym_set] = ACTIONS(159),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_public] = ACTIONS(163),
    [anon_sym_private] = ACTIONS(163),
    [anon_sym_protected] = ACTIONS(163),
    [anon_sym_any] = ACTIONS(165),
    [anon_sym_number] = ACTIONS(165),
    [anon_sym_boolean] = ACTIONS(165),
    [anon_sym_string] = ACTIONS(165),
    [anon_sym_symbol] = ACTIONS(165),
    [sym_readonly] = ACTIONS(167),
  },
  [4] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1600),
    [sym_assignment_pattern] = STATE(2672),
    [sym_array] = STATE(1601),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_spread_element] = STATE(2672),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1534),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_method_definition] = STATE(2672),
    [sym_pair] = STATE(2672),
    [sym__property_name] = STATE(2141),
    [sym_computed_property_name] = STATE(2141),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_accessibility_modifier] = STATE(1879),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [aux_sym_object_repeat1] = STATE(2664),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_export] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(175),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(181),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(185),
    [anon_sym_set] = ACTIONS(185),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(187),
    [anon_sym_public] = ACTIONS(189),
    [anon_sym_private] = ACTIONS(189),
    [anon_sym_protected] = ACTIONS(189),
    [anon_sym_any] = ACTIONS(191),
    [anon_sym_number] = ACTIONS(191),
    [anon_sym_boolean] = ACTIONS(191),
    [anon_sym_string] = ACTIONS(191),
    [anon_sym_symbol] = ACTIONS(191),
    [sym_readonly] = ACTIONS(193),
  },
  [5] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1600),
    [sym_assignment_pattern] = STATE(2672),
    [sym_array] = STATE(1601),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_spread_element] = STATE(2672),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1534),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_method_definition] = STATE(2672),
    [sym_pair] = STATE(2672),
    [sym__property_name] = STATE(2141),
    [sym_computed_property_name] = STATE(2141),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_accessibility_modifier] = STATE(1879),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [aux_sym_object_repeat1] = STATE(2664),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_export] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(195),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(181),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(185),
    [anon_sym_set] = ACTIONS(185),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(187),
    [anon_sym_public] = ACTIONS(189),
    [anon_sym_private] = ACTIONS(189),
    [anon_sym_protected] = ACTIONS(189),
    [anon_sym_any] = ACTIONS(191),
    [anon_sym_number] = ACTIONS(191),
    [anon_sym_boolean] = ACTIONS(191),
    [anon_sym_string] = ACTIONS(191),
    [anon_sym_symbol] = ACTIONS(191),
    [sym_readonly] = ACTIONS(193),
  },
  [6] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1600),
    [sym_assignment_pattern] = STATE(2672),
    [sym_array] = STATE(1601),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_spread_element] = STATE(2672),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1534),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_method_definition] = STATE(2672),
    [sym_pair] = STATE(2672),
    [sym__property_name] = STATE(2141),
    [sym_computed_property_name] = STATE(2141),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_accessibility_modifier] = STATE(1879),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [aux_sym_object_repeat1] = STATE(2664),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_export] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(197),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(177),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(181),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(185),
    [anon_sym_set] = ACTIONS(185),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(133),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(187),
    [anon_sym_public] = ACTIONS(189),
    [anon_sym_private] = ACTIONS(189),
    [anon_sym_protected] = ACTIONS(189),
    [anon_sym_any] = ACTIONS(191),
    [anon_sym_number] = ACTIONS(191),
    [anon_sym_boolean] = ACTIONS(191),
    [anon_sym_string] = ACTIONS(191),
    [anon_sym_symbol] = ACTIONS(191),
    [sym_readonly] = ACTIONS(193),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(199),
    [sym_identifier] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(204),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_namespace] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(212),
    [anon_sym_RBRACE] = ACTIONS(199),
    [anon_sym_typeof] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(218),
    [anon_sym_interface] = ACTIONS(221),
    [anon_sym_declare] = ACTIONS(224),
    [anon_sym_module] = ACTIONS(227),
    [anon_sym_import] = ACTIONS(230),
    [anon_sym_const] = ACTIONS(233),
    [anon_sym_enum] = ACTIONS(236),
    [anon_sym_var] = ACTIONS(239),
    [anon_sym_let] = ACTIONS(242),
    [anon_sym_BANG] = ACTIONS(245),
    [anon_sym_if] = ACTIONS(248),
    [anon_sym_switch] = ACTIONS(251),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(257),
    [anon_sym_await] = ACTIONS(260),
    [anon_sym_while] = ACTIONS(263),
    [anon_sym_do] = ACTIONS(266),
    [anon_sym_try] = ACTIONS(269),
    [anon_sym_with] = ACTIONS(272),
    [anon_sym_break] = ACTIONS(275),
    [anon_sym_continue] = ACTIONS(278),
    [anon_sym_debugger] = ACTIONS(281),
    [anon_sym_return] = ACTIONS(284),
    [anon_sym_throw] = ACTIONS(287),
    [anon_sym_SEMI] = ACTIONS(290),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(296),
    [anon_sym_class] = ACTIONS(299),
    [anon_sym_async] = ACTIONS(302),
    [anon_sym_function] = ACTIONS(305),
    [anon_sym_abstract] = ACTIONS(308),
    [anon_sym_get] = ACTIONS(311),
    [anon_sym_set] = ACTIONS(311),
    [anon_sym_new] = ACTIONS(314),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(320),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_TILDE] = ACTIONS(245),
    [anon_sym_void] = ACTIONS(326),
    [anon_sym_delete] = ACTIONS(326),
    [anon_sym_PLUS_PLUS] = ACTIONS(329),
    [anon_sym_DASH_DASH] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [anon_sym_SQUOTE] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(338),
    [sym_number] = ACTIONS(341),
    [sym_this] = ACTIONS(344),
    [sym_super] = ACTIONS(344),
    [sym_true] = ACTIONS(344),
    [sym_false] = ACTIONS(344),
    [sym_null] = ACTIONS(344),
    [anon_sym_AT] = ACTIONS(347),
    [anon_sym_static] = ACTIONS(311),
    [anon_sym_public] = ACTIONS(311),
    [anon_sym_private] = ACTIONS(311),
    [anon_sym_protected] = ACTIONS(311),
    [anon_sym_any] = ACTIONS(311),
    [anon_sym_number] = ACTIONS(311),
    [anon_sym_boolean] = ACTIONS(311),
    [anon_sym_string] = ACTIONS(311),
    [anon_sym_symbol] = ACTIONS(311),
    [sym_readonly] = ACTIONS(311),
  },
  [8] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(350),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(352),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(350),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [9] = {
    [sym_export_statement] = STATE(8),
    [sym__declaration] = STATE(8),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_switch_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_for_in_statement] = STATE(8),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_with_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_debugger_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_statement] = STATE(8),
    [sym_empty_statement] = STATE(8),
    [sym_labeled_statement] = STATE(8),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(354),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(356),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(354),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [10] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(358),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(360),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(358),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [11] = {
    [sym_export_statement] = STATE(10),
    [sym__declaration] = STATE(10),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(362),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(364),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(362),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [12] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [13] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [14] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(370),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [15] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [16] = {
    [sym_export_statement] = STATE(26),
    [sym__declaration] = STATE(26),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(26),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(374),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [17] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [18] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(378),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [19] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(370),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [20] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [21] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(382),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [22] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [ts_builtin_sym_end] = ACTIONS(384),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [23] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(386),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [24] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(390),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [26] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [27] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [28] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [29] = {
    [sym_export_statement] = STATE(554),
    [sym__declaration] = STATE(554),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(554),
    [sym_expression_statement] = STATE(554),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(554),
    [sym_if_statement] = STATE(554),
    [sym_switch_statement] = STATE(554),
    [sym_for_statement] = STATE(554),
    [sym_for_in_statement] = STATE(554),
    [sym_while_statement] = STATE(554),
    [sym_do_statement] = STATE(554),
    [sym_try_statement] = STATE(554),
    [sym_with_statement] = STATE(554),
    [sym_break_statement] = STATE(554),
    [sym_continue_statement] = STATE(554),
    [sym_debugger_statement] = STATE(554),
    [sym_return_statement] = STATE(554),
    [sym_throw_statement] = STATE(554),
    [sym_empty_statement] = STATE(554),
    [sym_labeled_statement] = STATE(554),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [30] = {
    [sym_export_statement] = STATE(604),
    [sym__declaration] = STATE(604),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(604),
    [sym_expression_statement] = STATE(604),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_switch_statement] = STATE(604),
    [sym_for_statement] = STATE(604),
    [sym_for_in_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_do_statement] = STATE(604),
    [sym_try_statement] = STATE(604),
    [sym_with_statement] = STATE(604),
    [sym_break_statement] = STATE(604),
    [sym_continue_statement] = STATE(604),
    [sym_debugger_statement] = STATE(604),
    [sym_return_statement] = STATE(604),
    [sym_throw_statement] = STATE(604),
    [sym_empty_statement] = STATE(604),
    [sym_labeled_statement] = STATE(604),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [31] = {
    [sym_export_statement] = STATE(531),
    [sym__declaration] = STATE(531),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(531),
    [sym_expression_statement] = STATE(531),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(531),
    [sym_if_statement] = STATE(531),
    [sym_switch_statement] = STATE(531),
    [sym_for_statement] = STATE(531),
    [sym_for_in_statement] = STATE(531),
    [sym_while_statement] = STATE(531),
    [sym_do_statement] = STATE(531),
    [sym_try_statement] = STATE(531),
    [sym_with_statement] = STATE(531),
    [sym_break_statement] = STATE(531),
    [sym_continue_statement] = STATE(531),
    [sym_debugger_statement] = STATE(531),
    [sym_return_statement] = STATE(531),
    [sym_throw_statement] = STATE(531),
    [sym_empty_statement] = STATE(531),
    [sym_labeled_statement] = STATE(531),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [32] = {
    [sym_export_statement] = STATE(552),
    [sym__declaration] = STATE(552),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(552),
    [sym_expression_statement] = STATE(552),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(552),
    [sym_if_statement] = STATE(552),
    [sym_switch_statement] = STATE(552),
    [sym_for_statement] = STATE(552),
    [sym_for_in_statement] = STATE(552),
    [sym_while_statement] = STATE(552),
    [sym_do_statement] = STATE(552),
    [sym_try_statement] = STATE(552),
    [sym_with_statement] = STATE(552),
    [sym_break_statement] = STATE(552),
    [sym_continue_statement] = STATE(552),
    [sym_debugger_statement] = STATE(552),
    [sym_return_statement] = STATE(552),
    [sym_throw_statement] = STATE(552),
    [sym_empty_statement] = STATE(552),
    [sym_labeled_statement] = STATE(552),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [33] = {
    [sym_export_statement] = STATE(552),
    [sym__declaration] = STATE(552),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(552),
    [sym_expression_statement] = STATE(552),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(552),
    [sym_if_statement] = STATE(552),
    [sym_switch_statement] = STATE(552),
    [sym_for_statement] = STATE(552),
    [sym_for_in_statement] = STATE(552),
    [sym_while_statement] = STATE(552),
    [sym_do_statement] = STATE(552),
    [sym_try_statement] = STATE(552),
    [sym_with_statement] = STATE(552),
    [sym_break_statement] = STATE(552),
    [sym_continue_statement] = STATE(552),
    [sym_debugger_statement] = STATE(552),
    [sym_return_statement] = STATE(552),
    [sym_throw_statement] = STATE(552),
    [sym_empty_statement] = STATE(552),
    [sym_labeled_statement] = STATE(552),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [34] = {
    [sym_export_statement] = STATE(615),
    [sym__declaration] = STATE(615),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(615),
    [sym_expression_statement] = STATE(615),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_switch_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_for_in_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_do_statement] = STATE(615),
    [sym_try_statement] = STATE(615),
    [sym_with_statement] = STATE(615),
    [sym_break_statement] = STATE(615),
    [sym_continue_statement] = STATE(615),
    [sym_debugger_statement] = STATE(615),
    [sym_return_statement] = STATE(615),
    [sym_throw_statement] = STATE(615),
    [sym_empty_statement] = STATE(615),
    [sym_labeled_statement] = STATE(615),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [35] = {
    [sym_export_statement] = STATE(601),
    [sym__declaration] = STATE(601),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(601),
    [sym_expression_statement] = STATE(601),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(601),
    [sym_if_statement] = STATE(601),
    [sym_switch_statement] = STATE(601),
    [sym_for_statement] = STATE(601),
    [sym_for_in_statement] = STATE(601),
    [sym_while_statement] = STATE(601),
    [sym_do_statement] = STATE(601),
    [sym_try_statement] = STATE(601),
    [sym_with_statement] = STATE(601),
    [sym_break_statement] = STATE(601),
    [sym_continue_statement] = STATE(601),
    [sym_debugger_statement] = STATE(601),
    [sym_return_statement] = STATE(601),
    [sym_throw_statement] = STATE(601),
    [sym_empty_statement] = STATE(601),
    [sym_labeled_statement] = STATE(601),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [36] = {
    [sym_export_statement] = STATE(3164),
    [sym__declaration] = STATE(3164),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(3164),
    [sym_expression_statement] = STATE(3164),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(3164),
    [sym_if_statement] = STATE(3164),
    [sym_switch_statement] = STATE(3164),
    [sym_for_statement] = STATE(3164),
    [sym_for_in_statement] = STATE(3164),
    [sym_while_statement] = STATE(3164),
    [sym_do_statement] = STATE(3164),
    [sym_try_statement] = STATE(3164),
    [sym_with_statement] = STATE(3164),
    [sym_break_statement] = STATE(3164),
    [sym_continue_statement] = STATE(3164),
    [sym_debugger_statement] = STATE(3164),
    [sym_return_statement] = STATE(3164),
    [sym_throw_statement] = STATE(3164),
    [sym_empty_statement] = STATE(3164),
    [sym_labeled_statement] = STATE(3164),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [37] = {
    [sym_export_statement] = STATE(576),
    [sym__declaration] = STATE(576),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(576),
    [sym_expression_statement] = STATE(576),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(576),
    [sym_if_statement] = STATE(576),
    [sym_switch_statement] = STATE(576),
    [sym_for_statement] = STATE(576),
    [sym_for_in_statement] = STATE(576),
    [sym_while_statement] = STATE(576),
    [sym_do_statement] = STATE(576),
    [sym_try_statement] = STATE(576),
    [sym_with_statement] = STATE(576),
    [sym_break_statement] = STATE(576),
    [sym_continue_statement] = STATE(576),
    [sym_debugger_statement] = STATE(576),
    [sym_return_statement] = STATE(576),
    [sym_throw_statement] = STATE(576),
    [sym_empty_statement] = STATE(576),
    [sym_labeled_statement] = STATE(576),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [38] = {
    [sym_export_statement] = STATE(579),
    [sym__declaration] = STATE(579),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(579),
    [sym_expression_statement] = STATE(579),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(579),
    [sym_if_statement] = STATE(579),
    [sym_switch_statement] = STATE(579),
    [sym_for_statement] = STATE(579),
    [sym_for_in_statement] = STATE(579),
    [sym_while_statement] = STATE(579),
    [sym_do_statement] = STATE(579),
    [sym_try_statement] = STATE(579),
    [sym_with_statement] = STATE(579),
    [sym_break_statement] = STATE(579),
    [sym_continue_statement] = STATE(579),
    [sym_debugger_statement] = STATE(579),
    [sym_return_statement] = STATE(579),
    [sym_throw_statement] = STATE(579),
    [sym_empty_statement] = STATE(579),
    [sym_labeled_statement] = STATE(579),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [39] = {
    [sym_export_statement] = STATE(589),
    [sym__declaration] = STATE(589),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(589),
    [sym_expression_statement] = STATE(589),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(589),
    [sym_if_statement] = STATE(589),
    [sym_switch_statement] = STATE(589),
    [sym_for_statement] = STATE(589),
    [sym_for_in_statement] = STATE(589),
    [sym_while_statement] = STATE(589),
    [sym_do_statement] = STATE(589),
    [sym_try_statement] = STATE(589),
    [sym_with_statement] = STATE(589),
    [sym_break_statement] = STATE(589),
    [sym_continue_statement] = STATE(589),
    [sym_debugger_statement] = STATE(589),
    [sym_return_statement] = STATE(589),
    [sym_throw_statement] = STATE(589),
    [sym_empty_statement] = STATE(589),
    [sym_labeled_statement] = STATE(589),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [40] = {
    [sym_export_statement] = STATE(615),
    [sym__declaration] = STATE(615),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(615),
    [sym_expression_statement] = STATE(615),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_switch_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_for_in_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_do_statement] = STATE(615),
    [sym_try_statement] = STATE(615),
    [sym_with_statement] = STATE(615),
    [sym_break_statement] = STATE(615),
    [sym_continue_statement] = STATE(615),
    [sym_debugger_statement] = STATE(615),
    [sym_return_statement] = STATE(615),
    [sym_throw_statement] = STATE(615),
    [sym_empty_statement] = STATE(615),
    [sym_labeled_statement] = STATE(615),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [41] = {
    [sym_export_statement] = STATE(589),
    [sym__declaration] = STATE(589),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(589),
    [sym_expression_statement] = STATE(589),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(589),
    [sym_if_statement] = STATE(589),
    [sym_switch_statement] = STATE(589),
    [sym_for_statement] = STATE(589),
    [sym_for_in_statement] = STATE(589),
    [sym_while_statement] = STATE(589),
    [sym_do_statement] = STATE(589),
    [sym_try_statement] = STATE(589),
    [sym_with_statement] = STATE(589),
    [sym_break_statement] = STATE(589),
    [sym_continue_statement] = STATE(589),
    [sym_debugger_statement] = STATE(589),
    [sym_return_statement] = STATE(589),
    [sym_throw_statement] = STATE(589),
    [sym_empty_statement] = STATE(589),
    [sym_labeled_statement] = STATE(589),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [42] = {
    [sym_export_statement] = STATE(601),
    [sym__declaration] = STATE(601),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(601),
    [sym_expression_statement] = STATE(601),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(601),
    [sym_if_statement] = STATE(601),
    [sym_switch_statement] = STATE(601),
    [sym_for_statement] = STATE(601),
    [sym_for_in_statement] = STATE(601),
    [sym_while_statement] = STATE(601),
    [sym_do_statement] = STATE(601),
    [sym_try_statement] = STATE(601),
    [sym_with_statement] = STATE(601),
    [sym_break_statement] = STATE(601),
    [sym_continue_statement] = STATE(601),
    [sym_debugger_statement] = STATE(601),
    [sym_return_statement] = STATE(601),
    [sym_throw_statement] = STATE(601),
    [sym_empty_statement] = STATE(601),
    [sym_labeled_statement] = STATE(601),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(86),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2224),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(25),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(39),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(49),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_function] = ACTIONS(77),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(81),
    [anon_sym_set] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_any] = ACTIONS(81),
    [anon_sym_number] = ACTIONS(81),
    [anon_sym_boolean] = ACTIONS(81),
    [anon_sym_string] = ACTIONS(81),
    [anon_sym_symbol] = ACTIONS(81),
    [sym_readonly] = ACTIONS(81),
  },
  [43] = {
    [sym_export_statement] = STATE(576),
    [sym__declaration] = STATE(576),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(576),
    [sym_expression_statement] = STATE(576),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(576),
    [sym_if_statement] = STATE(576),
    [sym_switch_statement] = STATE(576),
    [sym_for_statement] = STATE(576),
    [sym_for_in_statement] = STATE(576),
    [sym_while_statement] = STATE(576),
    [sym_do_statement] = STATE(576),
    [sym_try_statement] = STATE(576),
    [sym_with_statement] = STATE(576),
    [sym_break_statement] = STATE(576),
    [sym_continue_statement] = STATE(576),
    [sym_debugger_statement] = STATE(576),
    [sym_return_statement] = STATE(576),
    [sym_throw_statement] = STATE(576),
    [sym_empty_statement] = STATE(576),
    [sym_labeled_statement] = STATE(576),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [44] = {
    [sym_export_statement] = STATE(604),
    [sym__declaration] = STATE(604),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(604),
    [sym_expression_statement] = STATE(604),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(604),
    [sym_if_statement] = STATE(604),
    [sym_switch_statement] = STATE(604),
    [sym_for_statement] = STATE(604),
    [sym_for_in_statement] = STATE(604),
    [sym_while_statement] = STATE(604),
    [sym_do_statement] = STATE(604),
    [sym_try_statement] = STATE(604),
    [sym_with_statement] = STATE(604),
    [sym_break_statement] = STATE(604),
    [sym_continue_statement] = STATE(604),
    [sym_debugger_statement] = STATE(604),
    [sym_return_statement] = STATE(604),
    [sym_throw_statement] = STATE(604),
    [sym_empty_statement] = STATE(604),
    [sym_labeled_statement] = STATE(604),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [45] = {
    [sym_export_statement] = STATE(2686),
    [sym__declaration] = STATE(2686),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(2686),
    [sym_expression_statement] = STATE(2686),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(2686),
    [sym_if_statement] = STATE(2686),
    [sym_switch_statement] = STATE(2686),
    [sym_for_statement] = STATE(2686),
    [sym_for_in_statement] = STATE(2686),
    [sym_while_statement] = STATE(2686),
    [sym_do_statement] = STATE(2686),
    [sym_try_statement] = STATE(2686),
    [sym_with_statement] = STATE(2686),
    [sym_break_statement] = STATE(2686),
    [sym_continue_statement] = STATE(2686),
    [sym_debugger_statement] = STATE(2686),
    [sym_return_statement] = STATE(2686),
    [sym_throw_statement] = STATE(2686),
    [sym_empty_statement] = STATE(2686),
    [sym_labeled_statement] = STATE(2686),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [46] = {
    [sym_export_statement] = STATE(554),
    [sym__declaration] = STATE(554),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(554),
    [sym_expression_statement] = STATE(554),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(554),
    [sym_if_statement] = STATE(554),
    [sym_switch_statement] = STATE(554),
    [sym_for_statement] = STATE(554),
    [sym_for_in_statement] = STATE(554),
    [sym_while_statement] = STATE(554),
    [sym_do_statement] = STATE(554),
    [sym_try_statement] = STATE(554),
    [sym_with_statement] = STATE(554),
    [sym_break_statement] = STATE(554),
    [sym_continue_statement] = STATE(554),
    [sym_debugger_statement] = STATE(554),
    [sym_return_statement] = STATE(554),
    [sym_throw_statement] = STATE(554),
    [sym_empty_statement] = STATE(554),
    [sym_labeled_statement] = STATE(554),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [47] = {
    [sym_export_statement] = STATE(579),
    [sym__declaration] = STATE(579),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_import] = STATE(1497),
    [sym_import_statement] = STATE(579),
    [sym_expression_statement] = STATE(579),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_statement_block] = STATE(579),
    [sym_if_statement] = STATE(579),
    [sym_switch_statement] = STATE(579),
    [sym_for_statement] = STATE(579),
    [sym_for_in_statement] = STATE(579),
    [sym_while_statement] = STATE(579),
    [sym_do_statement] = STATE(579),
    [sym_try_statement] = STATE(579),
    [sym_with_statement] = STATE(579),
    [sym_break_statement] = STATE(579),
    [sym_continue_statement] = STATE(579),
    [sym_debugger_statement] = STATE(579),
    [sym_return_statement] = STATE(579),
    [sym_throw_statement] = STATE(579),
    [sym_empty_statement] = STATE(579),
    [sym_labeled_statement] = STATE(579),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_class_declaration] = STATE(566),
    [sym_function] = STATE(1497),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function] = STATE(1497),
    [sym_generator_function_declaration] = STATE(566),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(1372),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2194),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_export] = ACTIONS(400),
    [anon_sym_namespace] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(408),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_enum] = ACTIONS(31),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_let] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(41),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(51),
    [anon_sym_try] = ACTIONS(53),
    [anon_sym_with] = ACTIONS(418),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_debugger] = ACTIONS(61),
    [anon_sym_return] = ACTIONS(63),
    [anon_sym_throw] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(420),
    [anon_sym_async] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_abstract] = ACTIONS(79),
    [anon_sym_get] = ACTIONS(426),
    [anon_sym_set] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_protected] = ACTIONS(426),
    [anon_sym_any] = ACTIONS(426),
    [anon_sym_number] = ACTIONS(426),
    [anon_sym_boolean] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_symbol] = ACTIONS(426),
    [sym_readonly] = ACTIONS(426),
  },
  [48] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1611),
    [sym_array] = STATE(1518),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3035),
    [sym_string] = STATE(1491),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(2356),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__type] = STATE(2486),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2486),
    [sym_intersection_type] = STATE(2486),
    [sym_function_type] = STATE(2486),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2486),
    [aux_sym_export_statement_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(428),
    [anon_sym_export] = ACTIONS(430),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_typeof] = ACTIONS(438),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_declare] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(452),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(430),
    [anon_sym_set] = ACTIONS(430),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(474),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(486),
    [sym_this] = ACTIONS(488),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(492),
    [sym_false] = ACTIONS(492),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(430),
    [anon_sym_number] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(496),
    [anon_sym_string] = ACTIONS(496),
    [anon_sym_symbol] = ACTIONS(496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(500),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [49] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1168),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1611),
    [sym_array] = STATE(1518),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3167),
    [sym_string] = STATE(1491),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(2356),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__type] = STATE(2603),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2603),
    [sym_intersection_type] = STATE(2603),
    [sym_function_type] = STATE(2603),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2603),
    [aux_sym_export_statement_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(428),
    [anon_sym_export] = ACTIONS(430),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_typeof] = ACTIONS(438),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_declare] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(452),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(430),
    [anon_sym_set] = ACTIONS(430),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(474),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(486),
    [sym_this] = ACTIONS(488),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(492),
    [sym_false] = ACTIONS(492),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(430),
    [anon_sym_number] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(496),
    [anon_sym_string] = ACTIONS(496),
    [anon_sym_symbol] = ACTIONS(496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(500),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [50] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1611),
    [sym_array] = STATE(1518),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3035),
    [sym_string] = STATE(1491),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(2356),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__type] = STATE(2603),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2603),
    [sym_intersection_type] = STATE(2603),
    [sym_function_type] = STATE(2603),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2603),
    [aux_sym_export_statement_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(428),
    [anon_sym_export] = ACTIONS(430),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_typeof] = ACTIONS(438),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_declare] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(452),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(430),
    [anon_sym_set] = ACTIONS(430),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(474),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(486),
    [sym_this] = ACTIONS(488),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(492),
    [sym_false] = ACTIONS(492),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(430),
    [anon_sym_number] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(496),
    [anon_sym_string] = ACTIONS(496),
    [anon_sym_symbol] = ACTIONS(496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(500),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [51] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1103),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1611),
    [sym_array] = STATE(1518),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3078),
    [sym_string] = STATE(1491),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(2356),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__type] = STATE(2603),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2603),
    [sym_intersection_type] = STATE(2603),
    [sym_function_type] = STATE(2603),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2603),
    [aux_sym_export_statement_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(428),
    [anon_sym_export] = ACTIONS(430),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_typeof] = ACTIONS(438),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_declare] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(452),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(430),
    [anon_sym_set] = ACTIONS(430),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(474),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(486),
    [sym_this] = ACTIONS(488),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(492),
    [sym_false] = ACTIONS(492),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(430),
    [anon_sym_number] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(496),
    [anon_sym_string] = ACTIONS(496),
    [anon_sym_symbol] = ACTIONS(496),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(500),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [52] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1028),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_as] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_DOT] = ACTIONS(510),
    [anon_sym_COLON] = ACTIONS(516),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(516),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_in] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(516),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_QMARK] = ACTIONS(510),
    [anon_sym_QMARK_DOT] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_AMP_AMP] = ACTIONS(516),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(510),
    [anon_sym_GT_GT_GT] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(516),
    [anon_sym_instanceof] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [53] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1088),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(2356),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym__type] = STATE(2231),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2231),
    [sym_intersection_type] = STATE(2231),
    [sym_function_type] = STATE(2231),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2231),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(534),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(540),
    [anon_sym_typeof] = ACTIONS(542),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(554),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(560),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(566),
    [sym_this] = ACTIONS(568),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(572),
    [anon_sym_boolean] = ACTIONS(572),
    [anon_sym_string] = ACTIONS(572),
    [anon_sym_symbol] = ACTIONS(572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(574),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [54] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(580),
    [anon_sym_as] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_in] = ACTIONS(510),
    [anon_sym_SEMI] = ACTIONS(516),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(510),
    [anon_sym_QMARK_DOT] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_AMP_AMP] = ACTIONS(516),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(510),
    [anon_sym_GT_GT_GT] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(516),
    [anon_sym_instanceof] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
    [sym__automatic_semicolon] = ACTIONS(516),
  },
  [55] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1613),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(2356),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym__type] = STATE(2231),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2231),
    [sym_intersection_type] = STATE(2231),
    [sym_function_type] = STATE(2231),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2231),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(594),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(540),
    [anon_sym_typeof] = ACTIONS(600),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(614),
    [anon_sym_DASH] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(616),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(624),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(626),
    [sym_false] = ACTIONS(626),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(628),
    [anon_sym_boolean] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_symbol] = ACTIONS(628),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(630),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [56] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1073),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1088),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(2356),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__type] = STATE(2231),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2231),
    [sym_intersection_type] = STATE(2231),
    [sym_function_type] = STATE(2231),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2231),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(540),
    [anon_sym_typeof] = ACTIONS(634),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(444),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(474),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(566),
    [sym_this] = ACTIONS(568),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(638),
    [anon_sym_boolean] = ACTIONS(638),
    [anon_sym_string] = ACTIONS(638),
    [anon_sym_symbol] = ACTIONS(638),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(640),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [57] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1616),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(2356),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym__type] = STATE(2231),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2231),
    [sym_intersection_type] = STATE(2231),
    [sym_function_type] = STATE(2231),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2231),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(668),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(674),
    [sym_this] = ACTIONS(676),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(678),
    [sym_false] = ACTIONS(678),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(682),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [58] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1133),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1409),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(2356),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym__type] = STATE(2231),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2231),
    [sym_intersection_type] = STATE(2231),
    [sym_function_type] = STATE(2231),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2231),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(684),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(692),
    [anon_sym_DASH] = ACTIONS(692),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(694),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(696),
    [sym_this] = ACTIONS(698),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(700),
    [sym_false] = ACTIONS(700),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(702),
    [anon_sym_boolean] = ACTIONS(702),
    [anon_sym_string] = ACTIONS(702),
    [anon_sym_symbol] = ACTIONS(702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(704),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [59] = {
    [sym_object] = STATE(2441),
    [sym_array] = STATE(2406),
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_export] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(708),
    [anon_sym_declare] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(724),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(728),
    [anon_sym_async] = ACTIONS(708),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(708),
    [anon_sym_set] = ACTIONS(708),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(758),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_protected] = ACTIONS(708),
    [anon_sym_any] = ACTIONS(708),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(764),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [60] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1520),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(2356),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym__type] = STATE(2231),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2231),
    [sym_intersection_type] = STATE(2231),
    [sym_function_type] = STATE(2231),
    [sym_type_parameters] = STATE(2971),
    [sym_constructor_type] = STATE(2231),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(786),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(796),
    [anon_sym_DASH] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(800),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(812),
    [sym_this] = ACTIONS(814),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(818),
    [sym_false] = ACTIONS(818),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(820),
    [anon_sym_boolean] = ACTIONS(820),
    [anon_sym_string] = ACTIONS(820),
    [anon_sym_symbol] = ACTIONS(820),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(822),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [61] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1346),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_nested_identifier] = STATE(3017),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(1990),
    [sym_formal_parameters] = STATE(2421),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__type] = STATE(2016),
    [sym__primary_type] = STATE(1993),
    [sym_parenthesized_type] = STATE(1993),
    [sym_predefined_type] = STATE(1993),
    [sym_nested_type_identifier] = STATE(1952),
    [sym_generic_type] = STATE(1993),
    [sym_object_type] = STATE(1993),
    [sym_array_type] = STATE(1993),
    [sym_tuple_type] = STATE(1993),
    [sym__tuple_type_body] = STATE(2007),
    [sym_flow_maybe_type] = STATE(1993),
    [sym_type_query] = STATE(1993),
    [sym_index_type_query] = STATE(1993),
    [sym_existential_type] = STATE(1993),
    [sym_literal_type] = STATE(1993),
    [sym_lookup_type] = STATE(1993),
    [sym_conditional_type] = STATE(1993),
    [sym_union_type] = STATE(2016),
    [sym_intersection_type] = STATE(2016),
    [sym_function_type] = STATE(2016),
    [sym_type_parameters] = STATE(2863),
    [sym_constructor_type] = STATE(2016),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(826),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_typeof] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(834),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_QMARK] = ACTIONS(836),
    [anon_sym_new] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(846),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(848),
    [sym_this] = ACTIONS(850),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(854),
    [anon_sym_boolean] = ACTIONS(854),
    [anon_sym_string] = ACTIONS(854),
    [anon_sym_symbol] = ACTIONS(854),
    [anon_sym_LBRACE_PIPE] = ACTIONS(856),
    [sym_readonly] = ACTIONS(858),
    [anon_sym_keyof] = ACTIONS(860),
  },
  [62] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(864),
    [anon_sym_as] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_DOT] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(510),
    [anon_sym_SEMI] = ACTIONS(516),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(510),
    [anon_sym_QMARK_DOT] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_AMP_AMP] = ACTIONS(516),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(510),
    [anon_sym_GT_GT_GT] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(516),
    [anon_sym_instanceof] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
    [sym__automatic_semicolon] = ACTIONS(516),
  },
  [63] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1398),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_STAR] = ACTIONS(874),
    [anon_sym_as] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_DOT] = ACTIONS(510),
    [anon_sym_COLON] = ACTIONS(516),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_in] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(516),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_QMARK] = ACTIONS(510),
    [anon_sym_QMARK_DOT] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_AMP_AMP] = ACTIONS(516),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(510),
    [anon_sym_GT_GT_GT] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(516),
    [anon_sym_instanceof] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [64] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(884),
    [anon_sym_as] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_in] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_QMARK] = ACTIONS(510),
    [anon_sym_QMARK_DOT] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(516),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(510),
    [anon_sym_GT_GT_GT] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(516),
    [anon_sym_instanceof] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(516),
    [sym_readonly] = ACTIONS(768),
  },
  [65] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1214),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_STAR] = ACTIONS(902),
    [anon_sym_as] = ACTIONS(510),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(516),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_DOT] = ACTIONS(510),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_in] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_QMARK] = ACTIONS(510),
    [anon_sym_implements] = ACTIONS(510),
    [anon_sym_QMARK_DOT] = ACTIONS(516),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_AMP_AMP] = ACTIONS(516),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(510),
    [anon_sym_GT_GT_GT] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(510),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_LT_EQ] = ACTIONS(516),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(516),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(516),
    [anon_sym_GT_EQ] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(516),
    [anon_sym_instanceof] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [66] = {
    [sym_statement_block] = STATE(84),
    [ts_builtin_sym_end] = ACTIONS(910),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(912),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_default] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(912),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(914),
    [anon_sym_COMMA] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(910),
    [anon_sym_typeof] = ACTIONS(912),
    [anon_sym_type] = ACTIONS(912),
    [anon_sym_interface] = ACTIONS(912),
    [anon_sym_declare] = ACTIONS(912),
    [anon_sym_module] = ACTIONS(912),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_import] = ACTIONS(912),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_enum] = ACTIONS(912),
    [anon_sym_var] = ACTIONS(912),
    [anon_sym_let] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_else] = ACTIONS(912),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(910),
    [anon_sym_await] = ACTIONS(912),
    [anon_sym_in] = ACTIONS(912),
    [anon_sym_while] = ACTIONS(912),
    [anon_sym_do] = ACTIONS(912),
    [anon_sym_try] = ACTIONS(912),
    [anon_sym_with] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(912),
    [anon_sym_continue] = ACTIONS(912),
    [anon_sym_debugger] = ACTIONS(912),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_throw] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(912),
    [anon_sym_yield] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(912),
    [anon_sym_async] = ACTIONS(912),
    [anon_sym_function] = ACTIONS(912),
    [anon_sym_abstract] = ACTIONS(912),
    [anon_sym_get] = ACTIONS(912),
    [anon_sym_set] = ACTIONS(912),
    [anon_sym_QMARK] = ACTIONS(912),
    [anon_sym_QMARK_DOT] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(912),
    [anon_sym_AMP_AMP] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(910),
    [anon_sym_GT_GT] = ACTIONS(912),
    [anon_sym_GT_GT_GT] = ACTIONS(910),
    [anon_sym_LT_LT] = ACTIONS(910),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(910),
    [anon_sym_PIPE] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_SLASH] = ACTIONS(912),
    [anon_sym_PERCENT] = ACTIONS(910),
    [anon_sym_STAR_STAR] = ACTIONS(910),
    [anon_sym_LT] = ACTIONS(912),
    [anon_sym_LT_EQ] = ACTIONS(910),
    [anon_sym_EQ_EQ] = ACTIONS(912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(910),
    [anon_sym_BANG_EQ] = ACTIONS(912),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(910),
    [anon_sym_GT_EQ] = ACTIONS(910),
    [anon_sym_GT] = ACTIONS(912),
    [anon_sym_QMARK_QMARK] = ACTIONS(910),
    [anon_sym_instanceof] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(912),
    [anon_sym_delete] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(910),
    [anon_sym_DQUOTE] = ACTIONS(910),
    [anon_sym_SQUOTE] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(910),
    [sym_number] = ACTIONS(910),
    [sym_this] = ACTIONS(912),
    [sym_super] = ACTIONS(912),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [sym_null] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(912),
    [anon_sym_public] = ACTIONS(912),
    [anon_sym_private] = ACTIONS(912),
    [anon_sym_protected] = ACTIONS(912),
    [anon_sym_any] = ACTIONS(912),
    [anon_sym_number] = ACTIONS(912),
    [anon_sym_boolean] = ACTIONS(912),
    [anon_sym_string] = ACTIONS(912),
    [anon_sym_symbol] = ACTIONS(912),
    [sym_readonly] = ACTIONS(912),
    [sym__automatic_semicolon] = ACTIONS(910),
  },
  [67] = {
    [sym_statement_block] = STATE(84),
    [ts_builtin_sym_end] = ACTIONS(910),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(912),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_default] = ACTIONS(912),
    [anon_sym_as] = ACTIONS(912),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(914),
    [anon_sym_COMMA] = ACTIONS(910),
    [anon_sym_RBRACE] = ACTIONS(910),
    [anon_sym_typeof] = ACTIONS(912),
    [anon_sym_type] = ACTIONS(912),
    [anon_sym_interface] = ACTIONS(912),
    [anon_sym_declare] = ACTIONS(912),
    [anon_sym_module] = ACTIONS(912),
    [anon_sym_DOT] = ACTIONS(916),
    [anon_sym_import] = ACTIONS(912),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_enum] = ACTIONS(912),
    [anon_sym_var] = ACTIONS(912),
    [anon_sym_let] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_else] = ACTIONS(912),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(910),
    [anon_sym_await] = ACTIONS(912),
    [anon_sym_in] = ACTIONS(912),
    [anon_sym_while] = ACTIONS(912),
    [anon_sym_do] = ACTIONS(912),
    [anon_sym_try] = ACTIONS(912),
    [anon_sym_with] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(912),
    [anon_sym_continue] = ACTIONS(912),
    [anon_sym_debugger] = ACTIONS(912),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_throw] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(912),
    [anon_sym_yield] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(912),
    [anon_sym_async] = ACTIONS(912),
    [anon_sym_function] = ACTIONS(912),
    [anon_sym_abstract] = ACTIONS(912),
    [anon_sym_get] = ACTIONS(912),
    [anon_sym_set] = ACTIONS(912),
    [anon_sym_QMARK] = ACTIONS(912),
    [anon_sym_QMARK_DOT] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(912),
    [anon_sym_AMP_AMP] = ACTIONS(910),
    [anon_sym_PIPE_PIPE] = ACTIONS(910),
    [anon_sym_GT_GT] = ACTIONS(912),
    [anon_sym_GT_GT_GT] = ACTIONS(910),
    [anon_sym_LT_LT] = ACTIONS(910),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(910),
    [anon_sym_PIPE] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_SLASH] = ACTIONS(912),
    [anon_sym_PERCENT] = ACTIONS(910),
    [anon_sym_STAR_STAR] = ACTIONS(910),
    [anon_sym_LT] = ACTIONS(912),
    [anon_sym_LT_EQ] = ACTIONS(910),
    [anon_sym_EQ_EQ] = ACTIONS(912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(910),
    [anon_sym_BANG_EQ] = ACTIONS(912),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(910),
    [anon_sym_GT_EQ] = ACTIONS(910),
    [anon_sym_GT] = ACTIONS(912),
    [anon_sym_QMARK_QMARK] = ACTIONS(910),
    [anon_sym_instanceof] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(912),
    [anon_sym_delete] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(910),
    [anon_sym_DQUOTE] = ACTIONS(910),
    [anon_sym_SQUOTE] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(910),
    [sym_number] = ACTIONS(910),
    [sym_this] = ACTIONS(912),
    [sym_super] = ACTIONS(912),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [sym_null] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(912),
    [anon_sym_public] = ACTIONS(912),
    [anon_sym_private] = ACTIONS(912),
    [anon_sym_protected] = ACTIONS(912),
    [anon_sym_any] = ACTIONS(912),
    [anon_sym_number] = ACTIONS(912),
    [anon_sym_boolean] = ACTIONS(912),
    [anon_sym_string] = ACTIONS(912),
    [anon_sym_symbol] = ACTIONS(912),
    [sym_readonly] = ACTIONS(912),
    [sym__automatic_semicolon] = ACTIONS(910),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(918),
    [sym_identifier] = ACTIONS(920),
    [anon_sym_export] = ACTIONS(920),
    [anon_sym_STAR] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(920),
    [anon_sym_EQ] = ACTIONS(922),
    [anon_sym_as] = ACTIONS(922),
    [anon_sym_namespace] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(918),
    [anon_sym_COMMA] = ACTIONS(924),
    [anon_sym_RBRACE] = ACTIONS(918),
    [anon_sym_typeof] = ACTIONS(920),
    [anon_sym_type] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(920),
    [anon_sym_declare] = ACTIONS(920),
    [anon_sym_module] = ACTIONS(920),
    [anon_sym_DOT] = ACTIONS(922),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_const] = ACTIONS(920),
    [anon_sym_enum] = ACTIONS(920),
    [anon_sym_var] = ACTIONS(920),
    [anon_sym_let] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_switch] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_in] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(920),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_with] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_debugger] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_throw] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(918),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(920),
    [anon_sym_abstract] = ACTIONS(920),
    [anon_sym_get] = ACTIONS(920),
    [anon_sym_set] = ACTIONS(920),
    [anon_sym_QMARK] = ACTIONS(922),
    [anon_sym_QMARK_DOT] = ACTIONS(924),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_AMP_AMP] = ACTIONS(924),
    [anon_sym_PIPE_PIPE] = ACTIONS(924),
    [anon_sym_GT_GT] = ACTIONS(922),
    [anon_sym_GT_GT_GT] = ACTIONS(924),
    [anon_sym_LT_LT] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(922),
    [anon_sym_CARET] = ACTIONS(924),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_SLASH] = ACTIONS(920),
    [anon_sym_PERCENT] = ACTIONS(924),
    [anon_sym_STAR_STAR] = ACTIONS(924),
    [anon_sym_LT] = ACTIONS(920),
    [anon_sym_LT_EQ] = ACTIONS(924),
    [anon_sym_EQ_EQ] = ACTIONS(922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(924),
    [anon_sym_BANG_EQ] = ACTIONS(922),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(924),
    [anon_sym_GT_EQ] = ACTIONS(924),
    [anon_sym_GT] = ACTIONS(922),
    [anon_sym_QMARK_QMARK] = ACTIONS(924),
    [anon_sym_instanceof] = ACTIONS(922),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(920),
    [anon_sym_delete] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(918),
    [anon_sym_DQUOTE] = ACTIONS(918),
    [anon_sym_SQUOTE] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(918),
    [sym_number] = ACTIONS(918),
    [sym_this] = ACTIONS(920),
    [sym_super] = ACTIONS(920),
    [sym_true] = ACTIONS(920),
    [sym_false] = ACTIONS(920),
    [sym_null] = ACTIONS(920),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(920),
    [anon_sym_public] = ACTIONS(920),
    [anon_sym_private] = ACTIONS(920),
    [anon_sym_protected] = ACTIONS(920),
    [anon_sym_any] = ACTIONS(920),
    [anon_sym_number] = ACTIONS(920),
    [anon_sym_boolean] = ACTIONS(920),
    [anon_sym_string] = ACTIONS(920),
    [anon_sym_symbol] = ACTIONS(920),
    [sym_readonly] = ACTIONS(920),
    [sym__automatic_semicolon] = ACTIONS(926),
  },
  [69] = {
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(930),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(724),
    [anon_sym_COLON] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(934),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(936),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_number] = ACTIONS(750),
    [anon_sym_boolean] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_symbol] = ACTIONS(750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(938),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(940),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_export] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_as] = ACTIONS(942),
    [anon_sym_namespace] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_COMMA] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_typeof] = ACTIONS(942),
    [anon_sym_type] = ACTIONS(942),
    [anon_sym_interface] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(942),
    [anon_sym_DOT] = ACTIONS(942),
    [anon_sym_import] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_var] = ACTIONS(942),
    [anon_sym_let] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_await] = ACTIONS(942),
    [anon_sym_in] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_try] = ACTIONS(942),
    [anon_sym_with] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_debugger] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_throw] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_class] = ACTIONS(942),
    [anon_sym_async] = ACTIONS(942),
    [anon_sym_function] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_QMARK] = ACTIONS(942),
    [anon_sym_QMARK_DOT] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_AMP_AMP] = ACTIONS(940),
    [anon_sym_PIPE_PIPE] = ACTIONS(940),
    [anon_sym_GT_GT] = ACTIONS(942),
    [anon_sym_GT_GT_GT] = ACTIONS(940),
    [anon_sym_LT_LT] = ACTIONS(940),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_CARET] = ACTIONS(940),
    [anon_sym_PIPE] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(942),
    [anon_sym_PERCENT] = ACTIONS(940),
    [anon_sym_STAR_STAR] = ACTIONS(940),
    [anon_sym_LT] = ACTIONS(942),
    [anon_sym_LT_EQ] = ACTIONS(940),
    [anon_sym_EQ_EQ] = ACTIONS(942),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(940),
    [anon_sym_BANG_EQ] = ACTIONS(942),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(940),
    [anon_sym_GT_EQ] = ACTIONS(940),
    [anon_sym_GT] = ACTIONS(942),
    [anon_sym_QMARK_QMARK] = ACTIONS(940),
    [anon_sym_instanceof] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_delete] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(940),
    [anon_sym_SQUOTE] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(940),
    [sym_number] = ACTIONS(940),
    [sym_this] = ACTIONS(942),
    [sym_super] = ACTIONS(942),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_null] = ACTIONS(942),
    [anon_sym_AT] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [sym_readonly] = ACTIONS(942),
    [sym__automatic_semicolon] = ACTIONS(940),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(944),
    [sym_identifier] = ACTIONS(946),
    [anon_sym_export] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_as] = ACTIONS(946),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_COMMA] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_typeof] = ACTIONS(946),
    [anon_sym_type] = ACTIONS(946),
    [anon_sym_interface] = ACTIONS(946),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_DOT] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_var] = ACTIONS(946),
    [anon_sym_let] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_await] = ACTIONS(946),
    [anon_sym_in] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_try] = ACTIONS(946),
    [anon_sym_with] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_debugger] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_throw] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(944),
    [anon_sym_class] = ACTIONS(946),
    [anon_sym_async] = ACTIONS(946),
    [anon_sym_function] = ACTIONS(946),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_get] = ACTIONS(946),
    [anon_sym_set] = ACTIONS(946),
    [anon_sym_QMARK] = ACTIONS(946),
    [anon_sym_QMARK_DOT] = ACTIONS(944),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_GT_GT] = ACTIONS(946),
    [anon_sym_GT_GT_GT] = ACTIONS(944),
    [anon_sym_LT_LT] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(946),
    [anon_sym_CARET] = ACTIONS(944),
    [anon_sym_PIPE] = ACTIONS(946),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_SLASH] = ACTIONS(946),
    [anon_sym_PERCENT] = ACTIONS(944),
    [anon_sym_STAR_STAR] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(946),
    [anon_sym_LT_EQ] = ACTIONS(944),
    [anon_sym_EQ_EQ] = ACTIONS(946),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(944),
    [anon_sym_BANG_EQ] = ACTIONS(946),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(944),
    [anon_sym_GT_EQ] = ACTIONS(944),
    [anon_sym_GT] = ACTIONS(946),
    [anon_sym_QMARK_QMARK] = ACTIONS(944),
    [anon_sym_instanceof] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_void] = ACTIONS(946),
    [anon_sym_delete] = ACTIONS(946),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(944),
    [anon_sym_SQUOTE] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(944),
    [sym_number] = ACTIONS(944),
    [sym_this] = ACTIONS(946),
    [sym_super] = ACTIONS(946),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_null] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym_protected] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(946),
    [anon_sym_number] = ACTIONS(946),
    [anon_sym_boolean] = ACTIONS(946),
    [anon_sym_string] = ACTIONS(946),
    [anon_sym_symbol] = ACTIONS(946),
    [sym_readonly] = ACTIONS(946),
    [sym__automatic_semicolon] = ACTIONS(944),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(948),
    [sym_identifier] = ACTIONS(950),
    [anon_sym_export] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_as] = ACTIONS(952),
    [anon_sym_namespace] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_COMMA] = ACTIONS(954),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_typeof] = ACTIONS(950),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(950),
    [anon_sym_module] = ACTIONS(950),
    [anon_sym_DOT] = ACTIONS(952),
    [anon_sym_import] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_var] = ACTIONS(950),
    [anon_sym_let] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_await] = ACTIONS(950),
    [anon_sym_in] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_try] = ACTIONS(950),
    [anon_sym_with] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_debugger] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_throw] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_class] = ACTIONS(950),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(950),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_get] = ACTIONS(950),
    [anon_sym_set] = ACTIONS(950),
    [anon_sym_QMARK] = ACTIONS(952),
    [anon_sym_QMARK_DOT] = ACTIONS(954),
    [anon_sym_new] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [anon_sym_GT_GT] = ACTIONS(952),
    [anon_sym_GT_GT_GT] = ACTIONS(954),
    [anon_sym_LT_LT] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_CARET] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_SLASH] = ACTIONS(950),
    [anon_sym_PERCENT] = ACTIONS(954),
    [anon_sym_STAR_STAR] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(950),
    [anon_sym_LT_EQ] = ACTIONS(954),
    [anon_sym_EQ_EQ] = ACTIONS(952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(954),
    [anon_sym_BANG_EQ] = ACTIONS(952),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(954),
    [anon_sym_GT_EQ] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_QMARK_QMARK] = ACTIONS(954),
    [anon_sym_instanceof] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_void] = ACTIONS(950),
    [anon_sym_delete] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_DQUOTE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [sym_number] = ACTIONS(948),
    [sym_this] = ACTIONS(950),
    [sym_super] = ACTIONS(950),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(950),
    [anon_sym_AT] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_any] = ACTIONS(950),
    [anon_sym_number] = ACTIONS(950),
    [anon_sym_boolean] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_symbol] = ACTIONS(950),
    [sym_readonly] = ACTIONS(950),
    [sym__automatic_semicolon] = ACTIONS(956),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(958),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_as] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_COMMA] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_typeof] = ACTIONS(960),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_interface] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(960),
    [anon_sym_import] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_var] = ACTIONS(960),
    [anon_sym_let] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(960),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(958),
    [anon_sym_await] = ACTIONS(960),
    [anon_sym_in] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_try] = ACTIONS(960),
    [anon_sym_with] = ACTIONS(960),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_debugger] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_throw] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_yield] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(958),
    [anon_sym_class] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(960),
    [anon_sym_get] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(960),
    [anon_sym_QMARK_DOT] = ACTIONS(958),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(958),
    [anon_sym_PIPE_PIPE] = ACTIONS(958),
    [anon_sym_GT_GT] = ACTIONS(960),
    [anon_sym_GT_GT_GT] = ACTIONS(958),
    [anon_sym_LT_LT] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(960),
    [anon_sym_CARET] = ACTIONS(958),
    [anon_sym_PIPE] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_SLASH] = ACTIONS(960),
    [anon_sym_PERCENT] = ACTIONS(958),
    [anon_sym_STAR_STAR] = ACTIONS(958),
    [anon_sym_LT] = ACTIONS(960),
    [anon_sym_LT_EQ] = ACTIONS(958),
    [anon_sym_EQ_EQ] = ACTIONS(960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(958),
    [anon_sym_BANG_EQ] = ACTIONS(960),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(958),
    [anon_sym_GT_EQ] = ACTIONS(958),
    [anon_sym_GT] = ACTIONS(960),
    [anon_sym_QMARK_QMARK] = ACTIONS(958),
    [anon_sym_instanceof] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_delete] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [sym_number] = ACTIONS(958),
    [sym_this] = ACTIONS(960),
    [sym_super] = ACTIONS(960),
    [sym_true] = ACTIONS(960),
    [sym_false] = ACTIONS(960),
    [sym_null] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [sym_readonly] = ACTIONS(960),
    [sym__automatic_semicolon] = ACTIONS(958),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_export] = ACTIONS(964),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(964),
    [anon_sym_namespace] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(964),
    [anon_sym_type] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(964),
    [anon_sym_declare] = ACTIONS(964),
    [anon_sym_module] = ACTIONS(964),
    [anon_sym_DOT] = ACTIONS(964),
    [anon_sym_import] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_var] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(964),
    [anon_sym_in] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_try] = ACTIONS(964),
    [anon_sym_with] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_debugger] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_throw] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_yield] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(964),
    [anon_sym_async] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(964),
    [anon_sym_get] = ACTIONS(964),
    [anon_sym_set] = ACTIONS(964),
    [anon_sym_QMARK] = ACTIONS(964),
    [anon_sym_QMARK_DOT] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(964),
    [anon_sym_GT_GT_GT] = ACTIONS(962),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(964),
    [anon_sym_CARET] = ACTIONS(962),
    [anon_sym_PIPE] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_SLASH] = ACTIONS(964),
    [anon_sym_PERCENT] = ACTIONS(962),
    [anon_sym_STAR_STAR] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(964),
    [anon_sym_LT_EQ] = ACTIONS(962),
    [anon_sym_EQ_EQ] = ACTIONS(964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(962),
    [anon_sym_BANG_EQ] = ACTIONS(964),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(962),
    [anon_sym_GT_EQ] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(964),
    [anon_sym_QMARK_QMARK] = ACTIONS(962),
    [anon_sym_instanceof] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(964),
    [anon_sym_delete] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_number] = ACTIONS(962),
    [sym_this] = ACTIONS(964),
    [sym_super] = ACTIONS(964),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_public] = ACTIONS(964),
    [anon_sym_private] = ACTIONS(964),
    [anon_sym_protected] = ACTIONS(964),
    [anon_sym_any] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_boolean] = ACTIONS(964),
    [anon_sym_string] = ACTIONS(964),
    [anon_sym_symbol] = ACTIONS(964),
    [sym_readonly] = ACTIONS(964),
    [sym__automatic_semicolon] = ACTIONS(962),
  },
  [75] = {
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(936),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_number] = ACTIONS(750),
    [anon_sym_boolean] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_symbol] = ACTIONS(750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(938),
    [anon_sym_keyof] = ACTIONS(502),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(976),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(978),
    [anon_sym_as] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_COMMA] = ACTIONS(982),
    [anon_sym_RBRACE] = ACTIONS(976),
    [anon_sym_typeof] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_interface] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_DOT] = ACTIONS(980),
    [anon_sym_import] = ACTIONS(978),
    [anon_sym_const] = ACTIONS(978),
    [anon_sym_enum] = ACTIONS(978),
    [anon_sym_var] = ACTIONS(978),
    [anon_sym_let] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_else] = ACTIONS(978),
    [anon_sym_if] = ACTIONS(978),
    [anon_sym_switch] = ACTIONS(978),
    [anon_sym_for] = ACTIONS(978),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_await] = ACTIONS(978),
    [anon_sym_in] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(978),
    [anon_sym_do] = ACTIONS(978),
    [anon_sym_try] = ACTIONS(978),
    [anon_sym_with] = ACTIONS(978),
    [anon_sym_break] = ACTIONS(978),
    [anon_sym_continue] = ACTIONS(978),
    [anon_sym_debugger] = ACTIONS(978),
    [anon_sym_return] = ACTIONS(978),
    [anon_sym_throw] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(978),
    [anon_sym_LBRACK] = ACTIONS(976),
    [anon_sym_class] = ACTIONS(978),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(978),
    [anon_sym_abstract] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_QMARK] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(982),
    [anon_sym_new] = ACTIONS(978),
    [anon_sym_AMP_AMP] = ACTIONS(982),
    [anon_sym_PIPE_PIPE] = ACTIONS(982),
    [anon_sym_GT_GT] = ACTIONS(980),
    [anon_sym_GT_GT_GT] = ACTIONS(982),
    [anon_sym_LT_LT] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(980),
    [anon_sym_CARET] = ACTIONS(982),
    [anon_sym_PIPE] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(978),
    [anon_sym_SLASH] = ACTIONS(978),
    [anon_sym_PERCENT] = ACTIONS(982),
    [anon_sym_STAR_STAR] = ACTIONS(982),
    [anon_sym_LT] = ACTIONS(978),
    [anon_sym_LT_EQ] = ACTIONS(982),
    [anon_sym_EQ_EQ] = ACTIONS(980),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(982),
    [anon_sym_BANG_EQ] = ACTIONS(980),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(982),
    [anon_sym_GT_EQ] = ACTIONS(982),
    [anon_sym_GT] = ACTIONS(980),
    [anon_sym_QMARK_QMARK] = ACTIONS(982),
    [anon_sym_instanceof] = ACTIONS(980),
    [anon_sym_TILDE] = ACTIONS(976),
    [anon_sym_void] = ACTIONS(978),
    [anon_sym_delete] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(976),
    [anon_sym_DQUOTE] = ACTIONS(976),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(976),
    [sym_this] = ACTIONS(978),
    [sym_super] = ACTIONS(978),
    [sym_true] = ACTIONS(978),
    [sym_false] = ACTIONS(978),
    [sym_null] = ACTIONS(978),
    [anon_sym_AT] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [sym_readonly] = ACTIONS(978),
    [sym__automatic_semicolon] = ACTIONS(984),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(988),
    [anon_sym_export] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_as] = ACTIONS(990),
    [anon_sym_namespace] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(992),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_typeof] = ACTIONS(988),
    [anon_sym_type] = ACTIONS(988),
    [anon_sym_interface] = ACTIONS(988),
    [anon_sym_declare] = ACTIONS(988),
    [anon_sym_module] = ACTIONS(988),
    [anon_sym_DOT] = ACTIONS(990),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_var] = ACTIONS(988),
    [anon_sym_let] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_await] = ACTIONS(988),
    [anon_sym_in] = ACTIONS(990),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_try] = ACTIONS(988),
    [anon_sym_with] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_debugger] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_throw] = ACTIONS(988),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_yield] = ACTIONS(988),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_class] = ACTIONS(988),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(988),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_get] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(988),
    [anon_sym_QMARK] = ACTIONS(990),
    [anon_sym_QMARK_DOT] = ACTIONS(992),
    [anon_sym_new] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(992),
    [anon_sym_PIPE_PIPE] = ACTIONS(992),
    [anon_sym_GT_GT] = ACTIONS(990),
    [anon_sym_GT_GT_GT] = ACTIONS(992),
    [anon_sym_LT_LT] = ACTIONS(992),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_CARET] = ACTIONS(992),
    [anon_sym_PIPE] = ACTIONS(990),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_SLASH] = ACTIONS(988),
    [anon_sym_PERCENT] = ACTIONS(992),
    [anon_sym_STAR_STAR] = ACTIONS(992),
    [anon_sym_LT] = ACTIONS(988),
    [anon_sym_LT_EQ] = ACTIONS(992),
    [anon_sym_EQ_EQ] = ACTIONS(990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(992),
    [anon_sym_BANG_EQ] = ACTIONS(990),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(992),
    [anon_sym_GT_EQ] = ACTIONS(992),
    [anon_sym_GT] = ACTIONS(990),
    [anon_sym_QMARK_QMARK] = ACTIONS(992),
    [anon_sym_instanceof] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(988),
    [anon_sym_delete] = ACTIONS(988),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(986),
    [sym_number] = ACTIONS(986),
    [sym_this] = ACTIONS(988),
    [sym_super] = ACTIONS(988),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [anon_sym_AT] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_public] = ACTIONS(988),
    [anon_sym_private] = ACTIONS(988),
    [anon_sym_protected] = ACTIONS(988),
    [anon_sym_any] = ACTIONS(988),
    [anon_sym_number] = ACTIONS(988),
    [anon_sym_boolean] = ACTIONS(988),
    [anon_sym_string] = ACTIONS(988),
    [anon_sym_symbol] = ACTIONS(988),
    [sym_readonly] = ACTIONS(988),
    [sym__automatic_semicolon] = ACTIONS(994),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(996),
    [sym_identifier] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_default] = ACTIONS(998),
    [anon_sym_as] = ACTIONS(998),
    [anon_sym_namespace] = ACTIONS(998),
    [anon_sym_LBRACE] = ACTIONS(996),
    [anon_sym_COMMA] = ACTIONS(996),
    [anon_sym_RBRACE] = ACTIONS(996),
    [anon_sym_typeof] = ACTIONS(998),
    [anon_sym_type] = ACTIONS(998),
    [anon_sym_interface] = ACTIONS(998),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_module] = ACTIONS(998),
    [anon_sym_DOT] = ACTIONS(998),
    [anon_sym_import] = ACTIONS(998),
    [anon_sym_const] = ACTIONS(998),
    [anon_sym_enum] = ACTIONS(998),
    [anon_sym_var] = ACTIONS(998),
    [anon_sym_let] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_else] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_switch] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_in] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_do] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_debugger] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_throw] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(996),
    [anon_sym_class] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(998),
    [anon_sym_abstract] = ACTIONS(998),
    [anon_sym_get] = ACTIONS(998),
    [anon_sym_set] = ACTIONS(998),
    [anon_sym_QMARK] = ACTIONS(998),
    [anon_sym_QMARK_DOT] = ACTIONS(996),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_AMP_AMP] = ACTIONS(996),
    [anon_sym_PIPE_PIPE] = ACTIONS(996),
    [anon_sym_GT_GT] = ACTIONS(998),
    [anon_sym_GT_GT_GT] = ACTIONS(996),
    [anon_sym_LT_LT] = ACTIONS(996),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_CARET] = ACTIONS(996),
    [anon_sym_PIPE] = ACTIONS(998),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(998),
    [anon_sym_SLASH] = ACTIONS(998),
    [anon_sym_PERCENT] = ACTIONS(996),
    [anon_sym_STAR_STAR] = ACTIONS(996),
    [anon_sym_LT] = ACTIONS(998),
    [anon_sym_LT_EQ] = ACTIONS(996),
    [anon_sym_EQ_EQ] = ACTIONS(998),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(996),
    [anon_sym_BANG_EQ] = ACTIONS(998),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(996),
    [anon_sym_GT_EQ] = ACTIONS(996),
    [anon_sym_GT] = ACTIONS(998),
    [anon_sym_QMARK_QMARK] = ACTIONS(996),
    [anon_sym_instanceof] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(998),
    [anon_sym_delete] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(996),
    [anon_sym_DQUOTE] = ACTIONS(996),
    [anon_sym_SQUOTE] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(996),
    [sym_number] = ACTIONS(996),
    [sym_this] = ACTIONS(998),
    [sym_super] = ACTIONS(998),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(996),
    [anon_sym_static] = ACTIONS(998),
    [anon_sym_public] = ACTIONS(998),
    [anon_sym_private] = ACTIONS(998),
    [anon_sym_protected] = ACTIONS(998),
    [anon_sym_any] = ACTIONS(998),
    [anon_sym_number] = ACTIONS(998),
    [anon_sym_boolean] = ACTIONS(998),
    [anon_sym_string] = ACTIONS(998),
    [anon_sym_symbol] = ACTIONS(998),
    [sym_readonly] = ACTIONS(998),
    [sym__automatic_semicolon] = ACTIONS(996),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(1000),
    [sym_identifier] = ACTIONS(1002),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_as] = ACTIONS(1004),
    [anon_sym_namespace] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_COMMA] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [anon_sym_typeof] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_interface] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_DOT] = ACTIONS(1004),
    [anon_sym_import] = ACTIONS(1002),
    [anon_sym_const] = ACTIONS(1002),
    [anon_sym_enum] = ACTIONS(1002),
    [anon_sym_var] = ACTIONS(1002),
    [anon_sym_let] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_await] = ACTIONS(1002),
    [anon_sym_in] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_do] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_with] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_debugger] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_throw] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_yield] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1000),
    [anon_sym_class] = ACTIONS(1002),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(1002),
    [anon_sym_abstract] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_QMARK] = ACTIONS(1004),
    [anon_sym_QMARK_DOT] = ACTIONS(1006),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(1006),
    [anon_sym_PIPE_PIPE] = ACTIONS(1006),
    [anon_sym_GT_GT] = ACTIONS(1004),
    [anon_sym_GT_GT_GT] = ACTIONS(1006),
    [anon_sym_LT_LT] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1004),
    [anon_sym_CARET] = ACTIONS(1006),
    [anon_sym_PIPE] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1002),
    [anon_sym_SLASH] = ACTIONS(1002),
    [anon_sym_PERCENT] = ACTIONS(1006),
    [anon_sym_STAR_STAR] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(1002),
    [anon_sym_LT_EQ] = ACTIONS(1006),
    [anon_sym_EQ_EQ] = ACTIONS(1004),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1006),
    [anon_sym_BANG_EQ] = ACTIONS(1004),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1006),
    [anon_sym_GT_EQ] = ACTIONS(1006),
    [anon_sym_GT] = ACTIONS(1004),
    [anon_sym_QMARK_QMARK] = ACTIONS(1006),
    [anon_sym_instanceof] = ACTIONS(1004),
    [anon_sym_TILDE] = ACTIONS(1000),
    [anon_sym_void] = ACTIONS(1002),
    [anon_sym_delete] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [anon_sym_SQUOTE] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [sym_number] = ACTIONS(1000),
    [sym_this] = ACTIONS(1002),
    [sym_super] = ACTIONS(1002),
    [sym_true] = ACTIONS(1002),
    [sym_false] = ACTIONS(1002),
    [sym_null] = ACTIONS(1002),
    [anon_sym_AT] = ACTIONS(1000),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
    [sym_readonly] = ACTIONS(1002),
    [sym__automatic_semicolon] = ACTIONS(1008),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(1010),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_as] = ACTIONS(1014),
    [anon_sym_namespace] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_COMMA] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_interface] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_DOT] = ACTIONS(1014),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_var] = ACTIONS(1012),
    [anon_sym_let] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_await] = ACTIONS(1012),
    [anon_sym_in] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_try] = ACTIONS(1012),
    [anon_sym_with] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_debugger] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_throw] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [anon_sym_class] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_function] = ACTIONS(1012),
    [anon_sym_abstract] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(1014),
    [anon_sym_QMARK_DOT] = ACTIONS(1016),
    [anon_sym_new] = ACTIONS(1012),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1014),
    [anon_sym_GT_GT_GT] = ACTIONS(1016),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_CARET] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1014),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1012),
    [anon_sym_PERCENT] = ACTIONS(1016),
    [anon_sym_STAR_STAR] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1012),
    [anon_sym_LT_EQ] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1014),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1016),
    [anon_sym_BANG_EQ] = ACTIONS(1014),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1016),
    [anon_sym_GT_EQ] = ACTIONS(1016),
    [anon_sym_GT] = ACTIONS(1014),
    [anon_sym_QMARK_QMARK] = ACTIONS(1016),
    [anon_sym_instanceof] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [sym_number] = ACTIONS(1010),
    [sym_this] = ACTIONS(1012),
    [sym_super] = ACTIONS(1012),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [sym__automatic_semicolon] = ACTIONS(1018),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(1020),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_STAR] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1022),
    [anon_sym_as] = ACTIONS(1024),
    [anon_sym_namespace] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_COMMA] = ACTIONS(1026),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_typeof] = ACTIONS(1022),
    [anon_sym_type] = ACTIONS(1022),
    [anon_sym_interface] = ACTIONS(1022),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_module] = ACTIONS(1022),
    [anon_sym_DOT] = ACTIONS(1024),
    [anon_sym_import] = ACTIONS(1022),
    [anon_sym_const] = ACTIONS(1022),
    [anon_sym_enum] = ACTIONS(1022),
    [anon_sym_var] = ACTIONS(1022),
    [anon_sym_let] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_else] = ACTIONS(1022),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_switch] = ACTIONS(1022),
    [anon_sym_for] = ACTIONS(1022),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_await] = ACTIONS(1022),
    [anon_sym_in] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1022),
    [anon_sym_do] = ACTIONS(1022),
    [anon_sym_try] = ACTIONS(1022),
    [anon_sym_with] = ACTIONS(1022),
    [anon_sym_break] = ACTIONS(1022),
    [anon_sym_continue] = ACTIONS(1022),
    [anon_sym_debugger] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1022),
    [anon_sym_throw] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1022),
    [anon_sym_yield] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_class] = ACTIONS(1022),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(1022),
    [anon_sym_abstract] = ACTIONS(1022),
    [anon_sym_get] = ACTIONS(1022),
    [anon_sym_set] = ACTIONS(1022),
    [anon_sym_QMARK] = ACTIONS(1024),
    [anon_sym_QMARK_DOT] = ACTIONS(1026),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_AMP_AMP] = ACTIONS(1026),
    [anon_sym_PIPE_PIPE] = ACTIONS(1026),
    [anon_sym_GT_GT] = ACTIONS(1024),
    [anon_sym_GT_GT_GT] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1024),
    [anon_sym_CARET] = ACTIONS(1026),
    [anon_sym_PIPE] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PERCENT] = ACTIONS(1026),
    [anon_sym_STAR_STAR] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1026),
    [anon_sym_EQ_EQ] = ACTIONS(1024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1026),
    [anon_sym_BANG_EQ] = ACTIONS(1024),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1026),
    [anon_sym_GT] = ACTIONS(1024),
    [anon_sym_QMARK_QMARK] = ACTIONS(1026),
    [anon_sym_instanceof] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1022),
    [anon_sym_delete] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1020),
    [sym_number] = ACTIONS(1020),
    [sym_this] = ACTIONS(1022),
    [sym_super] = ACTIONS(1022),
    [sym_true] = ACTIONS(1022),
    [sym_false] = ACTIONS(1022),
    [sym_null] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_static] = ACTIONS(1022),
    [anon_sym_public] = ACTIONS(1022),
    [anon_sym_private] = ACTIONS(1022),
    [anon_sym_protected] = ACTIONS(1022),
    [anon_sym_any] = ACTIONS(1022),
    [anon_sym_number] = ACTIONS(1022),
    [anon_sym_boolean] = ACTIONS(1022),
    [anon_sym_string] = ACTIONS(1022),
    [anon_sym_symbol] = ACTIONS(1022),
    [sym_readonly] = ACTIONS(1022),
    [sym__automatic_semicolon] = ACTIONS(1028),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(1030),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_as] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1036),
    [anon_sym_RBRACE] = ACTIONS(1030),
    [anon_sym_typeof] = ACTIONS(1032),
    [anon_sym_type] = ACTIONS(1032),
    [anon_sym_interface] = ACTIONS(1032),
    [anon_sym_declare] = ACTIONS(1032),
    [anon_sym_module] = ACTIONS(1032),
    [anon_sym_DOT] = ACTIONS(1034),
    [anon_sym_import] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_var] = ACTIONS(1032),
    [anon_sym_let] = ACTIONS(1032),
    [anon_sym_BANG] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_await] = ACTIONS(1032),
    [anon_sym_in] = ACTIONS(1034),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_try] = ACTIONS(1032),
    [anon_sym_with] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_debugger] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_throw] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_yield] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(1030),
    [anon_sym_class] = ACTIONS(1032),
    [anon_sym_async] = ACTIONS(1032),
    [anon_sym_function] = ACTIONS(1032),
    [anon_sym_abstract] = ACTIONS(1032),
    [anon_sym_get] = ACTIONS(1032),
    [anon_sym_set] = ACTIONS(1032),
    [anon_sym_QMARK] = ACTIONS(1034),
    [anon_sym_QMARK_DOT] = ACTIONS(1036),
    [anon_sym_new] = ACTIONS(1032),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_GT_GT] = ACTIONS(1034),
    [anon_sym_GT_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1036),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_CARET] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1034),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(1032),
    [anon_sym_PERCENT] = ACTIONS(1036),
    [anon_sym_STAR_STAR] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_LT_EQ] = ACTIONS(1036),
    [anon_sym_EQ_EQ] = ACTIONS(1034),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1036),
    [anon_sym_BANG_EQ] = ACTIONS(1034),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1036),
    [anon_sym_GT_EQ] = ACTIONS(1036),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_QMARK_QMARK] = ACTIONS(1036),
    [anon_sym_instanceof] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_void] = ACTIONS(1032),
    [anon_sym_delete] = ACTIONS(1032),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [sym_number] = ACTIONS(1030),
    [sym_this] = ACTIONS(1032),
    [sym_super] = ACTIONS(1032),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [anon_sym_AT] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_public] = ACTIONS(1032),
    [anon_sym_private] = ACTIONS(1032),
    [anon_sym_protected] = ACTIONS(1032),
    [anon_sym_any] = ACTIONS(1032),
    [anon_sym_number] = ACTIONS(1032),
    [anon_sym_boolean] = ACTIONS(1032),
    [anon_sym_string] = ACTIONS(1032),
    [anon_sym_symbol] = ACTIONS(1032),
    [sym_readonly] = ACTIONS(1032),
    [sym__automatic_semicolon] = ACTIONS(1038),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1042),
    [anon_sym_as] = ACTIONS(1044),
    [anon_sym_namespace] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_COMMA] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1040),
    [anon_sym_typeof] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_interface] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_DOT] = ACTIONS(1044),
    [anon_sym_import] = ACTIONS(1042),
    [anon_sym_const] = ACTIONS(1042),
    [anon_sym_enum] = ACTIONS(1042),
    [anon_sym_var] = ACTIONS(1042),
    [anon_sym_let] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_else] = ACTIONS(1042),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_switch] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1042),
    [anon_sym_LPAREN] = ACTIONS(1040),
    [anon_sym_await] = ACTIONS(1042),
    [anon_sym_in] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1042),
    [anon_sym_do] = ACTIONS(1042),
    [anon_sym_try] = ACTIONS(1042),
    [anon_sym_with] = ACTIONS(1042),
    [anon_sym_break] = ACTIONS(1042),
    [anon_sym_continue] = ACTIONS(1042),
    [anon_sym_debugger] = ACTIONS(1042),
    [anon_sym_return] = ACTIONS(1042),
    [anon_sym_throw] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1042),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(1042),
    [anon_sym_abstract] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_QMARK] = ACTIONS(1044),
    [anon_sym_QMARK_DOT] = ACTIONS(1046),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP_AMP] = ACTIONS(1046),
    [anon_sym_PIPE_PIPE] = ACTIONS(1046),
    [anon_sym_GT_GT] = ACTIONS(1044),
    [anon_sym_GT_GT_GT] = ACTIONS(1046),
    [anon_sym_LT_LT] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1044),
    [anon_sym_CARET] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PERCENT] = ACTIONS(1046),
    [anon_sym_STAR_STAR] = ACTIONS(1046),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1046),
    [anon_sym_EQ_EQ] = ACTIONS(1044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1046),
    [anon_sym_BANG_EQ] = ACTIONS(1044),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1046),
    [anon_sym_GT_EQ] = ACTIONS(1046),
    [anon_sym_GT] = ACTIONS(1044),
    [anon_sym_QMARK_QMARK] = ACTIONS(1046),
    [anon_sym_instanceof] = ACTIONS(1044),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_void] = ACTIONS(1042),
    [anon_sym_delete] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1040),
    [sym_number] = ACTIONS(1040),
    [sym_this] = ACTIONS(1042),
    [sym_super] = ACTIONS(1042),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [sym_readonly] = ACTIONS(1042),
    [sym__automatic_semicolon] = ACTIONS(1048),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_identifier] = ACTIONS(1052),
    [anon_sym_export] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_as] = ACTIONS(1052),
    [anon_sym_namespace] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_COMMA] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_typeof] = ACTIONS(1052),
    [anon_sym_type] = ACTIONS(1052),
    [anon_sym_interface] = ACTIONS(1052),
    [anon_sym_declare] = ACTIONS(1052),
    [anon_sym_module] = ACTIONS(1052),
    [anon_sym_DOT] = ACTIONS(1052),
    [anon_sym_import] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_var] = ACTIONS(1052),
    [anon_sym_let] = ACTIONS(1052),
    [anon_sym_BANG] = ACTIONS(1052),
    [anon_sym_else] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [anon_sym_await] = ACTIONS(1052),
    [anon_sym_in] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_try] = ACTIONS(1052),
    [anon_sym_with] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_debugger] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_throw] = ACTIONS(1052),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1050),
    [anon_sym_class] = ACTIONS(1052),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(1052),
    [anon_sym_abstract] = ACTIONS(1052),
    [anon_sym_get] = ACTIONS(1052),
    [anon_sym_set] = ACTIONS(1052),
    [anon_sym_QMARK] = ACTIONS(1052),
    [anon_sym_QMARK_DOT] = ACTIONS(1050),
    [anon_sym_new] = ACTIONS(1052),
    [anon_sym_AMP_AMP] = ACTIONS(1050),
    [anon_sym_PIPE_PIPE] = ACTIONS(1050),
    [anon_sym_GT_GT] = ACTIONS(1052),
    [anon_sym_GT_GT_GT] = ACTIONS(1050),
    [anon_sym_LT_LT] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1052),
    [anon_sym_CARET] = ACTIONS(1050),
    [anon_sym_PIPE] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_SLASH] = ACTIONS(1052),
    [anon_sym_PERCENT] = ACTIONS(1050),
    [anon_sym_STAR_STAR] = ACTIONS(1050),
    [anon_sym_LT] = ACTIONS(1052),
    [anon_sym_LT_EQ] = ACTIONS(1050),
    [anon_sym_EQ_EQ] = ACTIONS(1052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1050),
    [anon_sym_BANG_EQ] = ACTIONS(1052),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1050),
    [anon_sym_GT_EQ] = ACTIONS(1050),
    [anon_sym_GT] = ACTIONS(1052),
    [anon_sym_QMARK_QMARK] = ACTIONS(1050),
    [anon_sym_instanceof] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_void] = ACTIONS(1052),
    [anon_sym_delete] = ACTIONS(1052),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1050),
    [sym_number] = ACTIONS(1050),
    [sym_this] = ACTIONS(1052),
    [sym_super] = ACTIONS(1052),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_public] = ACTIONS(1052),
    [anon_sym_private] = ACTIONS(1052),
    [anon_sym_protected] = ACTIONS(1052),
    [anon_sym_any] = ACTIONS(1052),
    [anon_sym_number] = ACTIONS(1052),
    [anon_sym_boolean] = ACTIONS(1052),
    [anon_sym_string] = ACTIONS(1052),
    [anon_sym_symbol] = ACTIONS(1052),
    [sym_readonly] = ACTIONS(1052),
    [sym__automatic_semicolon] = ACTIONS(1050),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(1054),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_as] = ACTIONS(1058),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_COMMA] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [anon_sym_typeof] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_interface] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_DOT] = ACTIONS(1058),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_var] = ACTIONS(1056),
    [anon_sym_let] = ACTIONS(1056),
    [anon_sym_BANG] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1054),
    [anon_sym_await] = ACTIONS(1056),
    [anon_sym_in] = ACTIONS(1058),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_debugger] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_throw] = ACTIONS(1056),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(1056),
    [anon_sym_abstract] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_QMARK] = ACTIONS(1058),
    [anon_sym_QMARK_DOT] = ACTIONS(1060),
    [anon_sym_new] = ACTIONS(1056),
    [anon_sym_AMP_AMP] = ACTIONS(1060),
    [anon_sym_PIPE_PIPE] = ACTIONS(1060),
    [anon_sym_GT_GT] = ACTIONS(1058),
    [anon_sym_GT_GT_GT] = ACTIONS(1060),
    [anon_sym_LT_LT] = ACTIONS(1060),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_CARET] = ACTIONS(1060),
    [anon_sym_PIPE] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_SLASH] = ACTIONS(1056),
    [anon_sym_PERCENT] = ACTIONS(1060),
    [anon_sym_STAR_STAR] = ACTIONS(1060),
    [anon_sym_LT] = ACTIONS(1056),
    [anon_sym_LT_EQ] = ACTIONS(1060),
    [anon_sym_EQ_EQ] = ACTIONS(1058),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1060),
    [anon_sym_BANG_EQ] = ACTIONS(1058),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1060),
    [anon_sym_GT_EQ] = ACTIONS(1060),
    [anon_sym_GT] = ACTIONS(1058),
    [anon_sym_QMARK_QMARK] = ACTIONS(1060),
    [anon_sym_instanceof] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_void] = ACTIONS(1056),
    [anon_sym_delete] = ACTIONS(1056),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1054),
    [sym_number] = ACTIONS(1054),
    [sym_this] = ACTIONS(1056),
    [sym_super] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [anon_sym_AT] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [sym_readonly] = ACTIONS(1056),
    [sym__automatic_semicolon] = ACTIONS(1062),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(1064),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_export] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1066),
    [anon_sym_as] = ACTIONS(1068),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1064),
    [anon_sym_COMMA] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1064),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_type] = ACTIONS(1066),
    [anon_sym_interface] = ACTIONS(1066),
    [anon_sym_declare] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1066),
    [anon_sym_DOT] = ACTIONS(1068),
    [anon_sym_import] = ACTIONS(1066),
    [anon_sym_const] = ACTIONS(1066),
    [anon_sym_enum] = ACTIONS(1066),
    [anon_sym_var] = ACTIONS(1066),
    [anon_sym_let] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_else] = ACTIONS(1066),
    [anon_sym_if] = ACTIONS(1066),
    [anon_sym_switch] = ACTIONS(1066),
    [anon_sym_for] = ACTIONS(1066),
    [anon_sym_LPAREN] = ACTIONS(1064),
    [anon_sym_await] = ACTIONS(1066),
    [anon_sym_in] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1066),
    [anon_sym_do] = ACTIONS(1066),
    [anon_sym_try] = ACTIONS(1066),
    [anon_sym_with] = ACTIONS(1066),
    [anon_sym_break] = ACTIONS(1066),
    [anon_sym_continue] = ACTIONS(1066),
    [anon_sym_debugger] = ACTIONS(1066),
    [anon_sym_return] = ACTIONS(1066),
    [anon_sym_throw] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1066),
    [anon_sym_yield] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1066),
    [anon_sym_async] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1066),
    [anon_sym_abstract] = ACTIONS(1066),
    [anon_sym_get] = ACTIONS(1066),
    [anon_sym_set] = ACTIONS(1066),
    [anon_sym_QMARK] = ACTIONS(1068),
    [anon_sym_QMARK_DOT] = ACTIONS(1070),
    [anon_sym_new] = ACTIONS(1066),
    [anon_sym_AMP_AMP] = ACTIONS(1070),
    [anon_sym_PIPE_PIPE] = ACTIONS(1070),
    [anon_sym_GT_GT] = ACTIONS(1068),
    [anon_sym_GT_GT_GT] = ACTIONS(1070),
    [anon_sym_LT_LT] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1068),
    [anon_sym_CARET] = ACTIONS(1070),
    [anon_sym_PIPE] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_PERCENT] = ACTIONS(1070),
    [anon_sym_STAR_STAR] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(1066),
    [anon_sym_LT_EQ] = ACTIONS(1070),
    [anon_sym_EQ_EQ] = ACTIONS(1068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1070),
    [anon_sym_BANG_EQ] = ACTIONS(1068),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1070),
    [anon_sym_GT_EQ] = ACTIONS(1070),
    [anon_sym_GT] = ACTIONS(1068),
    [anon_sym_QMARK_QMARK] = ACTIONS(1070),
    [anon_sym_instanceof] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1064),
    [anon_sym_void] = ACTIONS(1066),
    [anon_sym_delete] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1064),
    [anon_sym_DQUOTE] = ACTIONS(1064),
    [anon_sym_SQUOTE] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [sym_number] = ACTIONS(1064),
    [sym_this] = ACTIONS(1066),
    [sym_super] = ACTIONS(1066),
    [sym_true] = ACTIONS(1066),
    [sym_false] = ACTIONS(1066),
    [sym_null] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1064),
    [anon_sym_static] = ACTIONS(1066),
    [anon_sym_public] = ACTIONS(1066),
    [anon_sym_private] = ACTIONS(1066),
    [anon_sym_protected] = ACTIONS(1066),
    [anon_sym_any] = ACTIONS(1066),
    [anon_sym_number] = ACTIONS(1066),
    [anon_sym_boolean] = ACTIONS(1066),
    [anon_sym_string] = ACTIONS(1066),
    [anon_sym_symbol] = ACTIONS(1066),
    [sym_readonly] = ACTIONS(1066),
    [sym__automatic_semicolon] = ACTIONS(1070),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1074),
    [anon_sym_as] = ACTIONS(1074),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1074),
    [anon_sym_type] = ACTIONS(1074),
    [anon_sym_interface] = ACTIONS(1074),
    [anon_sym_declare] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1074),
    [anon_sym_import] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_in] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_debugger] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_throw] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1074),
    [anon_sym_abstract] = ACTIONS(1074),
    [anon_sym_get] = ACTIONS(1074),
    [anon_sym_set] = ACTIONS(1074),
    [anon_sym_QMARK] = ACTIONS(1074),
    [anon_sym_QMARK_DOT] = ACTIONS(1072),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_GT_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_STAR_STAR] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1074),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1074),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_QMARK_QMARK] = ACTIONS(1072),
    [anon_sym_instanceof] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1074),
    [anon_sym_delete] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_number] = ACTIONS(1072),
    [sym_this] = ACTIONS(1074),
    [sym_super] = ACTIONS(1074),
    [sym_true] = ACTIONS(1074),
    [sym_false] = ACTIONS(1074),
    [sym_null] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(1074),
    [anon_sym_public] = ACTIONS(1074),
    [anon_sym_private] = ACTIONS(1074),
    [anon_sym_protected] = ACTIONS(1074),
    [anon_sym_any] = ACTIONS(1074),
    [anon_sym_number] = ACTIONS(1074),
    [anon_sym_boolean] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [anon_sym_symbol] = ACTIONS(1074),
    [sym_readonly] = ACTIONS(1074),
    [sym__automatic_semicolon] = ACTIONS(1072),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(1076),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1078),
    [anon_sym_as] = ACTIONS(1080),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_COMMA] = ACTIONS(1082),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_typeof] = ACTIONS(1078),
    [anon_sym_type] = ACTIONS(1078),
    [anon_sym_interface] = ACTIONS(1078),
    [anon_sym_declare] = ACTIONS(1078),
    [anon_sym_module] = ACTIONS(1078),
    [anon_sym_DOT] = ACTIONS(1080),
    [anon_sym_import] = ACTIONS(1078),
    [anon_sym_const] = ACTIONS(1078),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_await] = ACTIONS(1078),
    [anon_sym_in] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_do] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_debugger] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_throw] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1078),
    [anon_sym_yield] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_function] = ACTIONS(1078),
    [anon_sym_abstract] = ACTIONS(1078),
    [anon_sym_get] = ACTIONS(1078),
    [anon_sym_set] = ACTIONS(1078),
    [anon_sym_QMARK] = ACTIONS(1080),
    [anon_sym_QMARK_DOT] = ACTIONS(1082),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_AMP_AMP] = ACTIONS(1082),
    [anon_sym_PIPE_PIPE] = ACTIONS(1082),
    [anon_sym_GT_GT] = ACTIONS(1080),
    [anon_sym_GT_GT_GT] = ACTIONS(1082),
    [anon_sym_LT_LT] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1080),
    [anon_sym_CARET] = ACTIONS(1082),
    [anon_sym_PIPE] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1078),
    [anon_sym_SLASH] = ACTIONS(1078),
    [anon_sym_PERCENT] = ACTIONS(1082),
    [anon_sym_STAR_STAR] = ACTIONS(1082),
    [anon_sym_LT] = ACTIONS(1078),
    [anon_sym_LT_EQ] = ACTIONS(1082),
    [anon_sym_EQ_EQ] = ACTIONS(1080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1082),
    [anon_sym_BANG_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1082),
    [anon_sym_GT_EQ] = ACTIONS(1082),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_QMARK_QMARK] = ACTIONS(1082),
    [anon_sym_instanceof] = ACTIONS(1080),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1078),
    [anon_sym_delete] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1076),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(1076),
    [sym_this] = ACTIONS(1078),
    [sym_super] = ACTIONS(1078),
    [sym_true] = ACTIONS(1078),
    [sym_false] = ACTIONS(1078),
    [sym_null] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_static] = ACTIONS(1078),
    [anon_sym_public] = ACTIONS(1078),
    [anon_sym_private] = ACTIONS(1078),
    [anon_sym_protected] = ACTIONS(1078),
    [anon_sym_any] = ACTIONS(1078),
    [anon_sym_number] = ACTIONS(1078),
    [anon_sym_boolean] = ACTIONS(1078),
    [anon_sym_string] = ACTIONS(1078),
    [anon_sym_symbol] = ACTIONS(1078),
    [sym_readonly] = ACTIONS(1078),
    [sym__automatic_semicolon] = ACTIONS(1084),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_export] = ACTIONS(964),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_as] = ACTIONS(964),
    [anon_sym_namespace] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(964),
    [anon_sym_type] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(964),
    [anon_sym_declare] = ACTIONS(964),
    [anon_sym_module] = ACTIONS(964),
    [anon_sym_DOT] = ACTIONS(964),
    [anon_sym_import] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_var] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(964),
    [anon_sym_in] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_try] = ACTIONS(964),
    [anon_sym_with] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_debugger] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_throw] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_yield] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(964),
    [anon_sym_async] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(964),
    [anon_sym_get] = ACTIONS(964),
    [anon_sym_set] = ACTIONS(964),
    [anon_sym_QMARK] = ACTIONS(964),
    [anon_sym_QMARK_DOT] = ACTIONS(962),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(964),
    [anon_sym_GT_GT_GT] = ACTIONS(962),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(964),
    [anon_sym_CARET] = ACTIONS(962),
    [anon_sym_PIPE] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_SLASH] = ACTIONS(964),
    [anon_sym_PERCENT] = ACTIONS(962),
    [anon_sym_STAR_STAR] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(964),
    [anon_sym_LT_EQ] = ACTIONS(962),
    [anon_sym_EQ_EQ] = ACTIONS(964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(962),
    [anon_sym_BANG_EQ] = ACTIONS(964),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(962),
    [anon_sym_GT_EQ] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(964),
    [anon_sym_QMARK_QMARK] = ACTIONS(962),
    [anon_sym_instanceof] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(964),
    [anon_sym_delete] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_number] = ACTIONS(962),
    [sym_this] = ACTIONS(964),
    [sym_super] = ACTIONS(964),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_public] = ACTIONS(964),
    [anon_sym_private] = ACTIONS(964),
    [anon_sym_protected] = ACTIONS(964),
    [anon_sym_any] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_boolean] = ACTIONS(964),
    [anon_sym_string] = ACTIONS(964),
    [anon_sym_symbol] = ACTIONS(964),
    [sym_readonly] = ACTIONS(964),
    [sym__automatic_semicolon] = ACTIONS(1086),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(918),
    [sym_identifier] = ACTIONS(920),
    [anon_sym_export] = ACTIONS(920),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_default] = ACTIONS(920),
    [anon_sym_as] = ACTIONS(920),
    [anon_sym_namespace] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(918),
    [anon_sym_COMMA] = ACTIONS(918),
    [anon_sym_RBRACE] = ACTIONS(918),
    [anon_sym_typeof] = ACTIONS(920),
    [anon_sym_type] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(920),
    [anon_sym_declare] = ACTIONS(920),
    [anon_sym_module] = ACTIONS(920),
    [anon_sym_DOT] = ACTIONS(920),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_const] = ACTIONS(920),
    [anon_sym_enum] = ACTIONS(920),
    [anon_sym_var] = ACTIONS(920),
    [anon_sym_let] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_switch] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_in] = ACTIONS(920),
    [anon_sym_while] = ACTIONS(920),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_with] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_debugger] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_throw] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(918),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(920),
    [anon_sym_abstract] = ACTIONS(920),
    [anon_sym_get] = ACTIONS(920),
    [anon_sym_set] = ACTIONS(920),
    [anon_sym_QMARK] = ACTIONS(920),
    [anon_sym_QMARK_DOT] = ACTIONS(918),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_AMP_AMP] = ACTIONS(918),
    [anon_sym_PIPE_PIPE] = ACTIONS(918),
    [anon_sym_GT_GT] = ACTIONS(920),
    [anon_sym_GT_GT_GT] = ACTIONS(918),
    [anon_sym_LT_LT] = ACTIONS(918),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(918),
    [anon_sym_PIPE] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_SLASH] = ACTIONS(920),
    [anon_sym_PERCENT] = ACTIONS(918),
    [anon_sym_STAR_STAR] = ACTIONS(918),
    [anon_sym_LT] = ACTIONS(920),
    [anon_sym_LT_EQ] = ACTIONS(918),
    [anon_sym_EQ_EQ] = ACTIONS(920),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(918),
    [anon_sym_BANG_EQ] = ACTIONS(920),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(918),
    [anon_sym_GT_EQ] = ACTIONS(918),
    [anon_sym_GT] = ACTIONS(920),
    [anon_sym_QMARK_QMARK] = ACTIONS(918),
    [anon_sym_instanceof] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(920),
    [anon_sym_delete] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(918),
    [anon_sym_DQUOTE] = ACTIONS(918),
    [anon_sym_SQUOTE] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(918),
    [sym_number] = ACTIONS(918),
    [sym_this] = ACTIONS(920),
    [sym_super] = ACTIONS(920),
    [sym_true] = ACTIONS(920),
    [sym_false] = ACTIONS(920),
    [sym_null] = ACTIONS(920),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(920),
    [anon_sym_public] = ACTIONS(920),
    [anon_sym_private] = ACTIONS(920),
    [anon_sym_protected] = ACTIONS(920),
    [anon_sym_any] = ACTIONS(920),
    [anon_sym_number] = ACTIONS(920),
    [anon_sym_boolean] = ACTIONS(920),
    [anon_sym_string] = ACTIONS(920),
    [anon_sym_symbol] = ACTIONS(920),
    [sym_readonly] = ACTIONS(920),
    [sym__automatic_semicolon] = ACTIONS(1088),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_identifier] = ACTIONS(1092),
    [anon_sym_export] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_as] = ACTIONS(1094),
    [anon_sym_namespace] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_COMMA] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [anon_sym_typeof] = ACTIONS(1092),
    [anon_sym_type] = ACTIONS(1092),
    [anon_sym_interface] = ACTIONS(1092),
    [anon_sym_declare] = ACTIONS(1092),
    [anon_sym_module] = ACTIONS(1092),
    [anon_sym_DOT] = ACTIONS(1094),
    [anon_sym_import] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_var] = ACTIONS(1092),
    [anon_sym_let] = ACTIONS(1092),
    [anon_sym_BANG] = ACTIONS(1092),
    [anon_sym_else] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_LPAREN] = ACTIONS(1090),
    [anon_sym_await] = ACTIONS(1092),
    [anon_sym_in] = ACTIONS(1094),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_try] = ACTIONS(1092),
    [anon_sym_with] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_debugger] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_throw] = ACTIONS(1092),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_yield] = ACTIONS(1092),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1092),
    [anon_sym_async] = ACTIONS(1092),
    [anon_sym_function] = ACTIONS(1092),
    [anon_sym_abstract] = ACTIONS(1092),
    [anon_sym_get] = ACTIONS(1092),
    [anon_sym_set] = ACTIONS(1092),
    [anon_sym_QMARK] = ACTIONS(1094),
    [anon_sym_QMARK_DOT] = ACTIONS(1096),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_AMP_AMP] = ACTIONS(1096),
    [anon_sym_PIPE_PIPE] = ACTIONS(1096),
    [anon_sym_GT_GT] = ACTIONS(1094),
    [anon_sym_GT_GT_GT] = ACTIONS(1096),
    [anon_sym_LT_LT] = ACTIONS(1096),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_CARET] = ACTIONS(1096),
    [anon_sym_PIPE] = ACTIONS(1094),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_SLASH] = ACTIONS(1092),
    [anon_sym_PERCENT] = ACTIONS(1096),
    [anon_sym_STAR_STAR] = ACTIONS(1096),
    [anon_sym_LT] = ACTIONS(1092),
    [anon_sym_LT_EQ] = ACTIONS(1096),
    [anon_sym_EQ_EQ] = ACTIONS(1094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1096),
    [anon_sym_BANG_EQ] = ACTIONS(1094),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1096),
    [anon_sym_GT_EQ] = ACTIONS(1096),
    [anon_sym_GT] = ACTIONS(1094),
    [anon_sym_QMARK_QMARK] = ACTIONS(1096),
    [anon_sym_instanceof] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_void] = ACTIONS(1092),
    [anon_sym_delete] = ACTIONS(1092),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1090),
    [sym_this] = ACTIONS(1092),
    [sym_super] = ACTIONS(1092),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_public] = ACTIONS(1092),
    [anon_sym_private] = ACTIONS(1092),
    [anon_sym_protected] = ACTIONS(1092),
    [anon_sym_any] = ACTIONS(1092),
    [anon_sym_number] = ACTIONS(1092),
    [anon_sym_boolean] = ACTIONS(1092),
    [anon_sym_string] = ACTIONS(1092),
    [anon_sym_symbol] = ACTIONS(1092),
    [sym_readonly] = ACTIONS(1092),
    [sym__automatic_semicolon] = ACTIONS(1098),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(1100),
    [sym_identifier] = ACTIONS(1102),
    [anon_sym_export] = ACTIONS(1102),
    [anon_sym_STAR] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1102),
    [anon_sym_as] = ACTIONS(1104),
    [anon_sym_namespace] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [anon_sym_COMMA] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1102),
    [anon_sym_interface] = ACTIONS(1102),
    [anon_sym_declare] = ACTIONS(1102),
    [anon_sym_module] = ACTIONS(1102),
    [anon_sym_DOT] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1102),
    [anon_sym_const] = ACTIONS(1102),
    [anon_sym_enum] = ACTIONS(1102),
    [anon_sym_var] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_else] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1102),
    [anon_sym_switch] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_await] = ACTIONS(1102),
    [anon_sym_in] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_debugger] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_throw] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1102),
    [anon_sym_yield] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1102),
    [anon_sym_async] = ACTIONS(1102),
    [anon_sym_function] = ACTIONS(1102),
    [anon_sym_abstract] = ACTIONS(1102),
    [anon_sym_get] = ACTIONS(1102),
    [anon_sym_set] = ACTIONS(1102),
    [anon_sym_QMARK] = ACTIONS(1104),
    [anon_sym_QMARK_DOT] = ACTIONS(1106),
    [anon_sym_new] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1106),
    [anon_sym_PIPE_PIPE] = ACTIONS(1106),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_GT_GT_GT] = ACTIONS(1106),
    [anon_sym_LT_LT] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1104),
    [anon_sym_CARET] = ACTIONS(1106),
    [anon_sym_PIPE] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1102),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_STAR_STAR] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_LT_EQ] = ACTIONS(1106),
    [anon_sym_EQ_EQ] = ACTIONS(1104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1106),
    [anon_sym_BANG_EQ] = ACTIONS(1104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1106),
    [anon_sym_GT_EQ] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_QMARK_QMARK] = ACTIONS(1106),
    [anon_sym_instanceof] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1102),
    [anon_sym_delete] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_SQUOTE] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_number] = ACTIONS(1100),
    [sym_this] = ACTIONS(1102),
    [sym_super] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_null] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_static] = ACTIONS(1102),
    [anon_sym_public] = ACTIONS(1102),
    [anon_sym_private] = ACTIONS(1102),
    [anon_sym_protected] = ACTIONS(1102),
    [anon_sym_any] = ACTIONS(1102),
    [anon_sym_number] = ACTIONS(1102),
    [anon_sym_boolean] = ACTIONS(1102),
    [anon_sym_string] = ACTIONS(1102),
    [anon_sym_symbol] = ACTIONS(1102),
    [sym_readonly] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(1108),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_export] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_default] = ACTIONS(1112),
    [anon_sym_as] = ACTIONS(1112),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_COMMA] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_typeof] = ACTIONS(1112),
    [anon_sym_type] = ACTIONS(1112),
    [anon_sym_interface] = ACTIONS(1112),
    [anon_sym_declare] = ACTIONS(1112),
    [anon_sym_module] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_import] = ACTIONS(1112),
    [anon_sym_const] = ACTIONS(1112),
    [anon_sym_enum] = ACTIONS(1112),
    [anon_sym_var] = ACTIONS(1112),
    [anon_sym_let] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1112),
    [anon_sym_else] = ACTIONS(1112),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_switch] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_await] = ACTIONS(1112),
    [anon_sym_in] = ACTIONS(1112),
    [anon_sym_while] = ACTIONS(1112),
    [anon_sym_do] = ACTIONS(1112),
    [anon_sym_try] = ACTIONS(1112),
    [anon_sym_with] = ACTIONS(1112),
    [anon_sym_break] = ACTIONS(1112),
    [anon_sym_continue] = ACTIONS(1112),
    [anon_sym_debugger] = ACTIONS(1112),
    [anon_sym_return] = ACTIONS(1112),
    [anon_sym_throw] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_case] = ACTIONS(1112),
    [anon_sym_yield] = ACTIONS(1112),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1112),
    [anon_sym_async] = ACTIONS(1112),
    [anon_sym_function] = ACTIONS(1112),
    [anon_sym_abstract] = ACTIONS(1112),
    [anon_sym_get] = ACTIONS(1112),
    [anon_sym_set] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_QMARK_DOT] = ACTIONS(1110),
    [anon_sym_new] = ACTIONS(1112),
    [anon_sym_AMP_AMP] = ACTIONS(1110),
    [anon_sym_PIPE_PIPE] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1112),
    [anon_sym_GT_GT_GT] = ACTIONS(1110),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1112),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1110),
    [anon_sym_STAR_STAR] = ACTIONS(1110),
    [anon_sym_LT] = ACTIONS(1112),
    [anon_sym_LT_EQ] = ACTIONS(1110),
    [anon_sym_EQ_EQ] = ACTIONS(1112),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ] = ACTIONS(1112),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1110),
    [anon_sym_GT_EQ] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_QMARK_QMARK] = ACTIONS(1110),
    [anon_sym_instanceof] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_void] = ACTIONS(1112),
    [anon_sym_delete] = ACTIONS(1112),
    [anon_sym_PLUS_PLUS] = ACTIONS(1110),
    [anon_sym_DASH_DASH] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1110),
    [sym_number] = ACTIONS(1110),
    [sym_this] = ACTIONS(1112),
    [sym_super] = ACTIONS(1112),
    [sym_true] = ACTIONS(1112),
    [sym_false] = ACTIONS(1112),
    [sym_null] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1110),
    [anon_sym_static] = ACTIONS(1112),
    [anon_sym_public] = ACTIONS(1112),
    [anon_sym_private] = ACTIONS(1112),
    [anon_sym_protected] = ACTIONS(1112),
    [anon_sym_any] = ACTIONS(1112),
    [anon_sym_number] = ACTIONS(1112),
    [anon_sym_boolean] = ACTIONS(1112),
    [anon_sym_string] = ACTIONS(1112),
    [anon_sym_symbol] = ACTIONS(1112),
    [sym_readonly] = ACTIONS(1112),
    [sym__automatic_semicolon] = ACTIONS(1110),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_as] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_DOT] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1116),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_in] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_QMARK] = ACTIONS(1116),
    [anon_sym_QMARK_DOT] = ACTIONS(1114),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_PIPE] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR_STAR] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1116),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1116),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1114),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_GT] = ACTIONS(1116),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_instanceof] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_number] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_any] = ACTIONS(1116),
    [anon_sym_number] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [sym_readonly] = ACTIONS(1116),
    [sym__automatic_semicolon] = ACTIONS(1114),
  },
  [95] = {
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(724),
    [anon_sym_COLON] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(934),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_EQ_GT] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(936),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_number] = ACTIONS(750),
    [anon_sym_boolean] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_symbol] = ACTIONS(750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(938),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [96] = {
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(1122),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(934),
    [anon_sym_EQ_GT] = ACTIONS(1124),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_implements] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(936),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_number] = ACTIONS(750),
    [anon_sym_boolean] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_symbol] = ACTIONS(750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(938),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [97] = {
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(1126),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_EQ_GT] = ACTIONS(1128),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(936),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_number] = ACTIONS(750),
    [anon_sym_boolean] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_symbol] = ACTIONS(750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(938),
    [anon_sym_keyof] = ACTIONS(502),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [98] = {
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2571),
    [sym_parenthesized_type] = STATE(2571),
    [sym_predefined_type] = STATE(2571),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2571),
    [sym_object_type] = STATE(2571),
    [sym_array_type] = STATE(2571),
    [sym_tuple_type] = STATE(2571),
    [sym__tuple_type_body] = STATE(1983),
    [sym_flow_maybe_type] = STATE(2571),
    [sym_type_query] = STATE(2571),
    [sym_index_type_query] = STATE(2571),
    [sym_existential_type] = STATE(2571),
    [sym_literal_type] = STATE(2571),
    [sym_lookup_type] = STATE(2571),
    [sym_conditional_type] = STATE(2571),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(930),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1130),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(1132),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_number] = ACTIONS(750),
    [anon_sym_boolean] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_symbol] = ACTIONS(750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(938),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [99] = {
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(1134),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_DOT] = ACTIONS(1136),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_EQ_GT] = ACTIONS(1140),
    [anon_sym_QMARK] = ACTIONS(732),
    [anon_sym_QMARK_DOT] = ACTIONS(1142),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(740),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(746),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(936),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_number] = ACTIONS(750),
    [anon_sym_boolean] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_symbol] = ACTIONS(750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(938),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [100] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2679),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3185),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1148),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [101] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1262),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2616),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2644),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [102] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2681),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1154),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [103] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2681),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1156),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [104] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2681),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2614),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2614),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1158),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [105] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2681),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1160),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [106] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2679),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1148),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [107] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1262),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2616),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2644),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1162),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [108] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2742),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1164),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [109] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1202),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1611),
    [sym_array] = STATE(1518),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3035),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(2226),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(1166),
    [anon_sym_export] = ACTIONS(430),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_declare] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(430),
    [anon_sym_set] = ACTIONS(430),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(430),
    [anon_sym_number] = ACTIONS(430),
    [anon_sym_boolean] = ACTIONS(430),
    [anon_sym_string] = ACTIONS(430),
    [anon_sym_symbol] = ACTIONS(430),
    [sym_readonly] = ACTIONS(1170),
  },
  [110] = {
    [sym_import] = STATE(1497),
    [sym_expression_statement] = STATE(152),
    [sym_variable_declaration] = STATE(152),
    [sym_lexical_declaration] = STATE(152),
    [sym_empty_statement] = STATE(152),
    [sym_parenthesized_expression] = STATE(764),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1412),
    [sym_array] = STATE(1410),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(772),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_export] = ACTIONS(1174),
    [anon_sym_namespace] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1174),
    [anon_sym_declare] = ACTIONS(1174),
    [anon_sym_module] = ACTIONS(1174),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_const] = ACTIONS(1178),
    [anon_sym_var] = ACTIONS(1180),
    [anon_sym_let] = ACTIONS(1178),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(1182),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(1174),
    [anon_sym_set] = ACTIONS(1174),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1174),
    [anon_sym_public] = ACTIONS(1174),
    [anon_sym_private] = ACTIONS(1174),
    [anon_sym_protected] = ACTIONS(1174),
    [anon_sym_any] = ACTIONS(1174),
    [anon_sym_number] = ACTIONS(1174),
    [anon_sym_boolean] = ACTIONS(1174),
    [anon_sym_string] = ACTIONS(1174),
    [anon_sym_symbol] = ACTIONS(1174),
    [sym_readonly] = ACTIONS(1174),
  },
  [111] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1461),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3010),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1184),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [112] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1168),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1611),
    [sym_array] = STATE(1518),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3167),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(2226),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(1166),
    [anon_sym_export] = ACTIONS(430),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_declare] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(430),
    [anon_sym_set] = ACTIONS(430),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(430),
    [anon_sym_number] = ACTIONS(430),
    [anon_sym_boolean] = ACTIONS(430),
    [anon_sym_string] = ACTIONS(430),
    [anon_sym_symbol] = ACTIONS(430),
    [sym_readonly] = ACTIONS(1170),
  },
  [113] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1450),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3122),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1184),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [114] = {
    [sym_import] = STATE(1497),
    [sym_expression_statement] = STATE(150),
    [sym_variable_declaration] = STATE(150),
    [sym_lexical_declaration] = STATE(150),
    [sym_empty_statement] = STATE(150),
    [sym_parenthesized_expression] = STATE(764),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1412),
    [sym_array] = STATE(1410),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(772),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_export] = ACTIONS(1174),
    [anon_sym_namespace] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1174),
    [anon_sym_declare] = ACTIONS(1174),
    [anon_sym_module] = ACTIONS(1174),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_const] = ACTIONS(1178),
    [anon_sym_var] = ACTIONS(1180),
    [anon_sym_let] = ACTIONS(1178),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(1182),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(1174),
    [anon_sym_set] = ACTIONS(1174),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1174),
    [anon_sym_public] = ACTIONS(1174),
    [anon_sym_private] = ACTIONS(1174),
    [anon_sym_protected] = ACTIONS(1174),
    [anon_sym_any] = ACTIONS(1174),
    [anon_sym_number] = ACTIONS(1174),
    [anon_sym_boolean] = ACTIONS(1174),
    [anon_sym_string] = ACTIONS(1174),
    [anon_sym_symbol] = ACTIONS(1174),
    [sym_readonly] = ACTIONS(1174),
  },
  [115] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1457),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3185),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2621),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2621),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1184),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [116] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1457),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3185),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_labeled_tuple_type_member] = STATE(2614),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2622),
    [sym_rest_identifier] = STATE(2608),
    [sym__tuple_type_member] = STATE(2614),
    [sym__tuple_type_identifier] = STATE(2608),
    [sym_optional_identifier] = STATE(2608),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1186),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [117] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1103),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1611),
    [sym_array] = STATE(1518),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3078),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(2226),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(1166),
    [anon_sym_export] = ACTIONS(430),
    [anon_sym_namespace] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(430),
    [anon_sym_declare] = ACTIONS(430),
    [anon_sym_module] = ACTIONS(430),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(456),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(430),
    [anon_sym_set] = ACTIONS(430),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(1168),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(430),
    [anon_sym_public] = ACTIONS(494),
    [anon_sym_private] = ACTIONS(494),
    [anon_sym_protected] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(430),
    [anon_sym_number] = ACTIONS(430),
    [anon_sym_boolean] = ACTIONS(430),
    [anon_sym_string] = ACTIONS(430),
    [anon_sym_symbol] = ACTIONS(430),
    [sym_readonly] = ACTIONS(1170),
  },
  [118] = {
    [sym_export_clause] = STATE(2565),
    [sym__declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2753),
    [anon_sym_STAR] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1192),
    [anon_sym_as] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [119] = {
    [sym_export_clause] = STATE(2565),
    [sym__declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2757),
    [anon_sym_STAR] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1192),
    [anon_sym_as] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [120] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1037),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(506),
    [sym__automatic_semicolon] = ACTIONS(1243),
  },
  [121] = {
    [sym_export_clause] = STATE(2565),
    [sym__declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2636),
    [anon_sym_STAR] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1192),
    [anon_sym_as] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [122] = {
    [sym__declaration] = STATE(545),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2636),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_global] = ACTIONS(1251),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [123] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2679),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3185),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [124] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1037),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1243),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [125] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2679),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3185),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [126] = {
    [sym_export_clause] = STATE(2565),
    [sym__declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_STAR] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_as] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1259),
    [anon_sym_module] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [127] = {
    [sym__declaration] = STATE(545),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2757),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_global] = ACTIONS(1251),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [128] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1227),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2679),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_mapped_type_clause] = STATE(3111),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(1263),
    [anon_sym_export] = ACTIONS(1265),
    [anon_sym_namespace] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_declare] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1269),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1265),
    [anon_sym_set] = ACTIONS(1265),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_public] = ACTIONS(1265),
    [anon_sym_private] = ACTIONS(1265),
    [anon_sym_protected] = ACTIONS(1265),
    [anon_sym_any] = ACTIONS(1265),
    [anon_sym_number] = ACTIONS(1265),
    [anon_sym_boolean] = ACTIONS(1265),
    [anon_sym_string] = ACTIONS(1265),
    [anon_sym_symbol] = ACTIONS(1265),
    [sym_readonly] = ACTIONS(1265),
  },
  [129] = {
    [sym_export_clause] = STATE(2565),
    [sym__declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_STAR] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_as] = ACTIONS(1194),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1208),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1271),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [130] = {
    [sym__declaration] = STATE(545),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2753),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_global] = ACTIONS(1251),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [131] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [132] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [133] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2625),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2626),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1275),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [134] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1229),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2721),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2719),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1277),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [135] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2632),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2623),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1279),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [136] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1237),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2675),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2677),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1281),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [137] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1262),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2616),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2644),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [138] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1406),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [139] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1145),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [140] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2616),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2644),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1283),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [141] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2742),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2743),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1285),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [142] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2681),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1287),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [143] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1231),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2679),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [144] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2679),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2680),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [145] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2670),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1289),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1289),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1289),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [146] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [147] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1462),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2670),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(2595),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1289),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(1289),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [148] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1228),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_spread_element] = STATE(2714),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [aux_sym_array_repeat1] = STATE(2715),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [149] = {
    [sym__declaration] = STATE(545),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1259),
    [anon_sym_global] = ACTIONS(1251),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1261),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [150] = {
    [sym_import] = STATE(1497),
    [sym_expression_statement] = STATE(168),
    [sym_empty_statement] = STATE(168),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [151] = {
    [sym__declaration] = STATE(545),
    [sym_type_alias_declaration] = STATE(566),
    [sym_interface_declaration] = STATE(566),
    [sym_ambient_declaration] = STATE(566),
    [sym_import_alias] = STATE(566),
    [sym_enum_declaration] = STATE(566),
    [sym_variable_declaration] = STATE(566),
    [sym_lexical_declaration] = STATE(566),
    [sym_class_declaration] = STATE(566),
    [sym_function_declaration] = STATE(566),
    [sym_generator_function_declaration] = STATE(566),
    [sym_module] = STATE(566),
    [sym_internal_module] = STATE(598),
    [sym_abstract_class_declaration] = STATE(566),
    [sym_function_signature] = STATE(566),
    [sym_decorator] = STATE(1908),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_declare] = ACTIONS(1206),
    [anon_sym_global] = ACTIONS(1251),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1271),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1234),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(105),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [152] = {
    [sym_import] = STATE(1497),
    [sym_expression_statement] = STATE(171),
    [sym_empty_statement] = STATE(171),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2816),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [153] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_nested_identifier] = STATE(1918),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_nested_type_identifier] = STATE(2986),
    [sym_generic_type] = STATE(444),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [154] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_nested_type_identifier] = STATE(2294),
    [sym_generic_type] = STATE(2690),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [155] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_nested_identifier] = STATE(1918),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_nested_type_identifier] = STATE(2986),
    [sym_generic_type] = STATE(444),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1299),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [156] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(960),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1724),
    [sym_array] = STATE(1715),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(959),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(960),
    [sym_subscript_expression] = STATE(960),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_var] = ACTIONS(1307),
    [anon_sym_let] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1309),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
    [sym_readonly] = ACTIONS(1303),
  },
  [157] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_nested_identifier] = STATE(1918),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_nested_type_identifier] = STATE(2986),
    [sym_generic_type] = STATE(444),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [158] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_nested_identifier] = STATE(1918),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_nested_type_identifier] = STATE(2986),
    [sym_generic_type] = STATE(444),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1313),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [159] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1419),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_nested_identifier] = STATE(1918),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_nested_type_identifier] = STATE(2986),
    [sym_generic_type] = STATE(444),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1315),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [160] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1159),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_nested_identifier] = STATE(3046),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_nested_type_identifier] = STATE(2199),
    [sym_generic_type] = STATE(2519),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(1317),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [161] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2848),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
    [sym__automatic_semicolon] = ACTIONS(1319),
  },
  [162] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_nested_identifier] = STATE(1918),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_nested_type_identifier] = STATE(2986),
    [sym_generic_type] = STATE(444),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [163] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_nested_identifier] = STATE(1918),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_nested_type_identifier] = STATE(2986),
    [sym_generic_type] = STATE(444),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [164] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_nested_identifier] = STATE(1954),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_nested_type_identifier] = STATE(2982),
    [sym_generic_type] = STATE(2001),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [165] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_nested_identifier] = STATE(3046),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_nested_type_identifier] = STATE(2366),
    [sym_generic_type] = STATE(2652),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(1327),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [166] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1135),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_nested_identifier] = STATE(3142),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_nested_type_identifier] = STATE(2217),
    [sym_generic_type] = STATE(2582),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [167] = {
    [sym__call_signature] = STATE(3151),
    [sym_string] = STATE(2230),
    [sym_formal_parameters] = STATE(2226),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_object_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_export] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1333),
    [anon_sym_declare] = ACTIONS(1333),
    [anon_sym_module] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1338),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1348),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_public] = ACTIONS(1333),
    [anon_sym_private] = ACTIONS(1333),
    [anon_sym_protected] = ACTIONS(1333),
    [anon_sym_any] = ACTIONS(1333),
    [anon_sym_number] = ACTIONS(1333),
    [anon_sym_boolean] = ACTIONS(1333),
    [anon_sym_string] = ACTIONS(1333),
    [anon_sym_symbol] = ACTIONS(1333),
    [sym_readonly] = ACTIONS(1333),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [168] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1384),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3065),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1354),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [169] = {
    [sym__call_signature] = STATE(3151),
    [sym_string] = STATE(2230),
    [sym_formal_parameters] = STATE(2226),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_export] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1333),
    [anon_sym_declare] = ACTIONS(1333),
    [anon_sym_module] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1338),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1348),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_public] = ACTIONS(1333),
    [anon_sym_private] = ACTIONS(1333),
    [anon_sym_protected] = ACTIONS(1333),
    [anon_sym_any] = ACTIONS(1333),
    [anon_sym_number] = ACTIONS(1333),
    [anon_sym_boolean] = ACTIONS(1333),
    [anon_sym_string] = ACTIONS(1333),
    [anon_sym_symbol] = ACTIONS(1333),
    [sym_readonly] = ACTIONS(1333),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [170] = {
    [sym__call_signature] = STATE(3151),
    [sym_string] = STATE(2230),
    [sym_formal_parameters] = STATE(2226),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_object_repeat1] = STATE(2757),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_export] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1333),
    [anon_sym_declare] = ACTIONS(1333),
    [anon_sym_module] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1338),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1333),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1348),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_public] = ACTIONS(1333),
    [anon_sym_private] = ACTIONS(1333),
    [anon_sym_protected] = ACTIONS(1333),
    [anon_sym_any] = ACTIONS(1333),
    [anon_sym_number] = ACTIONS(1333),
    [anon_sym_boolean] = ACTIONS(1333),
    [anon_sym_string] = ACTIONS(1333),
    [anon_sym_symbol] = ACTIONS(1333),
    [sym_readonly] = ACTIONS(1333),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [171] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1400),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3115),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(1356),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [172] = {
    [sym_import] = STATE(1705),
    [sym_statement_block] = STATE(1679),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [173] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1125),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1067),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [174] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1201),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1038),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [175] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1191),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1035),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [176] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1364),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1364),
    [anon_sym_module] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1370),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1364),
    [anon_sym_set] = ACTIONS(1364),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_protected] = ACTIONS(1364),
    [anon_sym_any] = ACTIONS(1364),
    [anon_sym_number] = ACTIONS(1364),
    [anon_sym_boolean] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [anon_sym_symbol] = ACTIONS(1364),
    [sym_readonly] = ACTIONS(1364),
  },
  [177] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1461),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3010),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [178] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1496),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1376),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [179] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1572),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1151),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [180] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1190),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1313),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [181] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1374),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3122),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [182] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2270),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2892),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_export] = ACTIONS(1380),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1380),
    [anon_sym_declare] = ACTIONS(1380),
    [anon_sym_module] = ACTIONS(1380),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1380),
    [anon_sym_set] = ACTIONS(1380),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1380),
    [anon_sym_private] = ACTIONS(1380),
    [anon_sym_protected] = ACTIONS(1380),
    [anon_sym_any] = ACTIONS(1380),
    [anon_sym_number] = ACTIONS(1380),
    [anon_sym_boolean] = ACTIONS(1380),
    [anon_sym_string] = ACTIONS(1380),
    [anon_sym_symbol] = ACTIONS(1380),
    [sym_readonly] = ACTIONS(1380),
  },
  [183] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1364),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1364),
    [anon_sym_module] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1388),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1370),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1364),
    [anon_sym_set] = ACTIONS(1364),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_protected] = ACTIONS(1364),
    [anon_sym_any] = ACTIONS(1364),
    [anon_sym_number] = ACTIONS(1364),
    [anon_sym_boolean] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [anon_sym_symbol] = ACTIONS(1364),
    [sym_readonly] = ACTIONS(1364),
  },
  [184] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1572),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1415),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [185] = {
    [sym_import] = STATE(1393),
    [sym_parenthesized_expression] = STATE(727),
    [sym__expression] = STATE(1643),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1249),
    [sym_array] = STATE(1250),
    [sym_class] = STATE(1393),
    [sym_function] = STATE(1393),
    [sym_generator_function] = STATE(1393),
    [sym_arrow_function] = STATE(1393),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1393),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1393),
    [sym_template_string] = STATE(1393),
    [sym_regex] = STATE(1393),
    [sym_meta_property] = STATE(1393),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(1390),
    [anon_sym_export] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_declare] = ACTIONS(1392),
    [anon_sym_module] = ACTIONS(1392),
    [anon_sym_DOT] = ACTIONS(1388),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(1392),
    [anon_sym_set] = ACTIONS(1392),
    [anon_sym_new] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(1400),
    [sym_this] = ACTIONS(1402),
    [sym_super] = ACTIONS(1402),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_null] = ACTIONS(1402),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1392),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_protected] = ACTIONS(1392),
    [anon_sym_any] = ACTIONS(1392),
    [anon_sym_number] = ACTIONS(1392),
    [anon_sym_boolean] = ACTIONS(1392),
    [anon_sym_string] = ACTIONS(1392),
    [anon_sym_symbol] = ACTIONS(1392),
    [sym_readonly] = ACTIONS(1392),
  },
  [186] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1539),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [187] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1383),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3150),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [188] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1071),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(2595),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [189] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1533),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1186),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [190] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1364),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1364),
    [anon_sym_module] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1370),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1364),
    [anon_sym_set] = ACTIONS(1364),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_protected] = ACTIONS(1364),
    [anon_sym_any] = ACTIONS(1364),
    [anon_sym_number] = ACTIONS(1364),
    [anon_sym_boolean] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [anon_sym_symbol] = ACTIONS(1364),
    [sym_readonly] = ACTIONS(1364),
  },
  [191] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3131),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [192] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1191),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1236),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [193] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1460),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3133),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [194] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1426),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3125),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [195] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1394),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3033),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [196] = {
    [sym_import] = STATE(1393),
    [sym_parenthesized_expression] = STATE(727),
    [sym__expression] = STATE(1643),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1249),
    [sym_array] = STATE(1250),
    [sym_class] = STATE(1393),
    [sym_function] = STATE(1393),
    [sym_generator_function] = STATE(1393),
    [sym_arrow_function] = STATE(1393),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1393),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(727),
    [sym_subscript_expression] = STATE(727),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1393),
    [sym_template_string] = STATE(1393),
    [sym_regex] = STATE(1393),
    [sym_meta_property] = STATE(1393),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2270),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2892),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(1390),
    [anon_sym_export] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_declare] = ACTIONS(1392),
    [anon_sym_module] = ACTIONS(1392),
    [anon_sym_DOT] = ACTIONS(1388),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(1392),
    [anon_sym_set] = ACTIONS(1392),
    [anon_sym_new] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(1400),
    [sym_this] = ACTIONS(1402),
    [sym_super] = ACTIONS(1402),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_null] = ACTIONS(1402),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1392),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_protected] = ACTIONS(1392),
    [anon_sym_any] = ACTIONS(1392),
    [anon_sym_number] = ACTIONS(1392),
    [anon_sym_boolean] = ACTIONS(1392),
    [anon_sym_string] = ACTIONS(1392),
    [anon_sym_symbol] = ACTIONS(1392),
    [sym_readonly] = ACTIONS(1392),
  },
  [197] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1539),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1446),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [198] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1201),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [199] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1207),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1232),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [200] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1401),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3121),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [201] = {
    [sym_import] = STATE(1705),
    [sym_statement_block] = STATE(1672),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1266),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [202] = {
    [sym_import] = STATE(1705),
    [sym_statement_block] = STATE(1676),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1268),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [203] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1471),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3014),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [204] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1581),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_mapped_type_clause] = STATE(3016),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1410),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [sym_readonly] = ACTIONS(1406),
  },
  [205] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1423),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3059),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [206] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1441),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3113),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [207] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3112),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [208] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1108),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [209] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1108),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1075),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [210] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(726),
    [sym__expression] = STATE(1655),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1169),
    [sym_array] = STATE(1140),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1312),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(726),
    [sym_subscript_expression] = STATE(726),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_export] = ACTIONS(1414),
    [anon_sym_namespace] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1414),
    [anon_sym_declare] = ACTIONS(1414),
    [anon_sym_module] = ACTIONS(1414),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(1414),
    [anon_sym_set] = ACTIONS(1414),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(1422),
    [sym_this] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_public] = ACTIONS(1414),
    [anon_sym_private] = ACTIONS(1414),
    [anon_sym_protected] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(1414),
    [anon_sym_number] = ACTIONS(1414),
    [anon_sym_boolean] = ACTIONS(1414),
    [anon_sym_string] = ACTIONS(1414),
    [anon_sym_symbol] = ACTIONS(1414),
    [sym_readonly] = ACTIONS(1414),
  },
  [211] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1207),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1042),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(1426),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_export] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(1428),
    [anon_sym_namespace] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_COMMA] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_typeof] = ACTIONS(1428),
    [anon_sym_type] = ACTIONS(1428),
    [anon_sym_interface] = ACTIONS(1428),
    [anon_sym_declare] = ACTIONS(1428),
    [anon_sym_module] = ACTIONS(1428),
    [anon_sym_DOT] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_enum] = ACTIONS(1428),
    [anon_sym_var] = ACTIONS(1428),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1426),
    [anon_sym_else] = ACTIONS(1428),
    [anon_sym_if] = ACTIONS(1428),
    [anon_sym_switch] = ACTIONS(1428),
    [anon_sym_for] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_RPAREN] = ACTIONS(1426),
    [anon_sym_await] = ACTIONS(1428),
    [anon_sym_while] = ACTIONS(1428),
    [anon_sym_do] = ACTIONS(1428),
    [anon_sym_try] = ACTIONS(1428),
    [anon_sym_with] = ACTIONS(1428),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_continue] = ACTIONS(1428),
    [anon_sym_debugger] = ACTIONS(1428),
    [anon_sym_return] = ACTIONS(1428),
    [anon_sym_throw] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1428),
    [anon_sym_yield] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_RBRACK] = ACTIONS(1426),
    [anon_sym_class] = ACTIONS(1428),
    [anon_sym_async] = ACTIONS(1428),
    [anon_sym_function] = ACTIONS(1428),
    [anon_sym_EQ_GT] = ACTIONS(1426),
    [anon_sym_abstract] = ACTIONS(1428),
    [anon_sym_get] = ACTIONS(1428),
    [anon_sym_set] = ACTIONS(1428),
    [anon_sym_QMARK] = ACTIONS(1426),
    [anon_sym_implements] = ACTIONS(1428),
    [anon_sym_extends] = ACTIONS(1428),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_PIPE] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1426),
    [anon_sym_GT] = ACTIONS(1426),
    [anon_sym_TILDE] = ACTIONS(1426),
    [anon_sym_void] = ACTIONS(1428),
    [anon_sym_delete] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1426),
    [anon_sym_DQUOTE] = ACTIONS(1426),
    [anon_sym_SQUOTE] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [sym_number] = ACTIONS(1426),
    [sym_this] = ACTIONS(1428),
    [sym_super] = ACTIONS(1428),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1428),
    [anon_sym_private] = ACTIONS(1428),
    [anon_sym_protected] = ACTIONS(1428),
    [anon_sym_any] = ACTIONS(1428),
    [anon_sym_number] = ACTIONS(1428),
    [anon_sym_boolean] = ACTIONS(1428),
    [anon_sym_string] = ACTIONS(1428),
    [anon_sym_symbol] = ACTIONS(1428),
    [sym_readonly] = ACTIONS(1428),
  },
  [213] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1442),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3068),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [214] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1388),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3064),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [215] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1474),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3044),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [216] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2270),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2892),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1430),
    [anon_sym_export] = ACTIONS(1432),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1432),
    [anon_sym_module] = ACTIONS(1432),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1432),
    [anon_sym_set] = ACTIONS(1432),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_public] = ACTIONS(1432),
    [anon_sym_private] = ACTIONS(1432),
    [anon_sym_protected] = ACTIONS(1432),
    [anon_sym_any] = ACTIONS(1432),
    [anon_sym_number] = ACTIONS(1432),
    [anon_sym_boolean] = ACTIONS(1432),
    [anon_sym_string] = ACTIONS(1432),
    [anon_sym_symbol] = ACTIONS(1432),
    [sym_readonly] = ACTIONS(1432),
  },
  [217] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1287),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2852),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [218] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1207),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [219] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3127),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [220] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1457),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3185),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [221] = {
    [sym_import] = STATE(1705),
    [sym_statement_block] = STATE(1686),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1281),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [222] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2385),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2888),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_export] = ACTIONS(1380),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1380),
    [anon_sym_declare] = ACTIONS(1380),
    [anon_sym_module] = ACTIONS(1380),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1380),
    [anon_sym_set] = ACTIONS(1380),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1380),
    [anon_sym_private] = ACTIONS(1380),
    [anon_sym_protected] = ACTIONS(1380),
    [anon_sym_any] = ACTIONS(1380),
    [anon_sym_number] = ACTIONS(1380),
    [anon_sym_boolean] = ACTIONS(1380),
    [anon_sym_string] = ACTIONS(1380),
    [anon_sym_symbol] = ACTIONS(1380),
    [sym_readonly] = ACTIONS(1380),
  },
  [223] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(726),
    [sym__expression] = STATE(1655),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1169),
    [sym_array] = STATE(1140),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1312),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(726),
    [sym_subscript_expression] = STATE(726),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2270),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2892),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_export] = ACTIONS(1414),
    [anon_sym_namespace] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1414),
    [anon_sym_declare] = ACTIONS(1414),
    [anon_sym_module] = ACTIONS(1414),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(1414),
    [anon_sym_set] = ACTIONS(1414),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(1422),
    [sym_this] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_public] = ACTIONS(1414),
    [anon_sym_private] = ACTIONS(1414),
    [anon_sym_protected] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(1414),
    [anon_sym_number] = ACTIONS(1414),
    [anon_sym_boolean] = ACTIONS(1414),
    [anon_sym_string] = ACTIONS(1414),
    [anon_sym_symbol] = ACTIONS(1414),
    [sym_readonly] = ACTIONS(1414),
  },
  [224] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1430),
    [anon_sym_export] = ACTIONS(1432),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1432),
    [anon_sym_module] = ACTIONS(1432),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1432),
    [anon_sym_set] = ACTIONS(1432),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_public] = ACTIONS(1432),
    [anon_sym_private] = ACTIONS(1432),
    [anon_sym_protected] = ACTIONS(1432),
    [anon_sym_any] = ACTIONS(1432),
    [anon_sym_number] = ACTIONS(1432),
    [anon_sym_boolean] = ACTIONS(1432),
    [anon_sym_string] = ACTIONS(1432),
    [anon_sym_symbol] = ACTIONS(1432),
    [sym_readonly] = ACTIONS(1432),
  },
  [225] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1557),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [226] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1377),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3053),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [227] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(726),
    [sym__expression] = STATE(1655),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1169),
    [sym_array] = STATE(1140),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1312),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(726),
    [sym_subscript_expression] = STATE(726),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1438),
    [anon_sym_export] = ACTIONS(1440),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1440),
    [anon_sym_declare] = ACTIONS(1440),
    [anon_sym_module] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(1440),
    [anon_sym_set] = ACTIONS(1440),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(1422),
    [sym_this] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_public] = ACTIONS(1440),
    [anon_sym_private] = ACTIONS(1440),
    [anon_sym_protected] = ACTIONS(1440),
    [anon_sym_any] = ACTIONS(1440),
    [anon_sym_number] = ACTIONS(1440),
    [anon_sym_boolean] = ACTIONS(1440),
    [anon_sym_string] = ACTIONS(1440),
    [anon_sym_symbol] = ACTIONS(1440),
    [sym_readonly] = ACTIONS(1440),
  },
  [228] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(726),
    [sym__expression] = STATE(1655),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1169),
    [sym_array] = STATE(1140),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1312),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(726),
    [sym_subscript_expression] = STATE(726),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2270),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2892),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1438),
    [anon_sym_export] = ACTIONS(1440),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1440),
    [anon_sym_declare] = ACTIONS(1440),
    [anon_sym_module] = ACTIONS(1440),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(1440),
    [anon_sym_set] = ACTIONS(1440),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(1422),
    [sym_this] = ACTIONS(1424),
    [sym_super] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_public] = ACTIONS(1440),
    [anon_sym_private] = ACTIONS(1440),
    [anon_sym_protected] = ACTIONS(1440),
    [anon_sym_any] = ACTIONS(1440),
    [anon_sym_number] = ACTIONS(1440),
    [anon_sym_boolean] = ACTIONS(1440),
    [anon_sym_string] = ACTIONS(1440),
    [anon_sym_symbol] = ACTIONS(1440),
    [sym_readonly] = ACTIONS(1440),
  },
  [229] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1190),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1056),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [230] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2270),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2892),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(1364),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1364),
    [anon_sym_declare] = ACTIONS(1364),
    [anon_sym_module] = ACTIONS(1364),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1370),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1364),
    [anon_sym_set] = ACTIONS(1364),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_protected] = ACTIONS(1364),
    [anon_sym_any] = ACTIONS(1364),
    [anon_sym_number] = ACTIONS(1364),
    [anon_sym_boolean] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [anon_sym_symbol] = ACTIONS(1364),
    [sym_readonly] = ACTIONS(1364),
  },
  [231] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3230),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [232] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1190),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [233] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1191),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [234] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1558),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1104),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [235] = {
    [sym_import] = STATE(1705),
    [sym_statement_block] = STATE(1653),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1309),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [236] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1463),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3047),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [237] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_sequence_expression] = STATE(2975),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [238] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1450),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3122),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [239] = {
    [sym_import] = STATE(1144),
    [sym_variable_declarator] = STATE(2586),
    [sym_parenthesized_expression] = STATE(957),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1052),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(958),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(957),
    [sym_subscript_expression] = STATE(957),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1446),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [sym_readonly] = ACTIONS(1448),
  },
  [240] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1108),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [241] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1125),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1321),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [242] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1475),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3050),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [243] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1125),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [244] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1581),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_mapped_type_clause] = STATE(3111),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_export] = ACTIONS(1456),
    [anon_sym_namespace] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1456),
    [anon_sym_declare] = ACTIONS(1456),
    [anon_sym_module] = ACTIONS(1456),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1460),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1456),
    [anon_sym_set] = ACTIONS(1456),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1456),
    [anon_sym_public] = ACTIONS(1456),
    [anon_sym_private] = ACTIONS(1456),
    [anon_sym_protected] = ACTIONS(1456),
    [anon_sym_any] = ACTIONS(1456),
    [anon_sym_number] = ACTIONS(1456),
    [anon_sym_boolean] = ACTIONS(1456),
    [anon_sym_string] = ACTIONS(1456),
    [anon_sym_symbol] = ACTIONS(1456),
    [sym_readonly] = ACTIONS(1456),
  },
  [245] = {
    [sym_import] = STATE(1705),
    [sym_statement_block] = STATE(1669),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [246] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1557),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1110),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [247] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1496),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1160),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [248] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1201),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [249] = {
    [sym_import] = STATE(1144),
    [sym_variable_declarator] = STATE(2593),
    [sym_parenthesized_expression] = STATE(957),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1052),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(958),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(957),
    [sym_subscript_expression] = STATE(957),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1446),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [sym_readonly] = ACTIONS(1448),
  },
  [250] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1467),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3027),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [251] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1411),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3067),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [252] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1558),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1459),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [253] = {
    [sym_import] = STATE(1497),
    [sym_statement_block] = STATE(1533),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1476),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [254] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(658),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(992),
    [sym_array] = STATE(988),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(1001),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(658),
    [sym_subscript_expression] = STATE(658),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_export] = ACTIONS(1380),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1380),
    [anon_sym_declare] = ACTIONS(1380),
    [anon_sym_module] = ACTIONS(1380),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1380),
    [anon_sym_set] = ACTIONS(1380),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1374),
    [sym_super] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_null] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1380),
    [anon_sym_private] = ACTIONS(1380),
    [anon_sym_protected] = ACTIONS(1380),
    [anon_sym_any] = ACTIONS(1380),
    [anon_sym_number] = ACTIONS(1380),
    [anon_sym_boolean] = ACTIONS(1380),
    [anon_sym_string] = ACTIONS(1380),
    [anon_sym_symbol] = ACTIONS(1380),
    [sym_readonly] = ACTIONS(1380),
  },
  [255] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1403),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_sequence_expression] = STATE(3172),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [256] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [257] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [258] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [259] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [260] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [261] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [262] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [263] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [264] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [265] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1027),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [266] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1318),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [267] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [268] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [269] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [270] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1300),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [271] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [272] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1162),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [273] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1306),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [274] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1333),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [275] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1157),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [276] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1357),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [277] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1133),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [278] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1536),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [279] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [280] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1131),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [281] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1130),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [282] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1129),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [283] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1128),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [284] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [285] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1119),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(1464),
    [sym_identifier] = ACTIONS(1466),
    [anon_sym_export] = ACTIONS(1466),
    [anon_sym_default] = ACTIONS(1466),
    [anon_sym_EQ] = ACTIONS(1466),
    [anon_sym_namespace] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_typeof] = ACTIONS(1466),
    [anon_sym_type] = ACTIONS(1466),
    [anon_sym_interface] = ACTIONS(1466),
    [anon_sym_declare] = ACTIONS(1466),
    [anon_sym_module] = ACTIONS(1466),
    [anon_sym_COLON] = ACTIONS(1464),
    [anon_sym_import] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_var] = ACTIONS(1466),
    [anon_sym_let] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1466),
    [anon_sym_switch] = ACTIONS(1466),
    [anon_sym_for] = ACTIONS(1466),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [anon_sym_RPAREN] = ACTIONS(1464),
    [anon_sym_await] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(1466),
    [anon_sym_do] = ACTIONS(1466),
    [anon_sym_try] = ACTIONS(1466),
    [anon_sym_with] = ACTIONS(1466),
    [anon_sym_break] = ACTIONS(1466),
    [anon_sym_continue] = ACTIONS(1466),
    [anon_sym_debugger] = ACTIONS(1466),
    [anon_sym_return] = ACTIONS(1466),
    [anon_sym_throw] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym_case] = ACTIONS(1466),
    [anon_sym_yield] = ACTIONS(1466),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_class] = ACTIONS(1466),
    [anon_sym_async] = ACTIONS(1466),
    [anon_sym_function] = ACTIONS(1466),
    [anon_sym_EQ_GT] = ACTIONS(1464),
    [anon_sym_abstract] = ACTIONS(1466),
    [anon_sym_get] = ACTIONS(1466),
    [anon_sym_set] = ACTIONS(1466),
    [anon_sym_QMARK] = ACTIONS(1464),
    [anon_sym_implements] = ACTIONS(1466),
    [anon_sym_extends] = ACTIONS(1466),
    [anon_sym_new] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_PIPE] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(1466),
    [anon_sym_LT] = ACTIONS(1464),
    [anon_sym_GT] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_void] = ACTIONS(1466),
    [anon_sym_delete] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1464),
    [sym_number] = ACTIONS(1464),
    [sym_this] = ACTIONS(1466),
    [sym_super] = ACTIONS(1466),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [sym_null] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_public] = ACTIONS(1466),
    [anon_sym_private] = ACTIONS(1466),
    [anon_sym_protected] = ACTIONS(1466),
    [anon_sym_any] = ACTIONS(1466),
    [anon_sym_number] = ACTIONS(1466),
    [anon_sym_boolean] = ACTIONS(1466),
    [anon_sym_string] = ACTIONS(1466),
    [anon_sym_symbol] = ACTIONS(1466),
    [sym_readonly] = ACTIONS(1466),
  },
  [287] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1117),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [288] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [289] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1109),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(1468),
    [sym_identifier] = ACTIONS(1470),
    [anon_sym_export] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_namespace] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_COMMA] = ACTIONS(1468),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [anon_sym_typeof] = ACTIONS(1470),
    [anon_sym_type] = ACTIONS(1470),
    [anon_sym_interface] = ACTIONS(1470),
    [anon_sym_declare] = ACTIONS(1470),
    [anon_sym_module] = ACTIONS(1470),
    [anon_sym_COLON] = ACTIONS(1468),
    [anon_sym_import] = ACTIONS(1470),
    [anon_sym_const] = ACTIONS(1470),
    [anon_sym_enum] = ACTIONS(1470),
    [anon_sym_var] = ACTIONS(1470),
    [anon_sym_let] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1470),
    [anon_sym_switch] = ACTIONS(1470),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_RPAREN] = ACTIONS(1468),
    [anon_sym_await] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1470),
    [anon_sym_do] = ACTIONS(1470),
    [anon_sym_try] = ACTIONS(1470),
    [anon_sym_with] = ACTIONS(1470),
    [anon_sym_break] = ACTIONS(1470),
    [anon_sym_continue] = ACTIONS(1470),
    [anon_sym_debugger] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1470),
    [anon_sym_throw] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym_case] = ACTIONS(1470),
    [anon_sym_yield] = ACTIONS(1470),
    [anon_sym_LBRACK] = ACTIONS(1468),
    [anon_sym_RBRACK] = ACTIONS(1468),
    [anon_sym_class] = ACTIONS(1470),
    [anon_sym_async] = ACTIONS(1470),
    [anon_sym_function] = ACTIONS(1470),
    [anon_sym_EQ_GT] = ACTIONS(1468),
    [anon_sym_abstract] = ACTIONS(1470),
    [anon_sym_get] = ACTIONS(1470),
    [anon_sym_set] = ACTIONS(1470),
    [anon_sym_QMARK] = ACTIONS(1468),
    [anon_sym_implements] = ACTIONS(1470),
    [anon_sym_extends] = ACTIONS(1470),
    [anon_sym_new] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_void] = ACTIONS(1470),
    [anon_sym_delete] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1468),
    [sym_number] = ACTIONS(1468),
    [sym_this] = ACTIONS(1470),
    [sym_super] = ACTIONS(1470),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [sym_null] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_public] = ACTIONS(1470),
    [anon_sym_private] = ACTIONS(1470),
    [anon_sym_protected] = ACTIONS(1470),
    [anon_sym_any] = ACTIONS(1470),
    [anon_sym_number] = ACTIONS(1470),
    [anon_sym_boolean] = ACTIONS(1470),
    [anon_sym_string] = ACTIONS(1470),
    [anon_sym_symbol] = ACTIONS(1470),
    [sym_readonly] = ACTIONS(1470),
  },
  [291] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [292] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1469),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [293] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1261),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [294] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [295] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [296] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [297] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1304),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [298] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [299] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [300] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [301] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [302] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [303] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [304] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(1472),
    [sym_identifier] = ACTIONS(1474),
    [anon_sym_export] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1474),
    [anon_sym_EQ] = ACTIONS(1474),
    [anon_sym_namespace] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [anon_sym_typeof] = ACTIONS(1474),
    [anon_sym_type] = ACTIONS(1474),
    [anon_sym_interface] = ACTIONS(1474),
    [anon_sym_declare] = ACTIONS(1474),
    [anon_sym_module] = ACTIONS(1474),
    [anon_sym_COLON] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_enum] = ACTIONS(1474),
    [anon_sym_var] = ACTIONS(1474),
    [anon_sym_let] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_switch] = ACTIONS(1474),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1472),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_await] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1474),
    [anon_sym_do] = ACTIONS(1474),
    [anon_sym_try] = ACTIONS(1474),
    [anon_sym_with] = ACTIONS(1474),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1474),
    [anon_sym_debugger] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1474),
    [anon_sym_throw] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym_case] = ACTIONS(1474),
    [anon_sym_yield] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_RBRACK] = ACTIONS(1472),
    [anon_sym_class] = ACTIONS(1474),
    [anon_sym_async] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(1474),
    [anon_sym_EQ_GT] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1474),
    [anon_sym_get] = ACTIONS(1474),
    [anon_sym_set] = ACTIONS(1474),
    [anon_sym_QMARK] = ACTIONS(1472),
    [anon_sym_implements] = ACTIONS(1474),
    [anon_sym_extends] = ACTIONS(1474),
    [anon_sym_new] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_void] = ACTIONS(1474),
    [anon_sym_delete] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1472),
    [sym_number] = ACTIONS(1472),
    [sym_this] = ACTIONS(1474),
    [sym_super] = ACTIONS(1474),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [sym_null] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_public] = ACTIONS(1474),
    [anon_sym_private] = ACTIONS(1474),
    [anon_sym_protected] = ACTIONS(1474),
    [anon_sym_any] = ACTIONS(1474),
    [anon_sym_number] = ACTIONS(1474),
    [anon_sym_boolean] = ACTIONS(1474),
    [anon_sym_string] = ACTIONS(1474),
    [anon_sym_symbol] = ACTIONS(1474),
    [sym_readonly] = ACTIONS(1474),
  },
  [306] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1244),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [307] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(991),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [308] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1113),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [309] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1476),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [310] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1406),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [311] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [312] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [313] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [314] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(1478),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [315] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [316] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1342),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [317] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [318] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [319] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [320] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1210),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [321] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [322] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1280),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [323] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [324] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1395),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [325] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1223),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [326] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [327] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1120),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [328] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1502),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [329] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1215),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [330] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1059),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [331] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1577),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [332] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1480),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [333] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1120),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [334] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(1482),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [335] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1150),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(1484),
    [sym_identifier] = ACTIONS(1486),
    [anon_sym_export] = ACTIONS(1486),
    [anon_sym_default] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_namespace] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_RBRACE] = ACTIONS(1484),
    [anon_sym_typeof] = ACTIONS(1486),
    [anon_sym_type] = ACTIONS(1486),
    [anon_sym_interface] = ACTIONS(1486),
    [anon_sym_declare] = ACTIONS(1486),
    [anon_sym_module] = ACTIONS(1486),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_import] = ACTIONS(1486),
    [anon_sym_const] = ACTIONS(1486),
    [anon_sym_enum] = ACTIONS(1486),
    [anon_sym_var] = ACTIONS(1486),
    [anon_sym_let] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1486),
    [anon_sym_switch] = ACTIONS(1486),
    [anon_sym_for] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(1484),
    [anon_sym_RPAREN] = ACTIONS(1484),
    [anon_sym_await] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1486),
    [anon_sym_do] = ACTIONS(1486),
    [anon_sym_try] = ACTIONS(1486),
    [anon_sym_with] = ACTIONS(1486),
    [anon_sym_break] = ACTIONS(1486),
    [anon_sym_continue] = ACTIONS(1486),
    [anon_sym_debugger] = ACTIONS(1486),
    [anon_sym_return] = ACTIONS(1486),
    [anon_sym_throw] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym_case] = ACTIONS(1486),
    [anon_sym_yield] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1484),
    [anon_sym_RBRACK] = ACTIONS(1484),
    [anon_sym_class] = ACTIONS(1486),
    [anon_sym_async] = ACTIONS(1486),
    [anon_sym_function] = ACTIONS(1486),
    [anon_sym_EQ_GT] = ACTIONS(1484),
    [anon_sym_abstract] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(1486),
    [anon_sym_set] = ACTIONS(1486),
    [anon_sym_QMARK] = ACTIONS(1484),
    [anon_sym_implements] = ACTIONS(1486),
    [anon_sym_extends] = ACTIONS(1486),
    [anon_sym_new] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_void] = ACTIONS(1486),
    [anon_sym_delete] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1484),
    [sym_number] = ACTIONS(1484),
    [sym_this] = ACTIONS(1486),
    [sym_super] = ACTIONS(1486),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [sym_null] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_public] = ACTIONS(1486),
    [anon_sym_private] = ACTIONS(1486),
    [anon_sym_protected] = ACTIONS(1486),
    [anon_sym_any] = ACTIONS(1486),
    [anon_sym_number] = ACTIONS(1486),
    [anon_sym_boolean] = ACTIONS(1486),
    [anon_sym_string] = ACTIONS(1486),
    [anon_sym_symbol] = ACTIONS(1486),
    [sym_readonly] = ACTIONS(1486),
  },
  [337] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1260),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [338] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [339] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [340] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1402),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [341] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [342] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [343] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [344] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1476),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [345] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [346] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(991),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [347] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [348] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1382),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [349] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1240),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [350] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [351] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [352] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1375),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [353] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1489),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [354] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [355] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1181),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [356] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1145),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_export] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(1492),
    [anon_sym_type] = ACTIONS(1492),
    [anon_sym_interface] = ACTIONS(1492),
    [anon_sym_declare] = ACTIONS(1492),
    [anon_sym_module] = ACTIONS(1492),
    [anon_sym_COLON] = ACTIONS(1490),
    [anon_sym_import] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_var] = ACTIONS(1492),
    [anon_sym_let] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_await] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_debugger] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_throw] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_class] = ACTIONS(1492),
    [anon_sym_async] = ACTIONS(1492),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_EQ_GT] = ACTIONS(1490),
    [anon_sym_abstract] = ACTIONS(1492),
    [anon_sym_get] = ACTIONS(1492),
    [anon_sym_set] = ACTIONS(1492),
    [anon_sym_QMARK] = ACTIONS(1490),
    [anon_sym_implements] = ACTIONS(1492),
    [anon_sym_extends] = ACTIONS(1492),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1490),
    [anon_sym_PIPE] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1490),
    [anon_sym_GT] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_void] = ACTIONS(1492),
    [anon_sym_delete] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1490),
    [sym_number] = ACTIONS(1490),
    [sym_this] = ACTIONS(1492),
    [sym_super] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [anon_sym_AT] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_public] = ACTIONS(1492),
    [anon_sym_private] = ACTIONS(1492),
    [anon_sym_protected] = ACTIONS(1492),
    [anon_sym_any] = ACTIONS(1492),
    [anon_sym_number] = ACTIONS(1492),
    [anon_sym_boolean] = ACTIONS(1492),
    [anon_sym_string] = ACTIONS(1492),
    [anon_sym_symbol] = ACTIONS(1492),
    [sym_readonly] = ACTIONS(1492),
  },
  [358] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [359] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1346),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [360] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [361] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1402),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [362] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [363] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [364] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [365] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1115),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1494),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [366] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(818),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1515),
    [sym_array] = STATE(1516),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1705),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym_as_expression] = STATE(1703),
    [sym_non_null_expression] = STATE(812),
    [sym_internal_module] = STATE(1703),
    [sym__call_signature] = STATE(3034),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(818),
    [sym_subscript_expression] = STATE(818),
    [sym_assignment_expression] = STATE(1703),
    [sym__augmented_assignment_lhs] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1703),
    [sym_type_arguments] = STATE(294),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2591),
    [sym_identifier] = ACTIONS(882),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(888),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_import] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_await] = ACTIONS(782),
    [anon_sym_yield] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(788),
    [anon_sym_async] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_new] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_void] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(804),
    [anon_sym_DASH_DASH] = ACTIONS(804),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(810),
    [sym_number] = ACTIONS(898),
    [sym_this] = ACTIONS(816),
    [sym_super] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_null] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [367] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1405),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [368] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1025),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1496),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [369] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [370] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1594),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [371] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1593),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [372] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(1476),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [373] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [374] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [375] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1074),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [376] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [377] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1078),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [378] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [379] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1238),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [380] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1452),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [381] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1366),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [382] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1399),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(1478),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [383] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1081),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [384] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [385] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1096),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [386] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1456),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [387] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1090),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [388] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [389] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1085),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [390] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1082),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [391] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1073),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [392] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1037),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [393] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(991),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [394] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [395] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [396] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1069),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [397] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [398] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [399] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1581),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [400] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [401] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(957),
    [sym__expression] = STATE(1644),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1713),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(958),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(957),
    [sym_subscript_expression] = STATE(957),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(1498),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [sym_readonly] = ACTIONS(1448),
  },
  [402] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1066),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [403] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1115),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [404] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1380),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [405] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1399),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [406] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1419),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [407] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [408] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [409] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [410] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1060),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [411] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [412] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(869),
    [sym__expression] = STATE(1506),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1709),
    [sym_array] = STATE(1708),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(869),
    [sym_subscript_expression] = STATE(869),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(302),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_export] = ACTIONS(596),
    [anon_sym_namespace] = ACTIONS(598),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(876),
    [anon_sym_type] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_new] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(602),
    [anon_sym_void] = ACTIONS(618),
    [anon_sym_delete] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [sym_readonly] = ACTIONS(596),
  },
  [413] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(743),
    [sym__expression] = STATE(1053),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1290),
    [sym_array] = STATE(1224),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(747),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3138),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(743),
    [sym_subscript_expression] = STATE(743),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(400),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_export] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(518),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_module] = ACTIONS(506),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(450),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(506),
    [anon_sym_set] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(520),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_void] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(506),
    [anon_sym_public] = ACTIONS(506),
    [anon_sym_private] = ACTIONS(506),
    [anon_sym_protected] = ACTIONS(506),
    [anon_sym_any] = ACTIONS(506),
    [anon_sym_number] = ACTIONS(506),
    [anon_sym_boolean] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_symbol] = ACTIONS(506),
    [sym_readonly] = ACTIONS(506),
  },
  [414] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [415] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1339),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [416] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(787),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1468),
    [sym_array] = STATE(1466),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(785),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3211),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(787),
    [sym_subscript_expression] = STATE(787),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1926),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(338),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_namespace] = ACTIONS(582),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(578),
    [anon_sym_declare] = ACTIONS(578),
    [anon_sym_module] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(578),
    [anon_sym_set] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_DASH] = ACTIONS(85),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(37),
    [anon_sym_void] = ACTIONS(91),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(578),
    [anon_sym_public] = ACTIONS(578),
    [anon_sym_private] = ACTIONS(578),
    [anon_sym_protected] = ACTIONS(578),
    [anon_sym_any] = ACTIONS(578),
    [anon_sym_number] = ACTIONS(578),
    [anon_sym_boolean] = ACTIONS(578),
    [anon_sym_string] = ACTIONS(578),
    [anon_sym_symbol] = ACTIONS(578),
    [sym_readonly] = ACTIONS(578),
  },
  [417] = {
    [sym_import] = STATE(1144),
    [sym_parenthesized_expression] = STATE(800),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1583),
    [sym_array] = STATE(1528),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1144),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym_as_expression] = STATE(1146),
    [sym_non_null_expression] = STATE(805),
    [sym_internal_module] = STATE(1146),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(800),
    [sym_subscript_expression] = STATE(800),
    [sym_assignment_expression] = STATE(1146),
    [sym__augmented_assignment_lhs] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1146),
    [sym_type_arguments] = STATE(342),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2525),
    [sym_identifier] = ACTIONS(900),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_namespace] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(536),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_await] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_class] = ACTIONS(454),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_void] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(532),
    [sym_this] = ACTIONS(490),
    [sym_super] = ACTIONS(490),
    [sym_true] = ACTIONS(490),
    [sym_false] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [sym_readonly] = ACTIONS(536),
  },
  [418] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [419] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(874),
    [sym__expression] = STATE(1437),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1660),
    [sym_array] = STATE(1696),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1497),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym_as_expression] = STATE(1484),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(1484),
    [sym__call_signature] = STATE(3079),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(874),
    [sym_subscript_expression] = STATE(874),
    [sym_assignment_expression] = STATE(1484),
    [sym__augmented_assignment_lhs] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(1908),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_assertion] = STATE(1484),
    [sym_type_arguments] = STATE(388),
    [sym_type_parameters] = STATE(2817),
    [aux_sym_export_statement_repeat1] = STATE(2576),
    [sym_identifier] = ACTIONS(862),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(584),
    [anon_sym_typeof] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_await] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(592),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(99),
    [sym_number] = ACTIONS(101),
    [sym_this] = ACTIONS(103),
    [sym_super] = ACTIONS(103),
    [sym_true] = ACTIONS(103),
    [sym_false] = ACTIONS(103),
    [sym_null] = ACTIONS(103),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(1502),
    [anon_sym_export] = ACTIONS(1502),
    [anon_sym_default] = ACTIONS(1502),
    [anon_sym_EQ] = ACTIONS(1502),
    [anon_sym_namespace] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_COMMA] = ACTIONS(1500),
    [anon_sym_RBRACE] = ACTIONS(1500),
    [anon_sym_typeof] = ACTIONS(1502),
    [anon_sym_type] = ACTIONS(1502),
    [anon_sym_interface] = ACTIONS(1502),
    [anon_sym_declare] = ACTIONS(1502),
    [anon_sym_module] = ACTIONS(1502),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_import] = ACTIONS(1502),
    [anon_sym_const] = ACTIONS(1502),
    [anon_sym_enum] = ACTIONS(1502),
    [anon_sym_var] = ACTIONS(1502),
    [anon_sym_let] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_else] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_switch] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_LPAREN] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_await] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_do] = ACTIONS(1502),
    [anon_sym_try] = ACTIONS(1502),
    [anon_sym_with] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_debugger] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_throw] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym_case] = ACTIONS(1502),
    [anon_sym_yield] = ACTIONS(1502),
    [anon_sym_LBRACK] = ACTIONS(1500),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_class] = ACTIONS(1502),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_function] = ACTIONS(1502),
    [anon_sym_EQ_GT] = ACTIONS(1500),
    [anon_sym_abstract] = ACTIONS(1502),
    [anon_sym_get] = ACTIONS(1502),
    [anon_sym_set] = ACTIONS(1502),
    [anon_sym_QMARK] = ACTIONS(1500),
    [anon_sym_extends] = ACTIONS(1502),
    [anon_sym_new] = ACTIONS(1502),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1502),
    [anon_sym_SLASH] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_void] = ACTIONS(1502),
    [anon_sym_delete] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1500),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(1502),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1500),
    [anon_sym_static] = ACTIONS(1502),
    [anon_sym_public] = ACTIONS(1502),
    [anon_sym_private] = ACTIONS(1502),
    [anon_sym_protected] = ACTIONS(1502),
    [anon_sym_any] = ACTIONS(1502),
    [anon_sym_number] = ACTIONS(1502),
    [anon_sym_boolean] = ACTIONS(1502),
    [anon_sym_string] = ACTIONS(1502),
    [anon_sym_symbol] = ACTIONS(1502),
    [sym_readonly] = ACTIONS(1502),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(1504),
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_export] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_EQ] = ACTIONS(1506),
    [anon_sym_namespace] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_COMMA] = ACTIONS(1504),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1506),
    [anon_sym_interface] = ACTIONS(1506),
    [anon_sym_declare] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [anon_sym_COLON] = ACTIONS(1504),
    [anon_sym_import] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_var] = ACTIONS(1506),
    [anon_sym_let] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_RPAREN] = ACTIONS(1504),
    [anon_sym_await] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1506),
    [anon_sym_with] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_debugger] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_throw] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_yield] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1504),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1506),
    [anon_sym_EQ_GT] = ACTIONS(1504),
    [anon_sym_abstract] = ACTIONS(1506),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_QMARK] = ACTIONS(1504),
    [anon_sym_extends] = ACTIONS(1506),
    [anon_sym_new] = ACTIONS(1506),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [sym_number] = ACTIONS(1504),
    [sym_this] = ACTIONS(1506),
    [sym_super] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_null] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_public] = ACTIONS(1506),
    [anon_sym_private] = ACTIONS(1506),
    [anon_sym_protected] = ACTIONS(1506),
    [anon_sym_any] = ACTIONS(1506),
    [anon_sym_number] = ACTIONS(1506),
    [anon_sym_boolean] = ACTIONS(1506),
    [anon_sym_string] = ACTIONS(1506),
    [anon_sym_symbol] = ACTIONS(1506),
    [sym_readonly] = ACTIONS(1506),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(1508),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_export] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_EQ] = ACTIONS(1510),
    [anon_sym_namespace] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_typeof] = ACTIONS(1510),
    [anon_sym_type] = ACTIONS(1510),
    [anon_sym_interface] = ACTIONS(1510),
    [anon_sym_declare] = ACTIONS(1510),
    [anon_sym_module] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1508),
    [anon_sym_import] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_var] = ACTIONS(1510),
    [anon_sym_let] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_else] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_switch] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_await] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [anon_sym_do] = ACTIONS(1510),
    [anon_sym_try] = ACTIONS(1510),
    [anon_sym_with] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_debugger] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_throw] = ACTIONS(1510),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_case] = ACTIONS(1510),
    [anon_sym_yield] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_class] = ACTIONS(1510),
    [anon_sym_async] = ACTIONS(1510),
    [anon_sym_function] = ACTIONS(1510),
    [anon_sym_EQ_GT] = ACTIONS(1508),
    [anon_sym_abstract] = ACTIONS(1510),
    [anon_sym_get] = ACTIONS(1510),
    [anon_sym_set] = ACTIONS(1510),
    [anon_sym_QMARK] = ACTIONS(1508),
    [anon_sym_extends] = ACTIONS(1510),
    [anon_sym_new] = ACTIONS(1510),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_SLASH] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_void] = ACTIONS(1510),
    [anon_sym_delete] = ACTIONS(1510),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_number] = ACTIONS(1508),
    [sym_this] = ACTIONS(1510),
    [sym_super] = ACTIONS(1510),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [sym_null] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1508),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_public] = ACTIONS(1510),
    [anon_sym_private] = ACTIONS(1510),
    [anon_sym_protected] = ACTIONS(1510),
    [anon_sym_any] = ACTIONS(1510),
    [anon_sym_number] = ACTIONS(1510),
    [anon_sym_boolean] = ACTIONS(1510),
    [anon_sym_string] = ACTIONS(1510),
    [anon_sym_symbol] = ACTIONS(1510),
    [sym_readonly] = ACTIONS(1510),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(1512),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_export] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_EQ] = ACTIONS(1514),
    [anon_sym_namespace] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_COMMA] = ACTIONS(1512),
    [anon_sym_RBRACE] = ACTIONS(1512),
    [anon_sym_typeof] = ACTIONS(1514),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_interface] = ACTIONS(1514),
    [anon_sym_declare] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [anon_sym_COLON] = ACTIONS(1512),
    [anon_sym_import] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_var] = ACTIONS(1514),
    [anon_sym_let] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_else] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [anon_sym_RPAREN] = ACTIONS(1512),
    [anon_sym_await] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_try] = ACTIONS(1514),
    [anon_sym_with] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_debugger] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_throw] = ACTIONS(1514),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_yield] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1512),
    [anon_sym_RBRACK] = ACTIONS(1512),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(1514),
    [anon_sym_function] = ACTIONS(1514),
    [anon_sym_EQ_GT] = ACTIONS(1512),
    [anon_sym_abstract] = ACTIONS(1514),
    [anon_sym_get] = ACTIONS(1514),
    [anon_sym_set] = ACTIONS(1514),
    [anon_sym_QMARK] = ACTIONS(1512),
    [anon_sym_extends] = ACTIONS(1514),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_void] = ACTIONS(1514),
    [anon_sym_delete] = ACTIONS(1514),
    [anon_sym_PLUS_PLUS] = ACTIONS(1512),
    [anon_sym_DASH_DASH] = ACTIONS(1512),
    [anon_sym_DQUOTE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1512),
    [sym_number] = ACTIONS(1512),
    [sym_this] = ACTIONS(1514),
    [sym_super] = ACTIONS(1514),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_null] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(1512),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_public] = ACTIONS(1514),
    [anon_sym_private] = ACTIONS(1514),
    [anon_sym_protected] = ACTIONS(1514),
    [anon_sym_any] = ACTIONS(1514),
    [anon_sym_number] = ACTIONS(1514),
    [anon_sym_boolean] = ACTIONS(1514),
    [anon_sym_string] = ACTIONS(1514),
    [anon_sym_symbol] = ACTIONS(1514),
    [sym_readonly] = ACTIONS(1514),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(1516),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_export] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_EQ] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_COMMA] = ACTIONS(1516),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_typeof] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1518),
    [anon_sym_interface] = ACTIONS(1518),
    [anon_sym_declare] = ACTIONS(1518),
    [anon_sym_module] = ACTIONS(1518),
    [anon_sym_COLON] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_var] = ACTIONS(1518),
    [anon_sym_let] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_else] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_LPAREN] = ACTIONS(1516),
    [anon_sym_RPAREN] = ACTIONS(1516),
    [anon_sym_await] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_try] = ACTIONS(1518),
    [anon_sym_with] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_debugger] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_throw] = ACTIONS(1518),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_yield] = ACTIONS(1518),
    [anon_sym_LBRACK] = ACTIONS(1516),
    [anon_sym_RBRACK] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1518),
    [anon_sym_async] = ACTIONS(1518),
    [anon_sym_function] = ACTIONS(1518),
    [anon_sym_EQ_GT] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1518),
    [anon_sym_get] = ACTIONS(1518),
    [anon_sym_set] = ACTIONS(1518),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_extends] = ACTIONS(1518),
    [anon_sym_new] = ACTIONS(1518),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_PIPE] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_SLASH] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(1516),
    [anon_sym_GT] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_void] = ACTIONS(1518),
    [anon_sym_delete] = ACTIONS(1518),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1516),
    [sym_number] = ACTIONS(1516),
    [sym_this] = ACTIONS(1518),
    [sym_super] = ACTIONS(1518),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [sym_null] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_public] = ACTIONS(1518),
    [anon_sym_private] = ACTIONS(1518),
    [anon_sym_protected] = ACTIONS(1518),
    [anon_sym_any] = ACTIONS(1518),
    [anon_sym_number] = ACTIONS(1518),
    [anon_sym_boolean] = ACTIONS(1518),
    [anon_sym_string] = ACTIONS(1518),
    [anon_sym_symbol] = ACTIONS(1518),
    [sym_readonly] = ACTIONS(1518),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1520),
    [sym_identifier] = ACTIONS(1522),
    [anon_sym_export] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(1522),
    [anon_sym_namespace] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_COMMA] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_typeof] = ACTIONS(1522),
    [anon_sym_type] = ACTIONS(1522),
    [anon_sym_interface] = ACTIONS(1522),
    [anon_sym_declare] = ACTIONS(1522),
    [anon_sym_module] = ACTIONS(1522),
    [anon_sym_COLON] = ACTIONS(1520),
    [anon_sym_import] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_var] = ACTIONS(1522),
    [anon_sym_let] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_else] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_RPAREN] = ACTIONS(1520),
    [anon_sym_await] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_try] = ACTIONS(1522),
    [anon_sym_with] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_debugger] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_throw] = ACTIONS(1522),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym_case] = ACTIONS(1522),
    [anon_sym_yield] = ACTIONS(1522),
    [anon_sym_LBRACK] = ACTIONS(1520),
    [anon_sym_RBRACK] = ACTIONS(1520),
    [anon_sym_class] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1522),
    [anon_sym_function] = ACTIONS(1522),
    [anon_sym_EQ_GT] = ACTIONS(1520),
    [anon_sym_abstract] = ACTIONS(1522),
    [anon_sym_get] = ACTIONS(1522),
    [anon_sym_set] = ACTIONS(1522),
    [anon_sym_QMARK] = ACTIONS(1520),
    [anon_sym_extends] = ACTIONS(1522),
    [anon_sym_new] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_SLASH] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(1520),
    [anon_sym_GT] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_void] = ACTIONS(1522),
    [anon_sym_delete] = ACTIONS(1522),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [sym_number] = ACTIONS(1520),
    [sym_this] = ACTIONS(1522),
    [sym_super] = ACTIONS(1522),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [sym_null] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1520),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_public] = ACTIONS(1522),
    [anon_sym_private] = ACTIONS(1522),
    [anon_sym_protected] = ACTIONS(1522),
    [anon_sym_any] = ACTIONS(1522),
    [anon_sym_number] = ACTIONS(1522),
    [anon_sym_boolean] = ACTIONS(1522),
    [anon_sym_string] = ACTIONS(1522),
    [anon_sym_symbol] = ACTIONS(1522),
    [sym_readonly] = ACTIONS(1522),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(1524),
    [sym_identifier] = ACTIONS(1526),
    [anon_sym_export] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_EQ] = ACTIONS(1526),
    [anon_sym_namespace] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_COMMA] = ACTIONS(1524),
    [anon_sym_RBRACE] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1526),
    [anon_sym_interface] = ACTIONS(1526),
    [anon_sym_declare] = ACTIONS(1526),
    [anon_sym_module] = ACTIONS(1526),
    [anon_sym_COLON] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_var] = ACTIONS(1526),
    [anon_sym_let] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_else] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_await] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1526),
    [anon_sym_try] = ACTIONS(1526),
    [anon_sym_with] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_debugger] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_throw] = ACTIONS(1526),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym_case] = ACTIONS(1526),
    [anon_sym_yield] = ACTIONS(1526),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1526),
    [anon_sym_function] = ACTIONS(1526),
    [anon_sym_EQ_GT] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1526),
    [anon_sym_get] = ACTIONS(1526),
    [anon_sym_set] = ACTIONS(1526),
    [anon_sym_QMARK] = ACTIONS(1524),
    [anon_sym_extends] = ACTIONS(1526),
    [anon_sym_new] = ACTIONS(1526),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_SLASH] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_void] = ACTIONS(1526),
    [anon_sym_delete] = ACTIONS(1526),
    [anon_sym_PLUS_PLUS] = ACTIONS(1524),
    [anon_sym_DASH_DASH] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1524),
    [sym_number] = ACTIONS(1524),
    [sym_this] = ACTIONS(1526),
    [sym_super] = ACTIONS(1526),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [sym_null] = ACTIONS(1526),
    [anon_sym_AT] = ACTIONS(1524),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_public] = ACTIONS(1526),
    [anon_sym_private] = ACTIONS(1526),
    [anon_sym_protected] = ACTIONS(1526),
    [anon_sym_any] = ACTIONS(1526),
    [anon_sym_number] = ACTIONS(1526),
    [anon_sym_boolean] = ACTIONS(1526),
    [anon_sym_string] = ACTIONS(1526),
    [anon_sym_symbol] = ACTIONS(1526),
    [sym_readonly] = ACTIONS(1526),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1528),
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_export] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_EQ] = ACTIONS(1530),
    [anon_sym_namespace] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_COMMA] = ACTIONS(1528),
    [anon_sym_RBRACE] = ACTIONS(1528),
    [anon_sym_typeof] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_interface] = ACTIONS(1530),
    [anon_sym_declare] = ACTIONS(1530),
    [anon_sym_module] = ACTIONS(1530),
    [anon_sym_COLON] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_var] = ACTIONS(1530),
    [anon_sym_let] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_else] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [anon_sym_RPAREN] = ACTIONS(1528),
    [anon_sym_await] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_debugger] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_throw] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_yield] = ACTIONS(1530),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_class] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(1528),
    [anon_sym_abstract] = ACTIONS(1530),
    [anon_sym_get] = ACTIONS(1530),
    [anon_sym_set] = ACTIONS(1530),
    [anon_sym_QMARK] = ACTIONS(1528),
    [anon_sym_extends] = ACTIONS(1530),
    [anon_sym_new] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_SLASH] = ACTIONS(1530),
    [anon_sym_LT] = ACTIONS(1528),
    [anon_sym_GT] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_void] = ACTIONS(1530),
    [anon_sym_delete] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_DASH_DASH] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1528),
    [sym_number] = ACTIONS(1528),
    [sym_this] = ACTIONS(1530),
    [sym_super] = ACTIONS(1530),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [sym_null] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1528),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_public] = ACTIONS(1530),
    [anon_sym_private] = ACTIONS(1530),
    [anon_sym_protected] = ACTIONS(1530),
    [anon_sym_any] = ACTIONS(1530),
    [anon_sym_number] = ACTIONS(1530),
    [anon_sym_boolean] = ACTIONS(1530),
    [anon_sym_string] = ACTIONS(1530),
    [anon_sym_symbol] = ACTIONS(1530),
    [sym_readonly] = ACTIONS(1530),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1532),
    [sym_identifier] = ACTIONS(1534),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_default] = ACTIONS(1534),
    [anon_sym_EQ] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_typeof] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_interface] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_COLON] = ACTIONS(1532),
    [anon_sym_import] = ACTIONS(1534),
    [anon_sym_const] = ACTIONS(1534),
    [anon_sym_enum] = ACTIONS(1534),
    [anon_sym_var] = ACTIONS(1534),
    [anon_sym_let] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1534),
    [anon_sym_if] = ACTIONS(1534),
    [anon_sym_switch] = ACTIONS(1534),
    [anon_sym_for] = ACTIONS(1534),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_await] = ACTIONS(1534),
    [anon_sym_while] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(1534),
    [anon_sym_try] = ACTIONS(1534),
    [anon_sym_with] = ACTIONS(1534),
    [anon_sym_break] = ACTIONS(1534),
    [anon_sym_continue] = ACTIONS(1534),
    [anon_sym_debugger] = ACTIONS(1534),
    [anon_sym_return] = ACTIONS(1534),
    [anon_sym_throw] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_case] = ACTIONS(1534),
    [anon_sym_yield] = ACTIONS(1534),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_class] = ACTIONS(1534),
    [anon_sym_async] = ACTIONS(1534),
    [anon_sym_function] = ACTIONS(1534),
    [anon_sym_EQ_GT] = ACTIONS(1532),
    [anon_sym_abstract] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_QMARK] = ACTIONS(1532),
    [anon_sym_extends] = ACTIONS(1538),
    [anon_sym_new] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_SLASH] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_void] = ACTIONS(1534),
    [anon_sym_delete] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_number] = ACTIONS(1532),
    [sym_this] = ACTIONS(1534),
    [sym_super] = ACTIONS(1534),
    [sym_true] = ACTIONS(1534),
    [sym_false] = ACTIONS(1534),
    [sym_null] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [sym_readonly] = ACTIONS(1534),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1540),
    [sym_identifier] = ACTIONS(1542),
    [anon_sym_export] = ACTIONS(1542),
    [anon_sym_default] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_namespace] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [anon_sym_COMMA] = ACTIONS(1540),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_typeof] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1542),
    [anon_sym_interface] = ACTIONS(1542),
    [anon_sym_declare] = ACTIONS(1542),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(1542),
    [anon_sym_const] = ACTIONS(1542),
    [anon_sym_enum] = ACTIONS(1542),
    [anon_sym_var] = ACTIONS(1542),
    [anon_sym_let] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_if] = ACTIONS(1542),
    [anon_sym_switch] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1542),
    [anon_sym_try] = ACTIONS(1542),
    [anon_sym_with] = ACTIONS(1542),
    [anon_sym_break] = ACTIONS(1542),
    [anon_sym_continue] = ACTIONS(1542),
    [anon_sym_debugger] = ACTIONS(1542),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_throw] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_case] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_class] = ACTIONS(1542),
    [anon_sym_async] = ACTIONS(1542),
    [anon_sym_function] = ACTIONS(1542),
    [anon_sym_EQ_GT] = ACTIONS(1540),
    [anon_sym_abstract] = ACTIONS(1542),
    [anon_sym_get] = ACTIONS(1542),
    [anon_sym_set] = ACTIONS(1542),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_extends] = ACTIONS(1542),
    [anon_sym_new] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_SLASH] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1542),
    [anon_sym_delete] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [sym_number] = ACTIONS(1540),
    [sym_this] = ACTIONS(1542),
    [sym_super] = ACTIONS(1542),
    [sym_true] = ACTIONS(1542),
    [sym_false] = ACTIONS(1542),
    [sym_null] = ACTIONS(1542),
    [anon_sym_AT] = ACTIONS(1540),
    [anon_sym_static] = ACTIONS(1542),
    [anon_sym_public] = ACTIONS(1542),
    [anon_sym_private] = ACTIONS(1542),
    [anon_sym_protected] = ACTIONS(1542),
    [anon_sym_any] = ACTIONS(1542),
    [anon_sym_number] = ACTIONS(1542),
    [anon_sym_boolean] = ACTIONS(1542),
    [anon_sym_string] = ACTIONS(1542),
    [anon_sym_symbol] = ACTIONS(1542),
    [sym_readonly] = ACTIONS(1542),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1074),
    [anon_sym_EQ] = ACTIONS(1074),
    [anon_sym_namespace] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_typeof] = ACTIONS(1074),
    [anon_sym_type] = ACTIONS(1074),
    [anon_sym_interface] = ACTIONS(1074),
    [anon_sym_declare] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_COLON] = ACTIONS(1072),
    [anon_sym_import] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_RPAREN] = ACTIONS(1072),
    [anon_sym_await] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_with] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_debugger] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_throw] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1074),
    [anon_sym_yield] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_RBRACK] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1074),
    [anon_sym_EQ_GT] = ACTIONS(1072),
    [anon_sym_abstract] = ACTIONS(1074),
    [anon_sym_get] = ACTIONS(1074),
    [anon_sym_set] = ACTIONS(1074),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_extends] = ACTIONS(1074),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_LT] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1074),
    [anon_sym_delete] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_number] = ACTIONS(1072),
    [sym_this] = ACTIONS(1074),
    [sym_super] = ACTIONS(1074),
    [sym_true] = ACTIONS(1074),
    [sym_false] = ACTIONS(1074),
    [sym_null] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(1074),
    [anon_sym_public] = ACTIONS(1074),
    [anon_sym_private] = ACTIONS(1074),
    [anon_sym_protected] = ACTIONS(1074),
    [anon_sym_any] = ACTIONS(1074),
    [anon_sym_number] = ACTIONS(1074),
    [anon_sym_boolean] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [anon_sym_symbol] = ACTIONS(1074),
    [sym_readonly] = ACTIONS(1074),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_export] = ACTIONS(1546),
    [anon_sym_default] = ACTIONS(1546),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_namespace] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_COMMA] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_typeof] = ACTIONS(1546),
    [anon_sym_type] = ACTIONS(1546),
    [anon_sym_interface] = ACTIONS(1546),
    [anon_sym_declare] = ACTIONS(1546),
    [anon_sym_module] = ACTIONS(1546),
    [anon_sym_COLON] = ACTIONS(1544),
    [anon_sym_import] = ACTIONS(1546),
    [anon_sym_const] = ACTIONS(1546),
    [anon_sym_enum] = ACTIONS(1546),
    [anon_sym_var] = ACTIONS(1546),
    [anon_sym_let] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_switch] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_await] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_do] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [anon_sym_with] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_debugger] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_throw] = ACTIONS(1546),
    [anon_sym_SEMI] = ACTIONS(1544),
    [anon_sym_case] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_class] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_function] = ACTIONS(1546),
    [anon_sym_EQ_GT] = ACTIONS(1544),
    [anon_sym_abstract] = ACTIONS(1546),
    [anon_sym_get] = ACTIONS(1546),
    [anon_sym_set] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1544),
    [anon_sym_extends] = ACTIONS(1546),
    [anon_sym_new] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1544),
    [anon_sym_void] = ACTIONS(1546),
    [anon_sym_delete] = ACTIONS(1546),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [anon_sym_SQUOTE] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [sym_number] = ACTIONS(1544),
    [sym_this] = ACTIONS(1546),
    [sym_super] = ACTIONS(1546),
    [sym_true] = ACTIONS(1546),
    [sym_false] = ACTIONS(1546),
    [sym_null] = ACTIONS(1546),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_public] = ACTIONS(1546),
    [anon_sym_private] = ACTIONS(1546),
    [anon_sym_protected] = ACTIONS(1546),
    [anon_sym_any] = ACTIONS(1546),
    [anon_sym_number] = ACTIONS(1546),
    [anon_sym_boolean] = ACTIONS(1546),
    [anon_sym_string] = ACTIONS(1546),
    [anon_sym_symbol] = ACTIONS(1546),
    [sym_readonly] = ACTIONS(1546),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(1548),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_export] = ACTIONS(1550),
    [anon_sym_default] = ACTIONS(1550),
    [anon_sym_EQ] = ACTIONS(1550),
    [anon_sym_namespace] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_typeof] = ACTIONS(1550),
    [anon_sym_type] = ACTIONS(1550),
    [anon_sym_interface] = ACTIONS(1550),
    [anon_sym_declare] = ACTIONS(1550),
    [anon_sym_module] = ACTIONS(1550),
    [anon_sym_COLON] = ACTIONS(1548),
    [anon_sym_import] = ACTIONS(1550),
    [anon_sym_const] = ACTIONS(1550),
    [anon_sym_enum] = ACTIONS(1550),
    [anon_sym_var] = ACTIONS(1550),
    [anon_sym_let] = ACTIONS(1550),
    [anon_sym_BANG] = ACTIONS(1548),
    [anon_sym_else] = ACTIONS(1550),
    [anon_sym_if] = ACTIONS(1550),
    [anon_sym_switch] = ACTIONS(1550),
    [anon_sym_for] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_RPAREN] = ACTIONS(1548),
    [anon_sym_await] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1550),
    [anon_sym_do] = ACTIONS(1550),
    [anon_sym_try] = ACTIONS(1550),
    [anon_sym_with] = ACTIONS(1550),
    [anon_sym_break] = ACTIONS(1550),
    [anon_sym_continue] = ACTIONS(1550),
    [anon_sym_debugger] = ACTIONS(1550),
    [anon_sym_return] = ACTIONS(1550),
    [anon_sym_throw] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_case] = ACTIONS(1550),
    [anon_sym_yield] = ACTIONS(1550),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_RBRACK] = ACTIONS(1548),
    [anon_sym_class] = ACTIONS(1550),
    [anon_sym_async] = ACTIONS(1550),
    [anon_sym_function] = ACTIONS(1550),
    [anon_sym_EQ_GT] = ACTIONS(1548),
    [anon_sym_abstract] = ACTIONS(1550),
    [anon_sym_get] = ACTIONS(1550),
    [anon_sym_set] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(1548),
    [anon_sym_extends] = ACTIONS(1550),
    [anon_sym_new] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1548),
    [anon_sym_GT] = ACTIONS(1548),
    [anon_sym_TILDE] = ACTIONS(1548),
    [anon_sym_void] = ACTIONS(1550),
    [anon_sym_delete] = ACTIONS(1550),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [sym_number] = ACTIONS(1548),
    [sym_this] = ACTIONS(1550),
    [sym_super] = ACTIONS(1550),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_null] = ACTIONS(1550),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_static] = ACTIONS(1550),
    [anon_sym_public] = ACTIONS(1550),
    [anon_sym_private] = ACTIONS(1550),
    [anon_sym_protected] = ACTIONS(1550),
    [anon_sym_any] = ACTIONS(1550),
    [anon_sym_number] = ACTIONS(1550),
    [anon_sym_boolean] = ACTIONS(1550),
    [anon_sym_string] = ACTIONS(1550),
    [anon_sym_symbol] = ACTIONS(1550),
    [sym_readonly] = ACTIONS(1550),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1552),
    [sym_identifier] = ACTIONS(1554),
    [anon_sym_export] = ACTIONS(1554),
    [anon_sym_default] = ACTIONS(1554),
    [anon_sym_EQ] = ACTIONS(1554),
    [anon_sym_namespace] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_COMMA] = ACTIONS(1552),
    [anon_sym_RBRACE] = ACTIONS(1552),
    [anon_sym_typeof] = ACTIONS(1554),
    [anon_sym_type] = ACTIONS(1554),
    [anon_sym_interface] = ACTIONS(1554),
    [anon_sym_declare] = ACTIONS(1554),
    [anon_sym_module] = ACTIONS(1554),
    [anon_sym_COLON] = ACTIONS(1552),
    [anon_sym_import] = ACTIONS(1554),
    [anon_sym_const] = ACTIONS(1554),
    [anon_sym_enum] = ACTIONS(1554),
    [anon_sym_var] = ACTIONS(1554),
    [anon_sym_let] = ACTIONS(1554),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_else] = ACTIONS(1554),
    [anon_sym_if] = ACTIONS(1554),
    [anon_sym_switch] = ACTIONS(1554),
    [anon_sym_for] = ACTIONS(1554),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [anon_sym_RPAREN] = ACTIONS(1552),
    [anon_sym_await] = ACTIONS(1554),
    [anon_sym_while] = ACTIONS(1554),
    [anon_sym_do] = ACTIONS(1554),
    [anon_sym_try] = ACTIONS(1554),
    [anon_sym_with] = ACTIONS(1554),
    [anon_sym_break] = ACTIONS(1554),
    [anon_sym_continue] = ACTIONS(1554),
    [anon_sym_debugger] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(1554),
    [anon_sym_throw] = ACTIONS(1554),
    [anon_sym_SEMI] = ACTIONS(1552),
    [anon_sym_case] = ACTIONS(1554),
    [anon_sym_yield] = ACTIONS(1554),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_RBRACK] = ACTIONS(1552),
    [anon_sym_class] = ACTIONS(1554),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_EQ_GT] = ACTIONS(1552),
    [anon_sym_abstract] = ACTIONS(1554),
    [anon_sym_get] = ACTIONS(1554),
    [anon_sym_set] = ACTIONS(1554),
    [anon_sym_QMARK] = ACTIONS(1552),
    [anon_sym_extends] = ACTIONS(1554),
    [anon_sym_new] = ACTIONS(1554),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_PLUS] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_SLASH] = ACTIONS(1554),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym_GT] = ACTIONS(1552),
    [anon_sym_TILDE] = ACTIONS(1552),
    [anon_sym_void] = ACTIONS(1554),
    [anon_sym_delete] = ACTIONS(1554),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_DQUOTE] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1552),
    [sym_number] = ACTIONS(1552),
    [sym_this] = ACTIONS(1554),
    [sym_super] = ACTIONS(1554),
    [sym_true] = ACTIONS(1554),
    [sym_false] = ACTIONS(1554),
    [sym_null] = ACTIONS(1554),
    [anon_sym_AT] = ACTIONS(1552),
    [anon_sym_static] = ACTIONS(1554),
    [anon_sym_public] = ACTIONS(1554),
    [anon_sym_private] = ACTIONS(1554),
    [anon_sym_protected] = ACTIONS(1554),
    [anon_sym_any] = ACTIONS(1554),
    [anon_sym_number] = ACTIONS(1554),
    [anon_sym_boolean] = ACTIONS(1554),
    [anon_sym_string] = ACTIONS(1554),
    [anon_sym_symbol] = ACTIONS(1554),
    [sym_readonly] = ACTIONS(1554),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1556),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_export] = ACTIONS(1558),
    [anon_sym_default] = ACTIONS(1558),
    [anon_sym_EQ] = ACTIONS(1558),
    [anon_sym_namespace] = ACTIONS(1558),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_COMMA] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1556),
    [anon_sym_typeof] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_interface] = ACTIONS(1558),
    [anon_sym_declare] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(1556),
    [anon_sym_import] = ACTIONS(1558),
    [anon_sym_const] = ACTIONS(1558),
    [anon_sym_enum] = ACTIONS(1558),
    [anon_sym_var] = ACTIONS(1558),
    [anon_sym_let] = ACTIONS(1558),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_else] = ACTIONS(1558),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1558),
    [anon_sym_for] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_RPAREN] = ACTIONS(1556),
    [anon_sym_await] = ACTIONS(1558),
    [anon_sym_while] = ACTIONS(1558),
    [anon_sym_do] = ACTIONS(1558),
    [anon_sym_try] = ACTIONS(1558),
    [anon_sym_with] = ACTIONS(1558),
    [anon_sym_break] = ACTIONS(1558),
    [anon_sym_continue] = ACTIONS(1558),
    [anon_sym_debugger] = ACTIONS(1558),
    [anon_sym_return] = ACTIONS(1558),
    [anon_sym_throw] = ACTIONS(1558),
    [anon_sym_SEMI] = ACTIONS(1556),
    [anon_sym_case] = ACTIONS(1558),
    [anon_sym_yield] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_RBRACK] = ACTIONS(1556),
    [anon_sym_class] = ACTIONS(1558),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_function] = ACTIONS(1558),
    [anon_sym_EQ_GT] = ACTIONS(1556),
    [anon_sym_abstract] = ACTIONS(1558),
    [anon_sym_get] = ACTIONS(1558),
    [anon_sym_set] = ACTIONS(1558),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_extends] = ACTIONS(1558),
    [anon_sym_new] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1558),
    [anon_sym_DASH] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym_GT] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1556),
    [anon_sym_void] = ACTIONS(1558),
    [anon_sym_delete] = ACTIONS(1558),
    [anon_sym_PLUS_PLUS] = ACTIONS(1556),
    [anon_sym_DASH_DASH] = ACTIONS(1556),
    [anon_sym_DQUOTE] = ACTIONS(1556),
    [anon_sym_SQUOTE] = ACTIONS(1556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1556),
    [sym_number] = ACTIONS(1556),
    [sym_this] = ACTIONS(1558),
    [sym_super] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_null] = ACTIONS(1558),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_static] = ACTIONS(1558),
    [anon_sym_public] = ACTIONS(1558),
    [anon_sym_private] = ACTIONS(1558),
    [anon_sym_protected] = ACTIONS(1558),
    [anon_sym_any] = ACTIONS(1558),
    [anon_sym_number] = ACTIONS(1558),
    [anon_sym_boolean] = ACTIONS(1558),
    [anon_sym_string] = ACTIONS(1558),
    [anon_sym_symbol] = ACTIONS(1558),
    [sym_readonly] = ACTIONS(1558),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1560),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_export] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1562),
    [anon_sym_EQ] = ACTIONS(1562),
    [anon_sym_namespace] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(1560),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [anon_sym_typeof] = ACTIONS(1562),
    [anon_sym_type] = ACTIONS(1562),
    [anon_sym_interface] = ACTIONS(1562),
    [anon_sym_declare] = ACTIONS(1562),
    [anon_sym_module] = ACTIONS(1562),
    [anon_sym_COLON] = ACTIONS(1560),
    [anon_sym_import] = ACTIONS(1562),
    [anon_sym_const] = ACTIONS(1562),
    [anon_sym_enum] = ACTIONS(1562),
    [anon_sym_var] = ACTIONS(1562),
    [anon_sym_let] = ACTIONS(1562),
    [anon_sym_BANG] = ACTIONS(1560),
    [anon_sym_else] = ACTIONS(1562),
    [anon_sym_if] = ACTIONS(1562),
    [anon_sym_switch] = ACTIONS(1562),
    [anon_sym_for] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(1560),
    [anon_sym_await] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(1562),
    [anon_sym_do] = ACTIONS(1562),
    [anon_sym_try] = ACTIONS(1562),
    [anon_sym_with] = ACTIONS(1562),
    [anon_sym_break] = ACTIONS(1562),
    [anon_sym_continue] = ACTIONS(1562),
    [anon_sym_debugger] = ACTIONS(1562),
    [anon_sym_return] = ACTIONS(1562),
    [anon_sym_throw] = ACTIONS(1562),
    [anon_sym_SEMI] = ACTIONS(1560),
    [anon_sym_case] = ACTIONS(1562),
    [anon_sym_yield] = ACTIONS(1562),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [anon_sym_RBRACK] = ACTIONS(1560),
    [anon_sym_class] = ACTIONS(1562),
    [anon_sym_async] = ACTIONS(1562),
    [anon_sym_function] = ACTIONS(1562),
    [anon_sym_EQ_GT] = ACTIONS(1560),
    [anon_sym_abstract] = ACTIONS(1562),
    [anon_sym_get] = ACTIONS(1562),
    [anon_sym_set] = ACTIONS(1562),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_extends] = ACTIONS(1562),
    [anon_sym_new] = ACTIONS(1562),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_PIPE] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1562),
    [anon_sym_DASH] = ACTIONS(1562),
    [anon_sym_SLASH] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_GT] = ACTIONS(1560),
    [anon_sym_TILDE] = ACTIONS(1560),
    [anon_sym_void] = ACTIONS(1562),
    [anon_sym_delete] = ACTIONS(1562),
    [anon_sym_PLUS_PLUS] = ACTIONS(1560),
    [anon_sym_DASH_DASH] = ACTIONS(1560),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1560),
    [sym_number] = ACTIONS(1560),
    [sym_this] = ACTIONS(1562),
    [sym_super] = ACTIONS(1562),
    [sym_true] = ACTIONS(1562),
    [sym_false] = ACTIONS(1562),
    [sym_null] = ACTIONS(1562),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_static] = ACTIONS(1562),
    [anon_sym_public] = ACTIONS(1562),
    [anon_sym_private] = ACTIONS(1562),
    [anon_sym_protected] = ACTIONS(1562),
    [anon_sym_any] = ACTIONS(1562),
    [anon_sym_number] = ACTIONS(1562),
    [anon_sym_boolean] = ACTIONS(1562),
    [anon_sym_string] = ACTIONS(1562),
    [anon_sym_symbol] = ACTIONS(1562),
    [sym_readonly] = ACTIONS(1562),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(1566),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1568),
    [anon_sym_EQ] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1568),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [anon_sym_typeof] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_interface] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_COLON] = ACTIONS(1566),
    [anon_sym_import] = ACTIONS(1568),
    [anon_sym_const] = ACTIONS(1568),
    [anon_sym_enum] = ACTIONS(1568),
    [anon_sym_var] = ACTIONS(1568),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_else] = ACTIONS(1568),
    [anon_sym_if] = ACTIONS(1568),
    [anon_sym_switch] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(1566),
    [anon_sym_await] = ACTIONS(1568),
    [anon_sym_while] = ACTIONS(1568),
    [anon_sym_do] = ACTIONS(1568),
    [anon_sym_try] = ACTIONS(1568),
    [anon_sym_with] = ACTIONS(1568),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1568),
    [anon_sym_debugger] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(1568),
    [anon_sym_throw] = ACTIONS(1568),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_yield] = ACTIONS(1568),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [anon_sym_class] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1568),
    [anon_sym_function] = ACTIONS(1568),
    [anon_sym_EQ_GT] = ACTIONS(1566),
    [anon_sym_abstract] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_QMARK] = ACTIONS(1566),
    [anon_sym_extends] = ACTIONS(1568),
    [anon_sym_new] = ACTIONS(1568),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1568),
    [anon_sym_DASH] = ACTIONS(1568),
    [anon_sym_SLASH] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_void] = ACTIONS(1568),
    [anon_sym_delete] = ACTIONS(1568),
    [anon_sym_PLUS_PLUS] = ACTIONS(1566),
    [anon_sym_DASH_DASH] = ACTIONS(1566),
    [anon_sym_DQUOTE] = ACTIONS(1566),
    [anon_sym_SQUOTE] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1566),
    [sym_number] = ACTIONS(1566),
    [sym_this] = ACTIONS(1568),
    [sym_super] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_null] = ACTIONS(1568),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_static] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [sym_readonly] = ACTIONS(1568),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1243),
    [sym_identifier] = ACTIONS(1245),
    [anon_sym_export] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(1245),
    [anon_sym_namespace] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1245),
    [anon_sym_type] = ACTIONS(1245),
    [anon_sym_interface] = ACTIONS(1245),
    [anon_sym_declare] = ACTIONS(1245),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_COLON] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_var] = ACTIONS(1245),
    [anon_sym_let] = ACTIONS(1245),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_LPAREN] = ACTIONS(1243),
    [anon_sym_RPAREN] = ACTIONS(1243),
    [anon_sym_await] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_try] = ACTIONS(1245),
    [anon_sym_with] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_debugger] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_throw] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_LBRACK] = ACTIONS(1243),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_class] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1245),
    [anon_sym_function] = ACTIONS(1245),
    [anon_sym_EQ_GT] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1245),
    [anon_sym_get] = ACTIONS(1245),
    [anon_sym_set] = ACTIONS(1245),
    [anon_sym_QMARK] = ACTIONS(1243),
    [anon_sym_extends] = ACTIONS(1245),
    [anon_sym_new] = ACTIONS(1245),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_void] = ACTIONS(1245),
    [anon_sym_delete] = ACTIONS(1245),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1243),
    [sym_number] = ACTIONS(1243),
    [sym_this] = ACTIONS(1245),
    [sym_super] = ACTIONS(1245),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [anon_sym_AT] = ACTIONS(1243),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_public] = ACTIONS(1245),
    [anon_sym_private] = ACTIONS(1245),
    [anon_sym_protected] = ACTIONS(1245),
    [anon_sym_any] = ACTIONS(1245),
    [anon_sym_number] = ACTIONS(1245),
    [anon_sym_boolean] = ACTIONS(1245),
    [anon_sym_string] = ACTIONS(1245),
    [anon_sym_symbol] = ACTIONS(1245),
    [sym_readonly] = ACTIONS(1245),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1570),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_export] = ACTIONS(1572),
    [anon_sym_default] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(1572),
    [anon_sym_namespace] = ACTIONS(1572),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_COMMA] = ACTIONS(1570),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [anon_sym_typeof] = ACTIONS(1572),
    [anon_sym_type] = ACTIONS(1572),
    [anon_sym_interface] = ACTIONS(1572),
    [anon_sym_declare] = ACTIONS(1572),
    [anon_sym_module] = ACTIONS(1572),
    [anon_sym_COLON] = ACTIONS(1570),
    [anon_sym_import] = ACTIONS(1572),
    [anon_sym_const] = ACTIONS(1572),
    [anon_sym_enum] = ACTIONS(1572),
    [anon_sym_var] = ACTIONS(1572),
    [anon_sym_let] = ACTIONS(1572),
    [anon_sym_BANG] = ACTIONS(1570),
    [anon_sym_else] = ACTIONS(1572),
    [anon_sym_if] = ACTIONS(1572),
    [anon_sym_switch] = ACTIONS(1572),
    [anon_sym_for] = ACTIONS(1572),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [anon_sym_await] = ACTIONS(1572),
    [anon_sym_while] = ACTIONS(1572),
    [anon_sym_do] = ACTIONS(1572),
    [anon_sym_try] = ACTIONS(1572),
    [anon_sym_with] = ACTIONS(1572),
    [anon_sym_break] = ACTIONS(1572),
    [anon_sym_continue] = ACTIONS(1572),
    [anon_sym_debugger] = ACTIONS(1572),
    [anon_sym_return] = ACTIONS(1572),
    [anon_sym_throw] = ACTIONS(1572),
    [anon_sym_SEMI] = ACTIONS(1570),
    [anon_sym_case] = ACTIONS(1572),
    [anon_sym_yield] = ACTIONS(1572),
    [anon_sym_LBRACK] = ACTIONS(1570),
    [anon_sym_RBRACK] = ACTIONS(1570),
    [anon_sym_class] = ACTIONS(1572),
    [anon_sym_async] = ACTIONS(1572),
    [anon_sym_function] = ACTIONS(1572),
    [anon_sym_EQ_GT] = ACTIONS(1570),
    [anon_sym_abstract] = ACTIONS(1572),
    [anon_sym_get] = ACTIONS(1572),
    [anon_sym_set] = ACTIONS(1572),
    [anon_sym_QMARK] = ACTIONS(1570),
    [anon_sym_extends] = ACTIONS(1572),
    [anon_sym_new] = ACTIONS(1572),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1572),
    [anon_sym_DASH] = ACTIONS(1572),
    [anon_sym_SLASH] = ACTIONS(1572),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_TILDE] = ACTIONS(1570),
    [anon_sym_void] = ACTIONS(1572),
    [anon_sym_delete] = ACTIONS(1572),
    [anon_sym_PLUS_PLUS] = ACTIONS(1570),
    [anon_sym_DASH_DASH] = ACTIONS(1570),
    [anon_sym_DQUOTE] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1570),
    [sym_number] = ACTIONS(1570),
    [sym_this] = ACTIONS(1572),
    [sym_super] = ACTIONS(1572),
    [sym_true] = ACTIONS(1572),
    [sym_false] = ACTIONS(1572),
    [sym_null] = ACTIONS(1572),
    [anon_sym_AT] = ACTIONS(1570),
    [anon_sym_static] = ACTIONS(1572),
    [anon_sym_public] = ACTIONS(1572),
    [anon_sym_private] = ACTIONS(1572),
    [anon_sym_protected] = ACTIONS(1572),
    [anon_sym_any] = ACTIONS(1572),
    [anon_sym_number] = ACTIONS(1572),
    [anon_sym_boolean] = ACTIONS(1572),
    [anon_sym_string] = ACTIONS(1572),
    [anon_sym_symbol] = ACTIONS(1572),
    [sym_readonly] = ACTIONS(1572),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1536),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_export] = ACTIONS(1538),
    [anon_sym_default] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1538),
    [anon_sym_namespace] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1536),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_typeof] = ACTIONS(1538),
    [anon_sym_type] = ACTIONS(1538),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_declare] = ACTIONS(1538),
    [anon_sym_module] = ACTIONS(1538),
    [anon_sym_COLON] = ACTIONS(1536),
    [anon_sym_import] = ACTIONS(1538),
    [anon_sym_const] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1538),
    [anon_sym_var] = ACTIONS(1538),
    [anon_sym_let] = ACTIONS(1538),
    [anon_sym_BANG] = ACTIONS(1536),
    [anon_sym_else] = ACTIONS(1538),
    [anon_sym_if] = ACTIONS(1538),
    [anon_sym_switch] = ACTIONS(1538),
    [anon_sym_for] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [anon_sym_await] = ACTIONS(1538),
    [anon_sym_while] = ACTIONS(1538),
    [anon_sym_do] = ACTIONS(1538),
    [anon_sym_try] = ACTIONS(1538),
    [anon_sym_with] = ACTIONS(1538),
    [anon_sym_break] = ACTIONS(1538),
    [anon_sym_continue] = ACTIONS(1538),
    [anon_sym_debugger] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1538),
    [anon_sym_throw] = ACTIONS(1538),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_case] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(1538),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_class] = ACTIONS(1538),
    [anon_sym_async] = ACTIONS(1538),
    [anon_sym_function] = ACTIONS(1538),
    [anon_sym_EQ_GT] = ACTIONS(1536),
    [anon_sym_abstract] = ACTIONS(1538),
    [anon_sym_get] = ACTIONS(1538),
    [anon_sym_set] = ACTIONS(1538),
    [anon_sym_QMARK] = ACTIONS(1536),
    [anon_sym_extends] = ACTIONS(1538),
    [anon_sym_new] = ACTIONS(1538),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_SLASH] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(1536),
    [anon_sym_GT] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1536),
    [anon_sym_void] = ACTIONS(1538),
    [anon_sym_delete] = ACTIONS(1538),
    [anon_sym_PLUS_PLUS] = ACTIONS(1536),
    [anon_sym_DASH_DASH] = ACTIONS(1536),
    [anon_sym_DQUOTE] = ACTIONS(1536),
    [anon_sym_SQUOTE] = ACTIONS(1536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [sym_number] = ACTIONS(1536),
    [sym_this] = ACTIONS(1538),
    [sym_super] = ACTIONS(1538),
    [sym_true] = ACTIONS(1538),
    [sym_false] = ACTIONS(1538),
    [sym_null] = ACTIONS(1538),
    [anon_sym_AT] = ACTIONS(1536),
    [anon_sym_static] = ACTIONS(1538),
    [anon_sym_public] = ACTIONS(1538),
    [anon_sym_private] = ACTIONS(1538),
    [anon_sym_protected] = ACTIONS(1538),
    [anon_sym_any] = ACTIONS(1538),
    [anon_sym_number] = ACTIONS(1538),
    [anon_sym_boolean] = ACTIONS(1538),
    [anon_sym_string] = ACTIONS(1538),
    [anon_sym_symbol] = ACTIONS(1538),
    [sym_readonly] = ACTIONS(1538),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(1574),
    [sym_identifier] = ACTIONS(1576),
    [anon_sym_export] = ACTIONS(1576),
    [anon_sym_default] = ACTIONS(1576),
    [anon_sym_EQ] = ACTIONS(1576),
    [anon_sym_namespace] = ACTIONS(1576),
    [anon_sym_LBRACE] = ACTIONS(1574),
    [anon_sym_COMMA] = ACTIONS(1574),
    [anon_sym_RBRACE] = ACTIONS(1574),
    [anon_sym_typeof] = ACTIONS(1576),
    [anon_sym_type] = ACTIONS(1576),
    [anon_sym_interface] = ACTIONS(1576),
    [anon_sym_declare] = ACTIONS(1576),
    [anon_sym_module] = ACTIONS(1576),
    [anon_sym_COLON] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(1576),
    [anon_sym_const] = ACTIONS(1576),
    [anon_sym_enum] = ACTIONS(1576),
    [anon_sym_var] = ACTIONS(1576),
    [anon_sym_let] = ACTIONS(1576),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_else] = ACTIONS(1576),
    [anon_sym_if] = ACTIONS(1576),
    [anon_sym_switch] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_LPAREN] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1574),
    [anon_sym_await] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1576),
    [anon_sym_do] = ACTIONS(1576),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_with] = ACTIONS(1576),
    [anon_sym_break] = ACTIONS(1576),
    [anon_sym_continue] = ACTIONS(1576),
    [anon_sym_debugger] = ACTIONS(1576),
    [anon_sym_return] = ACTIONS(1576),
    [anon_sym_throw] = ACTIONS(1576),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym_case] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1576),
    [anon_sym_LBRACK] = ACTIONS(1574),
    [anon_sym_RBRACK] = ACTIONS(1574),
    [anon_sym_class] = ACTIONS(1576),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_function] = ACTIONS(1576),
    [anon_sym_EQ_GT] = ACTIONS(1574),
    [anon_sym_abstract] = ACTIONS(1576),
    [anon_sym_get] = ACTIONS(1576),
    [anon_sym_set] = ACTIONS(1576),
    [anon_sym_QMARK] = ACTIONS(1574),
    [anon_sym_extends] = ACTIONS(1576),
    [anon_sym_new] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_PLUS] = ACTIONS(1576),
    [anon_sym_DASH] = ACTIONS(1576),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_TILDE] = ACTIONS(1574),
    [anon_sym_void] = ACTIONS(1576),
    [anon_sym_delete] = ACTIONS(1576),
    [anon_sym_PLUS_PLUS] = ACTIONS(1574),
    [anon_sym_DASH_DASH] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(1574),
    [anon_sym_SQUOTE] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1574),
    [sym_number] = ACTIONS(1574),
    [sym_this] = ACTIONS(1576),
    [sym_super] = ACTIONS(1576),
    [sym_true] = ACTIONS(1576),
    [sym_false] = ACTIONS(1576),
    [sym_null] = ACTIONS(1576),
    [anon_sym_AT] = ACTIONS(1574),
    [anon_sym_static] = ACTIONS(1576),
    [anon_sym_public] = ACTIONS(1576),
    [anon_sym_private] = ACTIONS(1576),
    [anon_sym_protected] = ACTIONS(1576),
    [anon_sym_any] = ACTIONS(1576),
    [anon_sym_number] = ACTIONS(1576),
    [anon_sym_boolean] = ACTIONS(1576),
    [anon_sym_string] = ACTIONS(1576),
    [anon_sym_symbol] = ACTIONS(1576),
    [sym_readonly] = ACTIONS(1576),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(944),
    [sym_identifier] = ACTIONS(946),
    [anon_sym_export] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_EQ] = ACTIONS(946),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_COMMA] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_typeof] = ACTIONS(946),
    [anon_sym_type] = ACTIONS(946),
    [anon_sym_interface] = ACTIONS(946),
    [anon_sym_declare] = ACTIONS(946),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_COLON] = ACTIONS(944),
    [anon_sym_import] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_var] = ACTIONS(946),
    [anon_sym_let] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_RPAREN] = ACTIONS(944),
    [anon_sym_await] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_try] = ACTIONS(946),
    [anon_sym_with] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_debugger] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_throw] = ACTIONS(946),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(944),
    [anon_sym_RBRACK] = ACTIONS(944),
    [anon_sym_class] = ACTIONS(946),
    [anon_sym_async] = ACTIONS(946),
    [anon_sym_function] = ACTIONS(946),
    [anon_sym_EQ_GT] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_get] = ACTIONS(946),
    [anon_sym_set] = ACTIONS(946),
    [anon_sym_QMARK] = ACTIONS(944),
    [anon_sym_extends] = ACTIONS(946),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(944),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_SLASH] = ACTIONS(946),
    [anon_sym_LT] = ACTIONS(944),
    [anon_sym_GT] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_void] = ACTIONS(946),
    [anon_sym_delete] = ACTIONS(946),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(944),
    [anon_sym_SQUOTE] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(944),
    [sym_number] = ACTIONS(944),
    [sym_this] = ACTIONS(946),
    [sym_super] = ACTIONS(946),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_null] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym_protected] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(946),
    [anon_sym_number] = ACTIONS(946),
    [anon_sym_boolean] = ACTIONS(946),
    [anon_sym_string] = ACTIONS(946),
    [anon_sym_symbol] = ACTIONS(946),
    [sym_readonly] = ACTIONS(946),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1578),
    [sym_identifier] = ACTIONS(1580),
    [anon_sym_export] = ACTIONS(1580),
    [anon_sym_default] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1580),
    [anon_sym_namespace] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_typeof] = ACTIONS(1580),
    [anon_sym_type] = ACTIONS(1580),
    [anon_sym_interface] = ACTIONS(1580),
    [anon_sym_declare] = ACTIONS(1580),
    [anon_sym_module] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1578),
    [anon_sym_import] = ACTIONS(1580),
    [anon_sym_const] = ACTIONS(1580),
    [anon_sym_enum] = ACTIONS(1580),
    [anon_sym_var] = ACTIONS(1580),
    [anon_sym_let] = ACTIONS(1580),
    [anon_sym_BANG] = ACTIONS(1578),
    [anon_sym_else] = ACTIONS(1580),
    [anon_sym_if] = ACTIONS(1580),
    [anon_sym_switch] = ACTIONS(1580),
    [anon_sym_for] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [anon_sym_await] = ACTIONS(1580),
    [anon_sym_while] = ACTIONS(1580),
    [anon_sym_do] = ACTIONS(1580),
    [anon_sym_try] = ACTIONS(1580),
    [anon_sym_with] = ACTIONS(1580),
    [anon_sym_break] = ACTIONS(1580),
    [anon_sym_continue] = ACTIONS(1580),
    [anon_sym_debugger] = ACTIONS(1580),
    [anon_sym_return] = ACTIONS(1580),
    [anon_sym_throw] = ACTIONS(1580),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_case] = ACTIONS(1580),
    [anon_sym_yield] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_RBRACK] = ACTIONS(1578),
    [anon_sym_class] = ACTIONS(1580),
    [anon_sym_async] = ACTIONS(1580),
    [anon_sym_function] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1578),
    [anon_sym_abstract] = ACTIONS(1580),
    [anon_sym_get] = ACTIONS(1580),
    [anon_sym_set] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1578),
    [anon_sym_extends] = ACTIONS(1580),
    [anon_sym_new] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1578),
    [anon_sym_PIPE] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_DASH] = ACTIONS(1580),
    [anon_sym_SLASH] = ACTIONS(1580),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1578),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_void] = ACTIONS(1580),
    [anon_sym_delete] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1578),
    [anon_sym_DASH_DASH] = ACTIONS(1578),
    [anon_sym_DQUOTE] = ACTIONS(1578),
    [anon_sym_SQUOTE] = ACTIONS(1578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1578),
    [sym_number] = ACTIONS(1578),
    [sym_this] = ACTIONS(1580),
    [sym_super] = ACTIONS(1580),
    [sym_true] = ACTIONS(1580),
    [sym_false] = ACTIONS(1580),
    [sym_null] = ACTIONS(1580),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_static] = ACTIONS(1580),
    [anon_sym_public] = ACTIONS(1580),
    [anon_sym_private] = ACTIONS(1580),
    [anon_sym_protected] = ACTIONS(1580),
    [anon_sym_any] = ACTIONS(1580),
    [anon_sym_number] = ACTIONS(1580),
    [anon_sym_boolean] = ACTIONS(1580),
    [anon_sym_string] = ACTIONS(1580),
    [anon_sym_symbol] = ACTIONS(1580),
    [sym_readonly] = ACTIONS(1580),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(1582),
    [sym_identifier] = ACTIONS(1584),
    [anon_sym_export] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_EQ] = ACTIONS(1584),
    [anon_sym_namespace] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_COMMA] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1582),
    [anon_sym_typeof] = ACTIONS(1584),
    [anon_sym_type] = ACTIONS(1584),
    [anon_sym_interface] = ACTIONS(1584),
    [anon_sym_declare] = ACTIONS(1584),
    [anon_sym_module] = ACTIONS(1584),
    [anon_sym_COLON] = ACTIONS(1582),
    [anon_sym_import] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_var] = ACTIONS(1584),
    [anon_sym_let] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_else] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_LPAREN] = ACTIONS(1582),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_await] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_try] = ACTIONS(1584),
    [anon_sym_with] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_debugger] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_throw] = ACTIONS(1584),
    [anon_sym_SEMI] = ACTIONS(1582),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_yield] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(1582),
    [anon_sym_class] = ACTIONS(1584),
    [anon_sym_async] = ACTIONS(1584),
    [anon_sym_function] = ACTIONS(1584),
    [anon_sym_EQ_GT] = ACTIONS(1582),
    [anon_sym_abstract] = ACTIONS(1584),
    [anon_sym_get] = ACTIONS(1584),
    [anon_sym_set] = ACTIONS(1584),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_extends] = ACTIONS(1584),
    [anon_sym_new] = ACTIONS(1584),
    [anon_sym_AMP] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1582),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_SLASH] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1582),
    [anon_sym_GT] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_void] = ACTIONS(1584),
    [anon_sym_delete] = ACTIONS(1584),
    [anon_sym_PLUS_PLUS] = ACTIONS(1582),
    [anon_sym_DASH_DASH] = ACTIONS(1582),
    [anon_sym_DQUOTE] = ACTIONS(1582),
    [anon_sym_SQUOTE] = ACTIONS(1582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [sym_number] = ACTIONS(1582),
    [sym_this] = ACTIONS(1584),
    [sym_super] = ACTIONS(1584),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [sym_null] = ACTIONS(1584),
    [anon_sym_AT] = ACTIONS(1582),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_public] = ACTIONS(1584),
    [anon_sym_private] = ACTIONS(1584),
    [anon_sym_protected] = ACTIONS(1584),
    [anon_sym_any] = ACTIONS(1584),
    [anon_sym_number] = ACTIONS(1584),
    [anon_sym_boolean] = ACTIONS(1584),
    [anon_sym_string] = ACTIONS(1584),
    [anon_sym_symbol] = ACTIONS(1584),
    [sym_readonly] = ACTIONS(1584),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_COLON] = ACTIONS(1586),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_RBRACK] = ACTIONS(1586),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_EQ_GT] = ACTIONS(1586),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_extends] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_PIPE] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1586),
    [anon_sym_GT] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_number] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_any] = ACTIONS(1588),
    [anon_sym_number] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [sym_readonly] = ACTIONS(1588),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(1590),
    [sym_identifier] = ACTIONS(1592),
    [anon_sym_export] = ACTIONS(1592),
    [anon_sym_default] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1592),
    [anon_sym_namespace] = ACTIONS(1592),
    [anon_sym_LBRACE] = ACTIONS(1590),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(1592),
    [anon_sym_type] = ACTIONS(1592),
    [anon_sym_interface] = ACTIONS(1592),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1592),
    [anon_sym_COLON] = ACTIONS(1590),
    [anon_sym_import] = ACTIONS(1592),
    [anon_sym_const] = ACTIONS(1592),
    [anon_sym_enum] = ACTIONS(1592),
    [anon_sym_var] = ACTIONS(1592),
    [anon_sym_let] = ACTIONS(1592),
    [anon_sym_BANG] = ACTIONS(1590),
    [anon_sym_else] = ACTIONS(1592),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_switch] = ACTIONS(1592),
    [anon_sym_for] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_RPAREN] = ACTIONS(1590),
    [anon_sym_await] = ACTIONS(1592),
    [anon_sym_while] = ACTIONS(1592),
    [anon_sym_do] = ACTIONS(1592),
    [anon_sym_try] = ACTIONS(1592),
    [anon_sym_with] = ACTIONS(1592),
    [anon_sym_break] = ACTIONS(1592),
    [anon_sym_continue] = ACTIONS(1592),
    [anon_sym_debugger] = ACTIONS(1592),
    [anon_sym_return] = ACTIONS(1592),
    [anon_sym_throw] = ACTIONS(1592),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_case] = ACTIONS(1592),
    [anon_sym_yield] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_RBRACK] = ACTIONS(1590),
    [anon_sym_class] = ACTIONS(1592),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(1592),
    [anon_sym_EQ_GT] = ACTIONS(1590),
    [anon_sym_abstract] = ACTIONS(1592),
    [anon_sym_get] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(1592),
    [anon_sym_QMARK] = ACTIONS(1590),
    [anon_sym_extends] = ACTIONS(1592),
    [anon_sym_new] = ACTIONS(1592),
    [anon_sym_AMP] = ACTIONS(1590),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(1592),
    [anon_sym_DASH] = ACTIONS(1592),
    [anon_sym_SLASH] = ACTIONS(1592),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_TILDE] = ACTIONS(1590),
    [anon_sym_void] = ACTIONS(1592),
    [anon_sym_delete] = ACTIONS(1592),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [sym_number] = ACTIONS(1590),
    [sym_this] = ACTIONS(1592),
    [sym_super] = ACTIONS(1592),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [anon_sym_AT] = ACTIONS(1590),
    [anon_sym_static] = ACTIONS(1592),
    [anon_sym_public] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1592),
    [anon_sym_protected] = ACTIONS(1592),
    [anon_sym_any] = ACTIONS(1592),
    [anon_sym_number] = ACTIONS(1592),
    [anon_sym_boolean] = ACTIONS(1592),
    [anon_sym_string] = ACTIONS(1592),
    [anon_sym_symbol] = ACTIONS(1592),
    [sym_readonly] = ACTIONS(1592),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1594),
    [sym_identifier] = ACTIONS(1596),
    [anon_sym_export] = ACTIONS(1596),
    [anon_sym_default] = ACTIONS(1596),
    [anon_sym_EQ] = ACTIONS(1596),
    [anon_sym_namespace] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1594),
    [anon_sym_COMMA] = ACTIONS(1594),
    [anon_sym_RBRACE] = ACTIONS(1594),
    [anon_sym_typeof] = ACTIONS(1596),
    [anon_sym_type] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1596),
    [anon_sym_declare] = ACTIONS(1596),
    [anon_sym_module] = ACTIONS(1596),
    [anon_sym_COLON] = ACTIONS(1594),
    [anon_sym_import] = ACTIONS(1596),
    [anon_sym_const] = ACTIONS(1596),
    [anon_sym_enum] = ACTIONS(1596),
    [anon_sym_var] = ACTIONS(1596),
    [anon_sym_let] = ACTIONS(1596),
    [anon_sym_BANG] = ACTIONS(1594),
    [anon_sym_else] = ACTIONS(1596),
    [anon_sym_if] = ACTIONS(1596),
    [anon_sym_switch] = ACTIONS(1596),
    [anon_sym_for] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1594),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [anon_sym_await] = ACTIONS(1596),
    [anon_sym_while] = ACTIONS(1596),
    [anon_sym_do] = ACTIONS(1596),
    [anon_sym_try] = ACTIONS(1596),
    [anon_sym_with] = ACTIONS(1596),
    [anon_sym_break] = ACTIONS(1596),
    [anon_sym_continue] = ACTIONS(1596),
    [anon_sym_debugger] = ACTIONS(1596),
    [anon_sym_return] = ACTIONS(1596),
    [anon_sym_throw] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [anon_sym_case] = ACTIONS(1596),
    [anon_sym_yield] = ACTIONS(1596),
    [anon_sym_LBRACK] = ACTIONS(1594),
    [anon_sym_RBRACK] = ACTIONS(1594),
    [anon_sym_class] = ACTIONS(1596),
    [anon_sym_async] = ACTIONS(1596),
    [anon_sym_function] = ACTIONS(1596),
    [anon_sym_EQ_GT] = ACTIONS(1594),
    [anon_sym_abstract] = ACTIONS(1596),
    [anon_sym_get] = ACTIONS(1596),
    [anon_sym_set] = ACTIONS(1596),
    [anon_sym_QMARK] = ACTIONS(1594),
    [anon_sym_extends] = ACTIONS(1596),
    [anon_sym_new] = ACTIONS(1596),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_PLUS] = ACTIONS(1596),
    [anon_sym_DASH] = ACTIONS(1596),
    [anon_sym_SLASH] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_TILDE] = ACTIONS(1594),
    [anon_sym_void] = ACTIONS(1596),
    [anon_sym_delete] = ACTIONS(1596),
    [anon_sym_PLUS_PLUS] = ACTIONS(1594),
    [anon_sym_DASH_DASH] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_SQUOTE] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [sym_number] = ACTIONS(1594),
    [sym_this] = ACTIONS(1596),
    [sym_super] = ACTIONS(1596),
    [sym_true] = ACTIONS(1596),
    [sym_false] = ACTIONS(1596),
    [sym_null] = ACTIONS(1596),
    [anon_sym_AT] = ACTIONS(1594),
    [anon_sym_static] = ACTIONS(1596),
    [anon_sym_public] = ACTIONS(1596),
    [anon_sym_private] = ACTIONS(1596),
    [anon_sym_protected] = ACTIONS(1596),
    [anon_sym_any] = ACTIONS(1596),
    [anon_sym_number] = ACTIONS(1596),
    [anon_sym_boolean] = ACTIONS(1596),
    [anon_sym_string] = ACTIONS(1596),
    [anon_sym_symbol] = ACTIONS(1596),
    [sym_readonly] = ACTIONS(1596),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1598),
    [sym_identifier] = ACTIONS(1600),
    [anon_sym_export] = ACTIONS(1600),
    [anon_sym_default] = ACTIONS(1600),
    [anon_sym_EQ] = ACTIONS(1600),
    [anon_sym_namespace] = ACTIONS(1600),
    [anon_sym_LBRACE] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [anon_sym_typeof] = ACTIONS(1600),
    [anon_sym_type] = ACTIONS(1600),
    [anon_sym_interface] = ACTIONS(1600),
    [anon_sym_declare] = ACTIONS(1600),
    [anon_sym_module] = ACTIONS(1600),
    [anon_sym_COLON] = ACTIONS(1598),
    [anon_sym_import] = ACTIONS(1600),
    [anon_sym_const] = ACTIONS(1600),
    [anon_sym_enum] = ACTIONS(1600),
    [anon_sym_var] = ACTIONS(1600),
    [anon_sym_let] = ACTIONS(1600),
    [anon_sym_BANG] = ACTIONS(1598),
    [anon_sym_else] = ACTIONS(1600),
    [anon_sym_if] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(1600),
    [anon_sym_for] = ACTIONS(1600),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_await] = ACTIONS(1600),
    [anon_sym_while] = ACTIONS(1600),
    [anon_sym_do] = ACTIONS(1600),
    [anon_sym_try] = ACTIONS(1600),
    [anon_sym_with] = ACTIONS(1600),
    [anon_sym_break] = ACTIONS(1600),
    [anon_sym_continue] = ACTIONS(1600),
    [anon_sym_debugger] = ACTIONS(1600),
    [anon_sym_return] = ACTIONS(1600),
    [anon_sym_throw] = ACTIONS(1600),
    [anon_sym_SEMI] = ACTIONS(1598),
    [anon_sym_case] = ACTIONS(1600),
    [anon_sym_yield] = ACTIONS(1600),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [anon_sym_RBRACK] = ACTIONS(1598),
    [anon_sym_class] = ACTIONS(1600),
    [anon_sym_async] = ACTIONS(1600),
    [anon_sym_function] = ACTIONS(1600),
    [anon_sym_EQ_GT] = ACTIONS(1598),
    [anon_sym_abstract] = ACTIONS(1600),
    [anon_sym_get] = ACTIONS(1600),
    [anon_sym_set] = ACTIONS(1600),
    [anon_sym_QMARK] = ACTIONS(1598),
    [anon_sym_extends] = ACTIONS(1600),
    [anon_sym_new] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1598),
    [anon_sym_PIPE] = ACTIONS(1598),
    [anon_sym_PLUS] = ACTIONS(1600),
    [anon_sym_DASH] = ACTIONS(1600),
    [anon_sym_SLASH] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1598),
    [anon_sym_GT] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_void] = ACTIONS(1600),
    [anon_sym_delete] = ACTIONS(1600),
    [anon_sym_PLUS_PLUS] = ACTIONS(1598),
    [anon_sym_DASH_DASH] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [sym_number] = ACTIONS(1598),
    [sym_this] = ACTIONS(1600),
    [sym_super] = ACTIONS(1600),
    [sym_true] = ACTIONS(1600),
    [sym_false] = ACTIONS(1600),
    [sym_null] = ACTIONS(1600),
    [anon_sym_AT] = ACTIONS(1598),
    [anon_sym_static] = ACTIONS(1600),
    [anon_sym_public] = ACTIONS(1600),
    [anon_sym_private] = ACTIONS(1600),
    [anon_sym_protected] = ACTIONS(1600),
    [anon_sym_any] = ACTIONS(1600),
    [anon_sym_number] = ACTIONS(1600),
    [anon_sym_boolean] = ACTIONS(1600),
    [anon_sym_string] = ACTIONS(1600),
    [anon_sym_symbol] = ACTIONS(1600),
    [sym_readonly] = ACTIONS(1600),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(1602),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_export] = ACTIONS(1604),
    [anon_sym_default] = ACTIONS(1604),
    [anon_sym_EQ] = ACTIONS(1604),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1602),
    [anon_sym_COMMA] = ACTIONS(1602),
    [anon_sym_RBRACE] = ACTIONS(1602),
    [anon_sym_typeof] = ACTIONS(1604),
    [anon_sym_type] = ACTIONS(1604),
    [anon_sym_interface] = ACTIONS(1604),
    [anon_sym_declare] = ACTIONS(1604),
    [anon_sym_module] = ACTIONS(1604),
    [anon_sym_COLON] = ACTIONS(1602),
    [anon_sym_import] = ACTIONS(1604),
    [anon_sym_const] = ACTIONS(1604),
    [anon_sym_enum] = ACTIONS(1604),
    [anon_sym_var] = ACTIONS(1604),
    [anon_sym_let] = ACTIONS(1604),
    [anon_sym_BANG] = ACTIONS(1602),
    [anon_sym_else] = ACTIONS(1604),
    [anon_sym_if] = ACTIONS(1604),
    [anon_sym_switch] = ACTIONS(1604),
    [anon_sym_for] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(1602),
    [anon_sym_await] = ACTIONS(1604),
    [anon_sym_while] = ACTIONS(1604),
    [anon_sym_do] = ACTIONS(1604),
    [anon_sym_try] = ACTIONS(1604),
    [anon_sym_with] = ACTIONS(1604),
    [anon_sym_break] = ACTIONS(1604),
    [anon_sym_continue] = ACTIONS(1604),
    [anon_sym_debugger] = ACTIONS(1604),
    [anon_sym_return] = ACTIONS(1604),
    [anon_sym_throw] = ACTIONS(1604),
    [anon_sym_SEMI] = ACTIONS(1602),
    [anon_sym_case] = ACTIONS(1604),
    [anon_sym_yield] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_RBRACK] = ACTIONS(1602),
    [anon_sym_class] = ACTIONS(1604),
    [anon_sym_async] = ACTIONS(1604),
    [anon_sym_function] = ACTIONS(1604),
    [anon_sym_EQ_GT] = ACTIONS(1602),
    [anon_sym_abstract] = ACTIONS(1604),
    [anon_sym_get] = ACTIONS(1604),
    [anon_sym_set] = ACTIONS(1604),
    [anon_sym_QMARK] = ACTIONS(1602),
    [anon_sym_extends] = ACTIONS(1604),
    [anon_sym_new] = ACTIONS(1604),
    [anon_sym_AMP] = ACTIONS(1602),
    [anon_sym_PIPE] = ACTIONS(1602),
    [anon_sym_PLUS] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_LT] = ACTIONS(1602),
    [anon_sym_GT] = ACTIONS(1602),
    [anon_sym_TILDE] = ACTIONS(1602),
    [anon_sym_void] = ACTIONS(1604),
    [anon_sym_delete] = ACTIONS(1604),
    [anon_sym_PLUS_PLUS] = ACTIONS(1602),
    [anon_sym_DASH_DASH] = ACTIONS(1602),
    [anon_sym_DQUOTE] = ACTIONS(1602),
    [anon_sym_SQUOTE] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1602),
    [sym_number] = ACTIONS(1602),
    [sym_this] = ACTIONS(1604),
    [sym_super] = ACTIONS(1604),
    [sym_true] = ACTIONS(1604),
    [sym_false] = ACTIONS(1604),
    [sym_null] = ACTIONS(1604),
    [anon_sym_AT] = ACTIONS(1602),
    [anon_sym_static] = ACTIONS(1604),
    [anon_sym_public] = ACTIONS(1604),
    [anon_sym_private] = ACTIONS(1604),
    [anon_sym_protected] = ACTIONS(1604),
    [anon_sym_any] = ACTIONS(1604),
    [anon_sym_number] = ACTIONS(1604),
    [anon_sym_boolean] = ACTIONS(1604),
    [anon_sym_string] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1604),
    [sym_readonly] = ACTIONS(1604),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(1606),
    [sym_identifier] = ACTIONS(1608),
    [anon_sym_export] = ACTIONS(1608),
    [anon_sym_default] = ACTIONS(1608),
    [anon_sym_EQ] = ACTIONS(1608),
    [anon_sym_namespace] = ACTIONS(1608),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_RBRACE] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_type] = ACTIONS(1608),
    [anon_sym_interface] = ACTIONS(1608),
    [anon_sym_declare] = ACTIONS(1608),
    [anon_sym_module] = ACTIONS(1608),
    [anon_sym_COLON] = ACTIONS(1606),
    [anon_sym_import] = ACTIONS(1608),
    [anon_sym_const] = ACTIONS(1608),
    [anon_sym_enum] = ACTIONS(1608),
    [anon_sym_var] = ACTIONS(1608),
    [anon_sym_let] = ACTIONS(1608),
    [anon_sym_BANG] = ACTIONS(1606),
    [anon_sym_else] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(1608),
    [anon_sym_switch] = ACTIONS(1608),
    [anon_sym_for] = ACTIONS(1608),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_RPAREN] = ACTIONS(1606),
    [anon_sym_await] = ACTIONS(1608),
    [anon_sym_while] = ACTIONS(1608),
    [anon_sym_do] = ACTIONS(1608),
    [anon_sym_try] = ACTIONS(1608),
    [anon_sym_with] = ACTIONS(1608),
    [anon_sym_break] = ACTIONS(1608),
    [anon_sym_continue] = ACTIONS(1608),
    [anon_sym_debugger] = ACTIONS(1608),
    [anon_sym_return] = ACTIONS(1608),
    [anon_sym_throw] = ACTIONS(1608),
    [anon_sym_SEMI] = ACTIONS(1606),
    [anon_sym_case] = ACTIONS(1608),
    [anon_sym_yield] = ACTIONS(1608),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_RBRACK] = ACTIONS(1606),
    [anon_sym_class] = ACTIONS(1608),
    [anon_sym_async] = ACTIONS(1608),
    [anon_sym_function] = ACTIONS(1608),
    [anon_sym_EQ_GT] = ACTIONS(1606),
    [anon_sym_abstract] = ACTIONS(1608),
    [anon_sym_get] = ACTIONS(1608),
    [anon_sym_set] = ACTIONS(1608),
    [anon_sym_QMARK] = ACTIONS(1606),
    [anon_sym_extends] = ACTIONS(1608),
    [anon_sym_new] = ACTIONS(1608),
    [anon_sym_AMP] = ACTIONS(1606),
    [anon_sym_PIPE] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1608),
    [anon_sym_DASH] = ACTIONS(1608),
    [anon_sym_SLASH] = ACTIONS(1608),
    [anon_sym_LT] = ACTIONS(1606),
    [anon_sym_GT] = ACTIONS(1606),
    [anon_sym_TILDE] = ACTIONS(1606),
    [anon_sym_void] = ACTIONS(1608),
    [anon_sym_delete] = ACTIONS(1608),
    [anon_sym_PLUS_PLUS] = ACTIONS(1606),
    [anon_sym_DASH_DASH] = ACTIONS(1606),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [anon_sym_SQUOTE] = ACTIONS(1606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [sym_number] = ACTIONS(1606),
    [sym_this] = ACTIONS(1608),
    [sym_super] = ACTIONS(1608),
    [sym_true] = ACTIONS(1608),
    [sym_false] = ACTIONS(1608),
    [sym_null] = ACTIONS(1608),
    [anon_sym_AT] = ACTIONS(1606),
    [anon_sym_static] = ACTIONS(1608),
    [anon_sym_public] = ACTIONS(1608),
    [anon_sym_private] = ACTIONS(1608),
    [anon_sym_protected] = ACTIONS(1608),
    [anon_sym_any] = ACTIONS(1608),
    [anon_sym_number] = ACTIONS(1608),
    [anon_sym_boolean] = ACTIONS(1608),
    [anon_sym_string] = ACTIONS(1608),
    [anon_sym_symbol] = ACTIONS(1608),
    [sym_readonly] = ACTIONS(1608),
  },
  [450] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1610),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1610),
    [anon_sym_set] = ACTIONS(1610),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1610),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [451] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1614),
    [anon_sym_set] = ACTIONS(1614),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1610),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [452] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2757),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1614),
    [anon_sym_set] = ACTIONS(1614),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1616),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [453] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2757),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1610),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1610),
    [anon_sym_set] = ACTIONS(1610),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1610),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [454] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1610),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1610),
    [anon_sym_set] = ACTIONS(1610),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1610),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [455] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1614),
    [anon_sym_set] = ACTIONS(1614),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1616),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [456] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1614),
    [anon_sym_set] = ACTIONS(1614),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1616),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [457] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1614),
    [anon_sym_set] = ACTIONS(1614),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1610),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [458] = {
    [sym_string] = STATE(2230),
    [sym__property_name] = STATE(2230),
    [sym_computed_property_name] = STATE(2230),
    [aux_sym_object_repeat1] = STATE(2757),
    [sym_identifier] = ACTIONS(1610),
    [anon_sym_export] = ACTIONS(1610),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1610),
    [anon_sym_declare] = ACTIONS(1610),
    [anon_sym_module] = ACTIONS(1610),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1612),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1614),
    [anon_sym_set] = ACTIONS(1614),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1610),
    [anon_sym_public] = ACTIONS(1610),
    [anon_sym_private] = ACTIONS(1610),
    [anon_sym_protected] = ACTIONS(1610),
    [anon_sym_any] = ACTIONS(1610),
    [anon_sym_number] = ACTIONS(1610),
    [anon_sym_boolean] = ACTIONS(1610),
    [anon_sym_string] = ACTIONS(1610),
    [anon_sym_symbol] = ACTIONS(1610),
    [sym_readonly] = ACTIONS(1610),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [459] = {
    [sym__call_signature] = STATE(3217),
    [sym_arguments] = STATE(1152),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_arguments] = STATE(1061),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_type] = ACTIONS(1620),
    [anon_sym_declare] = ACTIONS(1620),
    [anon_sym_module] = ACTIONS(1620),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(1620),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(1620),
    [anon_sym_set] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_static] = ACTIONS(1620),
    [anon_sym_public] = ACTIONS(1620),
    [anon_sym_private] = ACTIONS(1620),
    [anon_sym_protected] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1620),
    [anon_sym_number] = ACTIONS(1620),
    [anon_sym_boolean] = ACTIONS(1620),
    [anon_sym_string] = ACTIONS(1620),
    [anon_sym_symbol] = ACTIONS(1620),
    [sym_readonly] = ACTIONS(1620),
  },
  [460] = {
    [sym__call_signature] = STATE(3151),
    [sym_arguments] = STATE(1591),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_arguments] = STATE(1371),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_export] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_type] = ACTIONS(1634),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1634),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1634),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1634),
    [anon_sym_set] = ACTIONS(1634),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_public] = ACTIONS(1634),
    [anon_sym_private] = ACTIONS(1634),
    [anon_sym_protected] = ACTIONS(1634),
    [anon_sym_any] = ACTIONS(1634),
    [anon_sym_number] = ACTIONS(1634),
    [anon_sym_boolean] = ACTIONS(1634),
    [anon_sym_string] = ACTIONS(1634),
    [anon_sym_symbol] = ACTIONS(1634),
    [sym_readonly] = ACTIONS(1634),
    [sym__automatic_semicolon] = ACTIONS(1624),
  },
  [461] = {
    [sym__call_signature] = STATE(3217),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(930),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1620),
    [anon_sym_declare] = ACTIONS(1620),
    [anon_sym_module] = ACTIONS(1620),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_RPAREN] = ACTIONS(748),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_async] = ACTIONS(1620),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(1620),
    [anon_sym_set] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1620),
    [anon_sym_public] = ACTIONS(1620),
    [anon_sym_private] = ACTIONS(1620),
    [anon_sym_protected] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1620),
    [anon_sym_number] = ACTIONS(1620),
    [anon_sym_boolean] = ACTIONS(1620),
    [anon_sym_string] = ACTIONS(1620),
    [anon_sym_symbol] = ACTIONS(1620),
    [sym_readonly] = ACTIONS(1620),
  },
  [462] = {
    [sym__call_signature] = STATE(3194),
    [sym_arguments] = STATE(1152),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_arguments] = STATE(1061),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1644),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(1624),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1646),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1124),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_implements] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [sym_readonly] = ACTIONS(1646),
  },
  [463] = {
    [sym__call_signature] = STATE(3029),
    [sym_arguments] = STATE(1668),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_arguments] = STATE(1619),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1650),
    [anon_sym_LBRACE] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_type] = ACTIONS(1650),
    [anon_sym_declare] = ACTIONS(1650),
    [anon_sym_module] = ACTIONS(1650),
    [anon_sym_DOT] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_async] = ACTIONS(1650),
    [anon_sym_function] = ACTIONS(1656),
    [anon_sym_EQ_GT] = ACTIONS(1140),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_public] = ACTIONS(1650),
    [anon_sym_private] = ACTIONS(1650),
    [anon_sym_protected] = ACTIONS(1650),
    [anon_sym_any] = ACTIONS(1650),
    [anon_sym_number] = ACTIONS(1650),
    [anon_sym_boolean] = ACTIONS(1650),
    [anon_sym_string] = ACTIONS(1650),
    [anon_sym_symbol] = ACTIONS(1650),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1624),
    [sym_readonly] = ACTIONS(1650),
  },
  [464] = {
    [aux_sym_object_repeat1] = STATE(2757),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1658),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1658),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1658),
    [anon_sym_declare] = ACTIONS(1658),
    [anon_sym_module] = ACTIONS(1658),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1658),
    [anon_sym_set] = ACTIONS(1658),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1658),
    [anon_sym_public] = ACTIONS(1658),
    [anon_sym_private] = ACTIONS(1658),
    [anon_sym_protected] = ACTIONS(1658),
    [anon_sym_any] = ACTIONS(1658),
    [anon_sym_number] = ACTIONS(1658),
    [anon_sym_boolean] = ACTIONS(1658),
    [anon_sym_string] = ACTIONS(1658),
    [anon_sym_symbol] = ACTIONS(1658),
    [sym_readonly] = ACTIONS(1658),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [465] = {
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1658),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1658),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1658),
    [anon_sym_declare] = ACTIONS(1658),
    [anon_sym_module] = ACTIONS(1658),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1658),
    [anon_sym_set] = ACTIONS(1658),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1658),
    [anon_sym_public] = ACTIONS(1658),
    [anon_sym_private] = ACTIONS(1658),
    [anon_sym_protected] = ACTIONS(1658),
    [anon_sym_any] = ACTIONS(1658),
    [anon_sym_number] = ACTIONS(1658),
    [anon_sym_boolean] = ACTIONS(1658),
    [anon_sym_string] = ACTIONS(1658),
    [anon_sym_symbol] = ACTIONS(1658),
    [sym_readonly] = ACTIONS(1658),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [466] = {
    [aux_sym_object_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1658),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1658),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1658),
    [anon_sym_declare] = ACTIONS(1658),
    [anon_sym_module] = ACTIONS(1658),
    [anon_sym_DOT] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1658),
    [anon_sym_set] = ACTIONS(1658),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_number] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1658),
    [anon_sym_public] = ACTIONS(1658),
    [anon_sym_private] = ACTIONS(1658),
    [anon_sym_protected] = ACTIONS(1658),
    [anon_sym_any] = ACTIONS(1658),
    [anon_sym_number] = ACTIONS(1658),
    [anon_sym_boolean] = ACTIONS(1658),
    [anon_sym_string] = ACTIONS(1658),
    [anon_sym_symbol] = ACTIONS(1658),
    [sym_readonly] = ACTIONS(1658),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [467] = {
    [sym__call_signature] = STATE(3092),
    [sym_arguments] = STATE(1591),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_arguments] = STATE(1371),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1664),
    [anon_sym_type] = ACTIONS(1664),
    [anon_sym_declare] = ACTIONS(1664),
    [anon_sym_module] = ACTIONS(1664),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_EQ_GT] = ACTIONS(1128),
    [anon_sym_get] = ACTIONS(1664),
    [anon_sym_set] = ACTIONS(1664),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_public] = ACTIONS(1664),
    [anon_sym_private] = ACTIONS(1664),
    [anon_sym_protected] = ACTIONS(1664),
    [anon_sym_any] = ACTIONS(1664),
    [anon_sym_number] = ACTIONS(1664),
    [anon_sym_boolean] = ACTIONS(1664),
    [anon_sym_string] = ACTIONS(1664),
    [anon_sym_symbol] = ACTIONS(1664),
    [sym_readonly] = ACTIONS(1664),
    [sym__automatic_semicolon] = ACTIONS(1624),
  },
  [468] = {
    [sym_object] = STATE(2386),
    [sym_array] = STATE(2383),
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(3141),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym__type] = STATE(2486),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2486),
    [sym_intersection_type] = STATE(2486),
    [sym_function_type] = STATE(2486),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2486),
    [aux_sym_export_statement_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_get] = ACTIONS(1668),
    [anon_sym_set] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(1678),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_any] = ACTIONS(1668),
    [anon_sym_number] = ACTIONS(1682),
    [anon_sym_boolean] = ACTIONS(1682),
    [anon_sym_string] = ACTIONS(1682),
    [anon_sym_symbol] = ACTIONS(1682),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(1684),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [469] = {
    [sym__call_signature] = STATE(3151),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_export] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1634),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1634),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1634),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1634),
    [anon_sym_set] = ACTIONS(1634),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_public] = ACTIONS(1634),
    [anon_sym_private] = ACTIONS(1634),
    [anon_sym_protected] = ACTIONS(1634),
    [anon_sym_any] = ACTIONS(1634),
    [anon_sym_number] = ACTIONS(1634),
    [anon_sym_boolean] = ACTIONS(1634),
    [anon_sym_string] = ACTIONS(1634),
    [anon_sym_symbol] = ACTIONS(1634),
    [sym_readonly] = ACTIONS(1634),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [470] = {
    [sym_object] = STATE(2386),
    [sym_array] = STATE(2383),
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(3141),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym__type] = STATE(2594),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2594),
    [sym_intersection_type] = STATE(2594),
    [sym_function_type] = STATE(2594),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2594),
    [aux_sym_export_statement_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_get] = ACTIONS(1668),
    [anon_sym_set] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(1678),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_any] = ACTIONS(1668),
    [anon_sym_number] = ACTIONS(1682),
    [anon_sym_boolean] = ACTIONS(1682),
    [anon_sym_string] = ACTIONS(1682),
    [anon_sym_symbol] = ACTIONS(1682),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(1684),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [471] = {
    [sym_object] = STATE(2386),
    [sym_array] = STATE(2383),
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(3141),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym__type] = STATE(2603),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2603),
    [sym_intersection_type] = STATE(2603),
    [sym_function_type] = STATE(2603),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2603),
    [aux_sym_export_statement_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_get] = ACTIONS(1668),
    [anon_sym_set] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(1678),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_any] = ACTIONS(1668),
    [anon_sym_number] = ACTIONS(1682),
    [anon_sym_boolean] = ACTIONS(1682),
    [anon_sym_string] = ACTIONS(1682),
    [anon_sym_symbol] = ACTIONS(1682),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(1684),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [472] = {
    [sym__call_signature] = STATE(3042),
    [sym_arguments] = STATE(1152),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_arguments] = STATE(1061),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1120),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [sym_readonly] = ACTIONS(1688),
  },
  [473] = {
    [sym__call_signature] = STATE(3151),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_export] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1634),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1634),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1634),
    [anon_sym_function] = ACTIONS(1690),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1634),
    [anon_sym_set] = ACTIONS(1634),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_public] = ACTIONS(1634),
    [anon_sym_private] = ACTIONS(1634),
    [anon_sym_protected] = ACTIONS(1634),
    [anon_sym_any] = ACTIONS(1634),
    [anon_sym_number] = ACTIONS(1634),
    [anon_sym_boolean] = ACTIONS(1634),
    [anon_sym_string] = ACTIONS(1634),
    [anon_sym_symbol] = ACTIONS(1634),
    [sym_readonly] = ACTIONS(1634),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [474] = {
    [sym__call_signature] = STATE(3151),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_export] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1634),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1634),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1634),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1634),
    [anon_sym_set] = ACTIONS(1634),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_public] = ACTIONS(1634),
    [anon_sym_private] = ACTIONS(1634),
    [anon_sym_protected] = ACTIONS(1634),
    [anon_sym_any] = ACTIONS(1634),
    [anon_sym_number] = ACTIONS(1634),
    [anon_sym_boolean] = ACTIONS(1634),
    [anon_sym_string] = ACTIONS(1634),
    [anon_sym_symbol] = ACTIONS(1634),
    [sym_readonly] = ACTIONS(1634),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [475] = {
    [sym_object] = STATE(2386),
    [sym_array] = STATE(2383),
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(3141),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym__type] = STATE(2510),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2510),
    [sym_intersection_type] = STATE(2510),
    [sym_function_type] = STATE(2510),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2510),
    [aux_sym_export_statement_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_get] = ACTIONS(1668),
    [anon_sym_set] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(1678),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_any] = ACTIONS(1668),
    [anon_sym_number] = ACTIONS(1682),
    [anon_sym_boolean] = ACTIONS(1682),
    [anon_sym_string] = ACTIONS(1682),
    [anon_sym_symbol] = ACTIONS(1682),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(1684),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [476] = {
    [sym_object] = STATE(2386),
    [sym_array] = STATE(2383),
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym_decorator] = STATE(1908),
    [sym__number] = STATE(443),
    [sym_optional_parameter] = STATE(2634),
    [sym_formal_parameters] = STATE(3141),
    [sym_rest_parameter] = STATE(2634),
    [sym_required_parameter] = STATE(2634),
    [sym__parameter_name] = STATE(2106),
    [sym__type] = STATE(2544),
    [sym__primary_type] = STATE(435),
    [sym_parenthesized_type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(435),
    [sym_object_type] = STATE(435),
    [sym__rest_identifier] = STATE(2598),
    [sym_accessibility_modifier] = STATE(1910),
    [sym_array_type] = STATE(435),
    [sym_tuple_type] = STATE(435),
    [sym__tuple_type_body] = STATE(445),
    [sym_flow_maybe_type] = STATE(435),
    [sym_type_query] = STATE(435),
    [sym_index_type_query] = STATE(435),
    [sym_existential_type] = STATE(435),
    [sym_literal_type] = STATE(435),
    [sym_lookup_type] = STATE(435),
    [sym_conditional_type] = STATE(435),
    [sym_union_type] = STATE(2544),
    [sym_intersection_type] = STATE(2544),
    [sym_function_type] = STATE(2544),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2544),
    [aux_sym_export_statement_repeat1] = STATE(1800),
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_namespace] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(1668),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_get] = ACTIONS(1668),
    [anon_sym_set] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(464),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(1678),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(105),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_any] = ACTIONS(1668),
    [anon_sym_number] = ACTIONS(1682),
    [anon_sym_boolean] = ACTIONS(1682),
    [anon_sym_string] = ACTIONS(1682),
    [anon_sym_symbol] = ACTIONS(1682),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(1684),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [477] = {
    [sym__call_signature] = STATE(3151),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1632),
    [anon_sym_export] = ACTIONS(1634),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(966),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1634),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1634),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(1692),
    [anon_sym_of] = ACTIONS(1695),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1634),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(1634),
    [anon_sym_set] = ACTIONS(1634),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1634),
    [anon_sym_public] = ACTIONS(1634),
    [anon_sym_private] = ACTIONS(1634),
    [anon_sym_protected] = ACTIONS(1634),
    [anon_sym_any] = ACTIONS(1634),
    [anon_sym_number] = ACTIONS(1634),
    [anon_sym_boolean] = ACTIONS(1634),
    [anon_sym_string] = ACTIONS(1634),
    [anon_sym_symbol] = ACTIONS(1634),
    [sym_readonly] = ACTIONS(1634),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [478] = {
    [sym__call_signature] = STATE(3217),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_type] = ACTIONS(1620),
    [anon_sym_declare] = ACTIONS(1620),
    [anon_sym_module] = ACTIONS(1620),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1620),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(1620),
    [anon_sym_set] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1620),
    [anon_sym_public] = ACTIONS(1620),
    [anon_sym_private] = ACTIONS(1620),
    [anon_sym_protected] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1620),
    [anon_sym_number] = ACTIONS(1620),
    [anon_sym_boolean] = ACTIONS(1620),
    [anon_sym_string] = ACTIONS(1620),
    [anon_sym_symbol] = ACTIONS(1620),
    [sym_readonly] = ACTIONS(1620),
  },
  [479] = {
    [sym__call_signature] = STATE(3194),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1644),
    [anon_sym_export] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1122),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1646),
    [anon_sym_declare] = ACTIONS(1646),
    [anon_sym_module] = ACTIONS(1646),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1646),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1124),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_implements] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_public] = ACTIONS(1646),
    [anon_sym_private] = ACTIONS(1646),
    [anon_sym_protected] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [sym_readonly] = ACTIONS(1646),
  },
  [480] = {
    [sym_object] = STATE(2441),
    [sym_array] = STATE(2406),
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_export] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_type] = ACTIONS(708),
    [anon_sym_declare] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1706),
    [anon_sym_async] = ACTIONS(708),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(708),
    [anon_sym_set] = ACTIONS(708),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_this] = ACTIONS(1702),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_protected] = ACTIONS(708),
    [anon_sym_any] = ACTIONS(708),
    [anon_sym_number] = ACTIONS(708),
    [anon_sym_boolean] = ACTIONS(708),
    [anon_sym_string] = ACTIONS(708),
    [anon_sym_symbol] = ACTIONS(708),
    [sym_readonly] = ACTIONS(708),
  },
  [481] = {
    [sym__call_signature] = STATE(3217),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_type] = ACTIONS(1620),
    [anon_sym_declare] = ACTIONS(1620),
    [anon_sym_module] = ACTIONS(1620),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1620),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(1620),
    [anon_sym_set] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1620),
    [anon_sym_public] = ACTIONS(1620),
    [anon_sym_private] = ACTIONS(1620),
    [anon_sym_protected] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1620),
    [anon_sym_number] = ACTIONS(1620),
    [anon_sym_boolean] = ACTIONS(1620),
    [anon_sym_string] = ACTIONS(1620),
    [anon_sym_symbol] = ACTIONS(1620),
    [sym_readonly] = ACTIONS(1620),
  },
  [482] = {
    [sym__call_signature] = STATE(3029),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1134),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1650),
    [anon_sym_LBRACE] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1650),
    [anon_sym_declare] = ACTIONS(1650),
    [anon_sym_module] = ACTIONS(1650),
    [anon_sym_DOT] = ACTIONS(1652),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1654),
    [anon_sym_async] = ACTIONS(1650),
    [anon_sym_function] = ACTIONS(1656),
    [anon_sym_EQ_GT] = ACTIONS(1140),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(1142),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_public] = ACTIONS(1650),
    [anon_sym_private] = ACTIONS(1650),
    [anon_sym_protected] = ACTIONS(1650),
    [anon_sym_any] = ACTIONS(1650),
    [anon_sym_number] = ACTIONS(1650),
    [anon_sym_boolean] = ACTIONS(1650),
    [anon_sym_string] = ACTIONS(1650),
    [anon_sym_symbol] = ACTIONS(1650),
    [anon_sym_LBRACE_PIPE] = ACTIONS(748),
    [sym_readonly] = ACTIONS(1650),
  },
  [483] = {
    [sym_object] = STATE(2441),
    [sym_array] = STATE(2406),
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_export] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_type] = ACTIONS(708),
    [anon_sym_declare] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1708),
    [anon_sym_async] = ACTIONS(708),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(708),
    [anon_sym_set] = ACTIONS(708),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_this] = ACTIONS(1702),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_protected] = ACTIONS(708),
    [anon_sym_any] = ACTIONS(708),
    [anon_sym_number] = ACTIONS(708),
    [anon_sym_boolean] = ACTIONS(708),
    [anon_sym_string] = ACTIONS(708),
    [anon_sym_symbol] = ACTIONS(708),
    [sym_readonly] = ACTIONS(708),
  },
  [484] = {
    [sym_type_arguments] = STATE(305),
    [ts_builtin_sym_end] = ACTIONS(1710),
    [sym_identifier] = ACTIONS(1712),
    [anon_sym_export] = ACTIONS(1712),
    [anon_sym_default] = ACTIONS(1712),
    [anon_sym_namespace] = ACTIONS(1712),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_typeof] = ACTIONS(1712),
    [anon_sym_type] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1712),
    [anon_sym_declare] = ACTIONS(1712),
    [anon_sym_module] = ACTIONS(1712),
    [anon_sym_DOT] = ACTIONS(1714),
    [anon_sym_import] = ACTIONS(1712),
    [anon_sym_const] = ACTIONS(1712),
    [anon_sym_enum] = ACTIONS(1712),
    [anon_sym_var] = ACTIONS(1712),
    [anon_sym_let] = ACTIONS(1712),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_else] = ACTIONS(1712),
    [anon_sym_if] = ACTIONS(1712),
    [anon_sym_switch] = ACTIONS(1712),
    [anon_sym_for] = ACTIONS(1712),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_await] = ACTIONS(1712),
    [anon_sym_while] = ACTIONS(1712),
    [anon_sym_do] = ACTIONS(1712),
    [anon_sym_try] = ACTIONS(1712),
    [anon_sym_with] = ACTIONS(1712),
    [anon_sym_break] = ACTIONS(1712),
    [anon_sym_continue] = ACTIONS(1712),
    [anon_sym_debugger] = ACTIONS(1712),
    [anon_sym_return] = ACTIONS(1712),
    [anon_sym_throw] = ACTIONS(1712),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_case] = ACTIONS(1712),
    [anon_sym_yield] = ACTIONS(1712),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [anon_sym_class] = ACTIONS(1712),
    [anon_sym_async] = ACTIONS(1712),
    [anon_sym_function] = ACTIONS(1712),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_get] = ACTIONS(1712),
    [anon_sym_set] = ACTIONS(1712),
    [anon_sym_extends] = ACTIONS(1712),
    [anon_sym_new] = ACTIONS(1712),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_PIPE] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(1712),
    [anon_sym_DASH] = ACTIONS(1712),
    [anon_sym_SLASH] = ACTIONS(1712),
    [anon_sym_LT] = ACTIONS(1710),
    [anon_sym_TILDE] = ACTIONS(1710),
    [anon_sym_void] = ACTIONS(1712),
    [anon_sym_delete] = ACTIONS(1712),
    [anon_sym_PLUS_PLUS] = ACTIONS(1710),
    [anon_sym_DASH_DASH] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [sym_number] = ACTIONS(1710),
    [sym_this] = ACTIONS(1712),
    [sym_super] = ACTIONS(1712),
    [sym_true] = ACTIONS(1712),
    [sym_false] = ACTIONS(1712),
    [sym_null] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1710),
    [anon_sym_static] = ACTIONS(1712),
    [anon_sym_public] = ACTIONS(1712),
    [anon_sym_private] = ACTIONS(1712),
    [anon_sym_protected] = ACTIONS(1712),
    [anon_sym_any] = ACTIONS(1712),
    [anon_sym_number] = ACTIONS(1712),
    [anon_sym_boolean] = ACTIONS(1712),
    [anon_sym_string] = ACTIONS(1712),
    [anon_sym_symbol] = ACTIONS(1712),
    [sym_readonly] = ACTIONS(1712),
  },
  [485] = {
    [sym__call_signature] = STATE(3217),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_export] = ACTIONS(1620),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(930),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(1620),
    [anon_sym_declare] = ACTIONS(1620),
    [anon_sym_module] = ACTIONS(1620),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1716),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_async] = ACTIONS(1620),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(1620),
    [anon_sym_set] = ACTIONS(1620),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1620),
    [anon_sym_public] = ACTIONS(1620),
    [anon_sym_private] = ACTIONS(1620),
    [anon_sym_protected] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1620),
    [anon_sym_number] = ACTIONS(1620),
    [anon_sym_boolean] = ACTIONS(1620),
    [anon_sym_string] = ACTIONS(1620),
    [anon_sym_symbol] = ACTIONS(1620),
    [sym_readonly] = ACTIONS(1620),
  },
  [486] = {
    [sym_type_arguments] = STATE(305),
    [ts_builtin_sym_end] = ACTIONS(1718),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_export] = ACTIONS(1720),
    [anon_sym_default] = ACTIONS(1720),
    [anon_sym_namespace] = ACTIONS(1720),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1718),
    [anon_sym_typeof] = ACTIONS(1720),
    [anon_sym_type] = ACTIONS(1720),
    [anon_sym_interface] = ACTIONS(1720),
    [anon_sym_declare] = ACTIONS(1720),
    [anon_sym_module] = ACTIONS(1720),
    [anon_sym_DOT] = ACTIONS(1714),
    [anon_sym_import] = ACTIONS(1720),
    [anon_sym_const] = ACTIONS(1720),
    [anon_sym_enum] = ACTIONS(1720),
    [anon_sym_var] = ACTIONS(1720),
    [anon_sym_let] = ACTIONS(1720),
    [anon_sym_BANG] = ACTIONS(1718),
    [anon_sym_else] = ACTIONS(1720),
    [anon_sym_if] = ACTIONS(1720),
    [anon_sym_switch] = ACTIONS(1720),
    [anon_sym_for] = ACTIONS(1720),
    [anon_sym_LPAREN] = ACTIONS(1718),
    [anon_sym_await] = ACTIONS(1720),
    [anon_sym_while] = ACTIONS(1720),
    [anon_sym_do] = ACTIONS(1720),
    [anon_sym_try] = ACTIONS(1720),
    [anon_sym_with] = ACTIONS(1720),
    [anon_sym_break] = ACTIONS(1720),
    [anon_sym_continue] = ACTIONS(1720),
    [anon_sym_debugger] = ACTIONS(1720),
    [anon_sym_return] = ACTIONS(1720),
    [anon_sym_throw] = ACTIONS(1720),
    [anon_sym_SEMI] = ACTIONS(1718),
    [anon_sym_case] = ACTIONS(1720),
    [anon_sym_yield] = ACTIONS(1720),
    [anon_sym_LBRACK] = ACTIONS(1718),
    [anon_sym_class] = ACTIONS(1720),
    [anon_sym_async] = ACTIONS(1720),
    [anon_sym_function] = ACTIONS(1720),
    [anon_sym_abstract] = ACTIONS(1720),
    [anon_sym_get] = ACTIONS(1720),
    [anon_sym_set] = ACTIONS(1720),
    [anon_sym_extends] = ACTIONS(1720),
    [anon_sym_new] = ACTIONS(1720),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(1720),
    [anon_sym_DASH] = ACTIONS(1720),
    [anon_sym_SLASH] = ACTIONS(1720),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1718),
    [anon_sym_void] = ACTIONS(1720),
    [anon_sym_delete] = ACTIONS(1720),
    [anon_sym_PLUS_PLUS] = ACTIONS(1718),
    [anon_sym_DASH_DASH] = ACTIONS(1718),
    [anon_sym_DQUOTE] = ACTIONS(1718),
    [anon_sym_SQUOTE] = ACTIONS(1718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1718),
    [sym_number] = ACTIONS(1718),
    [sym_this] = ACTIONS(1720),
    [sym_super] = ACTIONS(1720),
    [sym_true] = ACTIONS(1720),
    [sym_false] = ACTIONS(1720),
    [sym_null] = ACTIONS(1720),
    [anon_sym_AT] = ACTIONS(1718),
    [anon_sym_static] = ACTIONS(1720),
    [anon_sym_public] = ACTIONS(1720),
    [anon_sym_private] = ACTIONS(1720),
    [anon_sym_protected] = ACTIONS(1720),
    [anon_sym_any] = ACTIONS(1720),
    [anon_sym_number] = ACTIONS(1720),
    [anon_sym_boolean] = ACTIONS(1720),
    [anon_sym_string] = ACTIONS(1720),
    [anon_sym_symbol] = ACTIONS(1720),
    [sym_readonly] = ACTIONS(1720),
  },
  [487] = {
    [sym_type_arguments] = STATE(305),
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_extends] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_PIPE] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_number] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_any] = ACTIONS(1588),
    [anon_sym_number] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [sym_readonly] = ACTIONS(1588),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1586),
    [sym_identifier] = ACTIONS(1588),
    [anon_sym_export] = ACTIONS(1588),
    [anon_sym_default] = ACTIONS(1588),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1588),
    [anon_sym_interface] = ACTIONS(1588),
    [anon_sym_declare] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(1588),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_import] = ACTIONS(1588),
    [anon_sym_const] = ACTIONS(1588),
    [anon_sym_enum] = ACTIONS(1588),
    [anon_sym_var] = ACTIONS(1588),
    [anon_sym_let] = ACTIONS(1588),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1588),
    [anon_sym_if] = ACTIONS(1588),
    [anon_sym_switch] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1588),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_await] = ACTIONS(1588),
    [anon_sym_while] = ACTIONS(1588),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_try] = ACTIONS(1588),
    [anon_sym_with] = ACTIONS(1588),
    [anon_sym_break] = ACTIONS(1588),
    [anon_sym_continue] = ACTIONS(1588),
    [anon_sym_debugger] = ACTIONS(1588),
    [anon_sym_return] = ACTIONS(1588),
    [anon_sym_throw] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1586),
    [anon_sym_case] = ACTIONS(1588),
    [anon_sym_yield] = ACTIONS(1588),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_class] = ACTIONS(1588),
    [anon_sym_async] = ACTIONS(1588),
    [anon_sym_function] = ACTIONS(1588),
    [anon_sym_abstract] = ACTIONS(1588),
    [anon_sym_get] = ACTIONS(1588),
    [anon_sym_set] = ACTIONS(1588),
    [anon_sym_extends] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_PIPE] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1588),
    [anon_sym_DASH] = ACTIONS(1588),
    [anon_sym_SLASH] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1588),
    [anon_sym_delete] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1586),
    [anon_sym_DASH_DASH] = ACTIONS(1586),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1586),
    [sym_number] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(1588),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1588),
    [anon_sym_public] = ACTIONS(1588),
    [anon_sym_private] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(1588),
    [anon_sym_any] = ACTIONS(1588),
    [anon_sym_number] = ACTIONS(1588),
    [anon_sym_boolean] = ACTIONS(1588),
    [anon_sym_string] = ACTIONS(1588),
    [anon_sym_symbol] = ACTIONS(1588),
    [sym_readonly] = ACTIONS(1588),
  },
  [489] = {
    [sym_catch_clause] = STATE(516),
    [sym_finally_clause] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(1727),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_export] = ACTIONS(1729),
    [anon_sym_default] = ACTIONS(1729),
    [anon_sym_namespace] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_typeof] = ACTIONS(1729),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_interface] = ACTIONS(1729),
    [anon_sym_declare] = ACTIONS(1729),
    [anon_sym_module] = ACTIONS(1729),
    [anon_sym_import] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(1729),
    [anon_sym_enum] = ACTIONS(1729),
    [anon_sym_var] = ACTIONS(1729),
    [anon_sym_let] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_else] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1729),
    [anon_sym_switch] = ACTIONS(1729),
    [anon_sym_for] = ACTIONS(1729),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_await] = ACTIONS(1729),
    [anon_sym_while] = ACTIONS(1729),
    [anon_sym_do] = ACTIONS(1729),
    [anon_sym_try] = ACTIONS(1729),
    [anon_sym_with] = ACTIONS(1729),
    [anon_sym_break] = ACTIONS(1729),
    [anon_sym_continue] = ACTIONS(1729),
    [anon_sym_debugger] = ACTIONS(1729),
    [anon_sym_return] = ACTIONS(1729),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_case] = ACTIONS(1729),
    [anon_sym_catch] = ACTIONS(1731),
    [anon_sym_finally] = ACTIONS(1733),
    [anon_sym_yield] = ACTIONS(1729),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_class] = ACTIONS(1729),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_function] = ACTIONS(1729),
    [anon_sym_abstract] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(1729),
    [anon_sym_set] = ACTIONS(1729),
    [anon_sym_new] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_SLASH] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_void] = ACTIONS(1729),
    [anon_sym_delete] = ACTIONS(1729),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_DQUOTE] = ACTIONS(1727),
    [anon_sym_SQUOTE] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1727),
    [sym_number] = ACTIONS(1727),
    [sym_this] = ACTIONS(1729),
    [sym_super] = ACTIONS(1729),
    [sym_true] = ACTIONS(1729),
    [sym_false] = ACTIONS(1729),
    [sym_null] = ACTIONS(1729),
    [anon_sym_AT] = ACTIONS(1727),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_public] = ACTIONS(1729),
    [anon_sym_private] = ACTIONS(1729),
    [anon_sym_protected] = ACTIONS(1729),
    [anon_sym_any] = ACTIONS(1729),
    [anon_sym_number] = ACTIONS(1729),
    [anon_sym_boolean] = ACTIONS(1729),
    [anon_sym_string] = ACTIONS(1729),
    [anon_sym_symbol] = ACTIONS(1729),
    [sym_readonly] = ACTIONS(1729),
  },
  [490] = {
    [sym__call_signature] = STATE(3042),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(748),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1120),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [sym_readonly] = ACTIONS(1688),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_export] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_namespace] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(964),
    [anon_sym_type] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(964),
    [anon_sym_declare] = ACTIONS(964),
    [anon_sym_module] = ACTIONS(964),
    [anon_sym_import] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_var] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_try] = ACTIONS(964),
    [anon_sym_with] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_debugger] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_throw] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_catch] = ACTIONS(964),
    [anon_sym_finally] = ACTIONS(964),
    [anon_sym_yield] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(964),
    [anon_sym_async] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(964),
    [anon_sym_get] = ACTIONS(964),
    [anon_sym_set] = ACTIONS(964),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_SLASH] = ACTIONS(964),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(964),
    [anon_sym_delete] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_number] = ACTIONS(962),
    [sym_this] = ACTIONS(964),
    [sym_super] = ACTIONS(964),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_public] = ACTIONS(964),
    [anon_sym_private] = ACTIONS(964),
    [anon_sym_protected] = ACTIONS(964),
    [anon_sym_any] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_boolean] = ACTIONS(964),
    [anon_sym_string] = ACTIONS(964),
    [anon_sym_symbol] = ACTIONS(964),
    [sym_readonly] = ACTIONS(964),
    [sym__automatic_semicolon] = ACTIONS(1735),
  },
  [492] = {
    [sym_type_arguments] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1737),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1739),
    [anon_sym_default] = ACTIONS(1739),
    [anon_sym_namespace] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1737),
    [anon_sym_RBRACE] = ACTIONS(1737),
    [anon_sym_typeof] = ACTIONS(1739),
    [anon_sym_type] = ACTIONS(1739),
    [anon_sym_interface] = ACTIONS(1739),
    [anon_sym_declare] = ACTIONS(1739),
    [anon_sym_module] = ACTIONS(1739),
    [anon_sym_import] = ACTIONS(1739),
    [anon_sym_const] = ACTIONS(1739),
    [anon_sym_enum] = ACTIONS(1739),
    [anon_sym_var] = ACTIONS(1739),
    [anon_sym_let] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1737),
    [anon_sym_else] = ACTIONS(1739),
    [anon_sym_if] = ACTIONS(1739),
    [anon_sym_switch] = ACTIONS(1739),
    [anon_sym_for] = ACTIONS(1739),
    [anon_sym_LPAREN] = ACTIONS(1737),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_while] = ACTIONS(1739),
    [anon_sym_do] = ACTIONS(1739),
    [anon_sym_try] = ACTIONS(1739),
    [anon_sym_with] = ACTIONS(1739),
    [anon_sym_break] = ACTIONS(1739),
    [anon_sym_continue] = ACTIONS(1739),
    [anon_sym_debugger] = ACTIONS(1739),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_throw] = ACTIONS(1739),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_case] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1737),
    [anon_sym_class] = ACTIONS(1739),
    [anon_sym_async] = ACTIONS(1739),
    [anon_sym_function] = ACTIONS(1739),
    [anon_sym_abstract] = ACTIONS(1739),
    [anon_sym_get] = ACTIONS(1739),
    [anon_sym_set] = ACTIONS(1739),
    [anon_sym_extends] = ACTIONS(1739),
    [anon_sym_new] = ACTIONS(1739),
    [anon_sym_AMP] = ACTIONS(1737),
    [anon_sym_PIPE] = ACTIONS(1737),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_SLASH] = ACTIONS(1739),
    [anon_sym_LT] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1737),
    [anon_sym_void] = ACTIONS(1739),
    [anon_sym_delete] = ACTIONS(1739),
    [anon_sym_PLUS_PLUS] = ACTIONS(1737),
    [anon_sym_DASH_DASH] = ACTIONS(1737),
    [anon_sym_DQUOTE] = ACTIONS(1737),
    [anon_sym_SQUOTE] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [sym_number] = ACTIONS(1737),
    [sym_this] = ACTIONS(1739),
    [sym_super] = ACTIONS(1739),
    [sym_true] = ACTIONS(1739),
    [sym_false] = ACTIONS(1739),
    [sym_null] = ACTIONS(1739),
    [anon_sym_AT] = ACTIONS(1737),
    [anon_sym_static] = ACTIONS(1739),
    [anon_sym_public] = ACTIONS(1739),
    [anon_sym_private] = ACTIONS(1739),
    [anon_sym_protected] = ACTIONS(1739),
    [anon_sym_any] = ACTIONS(1739),
    [anon_sym_number] = ACTIONS(1739),
    [anon_sym_boolean] = ACTIONS(1739),
    [anon_sym_string] = ACTIONS(1739),
    [anon_sym_symbol] = ACTIONS(1739),
    [sym_readonly] = ACTIONS(1739),
  },
  [493] = {
    [sym__call_signature] = STATE(3092),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(1664),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1126),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1664),
    [anon_sym_type] = ACTIONS(1664),
    [anon_sym_declare] = ACTIONS(1664),
    [anon_sym_module] = ACTIONS(1664),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_EQ_GT] = ACTIONS(1128),
    [anon_sym_get] = ACTIONS(1664),
    [anon_sym_set] = ACTIONS(1664),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1664),
    [anon_sym_public] = ACTIONS(1664),
    [anon_sym_private] = ACTIONS(1664),
    [anon_sym_protected] = ACTIONS(1664),
    [anon_sym_any] = ACTIONS(1664),
    [anon_sym_number] = ACTIONS(1664),
    [anon_sym_boolean] = ACTIONS(1664),
    [anon_sym_string] = ACTIONS(1664),
    [anon_sym_symbol] = ACTIONS(1664),
    [sym_readonly] = ACTIONS(1664),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [494] = {
    [sym_type_arguments] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1504),
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_export] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_namespace] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1506),
    [anon_sym_interface] = ACTIONS(1506),
    [anon_sym_declare] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_var] = ACTIONS(1506),
    [anon_sym_let] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_await] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1506),
    [anon_sym_with] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_debugger] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_throw] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_yield] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1504),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1506),
    [anon_sym_abstract] = ACTIONS(1506),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_extends] = ACTIONS(1506),
    [anon_sym_new] = ACTIONS(1506),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [sym_number] = ACTIONS(1504),
    [sym_this] = ACTIONS(1506),
    [sym_super] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_null] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_public] = ACTIONS(1506),
    [anon_sym_private] = ACTIONS(1506),
    [anon_sym_protected] = ACTIONS(1506),
    [anon_sym_any] = ACTIONS(1506),
    [anon_sym_number] = ACTIONS(1506),
    [anon_sym_boolean] = ACTIONS(1506),
    [anon_sym_string] = ACTIONS(1506),
    [anon_sym_symbol] = ACTIONS(1506),
    [sym_readonly] = ACTIONS(1506),
  },
  [495] = {
    [sym__call_signature] = STATE(3042),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1744),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1120),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [sym_readonly] = ACTIONS(1688),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(996),
    [sym_identifier] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_default] = ACTIONS(998),
    [anon_sym_namespace] = ACTIONS(998),
    [anon_sym_LBRACE] = ACTIONS(996),
    [anon_sym_RBRACE] = ACTIONS(996),
    [anon_sym_typeof] = ACTIONS(998),
    [anon_sym_type] = ACTIONS(998),
    [anon_sym_interface] = ACTIONS(998),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_module] = ACTIONS(998),
    [anon_sym_DOT] = ACTIONS(998),
    [anon_sym_import] = ACTIONS(998),
    [anon_sym_const] = ACTIONS(998),
    [anon_sym_enum] = ACTIONS(998),
    [anon_sym_var] = ACTIONS(998),
    [anon_sym_let] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_switch] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_do] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_debugger] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_throw] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(996),
    [anon_sym_class] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(998),
    [anon_sym_abstract] = ACTIONS(998),
    [anon_sym_get] = ACTIONS(998),
    [anon_sym_set] = ACTIONS(998),
    [anon_sym_extends] = ACTIONS(998),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(996),
    [anon_sym_PIPE] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(998),
    [anon_sym_SLASH] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(998),
    [anon_sym_delete] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(996),
    [anon_sym_DQUOTE] = ACTIONS(996),
    [anon_sym_SQUOTE] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(996),
    [sym_number] = ACTIONS(996),
    [sym_this] = ACTIONS(998),
    [sym_super] = ACTIONS(998),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(996),
    [anon_sym_static] = ACTIONS(998),
    [anon_sym_public] = ACTIONS(998),
    [anon_sym_private] = ACTIONS(998),
    [anon_sym_protected] = ACTIONS(998),
    [anon_sym_any] = ACTIONS(998),
    [anon_sym_number] = ACTIONS(998),
    [anon_sym_boolean] = ACTIONS(998),
    [anon_sym_string] = ACTIONS(998),
    [anon_sym_symbol] = ACTIONS(998),
    [sym_readonly] = ACTIONS(998),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(918),
    [sym_identifier] = ACTIONS(920),
    [anon_sym_export] = ACTIONS(920),
    [anon_sym_default] = ACTIONS(920),
    [anon_sym_namespace] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(918),
    [anon_sym_COMMA] = ACTIONS(918),
    [anon_sym_RBRACE] = ACTIONS(918),
    [anon_sym_typeof] = ACTIONS(920),
    [anon_sym_type] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(920),
    [anon_sym_declare] = ACTIONS(920),
    [anon_sym_module] = ACTIONS(920),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_const] = ACTIONS(920),
    [anon_sym_enum] = ACTIONS(920),
    [anon_sym_var] = ACTIONS(920),
    [anon_sym_let] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_switch] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_while] = ACTIONS(920),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_with] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_debugger] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_throw] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(920),
    [anon_sym_catch] = ACTIONS(920),
    [anon_sym_finally] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(918),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(920),
    [anon_sym_abstract] = ACTIONS(920),
    [anon_sym_get] = ACTIONS(920),
    [anon_sym_set] = ACTIONS(920),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_SLASH] = ACTIONS(920),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(920),
    [anon_sym_delete] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(918),
    [anon_sym_DQUOTE] = ACTIONS(918),
    [anon_sym_SQUOTE] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(918),
    [sym_number] = ACTIONS(918),
    [sym_this] = ACTIONS(920),
    [sym_super] = ACTIONS(920),
    [sym_true] = ACTIONS(920),
    [sym_false] = ACTIONS(920),
    [sym_null] = ACTIONS(920),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(920),
    [anon_sym_public] = ACTIONS(920),
    [anon_sym_private] = ACTIONS(920),
    [anon_sym_protected] = ACTIONS(920),
    [anon_sym_any] = ACTIONS(920),
    [anon_sym_number] = ACTIONS(920),
    [anon_sym_boolean] = ACTIONS(920),
    [anon_sym_string] = ACTIONS(920),
    [anon_sym_symbol] = ACTIONS(920),
    [sym_readonly] = ACTIONS(920),
    [sym__automatic_semicolon] = ACTIONS(926),
  },
  [498] = {
    [sym__call_signature] = STATE(3042),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1716),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1120),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [sym_readonly] = ACTIONS(1688),
  },
  [499] = {
    [sym__call_signature] = STATE(3042),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(1749),
    [anon_sym_of] = ACTIONS(1752),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1120),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [sym_readonly] = ACTIONS(1688),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(1754),
    [sym_identifier] = ACTIONS(1756),
    [anon_sym_export] = ACTIONS(1756),
    [anon_sym_default] = ACTIONS(1756),
    [anon_sym_namespace] = ACTIONS(1756),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_RBRACE] = ACTIONS(1754),
    [anon_sym_typeof] = ACTIONS(1756),
    [anon_sym_type] = ACTIONS(1756),
    [anon_sym_interface] = ACTIONS(1756),
    [anon_sym_declare] = ACTIONS(1756),
    [anon_sym_module] = ACTIONS(1756),
    [anon_sym_import] = ACTIONS(1756),
    [anon_sym_const] = ACTIONS(1756),
    [anon_sym_enum] = ACTIONS(1756),
    [anon_sym_var] = ACTIONS(1756),
    [anon_sym_let] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1754),
    [anon_sym_else] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(1756),
    [anon_sym_switch] = ACTIONS(1756),
    [anon_sym_for] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(1754),
    [anon_sym_await] = ACTIONS(1756),
    [anon_sym_while] = ACTIONS(1756),
    [anon_sym_do] = ACTIONS(1756),
    [anon_sym_try] = ACTIONS(1756),
    [anon_sym_with] = ACTIONS(1756),
    [anon_sym_break] = ACTIONS(1756),
    [anon_sym_continue] = ACTIONS(1756),
    [anon_sym_debugger] = ACTIONS(1756),
    [anon_sym_return] = ACTIONS(1756),
    [anon_sym_throw] = ACTIONS(1756),
    [anon_sym_SEMI] = ACTIONS(1754),
    [anon_sym_case] = ACTIONS(1756),
    [anon_sym_yield] = ACTIONS(1756),
    [anon_sym_LBRACK] = ACTIONS(1754),
    [anon_sym_class] = ACTIONS(1756),
    [anon_sym_async] = ACTIONS(1756),
    [anon_sym_function] = ACTIONS(1756),
    [anon_sym_abstract] = ACTIONS(1756),
    [anon_sym_get] = ACTIONS(1756),
    [anon_sym_set] = ACTIONS(1756),
    [anon_sym_extends] = ACTIONS(1758),
    [anon_sym_new] = ACTIONS(1756),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1756),
    [anon_sym_DASH] = ACTIONS(1756),
    [anon_sym_SLASH] = ACTIONS(1756),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_TILDE] = ACTIONS(1754),
    [anon_sym_void] = ACTIONS(1756),
    [anon_sym_delete] = ACTIONS(1756),
    [anon_sym_PLUS_PLUS] = ACTIONS(1754),
    [anon_sym_DASH_DASH] = ACTIONS(1754),
    [anon_sym_DQUOTE] = ACTIONS(1754),
    [anon_sym_SQUOTE] = ACTIONS(1754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1754),
    [sym_number] = ACTIONS(1754),
    [sym_this] = ACTIONS(1756),
    [sym_super] = ACTIONS(1756),
    [sym_true] = ACTIONS(1756),
    [sym_false] = ACTIONS(1756),
    [sym_null] = ACTIONS(1756),
    [anon_sym_AT] = ACTIONS(1754),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_public] = ACTIONS(1756),
    [anon_sym_private] = ACTIONS(1756),
    [anon_sym_protected] = ACTIONS(1756),
    [anon_sym_any] = ACTIONS(1756),
    [anon_sym_number] = ACTIONS(1756),
    [anon_sym_boolean] = ACTIONS(1756),
    [anon_sym_string] = ACTIONS(1756),
    [anon_sym_symbol] = ACTIONS(1756),
    [sym_readonly] = ACTIONS(1756),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_export] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_namespace] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(964),
    [anon_sym_type] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(964),
    [anon_sym_declare] = ACTIONS(964),
    [anon_sym_module] = ACTIONS(964),
    [anon_sym_import] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_var] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_try] = ACTIONS(964),
    [anon_sym_with] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_debugger] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_throw] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_catch] = ACTIONS(964),
    [anon_sym_finally] = ACTIONS(964),
    [anon_sym_yield] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(964),
    [anon_sym_async] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(964),
    [anon_sym_get] = ACTIONS(964),
    [anon_sym_set] = ACTIONS(964),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_SLASH] = ACTIONS(964),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(964),
    [anon_sym_delete] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_number] = ACTIONS(962),
    [sym_this] = ACTIONS(964),
    [sym_super] = ACTIONS(964),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_public] = ACTIONS(964),
    [anon_sym_private] = ACTIONS(964),
    [anon_sym_protected] = ACTIONS(964),
    [anon_sym_any] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_boolean] = ACTIONS(964),
    [anon_sym_string] = ACTIONS(964),
    [anon_sym_symbol] = ACTIONS(964),
    [sym_readonly] = ACTIONS(964),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1764),
    [sym_identifier] = ACTIONS(1766),
    [anon_sym_export] = ACTIONS(1766),
    [anon_sym_default] = ACTIONS(1766),
    [anon_sym_namespace] = ACTIONS(1766),
    [anon_sym_LBRACE] = ACTIONS(1764),
    [anon_sym_RBRACE] = ACTIONS(1764),
    [anon_sym_typeof] = ACTIONS(1766),
    [anon_sym_type] = ACTIONS(1766),
    [anon_sym_interface] = ACTIONS(1766),
    [anon_sym_declare] = ACTIONS(1766),
    [anon_sym_module] = ACTIONS(1766),
    [anon_sym_import] = ACTIONS(1766),
    [anon_sym_const] = ACTIONS(1766),
    [anon_sym_enum] = ACTIONS(1766),
    [anon_sym_var] = ACTIONS(1766),
    [anon_sym_let] = ACTIONS(1766),
    [anon_sym_BANG] = ACTIONS(1764),
    [anon_sym_else] = ACTIONS(1766),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_switch] = ACTIONS(1766),
    [anon_sym_for] = ACTIONS(1766),
    [anon_sym_LPAREN] = ACTIONS(1764),
    [anon_sym_await] = ACTIONS(1766),
    [anon_sym_while] = ACTIONS(1766),
    [anon_sym_do] = ACTIONS(1766),
    [anon_sym_try] = ACTIONS(1766),
    [anon_sym_with] = ACTIONS(1766),
    [anon_sym_break] = ACTIONS(1766),
    [anon_sym_continue] = ACTIONS(1766),
    [anon_sym_debugger] = ACTIONS(1766),
    [anon_sym_return] = ACTIONS(1766),
    [anon_sym_throw] = ACTIONS(1766),
    [anon_sym_SEMI] = ACTIONS(1764),
    [anon_sym_case] = ACTIONS(1766),
    [anon_sym_yield] = ACTIONS(1766),
    [anon_sym_LBRACK] = ACTIONS(1764),
    [anon_sym_class] = ACTIONS(1766),
    [anon_sym_async] = ACTIONS(1766),
    [anon_sym_function] = ACTIONS(1766),
    [anon_sym_abstract] = ACTIONS(1766),
    [anon_sym_get] = ACTIONS(1766),
    [anon_sym_set] = ACTIONS(1766),
    [anon_sym_extends] = ACTIONS(1766),
    [anon_sym_new] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_DASH] = ACTIONS(1766),
    [anon_sym_SLASH] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1764),
    [anon_sym_TILDE] = ACTIONS(1764),
    [anon_sym_void] = ACTIONS(1766),
    [anon_sym_delete] = ACTIONS(1766),
    [anon_sym_PLUS_PLUS] = ACTIONS(1764),
    [anon_sym_DASH_DASH] = ACTIONS(1764),
    [anon_sym_DQUOTE] = ACTIONS(1764),
    [anon_sym_SQUOTE] = ACTIONS(1764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1764),
    [sym_number] = ACTIONS(1764),
    [sym_this] = ACTIONS(1766),
    [sym_super] = ACTIONS(1766),
    [sym_true] = ACTIONS(1766),
    [sym_false] = ACTIONS(1766),
    [sym_null] = ACTIONS(1766),
    [anon_sym_AT] = ACTIONS(1764),
    [anon_sym_static] = ACTIONS(1766),
    [anon_sym_public] = ACTIONS(1766),
    [anon_sym_private] = ACTIONS(1766),
    [anon_sym_protected] = ACTIONS(1766),
    [anon_sym_any] = ACTIONS(1766),
    [anon_sym_number] = ACTIONS(1766),
    [anon_sym_boolean] = ACTIONS(1766),
    [anon_sym_string] = ACTIONS(1766),
    [anon_sym_symbol] = ACTIONS(1766),
    [sym_readonly] = ACTIONS(1766),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1768),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_export] = ACTIONS(1770),
    [anon_sym_default] = ACTIONS(1770),
    [anon_sym_namespace] = ACTIONS(1770),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1768),
    [anon_sym_typeof] = ACTIONS(1770),
    [anon_sym_type] = ACTIONS(1770),
    [anon_sym_interface] = ACTIONS(1770),
    [anon_sym_declare] = ACTIONS(1770),
    [anon_sym_module] = ACTIONS(1770),
    [anon_sym_import] = ACTIONS(1770),
    [anon_sym_const] = ACTIONS(1770),
    [anon_sym_enum] = ACTIONS(1770),
    [anon_sym_var] = ACTIONS(1770),
    [anon_sym_let] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1768),
    [anon_sym_else] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(1770),
    [anon_sym_switch] = ACTIONS(1770),
    [anon_sym_for] = ACTIONS(1770),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_await] = ACTIONS(1770),
    [anon_sym_while] = ACTIONS(1770),
    [anon_sym_do] = ACTIONS(1770),
    [anon_sym_try] = ACTIONS(1770),
    [anon_sym_with] = ACTIONS(1770),
    [anon_sym_break] = ACTIONS(1770),
    [anon_sym_continue] = ACTIONS(1770),
    [anon_sym_debugger] = ACTIONS(1770),
    [anon_sym_return] = ACTIONS(1770),
    [anon_sym_throw] = ACTIONS(1770),
    [anon_sym_SEMI] = ACTIONS(1768),
    [anon_sym_case] = ACTIONS(1770),
    [anon_sym_yield] = ACTIONS(1770),
    [anon_sym_LBRACK] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(1770),
    [anon_sym_async] = ACTIONS(1770),
    [anon_sym_function] = ACTIONS(1770),
    [anon_sym_abstract] = ACTIONS(1770),
    [anon_sym_get] = ACTIONS(1770),
    [anon_sym_set] = ACTIONS(1770),
    [anon_sym_extends] = ACTIONS(1758),
    [anon_sym_new] = ACTIONS(1770),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1770),
    [anon_sym_SLASH] = ACTIONS(1770),
    [anon_sym_LT] = ACTIONS(1768),
    [anon_sym_TILDE] = ACTIONS(1768),
    [anon_sym_void] = ACTIONS(1770),
    [anon_sym_delete] = ACTIONS(1770),
    [anon_sym_PLUS_PLUS] = ACTIONS(1768),
    [anon_sym_DASH_DASH] = ACTIONS(1768),
    [anon_sym_DQUOTE] = ACTIONS(1768),
    [anon_sym_SQUOTE] = ACTIONS(1768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1768),
    [sym_number] = ACTIONS(1768),
    [sym_this] = ACTIONS(1770),
    [sym_super] = ACTIONS(1770),
    [sym_true] = ACTIONS(1770),
    [sym_false] = ACTIONS(1770),
    [sym_null] = ACTIONS(1770),
    [anon_sym_AT] = ACTIONS(1768),
    [anon_sym_static] = ACTIONS(1770),
    [anon_sym_public] = ACTIONS(1770),
    [anon_sym_private] = ACTIONS(1770),
    [anon_sym_protected] = ACTIONS(1770),
    [anon_sym_any] = ACTIONS(1770),
    [anon_sym_number] = ACTIONS(1770),
    [anon_sym_boolean] = ACTIONS(1770),
    [anon_sym_string] = ACTIONS(1770),
    [anon_sym_symbol] = ACTIONS(1770),
    [sym_readonly] = ACTIONS(1770),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(918),
    [sym_identifier] = ACTIONS(920),
    [anon_sym_export] = ACTIONS(920),
    [anon_sym_default] = ACTIONS(920),
    [anon_sym_namespace] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(918),
    [anon_sym_COMMA] = ACTIONS(918),
    [anon_sym_RBRACE] = ACTIONS(918),
    [anon_sym_typeof] = ACTIONS(920),
    [anon_sym_type] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(920),
    [anon_sym_declare] = ACTIONS(920),
    [anon_sym_module] = ACTIONS(920),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_const] = ACTIONS(920),
    [anon_sym_enum] = ACTIONS(920),
    [anon_sym_var] = ACTIONS(920),
    [anon_sym_let] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_switch] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_await] = ACTIONS(920),
    [anon_sym_while] = ACTIONS(920),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_with] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_debugger] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_throw] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(920),
    [anon_sym_yield] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(918),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_async] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(920),
    [anon_sym_abstract] = ACTIONS(920),
    [anon_sym_get] = ACTIONS(920),
    [anon_sym_set] = ACTIONS(920),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_SLASH] = ACTIONS(920),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(920),
    [anon_sym_delete] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(918),
    [anon_sym_DQUOTE] = ACTIONS(918),
    [anon_sym_SQUOTE] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(918),
    [sym_number] = ACTIONS(918),
    [sym_this] = ACTIONS(920),
    [sym_super] = ACTIONS(920),
    [sym_true] = ACTIONS(920),
    [sym_false] = ACTIONS(920),
    [sym_null] = ACTIONS(920),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(920),
    [anon_sym_public] = ACTIONS(920),
    [anon_sym_private] = ACTIONS(920),
    [anon_sym_protected] = ACTIONS(920),
    [anon_sym_any] = ACTIONS(920),
    [anon_sym_number] = ACTIONS(920),
    [anon_sym_boolean] = ACTIONS(920),
    [anon_sym_string] = ACTIONS(920),
    [anon_sym_symbol] = ACTIONS(920),
    [anon_sym_PIPE_RBRACE] = ACTIONS(918),
    [sym_readonly] = ACTIONS(920),
    [sym__automatic_semicolon] = ACTIONS(1772),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(1774),
    [sym_identifier] = ACTIONS(1776),
    [anon_sym_export] = ACTIONS(1776),
    [anon_sym_default] = ACTIONS(1776),
    [anon_sym_namespace] = ACTIONS(1776),
    [anon_sym_LBRACE] = ACTIONS(1774),
    [anon_sym_RBRACE] = ACTIONS(1774),
    [anon_sym_typeof] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1776),
    [anon_sym_interface] = ACTIONS(1776),
    [anon_sym_declare] = ACTIONS(1776),
    [anon_sym_module] = ACTIONS(1776),
    [anon_sym_import] = ACTIONS(1776),
    [anon_sym_const] = ACTIONS(1776),
    [anon_sym_enum] = ACTIONS(1776),
    [anon_sym_var] = ACTIONS(1776),
    [anon_sym_let] = ACTIONS(1776),
    [anon_sym_BANG] = ACTIONS(1774),
    [anon_sym_else] = ACTIONS(1776),
    [anon_sym_if] = ACTIONS(1776),
    [anon_sym_switch] = ACTIONS(1776),
    [anon_sym_for] = ACTIONS(1776),
    [anon_sym_LPAREN] = ACTIONS(1774),
    [anon_sym_await] = ACTIONS(1776),
    [anon_sym_while] = ACTIONS(1776),
    [anon_sym_do] = ACTIONS(1776),
    [anon_sym_try] = ACTIONS(1776),
    [anon_sym_with] = ACTIONS(1776),
    [anon_sym_break] = ACTIONS(1776),
    [anon_sym_continue] = ACTIONS(1776),
    [anon_sym_debugger] = ACTIONS(1776),
    [anon_sym_return] = ACTIONS(1776),
    [anon_sym_throw] = ACTIONS(1776),
    [anon_sym_SEMI] = ACTIONS(1774),
    [anon_sym_case] = ACTIONS(1776),
    [anon_sym_yield] = ACTIONS(1776),
    [anon_sym_LBRACK] = ACTIONS(1774),
    [anon_sym_class] = ACTIONS(1776),
    [anon_sym_async] = ACTIONS(1776),
    [anon_sym_function] = ACTIONS(1776),
    [anon_sym_abstract] = ACTIONS(1776),
    [anon_sym_get] = ACTIONS(1776),
    [anon_sym_set] = ACTIONS(1776),
    [anon_sym_extends] = ACTIONS(1758),
    [anon_sym_new] = ACTIONS(1776),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1776),
    [anon_sym_SLASH] = ACTIONS(1776),
    [anon_sym_LT] = ACTIONS(1774),
    [anon_sym_TILDE] = ACTIONS(1774),
    [anon_sym_void] = ACTIONS(1776),
    [anon_sym_delete] = ACTIONS(1776),
    [anon_sym_PLUS_PLUS] = ACTIONS(1774),
    [anon_sym_DASH_DASH] = ACTIONS(1774),
    [anon_sym_DQUOTE] = ACTIONS(1774),
    [anon_sym_SQUOTE] = ACTIONS(1774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1774),
    [sym_number] = ACTIONS(1774),
    [sym_this] = ACTIONS(1776),
    [sym_super] = ACTIONS(1776),
    [sym_true] = ACTIONS(1776),
    [sym_false] = ACTIONS(1776),
    [sym_null] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(1774),
    [anon_sym_static] = ACTIONS(1776),
    [anon_sym_public] = ACTIONS(1776),
    [anon_sym_private] = ACTIONS(1776),
    [anon_sym_protected] = ACTIONS(1776),
    [anon_sym_any] = ACTIONS(1776),
    [anon_sym_number] = ACTIONS(1776),
    [anon_sym_boolean] = ACTIONS(1776),
    [anon_sym_string] = ACTIONS(1776),
    [anon_sym_symbol] = ACTIONS(1776),
    [sym_readonly] = ACTIONS(1776),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(940),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_export] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_namespace] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_COMMA] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_typeof] = ACTIONS(942),
    [anon_sym_type] = ACTIONS(942),
    [anon_sym_interface] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(942),
    [anon_sym_import] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_var] = ACTIONS(942),
    [anon_sym_let] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_await] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_try] = ACTIONS(942),
    [anon_sym_with] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_debugger] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_throw] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_class] = ACTIONS(942),
    [anon_sym_async] = ACTIONS(942),
    [anon_sym_function] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(942),
    [anon_sym_LT] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_delete] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(940),
    [anon_sym_SQUOTE] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(940),
    [sym_number] = ACTIONS(940),
    [sym_this] = ACTIONS(942),
    [sym_super] = ACTIONS(942),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_null] = ACTIONS(942),
    [anon_sym_AT] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_PIPE_RBRACE] = ACTIONS(940),
    [sym_readonly] = ACTIONS(942),
    [sym__automatic_semicolon] = ACTIONS(940),
  },
  [507] = {
    [sym__call_signature] = STATE(3042),
    [sym_formal_parameters] = STATE(2226),
    [sym_type_parameters] = STATE(2817),
    [sym_identifier] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1688),
    [anon_sym_type] = ACTIONS(1688),
    [anon_sym_declare] = ACTIONS(1688),
    [anon_sym_module] = ACTIONS(1688),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(1692),
    [anon_sym_of] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(1120),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(1688),
    [anon_sym_public] = ACTIONS(1688),
    [anon_sym_private] = ACTIONS(1688),
    [anon_sym_protected] = ACTIONS(1688),
    [anon_sym_any] = ACTIONS(1688),
    [anon_sym_number] = ACTIONS(1688),
    [anon_sym_boolean] = ACTIONS(1688),
    [anon_sym_string] = ACTIONS(1688),
    [anon_sym_symbol] = ACTIONS(1688),
    [sym_readonly] = ACTIONS(1688),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_COMMA] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_number] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_any] = ACTIONS(1116),
    [anon_sym_number] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1114),
    [sym_readonly] = ACTIONS(1116),
    [sym__automatic_semicolon] = ACTIONS(1114),
  },
  [509] = {
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1658),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1658),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_type] = ACTIONS(1658),
    [anon_sym_declare] = ACTIONS(1658),
    [anon_sym_module] = ACTIONS(1658),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1697),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(1658),
    [anon_sym_set] = ACTIONS(1658),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_this] = ACTIONS(1658),
    [anon_sym_static] = ACTIONS(1658),
    [anon_sym_public] = ACTIONS(1658),
    [anon_sym_private] = ACTIONS(1658),
    [anon_sym_protected] = ACTIONS(1658),
    [anon_sym_any] = ACTIONS(1658),
    [anon_sym_number] = ACTIONS(1658),
    [anon_sym_boolean] = ACTIONS(1658),
    [anon_sym_string] = ACTIONS(1658),
    [anon_sym_symbol] = ACTIONS(1658),
    [sym_readonly] = ACTIONS(1658),
  },
  [510] = {
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1658),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(712),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_namespace] = ACTIONS(1658),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(719),
    [anon_sym_type] = ACTIONS(1658),
    [anon_sym_declare] = ACTIONS(1658),
    [anon_sym_module] = ACTIONS(1658),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_get] = ACTIONS(1658),
    [anon_sym_set] = ACTIONS(1658),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym_this] = ACTIONS(1658),
    [anon_sym_static] = ACTIONS(1658),
    [anon_sym_public] = ACTIONS(1658),
    [anon_sym_private] = ACTIONS(1658),
    [anon_sym_protected] = ACTIONS(1658),
    [anon_sym_any] = ACTIONS(1658),
    [anon_sym_number] = ACTIONS(1658),
    [anon_sym_boolean] = ACTIONS(1658),
    [anon_sym_string] = ACTIONS(1658),
    [anon_sym_symbol] = ACTIONS(1658),
    [sym_readonly] = ACTIONS(1658),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(940),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_export] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_namespace] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_COMMA] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_typeof] = ACTIONS(942),
    [anon_sym_type] = ACTIONS(942),
    [anon_sym_interface] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(942),
    [anon_sym_import] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_var] = ACTIONS(942),
    [anon_sym_let] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_await] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_try] = ACTIONS(942),
    [anon_sym_with] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_debugger] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_throw] = ACTIONS(942),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_catch] = ACTIONS(942),
    [anon_sym_finally] = ACTIONS(942),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_class] = ACTIONS(942),
    [anon_sym_async] = ACTIONS(942),
    [anon_sym_function] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_new] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(942),
    [anon_sym_LT] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_void] = ACTIONS(942),
    [anon_sym_delete] = ACTIONS(942),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(940),
    [anon_sym_SQUOTE] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(940),
    [sym_number] = ACTIONS(940),
    [sym_this] = ACTIONS(942),
    [sym_super] = ACTIONS(942),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_null] = ACTIONS(942),
    [anon_sym_AT] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [sym_readonly] = ACTIONS(942),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(958),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_COMMA] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_typeof] = ACTIONS(960),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_interface] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_import] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_var] = ACTIONS(960),
    [anon_sym_let] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(958),
    [anon_sym_await] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_try] = ACTIONS(960),
    [anon_sym_with] = ACTIONS(960),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_debugger] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_throw] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_yield] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(958),
    [anon_sym_class] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(960),
    [anon_sym_get] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_SLASH] = ACTIONS(960),
    [anon_sym_LT] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_delete] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [sym_number] = ACTIONS(958),
    [sym_this] = ACTIONS(960),
    [sym_super] = ACTIONS(960),
    [sym_true] = ACTIONS(960),
    [sym_false] = ACTIONS(960),
    [sym_null] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_PIPE_RBRACE] = ACTIONS(958),
    [sym_readonly] = ACTIONS(960),
    [sym__automatic_semicolon] = ACTIONS(958),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_export] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_namespace] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(964),
    [anon_sym_type] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(964),
    [anon_sym_declare] = ACTIONS(964),
    [anon_sym_module] = ACTIONS(964),
    [anon_sym_import] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_var] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_try] = ACTIONS(964),
    [anon_sym_with] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_debugger] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_throw] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_yield] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(964),
    [anon_sym_async] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(964),
    [anon_sym_get] = ACTIONS(964),
    [anon_sym_set] = ACTIONS(964),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_SLASH] = ACTIONS(964),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(964),
    [anon_sym_delete] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_number] = ACTIONS(962),
    [sym_this] = ACTIONS(964),
    [sym_super] = ACTIONS(964),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_public] = ACTIONS(964),
    [anon_sym_private] = ACTIONS(964),
    [anon_sym_protected] = ACTIONS(964),
    [anon_sym_any] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_boolean] = ACTIONS(964),
    [anon_sym_string] = ACTIONS(964),
    [anon_sym_symbol] = ACTIONS(964),
    [anon_sym_PIPE_RBRACE] = ACTIONS(962),
    [sym_readonly] = ACTIONS(964),
    [sym__automatic_semicolon] = ACTIONS(1778),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_export] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_namespace] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(964),
    [anon_sym_type] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(964),
    [anon_sym_declare] = ACTIONS(964),
    [anon_sym_module] = ACTIONS(964),
    [anon_sym_import] = ACTIONS(964),
    [anon_sym_const] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_var] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(962),
    [anon_sym_await] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_try] = ACTIONS(964),
    [anon_sym_with] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_debugger] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_throw] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_yield] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_class] = ACTIONS(964),
    [anon_sym_async] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(964),
    [anon_sym_get] = ACTIONS(964),
    [anon_sym_set] = ACTIONS(964),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_SLASH] = ACTIONS(964),
    [anon_sym_LT] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(964),
    [anon_sym_delete] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_DQUOTE] = ACTIONS(962),
    [anon_sym_SQUOTE] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_number] = ACTIONS(962),
    [sym_this] = ACTIONS(964),
    [sym_super] = ACTIONS(964),
    [sym_true] = ACTIONS(964),
    [sym_false] = ACTIONS(964),
    [sym_null] = ACTIONS(964),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_public] = ACTIONS(964),
    [anon_sym_private] = ACTIONS(964),
    [anon_sym_protected] = ACTIONS(964),
    [anon_sym_any] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_boolean] = ACTIONS(964),
    [anon_sym_string] = ACTIONS(964),
    [anon_sym_symbol] = ACTIONS(964),
    [anon_sym_PIPE_RBRACE] = ACTIONS(962),
    [sym_readonly] = ACTIONS(964),
    [sym__automatic_semicolon] = ACTIONS(962),
  },
  [515] = {
    [sym_statement_block] = STATE(561),
    [ts_builtin_sym_end] = ACTIONS(910),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(912),
    [anon_sym_default] = ACTIONS(912),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1780),
    [anon_sym_RBRACE] = ACTIONS(910),
    [anon_sym_typeof] = ACTIONS(912),
    [anon_sym_type] = ACTIONS(912),
    [anon_sym_interface] = ACTIONS(912),
    [anon_sym_declare] = ACTIONS(912),
    [anon_sym_module] = ACTIONS(912),
    [anon_sym_DOT] = ACTIONS(1782),
    [anon_sym_import] = ACTIONS(912),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_enum] = ACTIONS(912),
    [anon_sym_var] = ACTIONS(912),
    [anon_sym_let] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(912),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(910),
    [anon_sym_await] = ACTIONS(912),
    [anon_sym_while] = ACTIONS(912),
    [anon_sym_do] = ACTIONS(912),
    [anon_sym_try] = ACTIONS(912),
    [anon_sym_with] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(912),
    [anon_sym_continue] = ACTIONS(912),
    [anon_sym_debugger] = ACTIONS(912),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_throw] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(912),
    [anon_sym_yield] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(912),
    [anon_sym_async] = ACTIONS(912),
    [anon_sym_function] = ACTIONS(912),
    [anon_sym_abstract] = ACTIONS(912),
    [anon_sym_get] = ACTIONS(912),
    [anon_sym_set] = ACTIONS(912),
    [anon_sym_new] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_SLASH] = ACTIONS(912),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_TILDE] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(912),
    [anon_sym_delete] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(910),
    [anon_sym_DQUOTE] = ACTIONS(910),
    [anon_sym_SQUOTE] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(910),
    [sym_number] = ACTIONS(910),
    [sym_this] = ACTIONS(912),
    [sym_super] = ACTIONS(912),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [sym_null] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(912),
    [anon_sym_public] = ACTIONS(912),
    [anon_sym_private] = ACTIONS(912),
    [anon_sym_protected] = ACTIONS(912),
    [anon_sym_any] = ACTIONS(912),
    [anon_sym_number] = ACTIONS(912),
    [anon_sym_boolean] = ACTIONS(912),
    [anon_sym_string] = ACTIONS(912),
    [anon_sym_symbol] = ACTIONS(912),
    [sym_readonly] = ACTIONS(912),
  },
  [516] = {
    [sym_finally_clause] = STATE(583),
    [ts_builtin_sym_end] = ACTIONS(1784),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1786),
    [anon_sym_default] = ACTIONS(1786),
    [anon_sym_namespace] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(1784),
    [anon_sym_RBRACE] = ACTIONS(1784),
    [anon_sym_typeof] = ACTIONS(1786),
    [anon_sym_type] = ACTIONS(1786),
    [anon_sym_interface] = ACTIONS(1786),
    [anon_sym_declare] = ACTIONS(1786),
    [anon_sym_module] = ACTIONS(1786),
    [anon_sym_import] = ACTIONS(1786),
    [anon_sym_const] = ACTIONS(1786),
    [anon_sym_enum] = ACTIONS(1786),
    [anon_sym_var] = ACTIONS(1786),
    [anon_sym_let] = ACTIONS(1786),
    [anon_sym_BANG] = ACTIONS(1784),
    [anon_sym_else] = ACTIONS(1786),
    [anon_sym_if] = ACTIONS(1786),
    [anon_sym_switch] = ACTIONS(1786),
    [anon_sym_for] = ACTIONS(1786),
    [anon_sym_LPAREN] = ACTIONS(1784),
    [anon_sym_await] = ACTIONS(1786),
    [anon_sym_while] = ACTIONS(1786),
    [anon_sym_do] = ACTIONS(1786),
    [anon_sym_try] = ACTIONS(1786),
    [anon_sym_with] = ACTIONS(1786),
    [anon_sym_break] = ACTIONS(1786),
    [anon_sym_continue] = ACTIONS(1786),
    [anon_sym_debugger] = ACTIONS(1786),
    [anon_sym_return] = ACTIONS(1786),
    [anon_sym_throw] = ACTIONS(1786),
    [anon_sym_SEMI] = ACTIONS(1784),
    [anon_sym_case] = ACTIONS(1786),
    [anon_sym_finally] = ACTIONS(1733),
    [anon_sym_yield] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(1786),
    [anon_sym_async] = ACTIONS(1786),
    [anon_sym_function] = ACTIONS(1786),
    [anon_sym_abstract] = ACTIONS(1786),
    [anon_sym_get] = ACTIONS(1786),
    [anon_sym_set] = ACTIONS(1786),
    [anon_sym_new] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(1786),
    [anon_sym_DASH] = ACTIONS(1786),
    [anon_sym_SLASH] = ACTIONS(1786),
    [anon_sym_LT] = ACTIONS(1784),
    [anon_sym_TILDE] = ACTIONS(1784),
    [anon_sym_void] = ACTIONS(1786),
    [anon_sym_delete] = ACTIONS(1786),
    [anon_sym_PLUS_PLUS] = ACTIONS(1784),
    [anon_sym_DASH_DASH] = ACTIONS(1784),
    [anon_sym_DQUOTE] = ACTIONS(1784),
    [anon_sym_SQUOTE] = ACTIONS(1784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1784),
    [sym_number] = ACTIONS(1784),
    [sym_this] = ACTIONS(1786),
    [sym_super] = ACTIONS(1786),
    [sym_true] = ACTIONS(1786),
    [sym_false] = ACTIONS(1786),
    [sym_null] = ACTIONS(1786),
    [anon_sym_AT] = ACTIONS(1784),
    [anon_sym_static] = ACTIONS(1786),
    [anon_sym_public] = ACTIONS(1786),
    [anon_sym_private] = ACTIONS(1786),
    [anon_sym_protected] = ACTIONS(1786),
    [anon_sym_any] = ACTIONS(1786),
    [anon_sym_number] = ACTIONS(1786),
    [anon_sym_boolean] = ACTIONS(1786),
    [anon_sym_string] = ACTIONS(1786),
    [anon_sym_symbol] = ACTIONS(1786),
    [sym_readonly] = ACTIONS(1786),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1054),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [anon_sym_typeof] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_interface] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_var] = ACTIONS(1056),
    [anon_sym_let] = ACTIONS(1056),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1054),
    [anon_sym_await] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_debugger] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_throw] = ACTIONS(1056),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(1056),
    [anon_sym_abstract] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_new] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_SLASH] = ACTIONS(1056),
    [anon_sym_LT] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_void] = ACTIONS(1056),
    [anon_sym_delete] = ACTIONS(1056),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1054),
    [sym_number] = ACTIONS(1054),
    [sym_this] = ACTIONS(1056),
    [sym_super] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [anon_sym_AT] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [sym_readonly] = ACTIONS(1056),
    [sym__automatic_semicolon] = ACTIONS(1062),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(988),
    [anon_sym_export] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_namespace] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_typeof] = ACTIONS(988),
    [anon_sym_type] = ACTIONS(988),
    [anon_sym_interface] = ACTIONS(988),
    [anon_sym_declare] = ACTIONS(988),
    [anon_sym_module] = ACTIONS(988),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_var] = ACTIONS(988),
    [anon_sym_let] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_await] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_try] = ACTIONS(988),
    [anon_sym_with] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_debugger] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_throw] = ACTIONS(988),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_yield] = ACTIONS(988),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_class] = ACTIONS(988),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(988),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_get] = ACTIONS(988),
    [anon_sym_set] = ACTIONS(988),
    [anon_sym_new] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_SLASH] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(988),
    [anon_sym_delete] = ACTIONS(988),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(986),
    [sym_number] = ACTIONS(986),
    [sym_this] = ACTIONS(988),
    [sym_super] = ACTIONS(988),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [anon_sym_AT] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_public] = ACTIONS(988),
    [anon_sym_private] = ACTIONS(988),
    [anon_sym_protected] = ACTIONS(988),
    [anon_sym_any] = ACTIONS(988),
    [anon_sym_number] = ACTIONS(988),
    [anon_sym_boolean] = ACTIONS(988),
    [anon_sym_string] = ACTIONS(988),
    [anon_sym_symbol] = ACTIONS(988),
    [sym_readonly] = ACTIONS(988),
    [sym__automatic_semicolon] = ACTIONS(994),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(976),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_default] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_RBRACE] = ACTIONS(976),
    [anon_sym_typeof] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_interface] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_import] = ACTIONS(978),
    [anon_sym_const] = ACTIONS(978),
    [anon_sym_enum] = ACTIONS(978),
    [anon_sym_var] = ACTIONS(978),
    [anon_sym_let] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(978),
    [anon_sym_if] = ACTIONS(978),
    [anon_sym_switch] = ACTIONS(978),
    [anon_sym_for] = ACTIONS(978),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_await] = ACTIONS(978),
    [anon_sym_while] = ACTIONS(978),
    [anon_sym_do] = ACTIONS(978),
    [anon_sym_try] = ACTIONS(978),
    [anon_sym_with] = ACTIONS(978),
    [anon_sym_break] = ACTIONS(978),
    [anon_sym_continue] = ACTIONS(978),
    [anon_sym_debugger] = ACTIONS(978),
    [anon_sym_return] = ACTIONS(978),
    [anon_sym_throw] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(978),
    [anon_sym_LBRACK] = ACTIONS(976),
    [anon_sym_class] = ACTIONS(978),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(978),
    [anon_sym_abstract] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_new] = ACTIONS(978),
    [anon_sym_PLUS] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(978),
    [anon_sym_SLASH] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(976),
    [anon_sym_TILDE] = ACTIONS(976),
    [anon_sym_void] = ACTIONS(978),
    [anon_sym_delete] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(976),
    [anon_sym_DQUOTE] = ACTIONS(976),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(976),
    [sym_this] = ACTIONS(978),
    [sym_super] = ACTIONS(978),
    [sym_true] = ACTIONS(978),
    [sym_false] = ACTIONS(978),
    [sym_null] = ACTIONS(978),
    [anon_sym_AT] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [sym_readonly] = ACTIONS(978),
    [sym__automatic_semicolon] = ACTIONS(984),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(996),
    [sym_identifier] = ACTIONS(998),
    [anon_sym_export] = ACTIONS(998),
    [anon_sym_default] = ACTIONS(998),
    [anon_sym_namespace] = ACTIONS(998),
    [anon_sym_LBRACE] = ACTIONS(996),
    [anon_sym_RBRACE] = ACTIONS(996),
    [anon_sym_typeof] = ACTIONS(998),
    [anon_sym_type] = ACTIONS(998),
    [anon_sym_interface] = ACTIONS(998),
    [anon_sym_declare] = ACTIONS(998),
    [anon_sym_module] = ACTIONS(998),
    [anon_sym_DOT] = ACTIONS(998),
    [anon_sym_import] = ACTIONS(998),
    [anon_sym_const] = ACTIONS(998),
    [anon_sym_enum] = ACTIONS(998),
    [anon_sym_var] = ACTIONS(998),
    [anon_sym_let] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_switch] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_await] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_do] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_debugger] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_throw] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(996),
    [anon_sym_class] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(998),
    [anon_sym_abstract] = ACTIONS(998),
    [anon_sym_get] = ACTIONS(998),
    [anon_sym_set] = ACTIONS(998),
    [anon_sym_new] = ACTIONS(998),
    [anon_sym_PLUS] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(998),
    [anon_sym_SLASH] = ACTIONS(998),
    [anon_sym_LT] = ACTIONS(996),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(998),
    [anon_sym_delete] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(996),
    [anon_sym_DQUOTE] = ACTIONS(996),
    [anon_sym_SQUOTE] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(996),
    [sym_number] = ACTIONS(996),
    [sym_this] = ACTIONS(998),
    [sym_super] = ACTIONS(998),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(996),
    [anon_sym_static] = ACTIONS(998),
    [anon_sym_public] = ACTIONS(998),
    [anon_sym_private] = ACTIONS(998),
    [anon_sym_protected] = ACTIONS(998),
    [anon_sym_any] = ACTIONS(998),
    [anon_sym_number] = ACTIONS(998),
    [anon_sym_boolean] = ACTIONS(998),
    [anon_sym_string] = ACTIONS(998),
    [anon_sym_symbol] = ACTIONS(998),
    [sym_readonly] = ACTIONS(998),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(1790),
    [anon_sym_export] = ACTIONS(1790),
    [anon_sym_default] = ACTIONS(1790),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_typeof] = ACTIONS(1790),
    [anon_sym_type] = ACTIONS(1790),
    [anon_sym_interface] = ACTIONS(1790),
    [anon_sym_declare] = ACTIONS(1790),
    [anon_sym_module] = ACTIONS(1790),
    [anon_sym_import] = ACTIONS(1790),
    [anon_sym_const] = ACTIONS(1790),
    [anon_sym_enum] = ACTIONS(1790),
    [anon_sym_var] = ACTIONS(1790),
    [anon_sym_let] = ACTIONS(1790),
    [anon_sym_BANG] = ACTIONS(1788),
    [anon_sym_else] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(1790),
    [anon_sym_switch] = ACTIONS(1790),
    [anon_sym_for] = ACTIONS(1790),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_RPAREN] = ACTIONS(1788),
    [anon_sym_await] = ACTIONS(1790),
    [anon_sym_while] = ACTIONS(1790),
    [anon_sym_do] = ACTIONS(1790),
    [anon_sym_try] = ACTIONS(1790),
    [anon_sym_with] = ACTIONS(1790),
    [anon_sym_break] = ACTIONS(1790),
    [anon_sym_continue] = ACTIONS(1790),
    [anon_sym_debugger] = ACTIONS(1790),
    [anon_sym_return] = ACTIONS(1790),
    [anon_sym_throw] = ACTIONS(1790),
    [anon_sym_SEMI] = ACTIONS(1788),
    [anon_sym_case] = ACTIONS(1790),
    [anon_sym_yield] = ACTIONS(1790),
    [anon_sym_LBRACK] = ACTIONS(1788),
    [anon_sym_class] = ACTIONS(1790),
    [anon_sym_async] = ACTIONS(1790),
    [anon_sym_function] = ACTIONS(1790),
    [anon_sym_abstract] = ACTIONS(1790),
    [anon_sym_get] = ACTIONS(1790),
    [anon_sym_set] = ACTIONS(1790),
    [anon_sym_new] = ACTIONS(1790),
    [anon_sym_PLUS] = ACTIONS(1790),
    [anon_sym_DASH] = ACTIONS(1790),
    [anon_sym_SLASH] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_TILDE] = ACTIONS(1788),
    [anon_sym_void] = ACTIONS(1790),
    [anon_sym_delete] = ACTIONS(1790),
    [anon_sym_PLUS_PLUS] = ACTIONS(1788),
    [anon_sym_DASH_DASH] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(1788),
    [anon_sym_SQUOTE] = ACTIONS(1788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1788),
    [sym_number] = ACTIONS(1788),
    [sym_this] = ACTIONS(1790),
    [sym_super] = ACTIONS(1790),
    [sym_true] = ACTIONS(1790),
    [sym_false] = ACTIONS(1790),
    [sym_null] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(1788),
    [anon_sym_static] = ACTIONS(1790),
    [anon_sym_public] = ACTIONS(1790),
    [anon_sym_private] = ACTIONS(1790),
    [anon_sym_protected] = ACTIONS(1790),
    [anon_sym_any] = ACTIONS(1790),
    [anon_sym_number] = ACTIONS(1790),
    [anon_sym_boolean] = ACTIONS(1790),
    [anon_sym_string] = ACTIONS(1790),
    [anon_sym_symbol] = ACTIONS(1790),
    [sym_readonly] = ACTIONS(1790),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1792),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1794),
    [anon_sym_namespace] = ACTIONS(1794),
    [anon_sym_LBRACE] = ACTIONS(1792),
    [anon_sym_RBRACE] = ACTIONS(1792),
    [anon_sym_typeof] = ACTIONS(1794),
    [anon_sym_type] = ACTIONS(1794),
    [anon_sym_interface] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1794),
    [anon_sym_module] = ACTIONS(1794),
    [anon_sym_import] = ACTIONS(1794),
    [anon_sym_const] = ACTIONS(1794),
    [anon_sym_enum] = ACTIONS(1794),
    [anon_sym_var] = ACTIONS(1794),
    [anon_sym_let] = ACTIONS(1794),
    [anon_sym_BANG] = ACTIONS(1792),
    [anon_sym_else] = ACTIONS(1794),
    [anon_sym_if] = ACTIONS(1794),
    [anon_sym_switch] = ACTIONS(1794),
    [anon_sym_for] = ACTIONS(1794),
    [anon_sym_LPAREN] = ACTIONS(1792),
    [anon_sym_await] = ACTIONS(1794),
    [anon_sym_while] = ACTIONS(1794),
    [anon_sym_do] = ACTIONS(1794),
    [anon_sym_try] = ACTIONS(1794),
    [anon_sym_with] = ACTIONS(1794),
    [anon_sym_break] = ACTIONS(1794),
    [anon_sym_continue] = ACTIONS(1794),
    [anon_sym_debugger] = ACTIONS(1794),
    [anon_sym_return] = ACTIONS(1794),
    [anon_sym_throw] = ACTIONS(1794),
    [anon_sym_SEMI] = ACTIONS(1792),
    [anon_sym_case] = ACTIONS(1794),
    [anon_sym_finally] = ACTIONS(1794),
    [anon_sym_yield] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(1794),
    [anon_sym_async] = ACTIONS(1794),
    [anon_sym_function] = ACTIONS(1794),
    [anon_sym_abstract] = ACTIONS(1794),
    [anon_sym_get] = ACTIONS(1794),
    [anon_sym_set] = ACTIONS(1794),
    [anon_sym_new] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1792),
    [anon_sym_void] = ACTIONS(1794),
    [anon_sym_delete] = ACTIONS(1794),
    [anon_sym_PLUS_PLUS] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1792),
    [anon_sym_SQUOTE] = ACTIONS(1792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [sym_number] = ACTIONS(1792),
    [sym_this] = ACTIONS(1794),
    [sym_super] = ACTIONS(1794),
    [sym_true] = ACTIONS(1794),
    [sym_false] = ACTIONS(1794),
    [sym_null] = ACTIONS(1794),
    [anon_sym_AT] = ACTIONS(1792),
    [anon_sym_static] = ACTIONS(1794),
    [anon_sym_public] = ACTIONS(1794),
    [anon_sym_private] = ACTIONS(1794),
    [anon_sym_protected] = ACTIONS(1794),
    [anon_sym_any] = ACTIONS(1794),
    [anon_sym_number] = ACTIONS(1794),
    [anon_sym_boolean] = ACTIONS(1794),
    [anon_sym_string] = ACTIONS(1794),
    [anon_sym_symbol] = ACTIONS(1794),
    [sym_readonly] = ACTIONS(1794),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1796),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1798),
    [anon_sym_default] = ACTIONS(1798),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1796),
    [anon_sym_RBRACE] = ACTIONS(1796),
    [anon_sym_typeof] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_interface] = ACTIONS(1798),
    [anon_sym_declare] = ACTIONS(1798),
    [anon_sym_module] = ACTIONS(1798),
    [anon_sym_import] = ACTIONS(1798),
    [anon_sym_const] = ACTIONS(1798),
    [anon_sym_enum] = ACTIONS(1798),
    [anon_sym_var] = ACTIONS(1798),
    [anon_sym_let] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(1796),
    [anon_sym_else] = ACTIONS(1798),
    [anon_sym_if] = ACTIONS(1798),
    [anon_sym_switch] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(1798),
    [anon_sym_LPAREN] = ACTIONS(1796),
    [anon_sym_await] = ACTIONS(1798),
    [anon_sym_while] = ACTIONS(1798),
    [anon_sym_do] = ACTIONS(1798),
    [anon_sym_try] = ACTIONS(1798),
    [anon_sym_with] = ACTIONS(1798),
    [anon_sym_break] = ACTIONS(1798),
    [anon_sym_continue] = ACTIONS(1798),
    [anon_sym_debugger] = ACTIONS(1798),
    [anon_sym_return] = ACTIONS(1798),
    [anon_sym_throw] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(1796),
    [anon_sym_case] = ACTIONS(1798),
    [anon_sym_finally] = ACTIONS(1798),
    [anon_sym_yield] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1796),
    [anon_sym_class] = ACTIONS(1798),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_function] = ACTIONS(1798),
    [anon_sym_abstract] = ACTIONS(1798),
    [anon_sym_get] = ACTIONS(1798),
    [anon_sym_set] = ACTIONS(1798),
    [anon_sym_new] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_SLASH] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1796),
    [anon_sym_TILDE] = ACTIONS(1796),
    [anon_sym_void] = ACTIONS(1798),
    [anon_sym_delete] = ACTIONS(1798),
    [anon_sym_PLUS_PLUS] = ACTIONS(1796),
    [anon_sym_DASH_DASH] = ACTIONS(1796),
    [anon_sym_DQUOTE] = ACTIONS(1796),
    [anon_sym_SQUOTE] = ACTIONS(1796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1796),
    [sym_number] = ACTIONS(1796),
    [sym_this] = ACTIONS(1798),
    [sym_super] = ACTIONS(1798),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_null] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1796),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_public] = ACTIONS(1798),
    [anon_sym_private] = ACTIONS(1798),
    [anon_sym_protected] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1798),
    [anon_sym_number] = ACTIONS(1798),
    [anon_sym_boolean] = ACTIONS(1798),
    [anon_sym_string] = ACTIONS(1798),
    [anon_sym_symbol] = ACTIONS(1798),
    [sym_readonly] = ACTIONS(1798),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_identifier] = ACTIONS(1092),
    [anon_sym_export] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_namespace] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [anon_sym_typeof] = ACTIONS(1092),
    [anon_sym_type] = ACTIONS(1092),
    [anon_sym_interface] = ACTIONS(1092),
    [anon_sym_declare] = ACTIONS(1092),
    [anon_sym_module] = ACTIONS(1092),
    [anon_sym_import] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_var] = ACTIONS(1092),
    [anon_sym_let] = ACTIONS(1092),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_LPAREN] = ACTIONS(1090),
    [anon_sym_await] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_try] = ACTIONS(1092),
    [anon_sym_with] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_debugger] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_throw] = ACTIONS(1092),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_yield] = ACTIONS(1092),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1092),
    [anon_sym_async] = ACTIONS(1092),
    [anon_sym_function] = ACTIONS(1092),
    [anon_sym_abstract] = ACTIONS(1092),
    [anon_sym_get] = ACTIONS(1092),
    [anon_sym_set] = ACTIONS(1092),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_SLASH] = ACTIONS(1092),
    [anon_sym_LT] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_void] = ACTIONS(1092),
    [anon_sym_delete] = ACTIONS(1092),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [sym_number] = ACTIONS(1090),
    [sym_this] = ACTIONS(1092),
    [sym_super] = ACTIONS(1092),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_public] = ACTIONS(1092),
    [anon_sym_private] = ACTIONS(1092),
    [anon_sym_protected] = ACTIONS(1092),
    [anon_sym_any] = ACTIONS(1092),
    [anon_sym_number] = ACTIONS(1092),
    [anon_sym_boolean] = ACTIONS(1092),
    [anon_sym_string] = ACTIONS(1092),
    [anon_sym_symbol] = ACTIONS(1092),
    [sym_readonly] = ACTIONS(1092),
    [sym__automatic_semicolon] = ACTIONS(1098),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1000),
    [sym_identifier] = ACTIONS(1002),
    [anon_sym_export] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_namespace] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [anon_sym_typeof] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_interface] = ACTIONS(1002),
    [anon_sym_declare] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1002),
    [anon_sym_const] = ACTIONS(1002),
    [anon_sym_enum] = ACTIONS(1002),
    [anon_sym_var] = ACTIONS(1002),
    [anon_sym_let] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_await] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_do] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_with] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_debugger] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_throw] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_yield] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1000),
    [anon_sym_class] = ACTIONS(1002),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(1002),
    [anon_sym_abstract] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1002),
    [anon_sym_set] = ACTIONS(1002),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1002),
    [anon_sym_SLASH] = ACTIONS(1002),
    [anon_sym_LT] = ACTIONS(1000),
    [anon_sym_TILDE] = ACTIONS(1000),
    [anon_sym_void] = ACTIONS(1002),
    [anon_sym_delete] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [anon_sym_SQUOTE] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [sym_number] = ACTIONS(1000),
    [sym_this] = ACTIONS(1002),
    [sym_super] = ACTIONS(1002),
    [sym_true] = ACTIONS(1002),
    [sym_false] = ACTIONS(1002),
    [sym_null] = ACTIONS(1002),
    [anon_sym_AT] = ACTIONS(1000),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_protected] = ACTIONS(1002),
    [anon_sym_any] = ACTIONS(1002),
    [anon_sym_number] = ACTIONS(1002),
    [anon_sym_boolean] = ACTIONS(1002),
    [anon_sym_string] = ACTIONS(1002),
    [anon_sym_symbol] = ACTIONS(1002),
    [sym_readonly] = ACTIONS(1002),
    [sym__automatic_semicolon] = ACTIONS(1008),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(1030),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_namespace] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_RBRACE] = ACTIONS(1030),
    [anon_sym_typeof] = ACTIONS(1032),
    [anon_sym_type] = ACTIONS(1032),
    [anon_sym_interface] = ACTIONS(1032),
    [anon_sym_declare] = ACTIONS(1032),
    [anon_sym_module] = ACTIONS(1032),
    [anon_sym_import] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_var] = ACTIONS(1032),
    [anon_sym_let] = ACTIONS(1032),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_await] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_try] = ACTIONS(1032),
    [anon_sym_with] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_debugger] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_throw] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_yield] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(1030),
    [anon_sym_class] = ACTIONS(1032),
    [anon_sym_async] = ACTIONS(1032),
    [anon_sym_function] = ACTIONS(1032),
    [anon_sym_abstract] = ACTIONS(1032),
    [anon_sym_get] = ACTIONS(1032),
    [anon_sym_set] = ACTIONS(1032),
    [anon_sym_new] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(1032),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_void] = ACTIONS(1032),
    [anon_sym_delete] = ACTIONS(1032),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [sym_number] = ACTIONS(1030),
    [sym_this] = ACTIONS(1032),
    [sym_super] = ACTIONS(1032),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [anon_sym_AT] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_public] = ACTIONS(1032),
    [anon_sym_private] = ACTIONS(1032),
    [anon_sym_protected] = ACTIONS(1032),
    [anon_sym_any] = ACTIONS(1032),
    [anon_sym_number] = ACTIONS(1032),
    [anon_sym_boolean] = ACTIONS(1032),
    [anon_sym_string] = ACTIONS(1032),
    [anon_sym_symbol] = ACTIONS(1032),
    [sym_readonly] = ACTIONS(1032),
    [sym__automatic_semicolon] = ACTIONS(1038),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1020),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_export] = ACTIONS(1022),
    [anon_sym_default] = ACTIONS(1022),
    [anon_sym_namespace] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_typeof] = ACTIONS(1022),
    [anon_sym_type] = ACTIONS(1022),
    [anon_sym_interface] = ACTIONS(1022),
    [anon_sym_declare] = ACTIONS(1022),
    [anon_sym_module] = ACTIONS(1022),
    [anon_sym_import] = ACTIONS(1022),
    [anon_sym_const] = ACTIONS(1022),
    [anon_sym_enum] = ACTIONS(1022),
    [anon_sym_var] = ACTIONS(1022),
    [anon_sym_let] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1022),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_switch] = ACTIONS(1022),
    [anon_sym_for] = ACTIONS(1022),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_await] = ACTIONS(1022),
    [anon_sym_while] = ACTIONS(1022),
    [anon_sym_do] = ACTIONS(1022),
    [anon_sym_try] = ACTIONS(1022),
    [anon_sym_with] = ACTIONS(1022),
    [anon_sym_break] = ACTIONS(1022),
    [anon_sym_continue] = ACTIONS(1022),
    [anon_sym_debugger] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1022),
    [anon_sym_throw] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1022),
    [anon_sym_yield] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_class] = ACTIONS(1022),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(1022),
    [anon_sym_abstract] = ACTIONS(1022),
    [anon_sym_get] = ACTIONS(1022),
    [anon_sym_set] = ACTIONS(1022),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_LT] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1022),
    [anon_sym_delete] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1020),
    [sym_number] = ACTIONS(1020),
    [sym_this] = ACTIONS(1022),
    [sym_super] = ACTIONS(1022),
    [sym_true] = ACTIONS(1022),
    [sym_false] = ACTIONS(1022),
    [sym_null] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1020),
    [anon_sym_static] = ACTIONS(1022),
    [anon_sym_public] = ACTIONS(1022),
    [anon_sym_private] = ACTIONS(1022),
    [anon_sym_protected] = ACTIONS(1022),
    [anon_sym_any] = ACTIONS(1022),
    [anon_sym_number] = ACTIONS(1022),
    [anon_sym_boolean] = ACTIONS(1022),
    [anon_sym_string] = ACTIONS(1022),
    [anon_sym_symbol] = ACTIONS(1022),
    [sym_readonly] = ACTIONS(1022),
    [sym__automatic_semicolon] = ACTIONS(1028),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(1076),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(1078),
    [anon_sym_default] = ACTIONS(1078),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_typeof] = ACTIONS(1078),
    [anon_sym_type] = ACTIONS(1078),
    [anon_sym_interface] = ACTIONS(1078),
    [anon_sym_declare] = ACTIONS(1078),
    [anon_sym_module] = ACTIONS(1078),
    [anon_sym_import] = ACTIONS(1078),
    [anon_sym_const] = ACTIONS(1078),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1076),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_await] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_do] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_debugger] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_throw] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1078),
    [anon_sym_yield] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_function] = ACTIONS(1078),
    [anon_sym_abstract] = ACTIONS(1078),
    [anon_sym_get] = ACTIONS(1078),
    [anon_sym_set] = ACTIONS(1078),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_PLUS] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1078),
    [anon_sym_SLASH] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(1076),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1078),
    [anon_sym_delete] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1076),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1076),
    [sym_number] = ACTIONS(1076),
    [sym_this] = ACTIONS(1078),
    [sym_super] = ACTIONS(1078),
    [sym_true] = ACTIONS(1078),
    [sym_false] = ACTIONS(1078),
    [sym_null] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_static] = ACTIONS(1078),
    [anon_sym_public] = ACTIONS(1078),
    [anon_sym_private] = ACTIONS(1078),
    [anon_sym_protected] = ACTIONS(1078),
    [anon_sym_any] = ACTIONS(1078),
    [anon_sym_number] = ACTIONS(1078),
    [anon_sym_boolean] = ACTIONS(1078),
    [anon_sym_string] = ACTIONS(1078),
    [anon_sym_symbol] = ACTIONS(1078),
    [sym_readonly] = ACTIONS(1078),
    [sym__automatic_semicolon] = ACTIONS(1084),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1800),
    [sym_identifier] = ACTIONS(1802),
    [anon_sym_export] = ACTIONS(1802),
    [anon_sym_default] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1802),
    [anon_sym_LBRACE] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [anon_sym_typeof] = ACTIONS(1802),
    [anon_sym_type] = ACTIONS(1802),
    [anon_sym_interface] = ACTIONS(1802),
    [anon_sym_declare] = ACTIONS(1802),
    [anon_sym_module] = ACTIONS(1802),
    [anon_sym_import] = ACTIONS(1802),
    [anon_sym_const] = ACTIONS(1802),
    [anon_sym_enum] = ACTIONS(1802),
    [anon_sym_var] = ACTIONS(1802),
    [anon_sym_let] = ACTIONS(1802),
    [anon_sym_BANG] = ACTIONS(1800),
    [anon_sym_else] = ACTIONS(1802),
    [anon_sym_if] = ACTIONS(1802),
    [anon_sym_switch] = ACTIONS(1802),
    [anon_sym_for] = ACTIONS(1802),
    [anon_sym_LPAREN] = ACTIONS(1800),
    [anon_sym_await] = ACTIONS(1802),
    [anon_sym_while] = ACTIONS(1802),
    [anon_sym_do] = ACTIONS(1802),
    [anon_sym_try] = ACTIONS(1802),
    [anon_sym_with] = ACTIONS(1802),
    [anon_sym_break] = ACTIONS(1802),
    [anon_sym_continue] = ACTIONS(1802),
    [anon_sym_debugger] = ACTIONS(1802),
    [anon_sym_return] = ACTIONS(1802),
    [anon_sym_throw] = ACTIONS(1802),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_case] = ACTIONS(1802),
    [anon_sym_finally] = ACTIONS(1802),
    [anon_sym_yield] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_class] = ACTIONS(1802),
    [anon_sym_async] = ACTIONS(1802),
    [anon_sym_function] = ACTIONS(1802),
    [anon_sym_abstract] = ACTIONS(1802),
    [anon_sym_get] = ACTIONS(1802),
    [anon_sym_set] = ACTIONS(1802),
    [anon_sym_new] = ACTIONS(1802),
    [anon_sym_PLUS] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(1802),
    [anon_sym_SLASH] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(1800),
    [anon_sym_TILDE] = ACTIONS(1800),
    [anon_sym_void] = ACTIONS(1802),
    [anon_sym_delete] = ACTIONS(1802),
    [anon_sym_PLUS_PLUS] = ACTIONS(1800),
    [anon_sym_DASH_DASH] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [sym_number] = ACTIONS(1800),
    [sym_this] = ACTIONS(1802),
    [sym_super] = ACTIONS(1802),
    [sym_true] = ACTIONS(1802),
    [sym_false] = ACTIONS(1802),
    [sym_null] = ACTIONS(1802),
    [anon_sym_AT] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1802),
    [anon_sym_public] = ACTIONS(1802),
    [anon_sym_private] = ACTIONS(1802),
    [anon_sym_protected] = ACTIONS(1802),
    [anon_sym_any] = ACTIONS(1802),
    [anon_sym_number] = ACTIONS(1802),
    [anon_sym_boolean] = ACTIONS(1802),
    [anon_sym_string] = ACTIONS(1802),
    [anon_sym_symbol] = ACTIONS(1802),
    [sym_readonly] = ACTIONS(1802),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(1010),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_interface] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_var] = ACTIONS(1012),
    [anon_sym_let] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_await] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_try] = ACTIONS(1012),
    [anon_sym_with] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_debugger] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_throw] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_yield] = ACTIONS(1012),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [anon_sym_class] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_function] = ACTIONS(1012),
    [anon_sym_abstract] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_new] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1012),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_delete] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [sym_number] = ACTIONS(1010),
    [sym_this] = ACTIONS(1012),
    [sym_super] = ACTIONS(1012),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [sym__automatic_semicolon] = ACTIONS(1018),
  },
  [531] = {
    [sym_else_clause] = STATE(608),
    [ts_builtin_sym_end] = ACTIONS(1804),
    [sym_identifier] = ACTIONS(1806),
    [anon_sym_export] = ACTIONS(1806),
    [anon_sym_default] = ACTIONS(1806),
    [anon_sym_namespace] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(1804),
    [anon_sym_RBRACE] = ACTIONS(1804),
    [anon_sym_typeof] = ACTIONS(1806),
    [anon_sym_type] = ACTIONS(1806),
    [anon_sym_interface] = ACTIONS(1806),
    [anon_sym_declare] = ACTIONS(1806),
    [anon_sym_module] = ACTIONS(1806),
    [anon_sym_import] = ACTIONS(1806),
    [anon_sym_const] = ACTIONS(1806),
    [anon_sym_enum] = ACTIONS(1806),
    [anon_sym_var] = ACTIONS(1806),
    [anon_sym_let] = ACTIONS(1806),
    [anon_sym_BANG] = ACTIONS(1804),
    [anon_sym_else] = ACTIONS(1808),
    [anon_sym_if] = ACTIONS(1806),
    [anon_sym_switch] = ACTIONS(1806),
    [anon_sym_for] = ACTIONS(1806),
    [anon_sym_LPAREN] = ACTIONS(1804),
    [anon_sym_await] = ACTIONS(1806),
    [anon_sym_while] = ACTIONS(1806),
    [anon_sym_do] = ACTIONS(1806),
    [anon_sym_try] = ACTIONS(1806),
    [anon_sym_with] = ACTIONS(1806),
    [anon_sym_break] = ACTIONS(1806),
    [anon_sym_continue] = ACTIONS(1806),
    [anon_sym_debugger] = ACTIONS(1806),
    [anon_sym_return] = ACTIONS(1806),
    [anon_sym_throw] = ACTIONS(1806),
    [anon_sym_SEMI] = ACTIONS(1804),
    [anon_sym_case] = ACTIONS(1806),
    [anon_sym_yield] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(1804),
    [anon_sym_class] = ACTIONS(1806),
    [anon_sym_async] = ACTIONS(1806),
    [anon_sym_function] = ACTIONS(1806),
    [anon_sym_abstract] = ACTIONS(1806),
    [anon_sym_get] = ACTIONS(1806),
    [anon_sym_set] = ACTIONS(1806),
    [anon_sym_new] = ACTIONS(1806),
    [anon_sym_PLUS] = ACTIONS(1806),
    [anon_sym_DASH] = ACTIONS(1806),
    [anon_sym_SLASH] = ACTIONS(1806),
    [anon_sym_LT] = ACTIONS(1804),
    [anon_sym_TILDE] = ACTIONS(1804),
    [anon_sym_void] = ACTIONS(1806),
    [anon_sym_delete] = ACTIONS(1806),
    [anon_sym_PLUS_PLUS] = ACTIONS(1804),
    [anon_sym_DASH_DASH] = ACTIONS(1804),
    [anon_sym_DQUOTE] = ACTIONS(1804),
    [anon_sym_SQUOTE] = ACTIONS(1804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1804),
    [sym_number] = ACTIONS(1804),
    [sym_this] = ACTIONS(1806),
    [sym_super] = ACTIONS(1806),
    [sym_true] = ACTIONS(1806),
    [sym_false] = ACTIONS(1806),
    [sym_null] = ACTIONS(1806),
    [anon_sym_AT] = ACTIONS(1804),
    [anon_sym_static] = ACTIONS(1806),
    [anon_sym_public] = ACTIONS(1806),
    [anon_sym_private] = ACTIONS(1806),
    [anon_sym_protected] = ACTIONS(1806),
    [anon_sym_any] = ACTIONS(1806),
    [anon_sym_number] = ACTIONS(1806),
    [anon_sym_boolean] = ACTIONS(1806),
    [anon_sym_string] = ACTIONS(1806),
    [anon_sym_symbol] = ACTIONS(1806),
    [sym_readonly] = ACTIONS(1806),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1810),
    [sym_identifier] = ACTIONS(1812),
    [anon_sym_export] = ACTIONS(1812),
    [anon_sym_default] = ACTIONS(1812),
    [anon_sym_namespace] = ACTIONS(1812),
    [anon_sym_LBRACE] = ACTIONS(1810),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [anon_sym_typeof] = ACTIONS(1812),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_interface] = ACTIONS(1812),
    [anon_sym_declare] = ACTIONS(1812),
    [anon_sym_module] = ACTIONS(1812),
    [anon_sym_import] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(1812),
    [anon_sym_enum] = ACTIONS(1812),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1812),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_else] = ACTIONS(1812),
    [anon_sym_if] = ACTIONS(1812),
    [anon_sym_switch] = ACTIONS(1812),
    [anon_sym_for] = ACTIONS(1812),
    [anon_sym_LPAREN] = ACTIONS(1810),
    [anon_sym_await] = ACTIONS(1812),
    [anon_sym_while] = ACTIONS(1812),
    [anon_sym_do] = ACTIONS(1812),
    [anon_sym_try] = ACTIONS(1812),
    [anon_sym_with] = ACTIONS(1812),
    [anon_sym_break] = ACTIONS(1812),
    [anon_sym_continue] = ACTIONS(1812),
    [anon_sym_debugger] = ACTIONS(1812),
    [anon_sym_return] = ACTIONS(1812),
    [anon_sym_throw] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1810),
    [anon_sym_case] = ACTIONS(1812),
    [anon_sym_finally] = ACTIONS(1812),
    [anon_sym_yield] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(1810),
    [anon_sym_class] = ACTIONS(1812),
    [anon_sym_async] = ACTIONS(1812),
    [anon_sym_function] = ACTIONS(1812),
    [anon_sym_abstract] = ACTIONS(1812),
    [anon_sym_get] = ACTIONS(1812),
    [anon_sym_set] = ACTIONS(1812),
    [anon_sym_new] = ACTIONS(1812),
    [anon_sym_PLUS] = ACTIONS(1812),
    [anon_sym_DASH] = ACTIONS(1812),
    [anon_sym_SLASH] = ACTIONS(1812),
    [anon_sym_LT] = ACTIONS(1810),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_void] = ACTIONS(1812),
    [anon_sym_delete] = ACTIONS(1812),
    [anon_sym_PLUS_PLUS] = ACTIONS(1810),
    [anon_sym_DASH_DASH] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_SQUOTE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [sym_number] = ACTIONS(1810),
    [sym_this] = ACTIONS(1812),
    [sym_super] = ACTIONS(1812),
    [sym_true] = ACTIONS(1812),
    [sym_false] = ACTIONS(1812),
    [sym_null] = ACTIONS(1812),
    [anon_sym_AT] = ACTIONS(1810),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_public] = ACTIONS(1812),
    [anon_sym_private] = ACTIONS(1812),
    [anon_sym_protected] = ACTIONS(1812),
    [anon_sym_any] = ACTIONS(1812),
    [anon_sym_number] = ACTIONS(1812),
    [anon_sym_boolean] = ACTIONS(1812),
    [anon_sym_string] = ACTIONS(1812),
    [anon_sym_symbol] = ACTIONS(1812),
    [sym_readonly] = ACTIONS(1812),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(1100),
    [sym_identifier] = ACTIONS(1102),
    [anon_sym_export] = ACTIONS(1102),
    [anon_sym_default] = ACTIONS(1102),
    [anon_sym_namespace] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [anon_sym_RBRACE] = ACTIONS(1100),
    [anon_sym_typeof] = ACTIONS(1102),
    [anon_sym_type] = ACTIONS(1102),
    [anon_sym_interface] = ACTIONS(1102),
    [anon_sym_declare] = ACTIONS(1102),
    [anon_sym_module] = ACTIONS(1102),
    [anon_sym_import] = ACTIONS(1102),
    [anon_sym_const] = ACTIONS(1102),
    [anon_sym_enum] = ACTIONS(1102),
    [anon_sym_var] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1102),
    [anon_sym_switch] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_await] = ACTIONS(1102),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_debugger] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_throw] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1102),
    [anon_sym_yield] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1102),
    [anon_sym_async] = ACTIONS(1102),
    [anon_sym_function] = ACTIONS(1102),
    [anon_sym_abstract] = ACTIONS(1102),
    [anon_sym_get] = ACTIONS(1102),
    [anon_sym_set] = ACTIONS(1102),
    [anon_sym_new] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1102),
    [anon_sym_delete] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_SQUOTE] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1100),
    [sym_number] = ACTIONS(1100),
    [sym_this] = ACTIONS(1102),
    [sym_super] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_null] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_static] = ACTIONS(1102),
    [anon_sym_public] = ACTIONS(1102),
    [anon_sym_private] = ACTIONS(1102),
    [anon_sym_protected] = ACTIONS(1102),
    [anon_sym_any] = ACTIONS(1102),
    [anon_sym_number] = ACTIONS(1102),
    [anon_sym_boolean] = ACTIONS(1102),
    [anon_sym_string] = ACTIONS(1102),
    [anon_sym_symbol] = ACTIONS(1102),
    [sym_readonly] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(1108),
  },
  [534] = {
    [sym_statement_block] = STATE(561),
    [ts_builtin_sym_end] = ACTIONS(910),
    [sym_identifier] = ACTIONS(912),
    [anon_sym_export] = ACTIONS(912),
    [anon_sym_default] = ACTIONS(912),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(1780),
    [anon_sym_RBRACE] = ACTIONS(910),
    [anon_sym_typeof] = ACTIONS(912),
    [anon_sym_type] = ACTIONS(912),
    [anon_sym_interface] = ACTIONS(912),
    [anon_sym_declare] = ACTIONS(912),
    [anon_sym_module] = ACTIONS(912),
    [anon_sym_import] = ACTIONS(912),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_enum] = ACTIONS(912),
    [anon_sym_var] = ACTIONS(912),
    [anon_sym_let] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(912),
    [anon_sym_if] = ACTIONS(912),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(910),
    [anon_sym_await] = ACTIONS(912),
    [anon_sym_while] = ACTIONS(912),
    [anon_sym_do] = ACTIONS(912),
    [anon_sym_try] = ACTIONS(912),
    [anon_sym_with] = ACTIONS(912),
    [anon_sym_break] = ACTIONS(912),
    [anon_sym_continue] = ACTIONS(912),
    [anon_sym_debugger] = ACTIONS(912),
    [anon_sym_return] = ACTIONS(912),
    [anon_sym_throw] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(912),
    [anon_sym_yield] = ACTIONS(912),
    [anon_sym_LBRACK] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(912),
    [anon_sym_async] = ACTIONS(912),
    [anon_sym_function] = ACTIONS(912),
    [anon_sym_abstract] = ACTIONS(912),
    [anon_sym_get] = ACTIONS(912),
    [anon_sym_set] = ACTIONS(912),
    [anon_sym_new] = ACTIONS(912),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_SLASH] = ACTIONS(912),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_TILDE] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(912),
    [anon_sym_delete] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(910),
    [anon_sym_DQUOTE] = ACTIONS(910),
    [anon_sym_SQUOTE] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(910),
    [sym_number] = ACTIONS(910),
    [sym_this] = ACTIONS(912),
    [sym_super] = ACTIONS(912),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [sym_null] = ACTIONS(912),
    [anon_sym_AT] = ACTIONS(910),
    [anon_sym_static] = ACTIONS(912),
    [anon_sym_public] = ACTIONS(912),
    [anon_sym_private] = ACTIONS(912),
    [anon_sym_protected] = ACTIONS(912),
    [anon_sym_any] = ACTIONS(912),
    [anon_sym_number] = ACTIONS(912),
    [anon_sym_boolean] = ACTIONS(912),
    [anon_sym_string] = ACTIONS(912),
    [anon_sym_symbol] = ACTIONS(912),
    [sym_readonly] = ACTIONS(912),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(948),
    [sym_identifier] = ACTIONS(950),
    [anon_sym_export] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_namespace] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_typeof] = ACTIONS(950),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(950),
    [anon_sym_module] = ACTIONS(950),
    [anon_sym_import] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_var] = ACTIONS(950),
    [anon_sym_let] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_await] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_try] = ACTIONS(950),
    [anon_sym_with] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_debugger] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_throw] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_yield] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_class] = ACTIONS(950),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(950),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_get] = ACTIONS(950),
    [anon_sym_set] = ACTIONS(950),
    [anon_sym_new] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_SLASH] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_void] = ACTIONS(950),
    [anon_sym_delete] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_DQUOTE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [sym_number] = ACTIONS(948),
    [sym_this] = ACTIONS(950),
    [sym_super] = ACTIONS(950),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(950),
    [anon_sym_AT] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_any] = ACTIONS(950),
    [anon_sym_number] = ACTIONS(950),
    [anon_sym_boolean] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_symbol] = ACTIONS(950),
    [sym_readonly] = ACTIONS(950),
    [sym__automatic_semicolon] = ACTIONS(956),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_default] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_RBRACE] = ACTIONS(1040),
    [anon_sym_typeof] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_interface] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_import] = ACTIONS(1042),
    [anon_sym_const] = ACTIONS(1042),
    [anon_sym_enum] = ACTIONS(1042),
    [anon_sym_var] = ACTIONS(1042),
    [anon_sym_let] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1042),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_switch] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1042),
    [anon_sym_LPAREN] = ACTIONS(1040),
    [anon_sym_await] = ACTIONS(1042),
    [anon_sym_while] = ACTIONS(1042),
    [anon_sym_do] = ACTIONS(1042),
    [anon_sym_try] = ACTIONS(1042),
    [anon_sym_with] = ACTIONS(1042),
    [anon_sym_break] = ACTIONS(1042),
    [anon_sym_continue] = ACTIONS(1042),
    [anon_sym_debugger] = ACTIONS(1042),
    [anon_sym_return] = ACTIONS(1042),
    [anon_sym_throw] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1042),
    [anon_sym_async] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(1042),
    [anon_sym_abstract] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_void] = ACTIONS(1042),
    [anon_sym_delete] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1040),
    [sym_number] = ACTIONS(1040),
    [sym_this] = ACTIONS(1042),
    [sym_super] = ACTIONS(1042),
    [sym_true] = ACTIONS(1042),
    [sym_false] = ACTIONS(1042),
    [sym_null] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [sym_readonly] = ACTIONS(1042),
    [sym__automatic_semicolon] = ACTIONS(1048),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1814),
    [sym_identifier] = ACTIONS(1816),
    [anon_sym_export] = ACTIONS(1816),
    [anon_sym_default] = ACTIONS(1816),
    [anon_sym_namespace] = ACTIONS(1816),
    [anon_sym_LBRACE] = ACTIONS(1814),
    [anon_sym_RBRACE] = ACTIONS(1814),
    [anon_sym_typeof] = ACTIONS(1816),
    [anon_sym_type] = ACTIONS(1816),
    [anon_sym_interface] = ACTIONS(1816),
    [anon_sym_declare] = ACTIONS(1816),
    [anon_sym_module] = ACTIONS(1816),
    [anon_sym_import] = ACTIONS(1816),
    [anon_sym_const] = ACTIONS(1816),
    [anon_sym_enum] = ACTIONS(1816),
    [anon_sym_var] = ACTIONS(1816),
    [anon_sym_let] = ACTIONS(1816),
    [anon_sym_BANG] = ACTIONS(1814),
    [anon_sym_else] = ACTIONS(1816),
    [anon_sym_if] = ACTIONS(1816),
    [anon_sym_switch] = ACTIONS(1816),
    [anon_sym_for] = ACTIONS(1816),
    [anon_sym_LPAREN] = ACTIONS(1814),
    [anon_sym_RPAREN] = ACTIONS(1814),
    [anon_sym_await] = ACTIONS(1816),
    [anon_sym_while] = ACTIONS(1816),
    [anon_sym_do] = ACTIONS(1816),
    [anon_sym_try] = ACTIONS(1816),
    [anon_sym_with] = ACTIONS(1816),
    [anon_sym_break] = ACTIONS(1816),
    [anon_sym_continue] = ACTIONS(1816),
    [anon_sym_debugger] = ACTIONS(1816),
    [anon_sym_return] = ACTIONS(1816),
    [anon_sym_throw] = ACTIONS(1816),
    [anon_sym_SEMI] = ACTIONS(1814),
    [anon_sym_case] = ACTIONS(1816),
    [anon_sym_yield] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(1814),
    [anon_sym_class] = ACTIONS(1816),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_function] = ACTIONS(1816),
    [anon_sym_abstract] = ACTIONS(1816),
    [anon_sym_get] = ACTIONS(1816),
    [anon_sym_set] = ACTIONS(1816),
    [anon_sym_new] = ACTIONS(1816),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_SLASH] = ACTIONS(1816),
    [anon_sym_LT] = ACTIONS(1814),
    [anon_sym_TILDE] = ACTIONS(1814),
    [anon_sym_void] = ACTIONS(1816),
    [anon_sym_delete] = ACTIONS(1816),
    [anon_sym_PLUS_PLUS] = ACTIONS(1814),
    [anon_sym_DASH_DASH] = ACTIONS(1814),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_SQUOTE] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1814),
    [sym_number] = ACTIONS(1814),
    [sym_this] = ACTIONS(1816),
    [sym_super] = ACTIONS(1816),
    [sym_true] = ACTIONS(1816),
    [sym_false] = ACTIONS(1816),
    [sym_null] = ACTIONS(1816),
    [anon_sym_AT] = ACTIONS(1814),
    [anon_sym_static] = ACTIONS(1816),
    [anon_sym_public] = ACTIONS(1816),
    [anon_sym_private] = ACTIONS(1816),
    [anon_sym_protected] = ACTIONS(1816),
    [anon_sym_any] = ACTIONS(1816),
    [anon_sym_number] = ACTIONS(1816),
    [anon_sym_boolean] = ACTIONS(1816),
    [anon_sym_string] = ACTIONS(1816),
    [anon_sym_symbol] = ACTIONS(1816),
    [sym_readonly] = ACTIONS(1816),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(1818),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_export] = ACTIONS(1820),
    [anon_sym_default] = ACTIONS(1820),
    [anon_sym_namespace] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1820),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_interface] = ACTIONS(1820),
    [anon_sym_declare] = ACTIONS(1820),
    [anon_sym_module] = ACTIONS(1820),
    [anon_sym_import] = ACTIONS(1820),
    [anon_sym_const] = ACTIONS(1820),
    [anon_sym_enum] = ACTIONS(1820),
    [anon_sym_var] = ACTIONS(1820),
    [anon_sym_let] = ACTIONS(1820),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1820),
    [anon_sym_if] = ACTIONS(1820),
    [anon_sym_switch] = ACTIONS(1820),
    [anon_sym_for] = ACTIONS(1820),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_await] = ACTIONS(1820),
    [anon_sym_while] = ACTIONS(1820),
    [anon_sym_do] = ACTIONS(1820),
    [anon_sym_try] = ACTIONS(1820),
    [anon_sym_with] = ACTIONS(1820),
    [anon_sym_break] = ACTIONS(1820),
    [anon_sym_continue] = ACTIONS(1820),
    [anon_sym_debugger] = ACTIONS(1820),
    [anon_sym_return] = ACTIONS(1820),
    [anon_sym_throw] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_case] = ACTIONS(1820),
    [anon_sym_yield] = ACTIONS(1820),
    [anon_sym_LBRACK] = ACTIONS(1818),
    [anon_sym_class] = ACTIONS(1820),
    [anon_sym_async] = ACTIONS(1820),
    [anon_sym_function] = ACTIONS(1820),
    [anon_sym_abstract] = ACTIONS(1820),
    [anon_sym_get] = ACTIONS(1820),
    [anon_sym_set] = ACTIONS(1820),
    [anon_sym_new] = ACTIONS(1820),
    [anon_sym_PLUS] = ACTIONS(1820),
    [anon_sym_DASH] = ACTIONS(1820),
    [anon_sym_SLASH] = ACTIONS(1820),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1818),
    [anon_sym_void] = ACTIONS(1820),
    [anon_sym_delete] = ACTIONS(1820),
    [anon_sym_PLUS_PLUS] = ACTIONS(1818),
    [anon_sym_DASH_DASH] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_SQUOTE] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(1820),
    [sym_super] = ACTIONS(1820),
    [sym_true] = ACTIONS(1820),
    [sym_false] = ACTIONS(1820),
    [sym_null] = ACTIONS(1820),
    [anon_sym_AT] = ACTIONS(1818),
    [anon_sym_static] = ACTIONS(1820),
    [anon_sym_public] = ACTIONS(1820),
    [anon_sym_private] = ACTIONS(1820),
    [anon_sym_protected] = ACTIONS(1820),
    [anon_sym_any] = ACTIONS(1820),
    [anon_sym_number] = ACTIONS(1820),
    [anon_sym_boolean] = ACTIONS(1820),
    [anon_sym_string] = ACTIONS(1820),
    [anon_sym_symbol] = ACTIONS(1820),
    [sym_readonly] = ACTIONS(1820),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1824),
    [anon_sym_export] = ACTIONS(1824),
    [anon_sym_default] = ACTIONS(1824),
    [anon_sym_namespace] = ACTIONS(1824),
    [anon_sym_LBRACE] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_typeof] = ACTIONS(1824),
    [anon_sym_type] = ACTIONS(1824),
    [anon_sym_interface] = ACTIONS(1824),
    [anon_sym_declare] = ACTIONS(1824),
    [anon_sym_module] = ACTIONS(1824),
    [anon_sym_import] = ACTIONS(1824),
    [anon_sym_const] = ACTIONS(1824),
    [anon_sym_enum] = ACTIONS(1824),
    [anon_sym_var] = ACTIONS(1824),
    [anon_sym_let] = ACTIONS(1824),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_else] = ACTIONS(1824),
    [anon_sym_if] = ACTIONS(1824),
    [anon_sym_switch] = ACTIONS(1824),
    [anon_sym_for] = ACTIONS(1824),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [anon_sym_while] = ACTIONS(1824),
    [anon_sym_do] = ACTIONS(1824),
    [anon_sym_try] = ACTIONS(1824),
    [anon_sym_with] = ACTIONS(1824),
    [anon_sym_break] = ACTIONS(1824),
    [anon_sym_continue] = ACTIONS(1824),
    [anon_sym_debugger] = ACTIONS(1824),
    [anon_sym_return] = ACTIONS(1824),
    [anon_sym_throw] = ACTIONS(1824),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_case] = ACTIONS(1824),
    [anon_sym_yield] = ACTIONS(1824),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_class] = ACTIONS(1824),
    [anon_sym_async] = ACTIONS(1824),
    [anon_sym_function] = ACTIONS(1824),
    [anon_sym_abstract] = ACTIONS(1824),
    [anon_sym_get] = ACTIONS(1824),
    [anon_sym_set] = ACTIONS(1824),
    [anon_sym_new] = ACTIONS(1824),
    [anon_sym_PLUS] = ACTIONS(1824),
    [anon_sym_DASH] = ACTIONS(1824),
    [anon_sym_SLASH] = ACTIONS(1824),
    [anon_sym_LT] = ACTIONS(1822),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_void] = ACTIONS(1824),
    [anon_sym_delete] = ACTIONS(1824),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_number] = ACTIONS(1822),
    [sym_this] = ACTIONS(1824),
    [sym_super] = ACTIONS(1824),
    [sym_true] = ACTIONS(1824),
    [sym_false] = ACTIONS(1824),
    [sym_null] = ACTIONS(1824),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1824),
    [anon_sym_public] = ACTIONS(1824),
    [anon_sym_private] = ACTIONS(1824),
    [anon_sym_protected] = ACTIONS(1824),
    [anon_sym_any] = ACTIONS(1824),
    [anon_sym_number] = ACTIONS(1824),
    [anon_sym_boolean] = ACTIONS(1824),
    [anon_sym_string] = ACTIONS(1824),
    [anon_sym_symbol] = ACTIONS(1824),
    [sym_readonly] = ACTIONS(1824),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1826),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_export] = ACTIONS(1828),
    [anon_sym_default] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1828),
    [anon_sym_LBRACE] = ACTIONS(1826),
    [anon_sym_RBRACE] = ACTIONS(1826),
    [anon_sym_typeof] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_interface] = ACTIONS(1828),
    [anon_sym_declare] = ACTIONS(1828),
    [anon_sym_module] = ACTIONS(1828),
    [anon_sym_import] = ACTIONS(1828),
    [anon_sym_const] = ACTIONS(1828),
    [anon_sym_enum] = ACTIONS(1828),
    [anon_sym_var] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1828),
    [anon_sym_BANG] = ACTIONS(1826),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_switch] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_LPAREN] = ACTIONS(1826),
    [anon_sym_await] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_try] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_break] = ACTIONS(1828),
    [anon_sym_continue] = ACTIONS(1828),
    [anon_sym_debugger] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_throw] = ACTIONS(1828),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_case] = ACTIONS(1828),
    [anon_sym_yield] = ACTIONS(1828),
    [anon_sym_LBRACK] = ACTIONS(1826),
    [anon_sym_class] = ACTIONS(1828),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_abstract] = ACTIONS(1828),
    [anon_sym_get] = ACTIONS(1828),
    [anon_sym_set] = ACTIONS(1828),
    [anon_sym_new] = ACTIONS(1828),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1828),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_TILDE] = ACTIONS(1826),
    [anon_sym_void] = ACTIONS(1828),
    [anon_sym_delete] = ACTIONS(1828),
    [anon_sym_PLUS_PLUS] = ACTIONS(1826),
    [anon_sym_DASH_DASH] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1826),
    [anon_sym_SQUOTE] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1826),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(1828),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(1826),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_public] = ACTIONS(1828),
    [anon_sym_private] = ACTIONS(1828),
    [anon_sym_protected] = ACTIONS(1828),
    [anon_sym_any] = ACTIONS(1828),
    [anon_sym_number] = ACTIONS(1828),
    [anon_sym_boolean] = ACTIONS(1828),
    [anon_sym_string] = ACTIONS(1828),
    [anon_sym_symbol] = ACTIONS(1828),
    [sym_readonly] = ACTIONS(1828),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(1832),
    [anon_sym_export] = ACTIONS(1832),
    [anon_sym_default] = ACTIONS(1832),
    [anon_sym_namespace] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(1830),
    [anon_sym_RBRACE] = ACTIONS(1830),
    [anon_sym_typeof] = ACTIONS(1832),
    [anon_sym_type] = ACTIONS(1832),
    [anon_sym_interface] = ACTIONS(1832),
    [anon_sym_declare] = ACTIONS(1832),
    [anon_sym_module] = ACTIONS(1832),
    [anon_sym_import] = ACTIONS(1832),
    [anon_sym_const] = ACTIONS(1832),
    [anon_sym_enum] = ACTIONS(1832),
    [anon_sym_var] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(1832),
    [anon_sym_BANG] = ACTIONS(1830),
    [anon_sym_else] = ACTIONS(1832),
    [anon_sym_if] = ACTIONS(1832),
    [anon_sym_switch] = ACTIONS(1832),
    [anon_sym_for] = ACTIONS(1832),
    [anon_sym_LPAREN] = ACTIONS(1830),
    [anon_sym_await] = ACTIONS(1832),
    [anon_sym_while] = ACTIONS(1832),
    [anon_sym_do] = ACTIONS(1832),
    [anon_sym_try] = ACTIONS(1832),
    [anon_sym_with] = ACTIONS(1832),
    [anon_sym_break] = ACTIONS(1832),
    [anon_sym_continue] = ACTIONS(1832),
    [anon_sym_debugger] = ACTIONS(1832),
    [anon_sym_return] = ACTIONS(1832),
    [anon_sym_throw] = ACTIONS(1832),
    [anon_sym_SEMI] = ACTIONS(1830),
    [anon_sym_case] = ACTIONS(1832),
    [anon_sym_yield] = ACTIONS(1832),
    [anon_sym_LBRACK] = ACTIONS(1830),
    [anon_sym_class] = ACTIONS(1832),
    [anon_sym_async] = ACTIONS(1832),
    [anon_sym_function] = ACTIONS(1832),
    [anon_sym_abstract] = ACTIONS(1832),
    [anon_sym_get] = ACTIONS(1832),
    [anon_sym_set] = ACTIONS(1832),
    [anon_sym_new] = ACTIONS(1832),
    [anon_sym_PLUS] = ACTIONS(1832),
    [anon_sym_DASH] = ACTIONS(1832),
    [anon_sym_SLASH] = ACTIONS(1832),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_TILDE] = ACTIONS(1830),
    [anon_sym_void] = ACTIONS(1832),
    [anon_sym_delete] = ACTIONS(1832),
    [anon_sym_PLUS_PLUS] = ACTIONS(1830),
    [anon_sym_DASH_DASH] = ACTIONS(1830),
    [anon_sym_DQUOTE] = ACTIONS(1830),
    [anon_sym_SQUOTE] = ACTIONS(1830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [sym_number] = ACTIONS(1830),
    [sym_this] = ACTIONS(1832),
    [sym_super] = ACTIONS(1832),
    [sym_true] = ACTIONS(1832),
    [sym_false] = ACTIONS(1832),
    [sym_null] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(1830),
    [anon_sym_static] = ACTIONS(1832),
    [anon_sym_public] = ACTIONS(1832),
    [anon_sym_private] = ACTIONS(1832),
    [anon_sym_protected] = ACTIONS(1832),
    [anon_sym_any] = ACTIONS(1832),
    [anon_sym_number] = ACTIONS(1832),
    [anon_sym_boolean] = ACTIONS(1832),
    [anon_sym_string] = ACTIONS(1832),
    [anon_sym_symbol] = ACTIONS(1832),
    [sym_readonly] = ACTIONS(1832),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(1836),
    [anon_sym_export] = ACTIONS(1836),
    [anon_sym_default] = ACTIONS(1836),
    [anon_sym_namespace] = ACTIONS(1836),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_typeof] = ACTIONS(1836),
    [anon_sym_type] = ACTIONS(1836),
    [anon_sym_interface] = ACTIONS(1836),
    [anon_sym_declare] = ACTIONS(1836),
    [anon_sym_module] = ACTIONS(1836),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_const] = ACTIONS(1836),
    [anon_sym_enum] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1836),
    [anon_sym_let] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_else] = ACTIONS(1836),
    [anon_sym_if] = ACTIONS(1836),
    [anon_sym_switch] = ACTIONS(1836),
    [anon_sym_for] = ACTIONS(1836),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_await] = ACTIONS(1836),
    [anon_sym_while] = ACTIONS(1836),
    [anon_sym_do] = ACTIONS(1836),
    [anon_sym_try] = ACTIONS(1836),
    [anon_sym_with] = ACTIONS(1836),
    [anon_sym_break] = ACTIONS(1836),
    [anon_sym_continue] = ACTIONS(1836),
    [anon_sym_debugger] = ACTIONS(1836),
    [anon_sym_return] = ACTIONS(1836),
    [anon_sym_throw] = ACTIONS(1836),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_case] = ACTIONS(1836),
    [anon_sym_yield] = ACTIONS(1836),
    [anon_sym_LBRACK] = ACTIONS(1834),
    [anon_sym_class] = ACTIONS(1836),
    [anon_sym_async] = ACTIONS(1836),
    [anon_sym_function] = ACTIONS(1836),
    [anon_sym_abstract] = ACTIONS(1836),
    [anon_sym_get] = ACTIONS(1836),
    [anon_sym_set] = ACTIONS(1836),
    [anon_sym_new] = ACTIONS(1836),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_SLASH] = ACTIONS(1836),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_TILDE] = ACTIONS(1834),
    [anon_sym_void] = ACTIONS(1836),
    [anon_sym_delete] = ACTIONS(1836),
    [anon_sym_PLUS_PLUS] = ACTIONS(1834),
    [anon_sym_DASH_DASH] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_SQUOTE] = ACTIONS(1834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [sym_number] = ACTIONS(1834),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(1836),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(1834),
    [anon_sym_static] = ACTIONS(1836),
    [anon_sym_public] = ACTIONS(1836),
    [anon_sym_private] = ACTIONS(1836),
    [anon_sym_protected] = ACTIONS(1836),
    [anon_sym_any] = ACTIONS(1836),
    [anon_sym_number] = ACTIONS(1836),
    [anon_sym_boolean] = ACTIONS(1836),
    [anon_sym_string] = ACTIONS(1836),
    [anon_sym_symbol] = ACTIONS(1836),
    [sym_readonly] = ACTIONS(1836),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_default] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_typeof] = ACTIONS(1840),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_interface] = ACTIONS(1840),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_import] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1840),
    [anon_sym_enum] = ACTIONS(1840),
    [anon_sym_var] = ACTIONS(1840),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_else] = ACTIONS(1840),
    [anon_sym_if] = ACTIONS(1840),
    [anon_sym_switch] = ACTIONS(1840),
    [anon_sym_for] = ACTIONS(1840),
    [anon_sym_LPAREN] = ACTIONS(1838),
    [anon_sym_await] = ACTIONS(1840),
    [anon_sym_while] = ACTIONS(1840),
    [anon_sym_do] = ACTIONS(1840),
    [anon_sym_try] = ACTIONS(1840),
    [anon_sym_with] = ACTIONS(1840),
    [anon_sym_break] = ACTIONS(1840),
    [anon_sym_continue] = ACTIONS(1840),
    [anon_sym_debugger] = ACTIONS(1840),
    [anon_sym_return] = ACTIONS(1840),
    [anon_sym_throw] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1838),
    [anon_sym_case] = ACTIONS(1840),
    [anon_sym_yield] = ACTIONS(1840),
    [anon_sym_LBRACK] = ACTIONS(1838),
    [anon_sym_class] = ACTIONS(1840),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_function] = ACTIONS(1840),
    [anon_sym_abstract] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_new] = ACTIONS(1840),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1840),
    [anon_sym_SLASH] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1838),
    [anon_sym_void] = ACTIONS(1840),
    [anon_sym_delete] = ACTIONS(1840),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_DQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1838),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(1840),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(1838),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [sym_readonly] = ACTIONS(1840),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1844),
    [anon_sym_default] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1844),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [anon_sym_RBRACE] = ACTIONS(1842),
    [anon_sym_typeof] = ACTIONS(1844),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_interface] = ACTIONS(1844),
    [anon_sym_declare] = ACTIONS(1844),
    [anon_sym_module] = ACTIONS(1844),
    [anon_sym_import] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1844),
    [anon_sym_enum] = ACTIONS(1844),
    [anon_sym_var] = ACTIONS(1844),
    [anon_sym_let] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1842),
    [anon_sym_else] = ACTIONS(1844),
    [anon_sym_if] = ACTIONS(1844),
    [anon_sym_switch] = ACTIONS(1844),
    [anon_sym_for] = ACTIONS(1844),
    [anon_sym_LPAREN] = ACTIONS(1842),
    [anon_sym_await] = ACTIONS(1844),
    [anon_sym_while] = ACTIONS(1844),
    [anon_sym_do] = ACTIONS(1844),
    [anon_sym_try] = ACTIONS(1844),
    [anon_sym_with] = ACTIONS(1844),
    [anon_sym_break] = ACTIONS(1844),
    [anon_sym_continue] = ACTIONS(1844),
    [anon_sym_debugger] = ACTIONS(1844),
    [anon_sym_return] = ACTIONS(1844),
    [anon_sym_throw] = ACTIONS(1844),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_case] = ACTIONS(1844),
    [anon_sym_yield] = ACTIONS(1844),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_class] = ACTIONS(1844),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_function] = ACTIONS(1844),
    [anon_sym_abstract] = ACTIONS(1844),
    [anon_sym_get] = ACTIONS(1844),
    [anon_sym_set] = ACTIONS(1844),
    [anon_sym_new] = ACTIONS(1844),
    [anon_sym_PLUS] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1844),
    [anon_sym_SLASH] = ACTIONS(1844),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_TILDE] = ACTIONS(1842),
    [anon_sym_void] = ACTIONS(1844),
    [anon_sym_delete] = ACTIONS(1844),
    [anon_sym_PLUS_PLUS] = ACTIONS(1842),
    [anon_sym_DASH_DASH] = ACTIONS(1842),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(1844),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_public] = ACTIONS(1844),
    [anon_sym_private] = ACTIONS(1844),
    [anon_sym_protected] = ACTIONS(1844),
    [anon_sym_any] = ACTIONS(1844),
    [anon_sym_number] = ACTIONS(1844),
    [anon_sym_boolean] = ACTIONS(1844),
    [anon_sym_string] = ACTIONS(1844),
    [anon_sym_symbol] = ACTIONS(1844),
    [sym_readonly] = ACTIONS(1844),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1846),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_export] = ACTIONS(1848),
    [anon_sym_default] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_type] = ACTIONS(1848),
    [anon_sym_interface] = ACTIONS(1848),
    [anon_sym_declare] = ACTIONS(1848),
    [anon_sym_module] = ACTIONS(1848),
    [anon_sym_import] = ACTIONS(1848),
    [anon_sym_const] = ACTIONS(1848),
    [anon_sym_enum] = ACTIONS(1848),
    [anon_sym_var] = ACTIONS(1848),
    [anon_sym_let] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_else] = ACTIONS(1848),
    [anon_sym_if] = ACTIONS(1848),
    [anon_sym_switch] = ACTIONS(1848),
    [anon_sym_for] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [anon_sym_await] = ACTIONS(1848),
    [anon_sym_while] = ACTIONS(1848),
    [anon_sym_do] = ACTIONS(1848),
    [anon_sym_try] = ACTIONS(1848),
    [anon_sym_with] = ACTIONS(1848),
    [anon_sym_break] = ACTIONS(1848),
    [anon_sym_continue] = ACTIONS(1848),
    [anon_sym_debugger] = ACTIONS(1848),
    [anon_sym_return] = ACTIONS(1848),
    [anon_sym_throw] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_case] = ACTIONS(1848),
    [anon_sym_yield] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_class] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_function] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_delete] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1846),
    [anon_sym_DASH_DASH] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [sym_number] = ACTIONS(1846),
    [sym_this] = ACTIONS(1848),
    [sym_super] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [anon_sym_AT] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_public] = ACTIONS(1848),
    [anon_sym_private] = ACTIONS(1848),
    [anon_sym_protected] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [sym_readonly] = ACTIONS(1848),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1850),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_export] = ACTIONS(1852),
    [anon_sym_default] = ACTIONS(1852),
    [anon_sym_namespace] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1850),
    [anon_sym_typeof] = ACTIONS(1852),
    [anon_sym_type] = ACTIONS(1852),
    [anon_sym_interface] = ACTIONS(1852),
    [anon_sym_declare] = ACTIONS(1852),
    [anon_sym_module] = ACTIONS(1852),
    [anon_sym_import] = ACTIONS(1852),
    [anon_sym_const] = ACTIONS(1852),
    [anon_sym_enum] = ACTIONS(1852),
    [anon_sym_var] = ACTIONS(1852),
    [anon_sym_let] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1850),
    [anon_sym_else] = ACTIONS(1852),
    [anon_sym_if] = ACTIONS(1852),
    [anon_sym_switch] = ACTIONS(1852),
    [anon_sym_for] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1850),
    [anon_sym_await] = ACTIONS(1852),
    [anon_sym_while] = ACTIONS(1852),
    [anon_sym_do] = ACTIONS(1852),
    [anon_sym_try] = ACTIONS(1852),
    [anon_sym_with] = ACTIONS(1852),
    [anon_sym_break] = ACTIONS(1852),
    [anon_sym_continue] = ACTIONS(1852),
    [anon_sym_debugger] = ACTIONS(1852),
    [anon_sym_return] = ACTIONS(1852),
    [anon_sym_throw] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_case] = ACTIONS(1852),
    [anon_sym_yield] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1850),
    [anon_sym_class] = ACTIONS(1852),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_function] = ACTIONS(1852),
    [anon_sym_abstract] = ACTIONS(1852),
    [anon_sym_get] = ACTIONS(1852),
    [anon_sym_set] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1852),
    [anon_sym_SLASH] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_TILDE] = ACTIONS(1850),
    [anon_sym_void] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1850),
    [anon_sym_DASH_DASH] = ACTIONS(1850),
    [anon_sym_DQUOTE] = ACTIONS(1850),
    [anon_sym_SQUOTE] = ACTIONS(1850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [sym_number] = ACTIONS(1850),
    [sym_this] = ACTIONS(1852),
    [sym_super] = ACTIONS(1852),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_null] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(1850),
    [anon_sym_static] = ACTIONS(1852),
    [anon_sym_public] = ACTIONS(1852),
    [anon_sym_private] = ACTIONS(1852),
    [anon_sym_protected] = ACTIONS(1852),
    [anon_sym_any] = ACTIONS(1852),
    [anon_sym_number] = ACTIONS(1852),
    [anon_sym_boolean] = ACTIONS(1852),
    [anon_sym_string] = ACTIONS(1852),
    [anon_sym_symbol] = ACTIONS(1852),
    [sym_readonly] = ACTIONS(1852),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(1854),
    [sym_identifier] = ACTIONS(1856),
    [anon_sym_export] = ACTIONS(1856),
    [anon_sym_default] = ACTIONS(1856),
    [anon_sym_namespace] = ACTIONS(1856),
    [anon_sym_LBRACE] = ACTIONS(1854),
    [anon_sym_RBRACE] = ACTIONS(1854),
    [anon_sym_typeof] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1856),
    [anon_sym_interface] = ACTIONS(1856),
    [anon_sym_declare] = ACTIONS(1856),
    [anon_sym_module] = ACTIONS(1856),
    [anon_sym_import] = ACTIONS(1856),
    [anon_sym_const] = ACTIONS(1856),
    [anon_sym_enum] = ACTIONS(1856),
    [anon_sym_var] = ACTIONS(1856),
    [anon_sym_let] = ACTIONS(1856),
    [anon_sym_BANG] = ACTIONS(1854),
    [anon_sym_else] = ACTIONS(1856),
    [anon_sym_if] = ACTIONS(1856),
    [anon_sym_switch] = ACTIONS(1856),
    [anon_sym_for] = ACTIONS(1856),
    [anon_sym_LPAREN] = ACTIONS(1854),
    [anon_sym_await] = ACTIONS(1856),
    [anon_sym_while] = ACTIONS(1856),
    [anon_sym_do] = ACTIONS(1856),
    [anon_sym_try] = ACTIONS(1856),
    [anon_sym_with] = ACTIONS(1856),
    [anon_sym_break] = ACTIONS(1856),
    [anon_sym_continue] = ACTIONS(1856),
    [anon_sym_debugger] = ACTIONS(1856),
    [anon_sym_return] = ACTIONS(1856),
    [anon_sym_throw] = ACTIONS(1856),
    [anon_sym_SEMI] = ACTIONS(1854),
    [anon_sym_case] = ACTIONS(1856),
    [anon_sym_yield] = ACTIONS(1856),
    [anon_sym_LBRACK] = ACTIONS(1854),
    [anon_sym_class] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1856),
    [anon_sym_function] = ACTIONS(1856),
    [anon_sym_abstract] = ACTIONS(1856),
    [anon_sym_get] = ACTIONS(1856),
    [anon_sym_set] = ACTIONS(1856),
    [anon_sym_new] = ACTIONS(1856),
    [anon_sym_PLUS] = ACTIONS(1856),
    [anon_sym_DASH] = ACTIONS(1856),
    [anon_sym_SLASH] = ACTIONS(1856),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_TILDE] = ACTIONS(1854),
    [anon_sym_void] = ACTIONS(1856),
    [anon_sym_delete] = ACTIONS(1856),
    [anon_sym_PLUS_PLUS] = ACTIONS(1854),
    [anon_sym_DASH_DASH] = ACTIONS(1854),
    [anon_sym_DQUOTE] = ACTIONS(1854),
    [anon_sym_SQUOTE] = ACTIONS(1854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1854),
    [sym_number] = ACTIONS(1854),
    [sym_this] = ACTIONS(1856),
    [sym_super] = ACTIONS(1856),
    [sym_true] = ACTIONS(1856),
    [sym_false] = ACTIONS(1856),
    [sym_null] = ACTIONS(1856),
    [anon_sym_AT] = ACTIONS(1854),
    [anon_sym_static] = ACTIONS(1856),
    [anon_sym_public] = ACTIONS(1856),
    [anon_sym_private] = ACTIONS(1856),
    [anon_sym_protected] = ACTIONS(1856),
    [anon_sym_any] = ACTIONS(1856),
    [anon_sym_number] = ACTIONS(1856),
    [anon_sym_boolean] = ACTIONS(1856),
    [anon_sym_string] = ACTIONS(1856),
    [anon_sym_symbol] = ACTIONS(1856),
    [sym_readonly] = ACTIONS(1856),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1858),
    [sym_identifier] = ACTIONS(1860),
    [anon_sym_export] = ACTIONS(1860),
    [anon_sym_default] = ACTIONS(1860),
    [anon_sym_namespace] = ACTIONS(1860),
    [anon_sym_LBRACE] = ACTIONS(1858),
    [anon_sym_RBRACE] = ACTIONS(1858),
    [anon_sym_typeof] = ACTIONS(1860),
    [anon_sym_type] = ACTIONS(1860),
    [anon_sym_interface] = ACTIONS(1860),
    [anon_sym_declare] = ACTIONS(1860),
    [anon_sym_module] = ACTIONS(1860),
    [anon_sym_import] = ACTIONS(1860),
    [anon_sym_const] = ACTIONS(1860),
    [anon_sym_enum] = ACTIONS(1860),
    [anon_sym_var] = ACTIONS(1860),
    [anon_sym_let] = ACTIONS(1860),
    [anon_sym_BANG] = ACTIONS(1858),
    [anon_sym_else] = ACTIONS(1860),
    [anon_sym_if] = ACTIONS(1860),
    [anon_sym_switch] = ACTIONS(1860),
    [anon_sym_for] = ACTIONS(1860),
    [anon_sym_LPAREN] = ACTIONS(1858),
    [anon_sym_await] = ACTIONS(1860),
    [anon_sym_while] = ACTIONS(1860),
    [anon_sym_do] = ACTIONS(1860),
    [anon_sym_try] = ACTIONS(1860),
    [anon_sym_with] = ACTIONS(1860),
    [anon_sym_break] = ACTIONS(1860),
    [anon_sym_continue] = ACTIONS(1860),
    [anon_sym_debugger] = ACTIONS(1860),
    [anon_sym_return] = ACTIONS(1860),
    [anon_sym_throw] = ACTIONS(1860),
    [anon_sym_SEMI] = ACTIONS(1858),
    [anon_sym_case] = ACTIONS(1860),
    [anon_sym_yield] = ACTIONS(1860),
    [anon_sym_LBRACK] = ACTIONS(1858),
    [anon_sym_class] = ACTIONS(1860),
    [anon_sym_async] = ACTIONS(1860),
    [anon_sym_function] = ACTIONS(1860),
    [anon_sym_abstract] = ACTIONS(1860),
    [anon_sym_get] = ACTIONS(1860),
    [anon_sym_set] = ACTIONS(1860),
    [anon_sym_new] = ACTIONS(1860),
    [anon_sym_PLUS] = ACTIONS(1860),
    [anon_sym_DASH] = ACTIONS(1860),
    [anon_sym_SLASH] = ACTIONS(1860),
    [anon_sym_LT] = ACTIONS(1858),
    [anon_sym_TILDE] = ACTIONS(1858),
    [anon_sym_void] = ACTIONS(1860),
    [anon_sym_delete] = ACTIONS(1860),
    [anon_sym_PLUS_PLUS] = ACTIONS(1858),
    [anon_sym_DASH_DASH] = ACTIONS(1858),
    [anon_sym_DQUOTE] = ACTIONS(1858),
    [anon_sym_SQUOTE] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [sym_number] = ACTIONS(1858),
    [sym_this] = ACTIONS(1860),
    [sym_super] = ACTIONS(1860),
    [sym_true] = ACTIONS(1860),
    [sym_false] = ACTIONS(1860),
    [sym_null] = ACTIONS(1860),
    [anon_sym_AT] = ACTIONS(1858),
    [anon_sym_static] = ACTIONS(1860),
    [anon_sym_public] = ACTIONS(1860),
    [anon_sym_private] = ACTIONS(1860),
    [anon_sym_protected] = ACTIONS(1860),
    [anon_sym_any] = ACTIONS(1860),
    [anon_sym_number] = ACTIONS(1860),
    [anon_sym_boolean] = ACTIONS(1860),
    [anon_sym_string] = ACTIONS(1860),
    [anon_sym_symbol] = ACTIONS(1860),
    [sym_readonly] = ACTIONS(1860),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1862),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_export] = ACTIONS(1864),
    [anon_sym_default] = ACTIONS(1864),
    [anon_sym_namespace] = ACTIONS(1864),
    [anon_sym_LBRACE] = ACTIONS(1862),
    [anon_sym_RBRACE] = ACTIONS(1862),
    [anon_sym_typeof] = ACTIONS(1864),
    [anon_sym_type] = ACTIONS(1864),
    [anon_sym_interface] = ACTIONS(1864),
    [anon_sym_declare] = ACTIONS(1864),
    [anon_sym_module] = ACTIONS(1864),
    [anon_sym_import] = ACTIONS(1864),
    [anon_sym_const] = ACTIONS(1864),
    [anon_sym_enum] = ACTIONS(1864),
    [anon_sym_var] = ACTIONS(1864),
    [anon_sym_let] = ACTIONS(1864),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_if] = ACTIONS(1864),
    [anon_sym_switch] = ACTIONS(1864),
    [anon_sym_for] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_await] = ACTIONS(1864),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1864),
    [anon_sym_try] = ACTIONS(1864),
    [anon_sym_with] = ACTIONS(1864),
    [anon_sym_break] = ACTIONS(1864),
    [anon_sym_continue] = ACTIONS(1864),
    [anon_sym_debugger] = ACTIONS(1864),
    [anon_sym_return] = ACTIONS(1864),
    [anon_sym_throw] = ACTIONS(1864),
    [anon_sym_SEMI] = ACTIONS(1862),
    [anon_sym_case] = ACTIONS(1864),
    [anon_sym_yield] = ACTIONS(1864),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_class] = ACTIONS(1864),
    [anon_sym_async] = ACTIONS(1864),
    [anon_sym_function] = ACTIONS(1864),
    [anon_sym_abstract] = ACTIONS(1864),
    [anon_sym_get] = ACTIONS(1864),
    [anon_sym_set] = ACTIONS(1864),
    [anon_sym_new] = ACTIONS(1864),
    [anon_sym_PLUS] = ACTIONS(1864),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1862),
    [anon_sym_void] = ACTIONS(1864),
    [anon_sym_delete] = ACTIONS(1864),
    [anon_sym_PLUS_PLUS] = ACTIONS(1862),
    [anon_sym_DASH_DASH] = ACTIONS(1862),
    [anon_sym_DQUOTE] = ACTIONS(1862),
    [anon_sym_SQUOTE] = ACTIONS(1862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1862),
    [sym_number] = ACTIONS(1862),
    [sym_this] = ACTIONS(1864),
    [sym_super] = ACTIONS(1864),
    [sym_true] = ACTIONS(1864),
    [sym_false] = ACTIONS(1864),
    [sym_null] = ACTIONS(1864),
    [anon_sym_AT] = ACTIONS(1862),
    [anon_sym_static] = ACTIONS(1864),
    [anon_sym_public] = ACTIONS(1864),
    [anon_sym_private] = ACTIONS(1864),
    [anon_sym_protected] = ACTIONS(1864),
    [anon_sym_any] = ACTIONS(1864),
    [anon_sym_number] = ACTIONS(1864),
    [anon_sym_boolean] = ACTIONS(1864),
    [anon_sym_string] = ACTIONS(1864),
    [anon_sym_symbol] = ACTIONS(1864),
    [sym_readonly] = ACTIONS(1864),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_export] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_namespace] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_declare] = ACTIONS(1116),
    [anon_sym_module] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [anon_sym_let] = ACTIONS(1116),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_await] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_with] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_debugger] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_yield] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_async] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_get] = ACTIONS(1116),
    [anon_sym_set] = ACTIONS(1116),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_LT] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_void] = ACTIONS(1116),
    [anon_sym_delete] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [sym_number] = ACTIONS(1114),
    [sym_this] = ACTIONS(1116),
    [sym_super] = ACTIONS(1116),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_protected] = ACTIONS(1116),
    [anon_sym_any] = ACTIONS(1116),
    [anon_sym_number] = ACTIONS(1116),
    [anon_sym_boolean] = ACTIONS(1116),
    [anon_sym_string] = ACTIONS(1116),
    [anon_sym_symbol] = ACTIONS(1116),
    [sym_readonly] = ACTIONS(1116),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(1866),
    [sym_identifier] = ACTIONS(1868),
    [anon_sym_export] = ACTIONS(1868),
    [anon_sym_default] = ACTIONS(1868),
    [anon_sym_namespace] = ACTIONS(1868),
    [anon_sym_LBRACE] = ACTIONS(1866),
    [anon_sym_RBRACE] = ACTIONS(1866),
    [anon_sym_typeof] = ACTIONS(1868),
    [anon_sym_type] = ACTIONS(1868),
    [anon_sym_interface] = ACTIONS(1868),
    [anon_sym_declare] = ACTIONS(1868),
    [anon_sym_module] = ACTIONS(1868),
    [anon_sym_import] = ACTIONS(1868),
    [anon_sym_const] = ACTIONS(1868),
    [anon_sym_enum] = ACTIONS(1868),
    [anon_sym_var] = ACTIONS(1868),
    [anon_sym_let] = ACTIONS(1868),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_else] = ACTIONS(1868),
    [anon_sym_if] = ACTIONS(1868),
    [anon_sym_switch] = ACTIONS(1868),
    [anon_sym_for] = ACTIONS(1868),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_await] = ACTIONS(1868),
    [anon_sym_while] = ACTIONS(1868),
    [anon_sym_do] = ACTIONS(1868),
    [anon_sym_try] = ACTIONS(1868),
    [anon_sym_with] = ACTIONS(1868),
    [anon_sym_break] = ACTIONS(1868),
    [anon_sym_continue] = ACTIONS(1868),
    [anon_sym_debugger] = ACTIONS(1868),
    [anon_sym_return] = ACTIONS(1868),
    [anon_sym_throw] = ACTIONS(1868),
    [anon_sym_SEMI] = ACTIONS(1866),
    [anon_sym_case] = ACTIONS(1868),
    [anon_sym_yield] = ACTIONS(1868),
    [anon_sym_LBRACK] = ACTIONS(1866),
    [anon_sym_class] = ACTIONS(1868),
    [anon_sym_async] = ACTIONS(1868),
    [anon_sym_function] = ACTIONS(1868),
    [anon_sym_abstract] = ACTIONS(1868),
    [anon_sym_get] = ACTIONS(1868),
    [anon_sym_set] = ACTIONS(1868),
    [anon_sym_new] = ACTIONS(1868),
    [anon_sym_PLUS] = ACTIONS(1868),
    [anon_sym_DASH] = ACTIONS(1868),
    [anon_sym_SLASH] = ACTIONS(1868),
    [anon_sym_LT] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [anon_sym_void] = ACTIONS(1868),
    [anon_sym_delete] = ACTIONS(1868),
    [anon_sym_PLUS_PLUS] = ACTIONS(1866),
    [anon_sym_DASH_DASH] = ACTIONS(1866),
    [anon_sym_DQUOTE] = ACTIONS(1866),
    [anon_sym_SQUOTE] = ACTIONS(1866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1866),
    [sym_number] = ACTIONS(1866),
    [sym_this] = ACTIONS(1868),
    [sym_super] = ACTIONS(1868),
    [sym_true] = ACTIONS(1868),
    [sym_false] = ACTIONS(1868),
    [sym_null] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_static] = ACTIONS(1868),
    [anon_sym_public] = ACTIONS(1868),
    [anon_sym_private] = ACTIONS(1868),
    [anon_sym_protected] = ACTIONS(1868),
    [anon_sym_any] = ACTIONS(1868),
    [anon_sym_number] = ACTIONS(1868),
    [anon_sym_boolean] = ACTIONS(1868),
    [anon_sym_string] = ACTIONS(1868),
    [anon_sym_symbol] = ACTIONS(1868),
    [sym_readonly] = ACTIONS(1868),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1870),
    [sym_identifier] = ACTIONS(1872),
    [anon_sym_export] = ACTIONS(1872),
    [anon_sym_default] = ACTIONS(1872),
    [anon_sym_namespace] = ACTIONS(1872),
    [anon_sym_LBRACE] = ACTIONS(1870),
    [anon_sym_RBRACE] = ACTIONS(1870),
    [anon_sym_typeof] = ACTIONS(1872),
    [anon_sym_type] = ACTIONS(1872),
    [anon_sym_interface] = ACTIONS(1872),
    [anon_sym_declare] = ACTIONS(1872),
    [anon_sym_module] = ACTIONS(1872),
    [anon_sym_import] = ACTIONS(1872),
    [anon_sym_const] = ACTIONS(1872),
    [anon_sym_enum] = ACTIONS(1872),
    [anon_sym_var] = ACTIONS(1872),
    [anon_sym_let] = ACTIONS(1872),
    [anon_sym_BANG] = ACTIONS(1870),
    [anon_sym_else] = ACTIONS(1872),
    [anon_sym_if] = ACTIONS(1872),
    [anon_sym_switch] = ACTIONS(1872),
    [anon_sym_for] = ACTIONS(1872),
    [anon_sym_LPAREN] = ACTIONS(1870),
    [anon_sym_await] = ACTIONS(1872),
    [anon_sym_while] = ACTIONS(1872),
    [anon_sym_do] = ACTIONS(1872),
    [anon_sym_try] = ACTIONS(1872),
    [anon_sym_with] = ACTIONS(1872),
    [anon_sym_break] = ACTIONS(1872),
    [anon_sym_continue] = ACTIONS(1872),
    [anon_sym_debugger] = ACTIONS(1872),
    [anon_sym_return] = ACTIONS(1872),
    [anon_sym_throw] = ACTIONS(1872),
    [anon_sym_SEMI] = ACTIONS(1870),
    [anon_sym_case] = ACTIONS(1872),
    [anon_sym_yield] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1870),
    [anon_sym_class] = ACTIONS(1872),
    [anon_sym_async] = ACTIONS(1872),
    [anon_sym_function] = ACTIONS(1872),
    [anon_sym_abstract] = ACTIONS(1872),
    [anon_sym_get] = ACTIONS(1872),
    [anon_sym_set] = ACTIONS(1872),
    [anon_sym_new] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_SLASH] = ACTIONS(1872),
    [anon_sym_LT] = ACTIONS(1870),
    [anon_sym_TILDE] = ACTIONS(1870),
    [anon_sym_void] = ACTIONS(1872),
    [anon_sym_delete] = ACTIONS(1872),
    [anon_sym_PLUS_PLUS] = ACTIONS(1870),
    [anon_sym_DASH_DASH] = ACTIONS(1870),
    [anon_sym_DQUOTE] = ACTIONS(1870),
    [anon_sym_SQUOTE] = ACTIONS(1870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1870),
    [sym_number] = ACTIONS(1870),
    [sym_this] = ACTIONS(1872),
    [sym_super] = ACTIONS(1872),
    [sym_true] = ACTIONS(1872),
    [sym_false] = ACTIONS(1872),
    [sym_null] = ACTIONS(1872),
    [anon_sym_AT] = ACTIONS(1870),
    [anon_sym_static] = ACTIONS(1872),
    [anon_sym_public] = ACTIONS(1872),
    [anon_sym_private] = ACTIONS(1872),
    [anon_sym_protected] = ACTIONS(1872),
    [anon_sym_any] = ACTIONS(1872),
    [anon_sym_number] = ACTIONS(1872),
    [anon_sym_boolean] = ACTIONS(1872),
    [anon_sym_string] = ACTIONS(1872),
    [anon_sym_symbol] = ACTIONS(1872),
    [sym_readonly] = ACTIONS(1872),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1874),
    [sym_identifier] = ACTIONS(1876),
    [anon_sym_export] = ACTIONS(1876),
    [anon_sym_default] = ACTIONS(1876),
    [anon_sym_namespace] = ACTIONS(1876),
    [anon_sym_LBRACE] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(1874),
    [anon_sym_typeof] = ACTIONS(1876),
    [anon_sym_type] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1876),
    [anon_sym_declare] = ACTIONS(1876),
    [anon_sym_module] = ACTIONS(1876),
    [anon_sym_import] = ACTIONS(1876),
    [anon_sym_const] = ACTIONS(1876),
    [anon_sym_enum] = ACTIONS(1876),
    [anon_sym_var] = ACTIONS(1876),
    [anon_sym_let] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1874),
    [anon_sym_else] = ACTIONS(1876),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_switch] = ACTIONS(1876),
    [anon_sym_for] = ACTIONS(1876),
    [anon_sym_LPAREN] = ACTIONS(1874),
    [anon_sym_await] = ACTIONS(1876),
    [anon_sym_while] = ACTIONS(1876),
    [anon_sym_do] = ACTIONS(1876),
    [anon_sym_try] = ACTIONS(1876),
    [anon_sym_with] = ACTIONS(1876),
    [anon_sym_break] = ACTIONS(1876),
    [anon_sym_continue] = ACTIONS(1876),
    [anon_sym_debugger] = ACTIONS(1876),
    [anon_sym_return] = ACTIONS(1876),
    [anon_sym_throw] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1874),
    [anon_sym_case] = ACTIONS(1876),
    [anon_sym_yield] = ACTIONS(1876),
    [anon_sym_LBRACK] = ACTIONS(1874),
    [anon_sym_class] = ACTIONS(1876),
    [anon_sym_async] = ACTIONS(1876),
    [anon_sym_function] = ACTIONS(1876),
    [anon_sym_abstract] = ACTIONS(1876),
    [anon_sym_get] = ACTIONS(1876),
    [anon_sym_set] = ACTIONS(1876),
    [anon_sym_new] = ACTIONS(1876),
    [anon_sym_PLUS] = ACTIONS(1876),
    [anon_sym_DASH] = ACTIONS(1876),
    [anon_sym_SLASH] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1874),
    [anon_sym_TILDE] = ACTIONS(1874),
    [anon_sym_void] = ACTIONS(1876),
    [anon_sym_delete] = ACTIONS(1876),
    [anon_sym_PLUS_PLUS] = ACTIONS(1874),
    [anon_sym_DASH_DASH] = ACTIONS(1874),
    [anon_sym_DQUOTE] = ACTIONS(1874),
    [anon_sym_SQUOTE] = ACTIONS(1874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [sym_number] = ACTIONS(1874),
    [sym_this] = ACTIONS(1876),
    [sym_super] = ACTIONS(1876),
    [sym_true] = ACTIONS(1876),
    [sym_false] = ACTIONS(1876),
    [sym_null] = ACTIONS(1876),
    [anon_sym_AT] = ACTIONS(1874),
    [anon_sym_static] = ACTIONS(1876),
    [anon_sym_public] = ACTIONS(1876),
    [anon_sym_private] = ACTIONS(1876),
    [anon_sym_protected] = ACTIONS(1876),
    [anon_sym_any] = ACTIONS(1876),
    [anon_sym_number] = ACTIONS(1876),
    [anon_sym_boolean] = ACTIONS(1876),
    [anon_sym_string] = ACTIONS(1876),
    [anon_sym_symbol] = ACTIONS(1876),
    [sym_readonly] = ACTIONS(1876),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1878),
    [sym_identifier] = ACTIONS(1880),
    [anon_sym_export] = ACTIONS(1880),
    [anon_sym_default] = ACTIONS(1880),
    [anon_sym_namespace] = ACTIONS(1880),
    [anon_sym_LBRACE] = ACTIONS(1878),
    [anon_sym_RBRACE] = ACTIONS(1878),
    [anon_sym_typeof] = ACTIONS(1880),
    [anon_sym_type] = ACTIONS(1880),
    [anon_sym_interface] = ACTIONS(1880),
    [anon_sym_declare] = ACTIONS(1880),
    [anon_sym_module] = ACTIONS(1880),
    [anon_sym_import] = ACTIONS(1880),
    [anon_sym_const] = ACTIONS(1880),
    [anon_sym_enum] = ACTIONS(1880),
    [anon_sym_var] = ACTIONS(1880),
    [anon_sym_let] = ACTIONS(1880),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_else] = ACTIONS(1880),
    [anon_sym_if] = ACTIONS(1880),
    [anon_sym_switch] = ACTIONS(1880),
    [anon_sym_for] = ACTIONS(1880),
    [anon_sym_LPAREN] = ACTIONS(1878),
    [anon_sym_await] = ACTIONS(1880),
    [anon_sym_while] = ACTIONS(1880),
    [anon_sym_do] = ACTIONS(1880),
    [anon_sym_try] = ACTIONS(1880),
    [anon_sym_with] = ACTIONS(1880),
    [anon_sym_break] = ACTIONS(1880),
    [anon_sym_continue] = ACTIONS(1880),
    [anon_sym_debugger] = ACTIONS(1880),
    [anon_sym_return] = ACTIONS(1880),
    [anon_sym_throw] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_case] = ACTIONS(1880),
    [anon_sym_yield] = ACTIONS(1880),
    [anon_sym_LBRACK] = ACTIONS(1878),
    [anon_sym_class] = ACTIONS(1880),
    [anon_sym_async] = ACTIONS(1880),
    [anon_sym_function] = ACTIONS(1880),
    [anon_sym_abstract] = ACTIONS(1880),
    [anon_sym_get] = ACTIONS(1880),
    [anon_sym_set] = ACTIONS(1880),
    [anon_sym_new] = ACTIONS(1880),
    [anon_sym_PLUS] = ACTIONS(1880),
    [anon_sym_DASH] = ACTIONS(1880),
    [anon_sym_SLASH] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [anon_sym_void] = ACTIONS(1880),
    [anon_sym_delete] = ACTIONS(1880),
    [anon_sym_PLUS_PLUS] = ACTIONS(1878),
    [anon_sym_DASH_DASH] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1878),
    [anon_sym_SQUOTE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [sym_number] = ACTIONS(1878),
    [sym_this] = ACTIONS(1880),
    [sym_super] = ACTIONS(1880),
    [sym_true] = ACTIONS(1880),
    [sym_false] = ACTIONS(1880),
    [sym_null] = ACTIONS(1880),
    [anon_sym_AT] = ACTIONS(1878),
    [anon_sym_static] = ACTIONS(1880),
    [anon_sym_public] = ACTIONS(1880),
    [anon_sym_private] = ACTIONS(1880),
    [anon_sym_protected] = ACTIONS(1880),
    [anon_sym_any] = ACTIONS(1880),
    [anon_sym_number] = ACTIONS(1880),
    [anon_sym_boolean] = ACTIONS(1880),
    [anon_sym_string] = ACTIONS(1880),
    [anon_sym_symbol] = ACTIONS(1880),
    [sym_readonly] = ACTIONS(1880),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1882),
    [sym_identifier] = ACTIONS(1884),
    [anon_sym_export] = ACTIONS(1884),
    [anon_sym_default] = ACTIONS(1884),
    [anon_sym_namespace] = ACTIONS(1884),
    [anon_sym_LBRACE] = ACTIONS(1882),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [anon_sym_typeof] = ACTIONS(1884),
    [anon_sym_type] = ACTIONS(1884),
    [anon_sym_interface] = ACTIONS(1884),
    [anon_sym_declare] = ACTIONS(1884),
    [anon_sym_module] = ACTIONS(1884),
    [anon_sym_import] = ACTIONS(1884),
    [anon_sym_const] = ACTIONS(1884),
    [anon_sym_enum] = ACTIONS(1884),
    [anon_sym_var] = ACTIONS(1884),
    [anon_sym_let] = ACTIONS(1884),
    [anon_sym_BANG] = ACTIONS(1882),
    [anon_sym_else] = ACTIONS(1884),
    [anon_sym_if] = ACTIONS(1884),
    [anon_sym_switch] = ACTIONS(1884),
    [anon_sym_for] = ACTIONS(1884),
    [anon_sym_LPAREN] = ACTIONS(1882),
    [anon_sym_await] = ACTIONS(1884),
    [anon_sym_while] = ACTIONS(1884),
    [anon_sym_do] = ACTIONS(1884),
    [anon_sym_try] = ACTIONS(1884),
    [anon_sym_with] = ACTIONS(1884),
    [anon_sym_break] = ACTIONS(1884),
    [anon_sym_continue] = ACTIONS(1884),
    [anon_sym_debugger] = ACTIONS(1884),
    [anon_sym_return] = ACTIONS(1884),
    [anon_sym_throw] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_case] = ACTIONS(1884),
    [anon_sym_yield] = ACTIONS(1884),
    [anon_sym_LBRACK] = ACTIONS(1882),
    [anon_sym_class] = ACTIONS(1884),
    [anon_sym_async] = ACTIONS(1884),
    [anon_sym_function] = ACTIONS(1884),
    [anon_sym_abstract] = ACTIONS(1884),
    [anon_sym_get] = ACTIONS(1884),
    [anon_sym_set] = ACTIONS(1884),
    [anon_sym_new] = ACTIONS(1884),
    [anon_sym_PLUS] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_SLASH] = ACTIONS(1884),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_TILDE] = ACTIONS(1882),
    [anon_sym_void] = ACTIONS(1884),
    [anon_sym_delete] = ACTIONS(1884),
    [anon_sym_PLUS_PLUS] = ACTIONS(1882),
    [anon_sym_DASH_DASH] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_SQUOTE] = ACTIONS(1882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [sym_number] = ACTIONS(1882),
    [sym_this] = ACTIONS(1884),
    [sym_super] = ACTIONS(1884),
    [sym_true] = ACTIONS(1884),
    [sym_false] = ACTIONS(1884),
    [sym_null] = ACTIONS(1884),
    [anon_sym_AT] = ACTIONS(1882),
    [anon_sym_static] = ACTIONS(1884),
    [anon_sym_public] = ACTIONS(1884),
    [anon_sym_private] = ACTIONS(1884),
    [anon_sym_protected] = ACTIONS(1884),
    [anon_sym_any] = ACTIONS(1884),
    [anon_sym_number] = ACTIONS(1884),
    [anon_sym_boolean] = ACTIONS(1884),
    [anon_sym_string] = ACTIONS(1884),
    [anon_sym_symbol] = ACTIONS(1884),
    [sym_readonly] = ACTIONS(1884),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1886),
    [sym_identifier] = ACTIONS(1888),
    [anon_sym_export] = ACTIONS(1888),
    [anon_sym_default] = ACTIONS(1888),
    [anon_sym_namespace] = ACTIONS(1888),
    [anon_sym_LBRACE] = ACTIONS(1886),
    [anon_sym_RBRACE] = ACTIONS(1886),
    [anon_sym_typeof] = ACTIONS(1888),
    [anon_sym_type] = ACTIONS(1888),
    [anon_sym_interface] = ACTIONS(1888),
    [anon_sym_declare] = ACTIONS(1888),
    [anon_sym_module] = ACTIONS(1888),
    [anon_sym_import] = ACTIONS(1888),
    [anon_sym_const] = ACTIONS(1888),
    [anon_sym_enum] = ACTIONS(1888),
    [anon_sym_var] = ACTIONS(1888),
    [anon_sym_let] = ACTIONS(1888),
    [anon_sym_BANG] = ACTIONS(1886),
    [anon_sym_else] = ACTIONS(1888),
    [anon_sym_if] = ACTIONS(1888),
    [anon_sym_switch] = ACTIONS(1888),
    [anon_sym_for] = ACTIONS(1888),
    [anon_sym_LPAREN] = ACTIONS(1886),
    [anon_sym_await] = ACTIONS(1888),
    [anon_sym_while] = ACTIONS(1888),
    [anon_sym_do] = ACTIONS(1888),
    [anon_sym_try] = ACTIONS(1888),
    [anon_sym_with] = ACTIONS(1888),
    [anon_sym_break] = ACTIONS(1888),
    [anon_sym_continue] = ACTIONS(1888),
    [anon_sym_debugger] = ACTIONS(1888),
    [anon_sym_return] = ACTIONS(1888),
    [anon_sym_throw] = ACTIONS(1888),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_case] = ACTIONS(1888),
    [anon_sym_yield] = ACTIONS(1888),
    [anon_sym_LBRACK] = ACTIONS(1886),
    [anon_sym_class] = ACTIONS(1888),
    [anon_sym_async] = ACTIONS(1888),
    [anon_sym_function] = ACTIONS(1888),
    [anon_sym_abstract] = ACTIONS(1888),
    [anon_sym_get] = ACTIONS(1888),
    [anon_sym_set] = ACTIONS(1888),
    [anon_sym_new] = ACTIONS(1888),
    [anon_sym_PLUS] = ACTIONS(1888),
    [anon_sym_DASH] = ACTIONS(1888),
    [anon_sym_SLASH] = ACTIONS(1888),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_TILDE] = ACTIONS(1886),
    [anon_sym_void] = ACTIONS(1888),
    [anon_sym_delete] = ACTIONS(1888),
    [anon_sym_PLUS_PLUS] = ACTIONS(1886),
    [anon_sym_DASH_DASH] = ACTIONS(1886),
    [anon_sym_DQUOTE] = ACTIONS(1886),
    [anon_sym_SQUOTE] = ACTIONS(1886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1886),
    [sym_number] = ACTIONS(1886),
    [sym_this] = ACTIONS(1888),
    [sym_super] = ACTIONS(1888),
    [sym_true] = ACTIONS(1888),
    [sym_false] = ACTIONS(1888),
    [sym_null] = ACTIONS(1888),
    [anon_sym_AT] = ACTIONS(1886),
    [anon_sym_static] = ACTIONS(1888),
    [anon_sym_public] = ACTIONS(1888),
    [anon_sym_private] = ACTIONS(1888),
    [anon_sym_protected] = ACTIONS(1888),
    [anon_sym_any] = ACTIONS(1888),
    [anon_sym_number] = ACTIONS(1888),
    [anon_sym_boolean] = ACTIONS(1888),
    [anon_sym_string] = ACTIONS(1888),
    [anon_sym_symbol] = ACTIONS(1888),
    [sym_readonly] = ACTIONS(1888),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1890),
    [sym_identifier] = ACTIONS(1892),
    [anon_sym_export] = ACTIONS(1892),
    [anon_sym_default] = ACTIONS(1892),
    [anon_sym_namespace] = ACTIONS(1892),
    [anon_sym_LBRACE] = ACTIONS(1890),
    [anon_sym_RBRACE] = ACTIONS(1890),
    [anon_sym_typeof] = ACTIONS(1892),
    [anon_sym_type] = ACTIONS(1892),
    [anon_sym_interface] = ACTIONS(1892),
    [anon_sym_declare] = ACTIONS(1892),
    [anon_sym_module] = ACTIONS(1892),
    [anon_sym_import] = ACTIONS(1892),
    [anon_sym_const] = ACTIONS(1892),
    [anon_sym_enum] = ACTIONS(1892),
    [anon_sym_var] = ACTIONS(1892),
    [anon_sym_let] = ACTIONS(1892),
    [anon_sym_BANG] = ACTIONS(1890),
    [anon_sym_else] = ACTIONS(1892),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(1892),
    [anon_sym_for] = ACTIONS(1892),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_await] = ACTIONS(1892),
    [anon_sym_while] = ACTIONS(1892),
    [anon_sym_do] = ACTIONS(1892),
    [anon_sym_try] = ACTIONS(1892),
    [anon_sym_with] = ACTIONS(1892),
    [anon_sym_break] = ACTIONS(1892),
    [anon_sym_continue] = ACTIONS(1892),
    [anon_sym_debugger] = ACTIONS(1892),
    [anon_sym_return] = ACTIONS(1892),
    [anon_sym_throw] = ACTIONS(1892),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_case] = ACTIONS(1892),
    [anon_sym_yield] = ACTIONS(1892),
    [anon_sym_LBRACK] = ACTIONS(1890),
    [anon_sym_class] = ACTIONS(1892),
    [anon_sym_async] = ACTIONS(1892),
    [anon_sym_function] = ACTIONS(1892),
    [anon_sym_abstract] = ACTIONS(1892),
    [anon_sym_get] = ACTIONS(1892),
    [anon_sym_set] = ACTIONS(1892),
    [anon_sym_new] = ACTIONS(1892),
    [anon_sym_PLUS] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1892),
    [anon_sym_SLASH] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(1890),
    [anon_sym_TILDE] = ACTIONS(1890),
    [anon_sym_void] = ACTIONS(1892),
    [anon_sym_delete] = ACTIONS(1892),
    [anon_sym_PLUS_PLUS] = ACTIONS(1890),
    [anon_sym_DASH_DASH] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_SQUOTE] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [sym_number] = ACTIONS(1890),
    [sym_this] = ACTIONS(1892),
    [sym_super] = ACTIONS(1892),
    [sym_true] = ACTIONS(1892),
    [sym_false] = ACTIONS(1892),
    [sym_null] = ACTIONS(1892),
    [anon_sym_AT] = ACTIONS(1890),
    [anon_sym_static] = ACTIONS(1892),
    [anon_sym_public] = ACTIONS(1892),
    [anon_sym_private] = ACTIONS(1892),
    [anon_sym_protected] = ACTIONS(1892),
    [anon_sym_any] = ACTIONS(1892),
    [anon_sym_number] = ACTIONS(1892),
    [anon_sym_boolean] = ACTIONS(1892),
    [anon_sym_string] = ACTIONS(1892),
    [anon_sym_symbol] = ACTIONS(1892),
    [sym_readonly] = ACTIONS(1892),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1894),
    [sym_identifier] = ACTIONS(1896),
    [anon_sym_export] = ACTIONS(1896),
    [anon_sym_default] = ACTIONS(1896),
    [anon_sym_namespace] = ACTIONS(1896),
    [anon_sym_LBRACE] = ACTIONS(1894),
    [anon_sym_RBRACE] = ACTIONS(1894),
    [anon_sym_typeof] = ACTIONS(1896),
    [anon_sym_type] = ACTIONS(1896),
    [anon_sym_interface] = ACTIONS(1896),
    [anon_sym_declare] = ACTIONS(1896),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_import] = ACTIONS(1896),
    [anon_sym_const] = ACTIONS(1896),
    [anon_sym_enum] = ACTIONS(1896),
    [anon_sym_var] = ACTIONS(1896),
    [anon_sym_let] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1894),
    [anon_sym_else] = ACTIONS(1896),
    [anon_sym_if] = ACTIONS(1896),
    [anon_sym_switch] = ACTIONS(1896),
    [anon_sym_for] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1894),
    [anon_sym_await] = ACTIONS(1896),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(1896),
    [anon_sym_try] = ACTIONS(1896),
    [anon_sym_with] = ACTIONS(1896),
    [anon_sym_break] = ACTIONS(1896),
    [anon_sym_continue] = ACTIONS(1896),
    [anon_sym_debugger] = ACTIONS(1896),
    [anon_sym_return] = ACTIONS(1896),
    [anon_sym_throw] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_case] = ACTIONS(1896),
    [anon_sym_yield] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1894),
    [anon_sym_class] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(1896),
    [anon_sym_function] = ACTIONS(1896),
    [anon_sym_abstract] = ACTIONS(1896),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(1896),
    [anon_sym_LT] = ACTIONS(1894),
    [anon_sym_TILDE] = ACTIONS(1894),
    [anon_sym_void] = ACTIONS(1896),
    [anon_sym_delete] = ACTIONS(1896),
    [anon_sym_PLUS_PLUS] = ACTIONS(1894),
    [anon_sym_DASH_DASH] = ACTIONS(1894),
    [anon_sym_DQUOTE] = ACTIONS(1894),
    [anon_sym_SQUOTE] = ACTIONS(1894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1894),
    [sym_number] = ACTIONS(1894),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(1896),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(1894),
    [anon_sym_static] = ACTIONS(1896),
    [anon_sym_public] = ACTIONS(1896),
    [anon_sym_private] = ACTIONS(1896),
    [anon_sym_protected] = ACTIONS(1896),
    [anon_sym_any] = ACTIONS(1896),
    [anon_sym_number] = ACTIONS(1896),
    [anon_sym_boolean] = ACTIONS(1896),
    [anon_sym_string] = ACTIONS(1896),
    [anon_sym_symbol] = ACTIONS(1896),
    [sym_readonly] = ACTIONS(1896),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1898),
    [sym_identifier] = ACTIONS(1900),
    [anon_sym_export] = ACTIONS(1900),
    [anon_sym_default] = ACTIONS(1900),
    [anon_sym_namespace] = ACTIONS(1900),
    [anon_sym_LBRACE] = ACTIONS(1898),
    [anon_sym_RBRACE] = ACTIONS(1898),
    [anon_sym_typeof] = ACTIONS(1900),
    [anon_sym_type] = ACTIONS(1900),
    [anon_sym_interface] = ACTIONS(1900),
    [anon_sym_declare] = ACTIONS(1900),
    [anon_sym_module] = ACTIONS(1900),
    [anon_sym_import] = ACTIONS(1900),
    [anon_sym_const] = ACTIONS(1900),
    [anon_sym_enum] = ACTIONS(1900),
    [anon_sym_var] = ACTIONS(1900),
    [anon_sym_let] = ACTIONS(1900),
    [anon_sym_BANG] = ACTIONS(1898),
    [anon_sym_else] = ACTIONS(1900),
    [anon_sym_if] = ACTIONS(1900),
    [anon_sym_switch] = ACTIONS(1900),
    [anon_sym_for] = ACTIONS(1900),
    [anon_sym_LPAREN] = ACTIONS(1898),
    [anon_sym_await] = ACTIONS(1900),
    [anon_sym_while] = ACTIONS(1900),
    [anon_sym_do] = ACTIONS(1900),
    [anon_sym_try] = ACTIONS(1900),
    [anon_sym_with] = ACTIONS(1900),
    [anon_sym_break] = ACTIONS(1900),
    [anon_sym_continue] = ACTIONS(1900),
    [anon_sym_debugger] = ACTIONS(1900),
    [anon_sym_return] = ACTIONS(1900),
    [anon_sym_throw] = ACTIONS(1900),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_case] = ACTIONS(1900),
    [anon_sym_yield] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(1898),
    [anon_sym_class] = ACTIONS(1900),
    [anon_sym_async] = ACTIONS(1900),
    [anon_sym_function] = ACTIONS(1900),
    [anon_sym_abstract] = ACTIONS(1900),
    [anon_sym_get] = ACTIONS(1900),
    [anon_sym_set] = ACTIONS(1900),
    [anon_sym_new] = ACTIONS(1900),
    [anon_sym_PLUS] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1900),
    [anon_sym_SLASH] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1898),
    [anon_sym_TILDE] = ACTIONS(1898),
    [anon_sym_void] = ACTIONS(1900),
    [anon_sym_delete] = ACTIONS(1900),
    [anon_sym_PLUS_PLUS] = ACTIONS(1898),
    [anon_sym_DASH_DASH] = ACTIONS(1898),
    [anon_sym_DQUOTE] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1898),
    [sym_number] = ACTIONS(1898),
    [sym_this] = ACTIONS(1900),
    [sym_super] = ACTIONS(1900),
    [sym_true] = ACTIONS(1900),
    [sym_false] = ACTIONS(1900),
    [sym_null] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(1898),
    [anon_sym_static] = ACTIONS(1900),
    [anon_sym_public] = ACTIONS(1900),
    [anon_sym_private] = ACTIONS(1900),
    [anon_sym_protected] = ACTIONS(1900),
    [anon_sym_any] = ACTIONS(1900),
    [anon_sym_number] = ACTIONS(1900),
    [anon_sym_boolean] = ACTIONS(1900),
    [anon_sym_string] = ACTIONS(1900),
    [anon_sym_symbol] = ACTIONS(1900),
    [sym_readonly] = ACTIONS(1900),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(1902),
    [sym_identifier] = ACTIONS(1904),
    [anon_sym_export] = ACTIONS(1904),
    [anon_sym_default] = ACTIONS(1904),
    [anon_sym_namespace] = ACTIONS(1904),
    [anon_sym_LBRACE] = ACTIONS(1902),
    [anon_sym_RBRACE] = ACTIONS(1902),
    [anon_sym_typeof] = ACTIONS(1904),
    [anon_sym_type] = ACTIONS(1904),
    [anon_sym_interface] = ACTIONS(1904),
    [anon_sym_declare] = ACTIONS(1904),
    [anon_sym_module] = ACTIONS(1904),
    [anon_sym_import] = ACTIONS(1904),
    [anon_sym_const] = ACTIONS(1904),
    [anon_sym_enum] = ACTIONS(1904),
    [anon_sym_var] = ACTIONS(1904),
    [anon_sym_let] = ACTIONS(1904),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_else] = ACTIONS(1904),
    [anon_sym_if] = ACTIONS(1904),
    [anon_sym_switch] = ACTIONS(1904),
    [anon_sym_for] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1902),
    [anon_sym_await] = ACTIONS(1904),
    [anon_sym_while] = ACTIONS(1904),
    [anon_sym_do] = ACTIONS(1904),
    [anon_sym_try] = ACTIONS(1904),
    [anon_sym_with] = ACTIONS(1904),
    [anon_sym_break] = ACTIONS(1904),
    [anon_sym_continue] = ACTIONS(1904),
    [anon_sym_debugger] = ACTIONS(1904),
    [anon_sym_return] = ACTIONS(1904),
    [anon_sym_throw] = ACTIONS(1904),
    [anon_sym_SEMI] = ACTIONS(1902),
    [anon_sym_case] = ACTIONS(1904),
    [anon_sym_yield] = ACTIONS(1904),
    [anon_sym_LBRACK] = ACTIONS(1902),
    [anon_sym_class] = ACTIONS(1904),
    [anon_sym_async] = ACTIONS(1904),
    [anon_sym_function] = ACTIONS(1904),
    [anon_sym_abstract] = ACTIONS(1904),
    [anon_sym_get] = ACTIONS(1904),
    [anon_sym_set] = ACTIONS(1904),
    [anon_sym_new] = ACTIONS(1904),
    [anon_sym_PLUS] = ACTIONS(1904),
    [anon_sym_DASH] = ACTIONS(1904),
    [anon_sym_SLASH] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_TILDE] = ACTIONS(1902),
    [anon_sym_void] = ACTIONS(1904),
    [anon_sym_delete] = ACTIONS(1904),
    [anon_sym_PLUS_PLUS] = ACTIONS(1902),
    [anon_sym_DASH_DASH] = ACTIONS(1902),
    [anon_sym_DQUOTE] = ACTIONS(1902),
    [anon_sym_SQUOTE] = ACTIONS(1902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1902),
    [sym_number] = ACTIONS(1902),
    [sym_this] = ACTIONS(1904),
    [sym_super] = ACTIONS(1904),
    [sym_true] = ACTIONS(1904),
    [sym_false] = ACTIONS(1904),
    [sym_null] = ACTIONS(1904),
    [anon_sym_AT] = ACTIONS(1902),
    [anon_sym_static] = ACTIONS(1904),
    [anon_sym_public] = ACTIONS(1904),
    [anon_sym_private] = ACTIONS(1904),
    [anon_sym_protected] = ACTIONS(1904),
    [anon_sym_any] = ACTIONS(1904),
    [anon_sym_number] = ACTIONS(1904),
    [anon_sym_boolean] = ACTIONS(1904),
    [anon_sym_string] = ACTIONS(1904),
    [anon_sym_symbol] = ACTIONS(1904),
    [sym_readonly] = ACTIONS(1904),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_identifier] = ACTIONS(1052),
    [anon_sym_export] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_namespace] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_typeof] = ACTIONS(1052),
    [anon_sym_type] = ACTIONS(1052),
    [anon_sym_interface] = ACTIONS(1052),
    [anon_sym_declare] = ACTIONS(1052),
    [anon_sym_module] = ACTIONS(1052),
    [anon_sym_import] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_var] = ACTIONS(1052),
    [anon_sym_let] = ACTIONS(1052),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_else] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [anon_sym_await] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_try] = ACTIONS(1052),
    [anon_sym_with] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_debugger] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_throw] = ACTIONS(1052),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1050),
    [anon_sym_class] = ACTIONS(1052),
    [anon_sym_async] = ACTIONS(1052),
    [anon_sym_function] = ACTIONS(1052),
    [anon_sym_abstract] = ACTIONS(1052),
    [anon_sym_get] = ACTIONS(1052),
    [anon_sym_set] = ACTIONS(1052),
    [anon_sym_new] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_SLASH] = ACTIONS(1052),
    [anon_sym_LT] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_void] = ACTIONS(1052),
    [anon_sym_delete] = ACTIONS(1052),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1050),
    [sym_number] = ACTIONS(1050),
    [sym_this] = ACTIONS(1052),
    [sym_super] = ACTIONS(1052),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_public] = ACTIONS(1052),
    [anon_sym_private] = ACTIONS(1052),
    [anon_sym_protected] = ACTIONS(1052),
    [anon_sym_any] = ACTIONS(1052),
    [anon_sym_number] = ACTIONS(1052),
    [anon_sym_boolean] = ACTIONS(1052),
    [anon_sym_string] = ACTIONS(1052),
    [anon_sym_symbol] = ACTIONS(1052),
    [sym_readonly] = ACTIONS(1052),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(1906),
    [sym_identifier] = ACTIONS(1908),
    [anon_sym_export] = ACTIONS(1908),
    [anon_sym_default] = ACTIONS(1908),
    [anon_sym_namespace] = ACTIONS(1908),
    [anon_sym_LBRACE] = ACTIONS(1906),
    [anon_sym_RBRACE] = ACTIONS(1906),
    [anon_sym_typeof] = ACTIONS(1908),
    [anon_sym_type] = ACTIONS(1908),
    [anon_sym_interface] = ACTIONS(1908),
    [anon_sym_declare] = ACTIONS(1908),
    [anon_sym_module] = ACTIONS(1908),
    [anon_sym_import] = ACTIONS(1908),
    [anon_sym_const] = ACTIONS(1908),
    [anon_sym_enum] = ACTIONS(1908),
    [anon_sym_var] = ACTIONS(1908),
    [anon_sym_let] = ACTIONS(1908),
    [anon_sym_BANG] = ACTIONS(1906),
    [anon_sym_else] = ACTIONS(1908),
    [anon_sym_if] = ACTIONS(1908),
    [anon_sym_switch] = ACTIONS(1908),
    [anon_sym_for] = ACTIONS(1908),
    [anon_sym_LPAREN] = ACTIONS(1906),
    [anon_sym_await] = ACTIONS(1908),
    [anon_sym_while] = ACTIONS(1908),
    [anon_sym_do] = ACTIONS(1908),
    [anon_sym_try] = ACTIONS(1908),
    [anon_sym_with] = ACTIONS(1908),
    [anon_sym_break] = ACTIONS(1908),
    [anon_sym_continue] = ACTIONS(1908),
    [anon_sym_debugger] = ACTIONS(1908),
    [anon_sym_return] = ACTIONS(1908),
    [anon_sym_throw] = ACTIONS(1908),
    [anon_sym_SEMI] = ACTIONS(1906),
    [anon_sym_case] = ACTIONS(1908),
    [anon_sym_yield] = ACTIONS(1908),
    [anon_sym_LBRACK] = ACTIONS(1906),
    [anon_sym_class] = ACTIONS(1908),
    [anon_sym_async] = ACTIONS(1908),
    [anon_sym_function] = ACTIONS(1908),
    [anon_sym_abstract] = ACTIONS(1908),
    [anon_sym_get] = ACTIONS(1908),
    [anon_sym_set] = ACTIONS(1908),
    [anon_sym_new] = ACTIONS(1908),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1908),
    [anon_sym_LT] = ACTIONS(1906),
    [anon_sym_TILDE] = ACTIONS(1906),
    [anon_sym_void] = ACTIONS(1908),
    [anon_sym_delete] = ACTIONS(1908),
    [anon_sym_PLUS_PLUS] = ACTIONS(1906),
    [anon_sym_DASH_DASH] = ACTIONS(1906),
    [anon_sym_DQUOTE] = ACTIONS(1906),
    [anon_sym_SQUOTE] = ACTIONS(1906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1906),
    [sym_number] = ACTIONS(1906),
    [sym_this] = ACTIONS(1908),
    [sym_super] = ACTIONS(1908),
    [sym_true] = ACTIONS(1908),
    [sym_false] = ACTIONS(1908),
    [sym_null] = ACTIONS(1908),
    [anon_sym_AT] = ACTIONS(1906),
    [anon_sym_static] = ACTIONS(1908),
    [anon_sym_public] = ACTIONS(1908),
    [anon_sym_private] = ACTIONS(1908),
    [anon_sym_protected] = ACTIONS(1908),
    [anon_sym_any] = ACTIONS(1908),
    [anon_sym_number] = ACTIONS(1908),
    [anon_sym_boolean] = ACTIONS(1908),
    [anon_sym_string] = ACTIONS(1908),
    [anon_sym_symbol] = ACTIONS(1908),
    [sym_readonly] = ACTIONS(1908),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(1910),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_export] = ACTIONS(1912),
    [anon_sym_default] = ACTIONS(1912),
    [anon_sym_namespace] = ACTIONS(1912),
    [anon_sym_LBRACE] = ACTIONS(1910),
    [anon_sym_RBRACE] = ACTIONS(1910),
    [anon_sym_typeof] = ACTIONS(1912),
    [anon_sym_type] = ACTIONS(1912),
    [anon_sym_interface] = ACTIONS(1912),
    [anon_sym_declare] = ACTIONS(1912),
    [anon_sym_module] = ACTIONS(1912),
    [anon_sym_import] = ACTIONS(1912),
    [anon_sym_const] = ACTIONS(1912),
    [anon_sym_enum] = ACTIONS(1912),
    [anon_sym_var] = ACTIONS(1912),
    [anon_sym_let] = ACTIONS(1912),
    [anon_sym_BANG] = ACTIONS(1910),
    [anon_sym_else] = ACTIONS(1912),
    [anon_sym_if] = ACTIONS(1912),
    [anon_sym_switch] = ACTIONS(1912),
    [anon_sym_for] = ACTIONS(1912),
    [anon_sym_LPAREN] = ACTIONS(1910),
    [anon_sym_await] = ACTIONS(1912),
    [anon_sym_while] = ACTIONS(1912),
    [anon_sym_do] = ACTIONS(1912),
    [anon_sym_try] = ACTIONS(1912),
    [anon_sym_with] = ACTIONS(1912),
    [anon_sym_break] = ACTIONS(1912),
    [anon_sym_continue] = ACTIONS(1912),
    [anon_sym_debugger] = ACTIONS(1912),
    [anon_sym_return] = ACTIONS(1912),
    [anon_sym_throw] = ACTIONS(1912),
    [anon_sym_SEMI] = ACTIONS(1910),
    [anon_sym_case] = ACTIONS(1912),
    [anon_sym_yield] = ACTIONS(1912),
    [anon_sym_LBRACK] = ACTIONS(1910),
    [anon_sym_class] = ACTIONS(1912),
    [anon_sym_async] = ACTIONS(1912),
    [anon_sym_function] = ACTIONS(1912),
    [anon_sym_abstract] = ACTIONS(1912),
    [anon_sym_get] = ACTIONS(1912),
    [anon_sym_set] = ACTIONS(1912),
    [anon_sym_new] = ACTIONS(1912),
    [anon_sym_PLUS] = ACTIONS(1912),
    [anon_sym_DASH] = ACTIONS(1912),
    [anon_sym_SLASH] = ACTIONS(1912),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_TILDE] = ACTIONS(1910),
    [anon_sym_void] = ACTIONS(1912),
    [anon_sym_delete] = ACTIONS(1912),
    [anon_sym_PLUS_PLUS] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(1910),
    [anon_sym_SQUOTE] = ACTIONS(1910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1910),
    [sym_number] = ACTIONS(1910),
    [sym_this] = ACTIONS(1912),
    [sym_super] = ACTIONS(1912),
    [sym_true] = ACTIONS(1912),
    [sym_false] = ACTIONS(1912),
    [sym_null] = ACTIONS(1912),
    [anon_sym_AT] = ACTIONS(1910),
    [anon_sym_static] = ACTIONS(1912),
    [anon_sym_public] = ACTIONS(1912),
    [anon_sym_private] = ACTIONS(1912),
    [anon_sym_protected] = ACTIONS(1912),
    [anon_sym_any] = ACTIONS(1912),
    [anon_sym_number] = ACTIONS(1912),
    [anon_sym_boolean] = ACTIONS(1912),
    [anon_sym_string] = ACTIONS(1912),
    [anon_sym_symbol] = ACTIONS(1912),
    [sym_readonly] = ACTIONS(1912),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(1914),
    [sym_identifier] = ACTIONS(1916),
    [anon_sym_export] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1914),
    [anon_sym_RBRACE] = ACTIONS(1914),
    [anon_sym_typeof] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1916),
    [anon_sym_interface] = ACTIONS(1916),
    [anon_sym_declare] = ACTIONS(1916),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_import] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_var] = ACTIONS(1916),
    [anon_sym_let] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1914),
    [anon_sym_else] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1914),
    [anon_sym_await] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_with] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_debugger] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_yield] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1914),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_function] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1916),
    [anon_sym_get] = ACTIONS(1916),
    [anon_sym_set] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_SLASH] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_TILDE] = ACTIONS(1914),
    [anon_sym_void] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_PLUS_PLUS] = ACTIONS(1914),
    [anon_sym_DASH_DASH] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_SQUOTE] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [sym_number] = ACTIONS(1914),
    [sym_this] = ACTIONS(1916),
    [sym_super] = ACTIONS(1916),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [sym_null] = ACTIONS(1916),
    [anon_sym_AT] = ACTIONS(1914),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_any] = ACTIONS(1916),
    [anon_sym_number] = ACTIONS(1916),
    [anon_sym_boolean] = ACTIONS(1916),
    [anon_sym_string] = ACTIONS(1916),
    [anon_sym_symbol] = ACTIONS(1916),
    [sym_readonly] = ACTIONS(1916),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(1918),
    [sym_identifier] = ACTIONS(1920),
    [anon_sym_export] = ACTIONS(1920),
    [anon_sym_default] = ACTIONS(1920),
    [anon_sym_namespace] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1918),
    [anon_sym_RBRACE] = ACTIONS(1918),
    [anon_sym_typeof] = ACTIONS(1920),
    [anon_sym_type] = ACTIONS(1920),
    [anon_sym_interface] = ACTIONS(1920),
    [anon_sym_declare] = ACTIONS(1920),
    [anon_sym_module] = ACTIONS(1920),
    [anon_sym_import] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_var] = ACTIONS(1920),
    [anon_sym_let] = ACTIONS(1920),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_else] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1920),
    [anon_sym_switch] = ACTIONS(1920),
    [anon_sym_for] = ACTIONS(1920),
    [anon_sym_LPAREN] = ACTIONS(1918),
    [anon_sym_await] = ACTIONS(1920),
    [anon_sym_while] = ACTIONS(1920),
    [anon_sym_do] = ACTIONS(1920),
    [anon_sym_try] = ACTIONS(1920),
    [anon_sym_with] = ACTIONS(1920),
    [anon_sym_break] = ACTIONS(1920),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_debugger] = ACTIONS(1920),
    [anon_sym_return] = ACTIONS(1920),
    [anon_sym_throw] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_case] = ACTIONS(1920),
    [anon_sym_yield] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_async] = ACTIONS(1920),
    [anon_sym_function] = ACTIONS(1920),
    [anon_sym_abstract] = ACTIONS(1920),
    [anon_sym_get] = ACTIONS(1920),
    [anon_sym_set] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1920),
    [anon_sym_PLUS] = ACTIONS(1920),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_SLASH] = ACTIONS(1920),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_void] = ACTIONS(1920),
    [anon_sym_delete] = ACTIONS(1920),
    [anon_sym_PLUS_PLUS] = ACTIONS(1918),
    [anon_sym_DASH_DASH] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1918),
    [sym_number] = ACTIONS(1918),
    [sym_this] = ACTIONS(1920),
    [sym_super] = ACTIONS(1920),
    [sym_true] = ACTIONS(1920),
    [sym_false] = ACTIONS(1920),
    [sym_null] = ACTIONS(1920),
    [anon_sym_AT] = ACTIONS(1918),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_public] = ACTIONS(1920),
    [anon_sym_private] = ACTIONS(1920),
    [anon_sym_protected] = ACTIONS(1920),
    [anon_sym_any] = ACTIONS(1920),
    [anon_sym_number] = ACTIONS(1920),
    [anon_sym_boolean] = ACTIONS(1920),
    [anon_sym_string] = ACTIONS(1920),
    [anon_sym_symbol] = ACTIONS(1920),
    [sym_readonly] = ACTIONS(1920),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(1064),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_export] = ACTIONS(1066),
    [anon_sym_default] = ACTIONS(1066),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1064),
    [anon_sym_RBRACE] = ACTIONS(1064),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_type] = ACTIONS(1066),
    [anon_sym_interface] = ACTIONS(1066),
    [anon_sym_declare] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1066),
    [anon_sym_import] = ACTIONS(1066),
    [anon_sym_const] = ACTIONS(1066),
    [anon_sym_enum] = ACTIONS(1066),
    [anon_sym_var] = ACTIONS(1066),
    [anon_sym_let] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1066),
    [anon_sym_if] = ACTIONS(1066),
    [anon_sym_switch] = ACTIONS(1066),
    [anon_sym_for] = ACTIONS(1066),
    [anon_sym_LPAREN] = ACTIONS(1064),
    [anon_sym_await] = ACTIONS(1066),
    [anon_sym_while] = ACTIONS(1066),
    [anon_sym_do] = ACTIONS(1066),
    [anon_sym_try] = ACTIONS(1066),
    [anon_sym_with] = ACTIONS(1066),
    [anon_sym_break] = ACTIONS(1066),
    [anon_sym_continue] = ACTIONS(1066),
    [anon_sym_debugger] = ACTIONS(1066),
    [anon_sym_return] = ACTIONS(1066),
    [anon_sym_throw] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1066),
    [anon_sym_yield] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1066),
    [anon_sym_async] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1066),
    [anon_sym_abstract] = ACTIONS(1066),
    [anon_sym_get] = ACTIONS(1066),
    [anon_sym_set] = ACTIONS(1066),
    [anon_sym_new] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_LT] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1064),
    [anon_sym_void] = ACTIONS(1066),
    [anon_sym_delete] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1064),
    [anon_sym_DQUOTE] = ACTIONS(1064),
    [anon_sym_SQUOTE] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [sym_number] = ACTIONS(1064),
    [sym_this] = ACTIONS(1066),
    [sym_super] = ACTIONS(1066),
    [sym_true] = ACTIONS(1066),
    [sym_false] = ACTIONS(1066),
    [sym_null] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1064),
    [anon_sym_static] = ACTIONS(1066),
    [anon_sym_public] = ACTIONS(1066),
    [anon_sym_private] = ACTIONS(1066),
    [anon_sym_protected] = ACTIONS(1066),
    [anon_sym_any] = ACTIONS(1066),
    [anon_sym_number] = ACTIONS(1066),
    [anon_sym_boolean] = ACTIONS(1066),
    [anon_sym_string] = ACTIONS(1066),
    [anon_sym_symbol] = ACTIONS(1066),
    [sym_readonly] = ACTIONS(1066),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(1922),
    [sym_identifier] = ACTIONS(1924),
    [anon_sym_export] = ACTIONS(1924),
    [anon_sym_default] = ACTIONS(1924),
    [anon_sym_namespace] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1922),
    [anon_sym_RBRACE] = ACTIONS(1922),
    [anon_sym_typeof] = ACTIONS(1924),
    [anon_sym_type] = ACTIONS(1924),
    [anon_sym_interface] = ACTIONS(1924),
    [anon_sym_declare] = ACTIONS(1924),
    [anon_sym_module] = ACTIONS(1924),
    [anon_sym_import] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_var] = ACTIONS(1924),
    [anon_sym_let] = ACTIONS(1924),
    [anon_sym_BANG] = ACTIONS(1922),
    [anon_sym_else] = ACTIONS(1924),
    [anon_sym_if] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(1922),
    [anon_sym_await] = ACTIONS(1924),
    [anon_sym_while] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1924),
    [anon_sym_try] = ACTIONS(1924),
    [anon_sym_with] = ACTIONS(1924),
    [anon_sym_break] = ACTIONS(1924),
    [anon_sym_continue] = ACTIONS(1924),
    [anon_sym_debugger] = ACTIONS(1924),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_case] = ACTIONS(1924),
    [anon_sym_yield] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_async] = ACTIONS(1924),
    [anon_sym_function] = ACTIONS(1924),
    [anon_sym_abstract] = ACTIONS(1924),
    [anon_sym_get] = ACTIONS(1924),
    [anon_sym_set] = ACTIONS(1924),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_SLASH] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_void] = ACTIONS(1924),
    [anon_sym_delete] = ACTIONS(1924),
    [anon_sym_PLUS_PLUS] = ACTIONS(1922),
    [anon_sym_DASH_DASH] = ACTIONS(1922),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1922),
    [sym_number] = ACTIONS(1922),
    [sym_this] = ACTIONS(1924),
    [sym_super] = ACTIONS(1924),
    [sym_true] = ACTIONS(1924),
    [sym_false] = ACTIONS(1924),
    [sym_null] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(1922),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_public] = ACTIONS(1924),
    [anon_sym_private] = ACTIONS(1924),
    [anon_sym_protected] = ACTIONS(1924),
    [anon_sym_any] = ACTIONS(1924),
    [anon_sym_number] = ACTIONS(1924),
    [anon_sym_boolean] = ACTIONS(1924),
    [anon_sym_string] = ACTIONS(1924),
    [anon_sym_symbol] = ACTIONS(1924),
    [sym_readonly] = ACTIONS(1924),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(1926),
    [sym_identifier] = ACTIONS(1928),
    [anon_sym_export] = ACTIONS(1928),
    [anon_sym_default] = ACTIONS(1928),
    [anon_sym_namespace] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(1928),
    [anon_sym_interface] = ACTIONS(1928),
    [anon_sym_declare] = ACTIONS(1928),
    [anon_sym_module] = ACTIONS(1928),
    [anon_sym_import] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_enum] = ACTIONS(1928),
    [anon_sym_var] = ACTIONS(1928),
    [anon_sym_let] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_else] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_LPAREN] = ACTIONS(1926),
    [anon_sym_await] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_with] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_debugger] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_case] = ACTIONS(1928),
    [anon_sym_yield] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1926),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_async] = ACTIONS(1928),
    [anon_sym_function] = ACTIONS(1928),
    [anon_sym_abstract] = ACTIONS(1928),
    [anon_sym_get] = ACTIONS(1928),
    [anon_sym_set] = ACTIONS(1928),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_SLASH] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_void] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1926),
    [sym_number] = ACTIONS(1926),
    [sym_this] = ACTIONS(1928),
    [sym_super] = ACTIONS(1928),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [sym_null] = ACTIONS(1928),
    [anon_sym_AT] = ACTIONS(1926),
    [anon_sym_static] = ACTIONS(1928),
    [anon_sym_public] = ACTIONS(1928),
    [anon_sym_private] = ACTIONS(1928),
    [anon_sym_protected] = ACTIONS(1928),
    [anon_sym_any] = ACTIONS(1928),
    [anon_sym_number] = ACTIONS(1928),
    [anon_sym_boolean] = ACTIONS(1928),
    [anon_sym_string] = ACTIONS(1928),
    [anon_sym_symbol] = ACTIONS(1928),
    [sym_readonly] = ACTIONS(1928),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(1930),
    [sym_identifier] = ACTIONS(1932),
    [anon_sym_export] = ACTIONS(1932),
    [anon_sym_default] = ACTIONS(1932),
    [anon_sym_namespace] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_typeof] = ACTIONS(1932),
    [anon_sym_type] = ACTIONS(1932),
    [anon_sym_interface] = ACTIONS(1932),
    [anon_sym_declare] = ACTIONS(1932),
    [anon_sym_module] = ACTIONS(1932),
    [anon_sym_import] = ACTIONS(1932),
    [anon_sym_const] = ACTIONS(1932),
    [anon_sym_enum] = ACTIONS(1932),
    [anon_sym_var] = ACTIONS(1932),
    [anon_sym_let] = ACTIONS(1932),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_else] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(1932),
    [anon_sym_switch] = ACTIONS(1932),
    [anon_sym_for] = ACTIONS(1932),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [anon_sym_await] = ACTIONS(1932),
    [anon_sym_while] = ACTIONS(1932),
    [anon_sym_do] = ACTIONS(1932),
    [anon_sym_try] = ACTIONS(1932),
    [anon_sym_with] = ACTIONS(1932),
    [anon_sym_break] = ACTIONS(1932),
    [anon_sym_continue] = ACTIONS(1932),
    [anon_sym_debugger] = ACTIONS(1932),
    [anon_sym_return] = ACTIONS(1932),
    [anon_sym_throw] = ACTIONS(1932),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_case] = ACTIONS(1932),
    [anon_sym_yield] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1930),
    [anon_sym_class] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1932),
    [anon_sym_function] = ACTIONS(1932),
    [anon_sym_abstract] = ACTIONS(1932),
    [anon_sym_get] = ACTIONS(1932),
    [anon_sym_set] = ACTIONS(1932),
    [anon_sym_new] = ACTIONS(1932),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_SLASH] = ACTIONS(1932),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_void] = ACTIONS(1932),
    [anon_sym_delete] = ACTIONS(1932),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1930),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_super] = ACTIONS(1932),
    [sym_true] = ACTIONS(1932),
    [sym_false] = ACTIONS(1932),
    [sym_null] = ACTIONS(1932),
    [anon_sym_AT] = ACTIONS(1930),
    [anon_sym_static] = ACTIONS(1932),
    [anon_sym_public] = ACTIONS(1932),
    [anon_sym_private] = ACTIONS(1932),
    [anon_sym_protected] = ACTIONS(1932),
    [anon_sym_any] = ACTIONS(1932),
    [anon_sym_number] = ACTIONS(1932),
    [anon_sym_boolean] = ACTIONS(1932),
    [anon_sym_string] = ACTIONS(1932),
    [anon_sym_symbol] = ACTIONS(1932),
    [sym_readonly] = ACTIONS(1932),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(1934),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_namespace] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_typeof] = ACTIONS(1936),
    [anon_sym_type] = ACTIONS(1936),
    [anon_sym_interface] = ACTIONS(1936),
    [anon_sym_declare] = ACTIONS(1936),
    [anon_sym_module] = ACTIONS(1936),
    [anon_sym_import] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_enum] = ACTIONS(1936),
    [anon_sym_var] = ACTIONS(1936),
    [anon_sym_let] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_LPAREN] = ACTIONS(1934),
    [anon_sym_await] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_with] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_debugger] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_yield] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_async] = ACTIONS(1936),
    [anon_sym_function] = ACTIONS(1936),
    [anon_sym_abstract] = ACTIONS(1936),
    [anon_sym_get] = ACTIONS(1936),
    [anon_sym_set] = ACTIONS(1936),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_SLASH] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_void] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [sym_number] = ACTIONS(1934),
    [sym_this] = ACTIONS(1936),
    [sym_super] = ACTIONS(1936),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [sym_null] = ACTIONS(1936),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1936),
    [anon_sym_public] = ACTIONS(1936),
    [anon_sym_private] = ACTIONS(1936),
    [anon_sym_protected] = ACTIONS(1936),
    [anon_sym_any] = ACTIONS(1936),
    [anon_sym_number] = ACTIONS(1936),
    [anon_sym_boolean] = ACTIONS(1936),
    [anon_sym_string] = ACTIONS(1936),
    [anon_sym_symbol] = ACTIONS(1936),
    [sym_readonly] = ACTIONS(1936),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(1938),
    [sym_identifier] = ACTIONS(1940),
    [anon_sym_export] = ACTIONS(1940),
    [anon_sym_default] = ACTIONS(1940),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1938),
    [anon_sym_RBRACE] = ACTIONS(1938),
    [anon_sym_typeof] = ACTIONS(1940),
    [anon_sym_type] = ACTIONS(1940),
    [anon_sym_interface] = ACTIONS(1940),
    [anon_sym_declare] = ACTIONS(1940),
    [anon_sym_module] = ACTIONS(1940),
    [anon_sym_import] = ACTIONS(1940),
    [anon_sym_const] = ACTIONS(1940),
    [anon_sym_enum] = ACTIONS(1940),
    [anon_sym_var] = ACTIONS(1940),
    [anon_sym_let] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1940),
    [anon_sym_if] = ACTIONS(1940),
    [anon_sym_switch] = ACTIONS(1940),
    [anon_sym_for] = ACTIONS(1940),
    [anon_sym_LPAREN] = ACTIONS(1938),
    [anon_sym_await] = ACTIONS(1940),
    [anon_sym_while] = ACTIONS(1940),
    [anon_sym_do] = ACTIONS(1940),
    [anon_sym_try] = ACTIONS(1940),
    [anon_sym_with] = ACTIONS(1940),
    [anon_sym_break] = ACTIONS(1940),
    [anon_sym_continue] = ACTIONS(1940),
    [anon_sym_debugger] = ACTIONS(1940),
    [anon_sym_return] = ACTIONS(1940),
    [anon_sym_throw] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(1940),
    [anon_sym_yield] = ACTIONS(1940),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_class] = ACTIONS(1940),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_function] = ACTIONS(1940),
    [anon_sym_abstract] = ACTIONS(1940),
    [anon_sym_get] = ACTIONS(1940),
    [anon_sym_set] = ACTIONS(1940),
    [anon_sym_new] = ACTIONS(1940),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1940),
    [anon_sym_SLASH] = ACTIONS(1940),
    [anon_sym_LT] = ACTIONS(1938),
    [anon_sym_TILDE] = ACTIONS(1938),
    [anon_sym_void] = ACTIONS(1940),
    [anon_sym_delete] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1938),
    [anon_sym_SQUOTE] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [sym_number] = ACTIONS(1938),
    [sym_this] = ACTIONS(1940),
    [sym_super] = ACTIONS(1940),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [sym_null] = ACTIONS(1940),
    [anon_sym_AT] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1940),
    [anon_sym_public] = ACTIONS(1940),
    [anon_sym_private] = ACTIONS(1940),
    [anon_sym_protected] = ACTIONS(1940),
    [anon_sym_any] = ACTIONS(1940),
    [anon_sym_number] = ACTIONS(1940),
    [anon_sym_boolean] = ACTIONS(1940),
    [anon_sym_string] = ACTIONS(1940),
    [anon_sym_symbol] = ACTIONS(1940),
    [sym_readonly] = ACTIONS(1940),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(1942),
    [sym_identifier] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_default] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1944),
    [anon_sym_LBRACE] = ACTIONS(1942),
    [anon_sym_RBRACE] = ACTIONS(1942),
    [anon_sym_typeof] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_interface] = ACTIONS(1944),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_const] = ACTIONS(1944),
    [anon_sym_enum] = ACTIONS(1944),
    [anon_sym_var] = ACTIONS(1944),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1944),
    [anon_sym_if] = ACTIONS(1944),
    [anon_sym_switch] = ACTIONS(1944),
    [anon_sym_for] = ACTIONS(1944),
    [anon_sym_LPAREN] = ACTIONS(1942),
    [anon_sym_await] = ACTIONS(1944),
    [anon_sym_while] = ACTIONS(1944),
    [anon_sym_do] = ACTIONS(1944),
    [anon_sym_try] = ACTIONS(1944),
    [anon_sym_with] = ACTIONS(1944),
    [anon_sym_break] = ACTIONS(1944),
    [anon_sym_continue] = ACTIONS(1944),
    [anon_sym_debugger] = ACTIONS(1944),
    [anon_sym_return] = ACTIONS(1944),
    [anon_sym_throw] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1944),
    [anon_sym_yield] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(1944),
    [anon_sym_abstract] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1944),
    [anon_sym_PLUS] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_LT] = ACTIONS(1942),
    [anon_sym_TILDE] = ACTIONS(1942),
    [anon_sym_void] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(1942),
    [anon_sym_SQUOTE] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [sym_number] = ACTIONS(1942),
    [sym_this] = ACTIONS(1944),
    [sym_super] = ACTIONS(1944),
    [sym_true] = ACTIONS(1944),
    [sym_false] = ACTIONS(1944),
    [sym_null] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1944),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [sym_readonly] = ACTIONS(1944),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(1946),
    [sym_identifier] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_default] = ACTIONS(1948),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(1946),
    [anon_sym_RBRACE] = ACTIONS(1946),
    [anon_sym_typeof] = ACTIONS(1948),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_interface] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_import] = ACTIONS(1948),
    [anon_sym_const] = ACTIONS(1948),
    [anon_sym_enum] = ACTIONS(1948),
    [anon_sym_var] = ACTIONS(1948),
    [anon_sym_let] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1948),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_switch] = ACTIONS(1948),
    [anon_sym_for] = ACTIONS(1948),
    [anon_sym_LPAREN] = ACTIONS(1946),
    [anon_sym_await] = ACTIONS(1948),
    [anon_sym_while] = ACTIONS(1948),
    [anon_sym_do] = ACTIONS(1948),
    [anon_sym_try] = ACTIONS(1948),
    [anon_sym_with] = ACTIONS(1948),
    [anon_sym_break] = ACTIONS(1948),
    [anon_sym_continue] = ACTIONS(1948),
    [anon_sym_debugger] = ACTIONS(1948),
    [anon_sym_return] = ACTIONS(1948),
    [anon_sym_throw] = ACTIONS(1948),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1948),
    [anon_sym_yield] = ACTIONS(1948),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1948),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1948),
    [anon_sym_abstract] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_new] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_SLASH] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_TILDE] = ACTIONS(1946),
    [anon_sym_void] = ACTIONS(1948),
    [anon_sym_delete] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1946),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(1946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1946),
    [sym_number] = ACTIONS(1946),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(1948),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [sym_readonly] = ACTIONS(1948),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_export] = ACTIONS(1112),
    [anon_sym_default] = ACTIONS(1112),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_typeof] = ACTIONS(1112),
    [anon_sym_type] = ACTIONS(1112),
    [anon_sym_interface] = ACTIONS(1112),
    [anon_sym_declare] = ACTIONS(1112),
    [anon_sym_module] = ACTIONS(1112),
    [anon_sym_import] = ACTIONS(1112),
    [anon_sym_const] = ACTIONS(1112),
    [anon_sym_enum] = ACTIONS(1112),
    [anon_sym_var] = ACTIONS(1112),
    [anon_sym_let] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_else] = ACTIONS(1112),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_switch] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_await] = ACTIONS(1112),
    [anon_sym_while] = ACTIONS(1112),
    [anon_sym_do] = ACTIONS(1112),
    [anon_sym_try] = ACTIONS(1112),
    [anon_sym_with] = ACTIONS(1112),
    [anon_sym_break] = ACTIONS(1112),
    [anon_sym_continue] = ACTIONS(1112),
    [anon_sym_debugger] = ACTIONS(1112),
    [anon_sym_return] = ACTIONS(1112),
    [anon_sym_throw] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_case] = ACTIONS(1112),
    [anon_sym_yield] = ACTIONS(1112),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_class] = ACTIONS(1112),
    [anon_sym_async] = ACTIONS(1112),
    [anon_sym_function] = ACTIONS(1112),
    [anon_sym_abstract] = ACTIONS(1112),
    [anon_sym_get] = ACTIONS(1112),
    [anon_sym_set] = ACTIONS(1112),
    [anon_sym_new] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_void] = ACTIONS(1112),
    [anon_sym_delete] = ACTIONS(1112),
    [anon_sym_PLUS_PLUS] = ACTIONS(1110),
    [anon_sym_DASH_DASH] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1110),
    [sym_number] = ACTIONS(1110),
    [sym_this] = ACTIONS(1112),
    [sym_super] = ACTIONS(1112),
    [sym_true] = ACTIONS(1112),
    [sym_false] = ACTIONS(1112),
    [sym_null] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1110),
    [anon_sym_static] = ACTIONS(1112),
    [anon_sym_public] = ACTIONS(1112),
    [anon_sym_private] = ACTIONS(1112),
    [anon_sym_protected] = ACTIONS(1112),
    [anon_sym_any] = ACTIONS(1112),
    [anon_sym_number] = ACTIONS(1112),
    [anon_sym_boolean] = ACTIONS(1112),
    [anon_sym_string] = ACTIONS(1112),
    [anon_sym_symbol] = ACTIONS(1112),
    [sym_readonly] = ACTIONS(1112),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(1950),
    [sym_identifier] = ACTIONS(1952),
    [anon_sym_export] = ACTIONS(1952),
    [anon_sym_default] = ACTIONS(1952),
    [anon_sym_namespace] = ACTIONS(1952),
    [anon_sym_LBRACE] = ACTIONS(1950),
    [anon_sym_RBRACE] = ACTIONS(1950),
    [anon_sym_typeof] = ACTIONS(1952),
    [anon_sym_type] = ACTIONS(1952),
    [anon_sym_interface] = ACTIONS(1952),
    [anon_sym_declare] = ACTIONS(1952),
    [anon_sym_module] = ACTIONS(1952),
    [anon_sym_import] = ACTIONS(1952),
    [anon_sym_const] = ACTIONS(1952),
    [anon_sym_enum] = ACTIONS(1952),
    [anon_sym_var] = ACTIONS(1952),
    [anon_sym_let] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_else] = ACTIONS(1952),
    [anon_sym_if] = ACTIONS(1952),
    [anon_sym_switch] = ACTIONS(1952),
    [anon_sym_for] = ACTIONS(1952),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_await] = ACTIONS(1952),
    [anon_sym_while] = ACTIONS(1952),
    [anon_sym_do] = ACTIONS(1952),
    [anon_sym_try] = ACTIONS(1952),
    [anon_sym_with] = ACTIONS(1952),
    [anon_sym_break] = ACTIONS(1952),
    [anon_sym_continue] = ACTIONS(1952),
    [anon_sym_debugger] = ACTIONS(1952),
    [anon_sym_return] = ACTIONS(1952),
    [anon_sym_throw] = ACTIONS(1952),
    [anon_sym_SEMI] = ACTIONS(1950),
    [anon_sym_case] = ACTIONS(1952),
    [anon_sym_yield] = ACTIONS(1952),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1952),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_function] = ACTIONS(1952),
    [anon_sym_abstract] = ACTIONS(1952),
    [anon_sym_get] = ACTIONS(1952),
    [anon_sym_set] = ACTIONS(1952),
    [anon_sym_new] = ACTIONS(1952),
    [anon_sym_PLUS] = ACTIONS(1952),
    [anon_sym_DASH] = ACTIONS(1952),
    [anon_sym_SLASH] = ACTIONS(1952),
    [anon_sym_LT] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1950),
    [anon_sym_void] = ACTIONS(1952),
    [anon_sym_delete] = ACTIONS(1952),
    [anon_sym_PLUS_PLUS] = ACTIONS(1950),
    [anon_sym_DASH_DASH] = ACTIONS(1950),
    [anon_sym_DQUOTE] = ACTIONS(1950),
    [anon_sym_SQUOTE] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1950),
    [sym_number] = ACTIONS(1950),
    [sym_this] = ACTIONS(1952),
    [sym_super] = ACTIONS(1952),
    [sym_true] = ACTIONS(1952),
    [sym_false] = ACTIONS(1952),
    [sym_null] = ACTIONS(1952),
    [anon_sym_AT] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1952),
    [anon_sym_public] = ACTIONS(1952),
    [anon_sym_private] = ACTIONS(1952),
    [anon_sym_protected] = ACTIONS(1952),
    [anon_sym_any] = ACTIONS(1952),
    [anon_sym_number] = ACTIONS(1952),
    [anon_sym_boolean] = ACTIONS(1952),
    [anon_sym_string] = ACTIONS(1952),
    [anon_sym_symbol] = ACTIONS(1952),
    [sym_readonly] = ACTIONS(1952),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1954),
    [sym_identifier] = ACTIONS(1956),
    [anon_sym_export] = ACTIONS(1956),
    [anon_sym_default] = ACTIONS(1956),
    [anon_sym_namespace] = ACTIONS(1956),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(1956),
    [anon_sym_type] = ACTIONS(1956),
    [anon_sym_interface] = ACTIONS(1956),
    [anon_sym_declare] = ACTIONS(1956),
    [anon_sym_module] = ACTIONS(1956),
    [anon_sym_import] = ACTIONS(1956),
    [anon_sym_const] = ACTIONS(1956),
    [anon_sym_enum] = ACTIONS(1956),
    [anon_sym_var] = ACTIONS(1956),
    [anon_sym_let] = ACTIONS(1956),
    [anon_sym_BANG] = ACTIONS(1954),
    [anon_sym_else] = ACTIONS(1956),
    [anon_sym_if] = ACTIONS(1956),
    [anon_sym_switch] = ACTIONS(1956),
    [anon_sym_for] = ACTIONS(1956),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_await] = ACTIONS(1956),
    [anon_sym_while] = ACTIONS(1956),
    [anon_sym_do] = ACTIONS(1956),
    [anon_sym_try] = ACTIONS(1956),
    [anon_sym_with] = ACTIONS(1956),
    [anon_sym_break] = ACTIONS(1956),
    [anon_sym_continue] = ACTIONS(1956),
    [anon_sym_debugger] = ACTIONS(1956),
    [anon_sym_return] = ACTIONS(1956),
    [anon_sym_throw] = ACTIONS(1956),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_case] = ACTIONS(1956),
    [anon_sym_yield] = ACTIONS(1956),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1956),
    [anon_sym_async] = ACTIONS(1956),
    [anon_sym_function] = ACTIONS(1956),
    [anon_sym_abstract] = ACTIONS(1956),
    [anon_sym_get] = ACTIONS(1956),
    [anon_sym_set] = ACTIONS(1956),
    [anon_sym_new] = ACTIONS(1956),
    [anon_sym_PLUS] = ACTIONS(1956),
    [anon_sym_DASH] = ACTIONS(1956),
    [anon_sym_SLASH] = ACTIONS(1956),
    [anon_sym_LT] = ACTIONS(1954),
    [anon_sym_TILDE] = ACTIONS(1954),
    [anon_sym_void] = ACTIONS(1956),
    [anon_sym_delete] = ACTIONS(1956),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1954),
    [anon_sym_SQUOTE] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [sym_number] = ACTIONS(1954),
    [sym_this] = ACTIONS(1956),
    [sym_super] = ACTIONS(1956),
    [sym_true] = ACTIONS(1956),
    [sym_false] = ACTIONS(1956),
    [sym_null] = ACTIONS(1956),
    [anon_sym_AT] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1956),
    [anon_sym_public] = ACTIONS(1956),
    [anon_sym_private] = ACTIONS(1956),
    [anon_sym_protected] = ACTIONS(1956),
    [anon_sym_any] = ACTIONS(1956),
    [anon_sym_number] = ACTIONS(1956),
    [anon_sym_boolean] = ACTIONS(1956),
    [anon_sym_string] = ACTIONS(1956),
    [anon_sym_symbol] = ACTIONS(1956),
    [sym_readonly] = ACTIONS(1956),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(1958),
    [sym_identifier] = ACTIONS(1960),
    [anon_sym_export] = ACTIONS(1960),
    [anon_sym_default] = ACTIONS(1960),
    [anon_sym_namespace] = ACTIONS(1960),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_RBRACE] = ACTIONS(1958),
    [anon_sym_typeof] = ACTIONS(1960),
    [anon_sym_type] = ACTIONS(1960),
    [anon_sym_interface] = ACTIONS(1960),
    [anon_sym_declare] = ACTIONS(1960),
    [anon_sym_module] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1960),
    [anon_sym_const] = ACTIONS(1960),
    [anon_sym_enum] = ACTIONS(1960),
    [anon_sym_var] = ACTIONS(1960),
    [anon_sym_let] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1960),
    [anon_sym_if] = ACTIONS(1960),
    [anon_sym_switch] = ACTIONS(1960),
    [anon_sym_for] = ACTIONS(1960),
    [anon_sym_LPAREN] = ACTIONS(1958),
    [anon_sym_await] = ACTIONS(1960),
    [anon_sym_while] = ACTIONS(1960),
    [anon_sym_do] = ACTIONS(1960),
    [anon_sym_try] = ACTIONS(1960),
    [anon_sym_with] = ACTIONS(1960),
    [anon_sym_break] = ACTIONS(1960),
    [anon_sym_continue] = ACTIONS(1960),
    [anon_sym_debugger] = ACTIONS(1960),
    [anon_sym_return] = ACTIONS(1960),
    [anon_sym_throw] = ACTIONS(1960),
    [anon_sym_SEMI] = ACTIONS(1958),
    [anon_sym_case] = ACTIONS(1960),
    [anon_sym_yield] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_class] = ACTIONS(1960),
    [anon_sym_async] = ACTIONS(1960),
    [anon_sym_function] = ACTIONS(1960),
    [anon_sym_abstract] = ACTIONS(1960),
    [anon_sym_get] = ACTIONS(1960),
    [anon_sym_set] = ACTIONS(1960),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1960),
    [anon_sym_SLASH] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1958),
    [anon_sym_TILDE] = ACTIONS(1958),
    [anon_sym_void] = ACTIONS(1960),
    [anon_sym_delete] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1958),
    [anon_sym_DQUOTE] = ACTIONS(1958),
    [anon_sym_SQUOTE] = ACTIONS(1958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1958),
    [sym_number] = ACTIONS(1958),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(1960),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(1958),
    [anon_sym_static] = ACTIONS(1960),
    [anon_sym_public] = ACTIONS(1960),
    [anon_sym_private] = ACTIONS(1960),
    [anon_sym_protected] = ACTIONS(1960),
    [anon_sym_any] = ACTIONS(1960),
    [anon_sym_number] = ACTIONS(1960),
    [anon_sym_boolean] = ACTIONS(1960),
    [anon_sym_string] = ACTIONS(1960),
    [anon_sym_symbol] = ACTIONS(1960),
    [sym_readonly] = ACTIONS(1960),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(1962),
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_export] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_typeof] = ACTIONS(1964),
    [anon_sym_type] = ACTIONS(1964),
    [anon_sym_interface] = ACTIONS(1964),
    [anon_sym_declare] = ACTIONS(1964),
    [anon_sym_module] = ACTIONS(1964),
    [anon_sym_import] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_var] = ACTIONS(1964),
    [anon_sym_let] = ACTIONS(1964),
    [anon_sym_BANG] = ACTIONS(1962),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_await] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_with] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_debugger] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_yield] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_async] = ACTIONS(1964),
    [anon_sym_function] = ACTIONS(1964),
    [anon_sym_abstract] = ACTIONS(1964),
    [anon_sym_get] = ACTIONS(1964),
    [anon_sym_set] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1962),
    [anon_sym_TILDE] = ACTIONS(1962),
    [anon_sym_void] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_PLUS_PLUS] = ACTIONS(1962),
    [anon_sym_DASH_DASH] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_SQUOTE] = ACTIONS(1962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [sym_number] = ACTIONS(1962),
    [sym_this] = ACTIONS(1964),
    [sym_super] = ACTIONS(1964),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [sym_null] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(1962),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_any] = ACTIONS(1964),
    [anon_sym_number] = ACTIONS(1964),
    [anon_sym_boolean] = ACTIONS(1964),
    [anon_sym_string] = ACTIONS(1964),
    [anon_sym_symbol] = ACTIONS(1964),
    [sym_readonly] = ACTIONS(1964),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1966),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_typeof] = ACTIONS(1968),
    [anon_sym_type] = ACTIONS(1968),
    [anon_sym_interface] = ACTIONS(1968),
    [anon_sym_declare] = ACTIONS(1968),
    [anon_sym_module] = ACTIONS(1968),
    [anon_sym_import] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_var] = ACTIONS(1968),
    [anon_sym_let] = ACTIONS(1968),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_await] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_with] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_debugger] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_yield] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_function] = ACTIONS(1968),
    [anon_sym_abstract] = ACTIONS(1968),
    [anon_sym_get] = ACTIONS(1968),
    [anon_sym_set] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_void] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [sym_number] = ACTIONS(1966),
    [sym_this] = ACTIONS(1968),
    [sym_super] = ACTIONS(1968),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [sym_null] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1966),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_public] = ACTIONS(1968),
    [anon_sym_private] = ACTIONS(1968),
    [anon_sym_protected] = ACTIONS(1968),
    [anon_sym_any] = ACTIONS(1968),
    [anon_sym_number] = ACTIONS(1968),
    [anon_sym_boolean] = ACTIONS(1968),
    [anon_sym_string] = ACTIONS(1968),
    [anon_sym_symbol] = ACTIONS(1968),
    [sym_readonly] = ACTIONS(1968),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_export] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [anon_sym_typeof] = ACTIONS(1972),
    [anon_sym_type] = ACTIONS(1972),
    [anon_sym_interface] = ACTIONS(1972),
    [anon_sym_declare] = ACTIONS(1972),
    [anon_sym_module] = ACTIONS(1972),
    [anon_sym_import] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [anon_sym_var] = ACTIONS(1972),
    [anon_sym_let] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_await] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_with] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_debugger] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_case] = ACTIONS(1972),
    [anon_sym_yield] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_async] = ACTIONS(1972),
    [anon_sym_function] = ACTIONS(1972),
    [anon_sym_abstract] = ACTIONS(1972),
    [anon_sym_get] = ACTIONS(1972),
    [anon_sym_set] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_SLASH] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1970),
    [sym_number] = ACTIONS(1970),
    [sym_this] = ACTIONS(1972),
    [sym_super] = ACTIONS(1972),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [sym_null] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_public] = ACTIONS(1972),
    [anon_sym_private] = ACTIONS(1972),
    [anon_sym_protected] = ACTIONS(1972),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [sym_readonly] = ACTIONS(1972),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1974),
    [sym_identifier] = ACTIONS(1976),
    [anon_sym_export] = ACTIONS(1976),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1974),
    [anon_sym_RBRACE] = ACTIONS(1974),
    [anon_sym_typeof] = ACTIONS(1976),
    [anon_sym_type] = ACTIONS(1976),
    [anon_sym_interface] = ACTIONS(1976),
    [anon_sym_declare] = ACTIONS(1976),
    [anon_sym_module] = ACTIONS(1976),
    [anon_sym_import] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_var] = ACTIONS(1976),
    [anon_sym_let] = ACTIONS(1976),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_else] = ACTIONS(1976),
    [anon_sym_if] = ACTIONS(1976),
    [anon_sym_switch] = ACTIONS(1976),
    [anon_sym_for] = ACTIONS(1976),
    [anon_sym_LPAREN] = ACTIONS(1974),
    [anon_sym_await] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1976),
    [anon_sym_do] = ACTIONS(1976),
    [anon_sym_try] = ACTIONS(1976),
    [anon_sym_with] = ACTIONS(1976),
    [anon_sym_break] = ACTIONS(1976),
    [anon_sym_continue] = ACTIONS(1976),
    [anon_sym_debugger] = ACTIONS(1976),
    [anon_sym_return] = ACTIONS(1976),
    [anon_sym_throw] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym_case] = ACTIONS(1976),
    [anon_sym_yield] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1974),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_async] = ACTIONS(1976),
    [anon_sym_function] = ACTIONS(1976),
    [anon_sym_abstract] = ACTIONS(1976),
    [anon_sym_get] = ACTIONS(1976),
    [anon_sym_set] = ACTIONS(1976),
    [anon_sym_new] = ACTIONS(1976),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_DASH] = ACTIONS(1976),
    [anon_sym_SLASH] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_TILDE] = ACTIONS(1974),
    [anon_sym_void] = ACTIONS(1976),
    [anon_sym_delete] = ACTIONS(1976),
    [anon_sym_PLUS_PLUS] = ACTIONS(1974),
    [anon_sym_DASH_DASH] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [anon_sym_SQUOTE] = ACTIONS(1974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1974),
    [sym_number] = ACTIONS(1974),
    [sym_this] = ACTIONS(1976),
    [sym_super] = ACTIONS(1976),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [sym_null] = ACTIONS(1976),
    [anon_sym_AT] = ACTIONS(1974),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_public] = ACTIONS(1976),
    [anon_sym_private] = ACTIONS(1976),
    [anon_sym_protected] = ACTIONS(1976),
    [anon_sym_any] = ACTIONS(1976),
    [anon_sym_number] = ACTIONS(1976),
    [anon_sym_boolean] = ACTIONS(1976),
    [anon_sym_string] = ACTIONS(1976),
    [anon_sym_symbol] = ACTIONS(1976),
    [sym_readonly] = ACTIONS(1976),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1978),
    [sym_identifier] = ACTIONS(1980),
    [anon_sym_export] = ACTIONS(1980),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_namespace] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1978),
    [anon_sym_typeof] = ACTIONS(1980),
    [anon_sym_type] = ACTIONS(1980),
    [anon_sym_interface] = ACTIONS(1980),
    [anon_sym_declare] = ACTIONS(1980),
    [anon_sym_module] = ACTIONS(1980),
    [anon_sym_import] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_var] = ACTIONS(1980),
    [anon_sym_let] = ACTIONS(1980),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_switch] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(1978),
    [anon_sym_await] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_do] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [anon_sym_with] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_debugger] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_throw] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_case] = ACTIONS(1980),
    [anon_sym_yield] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1978),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_function] = ACTIONS(1980),
    [anon_sym_abstract] = ACTIONS(1980),
    [anon_sym_get] = ACTIONS(1980),
    [anon_sym_set] = ACTIONS(1980),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1980),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_void] = ACTIONS(1980),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1978),
    [sym_number] = ACTIONS(1978),
    [sym_this] = ACTIONS(1980),
    [sym_super] = ACTIONS(1980),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [sym_null] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1978),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_public] = ACTIONS(1980),
    [anon_sym_private] = ACTIONS(1980),
    [anon_sym_protected] = ACTIONS(1980),
    [anon_sym_any] = ACTIONS(1980),
    [anon_sym_number] = ACTIONS(1980),
    [anon_sym_boolean] = ACTIONS(1980),
    [anon_sym_string] = ACTIONS(1980),
    [anon_sym_symbol] = ACTIONS(1980),
    [sym_readonly] = ACTIONS(1980),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(1982),
    [sym_identifier] = ACTIONS(1984),
    [anon_sym_export] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_typeof] = ACTIONS(1984),
    [anon_sym_type] = ACTIONS(1984),
    [anon_sym_interface] = ACTIONS(1984),
    [anon_sym_declare] = ACTIONS(1984),
    [anon_sym_module] = ACTIONS(1984),
    [anon_sym_import] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
    [anon_sym_var] = ACTIONS(1984),
    [anon_sym_let] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_await] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_debugger] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_throw] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_case] = ACTIONS(1984),
    [anon_sym_yield] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1982),
    [anon_sym_class] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_function] = ACTIONS(1984),
    [anon_sym_abstract] = ACTIONS(1984),
    [anon_sym_get] = ACTIONS(1984),
    [anon_sym_set] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_void] = ACTIONS(1984),
    [anon_sym_delete] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1982),
    [sym_number] = ACTIONS(1982),
    [sym_this] = ACTIONS(1984),
    [sym_super] = ACTIONS(1984),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [sym_null] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1982),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(1984),
    [anon_sym_private] = ACTIONS(1984),
    [anon_sym_protected] = ACTIONS(1984),
    [anon_sym_any] = ACTIONS(1984),
    [anon_sym_number] = ACTIONS(1984),
    [anon_sym_boolean] = ACTIONS(1984),
    [anon_sym_string] = ACTIONS(1984),
    [anon_sym_symbol] = ACTIONS(1984),
    [sym_readonly] = ACTIONS(1984),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(1986),
    [sym_identifier] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_default] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_typeof] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_interface] = ACTIONS(1988),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_module] = ACTIONS(1988),
    [anon_sym_import] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
    [anon_sym_var] = ACTIONS(1988),
    [anon_sym_let] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_switch] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_await] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_do] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [anon_sym_with] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_debugger] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_throw] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_yield] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [anon_sym_class] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_abstract] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_SLASH] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_void] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1986),
    [sym_number] = ACTIONS(1986),
    [sym_this] = ACTIONS(1988),
    [sym_super] = ACTIONS(1988),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [sym_null] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1986),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_public] = ACTIONS(1988),
    [anon_sym_private] = ACTIONS(1988),
    [anon_sym_protected] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [sym_readonly] = ACTIONS(1988),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_export] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_RBRACE] = ACTIONS(1990),
    [anon_sym_typeof] = ACTIONS(1992),
    [anon_sym_type] = ACTIONS(1992),
    [anon_sym_interface] = ACTIONS(1992),
    [anon_sym_declare] = ACTIONS(1992),
    [anon_sym_module] = ACTIONS(1992),
    [anon_sym_import] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [anon_sym_var] = ACTIONS(1992),
    [anon_sym_let] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1990),
    [anon_sym_await] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_with] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_debugger] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_yield] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1990),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_async] = ACTIONS(1992),
    [anon_sym_function] = ACTIONS(1992),
    [anon_sym_abstract] = ACTIONS(1992),
    [anon_sym_get] = ACTIONS(1992),
    [anon_sym_set] = ACTIONS(1992),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_SLASH] = ACTIONS(1992),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_TILDE] = ACTIONS(1990),
    [anon_sym_void] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [sym_number] = ACTIONS(1990),
    [sym_this] = ACTIONS(1992),
    [sym_super] = ACTIONS(1992),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [sym_null] = ACTIONS(1992),
    [anon_sym_AT] = ACTIONS(1990),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_public] = ACTIONS(1992),
    [anon_sym_private] = ACTIONS(1992),
    [anon_sym_protected] = ACTIONS(1992),
    [anon_sym_any] = ACTIONS(1992),
    [anon_sym_number] = ACTIONS(1992),
    [anon_sym_boolean] = ACTIONS(1992),
    [anon_sym_string] = ACTIONS(1992),
    [anon_sym_symbol] = ACTIONS(1992),
    [sym_readonly] = ACTIONS(1992),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(1994),
    [sym_identifier] = ACTIONS(1996),
    [anon_sym_export] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1996),
    [anon_sym_type] = ACTIONS(1996),
    [anon_sym_interface] = ACTIONS(1996),
    [anon_sym_declare] = ACTIONS(1996),
    [anon_sym_module] = ACTIONS(1996),
    [anon_sym_import] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_var] = ACTIONS(1996),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_else] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(1994),
    [anon_sym_await] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_with] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_debugger] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_throw] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_yield] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_async] = ACTIONS(1996),
    [anon_sym_function] = ACTIONS(1996),
    [anon_sym_abstract] = ACTIONS(1996),
    [anon_sym_get] = ACTIONS(1996),
    [anon_sym_set] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_SLASH] = ACTIONS(1996),
    [anon_sym_LT] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_void] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1994),
    [sym_number] = ACTIONS(1994),
    [sym_this] = ACTIONS(1996),
    [sym_super] = ACTIONS(1996),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [anon_sym_AT] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_public] = ACTIONS(1996),
    [anon_sym_private] = ACTIONS(1996),
    [anon_sym_protected] = ACTIONS(1996),
    [anon_sym_any] = ACTIONS(1996),
    [anon_sym_number] = ACTIONS(1996),
    [anon_sym_boolean] = ACTIONS(1996),
    [anon_sym_string] = ACTIONS(1996),
    [anon_sym_symbol] = ACTIONS(1996),
    [sym_readonly] = ACTIONS(1996),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(1998),
    [sym_identifier] = ACTIONS(2000),
    [anon_sym_export] = ACTIONS(2000),
    [anon_sym_default] = ACTIONS(2000),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(1998),
    [anon_sym_RBRACE] = ACTIONS(1998),
    [anon_sym_typeof] = ACTIONS(2000),
    [anon_sym_type] = ACTIONS(2000),
    [anon_sym_interface] = ACTIONS(2000),
    [anon_sym_declare] = ACTIONS(2000),
    [anon_sym_module] = ACTIONS(2000),
    [anon_sym_import] = ACTIONS(2000),
    [anon_sym_const] = ACTIONS(2000),
    [anon_sym_enum] = ACTIONS(2000),
    [anon_sym_var] = ACTIONS(2000),
    [anon_sym_let] = ACTIONS(2000),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_else] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_switch] = ACTIONS(2000),
    [anon_sym_for] = ACTIONS(2000),
    [anon_sym_LPAREN] = ACTIONS(1998),
    [anon_sym_await] = ACTIONS(2000),
    [anon_sym_while] = ACTIONS(2000),
    [anon_sym_do] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2000),
    [anon_sym_with] = ACTIONS(2000),
    [anon_sym_break] = ACTIONS(2000),
    [anon_sym_continue] = ACTIONS(2000),
    [anon_sym_debugger] = ACTIONS(2000),
    [anon_sym_return] = ACTIONS(2000),
    [anon_sym_throw] = ACTIONS(2000),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym_case] = ACTIONS(2000),
    [anon_sym_yield] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(1998),
    [anon_sym_class] = ACTIONS(2000),
    [anon_sym_async] = ACTIONS(2000),
    [anon_sym_function] = ACTIONS(2000),
    [anon_sym_abstract] = ACTIONS(2000),
    [anon_sym_get] = ACTIONS(2000),
    [anon_sym_set] = ACTIONS(2000),
    [anon_sym_new] = ACTIONS(2000),
    [anon_sym_PLUS] = ACTIONS(2000),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_SLASH] = ACTIONS(2000),
    [anon_sym_LT] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1998),
    [anon_sym_void] = ACTIONS(2000),
    [anon_sym_delete] = ACTIONS(2000),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1998),
    [sym_number] = ACTIONS(1998),
    [sym_this] = ACTIONS(2000),
    [sym_super] = ACTIONS(2000),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [sym_null] = ACTIONS(2000),
    [anon_sym_AT] = ACTIONS(1998),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_public] = ACTIONS(2000),
    [anon_sym_private] = ACTIONS(2000),
    [anon_sym_protected] = ACTIONS(2000),
    [anon_sym_any] = ACTIONS(2000),
    [anon_sym_number] = ACTIONS(2000),
    [anon_sym_boolean] = ACTIONS(2000),
    [anon_sym_string] = ACTIONS(2000),
    [anon_sym_symbol] = ACTIONS(2000),
    [sym_readonly] = ACTIONS(2000),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(2002),
    [sym_identifier] = ACTIONS(2004),
    [anon_sym_export] = ACTIONS(2004),
    [anon_sym_default] = ACTIONS(2004),
    [anon_sym_namespace] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_RBRACE] = ACTIONS(2002),
    [anon_sym_typeof] = ACTIONS(2004),
    [anon_sym_type] = ACTIONS(2004),
    [anon_sym_interface] = ACTIONS(2004),
    [anon_sym_declare] = ACTIONS(2004),
    [anon_sym_module] = ACTIONS(2004),
    [anon_sym_import] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_var] = ACTIONS(2004),
    [anon_sym_let] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_switch] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_await] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_do] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [anon_sym_with] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_debugger] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_throw] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym_case] = ACTIONS(2004),
    [anon_sym_yield] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_class] = ACTIONS(2004),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_function] = ACTIONS(2004),
    [anon_sym_abstract] = ACTIONS(2004),
    [anon_sym_get] = ACTIONS(2004),
    [anon_sym_set] = ACTIONS(2004),
    [anon_sym_new] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_SLASH] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(2002),
    [anon_sym_void] = ACTIONS(2004),
    [anon_sym_delete] = ACTIONS(2004),
    [anon_sym_PLUS_PLUS] = ACTIONS(2002),
    [anon_sym_DASH_DASH] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2002),
    [sym_number] = ACTIONS(2002),
    [sym_this] = ACTIONS(2004),
    [sym_super] = ACTIONS(2004),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [sym_null] = ACTIONS(2004),
    [anon_sym_AT] = ACTIONS(2002),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_public] = ACTIONS(2004),
    [anon_sym_private] = ACTIONS(2004),
    [anon_sym_protected] = ACTIONS(2004),
    [anon_sym_any] = ACTIONS(2004),
    [anon_sym_number] = ACTIONS(2004),
    [anon_sym_boolean] = ACTIONS(2004),
    [anon_sym_string] = ACTIONS(2004),
    [anon_sym_symbol] = ACTIONS(2004),
    [sym_readonly] = ACTIONS(2004),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2006),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2008),
    [anon_sym_default] = ACTIONS(2008),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_interface] = ACTIONS(2008),
    [anon_sym_declare] = ACTIONS(2008),
    [anon_sym_module] = ACTIONS(2008),
    [anon_sym_import] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_var] = ACTIONS(2008),
    [anon_sym_let] = ACTIONS(2008),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_else] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_switch] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_LPAREN] = ACTIONS(2006),
    [anon_sym_await] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [anon_sym_with] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_debugger] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_throw] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym_case] = ACTIONS(2008),
    [anon_sym_yield] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2006),
    [anon_sym_class] = ACTIONS(2008),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_abstract] = ACTIONS(2008),
    [anon_sym_get] = ACTIONS(2008),
    [anon_sym_set] = ACTIONS(2008),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_SLASH] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [anon_sym_void] = ACTIONS(2008),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_PLUS_PLUS] = ACTIONS(2006),
    [anon_sym_DASH_DASH] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [sym_number] = ACTIONS(2006),
    [sym_this] = ACTIONS(2008),
    [sym_super] = ACTIONS(2008),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [sym_null] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(2006),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_public] = ACTIONS(2008),
    [anon_sym_private] = ACTIONS(2008),
    [anon_sym_protected] = ACTIONS(2008),
    [anon_sym_any] = ACTIONS(2008),
    [anon_sym_number] = ACTIONS(2008),
    [anon_sym_boolean] = ACTIONS(2008),
    [anon_sym_string] = ACTIONS(2008),
    [anon_sym_symbol] = ACTIONS(2008),
    [sym_readonly] = ACTIONS(2008),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2010),
    [sym_identifier] = ACTIONS(2012),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_default] = ACTIONS(2012),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_typeof] = ACTIONS(2012),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_interface] = ACTIONS(2012),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_import] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_var] = ACTIONS(2012),
    [anon_sym_let] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_else] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_switch] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_await] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_do] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [anon_sym_with] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_debugger] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_throw] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_case] = ACTIONS(2012),
    [anon_sym_yield] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_class] = ACTIONS(2012),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_function] = ACTIONS(2012),
    [anon_sym_abstract] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_void] = ACTIONS(2012),
    [anon_sym_delete] = ACTIONS(2012),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [sym_number] = ACTIONS(2010),
    [sym_this] = ACTIONS(2012),
    [sym_super] = ACTIONS(2012),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [sym_null] = ACTIONS(2012),
    [anon_sym_AT] = ACTIONS(2010),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [sym_readonly] = ACTIONS(2012),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2014),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_export] = ACTIONS(2016),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_namespace] = ACTIONS(2016),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_RBRACE] = ACTIONS(2014),
    [anon_sym_typeof] = ACTIONS(2016),
    [anon_sym_type] = ACTIONS(2016),
    [anon_sym_interface] = ACTIONS(2016),
    [anon_sym_declare] = ACTIONS(2016),
    [anon_sym_module] = ACTIONS(2016),
    [anon_sym_import] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_var] = ACTIONS(2016),
    [anon_sym_let] = ACTIONS(2016),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_switch] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_LPAREN] = ACTIONS(2014),
    [anon_sym_await] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_do] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [anon_sym_with] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_debugger] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_throw] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_case] = ACTIONS(2016),
    [anon_sym_yield] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2014),
    [anon_sym_class] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(2016),
    [anon_sym_function] = ACTIONS(2016),
    [anon_sym_abstract] = ACTIONS(2016),
    [anon_sym_get] = ACTIONS(2016),
    [anon_sym_set] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_DASH] = ACTIONS(2016),
    [anon_sym_SLASH] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2014),
    [anon_sym_TILDE] = ACTIONS(2014),
    [anon_sym_void] = ACTIONS(2016),
    [anon_sym_delete] = ACTIONS(2016),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [sym_number] = ACTIONS(2014),
    [sym_this] = ACTIONS(2016),
    [sym_super] = ACTIONS(2016),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [sym_null] = ACTIONS(2016),
    [anon_sym_AT] = ACTIONS(2014),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_public] = ACTIONS(2016),
    [anon_sym_private] = ACTIONS(2016),
    [anon_sym_protected] = ACTIONS(2016),
    [anon_sym_any] = ACTIONS(2016),
    [anon_sym_number] = ACTIONS(2016),
    [anon_sym_boolean] = ACTIONS(2016),
    [anon_sym_string] = ACTIONS(2016),
    [anon_sym_symbol] = ACTIONS(2016),
    [sym_readonly] = ACTIONS(2016),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2020),
    [anon_sym_export] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(2020),
    [anon_sym_type] = ACTIONS(2020),
    [anon_sym_interface] = ACTIONS(2020),
    [anon_sym_declare] = ACTIONS(2020),
    [anon_sym_module] = ACTIONS(2020),
    [anon_sym_import] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_var] = ACTIONS(2020),
    [anon_sym_let] = ACTIONS(2020),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_else] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_switch] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_LPAREN] = ACTIONS(2018),
    [anon_sym_await] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_do] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [anon_sym_with] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_debugger] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_throw] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym_case] = ACTIONS(2020),
    [anon_sym_yield] = ACTIONS(2020),
    [anon_sym_LBRACK] = ACTIONS(2018),
    [anon_sym_class] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2020),
    [anon_sym_function] = ACTIONS(2020),
    [anon_sym_abstract] = ACTIONS(2020),
    [anon_sym_get] = ACTIONS(2020),
    [anon_sym_set] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_SLASH] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [anon_sym_void] = ACTIONS(2020),
    [anon_sym_delete] = ACTIONS(2020),
    [anon_sym_PLUS_PLUS] = ACTIONS(2018),
    [anon_sym_DASH_DASH] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2018),
    [sym_number] = ACTIONS(2018),
    [sym_this] = ACTIONS(2020),
    [sym_super] = ACTIONS(2020),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [sym_null] = ACTIONS(2020),
    [anon_sym_AT] = ACTIONS(2018),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_public] = ACTIONS(2020),
    [anon_sym_private] = ACTIONS(2020),
    [anon_sym_protected] = ACTIONS(2020),
    [anon_sym_any] = ACTIONS(2020),
    [anon_sym_number] = ACTIONS(2020),
    [anon_sym_boolean] = ACTIONS(2020),
    [anon_sym_string] = ACTIONS(2020),
    [anon_sym_symbol] = ACTIONS(2020),
    [sym_readonly] = ACTIONS(2020),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2022),
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_export] = ACTIONS(2024),
    [anon_sym_default] = ACTIONS(2024),
    [anon_sym_namespace] = ACTIONS(2024),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_RBRACE] = ACTIONS(2022),
    [anon_sym_typeof] = ACTIONS(2024),
    [anon_sym_type] = ACTIONS(2024),
    [anon_sym_interface] = ACTIONS(2024),
    [anon_sym_declare] = ACTIONS(2024),
    [anon_sym_module] = ACTIONS(2024),
    [anon_sym_import] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_var] = ACTIONS(2024),
    [anon_sym_let] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_else] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_switch] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(2022),
    [anon_sym_await] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_do] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [anon_sym_with] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_debugger] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_throw] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym_case] = ACTIONS(2024),
    [anon_sym_yield] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(2022),
    [anon_sym_class] = ACTIONS(2024),
    [anon_sym_async] = ACTIONS(2024),
    [anon_sym_function] = ACTIONS(2024),
    [anon_sym_abstract] = ACTIONS(2024),
    [anon_sym_get] = ACTIONS(2024),
    [anon_sym_set] = ACTIONS(2024),
    [anon_sym_new] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(2022),
    [anon_sym_void] = ACTIONS(2024),
    [anon_sym_delete] = ACTIONS(2024),
    [anon_sym_PLUS_PLUS] = ACTIONS(2022),
    [anon_sym_DASH_DASH] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2022),
    [sym_number] = ACTIONS(2022),
    [sym_this] = ACTIONS(2024),
    [sym_super] = ACTIONS(2024),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [sym_null] = ACTIONS(2024),
    [anon_sym_AT] = ACTIONS(2022),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_public] = ACTIONS(2024),
    [anon_sym_private] = ACTIONS(2024),
    [anon_sym_protected] = ACTIONS(2024),
    [anon_sym_any] = ACTIONS(2024),
    [anon_sym_number] = ACTIONS(2024),
    [anon_sym_boolean] = ACTIONS(2024),
    [anon_sym_string] = ACTIONS(2024),
    [anon_sym_symbol] = ACTIONS(2024),
    [sym_readonly] = ACTIONS(2024),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2026),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_namespace] = ACTIONS(2028),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_RBRACE] = ACTIONS(2026),
    [anon_sym_typeof] = ACTIONS(2028),
    [anon_sym_type] = ACTIONS(2028),
    [anon_sym_interface] = ACTIONS(2028),
    [anon_sym_declare] = ACTIONS(2028),
    [anon_sym_module] = ACTIONS(2028),
    [anon_sym_import] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_var] = ACTIONS(2028),
    [anon_sym_let] = ACTIONS(2028),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_else] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_switch] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_LPAREN] = ACTIONS(2026),
    [anon_sym_await] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_do] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [anon_sym_with] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_debugger] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_throw] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym_case] = ACTIONS(2028),
    [anon_sym_yield] = ACTIONS(2028),
    [anon_sym_LBRACK] = ACTIONS(2026),
    [anon_sym_class] = ACTIONS(2028),
    [anon_sym_async] = ACTIONS(2028),
    [anon_sym_function] = ACTIONS(2028),
    [anon_sym_abstract] = ACTIONS(2028),
    [anon_sym_get] = ACTIONS(2028),
    [anon_sym_set] = ACTIONS(2028),
    [anon_sym_new] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(2028),
    [anon_sym_delete] = ACTIONS(2028),
    [anon_sym_PLUS_PLUS] = ACTIONS(2026),
    [anon_sym_DASH_DASH] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2026),
    [sym_this] = ACTIONS(2028),
    [sym_super] = ACTIONS(2028),
    [sym_true] = ACTIONS(2028),
    [sym_false] = ACTIONS(2028),
    [sym_null] = ACTIONS(2028),
    [anon_sym_AT] = ACTIONS(2026),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_public] = ACTIONS(2028),
    [anon_sym_private] = ACTIONS(2028),
    [anon_sym_protected] = ACTIONS(2028),
    [anon_sym_any] = ACTIONS(2028),
    [anon_sym_number] = ACTIONS(2028),
    [anon_sym_boolean] = ACTIONS(2028),
    [anon_sym_string] = ACTIONS(2028),
    [anon_sym_symbol] = ACTIONS(2028),
    [sym_readonly] = ACTIONS(2028),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2030),
    [sym_identifier] = ACTIONS(2032),
    [anon_sym_export] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_RBRACE] = ACTIONS(2030),
    [anon_sym_typeof] = ACTIONS(2032),
    [anon_sym_type] = ACTIONS(2032),
    [anon_sym_interface] = ACTIONS(2032),
    [anon_sym_declare] = ACTIONS(2032),
    [anon_sym_module] = ACTIONS(2032),
    [anon_sym_import] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_var] = ACTIONS(2032),
    [anon_sym_let] = ACTIONS(2032),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_else] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [anon_sym_await] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [anon_sym_with] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_debugger] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_throw] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_yield] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2030),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_async] = ACTIONS(2032),
    [anon_sym_function] = ACTIONS(2032),
    [anon_sym_abstract] = ACTIONS(2032),
    [anon_sym_get] = ACTIONS(2032),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_SLASH] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_void] = ACTIONS(2032),
    [anon_sym_delete] = ACTIONS(2032),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_DQUOTE] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2030),
    [sym_number] = ACTIONS(2030),
    [sym_this] = ACTIONS(2032),
    [sym_super] = ACTIONS(2032),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(2030),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_public] = ACTIONS(2032),
    [anon_sym_private] = ACTIONS(2032),
    [anon_sym_protected] = ACTIONS(2032),
    [anon_sym_any] = ACTIONS(2032),
    [anon_sym_number] = ACTIONS(2032),
    [anon_sym_boolean] = ACTIONS(2032),
    [anon_sym_string] = ACTIONS(2032),
    [anon_sym_symbol] = ACTIONS(2032),
    [sym_readonly] = ACTIONS(2032),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(2034),
    [sym_identifier] = ACTIONS(2036),
    [anon_sym_export] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_namespace] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_typeof] = ACTIONS(2036),
    [anon_sym_type] = ACTIONS(2036),
    [anon_sym_interface] = ACTIONS(2036),
    [anon_sym_declare] = ACTIONS(2036),
    [anon_sym_module] = ACTIONS(2036),
    [anon_sym_import] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_var] = ACTIONS(2036),
    [anon_sym_let] = ACTIONS(2036),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [anon_sym_await] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_with] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_debugger] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_case] = ACTIONS(2036),
    [anon_sym_yield] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_async] = ACTIONS(2036),
    [anon_sym_function] = ACTIONS(2036),
    [anon_sym_abstract] = ACTIONS(2036),
    [anon_sym_get] = ACTIONS(2036),
    [anon_sym_set] = ACTIONS(2036),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_SLASH] = ACTIONS(2036),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_void] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2034),
    [sym_number] = ACTIONS(2034),
    [sym_this] = ACTIONS(2036),
    [sym_super] = ACTIONS(2036),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [sym_null] = ACTIONS(2036),
    [anon_sym_AT] = ACTIONS(2034),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_public] = ACTIONS(2036),
    [anon_sym_private] = ACTIONS(2036),
    [anon_sym_protected] = ACTIONS(2036),
    [anon_sym_any] = ACTIONS(2036),
    [anon_sym_number] = ACTIONS(2036),
    [anon_sym_boolean] = ACTIONS(2036),
    [anon_sym_string] = ACTIONS(2036),
    [anon_sym_symbol] = ACTIONS(2036),
    [sym_readonly] = ACTIONS(2036),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(958),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_typeof] = ACTIONS(960),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_interface] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_import] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_var] = ACTIONS(960),
    [anon_sym_let] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(958),
    [anon_sym_await] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_try] = ACTIONS(960),
    [anon_sym_with] = ACTIONS(960),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_debugger] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_throw] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_yield] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(958),
    [anon_sym_class] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(960),
    [anon_sym_get] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_SLASH] = ACTIONS(960),
    [anon_sym_LT] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_delete] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [sym_number] = ACTIONS(958),
    [sym_this] = ACTIONS(960),
    [sym_super] = ACTIONS(960),
    [sym_true] = ACTIONS(960),
    [sym_false] = ACTIONS(960),
    [sym_null] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(958),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [sym_readonly] = ACTIONS(960),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(1064),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_export] = ACTIONS(1066),
    [anon_sym_default] = ACTIONS(1066),
    [anon_sym_namespace] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1064),
    [anon_sym_RBRACE] = ACTIONS(1064),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_type] = ACTIONS(1066),
    [anon_sym_interface] = ACTIONS(1066),
    [anon_sym_declare] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1066),
    [anon_sym_import] = ACTIONS(1066),
    [anon_sym_const] = ACTIONS(1066),
    [anon_sym_enum] = ACTIONS(1066),
    [anon_sym_var] = ACTIONS(1066),
    [anon_sym_let] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1066),
    [anon_sym_if] = ACTIONS(1066),
    [anon_sym_switch] = ACTIONS(1066),
    [anon_sym_for] = ACTIONS(1066),
    [anon_sym_LPAREN] = ACTIONS(1064),
    [anon_sym_await] = ACTIONS(1066),
    [anon_sym_while] = ACTIONS(1066),
    [anon_sym_do] = ACTIONS(1066),
    [anon_sym_try] = ACTIONS(1066),
    [anon_sym_with] = ACTIONS(1066),
    [anon_sym_break] = ACTIONS(1066),
    [anon_sym_continue] = ACTIONS(1066),
    [anon_sym_debugger] = ACTIONS(1066),
    [anon_sym_return] = ACTIONS(1066),
    [anon_sym_throw] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1066),
    [anon_sym_yield] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1066),
    [anon_sym_async] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1066),
    [anon_sym_abstract] = ACTIONS(1066),
    [anon_sym_get] = ACTIONS(1066),
    [anon_sym_set] = ACTIONS(1066),
    [anon_sym_new] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_LT] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1064),
    [anon_sym_void] = ACTIONS(1066),
    [anon_sym_delete] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1064),
    [anon_sym_DQUOTE] = ACTIONS(1064),
    [anon_sym_SQUOTE] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [sym_number] = ACTIONS(1064),
    [sym_this] = ACTIONS(1066),
    [sym_super] = ACTIONS(1066),
    [sym_true] = ACTIONS(1066),
    [sym_false] = ACTIONS(1066),
    [sym_null] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1064),
    [anon_sym_static] = ACTIONS(1066),
    [anon_sym_public] = ACTIONS(1066),
    [anon_sym_private] = ACTIONS(1066),
    [anon_sym_protected] = ACTIONS(1066),
    [anon_sym_any] = ACTIONS(1066),
    [anon_sym_number] = ACTIONS(1066),
    [anon_sym_boolean] = ACTIONS(1066),
    [anon_sym_string] = ACTIONS(1066),
    [anon_sym_symbol] = ACTIONS(1066),
    [sym_readonly] = ACTIONS(1066),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2038),
    [sym_identifier] = ACTIONS(2040),
    [anon_sym_export] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_namespace] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [anon_sym_typeof] = ACTIONS(2040),
    [anon_sym_type] = ACTIONS(2040),
    [anon_sym_interface] = ACTIONS(2040),
    [anon_sym_declare] = ACTIONS(2040),
    [anon_sym_module] = ACTIONS(2040),
    [anon_sym_import] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_var] = ACTIONS(2040),
    [anon_sym_let] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_switch] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_LPAREN] = ACTIONS(2038),
    [anon_sym_await] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_do] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [anon_sym_with] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_debugger] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_throw] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym_case] = ACTIONS(2040),
    [anon_sym_yield] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2040),
    [anon_sym_async] = ACTIONS(2040),
    [anon_sym_function] = ACTIONS(2040),
    [anon_sym_abstract] = ACTIONS(2040),
    [anon_sym_get] = ACTIONS(2040),
    [anon_sym_set] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(2040),
    [anon_sym_LT] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_void] = ACTIONS(2040),
    [anon_sym_delete] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2038),
    [sym_number] = ACTIONS(2038),
    [sym_this] = ACTIONS(2040),
    [sym_super] = ACTIONS(2040),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [sym_null] = ACTIONS(2040),
    [anon_sym_AT] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_public] = ACTIONS(2040),
    [anon_sym_private] = ACTIONS(2040),
    [anon_sym_protected] = ACTIONS(2040),
    [anon_sym_any] = ACTIONS(2040),
    [anon_sym_number] = ACTIONS(2040),
    [anon_sym_boolean] = ACTIONS(2040),
    [anon_sym_string] = ACTIONS(2040),
    [anon_sym_symbol] = ACTIONS(2040),
    [sym_readonly] = ACTIONS(2040),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2042),
    [sym_identifier] = ACTIONS(2044),
    [anon_sym_export] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_typeof] = ACTIONS(2044),
    [anon_sym_type] = ACTIONS(2044),
    [anon_sym_interface] = ACTIONS(2044),
    [anon_sym_declare] = ACTIONS(2044),
    [anon_sym_module] = ACTIONS(2044),
    [anon_sym_import] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_var] = ACTIONS(2044),
    [anon_sym_let] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_await] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_do] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [anon_sym_with] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_debugger] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_throw] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_yield] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_async] = ACTIONS(2044),
    [anon_sym_function] = ACTIONS(2044),
    [anon_sym_abstract] = ACTIONS(2044),
    [anon_sym_get] = ACTIONS(2044),
    [anon_sym_set] = ACTIONS(2044),
    [anon_sym_new] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_SLASH] = ACTIONS(2044),
    [anon_sym_LT] = ACTIONS(2042),
    [anon_sym_TILDE] = ACTIONS(2042),
    [anon_sym_void] = ACTIONS(2044),
    [anon_sym_delete] = ACTIONS(2044),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2042),
    [sym_number] = ACTIONS(2042),
    [sym_this] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [sym_null] = ACTIONS(2044),
    [anon_sym_AT] = ACTIONS(2042),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_public] = ACTIONS(2044),
    [anon_sym_private] = ACTIONS(2044),
    [anon_sym_protected] = ACTIONS(2044),
    [anon_sym_any] = ACTIONS(2044),
    [anon_sym_number] = ACTIONS(2044),
    [anon_sym_boolean] = ACTIONS(2044),
    [anon_sym_string] = ACTIONS(2044),
    [anon_sym_symbol] = ACTIONS(2044),
    [sym_readonly] = ACTIONS(2044),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2046),
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_export] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_typeof] = ACTIONS(2048),
    [anon_sym_type] = ACTIONS(2048),
    [anon_sym_interface] = ACTIONS(2048),
    [anon_sym_declare] = ACTIONS(2048),
    [anon_sym_module] = ACTIONS(2048),
    [anon_sym_import] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_var] = ACTIONS(2048),
    [anon_sym_let] = ACTIONS(2048),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_LPAREN] = ACTIONS(2046),
    [anon_sym_await] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_with] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_debugger] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_yield] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2046),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_async] = ACTIONS(2048),
    [anon_sym_function] = ACTIONS(2048),
    [anon_sym_abstract] = ACTIONS(2048),
    [anon_sym_get] = ACTIONS(2048),
    [anon_sym_set] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_SLASH] = ACTIONS(2048),
    [anon_sym_LT] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_void] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2046),
    [sym_number] = ACTIONS(2046),
    [sym_this] = ACTIONS(2048),
    [sym_super] = ACTIONS(2048),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [sym_null] = ACTIONS(2048),
    [anon_sym_AT] = ACTIONS(2046),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_public] = ACTIONS(2048),
    [anon_sym_private] = ACTIONS(2048),
    [anon_sym_protected] = ACTIONS(2048),
    [anon_sym_any] = ACTIONS(2048),
    [anon_sym_number] = ACTIONS(2048),
    [anon_sym_boolean] = ACTIONS(2048),
    [anon_sym_string] = ACTIONS(2048),
    [anon_sym_symbol] = ACTIONS(2048),
    [sym_readonly] = ACTIONS(2048),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2050),
    [sym_identifier] = ACTIONS(2052),
    [anon_sym_export] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_namespace] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [anon_sym_typeof] = ACTIONS(2052),
    [anon_sym_type] = ACTIONS(2052),
    [anon_sym_interface] = ACTIONS(2052),
    [anon_sym_declare] = ACTIONS(2052),
    [anon_sym_module] = ACTIONS(2052),
    [anon_sym_import] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_var] = ACTIONS(2052),
    [anon_sym_let] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_await] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_with] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_debugger] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_yield] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_async] = ACTIONS(2052),
    [anon_sym_function] = ACTIONS(2052),
    [anon_sym_abstract] = ACTIONS(2052),
    [anon_sym_get] = ACTIONS(2052),
    [anon_sym_set] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_SLASH] = ACTIONS(2052),
    [anon_sym_LT] = ACTIONS(2050),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_void] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2050),
    [sym_number] = ACTIONS(2050),
    [sym_this] = ACTIONS(2052),
    [sym_super] = ACTIONS(2052),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [sym_null] = ACTIONS(2052),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_public] = ACTIONS(2052),
    [anon_sym_private] = ACTIONS(2052),
    [anon_sym_protected] = ACTIONS(2052),
    [anon_sym_any] = ACTIONS(2052),
    [anon_sym_number] = ACTIONS(2052),
    [anon_sym_boolean] = ACTIONS(2052),
    [anon_sym_string] = ACTIONS(2052),
    [anon_sym_symbol] = ACTIONS(2052),
    [sym_readonly] = ACTIONS(2052),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_typeof] = ACTIONS(2056),
    [anon_sym_type] = ACTIONS(2056),
    [anon_sym_interface] = ACTIONS(2056),
    [anon_sym_declare] = ACTIONS(2056),
    [anon_sym_module] = ACTIONS(2056),
    [anon_sym_import] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_var] = ACTIONS(2056),
    [anon_sym_let] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_with] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_debugger] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_yield] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2054),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_async] = ACTIONS(2056),
    [anon_sym_function] = ACTIONS(2056),
    [anon_sym_abstract] = ACTIONS(2056),
    [anon_sym_get] = ACTIONS(2056),
    [anon_sym_set] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_SLASH] = ACTIONS(2056),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_void] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2054),
    [sym_number] = ACTIONS(2054),
    [sym_this] = ACTIONS(2056),
    [sym_super] = ACTIONS(2056),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [sym_null] = ACTIONS(2056),
    [anon_sym_AT] = ACTIONS(2054),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_any] = ACTIONS(2056),
    [anon_sym_number] = ACTIONS(2056),
    [anon_sym_boolean] = ACTIONS(2056),
    [anon_sym_string] = ACTIONS(2056),
    [anon_sym_symbol] = ACTIONS(2056),
    [sym_readonly] = ACTIONS(2056),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_typeof] = ACTIONS(2060),
    [anon_sym_type] = ACTIONS(2060),
    [anon_sym_interface] = ACTIONS(2060),
    [anon_sym_declare] = ACTIONS(2060),
    [anon_sym_module] = ACTIONS(2060),
    [anon_sym_import] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_var] = ACTIONS(2060),
    [anon_sym_let] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_with] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_debugger] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_yield] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2058),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_async] = ACTIONS(2060),
    [anon_sym_function] = ACTIONS(2060),
    [anon_sym_abstract] = ACTIONS(2060),
    [anon_sym_get] = ACTIONS(2060),
    [anon_sym_set] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_SLASH] = ACTIONS(2060),
    [anon_sym_LT] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_void] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2058),
    [sym_number] = ACTIONS(2058),
    [sym_this] = ACTIONS(2060),
    [sym_super] = ACTIONS(2060),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [sym_null] = ACTIONS(2060),
    [anon_sym_AT] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_any] = ACTIONS(2060),
    [anon_sym_number] = ACTIONS(2060),
    [anon_sym_boolean] = ACTIONS(2060),
    [anon_sym_string] = ACTIONS(2060),
    [anon_sym_symbol] = ACTIONS(2060),
    [sym_readonly] = ACTIONS(2060),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(2062),
    [sym_identifier] = ACTIONS(2064),
    [anon_sym_export] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_namespace] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_typeof] = ACTIONS(2064),
    [anon_sym_type] = ACTIONS(2064),
    [anon_sym_interface] = ACTIONS(2064),
    [anon_sym_declare] = ACTIONS(2064),
    [anon_sym_module] = ACTIONS(2064),
    [anon_sym_import] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_var] = ACTIONS(2064),
    [anon_sym_let] = ACTIONS(2064),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_LPAREN] = ACTIONS(2062),
    [anon_sym_await] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_with] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_debugger] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym_case] = ACTIONS(2064),
    [anon_sym_yield] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2062),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_async] = ACTIONS(2064),
    [anon_sym_function] = ACTIONS(2064),
    [anon_sym_abstract] = ACTIONS(2064),
    [anon_sym_get] = ACTIONS(2064),
    [anon_sym_set] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_SLASH] = ACTIONS(2064),
    [anon_sym_LT] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_void] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2062),
    [sym_number] = ACTIONS(2062),
    [sym_this] = ACTIONS(2064),
    [sym_super] = ACTIONS(2064),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [sym_null] = ACTIONS(2064),
    [anon_sym_AT] = ACTIONS(2062),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_public] = ACTIONS(2064),
    [anon_sym_private] = ACTIONS(2064),
    [anon_sym_protected] = ACTIONS(2064),
    [anon_sym_any] = ACTIONS(2064),
    [anon_sym_number] = ACTIONS(2064),
    [anon_sym_boolean] = ACTIONS(2064),
    [anon_sym_string] = ACTIONS(2064),
    [anon_sym_symbol] = ACTIONS(2064),
    [sym_readonly] = ACTIONS(2064),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2068),
    [anon_sym_export] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_namespace] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_RBRACE] = ACTIONS(2066),
    [anon_sym_typeof] = ACTIONS(2068),
    [anon_sym_type] = ACTIONS(2068),
    [anon_sym_interface] = ACTIONS(2068),
    [anon_sym_declare] = ACTIONS(2068),
    [anon_sym_module] = ACTIONS(2068),
    [anon_sym_import] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_var] = ACTIONS(2068),
    [anon_sym_let] = ACTIONS(2068),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_LPAREN] = ACTIONS(2066),
    [anon_sym_await] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_with] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_debugger] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym_case] = ACTIONS(2068),
    [anon_sym_yield] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2066),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_async] = ACTIONS(2068),
    [anon_sym_function] = ACTIONS(2068),
    [anon_sym_abstract] = ACTIONS(2068),
    [anon_sym_get] = ACTIONS(2068),
    [anon_sym_set] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_SLASH] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_void] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2066),
    [sym_number] = ACTIONS(2066),
    [sym_this] = ACTIONS(2068),
    [sym_super] = ACTIONS(2068),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [sym_null] = ACTIONS(2068),
    [anon_sym_AT] = ACTIONS(2066),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_public] = ACTIONS(2068),
    [anon_sym_private] = ACTIONS(2068),
    [anon_sym_protected] = ACTIONS(2068),
    [anon_sym_any] = ACTIONS(2068),
    [anon_sym_number] = ACTIONS(2068),
    [anon_sym_boolean] = ACTIONS(2068),
    [anon_sym_string] = ACTIONS(2068),
    [anon_sym_symbol] = ACTIONS(2068),
    [sym_readonly] = ACTIONS(2068),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_export] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_RBRACE] = ACTIONS(2070),
    [anon_sym_typeof] = ACTIONS(2072),
    [anon_sym_type] = ACTIONS(2072),
    [anon_sym_interface] = ACTIONS(2072),
    [anon_sym_declare] = ACTIONS(2072),
    [anon_sym_module] = ACTIONS(2072),
    [anon_sym_import] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_var] = ACTIONS(2072),
    [anon_sym_let] = ACTIONS(2072),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_LPAREN] = ACTIONS(2070),
    [anon_sym_await] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_with] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_debugger] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_case] = ACTIONS(2072),
    [anon_sym_yield] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2070),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_async] = ACTIONS(2072),
    [anon_sym_function] = ACTIONS(2072),
    [anon_sym_abstract] = ACTIONS(2072),
    [anon_sym_get] = ACTIONS(2072),
    [anon_sym_set] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_SLASH] = ACTIONS(2072),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_void] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2070),
    [sym_number] = ACTIONS(2070),
    [sym_this] = ACTIONS(2072),
    [sym_super] = ACTIONS(2072),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [sym_null] = ACTIONS(2072),
    [anon_sym_AT] = ACTIONS(2070),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_public] = ACTIONS(2072),
    [anon_sym_private] = ACTIONS(2072),
    [anon_sym_protected] = ACTIONS(2072),
    [anon_sym_any] = ACTIONS(2072),
    [anon_sym_number] = ACTIONS(2072),
    [anon_sym_boolean] = ACTIONS(2072),
    [anon_sym_string] = ACTIONS(2072),
    [anon_sym_symbol] = ACTIONS(2072),
    [sym_readonly] = ACTIONS(2072),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_export] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_namespace] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_typeof] = ACTIONS(2076),
    [anon_sym_type] = ACTIONS(2076),
    [anon_sym_interface] = ACTIONS(2076),
    [anon_sym_declare] = ACTIONS(2076),
    [anon_sym_module] = ACTIONS(2076),
    [anon_sym_import] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_var] = ACTIONS(2076),
    [anon_sym_let] = ACTIONS(2076),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_LPAREN] = ACTIONS(2074),
    [anon_sym_await] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_with] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_debugger] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym_case] = ACTIONS(2076),
    [anon_sym_yield] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2074),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_async] = ACTIONS(2076),
    [anon_sym_function] = ACTIONS(2076),
    [anon_sym_abstract] = ACTIONS(2076),
    [anon_sym_get] = ACTIONS(2076),
    [anon_sym_set] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_SLASH] = ACTIONS(2076),
    [anon_sym_LT] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_void] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2074),
    [sym_number] = ACTIONS(2074),
    [sym_this] = ACTIONS(2076),
    [sym_super] = ACTIONS(2076),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [sym_null] = ACTIONS(2076),
    [anon_sym_AT] = ACTIONS(2074),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_public] = ACTIONS(2076),
    [anon_sym_private] = ACTIONS(2076),
    [anon_sym_protected] = ACTIONS(2076),
    [anon_sym_any] = ACTIONS(2076),
    [anon_sym_number] = ACTIONS(2076),
    [anon_sym_boolean] = ACTIONS(2076),
    [anon_sym_string] = ACTIONS(2076),
    [anon_sym_symbol] = ACTIONS(2076),
    [sym_readonly] = ACTIONS(2076),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2080),
    [anon_sym_export] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_RBRACE] = ACTIONS(2078),
    [anon_sym_typeof] = ACTIONS(2080),
    [anon_sym_type] = ACTIONS(2080),
    [anon_sym_interface] = ACTIONS(2080),
    [anon_sym_declare] = ACTIONS(2080),
    [anon_sym_module] = ACTIONS(2080),
    [anon_sym_import] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_var] = ACTIONS(2080),
    [anon_sym_let] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_else] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_switch] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_await] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [anon_sym_with] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_debugger] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_throw] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym_case] = ACTIONS(2080),
    [anon_sym_yield] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2078),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_async] = ACTIONS(2080),
    [anon_sym_function] = ACTIONS(2080),
    [anon_sym_abstract] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(2080),
    [anon_sym_set] = ACTIONS(2080),
    [anon_sym_new] = ACTIONS(2080),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_SLASH] = ACTIONS(2080),
    [anon_sym_LT] = ACTIONS(2078),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_void] = ACTIONS(2080),
    [anon_sym_delete] = ACTIONS(2080),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2078),
    [sym_number] = ACTIONS(2078),
    [sym_this] = ACTIONS(2080),
    [sym_super] = ACTIONS(2080),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [sym_null] = ACTIONS(2080),
    [anon_sym_AT] = ACTIONS(2078),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_any] = ACTIONS(2080),
    [anon_sym_number] = ACTIONS(2080),
    [anon_sym_boolean] = ACTIONS(2080),
    [anon_sym_string] = ACTIONS(2080),
    [anon_sym_symbol] = ACTIONS(2080),
    [sym_readonly] = ACTIONS(2080),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(2084),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_namespace] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_typeof] = ACTIONS(2084),
    [anon_sym_type] = ACTIONS(2084),
    [anon_sym_interface] = ACTIONS(2084),
    [anon_sym_declare] = ACTIONS(2084),
    [anon_sym_module] = ACTIONS(2084),
    [anon_sym_import] = ACTIONS(2084),
    [anon_sym_const] = ACTIONS(2084),
    [anon_sym_enum] = ACTIONS(2084),
    [anon_sym_var] = ACTIONS(2084),
    [anon_sym_let] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_else] = ACTIONS(2084),
    [anon_sym_if] = ACTIONS(2084),
    [anon_sym_switch] = ACTIONS(2084),
    [anon_sym_for] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2082),
    [anon_sym_await] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2084),
    [anon_sym_do] = ACTIONS(2084),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_with] = ACTIONS(2084),
    [anon_sym_break] = ACTIONS(2084),
    [anon_sym_continue] = ACTIONS(2084),
    [anon_sym_debugger] = ACTIONS(2084),
    [anon_sym_return] = ACTIONS(2084),
    [anon_sym_throw] = ACTIONS(2084),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym_case] = ACTIONS(2084),
    [anon_sym_yield] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2082),
    [anon_sym_class] = ACTIONS(2084),
    [anon_sym_async] = ACTIONS(2084),
    [anon_sym_function] = ACTIONS(2084),
    [anon_sym_abstract] = ACTIONS(2084),
    [anon_sym_get] = ACTIONS(2084),
    [anon_sym_set] = ACTIONS(2084),
    [anon_sym_new] = ACTIONS(2084),
    [anon_sym_PLUS] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_SLASH] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_void] = ACTIONS(2084),
    [anon_sym_delete] = ACTIONS(2084),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2082),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(2084),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2084),
    [anon_sym_public] = ACTIONS(2084),
    [anon_sym_private] = ACTIONS(2084),
    [anon_sym_protected] = ACTIONS(2084),
    [anon_sym_any] = ACTIONS(2084),
    [anon_sym_number] = ACTIONS(2084),
    [anon_sym_boolean] = ACTIONS(2084),
    [anon_sym_string] = ACTIONS(2084),
    [anon_sym_symbol] = ACTIONS(2084),
    [sym_readonly] = ACTIONS(2084),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(2086),
    [sym_identifier] = ACTIONS(2088),
    [anon_sym_export] = ACTIONS(2088),
    [anon_sym_default] = ACTIONS(2088),
    [anon_sym_namespace] = ACTIONS(2088),
    [anon_sym_LBRACE] = ACTIONS(2086),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [anon_sym_typeof] = ACTIONS(2088),
    [anon_sym_type] = ACTIONS(2088),
    [anon_sym_interface] = ACTIONS(2088),
    [anon_sym_declare] = ACTIONS(2088),
    [anon_sym_module] = ACTIONS(2088),
    [anon_sym_import] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(2088),
    [anon_sym_enum] = ACTIONS(2088),
    [anon_sym_var] = ACTIONS(2088),
    [anon_sym_let] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(2086),
    [anon_sym_else] = ACTIONS(2088),
    [anon_sym_if] = ACTIONS(2088),
    [anon_sym_switch] = ACTIONS(2088),
    [anon_sym_for] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(2086),
    [anon_sym_await] = ACTIONS(2088),
    [anon_sym_while] = ACTIONS(2088),
    [anon_sym_do] = ACTIONS(2088),
    [anon_sym_try] = ACTIONS(2088),
    [anon_sym_with] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2088),
    [anon_sym_continue] = ACTIONS(2088),
    [anon_sym_debugger] = ACTIONS(2088),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_throw] = ACTIONS(2088),
    [anon_sym_SEMI] = ACTIONS(2086),
    [anon_sym_case] = ACTIONS(2088),
    [anon_sym_yield] = ACTIONS(2088),
    [anon_sym_LBRACK] = ACTIONS(2086),
    [anon_sym_class] = ACTIONS(2088),
    [anon_sym_async] = ACTIONS(2088),
    [anon_sym_function] = ACTIONS(2088),
    [anon_sym_abstract] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(2088),
    [anon_sym_set] = ACTIONS(2088),
    [anon_sym_new] = ACTIONS(2088),
    [anon_sym_PLUS] = ACTIONS(2088),
    [anon_sym_DASH] = ACTIONS(2088),
    [anon_sym_SLASH] = ACTIONS(2088),
    [anon_sym_LT] = ACTIONS(2086),
    [anon_sym_TILDE] = ACTIONS(2086),
    [anon_sym_void] = ACTIONS(2088),
    [anon_sym_delete] = ACTIONS(2088),
    [anon_sym_PLUS_PLUS] = ACTIONS(2086),
    [anon_sym_DASH_DASH] = ACTIONS(2086),
    [anon_sym_DQUOTE] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2086),
    [sym_number] = ACTIONS(2086),
    [sym_this] = ACTIONS(2088),
    [sym_super] = ACTIONS(2088),
    [sym_true] = ACTIONS(2088),
    [sym_false] = ACTIONS(2088),
    [sym_null] = ACTIONS(2088),
    [anon_sym_AT] = ACTIONS(2086),
    [anon_sym_static] = ACTIONS(2088),
    [anon_sym_public] = ACTIONS(2088),
    [anon_sym_private] = ACTIONS(2088),
    [anon_sym_protected] = ACTIONS(2088),
    [anon_sym_any] = ACTIONS(2088),
    [anon_sym_number] = ACTIONS(2088),
    [anon_sym_boolean] = ACTIONS(2088),
    [anon_sym_string] = ACTIONS(2088),
    [anon_sym_symbol] = ACTIONS(2088),
    [sym_readonly] = ACTIONS(2088),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(2090),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_export] = ACTIONS(2092),
    [anon_sym_default] = ACTIONS(2092),
    [anon_sym_namespace] = ACTIONS(2092),
    [anon_sym_LBRACE] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [anon_sym_typeof] = ACTIONS(2092),
    [anon_sym_type] = ACTIONS(2092),
    [anon_sym_interface] = ACTIONS(2092),
    [anon_sym_declare] = ACTIONS(2092),
    [anon_sym_module] = ACTIONS(2092),
    [anon_sym_import] = ACTIONS(2092),
    [anon_sym_const] = ACTIONS(2092),
    [anon_sym_enum] = ACTIONS(2092),
    [anon_sym_var] = ACTIONS(2092),
    [anon_sym_let] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_else] = ACTIONS(2092),
    [anon_sym_if] = ACTIONS(2092),
    [anon_sym_switch] = ACTIONS(2092),
    [anon_sym_for] = ACTIONS(2092),
    [anon_sym_LPAREN] = ACTIONS(2090),
    [anon_sym_await] = ACTIONS(2092),
    [anon_sym_while] = ACTIONS(2092),
    [anon_sym_do] = ACTIONS(2092),
    [anon_sym_try] = ACTIONS(2092),
    [anon_sym_with] = ACTIONS(2092),
    [anon_sym_break] = ACTIONS(2092),
    [anon_sym_continue] = ACTIONS(2092),
    [anon_sym_debugger] = ACTIONS(2092),
    [anon_sym_return] = ACTIONS(2092),
    [anon_sym_throw] = ACTIONS(2092),
    [anon_sym_SEMI] = ACTIONS(2090),
    [anon_sym_case] = ACTIONS(2092),
    [anon_sym_yield] = ACTIONS(2092),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2092),
    [anon_sym_async] = ACTIONS(2092),
    [anon_sym_function] = ACTIONS(2092),
    [anon_sym_abstract] = ACTIONS(2092),
    [anon_sym_get] = ACTIONS(2092),
    [anon_sym_set] = ACTIONS(2092),
    [anon_sym_new] = ACTIONS(2092),
    [anon_sym_PLUS] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2092),
    [anon_sym_SLASH] = ACTIONS(2092),
    [anon_sym_LT] = ACTIONS(2090),
    [anon_sym_TILDE] = ACTIONS(2090),
    [anon_sym_void] = ACTIONS(2092),
    [anon_sym_delete] = ACTIONS(2092),
    [anon_sym_PLUS_PLUS] = ACTIONS(2090),
    [anon_sym_DASH_DASH] = ACTIONS(2090),
    [anon_sym_DQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2090),
    [sym_number] = ACTIONS(2090),
    [sym_this] = ACTIONS(2092),
    [sym_super] = ACTIONS(2092),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [sym_null] = ACTIONS(2092),
    [anon_sym_AT] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2092),
    [anon_sym_public] = ACTIONS(2092),
    [anon_sym_private] = ACTIONS(2092),
    [anon_sym_protected] = ACTIONS(2092),
    [anon_sym_any] = ACTIONS(2092),
    [anon_sym_number] = ACTIONS(2092),
    [anon_sym_boolean] = ACTIONS(2092),
    [anon_sym_string] = ACTIONS(2092),
    [anon_sym_symbol] = ACTIONS(2092),
    [sym_readonly] = ACTIONS(2092),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(2094),
    [sym_identifier] = ACTIONS(2096),
    [anon_sym_export] = ACTIONS(2096),
    [anon_sym_default] = ACTIONS(2096),
    [anon_sym_namespace] = ACTIONS(2096),
    [anon_sym_LBRACE] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [anon_sym_typeof] = ACTIONS(2096),
    [anon_sym_type] = ACTIONS(2096),
    [anon_sym_interface] = ACTIONS(2096),
    [anon_sym_declare] = ACTIONS(2096),
    [anon_sym_module] = ACTIONS(2096),
    [anon_sym_import] = ACTIONS(2096),
    [anon_sym_const] = ACTIONS(2096),
    [anon_sym_enum] = ACTIONS(2096),
    [anon_sym_var] = ACTIONS(2096),
    [anon_sym_let] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2094),
    [anon_sym_else] = ACTIONS(2096),
    [anon_sym_if] = ACTIONS(2096),
    [anon_sym_switch] = ACTIONS(2096),
    [anon_sym_for] = ACTIONS(2096),
    [anon_sym_LPAREN] = ACTIONS(2094),
    [anon_sym_await] = ACTIONS(2096),
    [anon_sym_while] = ACTIONS(2096),
    [anon_sym_do] = ACTIONS(2096),
    [anon_sym_try] = ACTIONS(2096),
    [anon_sym_with] = ACTIONS(2096),
    [anon_sym_break] = ACTIONS(2096),
    [anon_sym_continue] = ACTIONS(2096),
    [anon_sym_debugger] = ACTIONS(2096),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_throw] = ACTIONS(2096),
    [anon_sym_SEMI] = ACTIONS(2094),
    [anon_sym_case] = ACTIONS(2096),
    [anon_sym_yield] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2096),
    [anon_sym_async] = ACTIONS(2096),
    [anon_sym_function] = ACTIONS(2096),
    [anon_sym_abstract] = ACTIONS(2096),
    [anon_sym_get] = ACTIONS(2096),
    [anon_sym_set] = ACTIONS(2096),
    [anon_sym_new] = ACTIONS(2096),
    [anon_sym_PLUS] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2096),
    [anon_sym_SLASH] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(2094),
    [anon_sym_TILDE] = ACTIONS(2094),
    [anon_sym_void] = ACTIONS(2096),
    [anon_sym_delete] = ACTIONS(2096),
    [anon_sym_PLUS_PLUS] = ACTIONS(2094),
    [anon_sym_DASH_DASH] = ACTIONS(2094),
    [anon_sym_DQUOTE] = ACTIONS(2094),
    [anon_sym_SQUOTE] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2094),
    [sym_number] = ACTIONS(2094),
    [sym_this] = ACTIONS(2096),
    [sym_super] = ACTIONS(2096),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_null] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2096),
    [anon_sym_public] = ACTIONS(2096),
    [anon_sym_private] = ACTIONS(2096),
    [anon_sym_protected] = ACTIONS(2096),
    [anon_sym_any] = ACTIONS(2096),
    [anon_sym_number] = ACTIONS(2096),
    [anon_sym_boolean] = ACTIONS(2096),
    [anon_sym_string] = ACTIONS(2096),
    [anon_sym_symbol] = ACTIONS(2096),
    [sym_readonly] = ACTIONS(2096),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2098),
    [sym_identifier] = ACTIONS(2100),
    [anon_sym_export] = ACTIONS(2100),
    [anon_sym_default] = ACTIONS(2100),
    [anon_sym_namespace] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2098),
    [anon_sym_RBRACE] = ACTIONS(2098),
    [anon_sym_typeof] = ACTIONS(2100),
    [anon_sym_type] = ACTIONS(2100),
    [anon_sym_interface] = ACTIONS(2100),
    [anon_sym_declare] = ACTIONS(2100),
    [anon_sym_module] = ACTIONS(2100),
    [anon_sym_import] = ACTIONS(2100),
    [anon_sym_const] = ACTIONS(2100),
    [anon_sym_enum] = ACTIONS(2100),
    [anon_sym_var] = ACTIONS(2100),
    [anon_sym_let] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2100),
    [anon_sym_switch] = ACTIONS(2100),
    [anon_sym_for] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_await] = ACTIONS(2100),
    [anon_sym_while] = ACTIONS(2100),
    [anon_sym_do] = ACTIONS(2100),
    [anon_sym_try] = ACTIONS(2100),
    [anon_sym_with] = ACTIONS(2100),
    [anon_sym_break] = ACTIONS(2100),
    [anon_sym_continue] = ACTIONS(2100),
    [anon_sym_debugger] = ACTIONS(2100),
    [anon_sym_return] = ACTIONS(2100),
    [anon_sym_throw] = ACTIONS(2100),
    [anon_sym_SEMI] = ACTIONS(2098),
    [anon_sym_case] = ACTIONS(2100),
    [anon_sym_yield] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_class] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2100),
    [anon_sym_function] = ACTIONS(2100),
    [anon_sym_abstract] = ACTIONS(2100),
    [anon_sym_get] = ACTIONS(2100),
    [anon_sym_set] = ACTIONS(2100),
    [anon_sym_new] = ACTIONS(2100),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_SLASH] = ACTIONS(2100),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_TILDE] = ACTIONS(2098),
    [anon_sym_void] = ACTIONS(2100),
    [anon_sym_delete] = ACTIONS(2100),
    [anon_sym_PLUS_PLUS] = ACTIONS(2098),
    [anon_sym_DASH_DASH] = ACTIONS(2098),
    [anon_sym_DQUOTE] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2098),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(2100),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2100),
    [anon_sym_public] = ACTIONS(2100),
    [anon_sym_private] = ACTIONS(2100),
    [anon_sym_protected] = ACTIONS(2100),
    [anon_sym_any] = ACTIONS(2100),
    [anon_sym_number] = ACTIONS(2100),
    [anon_sym_boolean] = ACTIONS(2100),
    [anon_sym_string] = ACTIONS(2100),
    [anon_sym_symbol] = ACTIONS(2100),
    [sym_readonly] = ACTIONS(2100),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2104),
    [anon_sym_export] = ACTIONS(2104),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_namespace] = ACTIONS(2104),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_typeof] = ACTIONS(2104),
    [anon_sym_type] = ACTIONS(2104),
    [anon_sym_interface] = ACTIONS(2104),
    [anon_sym_declare] = ACTIONS(2104),
    [anon_sym_module] = ACTIONS(2104),
    [anon_sym_import] = ACTIONS(2104),
    [anon_sym_const] = ACTIONS(2104),
    [anon_sym_enum] = ACTIONS(2104),
    [anon_sym_var] = ACTIONS(2104),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_else] = ACTIONS(2104),
    [anon_sym_if] = ACTIONS(2104),
    [anon_sym_switch] = ACTIONS(2104),
    [anon_sym_for] = ACTIONS(2104),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_await] = ACTIONS(2104),
    [anon_sym_while] = ACTIONS(2104),
    [anon_sym_do] = ACTIONS(2104),
    [anon_sym_try] = ACTIONS(2104),
    [anon_sym_with] = ACTIONS(2104),
    [anon_sym_break] = ACTIONS(2104),
    [anon_sym_continue] = ACTIONS(2104),
    [anon_sym_debugger] = ACTIONS(2104),
    [anon_sym_return] = ACTIONS(2104),
    [anon_sym_throw] = ACTIONS(2104),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_case] = ACTIONS(2104),
    [anon_sym_yield] = ACTIONS(2104),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_class] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2104),
    [anon_sym_function] = ACTIONS(2104),
    [anon_sym_abstract] = ACTIONS(2104),
    [anon_sym_get] = ACTIONS(2104),
    [anon_sym_set] = ACTIONS(2104),
    [anon_sym_new] = ACTIONS(2104),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2104),
    [anon_sym_SLASH] = ACTIONS(2104),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_TILDE] = ACTIONS(2102),
    [anon_sym_void] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2104),
    [anon_sym_PLUS_PLUS] = ACTIONS(2102),
    [anon_sym_DASH_DASH] = ACTIONS(2102),
    [anon_sym_DQUOTE] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2102),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(2104),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2104),
    [anon_sym_public] = ACTIONS(2104),
    [anon_sym_private] = ACTIONS(2104),
    [anon_sym_protected] = ACTIONS(2104),
    [anon_sym_any] = ACTIONS(2104),
    [anon_sym_number] = ACTIONS(2104),
    [anon_sym_boolean] = ACTIONS(2104),
    [anon_sym_string] = ACTIONS(2104),
    [anon_sym_symbol] = ACTIONS(2104),
    [sym_readonly] = ACTIONS(2104),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [sym_readonly] = ACTIONS(2108),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2112),
    [anon_sym_export] = ACTIONS(2112),
    [anon_sym_default] = ACTIONS(2112),
    [anon_sym_namespace] = ACTIONS(2112),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_typeof] = ACTIONS(2112),
    [anon_sym_type] = ACTIONS(2112),
    [anon_sym_interface] = ACTIONS(2112),
    [anon_sym_declare] = ACTIONS(2112),
    [anon_sym_module] = ACTIONS(2112),
    [anon_sym_import] = ACTIONS(2112),
    [anon_sym_const] = ACTIONS(2112),
    [anon_sym_enum] = ACTIONS(2112),
    [anon_sym_var] = ACTIONS(2112),
    [anon_sym_let] = ACTIONS(2112),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_else] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(2112),
    [anon_sym_switch] = ACTIONS(2112),
    [anon_sym_for] = ACTIONS(2112),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_await] = ACTIONS(2112),
    [anon_sym_while] = ACTIONS(2112),
    [anon_sym_do] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2112),
    [anon_sym_with] = ACTIONS(2112),
    [anon_sym_break] = ACTIONS(2112),
    [anon_sym_continue] = ACTIONS(2112),
    [anon_sym_debugger] = ACTIONS(2112),
    [anon_sym_return] = ACTIONS(2112),
    [anon_sym_throw] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_yield] = ACTIONS(2112),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_class] = ACTIONS(2112),
    [anon_sym_async] = ACTIONS(2112),
    [anon_sym_function] = ACTIONS(2112),
    [anon_sym_abstract] = ACTIONS(2112),
    [anon_sym_get] = ACTIONS(2112),
    [anon_sym_set] = ACTIONS(2112),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_PLUS] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2112),
    [anon_sym_SLASH] = ACTIONS(2112),
    [anon_sym_LT] = ACTIONS(2110),
    [anon_sym_TILDE] = ACTIONS(2110),
    [anon_sym_void] = ACTIONS(2112),
    [anon_sym_delete] = ACTIONS(2112),
    [anon_sym_PLUS_PLUS] = ACTIONS(2110),
    [anon_sym_DASH_DASH] = ACTIONS(2110),
    [anon_sym_DQUOTE] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2110),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(2112),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(2110),
    [anon_sym_static] = ACTIONS(2112),
    [anon_sym_public] = ACTIONS(2112),
    [anon_sym_private] = ACTIONS(2112),
    [anon_sym_protected] = ACTIONS(2112),
    [anon_sym_any] = ACTIONS(2112),
    [anon_sym_number] = ACTIONS(2112),
    [anon_sym_boolean] = ACTIONS(2112),
    [anon_sym_string] = ACTIONS(2112),
    [anon_sym_symbol] = ACTIONS(2112),
    [sym_readonly] = ACTIONS(2112),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [anon_sym_export] = ACTIONS(2116),
    [anon_sym_default] = ACTIONS(2116),
    [anon_sym_namespace] = ACTIONS(2116),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_typeof] = ACTIONS(2116),
    [anon_sym_type] = ACTIONS(2116),
    [anon_sym_interface] = ACTIONS(2116),
    [anon_sym_declare] = ACTIONS(2116),
    [anon_sym_module] = ACTIONS(2116),
    [anon_sym_import] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_enum] = ACTIONS(2116),
    [anon_sym_var] = ACTIONS(2116),
    [anon_sym_let] = ACTIONS(2116),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_else] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(2116),
    [anon_sym_switch] = ACTIONS(2116),
    [anon_sym_for] = ACTIONS(2116),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_await] = ACTIONS(2116),
    [anon_sym_while] = ACTIONS(2116),
    [anon_sym_do] = ACTIONS(2116),
    [anon_sym_try] = ACTIONS(2116),
    [anon_sym_with] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2116),
    [anon_sym_continue] = ACTIONS(2116),
    [anon_sym_debugger] = ACTIONS(2116),
    [anon_sym_return] = ACTIONS(2116),
    [anon_sym_throw] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_case] = ACTIONS(2116),
    [anon_sym_yield] = ACTIONS(2116),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_class] = ACTIONS(2116),
    [anon_sym_async] = ACTIONS(2116),
    [anon_sym_function] = ACTIONS(2116),
    [anon_sym_abstract] = ACTIONS(2116),
    [anon_sym_get] = ACTIONS(2116),
    [anon_sym_set] = ACTIONS(2116),
    [anon_sym_new] = ACTIONS(2116),
    [anon_sym_PLUS] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_SLASH] = ACTIONS(2116),
    [anon_sym_LT] = ACTIONS(2114),
    [anon_sym_TILDE] = ACTIONS(2114),
    [anon_sym_void] = ACTIONS(2116),
    [anon_sym_delete] = ACTIONS(2116),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2114),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(2116),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(2114),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_public] = ACTIONS(2116),
    [anon_sym_private] = ACTIONS(2116),
    [anon_sym_protected] = ACTIONS(2116),
    [anon_sym_any] = ACTIONS(2116),
    [anon_sym_number] = ACTIONS(2116),
    [anon_sym_boolean] = ACTIONS(2116),
    [anon_sym_string] = ACTIONS(2116),
    [anon_sym_symbol] = ACTIONS(2116),
    [sym_readonly] = ACTIONS(2116),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_export] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_namespace] = ACTIONS(2120),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_typeof] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_interface] = ACTIONS(2120),
    [anon_sym_declare] = ACTIONS(2120),
    [anon_sym_module] = ACTIONS(2120),
    [anon_sym_import] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
    [anon_sym_var] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_else] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_switch] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_await] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_do] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [anon_sym_with] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_debugger] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_throw] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_case] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_class] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_function] = ACTIONS(2120),
    [anon_sym_abstract] = ACTIONS(2120),
    [anon_sym_get] = ACTIONS(2120),
    [anon_sym_set] = ACTIONS(2120),
    [anon_sym_new] = ACTIONS(2120),
    [anon_sym_PLUS] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2120),
    [anon_sym_SLASH] = ACTIONS(2120),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_void] = ACTIONS(2120),
    [anon_sym_delete] = ACTIONS(2120),
    [anon_sym_PLUS_PLUS] = ACTIONS(2118),
    [anon_sym_DASH_DASH] = ACTIONS(2118),
    [anon_sym_DQUOTE] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2118),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_public] = ACTIONS(2120),
    [anon_sym_private] = ACTIONS(2120),
    [anon_sym_protected] = ACTIONS(2120),
    [anon_sym_any] = ACTIONS(2120),
    [anon_sym_number] = ACTIONS(2120),
    [anon_sym_boolean] = ACTIONS(2120),
    [anon_sym_string] = ACTIONS(2120),
    [anon_sym_symbol] = ACTIONS(2120),
    [sym_readonly] = ACTIONS(2120),
  },
  [620] = {
    [sym_object] = STATE(2441),
    [sym_array] = STATE(2406),
    [sym_nested_identifier] = STATE(3142),
    [sym_string] = STATE(443),
    [sym__number] = STATE(443),
    [sym_formal_parameters] = STATE(3141),
    [sym__type] = STATE(2620),
    [sym__primary_type] = STATE(2611),
    [sym_parenthesized_type] = STATE(2611),
    [sym_predefined_type] = STATE(2611),
    [sym_nested_type_identifier] = STATE(1915),
    [sym_generic_type] = STATE(2611),
    [sym_object_type] = STATE(2611),
    [sym_array_type] = STATE(2611),
    [sym_tuple_type] = STATE(2611),
    [sym__tuple_type_body] = STATE(433),
    [sym_flow_maybe_type] = STATE(2611),
    [sym_type_query] = STATE(2611),
    [sym_index_type_query] = STATE(2611),
    [sym_existential_type] = STATE(2611),
    [sym_literal_type] = STATE(2611),
    [sym_lookup_type] = STATE(2611),
    [sym_conditional_type] = STATE(2611),
    [sym_union_type] = STATE(2620),
    [sym_intersection_type] = STATE(2620),
    [sym_function_type] = STATE(2620),
    [sym_type_parameters] = STATE(2862),
    [sym_constructor_type] = STATE(2620),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_export] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(432),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(708),
    [anon_sym_declare] = ACTIONS(708),
    [anon_sym_module] = ACTIONS(708),
    [anon_sym_COLON] = ACTIONS(1697),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_async] = ACTIONS(708),
    [anon_sym_get] = ACTIONS(708),
    [anon_sym_set] = ACTIONS(708),
    [anon_sym_QMARK] = ACTIONS(460),
    [anon_sym_new] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(468),
    [anon_sym_PLUS] = ACTIONS(1674),
    [anon_sym_DASH] = ACTIONS(1674),
    [anon_sym_LT] = ACTIONS(1676),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(756),
    [sym_this] = ACTIONS(758),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_protected] = ACTIONS(708),
    [anon_sym_any] = ACTIONS(708),
    [anon_sym_number] = ACTIONS(762),
    [anon_sym_boolean] = ACTIONS(762),
    [anon_sym_string] = ACTIONS(762),
    [anon_sym_symbol] = ACTIONS(762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(498),
    [sym_readonly] = ACTIONS(764),
    [anon_sym_keyof] = ACTIONS(502),
  },
  [621] = {
    [sym_identifier] = ACTIONS(2122),
    [anon_sym_export] = ACTIONS(2122),
    [anon_sym_namespace] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2124),
    [anon_sym_typeof] = ACTIONS(2122),
    [anon_sym_type] = ACTIONS(2122),
    [anon_sym_interface] = ACTIONS(2122),
    [anon_sym_declare] = ACTIONS(2122),
    [anon_sym_module] = ACTIONS(2122),
    [anon_sym_import] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_var] = ACTIONS(2122),
    [anon_sym_let] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_if] = ACTIONS(2122),
    [anon_sym_switch] = ACTIONS(2122),
    [anon_sym_for] = ACTIONS(2122),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_await] = ACTIONS(2122),
    [anon_sym_while] = ACTIONS(2122),
    [anon_sym_do] = ACTIONS(2122),
    [anon_sym_try] = ACTIONS(2122),
    [anon_sym_with] = ACTIONS(2122),
    [anon_sym_break] = ACTIONS(2122),
    [anon_sym_continue] = ACTIONS(2122),
    [anon_sym_debugger] = ACTIONS(2122),
    [anon_sym_return] = ACTIONS(2122),
    [anon_sym_throw] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2124),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_async] = ACTIONS(2122),
    [anon_sym_function] = ACTIONS(2122),
    [anon_sym_abstract] = ACTIONS(2122),
    [anon_sym_get] = ACTIONS(2122),
    [anon_sym_set] = ACTIONS(2122),
    [anon_sym_new] = ACTIONS(2122),
    [anon_sym_PLUS] = ACTIONS(2122),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_SLASH] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_void] = ACTIONS(2122),
    [anon_sym_delete] = ACTIONS(2122),
    [anon_sym_PLUS_PLUS] = ACTIONS(2124),
    [anon_sym_DASH_DASH] = ACTIONS(2124),
    [anon_sym_DQUOTE] = ACTIONS(2124),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2124),
    [sym_number] = ACTIONS(2124),
    [sym_this] = ACTIONS(2122),
    [sym_super] = ACTIONS(2122),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [sym_null] = ACTIONS(2122),
    [anon_sym_AT] = ACTIONS(2124),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_public] = ACTIONS(2122),
    [anon_sym_private] = ACTIONS(2122),
    [anon_sym_protected] = ACTIONS(2122),
    [anon_sym_any] = ACTIONS(2122),
    [anon_sym_number] = ACTIONS(2122),
    [anon_sym_boolean] = ACTIONS(2122),
    [anon_sym_string] = ACTIONS(2122),
    [anon_sym_symbol] = ACTIONS(2122),
    [sym_readonly] = ACTIONS(2122),
  },
  [622] = {
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2128),
    [anon_sym_DASH_DASH] = ACTIONS(2128),
    [anon_sym_DQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2128),
    [sym_number] = ACTIONS(2128),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2128),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [sym_readonly] = ACTIONS(2126),
  },
  [623] = {
    [sym_identifier] = ACTIONS(2130),
    [anon_sym_export] = ACTIONS(2130),
    [anon_sym_namespace] = ACTIONS(2130),
    [anon_sym_LBRACE] = ACTIONS(2132),
    [anon_sym_typeof] = ACTIONS(2130),
    [anon_sym_type] = ACTIONS(2130),
    [anon_sym_interface] = ACTIONS(2130),
    [anon_sym_declare] = ACTIONS(2130),
    [anon_sym_module] = ACTIONS(2130),
    [anon_sym_import] = ACTIONS(2130),
    [anon_sym_const] = ACTIONS(2130),
    [anon_sym_enum] = ACTIONS(2130),
    [anon_sym_var] = ACTIONS(2130),
    [anon_sym_let] = ACTIONS(2130),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(2130),
    [anon_sym_switch] = ACTIONS(2130),
    [anon_sym_for] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2132),
    [anon_sym_await] = ACTIONS(2130),
    [anon_sym_while] = ACTIONS(2130),
    [anon_sym_do] = ACTIONS(2130),
    [anon_sym_try] = ACTIONS(2130),
    [anon_sym_with] = ACTIONS(2130),
    [anon_sym_break] = ACTIONS(2130),
    [anon_sym_continue] = ACTIONS(2130),
    [anon_sym_debugger] = ACTIONS(2130),
    [anon_sym_return] = ACTIONS(2130),
    [anon_sym_throw] = ACTIONS(2130),
    [anon_sym_SEMI] = ACTIONS(2132),
    [anon_sym_yield] = ACTIONS(2130),
    [anon_sym_LBRACK] = ACTIONS(2132),
    [anon_sym_class] = ACTIONS(2130),
    [anon_sym_async] = ACTIONS(2130),
    [anon_sym_function] = ACTIONS(2130),
    [anon_sym_abstract] = ACTIONS(2130),
    [anon_sym_get] = ACTIONS(2130),
    [anon_sym_set] = ACTIONS(2130),
    [anon_sym_new] = ACTIONS(2130),
    [anon_sym_PLUS] = ACTIONS(2130),
    [anon_sym_DASH] = ACTIONS(2130),
    [anon_sym_SLASH] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2132),
    [anon_sym_void] = ACTIONS(2130),
    [anon_sym_delete] = ACTIONS(2130),
    [anon_sym_PLUS_PLUS] = ACTIONS(2132),
    [anon_sym_DASH_DASH] = ACTIONS(2132),
    [anon_sym_DQUOTE] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2132),
    [sym_number] = ACTIONS(2132),
    [sym_this] = ACTIONS(2130),
    [sym_super] = ACTIONS(2130),
    [sym_true] = ACTIONS(2130),
    [sym_false] = ACTIONS(2130),
    [sym_null] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(2132),
    [anon_sym_static] = ACTIONS(2130),
    [anon_sym_public] = ACTIONS(2130),
    [anon_sym_private] = ACTIONS(2130),
    [anon_sym_protected] = ACTIONS(2130),
    [anon_sym_any] = ACTIONS(2130),
    [anon_sym_number] = ACTIONS(2130),
    [anon_sym_boolean] = ACTIONS(2130),
    [anon_sym_string] = ACTIONS(2130),
    [anon_sym_symbol] = ACTIONS(2130),
    [sym_readonly] = ACTIONS(2130),
  },
  [624] = {
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_export] = ACTIONS(2134),
    [anon_sym_namespace] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2136),
    [anon_sym_typeof] = ACTIONS(2134),
    [anon_sym_type] = ACTIONS(2134),
    [anon_sym_interface] = ACTIONS(2134),
    [anon_sym_declare] = ACTIONS(2134),
    [anon_sym_module] = ACTIONS(2134),
    [anon_sym_import] = ACTIONS(2134),
    [anon_sym_const] = ACTIONS(2134),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_var] = ACTIONS(2134),
    [anon_sym_let] = ACTIONS(2134),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2134),
    [anon_sym_switch] = ACTIONS(2134),
    [anon_sym_for] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2136),
    [anon_sym_await] = ACTIONS(2134),
    [anon_sym_while] = ACTIONS(2134),
    [anon_sym_do] = ACTIONS(2134),
    [anon_sym_try] = ACTIONS(2134),
    [anon_sym_with] = ACTIONS(2134),
    [anon_sym_break] = ACTIONS(2134),
    [anon_sym_continue] = ACTIONS(2134),
    [anon_sym_debugger] = ACTIONS(2134),
    [anon_sym_return] = ACTIONS(2134),
    [anon_sym_throw] = ACTIONS(2134),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2134),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_class] = ACTIONS(2134),
    [anon_sym_async] = ACTIONS(2134),
    [anon_sym_function] = ACTIONS(2134),
    [anon_sym_abstract] = ACTIONS(2134),
    [anon_sym_get] = ACTIONS(2134),
    [anon_sym_set] = ACTIONS(2134),
    [anon_sym_new] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2136),
    [anon_sym_void] = ACTIONS(2134),
    [anon_sym_delete] = ACTIONS(2134),
    [anon_sym_PLUS_PLUS] = ACTIONS(2136),
    [anon_sym_DASH_DASH] = ACTIONS(2136),
    [anon_sym_DQUOTE] = ACTIONS(2136),
    [anon_sym_SQUOTE] = ACTIONS(2136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2136),
    [sym_number] = ACTIONS(2136),
    [sym_this] = ACTIONS(2134),
    [sym_super] = ACTIONS(2134),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [sym_null] = ACTIONS(2134),
    [anon_sym_AT] = ACTIONS(2136),
    [anon_sym_static] = ACTIONS(2134),
    [anon_sym_public] = ACTIONS(2134),
    [anon_sym_private] = ACTIONS(2134),
    [anon_sym_protected] = ACTIONS(2134),
    [anon_sym_any] = ACTIONS(2134),
    [anon_sym_number] = ACTIONS(2134),
    [anon_sym_boolean] = ACTIONS(2134),
    [anon_sym_string] = ACTIONS(2134),
    [anon_sym_symbol] = ACTIONS(2134),
    [sym_readonly] = ACTIONS(2134),
  },
  [625] = {
    [sym_identifier] = ACTIONS(2138),
    [anon_sym_export] = ACTIONS(2138),
    [anon_sym_namespace] = ACTIONS(2138),
    [anon_sym_LBRACE] = ACTIONS(2140),
    [anon_sym_typeof] = ACTIONS(2138),
    [anon_sym_type] = ACTIONS(2138),
    [anon_sym_interface] = ACTIONS(2138),
    [anon_sym_declare] = ACTIONS(2138),
    [anon_sym_module] = ACTIONS(2138),
    [anon_sym_import] = ACTIONS(2138),
    [anon_sym_const] = ACTIONS(2138),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_var] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(2138),
    [anon_sym_BANG] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(2138),
    [anon_sym_switch] = ACTIONS(2138),
    [anon_sym_for] = ACTIONS(2138),
    [anon_sym_LPAREN] = ACTIONS(2140),
    [anon_sym_await] = ACTIONS(2138),
    [anon_sym_while] = ACTIONS(2138),
    [anon_sym_do] = ACTIONS(2138),
    [anon_sym_try] = ACTIONS(2138),
    [anon_sym_with] = ACTIONS(2138),
    [anon_sym_break] = ACTIONS(2138),
    [anon_sym_continue] = ACTIONS(2138),
    [anon_sym_debugger] = ACTIONS(2138),
    [anon_sym_return] = ACTIONS(2138),
    [anon_sym_throw] = ACTIONS(2138),
    [anon_sym_SEMI] = ACTIONS(2140),
    [anon_sym_yield] = ACTIONS(2138),
    [anon_sym_LBRACK] = ACTIONS(2140),
    [anon_sym_class] = ACTIONS(2138),
    [anon_sym_async] = ACTIONS(2138),
    [anon_sym_function] = ACTIONS(2138),
    [anon_sym_abstract] = ACTIONS(2138),
    [anon_sym_get] = ACTIONS(2138),
    [anon_sym_set] = ACTIONS(2138),
    [anon_sym_new] = ACTIONS(2138),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_DASH] = ACTIONS(2138),
    [anon_sym_SLASH] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2140),
    [anon_sym_TILDE] = ACTIONS(2140),
    [anon_sym_void] = ACTIONS(2138),
    [anon_sym_delete] = ACTIONS(2138),
    [anon_sym_PLUS_PLUS] = ACTIONS(2140),
    [anon_sym_DASH_DASH] = ACTIONS(2140),
    [anon_sym_DQUOTE] = ACTIONS(2140),
    [anon_sym_SQUOTE] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2140),
    [sym_number] = ACTIONS(2140),
    [sym_this] = ACTIONS(2138),
    [sym_super] = ACTIONS(2138),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(2140),
    [anon_sym_static] = ACTIONS(2138),
    [anon_sym_public] = ACTIONS(2138),
    [anon_sym_private] = ACTIONS(2138),
    [anon_sym_protected] = ACTIONS(2138),
    [anon_sym_any] = ACTIONS(2138),
    [anon_sym_number] = ACTIONS(2138),
    [anon_sym_boolean] = ACTIONS(2138),
    [anon_sym_string] = ACTIONS(2138),
    [anon_sym_symbol] = ACTIONS(2138),
    [sym_readonly] = ACTIONS(2138),
  },
  [626] = {
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2144),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2144),
    [anon_sym_DASH_DASH] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2144),
    [sym_number] = ACTIONS(2144),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2144),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [sym_readonly] = ACTIONS(2142),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2146),
    [anon_sym_export] = ACTIONS(2146),
    [anon_sym_namespace] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2148),
    [anon_sym_typeof] = ACTIONS(2146),
    [anon_sym_type] = ACTIONS(2146),
    [anon_sym_interface] = ACTIONS(2146),
    [anon_sym_declare] = ACTIONS(2146),
    [anon_sym_module] = ACTIONS(2146),
    [anon_sym_import] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_var] = ACTIONS(2146),
    [anon_sym_let] = ACTIONS(2146),
    [anon_sym_BANG] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_await] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_do] = ACTIONS(2146),
    [anon_sym_try] = ACTIONS(2146),
    [anon_sym_with] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_debugger] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_throw] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_yield] = ACTIONS(2146),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_class] = ACTIONS(2146),
    [anon_sym_async] = ACTIONS(2146),
    [anon_sym_function] = ACTIONS(2146),
    [anon_sym_abstract] = ACTIONS(2146),
    [anon_sym_get] = ACTIONS(2146),
    [anon_sym_set] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2148),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_void] = ACTIONS(2146),
    [anon_sym_delete] = ACTIONS(2146),
    [anon_sym_PLUS_PLUS] = ACTIONS(2148),
    [anon_sym_DASH_DASH] = ACTIONS(2148),
    [anon_sym_DQUOTE] = ACTIONS(2148),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2148),
    [sym_number] = ACTIONS(2148),
    [sym_this] = ACTIONS(2146),
    [sym_super] = ACTIONS(2146),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [anon_sym_AT] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2146),
    [anon_sym_private] = ACTIONS(2146),
    [anon_sym_protected] = ACTIONS(2146),
    [anon_sym_any] = ACTIONS(2146),
    [anon_sym_number] = ACTIONS(2146),
    [anon_sym_boolean] = ACTIONS(2146),
    [anon_sym_string] = ACTIONS(2146),
    [anon_sym_symbol] = ACTIONS(2146),
    [sym_readonly] = ACTIONS(2146),
  },
  [628] = {
    [sym_identifier] = ACTIONS(2150),
    [anon_sym_export] = ACTIONS(2150),
    [anon_sym_namespace] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2150),
    [anon_sym_type] = ACTIONS(2150),
    [anon_sym_interface] = ACTIONS(2150),
    [anon_sym_declare] = ACTIONS(2150),
    [anon_sym_module] = ACTIONS(2150),
    [anon_sym_import] = ACTIONS(2150),
    [anon_sym_const] = ACTIONS(2150),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_var] = ACTIONS(2150),
    [anon_sym_let] = ACTIONS(2150),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2150),
    [anon_sym_switch] = ACTIONS(2150),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2150),
    [anon_sym_while] = ACTIONS(2150),
    [anon_sym_do] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2150),
    [anon_sym_with] = ACTIONS(2150),
    [anon_sym_break] = ACTIONS(2150),
    [anon_sym_continue] = ACTIONS(2150),
    [anon_sym_debugger] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(2150),
    [anon_sym_throw] = ACTIONS(2150),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2150),
    [anon_sym_async] = ACTIONS(2150),
    [anon_sym_function] = ACTIONS(2150),
    [anon_sym_abstract] = ACTIONS(2150),
    [anon_sym_get] = ACTIONS(2150),
    [anon_sym_set] = ACTIONS(2150),
    [anon_sym_new] = ACTIONS(2150),
    [anon_sym_PLUS] = ACTIONS(2150),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2150),
    [anon_sym_delete] = ACTIONS(2150),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_this] = ACTIONS(2150),
    [sym_super] = ACTIONS(2150),
    [sym_true] = ACTIONS(2150),
    [sym_false] = ACTIONS(2150),
    [sym_null] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2150),
    [anon_sym_public] = ACTIONS(2150),
    [anon_sym_private] = ACTIONS(2150),
    [anon_sym_protected] = ACTIONS(2150),
    [anon_sym_any] = ACTIONS(2150),
    [anon_sym_number] = ACTIONS(2150),
    [anon_sym_boolean] = ACTIONS(2150),
    [anon_sym_string] = ACTIONS(2150),
    [anon_sym_symbol] = ACTIONS(2150),
    [sym_readonly] = ACTIONS(2150),
  },
  [629] = {
    [sym_identifier] = ACTIONS(2154),
    [anon_sym_export] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(2154),
    [anon_sym_type] = ACTIONS(2154),
    [anon_sym_interface] = ACTIONS(2154),
    [anon_sym_declare] = ACTIONS(2154),
    [anon_sym_module] = ACTIONS(2154),
    [anon_sym_import] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_var] = ACTIONS(2154),
    [anon_sym_let] = ACTIONS(2154),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(2154),
    [anon_sym_switch] = ACTIONS(2154),
    [anon_sym_for] = ACTIONS(2154),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_await] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2154),
    [anon_sym_do] = ACTIONS(2154),
    [anon_sym_try] = ACTIONS(2154),
    [anon_sym_with] = ACTIONS(2154),
    [anon_sym_break] = ACTIONS(2154),
    [anon_sym_continue] = ACTIONS(2154),
    [anon_sym_debugger] = ACTIONS(2154),
    [anon_sym_return] = ACTIONS(2154),
    [anon_sym_throw] = ACTIONS(2154),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym_yield] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_async] = ACTIONS(2154),
    [anon_sym_function] = ACTIONS(2154),
    [anon_sym_abstract] = ACTIONS(2154),
    [anon_sym_get] = ACTIONS(2154),
    [anon_sym_set] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_SLASH] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_void] = ACTIONS(2154),
    [anon_sym_delete] = ACTIONS(2154),
    [anon_sym_PLUS_PLUS] = ACTIONS(2156),
    [anon_sym_DASH_DASH] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2156),
    [sym_number] = ACTIONS(2156),
    [sym_this] = ACTIONS(2154),
    [sym_super] = ACTIONS(2154),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [sym_null] = ACTIONS(2154),
    [anon_sym_AT] = ACTIONS(2156),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_public] = ACTIONS(2154),
    [anon_sym_private] = ACTIONS(2154),
    [anon_sym_protected] = ACTIONS(2154),
    [anon_sym_any] = ACTIONS(2154),
    [anon_sym_number] = ACTIONS(2154),
    [anon_sym_boolean] = ACTIONS(2154),
    [anon_sym_string] = ACTIONS(2154),
    [anon_sym_symbol] = ACTIONS(2154),
    [sym_readonly] = ACTIONS(2154),
  },
  [630] = {
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_export] = ACTIONS(2158),
    [anon_sym_namespace] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2158),
    [anon_sym_type] = ACTIONS(2158),
    [anon_sym_interface] = ACTIONS(2158),
    [anon_sym_declare] = ACTIONS(2158),
    [anon_sym_module] = ACTIONS(2158),
    [anon_sym_import] = ACTIONS(2158),
    [anon_sym_const] = ACTIONS(2158),
    [anon_sym_enum] = ACTIONS(2158),
    [anon_sym_var] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_switch] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_break] = ACTIONS(2158),
    [anon_sym_continue] = ACTIONS(2158),
    [anon_sym_debugger] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_throw] = ACTIONS(2158),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2158),
    [anon_sym_async] = ACTIONS(2158),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_abstract] = ACTIONS(2158),
    [anon_sym_get] = ACTIONS(2158),
    [anon_sym_set] = ACTIONS(2158),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_SLASH] = ACTIONS(2158),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2158),
    [anon_sym_delete] = ACTIONS(2158),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_this] = ACTIONS(2158),
    [sym_super] = ACTIONS(2158),
    [sym_true] = ACTIONS(2158),
    [sym_false] = ACTIONS(2158),
    [sym_null] = ACTIONS(2158),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_public] = ACTIONS(2158),
    [anon_sym_private] = ACTIONS(2158),
    [anon_sym_protected] = ACTIONS(2158),
    [anon_sym_any] = ACTIONS(2158),
    [anon_sym_number] = ACTIONS(2158),
    [anon_sym_boolean] = ACTIONS(2158),
    [anon_sym_string] = ACTIONS(2158),
    [anon_sym_symbol] = ACTIONS(2158),
    [sym_readonly] = ACTIONS(2158),
  },
  [631] = {
    [sym_nested_identifier] = STATE(1018),
    [sym__module] = STATE(1171),
    [sym_string] = STATE(1029),
    [sym_arguments] = STATE(1152),
    [sym_type_arguments] = STATE(1061),
    [sym_identifier] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_DOT] = ACTIONS(1626),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(2164),
    [anon_sym_RPAREN] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1628),
    [anon_sym_RBRACK] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(734),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
  },
  [632] = {
    [sym_nested_identifier] = STATE(515),
    [sym__module] = STATE(546),
    [sym_string] = STATE(534),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [633] = {
    [sym_nested_identifier] = STATE(515),
    [sym__module] = STATE(546),
    [sym_string] = STATE(534),
    [aux_sym_object_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [634] = {
    [sym_nested_identifier] = STATE(67),
    [sym__module] = STATE(93),
    [sym_string] = STATE(66),
    [aux_sym_object_repeat1] = STATE(2757),
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [635] = {
    [sym_nested_identifier] = STATE(515),
    [sym__module] = STATE(546),
    [sym_string] = STATE(534),
    [aux_sym_object_repeat1] = STATE(2757),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(752),
    [anon_sym_SQUOTE] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [636] = {
    [sym_nested_identifier] = STATE(67),
    [sym__module] = STATE(93),
    [sym_string] = STATE(66),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [637] = {
    [sym_nested_identifier] = STATE(67),
    [sym__module] = STATE(93),
    [sym_string] = STATE(66),
    [aux_sym_object_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(748),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_COLON] = ACTIONS(1212),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(715),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_GT_GT_GT] = ACTIONS(715),
    [anon_sym_LT_LT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(715),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_SLASH] = ACTIONS(715),
    [anon_sym_PERCENT] = ACTIONS(715),
    [anon_sym_STAR_STAR] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(1238),
    [anon_sym_LT_EQ] = ACTIONS(748),
    [anon_sym_EQ_EQ] = ACTIONS(715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(748),
    [anon_sym_BANG_EQ] = ACTIONS(715),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(748),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_QMARK_QMARK] = ACTIONS(715),
    [anon_sym_instanceof] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(748),
    [anon_sym_DASH_DASH] = ACTIONS(748),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(748),
    [sym__automatic_semicolon] = ACTIONS(748),
  },
  [638] = {
    [sym_nested_identifier] = STATE(1018),
    [sym__module] = STATE(1171),
    [sym_string] = STATE(1029),
    [sym_arguments] = STATE(1591),
    [sym_type_arguments] = STATE(1371),
    [sym_identifier] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(1622),
    [anon_sym_EQ] = ACTIONS(1118),
    [anon_sym_as] = ACTIONS(1622),
    [anon_sym_COMMA] = ACTIONS(1624),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_DOT] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_LPAREN] = ACTIONS(2176),
    [anon_sym_in] = ACTIONS(1622),
    [anon_sym_SEMI] = ACTIONS(1624),
    [anon_sym_LBRACK] = ACTIONS(1228),
    [anon_sym_EQ_GT] = ACTIONS(972),
    [anon_sym_QMARK] = ACTIONS(1622),
    [anon_sym_QMARK_DOT] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(738),
    [anon_sym_DASH_EQ] = ACTIONS(738),
    [anon_sym_STAR_EQ] = ACTIONS(738),
    [anon_sym_SLASH_EQ] = ACTIONS(738),
    [anon_sym_PERCENT_EQ] = ACTIONS(738),
    [anon_sym_CARET_EQ] = ACTIONS(738),
    [anon_sym_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(738),
    [anon_sym_LT_LT_EQ] = ACTIONS(738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(738),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(738),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1622),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1622),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1622),
    [anon_sym_PLUS] = ACTIONS(1622),
    [anon_sym_DASH] = ACTIONS(1622),
    [anon_sym_SLASH] = ACTIONS(1622),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_LT_EQ] = ACTIONS(1624),
    [anon_sym_EQ_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1624),
    [anon_sym_BANG_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1624),
    [anon_sym_GT_EQ] = ACTIONS(1624),
    [anon_sym_GT] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1622),
    [anon_sym_PLUS_PLUS] = ACTIONS(1624),
    [anon_sym_DASH_DASH] = ACTIONS(1624),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [sym__automatic_semicolon] = ACTIONS(1624),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1124), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1061), 1,
      sym_type_arguments,
    STATE(1152), 1,
      sym_arguments,
    STATE(1171), 1,
      sym__module,
    ACTIONS(1624), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [103] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1140), 1,
      anon_sym_EQ_GT,
    ACTIONS(1142), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1652), 1,
      anon_sym_DOT,
    ACTIONS(1654), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      anon_sym_LT,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    STATE(1619), 1,
      sym_type_arguments,
    STATE(1668), 1,
      sym_arguments,
    ACTIONS(1624), 9,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [206] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(930), 1,
      anon_sym_EQ,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [301] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1128), 1,
      anon_sym_EQ_GT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    STATE(1371), 1,
      sym_type_arguments,
    STATE(1591), 1,
      sym_arguments,
    ACTIONS(1624), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [403] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1061), 1,
      sym_type_arguments,
    STATE(1152), 1,
      sym_arguments,
    STATE(1171), 1,
      sym__module,
    ACTIONS(1624), 9,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [505] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_COLON,
    ACTIONS(2168), 1,
      sym_identifier,
    STATE(515), 1,
      sym_nested_identifier,
    STATE(534), 1,
      sym_string,
    STATE(546), 1,
      sym__module,
    ACTIONS(748), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [601] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_COLON,
    ACTIONS(2184), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_nested_identifier,
    STATE(1040), 1,
      sym_string,
    STATE(1213), 1,
      sym__module,
    ACTIONS(748), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [697] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1692), 1,
      anon_sym_in,
    ACTIONS(1695), 1,
      anon_sym_of,
    ACTIONS(2184), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_nested_identifier,
    STATE(1040), 1,
      sym_string,
    STATE(1213), 1,
      sym__module,
    ACTIONS(748), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [795] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(2184), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_nested_identifier,
    STATE(1040), 1,
      sym_string,
    STATE(1213), 1,
      sym__module,
    ACTIONS(748), 12,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [889] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_COLON,
    ACTIONS(2168), 1,
      sym_identifier,
    STATE(515), 1,
      sym_nested_identifier,
    STATE(534), 1,
      sym_string,
    STATE(546), 1,
      sym__module,
    ACTIONS(748), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [985] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_COLON,
    ACTIONS(2170), 1,
      sym_identifier,
    ACTIONS(2172), 1,
      anon_sym_DQUOTE,
    ACTIONS(2174), 1,
      anon_sym_SQUOTE,
    STATE(66), 1,
      sym_string,
    STATE(67), 1,
      sym_nested_identifier,
    STATE(93), 1,
      sym__module,
    ACTIONS(748), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1081] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1122), 1,
      anon_sym_EQ,
    ACTIONS(1124), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1174] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1134), 1,
      anon_sym_EQ,
    ACTIONS(1140), 1,
      anon_sym_EQ_GT,
    ACTIONS(1142), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1652), 1,
      anon_sym_DOT,
    ACTIONS(1654), 1,
      anon_sym_LBRACK,
    ACTIONS(2186), 1,
      sym_identifier,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1561), 1,
      sym_string,
    STATE(1657), 1,
      sym__module,
    ACTIONS(748), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1267] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(712), 1,
      anon_sym_EQ,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(719), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(748), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1364] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(930), 1,
      anon_sym_EQ,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1716), 1,
      anon_sym_COLON,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1459] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(712), 1,
      anon_sym_EQ,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1697), 1,
      anon_sym_COLON,
    ACTIONS(1699), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(719), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(748), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1558] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1716), 1,
      anon_sym_COLON,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1652] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1744), 1,
      anon_sym_COLON,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1746] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1126), 1,
      anon_sym_EQ,
    ACTIONS(1128), 1,
      anon_sym_EQ_GT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(2184), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_nested_identifier,
    STATE(1040), 1,
      sym_string,
    STATE(1213), 1,
      sym__module,
    ACTIONS(748), 10,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1838] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    STATE(1062), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2192), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2188), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [1924] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 10,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2016] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_extends,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2204), 1,
      anon_sym_COMMA,
    ACTIONS(2207), 1,
      anon_sym_DOT,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(2211), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2105] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2217), 1,
      anon_sym_DOT,
    ACTIONS(2219), 1,
      anon_sym_LT,
    STATE(1994), 1,
      sym_type_arguments,
    ACTIONS(1588), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1586), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [2192] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    STATE(1062), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(2192), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [2279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_extends,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(2226), 3,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2229), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 32,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [2354] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(1238), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(748), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2239), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [2512] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1692), 1,
      anon_sym_in,
    ACTIONS(1695), 1,
      anon_sym_of,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2140), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [2674] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(1238), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(748), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2243), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [2832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2247), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [2899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2144), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [2966] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1749), 1,
      anon_sym_in,
    ACTIONS(1752), 1,
      anon_sym_of,
    ACTIONS(2162), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_nested_identifier,
    STATE(1029), 1,
      sym_string,
    STATE(1171), 1,
      sym__module,
    ACTIONS(748), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3061] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(1238), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(748), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3152] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_extends,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2249), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2232), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 32,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [3227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [3294] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2252), 1,
      anon_sym_EQ,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2258), 1,
      anon_sym_BANG,
    ACTIONS(2260), 1,
      anon_sym_in,
    ACTIONS(2263), 1,
      anon_sym_of,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    STATE(2475), 1,
      sym_type_annotation,
    STATE(2791), 1,
      sym__initializer,
    ACTIONS(2254), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 20,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [3387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2269), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [3454] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    STATE(1061), 1,
      sym_type_arguments,
    STATE(1152), 1,
      sym_arguments,
    ACTIONS(1624), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [3541] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1588), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2275), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [3695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2279), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [3762] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2219), 1,
      anon_sym_LT,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    STATE(1994), 1,
      sym_type_arguments,
    ACTIONS(2204), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2211), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1718), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [3851] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_extends,
    ACTIONS(2204), 1,
      anon_sym_COMMA,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2285), 1,
      anon_sym_DOT,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(2211), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3939] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    STATE(1385), 1,
      sym_type_arguments,
    STATE(1571), 1,
      sym_arguments,
    ACTIONS(2192), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4025] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2295), 1,
      anon_sym_EQ,
    ACTIONS(2297), 1,
      anon_sym_LPAREN,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(2300), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1070), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4113] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(930), 1,
      anon_sym_EQ,
    ACTIONS(1243), 1,
      anon_sym_extends,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_COMMA,
    ACTIONS(2306), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(748), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4197] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    STATE(1371), 1,
      sym_type_arguments,
    STATE(1591), 1,
      sym_arguments,
    ACTIONS(1624), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4283] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(1238), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(748), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4371] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(1238), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(748), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4459] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(1238), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(748), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4547] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(930), 1,
      anon_sym_EQ,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2306), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1243), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(748), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4631] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2309), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1588), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4717] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2295), 1,
      anon_sym_EQ,
    ACTIONS(2297), 1,
      anon_sym_LPAREN,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(2300), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1070), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4805] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_COLON,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2295), 1,
      anon_sym_EQ,
    ACTIONS(2297), 1,
      anon_sym_LPAREN,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(2300), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1070), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [4893] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2313), 1,
      anon_sym_export,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_COMMA,
    ACTIONS(2319), 1,
      anon_sym_RBRACE,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2323), 1,
      anon_sym_SEMI,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2327), 1,
      anon_sym_async,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2341), 1,
      anon_sym_static,
    ACTIONS(2345), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2347), 1,
      sym_readonly,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2673), 1,
      aux_sym_object_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2329), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2343), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2671), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2185), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2311), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5024] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2349), 1,
      anon_sym_EQ_GT,
    STATE(1062), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(2192), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [5109] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_COLON,
    ACTIONS(2235), 1,
      sym_identifier,
    ACTIONS(748), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [5190] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2351), 1,
      anon_sym_EQ,
    ACTIONS(2353), 1,
      anon_sym_DOT,
    ACTIONS(2355), 1,
      anon_sym_EQ_GT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1718), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2211), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5275] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2313), 1,
      anon_sym_export,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_COMMA,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2323), 1,
      anon_sym_SEMI,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2327), 1,
      anon_sym_async,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2341), 1,
      anon_sym_static,
    ACTIONS(2345), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2347), 1,
      sym_readonly,
    ACTIONS(2357), 1,
      anon_sym_RBRACE,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2673), 1,
      aux_sym_object_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2329), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2343), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2671), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2185), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2311), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5406] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_extends,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2359), 1,
      anon_sym_EQ,
    ACTIONS(2365), 1,
      anon_sym_DOT,
    ACTIONS(2367), 1,
      anon_sym_RPAREN,
    ACTIONS(2371), 1,
      anon_sym_QMARK,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(2211), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2362), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [5497] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1070), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [5574] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_COMMA,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2323), 1,
      anon_sym_SEMI,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2345), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2376), 1,
      anon_sym_export,
    ACTIONS(2378), 1,
      anon_sym_RBRACE,
    ACTIONS(2380), 1,
      anon_sym_async,
    ACTIONS(2384), 1,
      anon_sym_static,
    ACTIONS(2388), 1,
      sym_readonly,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2736), 1,
      aux_sym_object_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2382), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2386), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2734), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2185), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2374), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5705] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(2229), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(996), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2226), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2222), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [5778] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2232), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(2249), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1426), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2222), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [5851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(930), 1,
      anon_sym_EQ,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(748), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [5928] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1140), 1,
      anon_sym_EQ_GT,
    ACTIONS(1142), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1652), 1,
      anon_sym_DOT,
    ACTIONS(1654), 1,
      anon_sym_LBRACK,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      anon_sym_LT,
    STATE(1619), 1,
      sym_type_arguments,
    STATE(1668), 1,
      sym_arguments,
    ACTIONS(1624), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [6013] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_COMMA,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2323), 1,
      anon_sym_SEMI,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2345), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2392), 1,
      anon_sym_export,
    ACTIONS(2394), 1,
      anon_sym_RBRACE,
    ACTIONS(2396), 1,
      anon_sym_async,
    ACTIONS(2400), 1,
      anon_sym_static,
    ACTIONS(2404), 1,
      sym_readonly,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2692), 1,
      aux_sym_object_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2398), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2402), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2701), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2185), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2390), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6144] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1124), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    STATE(1061), 1,
      sym_type_arguments,
    STATE(1152), 1,
      sym_arguments,
    ACTIONS(1624), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [6229] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_extends,
    ACTIONS(2204), 1,
      anon_sym_COMMA,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2408), 1,
      anon_sym_DOT,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2412), 1,
      anon_sym_EQ_GT,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(2211), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6316] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2412), 1,
      anon_sym_EQ_GT,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    STATE(1622), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2192), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [6401] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2351), 1,
      anon_sym_EQ,
    ACTIONS(2355), 1,
      anon_sym_EQ_GT,
    ACTIONS(2418), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1588), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6486] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2412), 1,
      anon_sym_EQ_GT,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1588), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6571] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_extends,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2204), 1,
      anon_sym_COMMA,
    ACTIONS(2207), 1,
      anon_sym_DOT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2349), 1,
      anon_sym_EQ_GT,
    ACTIONS(2422), 1,
      anon_sym_EQ,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(2211), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6658] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_COMMA,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2323), 1,
      anon_sym_SEMI,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2345), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2392), 1,
      anon_sym_export,
    ACTIONS(2396), 1,
      anon_sym_async,
    ACTIONS(2400), 1,
      anon_sym_static,
    ACTIONS(2404), 1,
      sym_readonly,
    ACTIONS(2424), 1,
      anon_sym_RBRACE,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2692), 1,
      aux_sym_object_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2398), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2402), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2701), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2185), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2390), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6789] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    ACTIONS(2426), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1718), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2211), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6874] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_COMMA,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2323), 1,
      anon_sym_SEMI,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2345), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2430), 1,
      anon_sym_export,
    ACTIONS(2432), 1,
      anon_sym_RBRACE,
    ACTIONS(2434), 1,
      anon_sym_async,
    ACTIONS(2438), 1,
      anon_sym_static,
    ACTIONS(2442), 1,
      sym_readonly,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2664), 1,
      aux_sym_object_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2436), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2440), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2672), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2185), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2428), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [7005] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      sym_this,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(2444), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(2611), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [7126] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2349), 1,
      anon_sym_EQ_GT,
    ACTIONS(2422), 1,
      anon_sym_EQ,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    ACTIONS(2452), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    STATE(2532), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(2448), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [7213] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2454), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(1588), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [7298] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    ACTIONS(2456), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1588), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7383] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2392), 1,
      anon_sym_export,
    ACTIONS(2396), 1,
      anon_sym_async,
    ACTIONS(2400), 1,
      anon_sym_static,
    ACTIONS(2404), 1,
      sym_readonly,
    ACTIONS(2458), 1,
      anon_sym_COMMA,
    ACTIONS(2460), 1,
      anon_sym_RBRACE,
    ACTIONS(2462), 1,
      anon_sym_SEMI,
    ACTIONS(2464), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2692), 1,
      aux_sym_object_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2398), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2402), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2701), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2157), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2390), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [7514] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1243), 1,
      anon_sym_extends,
    ACTIONS(2303), 1,
      anon_sym_COMMA,
    ACTIONS(2306), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(748), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7597] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2412), 1,
      anon_sym_EQ_GT,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2448), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2466), 1,
      anon_sym_LBRACE,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2552), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2709), 1,
      sym_type_arguments,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [7686] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_DOT,
    ACTIONS(2349), 1,
      anon_sym_EQ_GT,
    ACTIONS(2422), 1,
      anon_sym_EQ,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1588), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7771] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_COLON,
    ACTIONS(2235), 1,
      sym_identifier,
    ACTIONS(748), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7852] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    STATE(1385), 1,
      sym_type_arguments,
    STATE(1571), 1,
      sym_arguments,
    ACTIONS(2192), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [7935] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    STATE(1622), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2192), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2247), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8081] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2412), 1,
      anon_sym_EQ_GT,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2475), 1,
      anon_sym_LBRACE,
    STATE(2709), 1,
      sym_type_arguments,
    ACTIONS(2477), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8165] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2214), 1,
      anon_sym_LT,
    ACTIONS(2349), 1,
      anon_sym_EQ_GT,
    ACTIONS(2422), 1,
      anon_sym_EQ,
    ACTIONS(2452), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(2477), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8247] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(712), 1,
      anon_sym_EQ,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1243), 1,
      anon_sym_extends,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_QMARK,
    ACTIONS(2479), 1,
      anon_sym_RPAREN,
    ACTIONS(719), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2306), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(748), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8333] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2486), 1,
      anon_sym_COLON,
    ACTIONS(2483), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8413] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1128), 1,
      anon_sym_EQ_GT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    STATE(1371), 1,
      sym_type_arguments,
    STATE(1591), 1,
      sym_arguments,
    ACTIONS(1624), 11,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2239), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8561] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(748), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8637] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1692), 1,
      anon_sym_in,
    ACTIONS(2488), 1,
      anon_sym_of,
    ACTIONS(748), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8717] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2355), 1,
      anon_sym_EQ_GT,
    STATE(1385), 1,
      sym_type_arguments,
    STATE(1571), 1,
      sym_arguments,
    ACTIONS(2192), 11,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8801] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1126), 1,
      anon_sym_EQ,
    ACTIONS(1128), 1,
      anon_sym_EQ_GT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1243), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2306), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(748), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8881] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1271), 1,
      anon_sym_COLON,
    ACTIONS(748), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [8959] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1243), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2306), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(748), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9039] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    STATE(1061), 1,
      sym_type_arguments,
    STATE(1152), 1,
      sym_arguments,
    ACTIONS(1624), 11,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1622), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [9123] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_extends,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2249), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2232), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(1070), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [9269] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2490), 1,
      anon_sym_in,
    ACTIONS(2493), 1,
      anon_sym_of,
    ACTIONS(1070), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [9349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2275), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9413] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1122), 1,
      anon_sym_EQ,
    ACTIONS(1124), 1,
      anon_sym_EQ_GT,
    ACTIONS(1243), 1,
      anon_sym_extends,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_COMMA,
    ACTIONS(2306), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(748), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [9563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2279), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2140), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2269), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2243), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9819] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1261), 1,
      anon_sym_COLON,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1070), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [9897] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_extends,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(2226), 3,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2229), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1070), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [10109] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_EQ,
    ACTIONS(972), 1,
      anon_sym_EQ_GT,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_COLON,
    ACTIONS(748), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [10187] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    STATE(1062), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(2192), 11,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2188), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [10271] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 1,
      anon_sym_COLON,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1070), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [10349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2144), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10413] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      anon_sym_EQ,
    ACTIONS(1140), 1,
      anon_sym_EQ_GT,
    ACTIONS(1142), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1243), 1,
      anon_sym_extends,
    ACTIONS(1652), 1,
      anon_sym_DOT,
    ACTIONS(1654), 1,
      anon_sym_LBRACK,
    ACTIONS(2303), 1,
      anon_sym_COMMA,
    ACTIONS(2306), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(748), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10495] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2495), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [10573] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2497), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [10651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2249), 1,
      anon_sym_LBRACK,
    ACTIONS(1426), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2232), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 28,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10722] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2490), 1,
      anon_sym_in,
    ACTIONS(2493), 1,
      anon_sym_of,
    ACTIONS(1070), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [10799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_extends,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2249), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2232), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
    ACTIONS(2222), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10870] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2499), 1,
      sym_identifier,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2517), 1,
      sym_this,
    ACTIONS(2521), 1,
      anon_sym_asserts,
    ACTIONS(2523), 1,
      sym_readonly,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2225), 1,
      sym_type_predicate,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2016), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [10991] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2359), 1,
      anon_sym_EQ,
    ACTIONS(2371), 1,
      anon_sym_QMARK,
    ACTIONS(2525), 1,
      anon_sym_COLON,
    ACTIONS(2362), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11072] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2349), 1,
      anon_sym_EQ_GT,
    ACTIONS(2422), 1,
      anon_sym_EQ,
    ACTIONS(1070), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11147] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2412), 1,
      anon_sym_EQ_GT,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11222] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(712), 1,
      anon_sym_EQ,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1697), 1,
      anon_sym_COLON,
    ACTIONS(1699), 1,
      anon_sym_QMARK,
    ACTIONS(719), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(748), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11303] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(1504), 1,
      sym_template_string,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1379), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11424] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2490), 1,
      anon_sym_in,
    ACTIONS(2493), 1,
      anon_sym_of,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1070), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11495] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1122), 1,
      anon_sym_EQ,
    ACTIONS(1124), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(748), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11570] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2563), 1,
      anon_sym_COLON,
    ACTIONS(2565), 1,
      anon_sym_in,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [11649] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2567), 1,
      sym_identifier,
    ACTIONS(2569), 1,
      sym_this,
    ACTIONS(2571), 1,
      anon_sym_asserts,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(2969), 1,
      sym_type_predicate,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2054), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11770] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(1121), 1,
      sym_template_string,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1070), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [11891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2249), 1,
      anon_sym_LBRACK,
    ACTIONS(1426), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2232), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11962] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(996), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2226), 2,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2229), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 28,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_extends,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(2229), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2226), 3,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2222), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12104] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(996), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2226), 2,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2229), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2222), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12175] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2359), 1,
      anon_sym_EQ,
    ACTIONS(2371), 1,
      anon_sym_QMARK,
    ACTIONS(2362), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [12254] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(930), 1,
      anon_sym_EQ,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1716), 1,
      anon_sym_COLON,
    ACTIONS(748), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [12331] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(712), 1,
      anon_sym_EQ,
    ACTIONS(730), 1,
      anon_sym_EQ_GT,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_QMARK,
    ACTIONS(719), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(748), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [12410] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_extends,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2249), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2232), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2222), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [12481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1070), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [12548] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_extends,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(2226), 3,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(2229), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2222), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [12619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1070), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [12692] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(1641), 1,
      sym_template_string,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1555), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [12813] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2202), 1,
      anon_sym_EQ,
    ACTIONS(2209), 1,
      anon_sym_EQ_GT,
    ACTIONS(2648), 1,
      anon_sym_COLON,
    ACTIONS(2650), 1,
      anon_sym_QMARK,
    ACTIONS(2645), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [12894] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 1,
      anon_sym_EQ,
    ACTIONS(1140), 1,
      anon_sym_EQ_GT,
    ACTIONS(1142), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1652), 1,
      anon_sym_DOT,
    ACTIONS(1654), 1,
      anon_sym_LBRACK,
    ACTIONS(748), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [12969] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2653), 1,
      anon_sym_GT,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13087] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2657), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2511), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13205] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2659), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13323] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2661), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13441] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2663), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13559] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2665), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2541), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13677] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2667), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2232), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2249), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2222), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13863] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2669), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2511), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [13981] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2422), 1,
      anon_sym_EQ,
    ACTIONS(1070), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [14053] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2671), 1,
      sym_identifier,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2689), 1,
      sym_type_parameter,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2231), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14171] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2673), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14289] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2351), 1,
      anon_sym_EQ,
    ACTIONS(2355), 1,
      anon_sym_EQ_GT,
    ACTIONS(1070), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [14363] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2675), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2513), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_EQ,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1070), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [14547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [14621] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1744), 1,
      anon_sym_COLON,
    ACTIONS(748), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [14697] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2677), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2511), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [14815] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_LT,
    ACTIONS(2249), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(2222), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14883] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2679), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15001] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2681), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2511), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(1070), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [15185] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    ACTIONS(2563), 1,
      anon_sym_COLON,
    ACTIONS(2565), 1,
      anon_sym_in,
    ACTIONS(1070), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [15263] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2683), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15381] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2685), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2275), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [15561] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1716), 1,
      anon_sym_COLON,
    ACTIONS(748), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [15637] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [15709] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2687), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2503), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15827] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2689), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [15945] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2691), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2142), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2144), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [16125] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2693), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2511), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16243] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2695), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2580), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16361] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2699), 1,
      anon_sym_export,
    ACTIONS(2703), 1,
      anon_sym_async,
    ACTIONS(2707), 1,
      anon_sym_static,
    ACTIONS(2711), 1,
      sym_readonly,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2701), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2705), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2709), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2880), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2239), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2697), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16481] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2713), 1,
      anon_sym_RBRACK,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2511), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2279), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [16661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2239), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    ACTIONS(2565), 1,
      anon_sym_in,
    ACTIONS(2715), 1,
      anon_sym_COLON,
    ACTIONS(1070), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [16801] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2717), 1,
      anon_sym_GT,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [16919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 1,
      anon_sym_COLON,
    ACTIONS(2237), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2239), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2247), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [17045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2224), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [17107] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1126), 1,
      anon_sym_EQ,
    ACTIONS(1128), 1,
      anon_sym_EQ_GT,
    ACTIONS(1210), 1,
      anon_sym_DOT,
    ACTIONS(1228), 1,
      anon_sym_LBRACK,
    ACTIONS(748), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [17181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2239), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [17243] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(748), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [17317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2243), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [17379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2269), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [17441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2140), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [17503] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2325), 1,
      anon_sym_LBRACK,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      sym_number,
    ACTIONS(2699), 1,
      anon_sym_export,
    ACTIONS(2703), 1,
      anon_sym_async,
    ACTIONS(2707), 1,
      anon_sym_static,
    ACTIONS(2711), 1,
      sym_readonly,
    STATE(1880), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2701), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2705), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2709), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1951), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2880), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2218), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2697), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2239), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17685] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(434), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17800] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1532), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [17915] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1470), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18030] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1606), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18145] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1443), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18260] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1084), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18375] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2558), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18490] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2563), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18605] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2564), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18720] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2047), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18835] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2331), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [18950] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2231), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19065] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1331), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19180] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1332), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19295] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1335), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19410] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1454), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19525] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2247), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19640] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2522), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19755] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1089), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [19870] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    ACTIONS(2490), 1,
      anon_sym_in,
    ACTIONS(2493), 1,
      anon_sym_of,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [19947] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1692), 1,
      anon_sym_in,
    ACTIONS(2488), 1,
      anon_sym_of,
    ACTIONS(748), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [20024] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2492), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20139] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2054), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20254] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    ACTIONS(2725), 1,
      sym_this,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3141), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2776), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1604), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20369] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2208), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20484] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(420), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20599] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1605), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20714] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1070), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [20785] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1444), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [20900] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2334), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(1070), 15,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2351), 1,
      anon_sym_EQ,
    ACTIONS(1070), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2351), 1,
      anon_sym_EQ,
    ACTIONS(1070), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [21216] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2016), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21331] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2487), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21446] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1487), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21561] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(502), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21676] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1430), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21791] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2541), 1,
      anon_sym_new,
    ACTIONS(2543), 1,
      anon_sym_AMP,
    ACTIONS(2545), 1,
      anon_sym_PIPE,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2553), 1,
      sym_this,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3197), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1432), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1422), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [21906] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_SQUOTE,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_STAR,
    ACTIONS(2531), 1,
      anon_sym_LBRACE,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(2535), 1,
      anon_sym_LPAREN,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2539), 1,
      anon_sym_QMARK,
    ACTIONS(2551), 1,
      sym_number,
    ACTIONS(2557), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2559), 1,
      sym_readonly,
    ACTIONS(2561), 1,
      anon_sym_keyof,
    ACTIONS(2741), 1,
      sym_this,
    STATE(1221), 1,
      sym_nested_type_identifier,
    STATE(1424), 1,
      sym__tuple_type_body,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(3141), 1,
      sym_formal_parameters,
    ACTIONS(2547), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2555), 2,
      sym_true,
      sym_false,
    STATE(1421), 2,
      sym_string,
      sym__number,
    ACTIONS(2549), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2755), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1433), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22021] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2555), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22136] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1479), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22251] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1928), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22366] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(436), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22481] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2260), 1,
      anon_sym_in,
    ACTIONS(2263), 1,
      anon_sym_of,
    ACTIONS(2265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [22558] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(500), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22673] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2500), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22788] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1488), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [22903] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2539), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23018] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      sym_this,
    STATE(1051), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(2540), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23133] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2588), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23248] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2574), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23363] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2589), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23478] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2745), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3141), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2765), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1971), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23593] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1998), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23708] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1997), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23823] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1092), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [23938] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(436), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24053] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      sym_this,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(2611), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24168] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(448), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24283] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2211), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24398] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(422), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24513] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2747), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(447), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24628] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2548), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24743] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1095), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24858] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2275), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [24973] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2265), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25088] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(420), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25203] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2467), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25318] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1517), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25433] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    ACTIONS(2747), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2779), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(447), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25548] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(438), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25663] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1979), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25778] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1984), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [25893] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1987), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26008] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2220), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26123] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1925), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26238] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2507), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26353] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2508), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26468] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2187), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26583] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2184), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26698] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2514), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26813] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1924), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [26928] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1080), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27043] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(438), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27158] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(434), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27273] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1077), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27388] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(505), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27503] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1118), 1,
      anon_sym_EQ,
    ACTIONS(1120), 1,
      anon_sym_EQ_GT,
    ACTIONS(1626), 1,
      anon_sym_DOT,
    ACTIONS(1628), 1,
      anon_sym_LBRACK,
    ACTIONS(1749), 1,
      anon_sym_in,
    ACTIONS(2749), 1,
      anon_sym_of,
    ACTIONS(748), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(738), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(715), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [27580] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2528), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27695] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2410), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27810] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2073), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [27925] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2003), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28040] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2074), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28155] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1989), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28270] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1076), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28385] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2070), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28500] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1999), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28615] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2751), 1,
      sym_this,
    STATE(1609), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(2512), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28730] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_STAR,
    ACTIONS(836), 1,
      anon_sym_QMARK,
    ACTIONS(840), 1,
      anon_sym_AMP,
    ACTIONS(842), 1,
      anon_sym_PIPE,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(860), 1,
      anon_sym_keyof,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(2505), 1,
      anon_sym_LPAREN,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    ACTIONS(2509), 1,
      anon_sym_new,
    ACTIONS(2515), 1,
      sym_number,
    ACTIONS(2523), 1,
      sym_readonly,
    ACTIONS(2721), 1,
      sym_identifier,
    ACTIONS(2723), 1,
      sym_this,
    STATE(1952), 1,
      sym_nested_type_identifier,
    STATE(2007), 1,
      sym__tuple_type_body,
    STATE(2996), 1,
      sym_type_parameters,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(3021), 1,
      sym_formal_parameters,
    ACTIONS(2511), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2519), 2,
      sym_true,
      sym_false,
    STATE(1990), 2,
      sym_string,
      sym__number,
    ACTIONS(2513), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1974), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1993), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28845] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1132), 1,
      sym_this,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2507), 1,
      anon_sym_LBRACK,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(1983), 1,
      sym__tuple_type_body,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(2571), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [28960] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(503), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29075] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1551), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29190] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    ACTIONS(2753), 1,
      sym_this,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3141), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2775), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1046), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29305] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1047), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29420] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_DQUOTE,
    ACTIONS(482), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2573), 1,
      sym_identifier,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(2581), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_QMARK,
    ACTIONS(2587), 1,
      anon_sym_new,
    ACTIONS(2589), 1,
      anon_sym_AMP,
    ACTIONS(2591), 1,
      anon_sym_PIPE,
    ACTIONS(2597), 1,
      sym_number,
    ACTIONS(2599), 1,
      sym_this,
    ACTIONS(2603), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2605), 1,
      sym_readonly,
    ACTIONS(2607), 1,
      anon_sym_keyof,
    STATE(1016), 1,
      sym_nested_type_identifier,
    STATE(1036), 1,
      sym__tuple_type_body,
    STATE(2795), 1,
      sym_type_parameters,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(3084), 1,
      sym_formal_parameters,
    ACTIONS(2593), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2601), 2,
      sym_true,
      sym_false,
    STATE(1033), 2,
      sym_string,
      sym__number,
    ACTIONS(2595), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1048), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1034), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29535] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2496), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29650] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2159), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29765] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2537), 1,
      anon_sym_LBRACK,
    ACTIONS(2755), 1,
      sym_this,
    STATE(1427), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2620), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(2578), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29880] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(448), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [29995] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2273), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [30110] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_DQUOTE,
    ACTIONS(808), 1,
      anon_sym_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(2617), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      anon_sym_new,
    ACTIONS(2625), 1,
      anon_sym_AMP,
    ACTIONS(2627), 1,
      anon_sym_PIPE,
    ACTIONS(2633), 1,
      sym_number,
    ACTIONS(2635), 1,
      sym_this,
    ACTIONS(2639), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2641), 1,
      sym_readonly,
    ACTIONS(2643), 1,
      anon_sym_keyof,
    STATE(1451), 1,
      sym_nested_type_identifier,
    STATE(1576), 1,
      sym__tuple_type_body,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(3139), 1,
      sym_formal_parameters,
    ACTIONS(2629), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2637), 2,
      sym_true,
      sym_false,
    STATE(1567), 2,
      sym_string,
      sym__number,
    ACTIONS(2631), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1542), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(1574), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [30225] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(2731), 1,
      anon_sym_QMARK,
    ACTIONS(2733), 1,
      anon_sym_new,
    ACTIONS(2735), 1,
      anon_sym_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_keyof,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(492), 1,
      sym_nested_type_identifier,
    STATE(2947), 1,
      sym_type_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(3224), 1,
      sym_formal_parameters,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(422), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [30340] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2527), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [30455] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 1,
      anon_sym_STAR,
    ACTIONS(460), 1,
      anon_sym_QMARK,
    ACTIONS(466), 1,
      anon_sym_AMP,
    ACTIONS(468), 1,
      anon_sym_PIPE,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(502), 1,
      anon_sym_keyof,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(726), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_new,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(756), 1,
      sym_number,
    ACTIONS(928), 1,
      sym_identifier,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_readonly,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2446), 1,
      anon_sym_LBRACK,
    ACTIONS(2655), 1,
      sym_this,
    STATE(445), 1,
      sym__tuple_type_body,
    STATE(1915), 1,
      sym_nested_type_identifier,
    STATE(2862), 1,
      sym_type_parameters,
    STATE(3141), 1,
      sym_formal_parameters,
    STATE(3142), 1,
      sym_nested_identifier,
    ACTIONS(760), 2,
      sym_true,
      sym_false,
    ACTIONS(1674), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(443), 2,
      sym_string,
      sym__number,
    ACTIONS(750), 5,
      anon_sym_void,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2215), 5,
      sym__type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
      sym_constructor_type,
    STATE(435), 14,
      sym__primary_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_generic_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_flow_maybe_type,
      sym_type_query,
      sym_index_type_query,
      sym_existential_type,
      sym_literal_type,
      sym_lookup_type,
      sym_conditional_type,
  [30570] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2260), 1,
      anon_sym_in,
    ACTIONS(2263), 1,
      anon_sym_of,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30644] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2260), 1,
      anon_sym_in,
    ACTIONS(2263), 1,
      anon_sym_of,
    ACTIONS(1070), 13,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2490), 1,
      anon_sym_in,
    ACTIONS(2493), 1,
      anon_sym_of,
    ACTIONS(1070), 13,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30780] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2490), 1,
      anon_sym_in,
    ACTIONS(2493), 1,
      anon_sym_of,
    ACTIONS(1070), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2200), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1068), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_QMARK_QMARK,
  [30854] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2757), 1,
      sym_identifier,
    ACTIONS(2759), 1,
      anon_sym_STAR,
    ACTIONS(2763), 1,
      anon_sym_LBRACE,
    STATE(2827), 1,
      sym_import_clause,
    ACTIONS(2767), 2,
      anon_sym_typeof,
      anon_sym_type,
    STATE(2828), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3177), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(2761), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(2765), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30929] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1198), 1,
      anon_sym_LBRACE,
    ACTIONS(2769), 1,
      anon_sym_STAR,
    ACTIONS(2771), 1,
      anon_sym_default,
    ACTIONS(2773), 1,
      anon_sym_EQ,
    ACTIONS(2775), 1,
      anon_sym_as,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2787), 1,
      anon_sym_module,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    STATE(1908), 1,
      sym_decorator,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2452), 1,
      sym__declaration,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym_export_clause,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [31037] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2323), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2345), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2185), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31143] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2827), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2829), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2150), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31249] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2462), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2464), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2157), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31355] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1198), 1,
      anon_sym_LBRACE,
    ACTIONS(2769), 1,
      anon_sym_STAR,
    ACTIONS(2771), 1,
      anon_sym_default,
    ACTIONS(2773), 1,
      anon_sym_EQ,
    ACTIONS(2775), 1,
      anon_sym_as,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2787), 1,
      anon_sym_module,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    STATE(1908), 1,
      sym_decorator,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2452), 1,
      sym__declaration,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym_export_clause,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [31463] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1198), 1,
      anon_sym_LBRACE,
    ACTIONS(2769), 1,
      anon_sym_STAR,
    ACTIONS(2771), 1,
      anon_sym_default,
    ACTIONS(2773), 1,
      anon_sym_EQ,
    ACTIONS(2775), 1,
      anon_sym_as,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2787), 1,
      anon_sym_module,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    STATE(1908), 1,
      sym_decorator,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2452), 1,
      sym__declaration,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym_export_clause,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [31571] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2831), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2833), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2160), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31677] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2835), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2837), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2209), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31783] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1198), 1,
      anon_sym_LBRACE,
    ACTIONS(2769), 1,
      anon_sym_STAR,
    ACTIONS(2771), 1,
      anon_sym_default,
    ACTIONS(2773), 1,
      anon_sym_EQ,
    ACTIONS(2775), 1,
      anon_sym_as,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2787), 1,
      anon_sym_module,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    STATE(1908), 1,
      sym_decorator,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2452), 1,
      sym__declaration,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym_export_clause,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [31891] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1198), 1,
      anon_sym_LBRACE,
    ACTIONS(2769), 1,
      anon_sym_STAR,
    ACTIONS(2771), 1,
      anon_sym_default,
    ACTIONS(2775), 1,
      anon_sym_as,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2787), 1,
      anon_sym_module,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    ACTIONS(2839), 1,
      anon_sym_EQ,
    STATE(1908), 1,
      sym_decorator,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2452), 1,
      sym__declaration,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym_export_clause,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [31996] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1198), 1,
      anon_sym_LBRACE,
    ACTIONS(2769), 1,
      anon_sym_STAR,
    ACTIONS(2771), 1,
      anon_sym_default,
    ACTIONS(2773), 1,
      anon_sym_EQ,
    ACTIONS(2775), 1,
      anon_sym_as,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2787), 1,
      anon_sym_module,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    STATE(1908), 1,
      sym_decorator,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2452), 1,
      sym__declaration,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2538), 1,
      sym_export_clause,
    ACTIONS(2841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2779), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [32103] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2844), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32205] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2846), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32307] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2848), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32409] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2850), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32511] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2852), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32613] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2854), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32715] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2856), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32817] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2858), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32919] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2860), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33021] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2862), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33123] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33225] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2866), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33327] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2868), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33429] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2870), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33531] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2872), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33633] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2874), 1,
      anon_sym_EQ,
    STATE(1062), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(2188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(944), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [33755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2876), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2878), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33812] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2880), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2882), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33875] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2886), 1,
      anon_sym_EQ,
    STATE(1062), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(2188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1072), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [33997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    STATE(1050), 1,
      sym_type_arguments,
    ACTIONS(1588), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34053] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2191), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2719), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2894), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34255] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2180), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34353] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2167), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2898), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34503] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2166), 1,
      anon_sym_LT,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    STATE(1062), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(2188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34569] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2239), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2902), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(924), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34771] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_DOT,
    ACTIONS(2906), 1,
      anon_sym_LT,
    STATE(1050), 1,
      sym_type_arguments,
    ACTIONS(1720), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1718), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2911), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2915), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2919), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1576), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(922), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(924), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_extends,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2924), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2892), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2894), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35099] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2218), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35197] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(2331), 1,
      anon_sym_new,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2809), 1,
      anon_sym_export,
    ACTIONS(2811), 1,
      anon_sym_STAR,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_async,
    ACTIONS(2819), 1,
      sym_number,
    ACTIONS(2821), 1,
      anon_sym_static,
    ACTIONS(2825), 1,
      sym_readonly,
    STATE(1882), 1,
      sym_accessibility_modifier,
    STATE(1908), 1,
      sym_decorator,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2360), 1,
      sym__call_signature,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(2817), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1943), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2309), 6,
      sym_export_statement,
      sym_call_signature,
      sym_index_signature,
      sym_construct_signature,
      sym_method_signature,
      sym_property_signature,
    ACTIONS(2807), 10,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_EQ,
    ACTIONS(2927), 1,
      sym__automatic_semicolon,
    ACTIONS(920), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(918), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1058), 1,
      sym_type_arguments,
    ACTIONS(1506), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1504), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_DOT,
    STATE(1050), 1,
      sym_type_arguments,
    ACTIONS(1712), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1710), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_LT,
    STATE(1058), 1,
      sym_type_arguments,
    ACTIONS(1739), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1737), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35517] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    ACTIONS(2934), 1,
      anon_sym_DOT,
    STATE(1308), 1,
      sym_statement_block,
    ACTIONS(912), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(910), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35574] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    ACTIONS(2938), 1,
      anon_sym_DOT,
    STATE(1188), 1,
      sym_statement_block,
    ACTIONS(912), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(910), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1468), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 1,
      sym__automatic_semicolon,
    ACTIONS(964), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(962), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(2942), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2944), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1490), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35839] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2954), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [35910] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1606), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1608), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35971] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2954), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [36042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1484), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36093] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2963), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36188] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2989), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [36283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1188), 1,
      sym_statement_block,
    ACTIONS(912), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(910), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1544), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1072), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1243), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1582), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_LBRACK,
    ACTIONS(1562), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1560), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36595] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2993), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [36690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1590), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36741] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2954), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [36812] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2995), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [36907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      sym__automatic_semicolon,
    ACTIONS(920), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(918), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1308), 1,
      sym_statement_block,
    ACTIONS(912), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(910), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1574), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37066] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2997), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [37161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_DOT,
    ACTIONS(1588), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1578), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_LBRACK,
    ACTIONS(1600), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1598), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1508), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1602), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1606), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1472), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1552), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37624] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2999), 1,
      anon_sym_EQ,
    ACTIONS(3003), 1,
      anon_sym_in,
    ACTIONS(3006), 1,
      anon_sym_of,
    STATE(2485), 1,
      sym_type_annotation,
    STATE(2639), 1,
      sym__initializer,
    ACTIONS(3001), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37695] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3008), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [37790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1504), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37841] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(3010), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_in,
    ACTIONS(3017), 1,
      anon_sym_of,
    STATE(2484), 1,
      sym_type_annotation,
    STATE(2666), 1,
      sym__initializer,
    ACTIONS(3012), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37912] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3019), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_LT,
    ACTIONS(998), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(996), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1464), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38111] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3024), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38206] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3026), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(1172), 1,
      sym_arguments,
    ACTIONS(3028), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3030), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(1167), 1,
      sym_arguments,
    ACTIONS(3032), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3034), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_DOT,
    ACTIONS(1428), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1426), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(944), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1512), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38566] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3036), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38661] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3038), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1516), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38807] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3044), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [38880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_extends,
    ACTIONS(3053), 1,
      anon_sym_AMP,
    ACTIONS(3055), 1,
      anon_sym_PIPE,
    ACTIONS(3047), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3049), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38937] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3059), 4,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1524), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39085] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 9,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39162] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3061), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39257] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3063), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_extends,
    ACTIONS(3053), 1,
      anon_sym_AMP,
    ACTIONS(3055), 1,
      anon_sym_PIPE,
    ACTIONS(1776), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1774), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1556), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39460] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3065), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39555] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3067), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1570), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39701] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(3040), 1,
      anon_sym_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [39792] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 10,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [39875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1536), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_AMP,
    ACTIONS(3055), 1,
      anon_sym_PIPE,
    ACTIONS(1766), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1764), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39981] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3040), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [40068] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_extends,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3072), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1548), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40182] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_extends,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1566), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40296] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3040), 5,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3042), 10,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [40377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1594), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_extends,
    ACTIONS(3053), 1,
      anon_sym_AMP,
    ACTIONS(3055), 1,
      anon_sym_PIPE,
    ACTIONS(1756), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1754), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1540), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1538), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1534), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1532), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1500), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40642] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3044), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1528), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1520), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2915), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40865] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    STATE(2549), 1,
      sym_type_arguments,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2880), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2882), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(958), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1574), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(922), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(924), 20,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41029] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(3086), 1,
      sym_type_annotation,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41129] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3019), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3121), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3125), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3129), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3131), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3063), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41423] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3061), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41517] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3063), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3135), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2944), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41711] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3024), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41805] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3065), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41899] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3137), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2894), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42043] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3067), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1106), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42187] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_QMARK,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [42277] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3139), 1,
      anon_sym_COMMA,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3008), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3049), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42425] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2989), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1058), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1060), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2911), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3038), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(954), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3148), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42769] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3150), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42839] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3040), 5,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [42919] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3040), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [43005] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [43087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3155), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43137] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 9,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1046), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43263] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2531), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3159), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3187), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(996), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43461] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3189), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43531] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(3192), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(3179), 1,
      sym_type_annotation,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43631] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2874), 1,
      anon_sym_EQ,
    STATE(1385), 1,
      sym_type_arguments,
    STATE(1571), 1,
      sym_arguments,
    ACTIONS(2188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(940), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43747] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2963), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(996), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43947] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3189), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2719), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3196), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3200), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44217] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3026), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44311] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2997), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3204), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3208), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2765), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2902), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3212), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44655] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3150), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3216), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44777] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(3159), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3222), 1,
      anon_sym_LBRACE,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    STATE(2553), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44877] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3038), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44971] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3189), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45041] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3036), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1116), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1114), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2898), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(924), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3254), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3256), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3260), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45385] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(3262), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(3049), 1,
      sym_type_annotation,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45485] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2886), 1,
      anon_sym_EQ,
    STATE(1385), 1,
      sym_type_arguments,
    STATE(1571), 1,
      sym_arguments,
    ACTIONS(2188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3266), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1112), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1110), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3270), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3274), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1016), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2919), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(990), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(992), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(982), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1096), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1006), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3276), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3278), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46101] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3280), 1,
      anon_sym_COMMA,
    ACTIONS(3283), 1,
      anon_sym_RBRACE,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3067), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3285), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3287), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46249] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(3289), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(3157), 1,
      sym_type_annotation,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1082), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46399] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2995), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46493] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2993), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3293), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1050), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(964), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(962), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3019), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2993), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3301), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1026), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46937] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3142), 1,
      anon_sym_RBRACE,
    ACTIONS(3303), 1,
      anon_sym_COMMA,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3036), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3306), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3308), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1036), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47135] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3310), 1,
      anon_sym_COMMA,
    ACTIONS(3313), 1,
      anon_sym_RBRACE,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3065), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3317), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2921), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1578), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2892), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2894), 20,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2549), 1,
      sym_type_arguments,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2876), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2878), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2995), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47443] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(3321), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(3030), 1,
      sym_type_annotation,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3325), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47593] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3008), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3329), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3333), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2997), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3339), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_implements,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47887] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2995), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47980] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3040), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 5,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_QMARK_QMARK,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48069] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3341), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [48138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(2942), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2944), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1112), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1110), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48238] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2989), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48331] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3061), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48424] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    STATE(2592), 1,
      sym_type_arguments,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2880), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2882), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [48483] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3344), 1,
      anon_sym_COMMA,
    ACTIONS(3346), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2699), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48580] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3063), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48673] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3348), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48766] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3065), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3350), 1,
      anon_sym_LT,
    STATE(1417), 1,
      sym_type_arguments,
    ACTIONS(1739), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1737), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48912] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3353), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2760), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49009] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3067), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49102] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3355), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(964), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(962), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      sym__automatic_semicolon,
    ACTIONS(964), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(962), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49259] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3359), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2699), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49356] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3361), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2725), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49453] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3363), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2638), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(940), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3365), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2699), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49696] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2997), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49789] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3348), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49882] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3341), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [49951] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3069), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3072), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1737), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50012] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2993), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50105] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3367), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2768), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50202] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3348), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50295] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3369), 1,
      anon_sym_COMMA,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3371), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50390] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3373), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3024), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50485] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3040), 5,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [50564] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3348), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50657] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3375), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(2963), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50752] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3040), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 7,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [50837] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(2989), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 1,
      anon_sym_DOT,
    ACTIONS(3381), 1,
      anon_sym_LT,
    STATE(1428), 1,
      sym_type_arguments,
    ACTIONS(1720), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1718), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50987] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [51068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1576), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(922), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(924), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51121] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      anon_sym_LT,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(2886), 1,
      anon_sym_EQ,
    STATE(1622), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2188), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [51186] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      anon_sym_LT,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(2874), 1,
      anon_sym_EQ,
    STATE(1622), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2188), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [51251] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3384), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2650), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51348] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3369), 1,
      anon_sym_COMMA,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3059), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(926), 1,
      sym__automatic_semicolon,
    ACTIONS(918), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(922), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(924), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51496] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3341), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [51565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_extends,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2924), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2892), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2894), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51620] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3386), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51713] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3388), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3390), 1,
      sym__automatic_semicolon,
    ACTIONS(920), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(918), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51857] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3392), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2624), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51954] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 4,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [52035] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3067), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52130] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3396), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2669), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3402), 1,
      sym_regex_flags,
    ACTIONS(3398), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3400), 24,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52278] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3404), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52347] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3407), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52416] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3297), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(2993), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 1,
      anon_sym_DOT,
    STATE(1428), 1,
      sym_type_arguments,
    ACTIONS(1588), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52564] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3319), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(2995), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52659] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3335), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(2997), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1116), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1114), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(958), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 1,
      anon_sym_DOT,
    STATE(1428), 1,
      sym_type_arguments,
    ACTIONS(1712), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1710), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1417), 1,
      sym_type_arguments,
    ACTIONS(1506), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1504), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52956] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 9,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53031] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3407), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53102] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3404), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53171] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3412), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2774), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53268] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3038), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53361] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3078), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1582), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53422] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53517] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3131), 1,
      anon_sym_LBRACE,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3063), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53612] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3416), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3065), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53707] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3418), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2669), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53804] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3040), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3042), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53893] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3369), 1,
      anon_sym_COMMA,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3420), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53988] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3036), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54081] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3369), 1,
      anon_sym_COMMA,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54176] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3344), 1,
      anon_sym_COMMA,
    ACTIONS(3424), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2699), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54273] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2963), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3426), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54423] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3428), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54492] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3040), 6,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3042), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [54571] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 3,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [54656] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3386), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54751] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 10,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54826] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3433), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    STATE(2699), 1,
      aux_sym_array_repeat1,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54923] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3428), 1,
      anon_sym_LT,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54994] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3144), 1,
      anon_sym_LBRACE,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3038), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55089] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3435), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3036), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55184] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3026), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55277] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3404), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55346] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3024), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55439] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3019), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55532] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3163), 1,
      anon_sym_QMARK,
    ACTIONS(3165), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3171), 1,
      anon_sym_AMP,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3179), 1,
      anon_sym_LT,
    ACTIONS(3183), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3167), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3175), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3008), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3157), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3169), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3161), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3181), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3095), 1,
      anon_sym_QMARK,
    ACTIONS(3097), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3103), 1,
      anon_sym_AMP,
    ACTIONS(3105), 1,
      anon_sym_PIPE,
    ACTIONS(3109), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3111), 1,
      anon_sym_LT,
    ACTIONS(3115), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3099), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3107), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3087), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3101), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3348), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3093), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3113), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55718] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3437), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3026), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1608), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1606), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1050), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55921] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3295), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3019), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56016] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3220), 1,
      anon_sym_as,
    ACTIONS(3224), 1,
      anon_sym_BANG,
    ACTIONS(3228), 1,
      anon_sym_QMARK,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3238), 1,
      anon_sym_AMP,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3244), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3246), 1,
      anon_sym_LT,
    ACTIONS(3250), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3439), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(3008), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3234), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3242), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3252), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3236), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3226), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3248), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56111] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2592), 1,
      sym_type_arguments,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2876), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2878), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [56164] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_LT,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    STATE(1385), 1,
      sym_type_arguments,
    STATE(1571), 1,
      sym_arguments,
    ACTIONS(2188), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56227] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3019), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56319] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [56387] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3470), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [56455] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3040), 5,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 7,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [56533] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3040), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 6,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [56617] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 7,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [56697] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 9,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 12,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [56771] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3470), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 15,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [56841] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3038), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56933] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3036), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1574), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(922), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(924), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57077] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3026), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57169] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3473), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57263] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_extends,
    ACTIONS(2921), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2892), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2894), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57317] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3008), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57409] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3479), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57501] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3040), 5,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [57579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1536), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1570), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1556), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57723] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3067), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1490), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_extends,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(1776), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1774), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1524), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1516), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1512), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58061] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3509), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58129] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3040), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3042), 4,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1062), 1,
      sym__automatic_semicolon,
    ACTIONS(1054), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1058), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1060), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58269] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3024), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58361] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [58441] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2993), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58533] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2995), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58625] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3512), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58717] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3514), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_LBRACK,
    ACTIONS(1578), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2924), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2892), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2894), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58863] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3516), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [58931] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3024), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59023] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2997), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_LT,
    ACTIONS(998), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(996), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59165] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3061), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(956), 1,
      sym__automatic_semicolon,
    ACTIONS(948), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(952), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(954), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59309] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3063), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 1,
      sym__automatic_semicolon,
    ACTIONS(1040), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1044), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1046), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59453] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3065), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_DOT,
    ACTIONS(1428), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1426), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59595] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3040), 1,
      anon_sym_QMARK,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3042), 4,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59683] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1606), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1608), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59741] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3067), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59833] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3065), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1634), 1,
      sym_type_arguments,
    ACTIONS(1506), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1504), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59975] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(2989), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1108), 1,
      sym__automatic_semicolon,
    ACTIONS(1100), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1104), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1106), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60119] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3519), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60211] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3063), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60303] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3061), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60395] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3040), 9,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [60469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_DOT,
    STATE(1587), 1,
      sym_type_arguments,
    ACTIONS(1712), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1710), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [60521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    STATE(1519), 1,
      sym_arguments,
    ACTIONS(3028), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3030), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60623] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3523), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60717] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3525), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60811] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3509), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3040), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3042), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [60881] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3038), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60973] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3527), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 1,
      anon_sym_DOT,
    STATE(1587), 1,
      sym_type_arguments,
    ACTIONS(1588), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_extends,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(3047), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3049), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61173] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(2963), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_COLON,
    ACTIONS(3533), 1,
      anon_sym_LPAREN,
    ACTIONS(3536), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2890), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2719), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61319] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3036), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3539), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61505] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3541), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    STATE(1503), 1,
      sym_arguments,
    ACTIONS(3032), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3034), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3543), 1,
      sym_regex_flags,
    ACTIONS(3398), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3400), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61701] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_DOT,
    ACTIONS(3545), 1,
      anon_sym_LT,
    STATE(1587), 1,
      sym_type_arguments,
    ACTIONS(1720), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1718), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61755] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3548), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_EQ,
    ACTIONS(3550), 1,
      sym__automatic_semicolon,
    ACTIONS(920), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(918), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 1,
      sym__automatic_semicolon,
    ACTIONS(1010), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1014), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1016), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61953] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_extends,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2371), 1,
      anon_sym_QMARK,
    ACTIONS(3552), 1,
      anon_sym_EQ,
    ACTIONS(3554), 1,
      anon_sym_RPAREN,
    ACTIONS(2362), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3072), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62019] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62087] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      anon_sym_LT,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    STATE(1622), 1,
      sym_type_arguments,
    STATE(1677), 1,
      sym_arguments,
    ACTIONS(2188), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2192), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62149] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3558), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62243] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2963), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(994), 1,
      sym__automatic_semicolon,
    ACTIONS(986), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(990), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(992), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 1,
      sym__automatic_semicolon,
    ACTIONS(976), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(980), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(982), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62439] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2989), 2,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62531] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3516), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62599] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3560), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62693] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3562), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62787] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3142), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62879] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3564), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62973] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3283), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63065] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3313), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63157] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_extends,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3072), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63285] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_LBRACK,
    ACTIONS(1578), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2924), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2892), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2894), 22,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63339] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_extends,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63399] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3566), 1,
      anon_sym_EQ,
    ACTIONS(3568), 1,
      anon_sym_in,
    ACTIONS(3571), 1,
      anon_sym_of,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63459] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3573), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63553] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(3577), 1,
      anon_sym_in,
    ACTIONS(3580), 1,
      anon_sym_of,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(2942), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2944), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1520), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63711] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(2997), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1544), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1464), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1468), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63947] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3516), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2948), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2950), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [64015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1243), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1582), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_LBRACK,
    ACTIONS(1562), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1560), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64161] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3584), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1590), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1504), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64351] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3586), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1552), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1472), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1606), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1602), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_EQ,
    ACTIONS(3390), 1,
      sym__automatic_semicolon,
    ACTIONS(920), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(918), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1508), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3582), 1,
      anon_sym_LBRACK,
    ACTIONS(1600), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1598), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1578), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1528), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1576), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(922), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(924), 21,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64935] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3040), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3042), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [65019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 1,
      anon_sym_DOT,
    ACTIONS(1588), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1574), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65165] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3588), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65259] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3590), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1500), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(1766), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1764), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65453] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1084), 1,
      sym__automatic_semicolon,
    ACTIONS(1076), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1080), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1082), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65505] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(2995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1548), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1538), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1534), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1532), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 1,
      anon_sym_extends,
    ACTIONS(2921), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2924), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(2892), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2894), 21,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65751] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3592), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_LT,
    STATE(1634), 1,
      sym_type_arguments,
    ACTIONS(1739), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1737), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65897] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3597), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65989] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1038), 1,
      sym__automatic_semicolon,
    ACTIONS(1030), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1034), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1036), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1566), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1594), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66137] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3008), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66229] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3599), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 1,
      sym__automatic_semicolon,
    ACTIONS(1020), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1024), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1026), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66375] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3019), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66467] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3601), 1,
      anon_sym_COLON,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66561] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3603), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66655] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3388), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66747] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3605), 1,
      anon_sym_RBRACE,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 1,
      sym__automatic_semicolon,
    ACTIONS(1000), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1004), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1006), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1098), 1,
      sym__automatic_semicolon,
    ACTIONS(1090), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1094), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1096), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66945] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3566), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67001] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3607), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67095] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3575), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67151] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(3026), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67243] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_extends,
    ACTIONS(3505), 1,
      anon_sym_AMP,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(1756), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1754), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67297] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3609), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1540), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1484), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67487] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3611), 1,
      anon_sym_RPAREN,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67581] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(2967), 1,
      anon_sym_QMARK,
    ACTIONS(2969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2975), 1,
      anon_sym_AMP,
    ACTIONS(2977), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2983), 1,
      anon_sym_LT,
    ACTIONS(2987), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3613), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2971), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(2979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(2959), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2973), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(2965), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2985), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67675] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3089), 1,
      anon_sym_as,
    ACTIONS(3091), 1,
      anon_sym_BANG,
    ACTIONS(3481), 1,
      anon_sym_QMARK,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      anon_sym_AMP,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3495), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3497), 1,
      anon_sym_LT,
    ACTIONS(3501), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(2993), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3117), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3475), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3487), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3477), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3499), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67767] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3617), 1,
      anon_sym_RBRACE,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1628), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(1606), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1608), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1556), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67954] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(3633), 1,
      anon_sym_RBRACE,
    ACTIONS(3635), 1,
      anon_sym_LBRACK,
    ACTIONS(3637), 1,
      anon_sym_async,
    ACTIONS(3641), 1,
      sym_number,
    ACTIONS(3643), 1,
      anon_sym_static,
    ACTIONS(3647), 1,
      sym_readonly,
    STATE(1879), 1,
      sym_accessibility_modifier,
    STATE(2664), 1,
      aux_sym_object_repeat1,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(3639), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3645), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2672), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3631), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68039] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3649), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1482), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68122] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3651), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1598), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1536), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1520), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2765), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_extends,
    ACTIONS(3655), 1,
      anon_sym_AMP,
    ACTIONS(3657), 1,
      anon_sym_PIPE,
    ACTIONS(1776), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1774), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1570), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68493] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3659), 1,
      anon_sym_COLON,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3155), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68631] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_extends,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3075), 1,
      anon_sym_RPAREN,
    ACTIONS(3078), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_DOT,
    ACTIONS(1428), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1426), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_LT,
    ACTIONS(998), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(996), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3148), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1106), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3038), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3254), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3256), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69029] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(3635), 1,
      anon_sym_LBRACK,
    ACTIONS(3641), 1,
      sym_number,
    ACTIONS(3663), 1,
      anon_sym_RBRACE,
    ACTIONS(3665), 1,
      anon_sym_async,
    ACTIONS(3669), 1,
      anon_sym_static,
    ACTIONS(3673), 1,
      sym_readonly,
    STATE(1879), 1,
      sym_accessibility_modifier,
    STATE(2692), 1,
      aux_sym_object_repeat1,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(3667), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3671), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2701), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3661), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69114] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1737), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3072), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69171] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2371), 1,
      anon_sym_QMARK,
    ACTIONS(3552), 1,
      anon_sym_EQ,
    ACTIONS(2362), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69230] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3675), 1,
      anon_sym_COLON,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3260), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3049), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1528), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69462] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3677), 1,
      anon_sym_COLON,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(982), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1006), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2944), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1096), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      sym_regex_flags,
    ACTIONS(3398), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3400), 21,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1058), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1060), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(990), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(992), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69884] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3681), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1598), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69967] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3683), 1,
      anon_sym_EQ,
    ACTIONS(1068), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70022] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3685), 1,
      anon_sym_EQ,
    ACTIONS(1068), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1500), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70124] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3687), 1,
      anon_sym_EQ,
    ACTIONS(3693), 1,
      anon_sym_QMARK,
    ACTIONS(3690), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3270), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70230] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_extends,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(954), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3333), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1046), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1016), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3550), 1,
      sym__automatic_semicolon,
    ACTIONS(920), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(918), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3285), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3287), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1538), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1534), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1532), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3696), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70679] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(3635), 1,
      anon_sym_LBRACK,
    ACTIONS(3641), 1,
      sym_number,
    ACTIONS(3700), 1,
      anon_sym_RBRACE,
    ACTIONS(3702), 1,
      anon_sym_async,
    ACTIONS(3706), 1,
      anon_sym_static,
    ACTIONS(3710), 1,
      sym_readonly,
    STATE(1879), 1,
      sym_accessibility_modifier,
    STATE(2736), 1,
      aux_sym_object_repeat1,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(3704), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3708), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2734), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3698), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1540), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1484), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70858] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_extends,
    ACTIONS(3655), 1,
      anon_sym_AMP,
    ACTIONS(3657), 1,
      anon_sym_PIPE,
    ACTIONS(1756), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1754), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2993), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70958] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3712), 1,
      anon_sym_COLON,
    ACTIONS(3714), 1,
      anon_sym_LPAREN,
    ACTIONS(3717), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71017] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3720), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1598), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71100] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3722), 1,
      anon_sym_COLON,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3329), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1594), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2995), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3325), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3274), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1566), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71473] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3724), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1514), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3125), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1524), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3266), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1548), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1516), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3687), 1,
      anon_sym_EQ,
    ACTIONS(3693), 1,
      anon_sym_QMARK,
    ACTIONS(3726), 1,
      anon_sym_COLON,
    ACTIONS(3690), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71852] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3728), 1,
      anon_sym_EQ,
    ACTIONS(3734), 1,
      anon_sym_COLON,
    ACTIONS(3736), 1,
      anon_sym_QMARK,
    ACTIONS(3731), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3655), 1,
      anon_sym_AMP,
    ACTIONS(3657), 1,
      anon_sym_PIPE,
    ACTIONS(1766), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1764), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71964] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2371), 1,
      anon_sym_QMARK,
    ACTIONS(2525), 1,
      anon_sym_COLON,
    ACTIONS(3552), 1,
      anon_sym_EQ,
    ACTIONS(2362), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72025] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1606), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(1608), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3129), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_extends,
    ACTIONS(3655), 1,
      anon_sym_AMP,
    ACTIONS(3657), 1,
      anon_sym_PIPE,
    ACTIONS(3047), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3049), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1490), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3131), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3063), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3019), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72323] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(3635), 1,
      anon_sym_LBRACK,
    ACTIONS(3641), 1,
      sym_number,
    ACTIONS(3741), 1,
      anon_sym_RBRACE,
    ACTIONS(3743), 1,
      anon_sym_async,
    ACTIONS(3747), 1,
      anon_sym_static,
    ACTIONS(3751), 1,
      sym_readonly,
    STATE(1879), 1,
      sym_accessibility_modifier,
    STATE(2673), 1,
      aux_sym_object_repeat1,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(3745), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3749), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2671), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3739), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 1,
      anon_sym_LBRACE,
    ACTIONS(3755), 1,
      anon_sym_DOT,
    STATE(1650), 1,
      sym_statement_block,
    ACTIONS(912), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(910), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3753), 1,
      anon_sym_LBRACE,
    STATE(1650), 1,
      sym_statement_block,
    ACTIONS(912), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(910), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3306), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3308), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2894), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1544), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1243), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72700] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3757), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1590), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1582), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3121), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3293), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(944), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3196), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2997), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3187), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3759), 1,
      anon_sym_LBRACK,
    ACTIONS(1562), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1560), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3135), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1590), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73255] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3761), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3200), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3339), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2898), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73487] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3763), 1,
      anon_sym_RBRACK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1026), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73625] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3765), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2902), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3767), 1,
      sym__automatic_semicolon,
    ACTIONS(964), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(962), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1036), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1472), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(924), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2719), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73964] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3769), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1598), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3204), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3208), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74141] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3771), 1,
      anon_sym_COLON,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74232] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3773), 1,
      anon_sym_COLON,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3212), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1574), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 1,
      anon_sym_DOT,
    ACTIONS(1588), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74466] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 1,
      anon_sym_STAR,
    ACTIONS(3781), 1,
      anon_sym_RBRACE,
    ACTIONS(3783), 1,
      anon_sym_LBRACK,
    ACTIONS(3786), 1,
      anon_sym_async,
    ACTIONS(3789), 1,
      anon_sym_abstract,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3798), 1,
      anon_sym_DQUOTE,
    ACTIONS(3801), 1,
      anon_sym_SQUOTE,
    ACTIONS(3804), 1,
      sym_number,
    ACTIONS(3807), 1,
      anon_sym_AT,
    ACTIONS(3810), 1,
      anon_sym_static,
    ACTIONS(3816), 1,
      sym_readonly,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3792), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1598), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3813), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(3775), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1468), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74596] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3819), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3821), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1586), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1578), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3759), 1,
      anon_sym_LBRACK,
    ACTIONS(1600), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1598), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1508), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1602), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1606), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74990] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3823), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1627), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1552), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1504), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75167] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3728), 1,
      anon_sym_EQ,
    ACTIONS(3736), 1,
      anon_sym_QMARK,
    ACTIONS(3731), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3276), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3278), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75273] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1582), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75330] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3825), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1535), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_EQ_GT,
    ACTIONS(2942), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2944), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(1582), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3078), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2911), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2915), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    STATE(1666), 1,
      sym_arguments,
    ACTIONS(3028), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3030), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1082), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2919), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    STATE(1665), 1,
      sym_arguments,
    ACTIONS(3032), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3034), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3402), 1,
      sym_regex_flags,
    ACTIONS(3398), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_implements,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_instanceof,
    ACTIONS(3400), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1512), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75905] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_extends,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(3069), 1,
      anon_sym_COMMA,
    ACTIONS(3072), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3317), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76011] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3827), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1598), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76094] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2333), 1,
      anon_sym_DASH,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2813), 1,
      anon_sym_LBRACK,
    ACTIONS(3615), 1,
      anon_sym_STAR,
    ACTIONS(3619), 1,
      anon_sym_async,
    ACTIONS(3621), 1,
      anon_sym_abstract,
    ACTIONS(3625), 1,
      sym_number,
    ACTIONS(3627), 1,
      anon_sym_static,
    ACTIONS(3629), 1,
      sym_readonly,
    ACTIONS(3829), 1,
      anon_sym_RBRACE,
    STATE(1832), 1,
      sym_method_definition,
    STATE(1876), 1,
      sym_accessibility_modifier,
    ACTIONS(3623), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1598), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2823), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1939), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2660), 4,
      sym_abstract_method_signature,
      sym_public_field_definition,
      sym_index_signature,
      sym_method_signature,
    ACTIONS(2807), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3301), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76224] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(3635), 1,
      anon_sym_LBRACK,
    ACTIONS(3641), 1,
      sym_number,
    ACTIONS(3833), 1,
      anon_sym_RBRACE,
    ACTIONS(3835), 1,
      anon_sym_async,
    ACTIONS(3839), 1,
      anon_sym_static,
    ACTIONS(3843), 1,
      sym_readonly,
    STATE(1879), 1,
      sym_accessibility_modifier,
    STATE(2750), 1,
      aux_sym_object_repeat1,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(3837), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3841), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2752), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3831), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3216), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76356] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1737), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3072), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
    ACTIONS(1068), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1072), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1464), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3339), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76553] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3849), 1,
      anon_sym_LBRACK,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2944), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76665] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(3859), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3212), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3301), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3049), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3216), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76913] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3230), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2592), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1658), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77001] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2572), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1206), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77089] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3865), 1,
      sym_readonly,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77157] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3849), 1,
      anon_sym_LBRACK,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3121), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3317), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1116), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1114), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1050), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3293), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77453] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(3859), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3019), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3266), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77609] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(2952), 1,
      anon_sym_BANG,
    ACTIONS(2961), 1,
      anon_sym_as,
    ACTIONS(3081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3445), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3453), 1,
      anon_sym_AMP,
    ACTIONS(3455), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3461), 1,
      anon_sym_LT,
    ACTIONS(3465), 1,
      anon_sym_QMARK_QMARK,
    STATE(2549), 1,
      sym_type_arguments,
    ACTIONS(2957), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3449), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3457), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1522), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3441), 3,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3451), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3443), 4,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3463), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3129), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1112), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1110), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3333), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3329), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3867), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3306), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3308), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77981] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(3859), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3254), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3256), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3208), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3260), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3270), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3285), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3287), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3204), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3038), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(940), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(964), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(962), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2993), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78505] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3865), 1,
      sym_readonly,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78573] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_STAR,
    ACTIONS(131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(3635), 1,
      anon_sym_LBRACK,
    ACTIONS(3641), 1,
      sym_number,
    ACTIONS(3871), 1,
      anon_sym_async,
    ACTIONS(3875), 1,
      anon_sym_static,
    ACTIONS(3879), 1,
      sym_readonly,
    STATE(1879), 1,
      sym_accessibility_modifier,
    STATE(3110), 1,
      sym_array,
    STATE(3114), 1,
      sym_object,
    ACTIONS(2701), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3873), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3877), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2141), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2880), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3869), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3200), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2995), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3196), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3325), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2997), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78883] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3865), 1,
      sym_readonly,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3274), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1082), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3187), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3276), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3278), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79135] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3849), 1,
      anon_sym_LBRACK,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3131), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3063), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(954), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79293] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3849), 1,
      anon_sym_LBRACK,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3125), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1058), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1060), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79451] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3865), 1,
      sym_readonly,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3148), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(2765), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(958), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1016), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79703] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LBRACK,
    ACTIONS(2291), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_DOT,
    ACTIONS(3881), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1104), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1106), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1034), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1036), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3155), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(996), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(3135), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79987] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(3859), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1068), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1026), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2416), 1,
      anon_sym_DOT,
    ACTIONS(1068), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1046), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1006), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80287] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2874), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2886), 1,
      anon_sym_EQ,
    ACTIONS(1068), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 20,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1096), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(982), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(990), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(992), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80533] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2886), 1,
      anon_sym_EQ,
    ACTIONS(3014), 1,
      anon_sym_in,
    ACTIONS(3017), 1,
      anon_sym_of,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80590] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80649] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2874), 1,
      anon_sym_EQ,
    ACTIONS(3568), 1,
      anon_sym_in,
    ACTIONS(3571), 1,
      anon_sym_of,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80706] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3849), 1,
      anon_sym_LBRACK,
    ACTIONS(3883), 1,
      anon_sym_STAR,
    ACTIONS(3885), 1,
      anon_sym_async,
    ACTIONS(3887), 1,
      anon_sym_abstract,
    ACTIONS(3891), 1,
      sym_number,
    ACTIONS(3889), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1931), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80769] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3893), 1,
      anon_sym_STAR,
    ACTIONS(3895), 1,
      anon_sym_async,
    ACTIONS(3897), 1,
      anon_sym_abstract,
    ACTIONS(3901), 1,
      sym_number,
    ACTIONS(3899), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1933), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80832] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80891] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    ACTIONS(2841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3859), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80954] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3865), 1,
      sym_readonly,
    ACTIONS(2841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81021] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3849), 1,
      anon_sym_LBRACK,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    ACTIONS(2841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81086] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2874), 1,
      anon_sym_EQ,
    ACTIONS(3003), 1,
      anon_sym_in,
    ACTIONS(3006), 1,
      anon_sym_of,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81143] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81202] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 1,
      anon_sym_DOT,
    ACTIONS(2196), 1,
      anon_sym_LBRACK,
    ACTIONS(2198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2886), 1,
      anon_sym_EQ,
    ACTIONS(3577), 1,
      anon_sym_in,
    ACTIONS(3580), 1,
      anon_sym_of,
    ACTIONS(1068), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
    ACTIONS(1070), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81259] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81318] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3903), 1,
      anon_sym_STAR,
    ACTIONS(3905), 1,
      anon_sym_async,
    ACTIONS(3909), 1,
      sym_number,
    ACTIONS(3907), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1950), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81378] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_STAR,
    ACTIONS(3913), 1,
      anon_sym_async,
    ACTIONS(3917), 1,
      sym_number,
    ACTIONS(3919), 1,
      sym_readonly,
    ACTIONS(3915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1941), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81440] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3883), 1,
      anon_sym_STAR,
    ACTIONS(3885), 1,
      anon_sym_async,
    ACTIONS(3891), 1,
      sym_number,
    ACTIONS(3921), 1,
      sym_readonly,
    ACTIONS(3889), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1931), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81502] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3923), 1,
      anon_sym_STAR,
    ACTIONS(3925), 1,
      anon_sym_async,
    ACTIONS(3929), 1,
      sym_number,
    ACTIONS(3931), 1,
      sym_readonly,
    ACTIONS(3927), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1944), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81564] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3923), 1,
      anon_sym_STAR,
    ACTIONS(3925), 1,
      anon_sym_async,
    ACTIONS(3929), 1,
      sym_number,
    ACTIONS(3927), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1944), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81624] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_STAR,
    ACTIONS(3935), 1,
      sym_number,
    ACTIONS(3933), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2216), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81682] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3939), 1,
      anon_sym_async,
    ACTIONS(3943), 1,
      sym_number,
    ACTIONS(3945), 1,
      sym_readonly,
    ACTIONS(3941), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1948), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81744] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3939), 1,
      anon_sym_async,
    ACTIONS(3943), 1,
      sym_number,
    ACTIONS(3941), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1948), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81804] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3937), 1,
      anon_sym_STAR,
    ACTIONS(3949), 1,
      sym_number,
    ACTIONS(3947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2259), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2779), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1658), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81908] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    ACTIONS(2841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81966] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3951), 1,
      anon_sym_STAR,
    ACTIONS(3953), 1,
      anon_sym_async,
    ACTIONS(3957), 1,
      sym_number,
    ACTIONS(3955), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1945), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82026] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3951), 1,
      anon_sym_STAR,
    ACTIONS(3961), 1,
      sym_number,
    ACTIONS(3959), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82084] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3883), 1,
      anon_sym_STAR,
    ACTIONS(3965), 1,
      sym_number,
    ACTIONS(3963), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82142] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3967), 1,
      anon_sym_STAR,
    ACTIONS(3969), 1,
      anon_sym_async,
    ACTIONS(3973), 1,
      sym_number,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82202] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3903), 1,
      anon_sym_STAR,
    ACTIONS(3977), 1,
      sym_number,
    ACTIONS(3975), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82260] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3923), 1,
      anon_sym_STAR,
    ACTIONS(3981), 1,
      sym_number,
    ACTIONS(3979), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2256), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82318] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3983), 1,
      anon_sym_STAR,
    ACTIONS(3987), 1,
      sym_number,
    ACTIONS(3985), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2263), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82376] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3967), 1,
      anon_sym_STAR,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(3989), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2245), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82434] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3993), 1,
      anon_sym_STAR,
    ACTIONS(3997), 1,
      sym_number,
    ACTIONS(3995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2260), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3893), 1,
      anon_sym_STAR,
    ACTIONS(3895), 1,
      anon_sym_async,
    ACTIONS(3901), 1,
      sym_number,
    ACTIONS(3999), 1,
      sym_readonly,
    ACTIONS(3899), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1933), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82554] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4001), 1,
      anon_sym_STAR,
    ACTIONS(4005), 1,
      sym_number,
    ACTIONS(4003), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82612] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3849), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_STAR,
    ACTIONS(3913), 1,
      anon_sym_async,
    ACTIONS(3917), 1,
      sym_number,
    ACTIONS(3915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1941), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82672] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3893), 1,
      anon_sym_STAR,
    ACTIONS(4009), 1,
      sym_number,
    ACTIONS(4007), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2192), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82730] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3893), 1,
      anon_sym_STAR,
    ACTIONS(3895), 1,
      anon_sym_async,
    ACTIONS(3901), 1,
      sym_number,
    ACTIONS(3899), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1933), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      sym_number,
    STATE(2256), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82843] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82910] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      sym_number,
    STATE(2259), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82963] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3935), 1,
      sym_number,
    STATE(2216), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      anon_sym_DOT,
    ACTIONS(4019), 1,
      anon_sym_LPAREN,
    STATE(1822), 1,
      sym_arguments,
    ACTIONS(4015), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4013), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83114] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(1616), 1,
      sym_readonly,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4009), 1,
      sym_number,
    STATE(2192), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83236] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3997), 1,
      sym_number,
    STATE(2260), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83289] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      sym_number,
    STATE(2166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83342] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4023), 1,
      anon_sym_RPAREN,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    STATE(1797), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2895), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83415] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    ACTIONS(4029), 1,
      anon_sym_RPAREN,
    STATE(1797), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2895), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83488] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(4031), 1,
      anon_sym_RBRACE,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83553] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83620] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(1616), 1,
      sym_readonly,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83689] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83754] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    ACTIONS(4033), 1,
      anon_sym_RPAREN,
    STATE(1804), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2737), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83827] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83892] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    ACTIONS(4035), 1,
      anon_sym_RPAREN,
    STATE(1797), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2895), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83965] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(1616), 1,
      sym_readonly,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(4031), 1,
      anon_sym_RBRACE,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84132] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(4037), 1,
      sym_number,
    STATE(2058), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84185] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(4031), 1,
      anon_sym_RBRACE,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84252] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(446), 1,
      anon_sym_RPAREN,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    STATE(1800), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2634), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84325] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3977), 1,
      sym_number,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84378] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4005), 1,
      sym_number,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84431] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3961), 1,
      sym_number,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84484] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(4039), 1,
      anon_sym_RBRACE,
    STATE(2655), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84551] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    ACTIONS(4041), 1,
      anon_sym_RPAREN,
    STATE(1797), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2895), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84624] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    ACTIONS(4043), 1,
      anon_sym_RPAREN,
    STATE(1797), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2895), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84697] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3987), 1,
      sym_number,
    STATE(2263), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84750] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    ACTIONS(4045), 1,
      anon_sym_class,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2688), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84823] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84890] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    STATE(2245), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84943] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      sym_number,
    STATE(2207), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      sym_number,
    STATE(2048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(2807), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4051), 1,
      sym_number,
    STATE(2195), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85102] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(1616), 1,
      sym_readonly,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(4039), 1,
      anon_sym_RBRACE,
    STATE(2655), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85220] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(1616), 1,
      sym_readonly,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85289] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(4039), 1,
      anon_sym_RBRACE,
    STATE(2655), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85354] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    ACTIONS(4053), 1,
      anon_sym_RPAREN,
    STATE(1797), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2895), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85427] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4057), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4055), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85534] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85594] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2884), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85664] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85726] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85786] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2688), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85856] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(1616), 1,
      sym_readonly,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85920] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85980] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    STATE(1797), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2895), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86050] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4027), 1,
      sym_readonly,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    STATE(1910), 1,
      sym_accessibility_modifier,
    STATE(2106), 1,
      sym__parameter_name,
    STATE(2383), 1,
      sym_array,
    STATE(2386), 1,
      sym_object,
    STATE(2598), 1,
      sym__rest_identifier,
    ACTIONS(4021), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1680), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2612), 3,
      sym_optional_parameter,
      sym_rest_parameter,
      sym_required_parameter,
    ACTIONS(1668), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(2841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2779), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86168] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4039), 1,
      anon_sym_RBRACE,
    STATE(2655), 1,
      aux_sym_object_repeat1,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86228] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86288] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4031), 1,
      anon_sym_RBRACE,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86348] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_namespace,
    ACTIONS(1202), 1,
      anon_sym_type,
    ACTIONS(1204), 1,
      anon_sym_interface,
    ACTIONS(1215), 1,
      anon_sym_import,
    ACTIONS(1217), 1,
      anon_sym_const,
    ACTIONS(1219), 1,
      anon_sym_enum,
    ACTIONS(1221), 1,
      anon_sym_var,
    ACTIONS(1223), 1,
      anon_sym_let,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(1251), 1,
      anon_sym_global,
    ACTIONS(1259), 1,
      anon_sym_declare,
    ACTIONS(1293), 1,
      anon_sym_module,
    STATE(545), 1,
      sym__declaration,
    STATE(598), 1,
      sym_internal_module,
    STATE(1908), 1,
      sym_decorator,
    STATE(2312), 1,
      aux_sym_export_statement_repeat1,
    STATE(566), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [86427] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_namespace,
    ACTIONS(1202), 1,
      anon_sym_type,
    ACTIONS(1204), 1,
      anon_sym_interface,
    ACTIONS(1206), 1,
      anon_sym_declare,
    ACTIONS(1215), 1,
      anon_sym_import,
    ACTIONS(1217), 1,
      anon_sym_const,
    ACTIONS(1219), 1,
      anon_sym_enum,
    ACTIONS(1221), 1,
      anon_sym_var,
    ACTIONS(1223), 1,
      anon_sym_let,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(1251), 1,
      anon_sym_global,
    ACTIONS(1253), 1,
      anon_sym_module,
    STATE(545), 1,
      sym__declaration,
    STATE(598), 1,
      sym_internal_module,
    STATE(1908), 1,
      sym_decorator,
    STATE(2312), 1,
      aux_sym_export_statement_repeat1,
    STATE(566), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [86506] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_namespace,
    ACTIONS(1202), 1,
      anon_sym_type,
    ACTIONS(1204), 1,
      anon_sym_interface,
    ACTIONS(1206), 1,
      anon_sym_declare,
    ACTIONS(1208), 1,
      anon_sym_module,
    ACTIONS(1215), 1,
      anon_sym_import,
    ACTIONS(1217), 1,
      anon_sym_const,
    ACTIONS(1219), 1,
      anon_sym_enum,
    ACTIONS(1221), 1,
      anon_sym_var,
    ACTIONS(1223), 1,
      anon_sym_let,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(4061), 1,
      anon_sym_default,
    STATE(584), 1,
      sym__declaration,
    STATE(598), 1,
      sym_internal_module,
    STATE(1908), 1,
      sym_decorator,
    STATE(2312), 1,
      aux_sym_export_statement_repeat1,
    STATE(566), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [86585] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86640] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(1196), 1,
      anon_sym_namespace,
    ACTIONS(1202), 1,
      anon_sym_type,
    ACTIONS(1204), 1,
      anon_sym_interface,
    ACTIONS(1208), 1,
      anon_sym_module,
    ACTIONS(1215), 1,
      anon_sym_import,
    ACTIONS(1217), 1,
      anon_sym_const,
    ACTIONS(1219), 1,
      anon_sym_enum,
    ACTIONS(1221), 1,
      anon_sym_var,
    ACTIONS(1223), 1,
      anon_sym_let,
    ACTIONS(1230), 1,
      anon_sym_class,
    ACTIONS(1232), 1,
      anon_sym_async,
    ACTIONS(1234), 1,
      anon_sym_function,
    ACTIONS(1236), 1,
      anon_sym_abstract,
    ACTIONS(1259), 1,
      anon_sym_declare,
    ACTIONS(4061), 1,
      anon_sym_default,
    STATE(584), 1,
      sym__declaration,
    STATE(598), 1,
      sym_internal_module,
    STATE(1908), 1,
      sym_decorator,
    STATE(2312), 1,
      aux_sym_export_statement_repeat1,
    STATE(566), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [86719] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2787), 1,
      anon_sym_module,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    ACTIONS(4063), 1,
      anon_sym_default,
    STATE(1908), 1,
      sym_decorator,
    STATE(2420), 1,
      sym__declaration,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [86798] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(2777), 1,
      anon_sym_namespace,
    ACTIONS(2781), 1,
      anon_sym_type,
    ACTIONS(2783), 1,
      anon_sym_interface,
    ACTIONS(2785), 1,
      anon_sym_declare,
    ACTIONS(2789), 1,
      anon_sym_import,
    ACTIONS(2791), 1,
      anon_sym_const,
    ACTIONS(2793), 1,
      anon_sym_enum,
    ACTIONS(2795), 1,
      anon_sym_var,
    ACTIONS(2797), 1,
      anon_sym_let,
    ACTIONS(2799), 1,
      anon_sym_class,
    ACTIONS(2801), 1,
      anon_sym_async,
    ACTIONS(2803), 1,
      anon_sym_function,
    ACTIONS(2805), 1,
      anon_sym_abstract,
    ACTIONS(4065), 1,
      anon_sym_global,
    ACTIONS(4067), 1,
      anon_sym_module,
    STATE(1908), 1,
      sym_decorator,
    STATE(2447), 1,
      sym__declaration,
    STATE(2451), 1,
      sym_internal_module,
    STATE(2463), 1,
      aux_sym_export_statement_repeat1,
    STATE(2454), 13,
      sym_type_alias_declaration,
      sym_interface_declaration,
      sym_ambient_declaration,
      sym_import_alias,
      sym_enum_declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_module,
      sym_abstract_class_declaration,
      sym_function_signature,
  [86877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3264), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_RBRACE,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4013), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2942), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4069), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3119), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87227] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(4039), 1,
      anon_sym_RBRACE,
    STATE(2655), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(4059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1660), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1658), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4073), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4077), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4081), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4085), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4089), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4097), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4095), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4093), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87602] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4099), 1,
      anon_sym_EQ_GT,
    ACTIONS(4101), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87652] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4101), 1,
      sym_number,
    ACTIONS(4103), 1,
      anon_sym_STAR,
    ACTIONS(4105), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87704] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4101), 1,
      sym_number,
    ACTIONS(4103), 1,
      anon_sym_STAR,
    ACTIONS(4107), 1,
      anon_sym_async,
    ACTIONS(4105), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87758] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4101), 1,
      sym_number,
    ACTIONS(4103), 1,
      anon_sym_STAR,
    ACTIONS(4107), 1,
      anon_sym_async,
    ACTIONS(4109), 1,
      sym_readonly,
    ACTIONS(4105), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(942), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4111), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 1,
      sym__automatic_semicolon,
    ACTIONS(918), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(920), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(964), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4119), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4117), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4123), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4121), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4125), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88082] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4129), 1,
      anon_sym_STAR,
    ACTIONS(4131), 1,
      anon_sym_async,
    ACTIONS(4135), 1,
      sym_number,
    ACTIONS(4133), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4137), 1,
      sym__automatic_semicolon,
    ACTIONS(962), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(964), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4139), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4143), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88252] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4129), 1,
      anon_sym_STAR,
    ACTIONS(4135), 1,
      sym_number,
    ACTIONS(4133), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88304] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4147), 1,
      anon_sym_STAR,
    ACTIONS(4151), 1,
      sym_number,
    ACTIONS(4149), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2250), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4153), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88394] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4151), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2250), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88441] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4009), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2192), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88488] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3987), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2263), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88535] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4135), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88582] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4157), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2244), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88629] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    STATE(2282), 1,
      sym_array,
    STATE(2283), 1,
      sym_object,
    ACTIONS(4159), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2444), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(4161), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88676] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2245), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88723] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2259), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3977), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88817] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3997), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2260), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2256), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4005), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3961), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89005] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4101), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89052] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4163), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2178), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89099] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    STATE(2406), 1,
      sym_array,
    STATE(2441), 1,
      sym_object,
    ACTIONS(1702), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1697), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(708), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4165), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2243), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89193] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4167), 1,
      sym_number,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2152), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89240] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4169), 1,
      anon_sym_RBRACE,
    ACTIONS(4171), 1,
      sym_number,
    STATE(2749), 1,
      sym_enum_assignment,
    STATE(2415), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4177), 1,
      anon_sym_AT,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
    ACTIONS(4175), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4173), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89330] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      anon_sym_RBRACE,
    ACTIONS(4182), 1,
      sym_number,
    STATE(2979), 1,
      sym_enum_assignment,
    STATE(2609), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89378] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4182), 1,
      sym_number,
    ACTIONS(4184), 1,
      anon_sym_RBRACE,
    STATE(2979), 1,
      sym_enum_assignment,
    STATE(2609), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89426] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4182), 1,
      sym_number,
    ACTIONS(4186), 1,
      anon_sym_RBRACE,
    STATE(2979), 1,
      sym_enum_assignment,
    STATE(2609), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89474] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4188), 1,
      anon_sym_RBRACE,
    ACTIONS(4190), 1,
      sym_number,
    STATE(2698), 1,
      sym_enum_assignment,
    STATE(2291), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89522] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4182), 1,
      sym_number,
    ACTIONS(4192), 1,
      anon_sym_RBRACE,
    STATE(2979), 1,
      sym_enum_assignment,
    STATE(2609), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89570] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3883), 1,
      anon_sym_STAR,
    ACTIONS(3885), 1,
      anon_sym_async,
    ACTIONS(3891), 1,
      sym_number,
    ACTIONS(4194), 1,
      anon_sym_abstract,
    ACTIONS(4196), 1,
      anon_sym_static,
    ACTIONS(4198), 1,
      sym_readonly,
    ACTIONS(3889), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1931), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2807), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4200), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1660), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(1697), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(1658), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89699] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(1612), 1,
      anon_sym_async,
    ACTIONS(1616), 1,
      sym_readonly,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4011), 1,
      anon_sym_STAR,
    ACTIONS(4202), 1,
      anon_sym_static,
    ACTIONS(1614), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89752] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3845), 1,
      anon_sym_STAR,
    ACTIONS(3851), 1,
      anon_sym_async,
    ACTIONS(3855), 1,
      sym_number,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3865), 1,
      sym_readonly,
    ACTIONS(4204), 1,
      anon_sym_static,
    ACTIONS(3853), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2807), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4182), 1,
      sym_number,
    STATE(2979), 1,
      sym_enum_assignment,
    STATE(2609), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89850] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_STAR,
    ACTIONS(3913), 1,
      anon_sym_async,
    ACTIONS(3917), 1,
      sym_number,
    ACTIONS(3919), 1,
      sym_readonly,
    ACTIONS(4206), 1,
      anon_sym_static,
    ACTIONS(3915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1941), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2807), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89903] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(4208), 1,
      anon_sym_STAR,
    ACTIONS(4212), 1,
      sym_number,
    ACTIONS(4214), 1,
      sym_readonly,
    ACTIONS(4210), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1935), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89952] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(4216), 1,
      anon_sym_STAR,
    ACTIONS(4220), 1,
      sym_number,
    ACTIONS(4222), 1,
      sym_readonly,
    ACTIONS(4218), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1938), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2807), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90001] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4051), 1,
      sym_number,
    STATE(2195), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3987), 1,
      sym_number,
    STATE(2263), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4165), 1,
      sym_number,
    STATE(2243), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(4037), 1,
      sym_number,
    STATE(2058), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2807), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90169] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4167), 1,
      sym_number,
    STATE(2152), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4151), 1,
      sym_number,
    STATE(2250), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90253] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    STATE(2245), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90295] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4163), 1,
      sym_number,
    STATE(2178), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90337] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(3863), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      sym_number,
    STATE(2048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2807), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90379] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      sym_number,
    STATE(2166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90421] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3861), 1,
      sym_number,
    STATE(2206), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3961), 1,
      sym_number,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90505] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4009), 1,
      sym_number,
    STATE(2192), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4101), 1,
      sym_number,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3981), 1,
      sym_number,
    STATE(2256), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4157), 1,
      sym_number,
    STATE(2244), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90673] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3977), 1,
      sym_number,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90715] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(1352), 1,
      sym_number,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    STATE(2230), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90757] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      sym_number,
    STATE(2259), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4005), 1,
      sym_number,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3997), 1,
      sym_number,
    STATE(2260), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90883] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4047), 1,
      sym_number,
    STATE(2207), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90925] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(3935), 1,
      sym_number,
    STATE(2216), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4226), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(4224), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_class,
      anon_sym_async,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91001] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(3857), 1,
      anon_sym_LBRACK,
    ACTIONS(4135), 1,
      sym_number,
    STATE(2165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1610), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91043] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4228), 1,
      sym_readonly,
    STATE(2406), 1,
      sym_array,
    STATE(2441), 1,
      sym_object,
    ACTIONS(1702), 2,
      sym_identifier,
      sym_this,
    ACTIONS(708), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      sym_identifier,
    STATE(3038), 1,
      sym_mapped_type_clause,
    ACTIONS(4232), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_async,
      anon_sym_get,
      anon_sym_set,
      anon_sym_static,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91115] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    ACTIONS(4234), 1,
      anon_sym_DOT,
    ACTIONS(4236), 1,
      anon_sym_LT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1586), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [91147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_EQ,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4238), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1710), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [91179] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_EQ,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4238), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1718), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [91211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 1,
      anon_sym_EQ,
    ACTIONS(4236), 1,
      anon_sym_LT,
    STATE(286), 1,
      sym_type_arguments,
    ACTIONS(1737), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [91240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 1,
      anon_sym_EQ,
    ACTIONS(1426), 1,
      anon_sym_LT,
    ACTIONS(996), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [91267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_EQ,
    ACTIONS(4236), 1,
      anon_sym_LT,
    STATE(286), 1,
      sym_type_arguments,
    ACTIONS(1504), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [91296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    ACTIONS(4234), 1,
      anon_sym_DOT,
    ACTIONS(1586), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
  [91322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 1,
      anon_sym_PIPE,
    ACTIONS(944), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [91346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_PIPE,
    ACTIONS(1072), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [91370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4244), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1776), 1,
      anon_sym_EQ,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(1774), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_GT,
  [91462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_EQ,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(1764), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_GT,
  [91489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4252), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91531] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_EQ,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(1754), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_GT,
  [91560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4256), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91581] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_DOT,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(4262), 1,
      anon_sym_is,
    STATE(1994), 1,
      sym_type_arguments,
    ACTIONS(1718), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91611] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4268), 1,
      anon_sym_BANG,
    ACTIONS(4270), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2286), 1,
      sym__call_signature,
    STATE(2287), 1,
      sym_type_annotation,
    STATE(2711), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4266), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91653] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_DOT,
    ACTIONS(4260), 1,
      anon_sym_LT,
    STATE(1994), 1,
      sym_type_arguments,
    ACTIONS(1718), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91681] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4274), 1,
      anon_sym_BANG,
    ACTIONS(4276), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2367), 1,
      sym__call_signature,
    STATE(2371), 1,
      sym_type_annotation,
    STATE(2663), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4272), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_PIPE,
    ACTIONS(4258), 1,
      anon_sym_DOT,
    ACTIONS(4260), 1,
      anon_sym_LT,
    STATE(1994), 1,
      sym_type_arguments,
    ACTIONS(1710), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91751] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4268), 1,
      anon_sym_BANG,
    ACTIONS(4278), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2287), 1,
      sym_type_annotation,
    STATE(2711), 1,
      sym__initializer,
    STATE(2713), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4266), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91793] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(4280), 1,
      anon_sym_DOT,
    STATE(1994), 1,
      sym_type_arguments,
    ACTIONS(1586), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91821] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4284), 1,
      anon_sym_BANG,
    ACTIONS(4286), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2414), 1,
      sym__call_signature,
    STATE(2425), 1,
      sym_type_annotation,
    STATE(2756), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4282), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91863] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4274), 1,
      anon_sym_BANG,
    ACTIONS(4288), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2371), 1,
      sym_type_annotation,
    STATE(2661), 1,
      sym__call_signature,
    STATE(2663), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4272), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91905] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4292), 1,
      anon_sym_BANG,
    ACTIONS(4294), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2278), 1,
      sym_type_annotation,
    STATE(2279), 1,
      sym__call_signature,
    STATE(2731), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4290), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 1,
      anon_sym_PIPE,
    ACTIONS(1426), 1,
      anon_sym_LT,
    ACTIONS(996), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91970] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4298), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2299), 1,
      sym__call_signature,
    STATE(2306), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4296), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92005] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4238), 1,
      anon_sym_DOT,
    ACTIONS(4300), 1,
      anon_sym_EQ,
    ACTIONS(4305), 1,
      anon_sym_COLON,
    ACTIONS(4307), 1,
      anon_sym_extends,
    STATE(305), 1,
      sym_type_arguments,
    STATE(2610), 1,
      sym_constraint,
    STATE(2980), 1,
      sym_default_type,
    ACTIONS(4302), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(1718), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [92042] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4312), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2274), 1,
      sym_type_annotation,
    STATE(2276), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4310), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92077] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4316), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2079), 1,
      sym__call_signature,
    STATE(2396), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4314), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92112] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4320), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2428), 1,
      sym__call_signature,
    STATE(2430), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4318), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92147] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4322), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2081), 1,
      sym__call_signature,
    STATE(2306), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4296), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_LT,
    STATE(1980), 1,
      sym_type_arguments,
    ACTIONS(1504), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92207] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4324), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2391), 1,
      sym__call_signature,
    STATE(2396), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4314), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_DOT,
    ACTIONS(1428), 1,
      anon_sym_PIPE,
    ACTIONS(1426), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [92265] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4326), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2117), 1,
      sym__call_signature,
    STATE(2430), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4318), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92300] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4328), 1,
      anon_sym_COLON,
    ACTIONS(4330), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2111), 1,
      sym__call_signature,
    STATE(2274), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4310), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 1,
      anon_sym_PIPE,
    ACTIONS(4260), 1,
      anon_sym_LT,
    STATE(1980), 1,
      sym_type_arguments,
    ACTIONS(1737), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92360] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2455), 1,
      sym__call_signature,
    STATE(2462), 1,
      sym_type_annotation,
    STATE(2783), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4332), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_PIPE,
    ACTIONS(4280), 1,
      anon_sym_DOT,
    ACTIONS(1586), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92418] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2464), 1,
      sym__call_signature,
    STATE(2469), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4334), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92450] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2408), 1,
      sym__call_signature,
    STATE(2411), 1,
      sym_type_annotation,
    STATE(2735), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92486] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4238), 1,
      anon_sym_DOT,
    ACTIONS(4338), 1,
      anon_sym_RPAREN,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1718), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2525), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [92514] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2107), 1,
      sym__call_signature,
    STATE(2429), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4341), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2121), 1,
      sym__call_signature,
    STATE(2469), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4334), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92578] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4238), 1,
      anon_sym_DOT,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1718), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4343), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [92604] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2363), 1,
      sym__call_signature,
    STATE(2380), 1,
      sym_type_annotation,
    STATE(2674), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4345), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92640] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2388), 1,
      sym__call_signature,
    STATE(2398), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4347), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92672] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2426), 1,
      sym__call_signature,
    STATE(2429), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4341), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92704] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2411), 1,
      sym_type_annotation,
    STATE(2733), 1,
      sym__call_signature,
    STATE(2735), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92740] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2292), 1,
      sym_type_annotation,
    STATE(2293), 1,
      sym__call_signature,
    STATE(2613), 1,
      sym__initializer,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4349), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92776] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2380), 1,
      sym_type_annotation,
    STATE(2674), 1,
      sym__initializer,
    STATE(2683), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4345), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92812] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2080), 1,
      sym__call_signature,
    STATE(2316), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4351), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92844] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2310), 1,
      sym__call_signature,
    STATE(2316), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4351), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2093), 1,
      sym__call_signature,
    STATE(2398), 1,
      sym_type_annotation,
    STATE(2803), 1,
      sym_type_parameters,
    ACTIONS(4347), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 1,
      anon_sym_PIPE,
    ACTIONS(4353), 1,
      anon_sym_LBRACK,
    ACTIONS(1598), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 1,
      anon_sym_PIPE,
    ACTIONS(1512), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 1,
      anon_sym_PIPE,
    ACTIONS(1516), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(1764), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 1,
      anon_sym_PIPE,
    ACTIONS(1524), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 1,
      anon_sym_PIPE,
    ACTIONS(1594), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_PIPE,
    ACTIONS(1504), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(1774), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [93108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 1,
      anon_sym_PIPE,
    ACTIONS(1464), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 1,
      anon_sym_PIPE,
    ACTIONS(1468), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 1,
      anon_sym_PIPE,
    ACTIONS(1490), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 1,
      anon_sym_PIPE,
    ACTIONS(1552), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 1,
      anon_sym_PIPE,
    ACTIONS(1556), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 1,
      anon_sym_PIPE,
    ACTIONS(1544), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 1,
      anon_sym_PIPE,
    ACTIONS(1570), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      anon_sym_PIPE,
    ACTIONS(1243), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(1754), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [93300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_PIPE,
    ACTIONS(1582), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      anon_sym_PIPE,
    ACTIONS(1536), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 1,
      anon_sym_PIPE,
    ACTIONS(4353), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 1,
      anon_sym_PIPE,
    ACTIONS(1472), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 1,
      anon_sym_PIPE,
    ACTIONS(1540), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1608), 1,
      anon_sym_PIPE,
    ACTIONS(1606), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 1,
      anon_sym_PIPE,
    ACTIONS(1602), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 1,
      anon_sym_PIPE,
    ACTIONS(1508), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      anon_sym_PIPE,
    ACTIONS(1566), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_PIPE,
    ACTIONS(1578), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_PIPE,
    ACTIONS(1586), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      anon_sym_PIPE,
    ACTIONS(1536), 3,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
    ACTIONS(1532), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 1,
      anon_sym_PIPE,
    ACTIONS(1500), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 1,
      anon_sym_PIPE,
    ACTIONS(1528), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_PIPE,
    ACTIONS(1574), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 1,
      anon_sym_PIPE,
    ACTIONS(1520), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      anon_sym_PIPE,
    ACTIONS(1590), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 1,
      anon_sym_PIPE,
    ACTIONS(1484), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 1,
      anon_sym_PIPE,
    ACTIONS(4262), 1,
      anon_sym_is,
    ACTIONS(1737), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [93705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 1,
      anon_sym_EQ,
    ACTIONS(3531), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93765] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4361), 1,
      sym_identifier,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    STATE(1612), 1,
      sym_class_body,
    STATE(2133), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2857), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [93799] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4369), 1,
      sym_identifier,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_class_body,
    STATE(2088), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(3001), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [93833] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4373), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_COLON,
    STATE(2164), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
    ACTIONS(4375), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93875] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4379), 1,
      sym_identifier,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1158), 1,
      sym_class_body,
    STATE(2096), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2887), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [93909] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(2763), 1,
      anon_sym_LBRACE,
    ACTIONS(4383), 1,
      sym_identifier,
    ACTIONS(4385), 1,
      anon_sym_STAR,
    STATE(2906), 1,
      sym_import_clause,
    STATE(2908), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3177), 2,
      sym_namespace_import,
      sym_named_imports,
  [93939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(2841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2779), 7,
      sym__automatic_semicolon,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_PIPE_RBRACE,
  [93959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4238), 1,
      anon_sym_DOT,
    ACTIONS(4387), 1,
      anon_sym_is,
    STATE(305), 1,
      sym_type_arguments,
    ACTIONS(1718), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [93983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_COLON,
    STATE(2227), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
    ACTIONS(4389), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94003] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4391), 1,
      sym_identifier,
    STATE(1631), 1,
      sym_class_body,
    STATE(2108), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2967), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94037] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4393), 1,
      sym_identifier,
    STATE(1631), 1,
      sym_class_body,
    STATE(2108), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2967), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94071] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4395), 1,
      sym_identifier,
    STATE(1631), 1,
      sym_class_body,
    STATE(2108), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2967), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94105] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4397), 1,
      sym_identifier,
    STATE(1180), 1,
      sym_class_body,
    STATE(2087), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2808), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94139] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    ACTIONS(4399), 1,
      sym_identifier,
    STATE(1642), 1,
      sym_class_body,
    STATE(2092), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2970), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94173] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4401), 1,
      sym_identifier,
    STATE(1612), 1,
      sym_class_body,
    STATE(2133), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2857), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94207] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4365), 1,
      anon_sym_implements,
    ACTIONS(4367), 1,
      anon_sym_extends,
    ACTIONS(4403), 1,
      sym_identifier,
    STATE(1612), 1,
      sym_class_body,
    STATE(2133), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2857), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94241] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2097), 1,
      sym_type_parameters,
    STATE(2416), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2869), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94272] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1620), 1,
      sym_class_body,
    STATE(2136), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2938), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94303] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4411), 1,
      sym_identifier,
    ACTIONS(4413), 1,
      anon_sym_RBRACK,
    STATE(2622), 1,
      sym__rest_identifier,
    STATE(2706), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2608), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [94328] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(553), 1,
      sym_class_body,
    STATE(2109), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2861), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1574), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [94376] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1365), 1,
      sym_class_body,
    STATE(2089), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2890), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4411), 1,
      sym_identifier,
    ACTIONS(4417), 1,
      anon_sym_RBRACK,
    STATE(2622), 1,
      sym__rest_identifier,
    STATE(2640), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2608), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [94432] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(88), 1,
      sym_class_body,
    STATE(2138), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2997), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_RPAREN,
    ACTIONS(1578), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2894), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4343), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [94499] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2084), 1,
      sym_type_parameters,
    STATE(2377), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2898), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94530] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1697), 1,
      sym_class_body,
    STATE(2102), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2929), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1243), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2444), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [94578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(924), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [94595] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1118), 1,
      sym_class_body,
    STATE(2083), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2905), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94626] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(533), 1,
      sym_class_body,
    STATE(2129), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2797), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94657] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2123), 1,
      sym_type_parameters,
    STATE(2387), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2883), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4421), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2425), 1,
      sym_type_annotation,
    STATE(2756), 1,
      sym__initializer,
    ACTIONS(4284), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4282), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94734] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1682), 1,
      sym_class_body,
    STATE(2099), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2959), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94765] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(614), 1,
      sym_class_body,
    STATE(2101), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2923), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94796] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1184), 1,
      sym_class_body,
    STATE(2100), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2874), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_RPAREN,
    ACTIONS(1737), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2525), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1445), 1,
      sym_class_body,
    STATE(2113), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2829), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4426), 1,
      anon_sym_EQ,
    ACTIONS(4373), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [94900] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(528), 1,
      sym_class_body,
    STATE(2085), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2957), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4428), 1,
      anon_sym_RPAREN,
    ACTIONS(1243), 4,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1697), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94950] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(92), 1,
      sym_class_body,
    STATE(2124), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2802), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [94981] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2371), 1,
      sym_type_annotation,
    STATE(2663), 1,
      sym__initializer,
    ACTIONS(4274), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4272), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95006] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1495), 1,
      sym_class_body,
    STATE(2145), 1,
      sym_type_parameters,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2856), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95037] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4411), 1,
      sym_identifier,
    ACTIONS(4431), 1,
      anon_sym_RBRACK,
    STATE(2622), 1,
      sym__rest_identifier,
    STATE(2767), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2608), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [95062] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2144), 1,
      sym_type_parameters,
    STATE(2342), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2924), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95093] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1186), 1,
      anon_sym_RBRACK,
    ACTIONS(4411), 1,
      sym_identifier,
    STATE(2622), 1,
      sym__rest_identifier,
    STATE(2614), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2608), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [95118] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1184), 1,
      anon_sym_RBRACK,
    ACTIONS(4411), 1,
      sym_identifier,
    STATE(2622), 1,
      sym__rest_identifier,
    STATE(2621), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2608), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [95143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(4031), 1,
      anon_sym_RBRACE,
    STATE(2696), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [95165] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1247), 1,
      anon_sym_RBRACE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2636), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [95187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1200), 1,
      anon_sym_RBRACE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [95209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    ACTIONS(4435), 1,
      anon_sym_DOT,
    STATE(2289), 1,
      sym_statement_block,
    ACTIONS(910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(1241), 1,
      anon_sym_RBRACE,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    STATE(2757), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [95251] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(4039), 1,
      anon_sym_RBRACE,
    STATE(2655), 1,
      aux_sym_object_repeat1,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [95273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(1768), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95293] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4437), 1,
      anon_sym_BANG,
    STATE(2475), 1,
      sym_type_annotation,
    STATE(2791), 1,
      sym__initializer,
    ACTIONS(2254), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4411), 1,
      sym_identifier,
    STATE(2622), 1,
      sym__rest_identifier,
    STATE(2912), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2608), 3,
      sym_rest_identifier,
      sym__tuple_type_identifier,
      sym_optional_identifier,
  [95339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4439), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4441), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2462), 1,
      sym_type_annotation,
    STATE(2783), 1,
      sym__initializer,
    ACTIONS(4332), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(2289), 1,
      sym_statement_block,
    ACTIONS(910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95417] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4443), 1,
      sym_identifier,
    ACTIONS(4445), 1,
      anon_sym_STAR,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2991), 1,
      sym__call_signature,
  [95442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2411), 1,
      sym_type_annotation,
    STATE(2735), 1,
      sym__initializer,
    ACTIONS(4336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2950), 1,
      sym_statement_block,
    ACTIONS(4449), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2838), 1,
      sym_statement_block,
    ACTIONS(4451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2831), 1,
      sym_statement_block,
    ACTIONS(4453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_enum,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    STATE(2135), 1,
      sym_array,
    STATE(2137), 1,
      sym_object,
    STATE(2586), 1,
      sym_variable_declarator,
  [95539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1179), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2931), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95564] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2313), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2925), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(535), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2994), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95614] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(4463), 1,
      sym_identifier,
    ACTIONS(4465), 1,
      anon_sym_DOT,
    STATE(2067), 1,
      sym_nested_identifier,
    STATE(2076), 1,
      sym_string,
    STATE(2444), 1,
      sym__module,
  [95639] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1156), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2833), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95664] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1639), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2985), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95689] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1464), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2922), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    STATE(2394), 1,
      sym_type_annotation,
    ACTIONS(4467), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95731] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(4469), 1,
      anon_sym_extends,
    ACTIONS(4471), 1,
      anon_sym_LT,
    STATE(2337), 1,
      sym_type_parameters,
    STATE(2436), 1,
      sym_object_type,
    STATE(2649), 1,
      sym_extends_clause,
  [95756] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1640), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2851), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2946), 1,
      sym_statement_block,
    ACTIONS(4473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4262), 1,
      anon_sym_is,
    ACTIONS(4475), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95826] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1192), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2894), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95851] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2378), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2897), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95876] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4479), 1,
      sym_identifier,
    ACTIONS(4481), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2858), 1,
      sym__call_signature,
  [95901] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1687), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2933), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95926] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1126), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2900), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95951] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(599), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(3004), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [95976] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1707), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2917), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    STATE(2304), 1,
      sym_type_annotation,
    ACTIONS(4483), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4485), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4487), 1,
      sym_identifier,
    ACTIONS(4489), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2999), 1,
      sym__call_signature,
  [96056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(4491), 1,
      anon_sym_EQ,
    ACTIONS(4495), 1,
      anon_sym_QMARK,
    STATE(2545), 1,
      sym_type_annotation,
    STATE(3007), 1,
      sym__initializer,
    ACTIONS(4493), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [96079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(3006), 1,
      sym_statement_block,
    ACTIONS(4497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96096] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1629), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2801), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(580), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2909), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4499), 1,
      sym_identifier,
    ACTIONS(4501), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2815), 1,
      sym__call_signature,
    STATE(2817), 1,
      sym_type_parameters,
  [96171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2939), 1,
      sym_statement_block,
    ACTIONS(4503), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96188] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4505), 1,
      anon_sym_enum,
    STATE(2135), 1,
      sym_array,
    STATE(2137), 1,
      sym_object,
    STATE(2509), 1,
      sym_variable_declarator,
  [96213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1354), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2878), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_EQ,
    ACTIONS(4059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2779), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [96255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(3009), 1,
      sym_statement_block,
    ACTIONS(4509), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96298] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4511), 1,
      sym_identifier,
    ACTIONS(4513), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2984), 1,
      sym__call_signature,
  [96323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(4515), 1,
      sym_identifier,
    ACTIONS(4517), 1,
      anon_sym_DOT,
    STATE(515), 1,
      sym_nested_identifier,
    STATE(534), 1,
      sym_string,
    STATE(546), 1,
      sym__module,
  [96348] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2292), 1,
      sym_type_annotation,
    STATE(2613), 1,
      sym__initializer,
    ACTIONS(4349), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2972), 1,
      sym_statement_block,
    ACTIONS(4519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2380), 1,
      sym_type_annotation,
    STATE(2674), 1,
      sym__initializer,
    ACTIONS(4345), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96407] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2351), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2920), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96432] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(79), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2921), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4521), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym_is,
    ACTIONS(1737), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [96485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 1,
      anon_sym_EQ,
    STATE(2610), 1,
      sym_constraint,
    STATE(2980), 1,
      sym_default_type,
    ACTIONS(4305), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(4523), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [96506] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(4469), 1,
      anon_sym_extends,
    ACTIONS(4471), 1,
      anon_sym_LT,
    STATE(551), 1,
      sym_object_type,
    STATE(2457), 1,
      sym_type_parameters,
    STATE(2780), 1,
      sym_extends_clause,
  [96531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(525), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2943), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96556] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4525), 1,
      sym_identifier,
    ACTIONS(4527), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2858), 1,
      sym__call_signature,
  [96581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2910), 1,
      sym_statement_block,
    ACTIONS(4529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1595), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2993), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4531), 1,
      sym_identifier,
    ACTIONS(4533), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2858), 1,
      sym__call_signature,
  [96661] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2485), 1,
      sym_type_annotation,
    STATE(2639), 1,
      sym__initializer,
    ACTIONS(3001), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96682] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1521), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2841), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2484), 1,
      sym_type_annotation,
    STATE(2666), 1,
      sym__initializer,
    ACTIONS(3012), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96728] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(72), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2868), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96753] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4535), 1,
      sym_identifier,
    ACTIONS(4537), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2991), 1,
      sym__call_signature,
  [96778] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(4515), 1,
      sym_identifier,
    ACTIONS(4539), 1,
      anon_sym_DOT,
    STATE(515), 1,
      sym_nested_identifier,
    STATE(534), 1,
      sym_string,
    STATE(546), 1,
      sym__module,
  [96803] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4541), 1,
      anon_sym_COLON,
    ACTIONS(4543), 1,
      anon_sym_QMARK,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2889), 1,
      sym__call_signature,
  [96828] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4545), 1,
      sym_identifier,
    ACTIONS(4547), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2991), 1,
      sym__call_signature,
  [96853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2944), 1,
      sym_statement_block,
    ACTIONS(4549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96870] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(2321), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2952), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(4409), 1,
      anon_sym_extends,
    STATE(1508), 1,
      sym_class_body,
    STATE(2645), 1,
      sym_extends_clause,
    STATE(2963), 1,
      sym_class_heritage,
    STATE(3155), 1,
      sym_implements_clause,
  [96920] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4551), 1,
      sym_identifier,
    ACTIONS(4553), 1,
      anon_sym_STAR,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2836), 1,
      sym__call_signature,
  [96945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2955), 1,
      sym_statement_block,
    ACTIONS(4555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2934), 1,
      sym_statement_block,
    ACTIONS(4557), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [96991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2183), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4561), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4559), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4563), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2881), 1,
      sym__call_signature,
  [97029] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4565), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2148), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [97051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 1,
      anon_sym_default,
    ACTIONS(4570), 1,
      anon_sym_RBRACE,
    ACTIONS(4572), 1,
      anon_sym_case,
    STATE(2153), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [97069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4575), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2837), 1,
      sym__call_signature,
  [97091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_default,
    ACTIONS(4579), 1,
      anon_sym_RBRACE,
    ACTIONS(4581), 1,
      anon_sym_case,
    STATE(2153), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [97109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2850), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4583), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2235), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4587), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4585), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_typeof,
    ACTIONS(4589), 1,
      sym_identifier,
    STATE(1363), 1,
      sym_nested_type_identifier,
    STATE(3062), 1,
      sym_nested_identifier,
    STATE(1610), 2,
      sym_generic_type,
      sym_type_query,
  [97161] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4591), 1,
      anon_sym_COMMA,
    ACTIONS(4593), 1,
      anon_sym_GT,
    STATE(2771), 1,
      aux_sym_implements_clause_repeat1,
  [97183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2168), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4597), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4595), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97199] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4599), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2989), 1,
      sym__call_signature,
  [97221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LBRACK,
    STATE(1127), 1,
      sym_arguments,
    STATE(2860), 1,
      sym_type_arguments,
  [97243] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4605), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2867), 1,
      sym__call_signature,
  [97265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4607), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4609), 1,
      anon_sym_QMARK,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2956), 1,
      sym__call_signature,
  [97299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4611), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2286), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [97321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2181), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 1,
      anon_sym_typeof,
    ACTIONS(4615), 1,
      sym_identifier,
    STATE(1947), 1,
      sym_nested_type_identifier,
    STATE(3017), 1,
      sym_nested_identifier,
    STATE(1978), 2,
      sym_generic_type,
      sym_type_query,
  [97373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4617), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2989), 1,
      sym__call_signature,
  [97395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2854), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4619), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97411] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4621), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2867), 1,
      sym__call_signature,
  [97433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [97445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2852), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4623), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4389), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(2968), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [97477] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4627), 1,
      sym_identifier,
    STATE(2135), 1,
      sym_array,
    STATE(2137), 1,
      sym_object,
    STATE(2682), 1,
      sym_variable_declarator,
  [97499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2481), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [97517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4633), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2476), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [97539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2872), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4635), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2174), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2872), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4635), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2860), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4637), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2480), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [97605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2862), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4639), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97621] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4641), 1,
      anon_sym_COMMA,
    ACTIONS(4643), 1,
      anon_sym_GT,
    STATE(2618), 1,
      aux_sym_implements_clause_repeat1,
  [97643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2156), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4647), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4645), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 1,
      anon_sym_typeof,
    ACTIONS(4649), 1,
      sym_identifier,
    STATE(494), 1,
      sym_nested_type_identifier,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(421), 2,
      sym_generic_type,
      sym_type_query,
  [97679] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4651), 1,
      anon_sym_COMMA,
    ACTIONS(4653), 1,
      anon_sym_GT,
    STATE(2792), 1,
      aux_sym_implements_clause_repeat1,
  [97701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4655), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2466), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [97723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4659), 1,
      anon_sym_BQUOTE,
    ACTIONS(4661), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4657), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2205), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [97741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2364), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [97759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2171), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2862), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4639), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97775] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4663), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2367), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [97797] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4665), 1,
      sym_identifier,
    ACTIONS(4667), 1,
      anon_sym_LBRACK,
    STATE(1692), 1,
      sym_arguments,
    STATE(2974), 1,
      sym_type_arguments,
  [97819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4669), 1,
      anon_sym_export,
    ACTIONS(4671), 1,
      anon_sym_class,
    ACTIONS(4673), 1,
      anon_sym_abstract,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [97841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4675), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2661), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [97863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    ACTIONS(4491), 1,
      anon_sym_EQ,
    STATE(2543), 1,
      sym_type_annotation,
    STATE(2893), 1,
      sym__initializer,
    ACTIONS(4677), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [97883] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4679), 1,
      sym_identifier,
    ACTIONS(4681), 1,
      anon_sym_LBRACK,
    STATE(1494), 1,
      sym_arguments,
    STATE(2977), 1,
      sym_type_arguments,
  [97905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4683), 1,
      anon_sym_BQUOTE,
    ACTIONS(4657), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2205), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [97923] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(3159), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3222), 1,
      anon_sym_LBRACE,
    ACTIONS(4685), 1,
      anon_sym_LT,
    STATE(2553), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2718), 1,
      sym_type_arguments,
  [97945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4687), 1,
      anon_sym_BQUOTE,
    ACTIONS(4657), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2205), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [97963] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4689), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2428), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [97985] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4627), 1,
      sym_identifier,
    STATE(2135), 1,
      sym_array,
    STATE(2137), 1,
      sym_object,
    STATE(2516), 1,
      sym_variable_declarator,
  [98007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4627), 1,
      sym_identifier,
    STATE(2135), 1,
      sym_array,
    STATE(2137), 1,
      sym_object,
    STATE(2509), 1,
      sym_variable_declarator,
  [98029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2868), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4691), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_BQUOTE,
    ACTIONS(4698), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4693), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2205), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [98063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4701), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2081), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [98085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4703), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2754), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [98107] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4705), 1,
      anon_sym_COMMA,
    ACTIONS(4707), 1,
      anon_sym_GT,
    STATE(2647), 1,
      aux_sym_implements_clause_repeat1,
  [98129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2179), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4711), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4709), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_typeof,
    ACTIONS(4713), 1,
      sym_identifier,
    STATE(1273), 1,
      sym_nested_type_identifier,
    STATE(3118), 1,
      sym_nested_identifier,
    STATE(1425), 2,
      sym_generic_type,
      sym_type_query,
  [98165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4715), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [98183] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2867), 1,
      sym__call_signature,
  [98205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2419), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [98223] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4719), 1,
      sym_identifier,
    ACTIONS(4721), 1,
      anon_sym_LBRACK,
    STATE(1569), 1,
      sym_arguments,
    STATE(2877), 1,
      sym_type_arguments,
  [98245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4723), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [98263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4725), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2299), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [98285] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    ACTIONS(4236), 1,
      anon_sym_LT,
    STATE(286), 1,
      sym_type_arguments,
    STATE(2531), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3159), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [98305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2258), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2850), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4583), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(4515), 1,
      sym_identifier,
    STATE(515), 1,
      sym_nested_identifier,
    STATE(534), 1,
      sym_string,
    STATE(546), 1,
      sym__module,
  [98343] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4727), 1,
      anon_sym_LBRACE,
    ACTIONS(4729), 1,
      anon_sym_COMMA,
    STATE(2738), 1,
      aux_sym_implements_clause_repeat1,
  [98365] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4731), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2951), 1,
      sym__call_signature,
  [98387] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    ACTIONS(4515), 1,
      sym_identifier,
    STATE(515), 1,
      sym_nested_identifier,
    STATE(534), 1,
      sym_string,
    STATE(574), 1,
      sym__module,
  [98409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_default,
    ACTIONS(4581), 1,
      anon_sym_case,
    ACTIONS(4733), 1,
      anon_sym_RBRACE,
    STATE(2155), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [98427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4673), 1,
      anon_sym_abstract,
    ACTIONS(4735), 1,
      anon_sym_export,
    ACTIONS(4737), 1,
      anon_sym_class,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [98449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4375), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(2872), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [98477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4741), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2450), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [98507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4743), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2983), 1,
      sym__call_signature,
  [98529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4745), 1,
      anon_sym_QMARK,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2941), 1,
      sym__call_signature,
  [98551] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4747), 1,
      anon_sym_COMMA,
    ACTIONS(4749), 1,
      anon_sym_GT,
    STATE(2703), 1,
      aux_sym_implements_clause_repeat1,
  [98573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2446), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [98591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_typeof,
    ACTIONS(4751), 1,
      sym_identifier,
    STATE(1917), 1,
      sym_nested_type_identifier,
    STATE(3142), 1,
      sym_nested_identifier,
    STATE(421), 2,
      sym_generic_type,
      sym_type_query,
  [98611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2449), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [98629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2866), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4753), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4757), 1,
      anon_sym_BQUOTE,
    ACTIONS(4755), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2200), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [98663] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4759), 1,
      sym_identifier,
    ACTIONS(4761), 1,
      anon_sym_LBRACK,
    STATE(1651), 1,
      sym_arguments,
    STATE(2990), 1,
      sym_type_arguments,
  [98685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(4463), 1,
      sym_identifier,
    STATE(2067), 1,
      sym_nested_identifier,
    STATE(2076), 1,
      sym_string,
    STATE(2280), 1,
      sym__module,
  [98707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2204), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2866), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4753), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    ACTIONS(4463), 1,
      sym_identifier,
    STATE(2067), 1,
      sym_nested_identifier,
    STATE(2076), 1,
      sym_string,
    STATE(2444), 1,
      sym__module,
  [98745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4765), 1,
      anon_sym_BQUOTE,
    ACTIONS(4763), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2198), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [98763] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    ACTIONS(4236), 1,
      anon_sym_LT,
    ACTIONS(4767), 1,
      sym_identifier,
    ACTIONS(4769), 1,
      anon_sym_LBRACK,
    STATE(1187), 1,
      sym_arguments,
    STATE(2824), 1,
      sym_type_arguments,
  [98785] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4771), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2471), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [98807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4773), 1,
      anon_sym_QMARK,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2953), 1,
      sym__call_signature,
  [98829] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4775), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2414), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [98851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(4779), 1,
      anon_sym_BQUOTE,
    ACTIONS(4777), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2189), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [98869] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4781), 1,
      anon_sym_COMMA,
    ACTIONS(4783), 1,
      anon_sym_GT,
    STATE(2710), 1,
      aux_sym_implements_clause_repeat1,
  [98891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2440), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [98909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_typeof,
    ACTIONS(4785), 1,
      sym_identifier,
    STATE(1014), 1,
      sym_nested_type_identifier,
    STATE(3055), 1,
      sym_nested_identifier,
    STATE(1054), 2,
      sym_generic_type,
      sym_type_query,
  [98929] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4787), 1,
      anon_sym_QMARK,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2978), 1,
      sym__call_signature,
  [98951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    ACTIONS(4629), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(4631), 1,
      anon_sym_QMARK_COLON,
    STATE(2468), 3,
      sym_type_annotation,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
  [98969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4789), 1,
      anon_sym_QMARK,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2832), 1,
      sym__call_signature,
  [98991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4475), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99003] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4627), 1,
      sym_identifier,
    STATE(2135), 1,
      sym_array,
    STATE(2137), 1,
      sym_object,
    STATE(2586), 1,
      sym_variable_declarator,
  [99025] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4461), 1,
      anon_sym_LBRACK,
    ACTIONS(4627), 1,
      sym_identifier,
    STATE(2135), 1,
      sym_array,
    STATE(2137), 1,
      sym_object,
    STATE(2593), 1,
      sym_variable_declarator,
  [99047] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4791), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2079), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4793), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2117), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(2844), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4795), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99107] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4797), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2391), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99129] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4799), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2147), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4804), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4801), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99167] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    ACTIONS(4806), 1,
      sym_identifier,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2989), 1,
      sym__call_signature,
  [99189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    ACTIONS(4808), 1,
      anon_sym_QMARK,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2460), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2907), 1,
      sym__call_signature,
  [99230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4421), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [99247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2937), 1,
      sym__call_signature,
  [99266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 1,
      anon_sym_DOT,
    ACTIONS(1428), 1,
      anon_sym_LBRACE,
    ACTIONS(1426), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [99281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4810), 1,
      anon_sym_EQ_GT,
    STATE(2968), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [99296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2948), 1,
      sym__call_signature,
  [99315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4812), 1,
      anon_sym_EQ_GT,
    STATE(2872), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [99330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [99341] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2962), 1,
      sym__call_signature,
  [99360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4816), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [99377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4822), 1,
      anon_sym_PIPE,
    ACTIONS(4820), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4503), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99416] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2602), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2694), 1,
      sym__initializer,
    ACTIONS(4824), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1829), 1,
      sym_statement_block,
    ACTIONS(4503), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1110), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1704), 1,
      anon_sym_LBRACE,
    ACTIONS(4025), 1,
      anon_sym_LBRACK,
    ACTIONS(4828), 1,
      sym_identifier,
    STATE(3070), 1,
      sym_object,
    STATE(3105), 1,
      sym_array,
  [99495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4832), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1830), 1,
      sym_statement_block,
    ACTIONS(4453), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2684), 1,
      sym__initializer,
    ACTIONS(4838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2546), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2363), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99618] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 1,
      anon_sym_EQ,
    ACTIONS(4840), 1,
      anon_sym_COMMA,
    ACTIONS(4842), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      aux_sym_enum_body_repeat1,
    STATE(2871), 1,
      sym__initializer,
  [99637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2693), 1,
      sym__initializer,
    ACTIONS(4844), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1831), 1,
      sym_statement_block,
    ACTIONS(4451), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_LT,
    STATE(286), 1,
      sym_type_arguments,
    ACTIONS(3386), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [99682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2875), 1,
      sym__call_signature,
  [99712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2388), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4848), 1,
      anon_sym_COMMA,
    ACTIONS(4850), 1,
      anon_sym_RBRACE,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    STATE(2732), 1,
      sym__import_export_specifier,
  [99805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4467), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4854), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2521), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [99868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4804), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2898), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [99901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4673), 1,
      anon_sym_abstract,
    ACTIONS(4856), 1,
      anon_sym_class,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [99920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1000), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1894), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4858), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [99986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1030), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4862), 1,
      anon_sym_EQ_GT,
    STATE(2968), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [100012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2030), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2882), 1,
      sym__call_signature,
  [100064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1838), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1842), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2026), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2504), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    ACTIONS(4864), 1,
      anon_sym_COMMA,
    ACTIONS(4866), 1,
      anon_sym_RBRACE,
    STATE(2784), 1,
      sym__import_export_specifier,
  [100135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2901), 1,
      sym__call_signature,
  [100154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(1768), 2,
      anon_sym_else,
      anon_sym_while,
  [100171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2903), 1,
      sym__call_signature,
  [100190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4822), 1,
      anon_sym_PIPE,
    ACTIONS(4868), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1090), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2911), 1,
      sym__call_signature,
  [100248] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    ACTIONS(4469), 1,
      anon_sym_extends,
    STATE(2402), 1,
      sym_object_type,
    STATE(2739), 1,
      sym_extends_clause,
  [100267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2855), 1,
      sym__call_signature,
  [100286] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2847), 1,
      sym__call_signature,
  [100305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2928), 1,
      sym__call_signature,
  [100335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2098), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100346] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2806), 1,
      sym__call_signature,
    STATE(2817), 1,
      sym_type_parameters,
  [100365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2093), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100395] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2107), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4870), 1,
      anon_sym_EQ_GT,
    STATE(2968), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [100429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2796), 1,
      sym__call_signature,
    STATE(2817), 1,
      sym_type_parameters,
  [100448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2121), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100467] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(3008), 1,
      sym__call_signature,
  [100486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1970), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2502), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1962), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2143), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2132), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4872), 1,
      anon_sym_EQ_GT,
    STATE(2872), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [100580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1950), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1946), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4874), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [100613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4876), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100624] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2864), 1,
      sym__call_signature,
  [100643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2529), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1827), 1,
      sym_statement_block,
    ACTIONS(4473), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4878), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2408), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100707] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    ACTIONS(4685), 1,
      anon_sym_LT,
    STATE(2718), 1,
      sym_type_arguments,
    ACTIONS(3386), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [100724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1838), 1,
      sym_statement_block,
    ACTIONS(4449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2042), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2596), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2733), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [100788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2741), 1,
      sym__initializer,
    ACTIONS(4880), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2050), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100814] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2954), 1,
      sym__call_signature,
  [100833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2932), 1,
      sym__call_signature,
  [100852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2118), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2930), 1,
      sym__call_signature,
  [100915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2746), 1,
      sym__initializer,
    ACTIONS(4882), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3726), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [100963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4884), 1,
      anon_sym_EQ_GT,
    STATE(2968), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [100978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4886), 1,
      anon_sym_EQ_GT,
    STATE(2872), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [100993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [101004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1874), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1890), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2426), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [101056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1990), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4892), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2918), 1,
      sym__call_signature,
  [101163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1942), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [101185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1882), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2961), 1,
      sym__call_signature,
  [101215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [101248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 1,
      anon_sym_EQ,
    ACTIONS(3531), 4,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [101261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1841), 1,
      sym_statement_block,
    ACTIONS(4497), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4822), 1,
      anon_sym_PIPE,
    ACTIONS(4896), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2773), 1,
      sym__initializer,
    ACTIONS(4898), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2590), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [101338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2455), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [101357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1842), 1,
      sym_statement_block,
    ACTIONS(4509), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 1,
      anon_sym_EQ,
    ACTIONS(4900), 1,
      anon_sym_COMMA,
    ACTIONS(4902), 1,
      anon_sym_RBRACE,
    STATE(2790), 1,
      aux_sym_enum_body_repeat1,
    STATE(2871), 1,
      sym__initializer,
  [101391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1994), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1986), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_COLON,
    ACTIONS(4906), 1,
      anon_sym_EQ_GT,
    STATE(2872), 3,
      sym_type_annotation,
      sym_type_predicate_annotation,
      sym_asserts,
  [101461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2782), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [101480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2949), 1,
      sym__call_signature,
  [101499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2785), 1,
      sym__initializer,
    ACTIONS(4908), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2464), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [101555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4509), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2110), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1822), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2898), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4916), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [101709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [101720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [101731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1850), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2936), 1,
      sym__call_signature,
  [101761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2940), 1,
      sym__call_signature,
  [101802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4920), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2022), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2942), 1,
      sym__call_signature,
  [101865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1847), 1,
      sym_statement_block,
    ACTIONS(4519), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101902] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(4469), 1,
      anon_sym_extends,
    STATE(555), 1,
      sym_object_type,
    STATE(2653), 1,
      sym_extends_clause,
  [101921] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2479), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [101940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      sym__automatic_semicolon,
    ACTIONS(1054), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1846), 1,
      sym_statement_block,
    ACTIONS(4555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1850), 1,
      sym_statement_block,
    ACTIONS(4529), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2793), 1,
      sym__initializer,
    ACTIONS(4926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101998] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(4928), 1,
      anon_sym_class,
    ACTIONS(4930), 1,
      anon_sym_abstract,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [102017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102028] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2473), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [102047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4359), 1,
      anon_sym_extends,
    ACTIONS(4822), 1,
      anon_sym_PIPE,
    ACTIONS(4932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4934), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4936), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2226), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym_type_parameters,
    STATE(2935), 1,
      sym__call_signature,
  [102116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4557), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2456), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [102146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4938), 1,
      sym__automatic_semicolon,
    ACTIONS(1020), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2668), 1,
      sym__initializer,
    ACTIONS(4940), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1828), 1,
      sym_statement_block,
    ACTIONS(4557), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102200] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
    STATE(2461), 1,
      sym__call_signature,
    STATE(2803), 1,
      sym_type_parameters,
  [102219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [102230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_LBRACE,
    STATE(1843), 1,
      sym_statement_block,
    ACTIONS(4549), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4942), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4944), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4946), 1,
      sym__automatic_semicolon,
    ACTIONS(986), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4948), 1,
      sym__automatic_semicolon,
    ACTIONS(976), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2687), 1,
      sym__initializer,
    ACTIONS(4950), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    STATE(2695), 1,
      sym__initializer,
    ACTIONS(4952), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4954), 1,
      anon_sym_RPAREN,
  [102339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4956), 1,
      anon_sym_COLON,
  [102355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2560), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(4960), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2560), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(4962), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [102393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2945), 1,
      sym_type_parameters,
    STATE(3232), 1,
      sym_formal_parameters,
  [102409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4964), 1,
      anon_sym_COLON,
  [102425] = 5,
    ACTIONS(4966), 1,
      anon_sym_SQUOTE,
    ACTIONS(4968), 1,
      aux_sym_string_token2,
    ACTIONS(4970), 1,
      sym_escape_sequence,
    ACTIONS(4972), 1,
      sym_comment,
    STATE(2606), 1,
      aux_sym_string_repeat2,
  [102441] = 5,
    ACTIONS(4966), 1,
      anon_sym_DQUOTE,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4974), 1,
      aux_sym_string_token1,
    ACTIONS(4976), 1,
      sym_escape_sequence,
    STATE(2607), 1,
      aux_sym_string_repeat1,
  [102457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4978), 1,
      sym_identifier,
    STATE(444), 1,
      sym_generic_type,
    STATE(488), 1,
      sym_nested_identifier,
    STATE(2986), 1,
      sym_nested_type_identifier,
  [102473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4980), 1,
      anon_sym_RBRACK,
  [102489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    ACTIONS(4982), 1,
      anon_sym_RBRACE,
    STATE(2811), 1,
      sym__import_export_specifier,
  [102505] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4984), 1,
      anon_sym_SQUOTE,
    ACTIONS(4986), 1,
      aux_sym_string_token2,
    ACTIONS(4988), 1,
      sym_escape_sequence,
    STATE(2493), 1,
      aux_sym_string_repeat2,
  [102521] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4984), 1,
      anon_sym_DQUOTE,
    ACTIONS(4990), 1,
      aux_sym_string_token1,
    ACTIONS(4992), 1,
      sym_escape_sequence,
    STATE(2494), 1,
      aux_sym_string_repeat1,
  [102537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4994), 1,
      anon_sym_COLON,
  [102553] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4996), 1,
      anon_sym_SQUOTE,
    ACTIONS(4998), 1,
      aux_sym_string_token2,
    ACTIONS(5000), 1,
      sym_escape_sequence,
    STATE(2567), 1,
      aux_sym_string_repeat2,
  [102569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(518), 1,
      sym_statement_block,
    ACTIONS(5002), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5004), 1,
      anon_sym_RBRACK,
  [102599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(2482), 1,
      sym_statement_block,
    ACTIONS(5006), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5008), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(4715), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [102627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [102637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5013), 1,
      anon_sym_RBRACK,
  [102653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_RBRACK,
  [102669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2581), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5017), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5019), 1,
      anon_sym_RPAREN,
  [102699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5021), 1,
      anon_sym_RBRACK,
  [102715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5023), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [102727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5025), 1,
      anon_sym_RBRACK,
  [102743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5027), 1,
      anon_sym_QMARK,
  [102759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2960), 1,
      sym_type_parameters,
    STATE(3165), 1,
      sym_formal_parameters,
  [102775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2583), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5029), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5031), 1,
      anon_sym_EQ_GT,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [102801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_EQ_GT,
    ACTIONS(2779), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
  [102813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(3159), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3222), 1,
      anon_sym_LBRACE,
    STATE(2553), 1,
      aux_sym_extends_clause_repeat1,
  [102829] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4996), 1,
      anon_sym_DQUOTE,
    ACTIONS(5033), 1,
      aux_sym_string_token1,
    ACTIONS(5035), 1,
      sym_escape_sequence,
    STATE(2566), 1,
      aux_sym_string_repeat1,
  [102845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1396), 1,
      sym_statement_block,
    ACTIONS(5002), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_QMARK,
  [102875] = 5,
    ACTIONS(4968), 1,
      aux_sym_string_token2,
    ACTIONS(4970), 1,
      sym_escape_sequence,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_SQUOTE,
    STATE(2606), 1,
      aux_sym_string_repeat2,
  [102891] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4974), 1,
      aux_sym_string_token1,
    ACTIONS(4976), 1,
      sym_escape_sequence,
    ACTIONS(5039), 1,
      anon_sym_DQUOTE,
    STATE(2607), 1,
      aux_sym_string_repeat1,
  [102907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5041), 1,
      anon_sym_class,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [102923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    ACTIONS(5043), 1,
      anon_sym_RBRACE,
    STATE(2794), 1,
      sym__import_export_specifier,
  [102939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5045), 1,
      anon_sym_RBRACK,
  [102955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5047), 1,
      anon_sym_RBRACK,
  [102971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(914), 1,
      anon_sym_LBRACE,
    STATE(77), 1,
      sym_statement_block,
    ACTIONS(5002), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5049), 1,
      sym_identifier,
    STATE(1597), 1,
      sym_nested_identifier,
    STATE(1602), 1,
      sym_generic_type,
    STATE(2813), 1,
      sym_nested_type_identifier,
  [103001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    STATE(2559), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5051), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [103015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    STATE(2559), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5053), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [103029] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2916), 1,
      sym_type_parameters,
    STATE(3159), 1,
      sym_formal_parameters,
  [103045] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5055), 1,
      anon_sym_SQUOTE,
    ACTIONS(5057), 1,
      aux_sym_string_token2,
    ACTIONS(5059), 1,
      sym_escape_sequence,
    STATE(2523), 1,
      aux_sym_string_repeat2,
  [103061] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5055), 1,
      anon_sym_DQUOTE,
    ACTIONS(5061), 1,
      aux_sym_string_token1,
    ACTIONS(5063), 1,
      sym_escape_sequence,
    STATE(2524), 1,
      aux_sym_string_repeat1,
  [103077] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DQUOTE,
    ACTIONS(5067), 1,
      aux_sym_string_token1,
    ACTIONS(5069), 1,
      sym_escape_sequence,
    STATE(2584), 1,
      aux_sym_string_repeat1,
  [103093] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_SQUOTE,
    ACTIONS(5071), 1,
      aux_sym_string_token2,
    ACTIONS(5073), 1,
      sym_escape_sequence,
    STATE(2585), 1,
      aux_sym_string_repeat2,
  [103109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_from,
    STATE(2823), 1,
      sym__from_clause,
    ACTIONS(5077), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_COLON,
  [103139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5081), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [103151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5083), 1,
      anon_sym_RBRACK,
  [103167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
  [103183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 1,
      anon_sym_EQ,
    STATE(2886), 1,
      sym__initializer,
    ACTIONS(5085), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103197] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5087), 1,
      anon_sym_RPAREN,
  [103213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 1,
      anon_sym_EQ,
    STATE(2891), 1,
      sym__initializer,
    ACTIONS(5089), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(2459), 1,
      sym_statement_block,
    ACTIONS(5091), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103241] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5093), 1,
      anon_sym_DQUOTE,
    ACTIONS(5095), 1,
      aux_sym_string_token1,
    ACTIONS(5097), 1,
      sym_escape_sequence,
    STATE(2554), 1,
      aux_sym_string_repeat1,
  [103257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_COLON,
  [103273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_BQUOTE,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    STATE(1544), 2,
      sym_template_string,
      sym_arguments,
  [103287] = 5,
    ACTIONS(4968), 1,
      aux_sym_string_token2,
    ACTIONS(4970), 1,
      sym_escape_sequence,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5101), 1,
      anon_sym_SQUOTE,
    STATE(2606), 1,
      aux_sym_string_repeat2,
  [103303] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5093), 1,
      anon_sym_SQUOTE,
    ACTIONS(5103), 1,
      aux_sym_string_token2,
    ACTIONS(5105), 1,
      sym_escape_sequence,
    STATE(2550), 1,
      aux_sym_string_repeat2,
  [103319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(5053), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5107), 1,
      anon_sym_LBRACE,
    STATE(2599), 1,
      aux_sym_extends_clause_repeat1,
  [103335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(5051), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5109), 1,
      anon_sym_LBRACE,
    STATE(2599), 1,
      aux_sym_extends_clause_repeat1,
  [103351] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4974), 1,
      aux_sym_string_token1,
    ACTIONS(4976), 1,
      sym_escape_sequence,
    ACTIONS(5101), 1,
      anon_sym_DQUOTE,
    STATE(2607), 1,
      aux_sym_string_repeat1,
  [103367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5111), 1,
      anon_sym_QMARK,
  [103383] = 5,
    ACTIONS(4968), 1,
      aux_sym_string_token2,
    ACTIONS(4970), 1,
      sym_escape_sequence,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5113), 1,
      anon_sym_SQUOTE,
    STATE(2606), 1,
      aux_sym_string_repeat2,
  [103399] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4974), 1,
      aux_sym_string_token1,
    ACTIONS(4976), 1,
      sym_escape_sequence,
    ACTIONS(5113), 1,
      anon_sym_DQUOTE,
    STATE(2607), 1,
      aux_sym_string_repeat1,
  [103415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5115), 1,
      anon_sym_QMARK,
  [103431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 1,
      anon_sym_COMMA,
    STATE(2559), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3386), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [103445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    STATE(2560), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5123), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 1,
      sym_identifier,
    STATE(1043), 1,
      sym_nested_identifier,
    STATE(1044), 1,
      sym_generic_type,
    STATE(2902), 1,
      sym_nested_type_identifier,
  [103475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 1,
      sym_identifier,
    STATE(1438), 1,
      sym_generic_type,
    STATE(1439), 1,
      sym_nested_identifier,
    STATE(2842), 1,
      sym_nested_type_identifier,
  [103491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5129), 1,
      anon_sym_QMARK,
  [103507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5131), 1,
      anon_sym_QMARK,
  [103523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_from,
    STATE(2873), 1,
      sym__from_clause,
    ACTIONS(5133), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103537] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4974), 1,
      aux_sym_string_token1,
    ACTIONS(4976), 1,
      sym_escape_sequence,
    ACTIONS(5135), 1,
      anon_sym_DQUOTE,
    STATE(2607), 1,
      aux_sym_string_repeat1,
  [103553] = 5,
    ACTIONS(4968), 1,
      aux_sym_string_token2,
    ACTIONS(4970), 1,
      sym_escape_sequence,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5135), 1,
      anon_sym_SQUOTE,
    STATE(2606), 1,
      aux_sym_string_repeat2,
  [103569] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5137), 1,
      anon_sym_SQUOTE,
    ACTIONS(5139), 1,
      aux_sym_string_token2,
    ACTIONS(5141), 1,
      sym_escape_sequence,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [103585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2981), 1,
      sym_type_parameters,
    STATE(3012), 1,
      sym_formal_parameters,
  [103601] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5137), 1,
      anon_sym_DQUOTE,
    ACTIONS(5143), 1,
      aux_sym_string_token1,
    ACTIONS(5145), 1,
      sym_escape_sequence,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [103617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5147), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [103629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 1,
      anon_sym_BQUOTE,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(1106), 2,
      sym_template_string,
      sym_arguments,
  [103643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 1,
      sym_identifier,
    STATE(444), 1,
      sym_generic_type,
    STATE(1918), 1,
      sym_nested_identifier,
    STATE(2986), 1,
      sym_nested_type_identifier,
  [103659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5151), 1,
      anon_sym_COLON,
  [103675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5153), 1,
      anon_sym_COMMA,
    STATE(2575), 1,
      aux_sym_array_repeat1,
    ACTIONS(3388), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [103689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5156), 1,
      anon_sym_class,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [103705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5158), 1,
      sym_identifier,
    STATE(1954), 1,
      sym_nested_identifier,
    STATE(2001), 1,
      sym_generic_type,
    STATE(2982), 1,
      sym_nested_type_identifier,
  [103721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [103733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    ACTIONS(5162), 1,
      anon_sym_RBRACE,
    STATE(2794), 1,
      sym__import_export_specifier,
  [103749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_RBRACK,
  [103765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2560), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5166), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    STATE(2531), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3159), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [103793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2560), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5168), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103807] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(4974), 1,
      aux_sym_string_token1,
    ACTIONS(4976), 1,
      sym_escape_sequence,
    ACTIONS(5170), 1,
      anon_sym_DQUOTE,
    STATE(2607), 1,
      aux_sym_string_repeat1,
  [103823] = 5,
    ACTIONS(4968), 1,
      aux_sym_string_token2,
    ACTIONS(4970), 1,
      sym_escape_sequence,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5170), 1,
      anon_sym_SQUOTE,
    STATE(2606), 1,
      aux_sym_string_repeat2,
  [103839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2488), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5172), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2998), 1,
      sym_type_parameters,
    STATE(3028), 1,
      sym_formal_parameters,
  [103869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5174), 1,
      anon_sym_RBRACK,
  [103885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5176), 1,
      anon_sym_RBRACK,
  [103901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_statement_block,
    ACTIONS(5178), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5180), 1,
      anon_sym_class,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [103931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_BQUOTE,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
  [103945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(2489), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5182), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5184), 1,
      anon_sym_RPAREN,
  [103975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 4,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [103985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(914), 1,
      anon_sym_LBRACE,
    STATE(85), 1,
      sym_statement_block,
    ACTIONS(5178), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2763), 1,
      anon_sym_LBRACE,
    ACTIONS(4385), 1,
      anon_sym_STAR,
    STATE(3077), 2,
      sym_namespace_import,
      sym_named_imports,
  [104013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    STATE(3005), 1,
      sym_type_annotation,
    ACTIONS(5186), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [104027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    ACTIONS(5188), 1,
      anon_sym_COMMA,
    STATE(2599), 1,
      aux_sym_extends_clause_repeat1,
  [104043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    ACTIONS(5191), 1,
      anon_sym_RBRACE,
    STATE(2811), 1,
      sym__import_export_specifier,
  [104059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_AT,
    ACTIONS(5193), 1,
      anon_sym_export,
    STATE(1870), 1,
      aux_sym_export_statement_repeat1,
    STATE(1908), 1,
      sym_decorator,
  [104075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1341), 1,
      sym_statement_block,
    ACTIONS(5178), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5195), 1,
      anon_sym_RPAREN,
  [104105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2103), 1,
      sym_formal_parameters,
    STATE(2859), 1,
      sym_type_parameters,
  [104121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5197), 1,
      anon_sym_QMARK,
    ACTIONS(2648), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [104133] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5199), 1,
      anon_sym_SQUOTE,
    ACTIONS(5201), 1,
      aux_sym_string_token2,
    ACTIONS(5204), 1,
      sym_escape_sequence,
    STATE(2606), 1,
      aux_sym_string_repeat2,
  [104149] = 5,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5207), 1,
      anon_sym_DQUOTE,
    ACTIONS(5209), 1,
      aux_sym_string_token1,
    ACTIONS(5212), 1,
      sym_escape_sequence,
    STATE(2607), 1,
      aux_sym_string_repeat1,
  [104165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_COLON,
    STATE(2854), 1,
      sym_type_annotation,
    ACTIONS(5215), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [104179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4491), 1,
      anon_sym_EQ,
    STATE(2871), 1,
      sym__initializer,
    ACTIONS(5217), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 1,
      anon_sym_EQ,
    STATE(2849), 1,
      sym_default_type,
    ACTIONS(5219), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [104207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5221), 1,
      anon_sym_LBRACK,
    ACTIONS(1560), 3,
      anon_sym_extends,
      anon_sym_AMP,
      anon_sym_PIPE,
  [104219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_RPAREN,
    ACTIONS(5223), 1,
      anon_sym_COMMA,
    STATE(2751), 1,
      aux_sym_formal_parameters_repeat1,
  [104232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5229), 1,
      anon_sym_RBRACK,
    STATE(2643), 1,
      aux_sym__tuple_type_body_repeat1,
  [104254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    ACTIONS(5233), 1,
      anon_sym_GT,
    STATE(2839), 1,
      sym_type_parameter,
  [104267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3396), 1,
      anon_sym_RBRACK,
    STATE(2669), 1,
      aux_sym_array_repeat1,
  [104280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      anon_sym_GT,
    ACTIONS(5235), 1,
      anon_sym_COMMA,
    STATE(2772), 1,
      aux_sym_type_parameters_repeat1,
  [104293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_GT,
    ACTIONS(5237), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
  [104306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5239), 1,
      anon_sym_COMMA,
    ACTIONS(5241), 1,
      anon_sym_GT,
    STATE(2772), 1,
      aux_sym_type_parameters_repeat1,
  [104319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
  [104332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5243), 1,
      anon_sym_RBRACK,
    STATE(2761), 1,
      aux_sym__tuple_type_body_repeat1,
  [104345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5245), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [104354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3412), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [104367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5247), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [104380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3384), 1,
      anon_sym_RPAREN,
    STATE(2650), 1,
      aux_sym_array_repeat1,
  [104393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3384), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [104406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    STATE(2794), 1,
      sym__import_export_specifier,
  [104419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5251), 1,
      sym_this,
    STATE(2805), 1,
      sym_type_predicate,
  [104432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5253), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [104441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5255), 1,
      anon_sym_as,
    ACTIONS(5257), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4521), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [104461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3412), 1,
      anon_sym_RPAREN,
    STATE(2774), 1,
      aux_sym_array_repeat1,
  [104474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5259), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [104487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_COMMA,
    ACTIONS(5263), 1,
      anon_sym_RPAREN,
    STATE(2716), 1,
      aux_sym_formal_parameters_repeat1,
  [104500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [104509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5265), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [104522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5267), 1,
      anon_sym_LBRACE,
    ACTIONS(4860), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [104533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5269), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [104546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5273), 1,
      anon_sym_RBRACK,
    STATE(2763), 1,
      aux_sym__tuple_type_body_repeat1,
  [104568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_RPAREN,
    ACTIONS(5223), 1,
      anon_sym_COMMA,
    STATE(2712), 1,
      aux_sym_formal_parameters_repeat1,
  [104581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5217), 1,
      anon_sym_RBRACE,
    ACTIONS(5275), 1,
      anon_sym_COMMA,
    STATE(2642), 1,
      aux_sym_enum_body_repeat1,
  [104594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5278), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym__tuple_type_body_repeat1,
  [104607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3396), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [104620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_implements,
    ACTIONS(5280), 1,
      anon_sym_LBRACE,
    STATE(3015), 1,
      sym_implements_clause,
  [104633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5282), 1,
      anon_sym_EQ,
    ACTIONS(5284), 1,
      anon_sym_COMMA,
    ACTIONS(5286), 1,
      anon_sym_from,
  [104646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2683), 1,
      anon_sym_GT,
    ACTIONS(5288), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
  [104659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      anon_sym_typeof,
    STATE(2811), 1,
      sym__import_export_specifier,
  [104672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    STATE(2404), 1,
      sym_object_type,
  [104685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5290), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [104698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [104707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    ACTIONS(3386), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [104718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    STATE(538), 1,
      sym_object_type,
  [104731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5294), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [104744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5296), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [104757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(5298), 1,
      anon_sym_EQ,
    STATE(3101), 1,
      sym_type_parameters,
  [104770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    ACTIONS(5241), 1,
      anon_sym_GT,
    STATE(2839), 1,
      sym_type_parameter,
  [104783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 1,
      anon_sym_RBRACE,
    ACTIONS(5300), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_named_imports_repeat1,
  [104796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_DOT,
    ACTIONS(5302), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4097), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym_is,
    ACTIONS(4475), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [104836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5306), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5308), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [104858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5310), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5314), 1,
      anon_sym_COMMA,
    ACTIONS(5317), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym__tuple_type_body_repeat1,
  [104889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5321), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [104911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3388), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [104920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5323), 1,
      anon_sym_RBRACE,
    STATE(2697), 1,
      aux_sym_object_repeat1,
  [104933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5308), 1,
      anon_sym_RBRACE,
    STATE(2764), 1,
      aux_sym_object_repeat1,
  [104946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5323), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [104959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5325), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3367), 1,
      anon_sym_RPAREN,
    STATE(2768), 1,
      aux_sym_array_repeat1,
  [104981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_COMMA,
    ACTIONS(5329), 1,
      anon_sym_GT,
    STATE(2619), 1,
      aux_sym_type_parameters_repeat1,
  [104994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3367), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3433), 1,
      anon_sym_RBRACK,
    STATE(2699), 1,
      aux_sym_array_repeat1,
  [105033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3433), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_RBRACK,
    STATE(2624), 1,
      aux_sym_array_repeat1,
  [105059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5331), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5333), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    STATE(532), 1,
      sym_statement_block,
  [105099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_while,
    ACTIONS(5337), 1,
      anon_sym_else,
    STATE(608), 1,
      sym_else_clause,
  [105112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_RPAREN,
    ACTIONS(5341), 1,
      anon_sym_COMMA,
    STATE(2723), 1,
      aux_sym_formal_parameters_repeat1,
  [105134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5343), 1,
      anon_sym_COMMA,
    ACTIONS(5345), 1,
      anon_sym_GT,
    STATE(2617), 1,
      aux_sym_type_parameters_repeat1,
  [105147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [105156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5347), 1,
      anon_sym_LBRACE,
    ACTIONS(4814), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [105167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5349), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5353), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5355), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5357), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5359), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4840), 1,
      anon_sym_COMMA,
    ACTIONS(4842), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      aux_sym_enum_body_repeat1,
  [105246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5361), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5363), 1,
      sym_identifier,
    STATE(1756), 1,
      sym_decorator_member_expression,
    STATE(1820), 1,
      sym_decorator_call_expression,
  [105272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5349), 1,
      anon_sym_RBRACE,
    STATE(2633), 1,
      aux_sym_object_repeat1,
  [105285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      sym_identifier,
    ACTIONS(5367), 1,
      sym_this,
    STATE(2253), 1,
      sym_type_predicate,
  [105298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_GT,
    ACTIONS(5369), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
  [105311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 1,
      sym_identifier,
    ACTIONS(5373), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_DQUOTE,
    ACTIONS(2337), 1,
      anon_sym_SQUOTE,
    STATE(2965), 1,
      sym_string,
  [105335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5375), 1,
      anon_sym_RBRACK,
    STATE(2720), 1,
      aux_sym__tuple_type_body_repeat1,
  [105348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5377), 1,
      sym_identifier,
    ACTIONS(5379), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [105368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 1,
      anon_sym_LBRACE,
    ACTIONS(1472), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [105379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_GT,
    ACTIONS(5381), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
  [105392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 1,
      anon_sym_COMMA,
    ACTIONS(5388), 1,
      anon_sym_RPAREN,
    STATE(2712), 1,
      aux_sym_formal_parameters_repeat1,
  [105414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3361), 1,
      anon_sym_RPAREN,
    STATE(2725), 1,
      aux_sym_array_repeat1,
  [105436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3361), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_RPAREN,
    ACTIONS(5341), 1,
      anon_sym_COMMA,
    STATE(2712), 1,
      aux_sym_formal_parameters_repeat1,
  [105462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 1,
      anon_sym_LBRACE,
    ACTIONS(1468), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [105473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 1,
      anon_sym_LBRACE,
    ACTIONS(1464), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [105484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3363), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5392), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym__tuple_type_body_repeat1,
  [105510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3363), 1,
      anon_sym_RBRACK,
    STATE(2638), 1,
      aux_sym_array_repeat1,
  [105523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 1,
      anon_sym_LBRACE,
    ACTIONS(1490), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [105534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4041), 1,
      anon_sym_RPAREN,
    ACTIONS(5394), 1,
      anon_sym_COMMA,
    STATE(2712), 1,
      aux_sym_formal_parameters_repeat1,
  [105547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5396), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [105556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5398), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 1,
      anon_sym_LBRACE,
    ACTIONS(1484), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [105580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4485), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [105589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_RBRACE,
    ACTIONS(5400), 1,
      anon_sym_COMMA,
    STATE(2786), 1,
      aux_sym_export_clause_repeat1,
  [105602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4507), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [105611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_as,
    ACTIONS(5404), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [105622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5406), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5408), 1,
      anon_sym_COMMA,
    ACTIONS(5410), 1,
      anon_sym_RBRACE,
    STATE(2728), 1,
      aux_sym_export_clause_repeat1,
  [105644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5412), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5414), 1,
      anon_sym_RBRACE,
    STATE(2758), 1,
      aux_sym_object_repeat1,
  [105666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5416), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5414), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 1,
      anon_sym_COMMA,
    ACTIONS(5420), 1,
      anon_sym_RPAREN,
    STATE(2641), 1,
      aux_sym_formal_parameters_repeat1,
  [105701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_LBRACE,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
  [105714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2501), 1,
      anon_sym_LBRACE,
    STATE(2375), 1,
      sym_object_type,
  [105727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5426), 1,
      anon_sym_await,
    STATE(32), 1,
      sym__for_header,
  [105740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3353), 1,
      anon_sym_RBRACK,
    STATE(2760), 1,
      aux_sym_array_repeat1,
  [105762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(3353), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4192), 1,
      anon_sym_RBRACE,
    ACTIONS(5430), 1,
      anon_sym_COMMA,
    STATE(2642), 1,
      aux_sym_enum_body_repeat1,
  [105788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 1,
      anon_sym_DQUOTE,
    ACTIONS(754), 1,
      anon_sym_SQUOTE,
    STATE(3054), 1,
      sym_string,
  [105801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5434), 1,
      anon_sym_COMMA,
    ACTIONS(5437), 1,
      anon_sym_RBRACE,
    STATE(2747), 1,
      aux_sym_named_imports_repeat1,
  [105823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_DOT,
    ACTIONS(5439), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4900), 1,
      anon_sym_COMMA,
    ACTIONS(4902), 1,
      anon_sym_RBRACE,
    STATE(2790), 1,
      aux_sym_enum_body_repeat1,
  [105847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5441), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      anon_sym_RPAREN,
    ACTIONS(5443), 1,
      anon_sym_COMMA,
    STATE(2712), 1,
      aux_sym_formal_parameters_repeat1,
  [105873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5441), 1,
      anon_sym_RBRACE,
    STATE(2654), 1,
      aux_sym_object_repeat1,
  [105886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5445), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
  [105921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5451), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5453), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [105956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5455), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [105965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5457), 1,
      anon_sym_RBRACK,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [105978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5459), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym__tuple_type_body_repeat1,
  [105991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_LBRACE,
    ACTIONS(4874), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [106002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5463), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym__tuple_type_body_repeat1,
  [106015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(115), 1,
      anon_sym_COMMA,
    ACTIONS(5465), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [106028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 1,
      anon_sym_extends,
  [106041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    ACTIONS(5467), 1,
      anon_sym_GT,
    STATE(2839), 1,
      sym_type_parameter,
  [106054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5469), 1,
      anon_sym_RBRACK,
    STATE(2778), 1,
      aux_sym__tuple_type_body_repeat1,
  [106067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [106080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_LPAREN,
    ACTIONS(5475), 1,
      anon_sym_await,
    STATE(33), 1,
      sym__for_header,
  [106093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    ACTIONS(5477), 1,
      anon_sym_GT,
    STATE(2839), 1,
      sym_type_parameter,
  [106106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_GT,
    ACTIONS(5479), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
  [106119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 1,
      anon_sym_COMMA,
    ACTIONS(5484), 1,
      anon_sym_GT,
    STATE(2772), 1,
      aux_sym_type_parameters_repeat1,
  [106132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 1,
      anon_sym_COMMA,
    ACTIONS(5488), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      aux_sym_array_repeat1,
  [106154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
  [106167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_extends,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
  [106180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_COMMA,
    ACTIONS(5493), 1,
      anon_sym_RBRACE,
    STATE(2777), 1,
      aux_sym_object_repeat1,
  [106193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_COMMA,
    ACTIONS(5495), 1,
      anon_sym_RBRACK,
    STATE(2667), 1,
      aux_sym__tuple_type_body_repeat1,
  [106206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_AMP,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(5497), 1,
      anon_sym_extends,
  [106219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    STATE(556), 1,
      sym_object_type,
  [106232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1676), 1,
      anon_sym_LT,
    ACTIONS(5499), 1,
      anon_sym_EQ,
    STATE(3098), 1,
      sym_type_parameters,
  [106245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 1,
      anon_sym_COMMA,
    ACTIONS(5507), 1,
      anon_sym_RBRACE,
    STATE(2658), 1,
      aux_sym_named_imports_repeat1,
  [106276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 1,
      anon_sym_COMMA,
    ACTIONS(5514), 1,
      anon_sym_RBRACE,
    STATE(2786), 1,
      aux_sym_export_clause_repeat1,
  [106298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 1,
      anon_sym_COMMA,
    ACTIONS(5286), 1,
      anon_sym_from,
    ACTIONS(5516), 1,
      anon_sym_EQ,
  [106311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 1,
      sym_identifier,
    ACTIONS(5520), 1,
      anon_sym_require,
    STATE(2659), 1,
      sym_nested_identifier,
  [106324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5522), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [106333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_RBRACE,
    ACTIONS(5524), 1,
      anon_sym_COMMA,
    STATE(2642), 1,
      aux_sym_enum_body_repeat1,
  [106346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5526), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_GT,
    ACTIONS(5528), 1,
      anon_sym_COMMA,
    STATE(2505), 1,
      aux_sym_implements_clause_repeat1,
  [106368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5530), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3103), 1,
      sym_formal_parameters,
  [106395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_statement_block,
  [106405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_class_body,
  [106415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(2435), 1,
      sym_statement_block,
  [106433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 1,
      anon_sym_LBRACE,
    STATE(2433), 1,
      sym_enum_body,
  [106443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1541), 1,
      sym_class_body,
  [106453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(91), 1,
      sym_class_body,
  [106463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2022), 1,
      sym_formal_parameters,
  [106473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parenthesized_expression,
  [106483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4475), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [106491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2946), 1,
      sym_statement_block,
  [106501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LPAREN,
    STATE(2834), 1,
      sym_parenthesized_expression,
  [106511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1158), 1,
      sym_class_body,
  [106521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [106531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(489), 1,
      sym_statement_block,
  [106541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5540), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [106559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5542), 1,
      anon_sym_LT,
    STATE(1634), 1,
      sym_type_arguments,
  [106569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1153), 1,
      sym_statement_block,
  [106587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3371), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2175), 1,
      sym_formal_parameters,
  [106605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_from,
    STATE(2873), 1,
      sym__from_clause,
  [106615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2140), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2144), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5546), 1,
      sym_identifier,
    ACTIONS(5548), 1,
      anon_sym_STAR,
  [106641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LBRACK,
  [106651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(1136), 1,
      sym_arguments,
  [106669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_statement_block,
  [106679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5536), 1,
      anon_sym_LBRACE,
    STATE(2400), 1,
      sym_enum_body,
  [106689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_from,
    STATE(2908), 1,
      sym__from_clause,
  [106699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1356), 1,
      sym_class_body,
  [106717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5552), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym_enum_body,
  [106727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2950), 1,
      sym_statement_block,
  [106745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1208), 1,
      sym_class_body,
  [106755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5554), 1,
      anon_sym_LBRACE,
    STATE(540), 1,
      sym_switch_body,
  [106765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym__for_header,
  [106775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1203), 1,
      sym_statement_block,
  [106785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1182), 1,
      sym_statement_block,
  [106795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [106811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [106821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1524), 1,
      sym_class_body,
  [106831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 1,
      anon_sym_LT,
    STATE(1417), 1,
      sym_type_arguments,
  [106841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parenthesized_expression,
  [106851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5538), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [106861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5562), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1513), 1,
      sym_statement_block,
  [106887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3420), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [106903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_from,
    STATE(2823), 1,
      sym__from_clause,
  [106913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_class_body,
  [106923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    STATE(2689), 1,
      sym_type_parameter,
  [106941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5566), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [106949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1507), 1,
      sym_statement_block,
  [106959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1510), 1,
      sym_class_body,
  [106969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1631), 1,
      sym_class_body,
  [106979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1592), 1,
      sym_statement_block,
  [106989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_LPAREN,
    STATE(2090), 1,
      sym_formal_parameters,
  [106999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2164), 1,
      anon_sym_LPAREN,
    STATE(1107), 1,
      sym_arguments,
  [107009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(578), 1,
      sym_class_body,
  [107019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3019), 1,
      sym_formal_parameters,
  [107029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2384), 1,
      sym_formal_parameters,
  [107039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(914), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_statement_block,
  [107049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5556), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym__for_header,
  [107067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1575), 1,
      sym_statement_block,
  [107077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(80), 1,
      sym_class_body,
  [107087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2381), 1,
      sym_class_body,
  [107097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    STATE(2676), 1,
      sym_type_parameter,
  [107107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5570), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4607), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [107123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2497), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1134), 1,
      sym_class_body,
  [107141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1123), 1,
      sym_statement_block,
  [107151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 1,
      sym_identifier,
    ACTIONS(5574), 1,
      anon_sym_STAR,
  [107161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    STATE(1573), 1,
      sym_arguments,
  [107171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1390), 1,
      sym_class_body,
  [107181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3154), 1,
      sym_formal_parameters,
  [107191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5493), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1111), 1,
      sym_statement_block,
  [107209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1397), 1,
      sym_statement_block,
  [107219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2353), 1,
      sym_class_body,
  [107229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1198), 1,
      sym_class_body,
  [107263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym_formal_parameters,
  [107273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2939), 1,
      sym_statement_block,
  [107283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1465), 1,
      sym_class_body,
  [107293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5582), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2320), 1,
      sym_formal_parameters,
  [107311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5584), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1173), 1,
      sym_class_body,
  [107329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5586), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4679), 1,
      sym_identifier,
    ACTIONS(4681), 1,
      anon_sym_LBRACK,
  [107347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2340), 1,
      sym_class_body,
  [107357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2335), 1,
      sym_class_body,
  [107367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5588), 1,
      sym_identifier,
    ACTIONS(5590), 1,
      anon_sym_STAR,
  [107377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1174), 1,
      sym_class_body,
  [107387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1176), 1,
      sym_statement_block,
  [107397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_LT,
    STATE(1058), 1,
      sym_type_arguments,
  [107407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1177), 1,
      sym_statement_block,
  [107417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      sym_identifier,
    ACTIONS(5596), 1,
      anon_sym_STAR,
  [107427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1178), 1,
      sym_class_body,
  [107437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_from,
    STATE(2919), 1,
      sym__from_clause,
  [107447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(914), 1,
      anon_sym_LBRACE,
    STATE(81), 1,
      sym_statement_block,
  [107457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(541), 1,
      sym_class_body,
  [107475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1458), 1,
      sym_statement_block,
  [107493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5317), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      sym_identifier,
    STATE(2839), 1,
      sym_type_parameter,
  [107511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5552), 1,
      anon_sym_LBRACE,
    STATE(572), 1,
      sym_enum_body,
  [107521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_COLON,
    STATE(2665), 1,
      sym_type_annotation,
  [107531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3108), 1,
      sym_formal_parameters,
  [107541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1698), 1,
      sym_class_body,
  [107551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1704), 1,
      sym_statement_block,
  [107561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5602), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2323), 1,
      sym_class_body,
  [107579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(82), 1,
      sym_class_body,
  [107589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1453), 1,
      sym_class_body,
  [107599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_class_body,
  [107609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2322), 1,
      sym_class_body,
  [107619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2319), 1,
      sym_class_body,
  [107629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5604), 1,
      sym_identifier,
    STATE(2748), 1,
      sym_nested_identifier,
  [107639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5606), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LBRACE,
    STATE(1193), 1,
      sym_statement_block,
  [107657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1710), 1,
      sym_class_body,
  [107667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1711), 1,
      sym_statement_block,
  [107677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    STATE(1196), 1,
      sym_class_body,
  [107687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1712), 1,
      sym_statement_block,
  [107697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1695), 1,
      sym_class_body,
  [107707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1512), 1,
      sym_statement_block,
  [107725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2910), 1,
      sym_statement_block,
  [107735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(527), 1,
      sym_statement_block,
  [107745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1523), 1,
      sym_class_body,
  [107755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2838), 1,
      sym_statement_block,
  [107773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2831), 1,
      sym_statement_block,
  [107783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(2483), 1,
      sym_statement_block,
  [107793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(526), 1,
      sym_class_body,
  [107803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3226), 1,
      sym_formal_parameters,
  [107821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3228), 1,
      sym_formal_parameters,
  [107839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(3006), 1,
      sym_statement_block,
  [107849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_LBRACE,
    STATE(2474), 1,
      sym_statement_block,
  [107859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1701), 1,
      sym_statement_block,
  [107877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(2314), 1,
      sym_class_body,
  [107887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2934), 1,
      sym_statement_block,
  [107897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1690), 1,
      sym_statement_block,
  [107907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(3009), 1,
      sym_statement_block,
  [107925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(536), 1,
      sym_class_body,
  [107935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      sym_identifier,
    STATE(2659), 1,
      sym_nested_identifier,
  [107945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1706), 1,
      sym_class_body,
  [107955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3216), 1,
      sym_formal_parameters,
  [107965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2944), 1,
      sym_statement_block,
  [107975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1582), 1,
      sym_statement_block,
  [107985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1586), 1,
      sym_class_body,
  [107995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5610), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5612), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3170), 1,
      sym_formal_parameters,
  [108021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1626), 1,
      sym_class_body,
  [108031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4741), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [108039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [108047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1648), 1,
      sym_class_body,
  [108057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(2268), 1,
      sym_formal_parameters,
  [108067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5614), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    STATE(1656), 1,
      sym_arguments,
  [108093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3106), 1,
      sym_formal_parameters,
  [108111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_LPAREN,
    STATE(1554), 1,
      sym_arguments,
  [108121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2955), 1,
      sym_statement_block,
  [108131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5217), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [108147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3161), 1,
      sym_formal_parameters,
  [108157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    STATE(1980), 1,
      sym_type_arguments,
  [108167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1667), 1,
      sym_statement_block,
  [108177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1678), 1,
      sym_statement_block,
  [108187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1635), 1,
      sym_class_body,
  [108197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_LT,
    STATE(286), 1,
      sym_type_arguments,
  [108207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_statement_block,
  [108217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(523), 1,
      sym_statement_block,
  [108227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1526), 1,
      sym_statement_block,
  [108237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    STATE(1683), 1,
      sym_arguments,
  [108247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
    STATE(1540), 1,
      sym_statement_block,
  [108257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(522), 1,
      sym_statement_block,
  [108267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      anon_sym_LBRACE,
    STATE(1579), 1,
      sym_class_body,
  [108277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_LBRACE,
    STATE(530), 1,
      sym_class_body,
  [108287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym_identifier,
    ACTIONS(4667), 1,
      anon_sym_LBRACK,
  [108297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3013), 1,
      sym_formal_parameters,
  [108307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_LBRACE,
    STATE(83), 1,
      sym_class_body,
  [108317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LPAREN,
    STATE(3066), 1,
      sym_formal_parameters,
  [108327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      anon_sym_LBRACE,
    STATE(1664), 1,
      sym_statement_block,
  [108337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(587), 1,
      sym_statement_block,
  [108347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_LBRACE,
    STATE(1642), 1,
      sym_class_body,
  [108357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5616), 1,
      anon_sym_LPAREN,
    STATE(2885), 1,
      sym_parenthesized_expression,
  [108367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 1,
      anon_sym_COLON,
    ACTIONS(5620), 1,
      anon_sym_in,
  [108377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_LBRACE,
    STATE(558), 1,
      sym_class_body,
  [108387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [108395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4119), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [108411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 1,
      anon_sym_LBRACE,
    STATE(2972), 1,
      sym_statement_block,
  [108421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4123), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_RBRACK,
  [108436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_EQ,
  [108443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 1,
      anon_sym_EQ_GT,
  [108450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 1,
      anon_sym_EQ_GT,
  [108457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_RPAREN,
  [108464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_LBRACE,
  [108471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_RBRACK,
  [108478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4258), 1,
      anon_sym_DOT,
  [108485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 1,
      sym_identifier,
  [108492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      anon_sym_EQ_GT,
  [108499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4665), 1,
      sym_identifier,
  [108506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_EQ_GT,
  [108513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 1,
      sym_readonly,
  [108520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5636), 1,
      sym_number,
  [108527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_SLASH2,
  [108534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 1,
      sym_identifier,
  [108541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 1,
      anon_sym_target,
  [108548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_RPAREN,
  [108555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 1,
      anon_sym_EQ_GT,
  [108562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_EQ_GT,
  [108569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      anon_sym_RPAREN,
  [108576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_EQ_GT,
  [108583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5650), 1,
      anon_sym_EQ_GT,
  [108590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3558), 1,
      anon_sym_RPAREN,
  [108597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_EQ_GT,
  [108604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_RPAREN,
  [108611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_COLON,
  [108618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_EQ_GT,
  [108625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 1,
      anon_sym_RBRACK,
  [108632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 1,
      sym_identifier,
  [108639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5662), 1,
      anon_sym_EQ_GT,
  [108646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 1,
      anon_sym_EQ_GT,
  [108653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_EQ_GT,
  [108660] = 2,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5668), 1,
      sym_regex_pattern,
  [108667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_RPAREN,
  [108674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_identifier,
  [108681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_DOT,
  [108688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_RBRACE,
  [108695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5674), 1,
      anon_sym_from,
  [108702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_RPAREN,
  [108709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3613), 1,
      anon_sym_RBRACK,
  [108716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4759), 1,
      sym_identifier,
  [108723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 1,
      sym_identifier,
  [108730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_RBRACK,
  [108737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_RPAREN,
  [108744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_DOT,
  [108751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_from,
  [108758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      sym_identifier,
  [108765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym_identifier,
  [108772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3584), 1,
      anon_sym_RBRACK,
  [108779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
  [108786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_COLON,
  [108793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_DOT,
  [108800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      sym_identifier,
  [108807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 1,
      anon_sym_RBRACK,
  [108814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_RPAREN,
  [108821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4870), 1,
      anon_sym_EQ_GT,
  [108828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_RBRACK,
  [108835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3590), 1,
      anon_sym_RBRACK,
  [108842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_COLON,
  [108849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 1,
      anon_sym_RPAREN,
  [108856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5698), 1,
      anon_sym_class,
  [108863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      sym_identifier,
  [108870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5702), 1,
      anon_sym_from,
  [108877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 1,
      anon_sym_from,
  [108884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 1,
      anon_sym_require,
  [108891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      anon_sym_LPAREN,
  [108898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 1,
      anon_sym_from,
  [108905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
  [108912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5712), 1,
      anon_sym_EQ_GT,
  [108919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 1,
      anon_sym_SLASH2,
  [108926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5716), 1,
      sym_number,
  [108933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 1,
      sym_identifier,
  [108940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_namespace,
  [108947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
  [108954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      sym_identifier,
  [108961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5726), 1,
      anon_sym_RPAREN,
  [108968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 1,
      anon_sym_EQ_GT,
  [108975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_from,
  [108982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_EQ_GT,
  [108989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_RBRACE,
  [108996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_EQ_GT,
  [109003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5738), 1,
      anon_sym_EQ_GT,
  [109010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym_identifier,
  [109017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 1,
      sym_identifier,
  [109024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_class,
  [109031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_EQ,
  [109038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5748), 1,
      sym_identifier,
  [109045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_EQ,
  [109052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5752), 1,
      anon_sym_COLON,
  [109059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 1,
      sym_identifier,
  [109066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5756), 1,
      anon_sym_EQ,
  [109073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 1,
      sym_identifier,
  [109080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_EQ_GT,
  [109087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5762), 1,
      sym_identifier,
  [109094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5764), 1,
      anon_sym_RPAREN,
  [109101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5766), 1,
      anon_sym_EQ_GT,
  [109108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5768), 1,
      sym_identifier,
  [109115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 1,
      anon_sym_EQ_GT,
  [109122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_RPAREN,
  [109129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 1,
      anon_sym_EQ,
  [109136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5776), 1,
      anon_sym_RBRACK,
  [109143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 1,
      anon_sym_RPAREN,
  [109150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3588), 1,
      anon_sym_RPAREN,
  [109157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 1,
      anon_sym_EQ,
  [109164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 1,
      anon_sym_RPAREN,
  [109171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 1,
      sym_identifier,
  [109178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      sym_identifier,
  [109185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 1,
      anon_sym_DOT,
  [109192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5784), 1,
      sym_identifier,
  [109199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5786), 1,
      sym_identifier,
  [109206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 1,
      anon_sym_RPAREN,
  [109213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3592), 1,
      anon_sym_RBRACK,
  [109220] = 2,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5788), 1,
      sym_regex_pattern,
  [109227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5790), 1,
      anon_sym_COLON,
  [109234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_RPAREN,
  [109241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5792), 1,
      sym_identifier,
  [109248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_RPAREN,
  [109255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5410), 1,
      anon_sym_RBRACE,
  [109262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 1,
      sym_identifier,
  [109269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5796), 1,
      sym_identifier,
  [109276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_RBRACK,
  [109283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5798), 1,
      anon_sym_class,
  [109290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON,
  [109297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5800), 1,
      sym_identifier,
  [109304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      anon_sym_as,
  [109311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4679), 1,
      sym_identifier,
  [109318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5804), 1,
      sym_number,
  [109325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 1,
      anon_sym_EQ_GT,
  [109332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5808), 1,
      anon_sym_EQ_GT,
  [109339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 1,
      sym_identifier,
  [109346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4872), 1,
      anon_sym_EQ_GT,
  [109353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4238), 1,
      anon_sym_DOT,
  [109360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      sym_number,
  [109367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4262), 1,
      anon_sym_is,
  [109374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5814), 1,
      anon_sym_from,
  [109381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_SLASH2,
  [109388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_target,
  [109395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5820), 1,
      sym_identifier,
  [109402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5822), 1,
      sym_identifier,
  [109409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 1,
      anon_sym_RBRACK,
  [109416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5824), 1,
      anon_sym_EQ_GT,
  [109423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5031), 1,
      anon_sym_EQ_GT,
  [109430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_EQ_GT,
  [109437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5826), 1,
      anon_sym_EQ_GT,
  [109444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5280), 1,
      anon_sym_LBRACE,
  [109451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5828), 1,
      sym_identifier,
  [109458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5830), 1,
      anon_sym_RPAREN,
  [109465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5832), 1,
      sym_identifier,
  [109472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5834), 1,
      anon_sym_EQ_GT,
  [109479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5836), 1,
      sym_identifier,
  [109486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 1,
      anon_sym_EQ_GT,
  [109493] = 2,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5838), 1,
      sym_regex_pattern,
  [109500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5840), 1,
      anon_sym_LBRACK,
  [109507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5842), 1,
      anon_sym_while,
  [109514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5844), 1,
      anon_sym_EQ_GT,
  [109521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym_identifier,
  [109528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_RPAREN,
  [109535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5848), 1,
      sym_identifier,
  [109542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5850), 1,
      sym_identifier,
  [109549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5852), 1,
      anon_sym_EQ_GT,
  [109556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5854), 1,
      sym_identifier,
  [109563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3564), 1,
      anon_sym_RBRACK,
  [109570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5856), 1,
      sym_identifier,
  [109577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5858), 1,
      sym_identifier,
  [109584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5860), 1,
      sym_identifier,
  [109591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5862), 1,
      sym_identifier,
  [109598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      anon_sym_from,
  [109605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5864), 1,
      sym_identifier,
  [109612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5866), 1,
      anon_sym_RPAREN,
  [109619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym_identifier,
  [109626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      sym_identifier,
  [109633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5872), 1,
      sym_identifier,
  [109640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5874), 1,
      sym_identifier,
  [109647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5876), 1,
      sym_identifier,
  [109654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_RBRACK,
  [109661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      sym_identifier,
  [109668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5880), 1,
      sym_identifier,
  [109675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      sym_identifier,
  [109682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5882), 1,
      sym_identifier,
  [109689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5884), 1,
      anon_sym_EQ_GT,
  [109696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5886), 1,
      anon_sym_function,
  [109703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 1,
      anon_sym_EQ_GT,
  [109710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5890), 1,
      anon_sym_EQ_GT,
  [109717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 1,
      anon_sym_EQ_GT,
  [109724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 1,
      sym_identifier,
  [109731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 1,
      sym_identifier,
  [109738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5898), 1,
      anon_sym_EQ_GT,
  [109745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 1,
      sym_identifier,
  [109752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5900), 1,
      sym_identifier,
  [109759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 1,
      sym_identifier,
  [109766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 1,
      anon_sym_namespace,
  [109773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5906), 1,
      sym_number,
  [109780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 1,
      sym_identifier,
  [109787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5910), 1,
      anon_sym_SLASH2,
  [109794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 1,
      sym_identifier,
  [109801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 1,
      sym_identifier,
  [109808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 1,
      sym_identifier,
  [109815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5918), 1,
      anon_sym_function,
  [109822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 1,
      sym_identifier,
  [109829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5922), 1,
      sym_identifier,
  [109836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5924), 1,
      anon_sym_EQ_GT,
  [109843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      sym_identifier,
  [109850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      ts_builtin_sym_end,
  [109857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 1,
      sym_identifier,
  [109864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5932), 1,
      anon_sym_target,
  [109871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 1,
      anon_sym_EQ_GT,
  [109878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5936), 1,
      anon_sym_EQ_GT,
  [109885] = 2,
    ACTIONS(4972), 1,
      sym_comment,
    ACTIONS(5938), 1,
      sym_regex_pattern,
  [109892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5940), 1,
      anon_sym_class,
  [109899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 1,
      sym_identifier,
  [109906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5944), 1,
      anon_sym_EQ_GT,
  [109913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 1,
      anon_sym_EQ_GT,
  [109920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5948), 1,
      sym_identifier,
  [109927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 1,
      anon_sym_EQ_GT,
  [109934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym_is,
  [109941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5952), 1,
      anon_sym_EQ_GT,
  [109948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 1,
      sym_identifier,
  [109955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_EQ_GT,
  [109962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      sym_identifier,
  [109969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym_RPAREN,
  [109976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      sym_identifier,
  [109983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 1,
      anon_sym_EQ_GT,
  [109990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4767), 1,
      sym_identifier,
  [109997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5964), 1,
      sym_identifier,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(639)] = 0,
  [SMALL_STATE(640)] = 103,
  [SMALL_STATE(641)] = 206,
  [SMALL_STATE(642)] = 301,
  [SMALL_STATE(643)] = 403,
  [SMALL_STATE(644)] = 505,
  [SMALL_STATE(645)] = 601,
  [SMALL_STATE(646)] = 697,
  [SMALL_STATE(647)] = 795,
  [SMALL_STATE(648)] = 889,
  [SMALL_STATE(649)] = 985,
  [SMALL_STATE(650)] = 1081,
  [SMALL_STATE(651)] = 1174,
  [SMALL_STATE(652)] = 1267,
  [SMALL_STATE(653)] = 1364,
  [SMALL_STATE(654)] = 1459,
  [SMALL_STATE(655)] = 1558,
  [SMALL_STATE(656)] = 1652,
  [SMALL_STATE(657)] = 1746,
  [SMALL_STATE(658)] = 1838,
  [SMALL_STATE(659)] = 1924,
  [SMALL_STATE(660)] = 2016,
  [SMALL_STATE(661)] = 2105,
  [SMALL_STATE(662)] = 2192,
  [SMALL_STATE(663)] = 2279,
  [SMALL_STATE(664)] = 2354,
  [SMALL_STATE(665)] = 2445,
  [SMALL_STATE(666)] = 2512,
  [SMALL_STATE(667)] = 2607,
  [SMALL_STATE(668)] = 2674,
  [SMALL_STATE(669)] = 2765,
  [SMALL_STATE(670)] = 2832,
  [SMALL_STATE(671)] = 2899,
  [SMALL_STATE(672)] = 2966,
  [SMALL_STATE(673)] = 3061,
  [SMALL_STATE(674)] = 3152,
  [SMALL_STATE(675)] = 3227,
  [SMALL_STATE(676)] = 3294,
  [SMALL_STATE(677)] = 3387,
  [SMALL_STATE(678)] = 3454,
  [SMALL_STATE(679)] = 3541,
  [SMALL_STATE(680)] = 3628,
  [SMALL_STATE(681)] = 3695,
  [SMALL_STATE(682)] = 3762,
  [SMALL_STATE(683)] = 3851,
  [SMALL_STATE(684)] = 3939,
  [SMALL_STATE(685)] = 4025,
  [SMALL_STATE(686)] = 4113,
  [SMALL_STATE(687)] = 4197,
  [SMALL_STATE(688)] = 4283,
  [SMALL_STATE(689)] = 4371,
  [SMALL_STATE(690)] = 4459,
  [SMALL_STATE(691)] = 4547,
  [SMALL_STATE(692)] = 4631,
  [SMALL_STATE(693)] = 4717,
  [SMALL_STATE(694)] = 4805,
  [SMALL_STATE(695)] = 4893,
  [SMALL_STATE(696)] = 5024,
  [SMALL_STATE(697)] = 5109,
  [SMALL_STATE(698)] = 5190,
  [SMALL_STATE(699)] = 5275,
  [SMALL_STATE(700)] = 5406,
  [SMALL_STATE(701)] = 5497,
  [SMALL_STATE(702)] = 5574,
  [SMALL_STATE(703)] = 5705,
  [SMALL_STATE(704)] = 5778,
  [SMALL_STATE(705)] = 5851,
  [SMALL_STATE(706)] = 5928,
  [SMALL_STATE(707)] = 6013,
  [SMALL_STATE(708)] = 6144,
  [SMALL_STATE(709)] = 6229,
  [SMALL_STATE(710)] = 6316,
  [SMALL_STATE(711)] = 6401,
  [SMALL_STATE(712)] = 6486,
  [SMALL_STATE(713)] = 6571,
  [SMALL_STATE(714)] = 6658,
  [SMALL_STATE(715)] = 6789,
  [SMALL_STATE(716)] = 6874,
  [SMALL_STATE(717)] = 7005,
  [SMALL_STATE(718)] = 7126,
  [SMALL_STATE(719)] = 7213,
  [SMALL_STATE(720)] = 7298,
  [SMALL_STATE(721)] = 7383,
  [SMALL_STATE(722)] = 7514,
  [SMALL_STATE(723)] = 7597,
  [SMALL_STATE(724)] = 7686,
  [SMALL_STATE(725)] = 7771,
  [SMALL_STATE(726)] = 7852,
  [SMALL_STATE(727)] = 7935,
  [SMALL_STATE(728)] = 8017,
  [SMALL_STATE(729)] = 8081,
  [SMALL_STATE(730)] = 8165,
  [SMALL_STATE(731)] = 8247,
  [SMALL_STATE(732)] = 8333,
  [SMALL_STATE(733)] = 8413,
  [SMALL_STATE(734)] = 8497,
  [SMALL_STATE(735)] = 8561,
  [SMALL_STATE(736)] = 8637,
  [SMALL_STATE(737)] = 8717,
  [SMALL_STATE(738)] = 8801,
  [SMALL_STATE(739)] = 8881,
  [SMALL_STATE(740)] = 8959,
  [SMALL_STATE(741)] = 9039,
  [SMALL_STATE(742)] = 9123,
  [SMALL_STATE(743)] = 9195,
  [SMALL_STATE(744)] = 9269,
  [SMALL_STATE(745)] = 9349,
  [SMALL_STATE(746)] = 9413,
  [SMALL_STATE(747)] = 9495,
  [SMALL_STATE(748)] = 9563,
  [SMALL_STATE(749)] = 9627,
  [SMALL_STATE(750)] = 9691,
  [SMALL_STATE(751)] = 9755,
  [SMALL_STATE(752)] = 9819,
  [SMALL_STATE(753)] = 9897,
  [SMALL_STATE(754)] = 9969,
  [SMALL_STATE(755)] = 10033,
  [SMALL_STATE(756)] = 10109,
  [SMALL_STATE(757)] = 10187,
  [SMALL_STATE(758)] = 10271,
  [SMALL_STATE(759)] = 10349,
  [SMALL_STATE(760)] = 10413,
  [SMALL_STATE(761)] = 10495,
  [SMALL_STATE(762)] = 10573,
  [SMALL_STATE(763)] = 10651,
  [SMALL_STATE(764)] = 10722,
  [SMALL_STATE(765)] = 10799,
  [SMALL_STATE(766)] = 10870,
  [SMALL_STATE(767)] = 10991,
  [SMALL_STATE(768)] = 11072,
  [SMALL_STATE(769)] = 11147,
  [SMALL_STATE(770)] = 11222,
  [SMALL_STATE(771)] = 11303,
  [SMALL_STATE(772)] = 11424,
  [SMALL_STATE(773)] = 11495,
  [SMALL_STATE(774)] = 11570,
  [SMALL_STATE(775)] = 11649,
  [SMALL_STATE(776)] = 11770,
  [SMALL_STATE(777)] = 11891,
  [SMALL_STATE(778)] = 11962,
  [SMALL_STATE(779)] = 12033,
  [SMALL_STATE(780)] = 12104,
  [SMALL_STATE(781)] = 12175,
  [SMALL_STATE(782)] = 12254,
  [SMALL_STATE(783)] = 12331,
  [SMALL_STATE(784)] = 12410,
  [SMALL_STATE(785)] = 12481,
  [SMALL_STATE(786)] = 12548,
  [SMALL_STATE(787)] = 12619,
  [SMALL_STATE(788)] = 12692,
  [SMALL_STATE(789)] = 12813,
  [SMALL_STATE(790)] = 12894,
  [SMALL_STATE(791)] = 12969,
  [SMALL_STATE(792)] = 13087,
  [SMALL_STATE(793)] = 13205,
  [SMALL_STATE(794)] = 13323,
  [SMALL_STATE(795)] = 13441,
  [SMALL_STATE(796)] = 13559,
  [SMALL_STATE(797)] = 13677,
  [SMALL_STATE(798)] = 13795,
  [SMALL_STATE(799)] = 13863,
  [SMALL_STATE(800)] = 13981,
  [SMALL_STATE(801)] = 14053,
  [SMALL_STATE(802)] = 14171,
  [SMALL_STATE(803)] = 14289,
  [SMALL_STATE(804)] = 14363,
  [SMALL_STATE(805)] = 14481,
  [SMALL_STATE(806)] = 14547,
  [SMALL_STATE(807)] = 14621,
  [SMALL_STATE(808)] = 14697,
  [SMALL_STATE(809)] = 14815,
  [SMALL_STATE(810)] = 14883,
  [SMALL_STATE(811)] = 15001,
  [SMALL_STATE(812)] = 15119,
  [SMALL_STATE(813)] = 15185,
  [SMALL_STATE(814)] = 15263,
  [SMALL_STATE(815)] = 15381,
  [SMALL_STATE(816)] = 15499,
  [SMALL_STATE(817)] = 15561,
  [SMALL_STATE(818)] = 15637,
  [SMALL_STATE(819)] = 15709,
  [SMALL_STATE(820)] = 15827,
  [SMALL_STATE(821)] = 15945,
  [SMALL_STATE(822)] = 16063,
  [SMALL_STATE(823)] = 16125,
  [SMALL_STATE(824)] = 16243,
  [SMALL_STATE(825)] = 16361,
  [SMALL_STATE(826)] = 16481,
  [SMALL_STATE(827)] = 16599,
  [SMALL_STATE(828)] = 16661,
  [SMALL_STATE(829)] = 16723,
  [SMALL_STATE(830)] = 16801,
  [SMALL_STATE(831)] = 16919,
  [SMALL_STATE(832)] = 16983,
  [SMALL_STATE(833)] = 17045,
  [SMALL_STATE(834)] = 17107,
  [SMALL_STATE(835)] = 17181,
  [SMALL_STATE(836)] = 17243,
  [SMALL_STATE(837)] = 17317,
  [SMALL_STATE(838)] = 17379,
  [SMALL_STATE(839)] = 17441,
  [SMALL_STATE(840)] = 17503,
  [SMALL_STATE(841)] = 17623,
  [SMALL_STATE(842)] = 17685,
  [SMALL_STATE(843)] = 17800,
  [SMALL_STATE(844)] = 17915,
  [SMALL_STATE(845)] = 18030,
  [SMALL_STATE(846)] = 18145,
  [SMALL_STATE(847)] = 18260,
  [SMALL_STATE(848)] = 18375,
  [SMALL_STATE(849)] = 18490,
  [SMALL_STATE(850)] = 18605,
  [SMALL_STATE(851)] = 18720,
  [SMALL_STATE(852)] = 18835,
  [SMALL_STATE(853)] = 18950,
  [SMALL_STATE(854)] = 19065,
  [SMALL_STATE(855)] = 19180,
  [SMALL_STATE(856)] = 19295,
  [SMALL_STATE(857)] = 19410,
  [SMALL_STATE(858)] = 19525,
  [SMALL_STATE(859)] = 19640,
  [SMALL_STATE(860)] = 19755,
  [SMALL_STATE(861)] = 19870,
  [SMALL_STATE(862)] = 19947,
  [SMALL_STATE(863)] = 20024,
  [SMALL_STATE(864)] = 20139,
  [SMALL_STATE(865)] = 20254,
  [SMALL_STATE(866)] = 20369,
  [SMALL_STATE(867)] = 20484,
  [SMALL_STATE(868)] = 20599,
  [SMALL_STATE(869)] = 20714,
  [SMALL_STATE(870)] = 20785,
  [SMALL_STATE(871)] = 20900,
  [SMALL_STATE(872)] = 21015,
  [SMALL_STATE(873)] = 21080,
  [SMALL_STATE(874)] = 21145,
  [SMALL_STATE(875)] = 21216,
  [SMALL_STATE(876)] = 21331,
  [SMALL_STATE(877)] = 21446,
  [SMALL_STATE(878)] = 21561,
  [SMALL_STATE(879)] = 21676,
  [SMALL_STATE(880)] = 21791,
  [SMALL_STATE(881)] = 21906,
  [SMALL_STATE(882)] = 22021,
  [SMALL_STATE(883)] = 22136,
  [SMALL_STATE(884)] = 22251,
  [SMALL_STATE(885)] = 22366,
  [SMALL_STATE(886)] = 22481,
  [SMALL_STATE(887)] = 22558,
  [SMALL_STATE(888)] = 22673,
  [SMALL_STATE(889)] = 22788,
  [SMALL_STATE(890)] = 22903,
  [SMALL_STATE(891)] = 23018,
  [SMALL_STATE(892)] = 23133,
  [SMALL_STATE(893)] = 23248,
  [SMALL_STATE(894)] = 23363,
  [SMALL_STATE(895)] = 23478,
  [SMALL_STATE(896)] = 23593,
  [SMALL_STATE(897)] = 23708,
  [SMALL_STATE(898)] = 23823,
  [SMALL_STATE(899)] = 23938,
  [SMALL_STATE(900)] = 24053,
  [SMALL_STATE(901)] = 24168,
  [SMALL_STATE(902)] = 24283,
  [SMALL_STATE(903)] = 24398,
  [SMALL_STATE(904)] = 24513,
  [SMALL_STATE(905)] = 24628,
  [SMALL_STATE(906)] = 24743,
  [SMALL_STATE(907)] = 24858,
  [SMALL_STATE(908)] = 24973,
  [SMALL_STATE(909)] = 25088,
  [SMALL_STATE(910)] = 25203,
  [SMALL_STATE(911)] = 25318,
  [SMALL_STATE(912)] = 25433,
  [SMALL_STATE(913)] = 25548,
  [SMALL_STATE(914)] = 25663,
  [SMALL_STATE(915)] = 25778,
  [SMALL_STATE(916)] = 25893,
  [SMALL_STATE(917)] = 26008,
  [SMALL_STATE(918)] = 26123,
  [SMALL_STATE(919)] = 26238,
  [SMALL_STATE(920)] = 26353,
  [SMALL_STATE(921)] = 26468,
  [SMALL_STATE(922)] = 26583,
  [SMALL_STATE(923)] = 26698,
  [SMALL_STATE(924)] = 26813,
  [SMALL_STATE(925)] = 26928,
  [SMALL_STATE(926)] = 27043,
  [SMALL_STATE(927)] = 27158,
  [SMALL_STATE(928)] = 27273,
  [SMALL_STATE(929)] = 27388,
  [SMALL_STATE(930)] = 27503,
  [SMALL_STATE(931)] = 27580,
  [SMALL_STATE(932)] = 27695,
  [SMALL_STATE(933)] = 27810,
  [SMALL_STATE(934)] = 27925,
  [SMALL_STATE(935)] = 28040,
  [SMALL_STATE(936)] = 28155,
  [SMALL_STATE(937)] = 28270,
  [SMALL_STATE(938)] = 28385,
  [SMALL_STATE(939)] = 28500,
  [SMALL_STATE(940)] = 28615,
  [SMALL_STATE(941)] = 28730,
  [SMALL_STATE(942)] = 28845,
  [SMALL_STATE(943)] = 28960,
  [SMALL_STATE(944)] = 29075,
  [SMALL_STATE(945)] = 29190,
  [SMALL_STATE(946)] = 29305,
  [SMALL_STATE(947)] = 29420,
  [SMALL_STATE(948)] = 29535,
  [SMALL_STATE(949)] = 29650,
  [SMALL_STATE(950)] = 29765,
  [SMALL_STATE(951)] = 29880,
  [SMALL_STATE(952)] = 29995,
  [SMALL_STATE(953)] = 30110,
  [SMALL_STATE(954)] = 30225,
  [SMALL_STATE(955)] = 30340,
  [SMALL_STATE(956)] = 30455,
  [SMALL_STATE(957)] = 30570,
  [SMALL_STATE(958)] = 30644,
  [SMALL_STATE(959)] = 30712,
  [SMALL_STATE(960)] = 30780,
  [SMALL_STATE(961)] = 30854,
  [SMALL_STATE(962)] = 30929,
  [SMALL_STATE(963)] = 31037,
  [SMALL_STATE(964)] = 31143,
  [SMALL_STATE(965)] = 31249,
  [SMALL_STATE(966)] = 31355,
  [SMALL_STATE(967)] = 31463,
  [SMALL_STATE(968)] = 31571,
  [SMALL_STATE(969)] = 31677,
  [SMALL_STATE(970)] = 31783,
  [SMALL_STATE(971)] = 31891,
  [SMALL_STATE(972)] = 31996,
  [SMALL_STATE(973)] = 32103,
  [SMALL_STATE(974)] = 32205,
  [SMALL_STATE(975)] = 32307,
  [SMALL_STATE(976)] = 32409,
  [SMALL_STATE(977)] = 32511,
  [SMALL_STATE(978)] = 32613,
  [SMALL_STATE(979)] = 32715,
  [SMALL_STATE(980)] = 32817,
  [SMALL_STATE(981)] = 32919,
  [SMALL_STATE(982)] = 33021,
  [SMALL_STATE(983)] = 33123,
  [SMALL_STATE(984)] = 33225,
  [SMALL_STATE(985)] = 33327,
  [SMALL_STATE(986)] = 33429,
  [SMALL_STATE(987)] = 33531,
  [SMALL_STATE(988)] = 33633,
  [SMALL_STATE(989)] = 33702,
  [SMALL_STATE(990)] = 33755,
  [SMALL_STATE(991)] = 33812,
  [SMALL_STATE(992)] = 33875,
  [SMALL_STATE(993)] = 33944,
  [SMALL_STATE(994)] = 33997,
  [SMALL_STATE(995)] = 34053,
  [SMALL_STATE(996)] = 34151,
  [SMALL_STATE(997)] = 34203,
  [SMALL_STATE(998)] = 34255,
  [SMALL_STATE(999)] = 34353,
  [SMALL_STATE(1000)] = 34451,
  [SMALL_STATE(1001)] = 34503,
  [SMALL_STATE(1002)] = 34569,
  [SMALL_STATE(1003)] = 34667,
  [SMALL_STATE(1004)] = 34719,
  [SMALL_STATE(1005)] = 34771,
  [SMALL_STATE(1006)] = 34829,
  [SMALL_STATE(1007)] = 34881,
  [SMALL_STATE(1008)] = 34933,
  [SMALL_STATE(1009)] = 34985,
  [SMALL_STATE(1010)] = 35041,
  [SMALL_STATE(1011)] = 35099,
  [SMALL_STATE(1012)] = 35197,
  [SMALL_STATE(1013)] = 35295,
  [SMALL_STATE(1014)] = 35351,
  [SMALL_STATE(1015)] = 35405,
  [SMALL_STATE(1016)] = 35461,
  [SMALL_STATE(1017)] = 35517,
  [SMALL_STATE(1018)] = 35574,
  [SMALL_STATE(1019)] = 35631,
  [SMALL_STATE(1020)] = 35682,
  [SMALL_STATE(1021)] = 35735,
  [SMALL_STATE(1022)] = 35788,
  [SMALL_STATE(1023)] = 35839,
  [SMALL_STATE(1024)] = 35910,
  [SMALL_STATE(1025)] = 35971,
  [SMALL_STATE(1026)] = 36042,
  [SMALL_STATE(1027)] = 36093,
  [SMALL_STATE(1028)] = 36188,
  [SMALL_STATE(1029)] = 36283,
  [SMALL_STATE(1030)] = 36338,
  [SMALL_STATE(1031)] = 36389,
  [SMALL_STATE(1032)] = 36440,
  [SMALL_STATE(1033)] = 36491,
  [SMALL_STATE(1034)] = 36542,
  [SMALL_STATE(1035)] = 36595,
  [SMALL_STATE(1036)] = 36690,
  [SMALL_STATE(1037)] = 36741,
  [SMALL_STATE(1038)] = 36812,
  [SMALL_STATE(1039)] = 36907,
  [SMALL_STATE(1040)] = 36960,
  [SMALL_STATE(1041)] = 37015,
  [SMALL_STATE(1042)] = 37066,
  [SMALL_STATE(1043)] = 37161,
  [SMALL_STATE(1044)] = 37214,
  [SMALL_STATE(1045)] = 37265,
  [SMALL_STATE(1046)] = 37316,
  [SMALL_STATE(1047)] = 37369,
  [SMALL_STATE(1048)] = 37420,
  [SMALL_STATE(1049)] = 37471,
  [SMALL_STATE(1050)] = 37522,
  [SMALL_STATE(1051)] = 37573,
  [SMALL_STATE(1052)] = 37624,
  [SMALL_STATE(1053)] = 37695,
  [SMALL_STATE(1054)] = 37790,
  [SMALL_STATE(1055)] = 37841,
  [SMALL_STATE(1056)] = 37912,
  [SMALL_STATE(1057)] = 38007,
  [SMALL_STATE(1058)] = 38060,
  [SMALL_STATE(1059)] = 38111,
  [SMALL_STATE(1060)] = 38206,
  [SMALL_STATE(1061)] = 38301,
  [SMALL_STATE(1062)] = 38356,
  [SMALL_STATE(1063)] = 38411,
  [SMALL_STATE(1064)] = 38464,
  [SMALL_STATE(1065)] = 38515,
  [SMALL_STATE(1066)] = 38566,
  [SMALL_STATE(1067)] = 38661,
  [SMALL_STATE(1068)] = 38756,
  [SMALL_STATE(1069)] = 38807,
  [SMALL_STATE(1070)] = 38880,
  [SMALL_STATE(1071)] = 38937,
  [SMALL_STATE(1072)] = 39034,
  [SMALL_STATE(1073)] = 39085,
  [SMALL_STATE(1074)] = 39162,
  [SMALL_STATE(1075)] = 39257,
  [SMALL_STATE(1076)] = 39352,
  [SMALL_STATE(1077)] = 39409,
  [SMALL_STATE(1078)] = 39460,
  [SMALL_STATE(1079)] = 39555,
  [SMALL_STATE(1080)] = 39650,
  [SMALL_STATE(1081)] = 39701,
  [SMALL_STATE(1082)] = 39792,
  [SMALL_STATE(1083)] = 39875,
  [SMALL_STATE(1084)] = 39926,
  [SMALL_STATE(1085)] = 39981,
  [SMALL_STATE(1086)] = 40068,
  [SMALL_STATE(1087)] = 40131,
  [SMALL_STATE(1088)] = 40182,
  [SMALL_STATE(1089)] = 40245,
  [SMALL_STATE(1090)] = 40296,
  [SMALL_STATE(1091)] = 40377,
  [SMALL_STATE(1092)] = 40428,
  [SMALL_STATE(1093)] = 40485,
  [SMALL_STATE(1094)] = 40536,
  [SMALL_STATE(1095)] = 40591,
  [SMALL_STATE(1096)] = 40642,
  [SMALL_STATE(1097)] = 40713,
  [SMALL_STATE(1098)] = 40764,
  [SMALL_STATE(1099)] = 40815,
  [SMALL_STATE(1100)] = 40865,
  [SMALL_STATE(1101)] = 40925,
  [SMALL_STATE(1102)] = 40975,
  [SMALL_STATE(1103)] = 41029,
  [SMALL_STATE(1104)] = 41129,
  [SMALL_STATE(1105)] = 41223,
  [SMALL_STATE(1106)] = 41273,
  [SMALL_STATE(1107)] = 41323,
  [SMALL_STATE(1108)] = 41373,
  [SMALL_STATE(1109)] = 41423,
  [SMALL_STATE(1110)] = 41517,
  [SMALL_STATE(1111)] = 41611,
  [SMALL_STATE(1112)] = 41661,
  [SMALL_STATE(1113)] = 41711,
  [SMALL_STATE(1114)] = 41805,
  [SMALL_STATE(1115)] = 41899,
  [SMALL_STATE(1116)] = 41993,
  [SMALL_STATE(1117)] = 42043,
  [SMALL_STATE(1118)] = 42137,
  [SMALL_STATE(1119)] = 42187,
  [SMALL_STATE(1120)] = 42277,
  [SMALL_STATE(1121)] = 42375,
  [SMALL_STATE(1122)] = 42425,
  [SMALL_STATE(1123)] = 42519,
  [SMALL_STATE(1124)] = 42569,
  [SMALL_STATE(1125)] = 42619,
  [SMALL_STATE(1126)] = 42669,
  [SMALL_STATE(1127)] = 42719,
  [SMALL_STATE(1128)] = 42769,
  [SMALL_STATE(1129)] = 42839,
  [SMALL_STATE(1130)] = 42919,
  [SMALL_STATE(1131)] = 43005,
  [SMALL_STATE(1132)] = 43087,
  [SMALL_STATE(1133)] = 43137,
  [SMALL_STATE(1134)] = 43213,
  [SMALL_STATE(1135)] = 43263,
  [SMALL_STATE(1136)] = 43361,
  [SMALL_STATE(1137)] = 43411,
  [SMALL_STATE(1138)] = 43461,
  [SMALL_STATE(1139)] = 43531,
  [SMALL_STATE(1140)] = 43631,
  [SMALL_STATE(1141)] = 43697,
  [SMALL_STATE(1142)] = 43747,
  [SMALL_STATE(1143)] = 43841,
  [SMALL_STATE(1144)] = 43891,
  [SMALL_STATE(1145)] = 43947,
  [SMALL_STATE(1146)] = 44017,
  [SMALL_STATE(1147)] = 44067,
  [SMALL_STATE(1148)] = 44117,
  [SMALL_STATE(1149)] = 44167,
  [SMALL_STATE(1150)] = 44217,
  [SMALL_STATE(1151)] = 44311,
  [SMALL_STATE(1152)] = 44405,
  [SMALL_STATE(1153)] = 44455,
  [SMALL_STATE(1154)] = 44505,
  [SMALL_STATE(1155)] = 44555,
  [SMALL_STATE(1156)] = 44605,
  [SMALL_STATE(1157)] = 44655,
  [SMALL_STATE(1158)] = 44727,
  [SMALL_STATE(1159)] = 44777,
  [SMALL_STATE(1160)] = 44877,
  [SMALL_STATE(1161)] = 44971,
  [SMALL_STATE(1162)] = 45041,
  [SMALL_STATE(1163)] = 45135,
  [SMALL_STATE(1164)] = 45185,
  [SMALL_STATE(1165)] = 45235,
  [SMALL_STATE(1166)] = 45285,
  [SMALL_STATE(1167)] = 45335,
  [SMALL_STATE(1168)] = 45385,
  [SMALL_STATE(1169)] = 45485,
  [SMALL_STATE(1170)] = 45551,
  [SMALL_STATE(1171)] = 45601,
  [SMALL_STATE(1172)] = 45651,
  [SMALL_STATE(1173)] = 45701,
  [SMALL_STATE(1174)] = 45751,
  [SMALL_STATE(1175)] = 45801,
  [SMALL_STATE(1176)] = 45851,
  [SMALL_STATE(1177)] = 45901,
  [SMALL_STATE(1178)] = 45951,
  [SMALL_STATE(1179)] = 46001,
  [SMALL_STATE(1180)] = 46051,
  [SMALL_STATE(1181)] = 46101,
  [SMALL_STATE(1182)] = 46199,
  [SMALL_STATE(1183)] = 46249,
  [SMALL_STATE(1184)] = 46349,
  [SMALL_STATE(1185)] = 46399,
  [SMALL_STATE(1186)] = 46493,
  [SMALL_STATE(1187)] = 46587,
  [SMALL_STATE(1188)] = 46637,
  [SMALL_STATE(1189)] = 46687,
  [SMALL_STATE(1190)] = 46737,
  [SMALL_STATE(1191)] = 46787,
  [SMALL_STATE(1192)] = 46837,
  [SMALL_STATE(1193)] = 46887,
  [SMALL_STATE(1194)] = 46937,
  [SMALL_STATE(1195)] = 47035,
  [SMALL_STATE(1196)] = 47085,
  [SMALL_STATE(1197)] = 47135,
  [SMALL_STATE(1198)] = 47233,
  [SMALL_STATE(1199)] = 47283,
  [SMALL_STATE(1200)] = 47339,
  [SMALL_STATE(1201)] = 47393,
  [SMALL_STATE(1202)] = 47443,
  [SMALL_STATE(1203)] = 47543,
  [SMALL_STATE(1204)] = 47593,
  [SMALL_STATE(1205)] = 47687,
  [SMALL_STATE(1206)] = 47737,
  [SMALL_STATE(1207)] = 47787,
  [SMALL_STATE(1208)] = 47837,
  [SMALL_STATE(1209)] = 47887,
  [SMALL_STATE(1210)] = 47980,
  [SMALL_STATE(1211)] = 48069,
  [SMALL_STATE(1212)] = 48138,
  [SMALL_STATE(1213)] = 48189,
  [SMALL_STATE(1214)] = 48238,
  [SMALL_STATE(1215)] = 48331,
  [SMALL_STATE(1216)] = 48424,
  [SMALL_STATE(1217)] = 48483,
  [SMALL_STATE(1218)] = 48580,
  [SMALL_STATE(1219)] = 48673,
  [SMALL_STATE(1220)] = 48766,
  [SMALL_STATE(1221)] = 48859,
  [SMALL_STATE(1222)] = 48912,
  [SMALL_STATE(1223)] = 49009,
  [SMALL_STATE(1224)] = 49102,
  [SMALL_STATE(1225)] = 49159,
  [SMALL_STATE(1226)] = 49208,
  [SMALL_STATE(1227)] = 49259,
  [SMALL_STATE(1228)] = 49356,
  [SMALL_STATE(1229)] = 49453,
  [SMALL_STATE(1230)] = 49550,
  [SMALL_STATE(1231)] = 49599,
  [SMALL_STATE(1232)] = 49696,
  [SMALL_STATE(1233)] = 49789,
  [SMALL_STATE(1234)] = 49882,
  [SMALL_STATE(1235)] = 49951,
  [SMALL_STATE(1236)] = 50012,
  [SMALL_STATE(1237)] = 50105,
  [SMALL_STATE(1238)] = 50202,
  [SMALL_STATE(1239)] = 50295,
  [SMALL_STATE(1240)] = 50390,
  [SMALL_STATE(1241)] = 50485,
  [SMALL_STATE(1242)] = 50564,
  [SMALL_STATE(1243)] = 50657,
  [SMALL_STATE(1244)] = 50752,
  [SMALL_STATE(1245)] = 50837,
  [SMALL_STATE(1246)] = 50932,
  [SMALL_STATE(1247)] = 50987,
  [SMALL_STATE(1248)] = 51068,
  [SMALL_STATE(1249)] = 51121,
  [SMALL_STATE(1250)] = 51186,
  [SMALL_STATE(1251)] = 51251,
  [SMALL_STATE(1252)] = 51348,
  [SMALL_STATE(1253)] = 51443,
  [SMALL_STATE(1254)] = 51496,
  [SMALL_STATE(1255)] = 51565,
  [SMALL_STATE(1256)] = 51620,
  [SMALL_STATE(1257)] = 51713,
  [SMALL_STATE(1258)] = 51806,
  [SMALL_STATE(1259)] = 51857,
  [SMALL_STATE(1260)] = 51954,
  [SMALL_STATE(1261)] = 52035,
  [SMALL_STATE(1262)] = 52130,
  [SMALL_STATE(1263)] = 52227,
  [SMALL_STATE(1264)] = 52278,
  [SMALL_STATE(1265)] = 52347,
  [SMALL_STATE(1266)] = 52416,
  [SMALL_STATE(1267)] = 52511,
  [SMALL_STATE(1268)] = 52564,
  [SMALL_STATE(1269)] = 52659,
  [SMALL_STATE(1270)] = 52754,
  [SMALL_STATE(1271)] = 52803,
  [SMALL_STATE(1272)] = 52852,
  [SMALL_STATE(1273)] = 52905,
  [SMALL_STATE(1274)] = 52956,
  [SMALL_STATE(1275)] = 53031,
  [SMALL_STATE(1276)] = 53102,
  [SMALL_STATE(1277)] = 53171,
  [SMALL_STATE(1278)] = 53268,
  [SMALL_STATE(1279)] = 53361,
  [SMALL_STATE(1280)] = 53422,
  [SMALL_STATE(1281)] = 53517,
  [SMALL_STATE(1282)] = 53612,
  [SMALL_STATE(1283)] = 53707,
  [SMALL_STATE(1284)] = 53804,
  [SMALL_STATE(1285)] = 53893,
  [SMALL_STATE(1286)] = 53988,
  [SMALL_STATE(1287)] = 54081,
  [SMALL_STATE(1288)] = 54176,
  [SMALL_STATE(1289)] = 54273,
  [SMALL_STATE(1290)] = 54366,
  [SMALL_STATE(1291)] = 54423,
  [SMALL_STATE(1292)] = 54492,
  [SMALL_STATE(1293)] = 54571,
  [SMALL_STATE(1294)] = 54656,
  [SMALL_STATE(1295)] = 54751,
  [SMALL_STATE(1296)] = 54826,
  [SMALL_STATE(1297)] = 54923,
  [SMALL_STATE(1298)] = 54994,
  [SMALL_STATE(1299)] = 55089,
  [SMALL_STATE(1300)] = 55184,
  [SMALL_STATE(1301)] = 55277,
  [SMALL_STATE(1302)] = 55346,
  [SMALL_STATE(1303)] = 55439,
  [SMALL_STATE(1304)] = 55532,
  [SMALL_STATE(1305)] = 55625,
  [SMALL_STATE(1306)] = 55718,
  [SMALL_STATE(1307)] = 55813,
  [SMALL_STATE(1308)] = 55872,
  [SMALL_STATE(1309)] = 55921,
  [SMALL_STATE(1310)] = 56016,
  [SMALL_STATE(1311)] = 56111,
  [SMALL_STATE(1312)] = 56164,
  [SMALL_STATE(1313)] = 56227,
  [SMALL_STATE(1314)] = 56319,
  [SMALL_STATE(1315)] = 56387,
  [SMALL_STATE(1316)] = 56455,
  [SMALL_STATE(1317)] = 56533,
  [SMALL_STATE(1318)] = 56617,
  [SMALL_STATE(1319)] = 56697,
  [SMALL_STATE(1320)] = 56771,
  [SMALL_STATE(1321)] = 56841,
  [SMALL_STATE(1322)] = 56933,
  [SMALL_STATE(1323)] = 57025,
  [SMALL_STATE(1324)] = 57077,
  [SMALL_STATE(1325)] = 57169,
  [SMALL_STATE(1326)] = 57263,
  [SMALL_STATE(1327)] = 57317,
  [SMALL_STATE(1328)] = 57409,
  [SMALL_STATE(1329)] = 57501,
  [SMALL_STATE(1330)] = 57579,
  [SMALL_STATE(1331)] = 57627,
  [SMALL_STATE(1332)] = 57675,
  [SMALL_STATE(1333)] = 57723,
  [SMALL_STATE(1334)] = 57815,
  [SMALL_STATE(1335)] = 57863,
  [SMALL_STATE(1336)] = 57917,
  [SMALL_STATE(1337)] = 57965,
  [SMALL_STATE(1338)] = 58013,
  [SMALL_STATE(1339)] = 58061,
  [SMALL_STATE(1340)] = 58129,
  [SMALL_STATE(1341)] = 58217,
  [SMALL_STATE(1342)] = 58269,
  [SMALL_STATE(1343)] = 58361,
  [SMALL_STATE(1344)] = 58441,
  [SMALL_STATE(1345)] = 58533,
  [SMALL_STATE(1346)] = 58625,
  [SMALL_STATE(1347)] = 58717,
  [SMALL_STATE(1348)] = 58809,
  [SMALL_STATE(1349)] = 58863,
  [SMALL_STATE(1350)] = 58931,
  [SMALL_STATE(1351)] = 59023,
  [SMALL_STATE(1352)] = 59115,
  [SMALL_STATE(1353)] = 59165,
  [SMALL_STATE(1354)] = 59257,
  [SMALL_STATE(1355)] = 59309,
  [SMALL_STATE(1356)] = 59401,
  [SMALL_STATE(1357)] = 59453,
  [SMALL_STATE(1358)] = 59545,
  [SMALL_STATE(1359)] = 59595,
  [SMALL_STATE(1360)] = 59683,
  [SMALL_STATE(1361)] = 59741,
  [SMALL_STATE(1362)] = 59833,
  [SMALL_STATE(1363)] = 59925,
  [SMALL_STATE(1364)] = 59975,
  [SMALL_STATE(1365)] = 60067,
  [SMALL_STATE(1366)] = 60119,
  [SMALL_STATE(1367)] = 60211,
  [SMALL_STATE(1368)] = 60303,
  [SMALL_STATE(1369)] = 60395,
  [SMALL_STATE(1370)] = 60469,
  [SMALL_STATE(1371)] = 60521,
  [SMALL_STATE(1372)] = 60573,
  [SMALL_STATE(1373)] = 60623,
  [SMALL_STATE(1374)] = 60717,
  [SMALL_STATE(1375)] = 60811,
  [SMALL_STATE(1376)] = 60881,
  [SMALL_STATE(1377)] = 60973,
  [SMALL_STATE(1378)] = 61067,
  [SMALL_STATE(1379)] = 61119,
  [SMALL_STATE(1380)] = 61173,
  [SMALL_STATE(1381)] = 61265,
  [SMALL_STATE(1382)] = 61319,
  [SMALL_STATE(1383)] = 61411,
  [SMALL_STATE(1384)] = 61505,
  [SMALL_STATE(1385)] = 61599,
  [SMALL_STATE(1386)] = 61651,
  [SMALL_STATE(1387)] = 61701,
  [SMALL_STATE(1388)] = 61755,
  [SMALL_STATE(1389)] = 61849,
  [SMALL_STATE(1390)] = 61901,
  [SMALL_STATE(1391)] = 61953,
  [SMALL_STATE(1392)] = 62019,
  [SMALL_STATE(1393)] = 62087,
  [SMALL_STATE(1394)] = 62149,
  [SMALL_STATE(1395)] = 62243,
  [SMALL_STATE(1396)] = 62335,
  [SMALL_STATE(1397)] = 62387,
  [SMALL_STATE(1398)] = 62439,
  [SMALL_STATE(1399)] = 62531,
  [SMALL_STATE(1400)] = 62599,
  [SMALL_STATE(1401)] = 62693,
  [SMALL_STATE(1402)] = 62787,
  [SMALL_STATE(1403)] = 62879,
  [SMALL_STATE(1404)] = 62973,
  [SMALL_STATE(1405)] = 63065,
  [SMALL_STATE(1406)] = 63157,
  [SMALL_STATE(1407)] = 63225,
  [SMALL_STATE(1408)] = 63285,
  [SMALL_STATE(1409)] = 63339,
  [SMALL_STATE(1410)] = 63399,
  [SMALL_STATE(1411)] = 63459,
  [SMALL_STATE(1412)] = 63553,
  [SMALL_STATE(1413)] = 63613,
  [SMALL_STATE(1414)] = 63663,
  [SMALL_STATE(1415)] = 63711,
  [SMALL_STATE(1416)] = 63803,
  [SMALL_STATE(1417)] = 63851,
  [SMALL_STATE(1418)] = 63899,
  [SMALL_STATE(1419)] = 63947,
  [SMALL_STATE(1420)] = 64015,
  [SMALL_STATE(1421)] = 64063,
  [SMALL_STATE(1422)] = 64111,
  [SMALL_STATE(1423)] = 64161,
  [SMALL_STATE(1424)] = 64255,
  [SMALL_STATE(1425)] = 64303,
  [SMALL_STATE(1426)] = 64351,
  [SMALL_STATE(1427)] = 64445,
  [SMALL_STATE(1428)] = 64493,
  [SMALL_STATE(1429)] = 64541,
  [SMALL_STATE(1430)] = 64589,
  [SMALL_STATE(1431)] = 64637,
  [SMALL_STATE(1432)] = 64689,
  [SMALL_STATE(1433)] = 64737,
  [SMALL_STATE(1434)] = 64787,
  [SMALL_STATE(1435)] = 64835,
  [SMALL_STATE(1436)] = 64883,
  [SMALL_STATE(1437)] = 64935,
  [SMALL_STATE(1438)] = 65019,
  [SMALL_STATE(1439)] = 65067,
  [SMALL_STATE(1440)] = 65117,
  [SMALL_STATE(1441)] = 65165,
  [SMALL_STATE(1442)] = 65259,
  [SMALL_STATE(1443)] = 65353,
  [SMALL_STATE(1444)] = 65401,
  [SMALL_STATE(1445)] = 65453,
  [SMALL_STATE(1446)] = 65505,
  [SMALL_STATE(1447)] = 65597,
  [SMALL_STATE(1448)] = 65645,
  [SMALL_STATE(1449)] = 65697,
  [SMALL_STATE(1450)] = 65751,
  [SMALL_STATE(1451)] = 65845,
  [SMALL_STATE(1452)] = 65897,
  [SMALL_STATE(1453)] = 65989,
  [SMALL_STATE(1454)] = 66041,
  [SMALL_STATE(1455)] = 66089,
  [SMALL_STATE(1456)] = 66137,
  [SMALL_STATE(1457)] = 66229,
  [SMALL_STATE(1458)] = 66323,
  [SMALL_STATE(1459)] = 66375,
  [SMALL_STATE(1460)] = 66467,
  [SMALL_STATE(1461)] = 66561,
  [SMALL_STATE(1462)] = 66655,
  [SMALL_STATE(1463)] = 66747,
  [SMALL_STATE(1464)] = 66841,
  [SMALL_STATE(1465)] = 66893,
  [SMALL_STATE(1466)] = 66945,
  [SMALL_STATE(1467)] = 67001,
  [SMALL_STATE(1468)] = 67095,
  [SMALL_STATE(1469)] = 67151,
  [SMALL_STATE(1470)] = 67243,
  [SMALL_STATE(1471)] = 67297,
  [SMALL_STATE(1472)] = 67391,
  [SMALL_STATE(1473)] = 67439,
  [SMALL_STATE(1474)] = 67487,
  [SMALL_STATE(1475)] = 67581,
  [SMALL_STATE(1476)] = 67675,
  [SMALL_STATE(1477)] = 67767,
  [SMALL_STATE(1478)] = 67850,
  [SMALL_STATE(1479)] = 67907,
  [SMALL_STATE(1480)] = 67954,
  [SMALL_STATE(1481)] = 68039,
  [SMALL_STATE(1482)] = 68122,
  [SMALL_STATE(1483)] = 68205,
  [SMALL_STATE(1484)] = 68252,
  [SMALL_STATE(1485)] = 68299,
  [SMALL_STATE(1486)] = 68346,
  [SMALL_STATE(1487)] = 68393,
  [SMALL_STATE(1488)] = 68446,
  [SMALL_STATE(1489)] = 68493,
  [SMALL_STATE(1490)] = 68584,
  [SMALL_STATE(1491)] = 68631,
  [SMALL_STATE(1492)] = 68690,
  [SMALL_STATE(1493)] = 68739,
  [SMALL_STATE(1494)] = 68788,
  [SMALL_STATE(1495)] = 68835,
  [SMALL_STATE(1496)] = 68882,
  [SMALL_STATE(1497)] = 68929,
  [SMALL_STATE(1498)] = 68982,
  [SMALL_STATE(1499)] = 69029,
  [SMALL_STATE(1500)] = 69114,
  [SMALL_STATE(1501)] = 69171,
  [SMALL_STATE(1502)] = 69230,
  [SMALL_STATE(1503)] = 69321,
  [SMALL_STATE(1504)] = 69368,
  [SMALL_STATE(1505)] = 69415,
  [SMALL_STATE(1506)] = 69462,
  [SMALL_STATE(1507)] = 69553,
  [SMALL_STATE(1508)] = 69600,
  [SMALL_STATE(1509)] = 69647,
  [SMALL_STATE(1510)] = 69694,
  [SMALL_STATE(1511)] = 69741,
  [SMALL_STATE(1512)] = 69790,
  [SMALL_STATE(1513)] = 69837,
  [SMALL_STATE(1514)] = 69884,
  [SMALL_STATE(1515)] = 69967,
  [SMALL_STATE(1516)] = 70022,
  [SMALL_STATE(1517)] = 70077,
  [SMALL_STATE(1518)] = 70124,
  [SMALL_STATE(1519)] = 70183,
  [SMALL_STATE(1520)] = 70230,
  [SMALL_STATE(1521)] = 70289,
  [SMALL_STATE(1522)] = 70336,
  [SMALL_STATE(1523)] = 70383,
  [SMALL_STATE(1524)] = 70430,
  [SMALL_STATE(1525)] = 70477,
  [SMALL_STATE(1526)] = 70526,
  [SMALL_STATE(1527)] = 70573,
  [SMALL_STATE(1528)] = 70624,
  [SMALL_STATE(1529)] = 70679,
  [SMALL_STATE(1530)] = 70764,
  [SMALL_STATE(1531)] = 70811,
  [SMALL_STATE(1532)] = 70858,
  [SMALL_STATE(1533)] = 70911,
  [SMALL_STATE(1534)] = 70958,
  [SMALL_STATE(1535)] = 71017,
  [SMALL_STATE(1536)] = 71100,
  [SMALL_STATE(1537)] = 71191,
  [SMALL_STATE(1538)] = 71238,
  [SMALL_STATE(1539)] = 71285,
  [SMALL_STATE(1540)] = 71332,
  [SMALL_STATE(1541)] = 71379,
  [SMALL_STATE(1542)] = 71426,
  [SMALL_STATE(1543)] = 71473,
  [SMALL_STATE(1544)] = 71556,
  [SMALL_STATE(1545)] = 71603,
  [SMALL_STATE(1546)] = 71650,
  [SMALL_STATE(1547)] = 71697,
  [SMALL_STATE(1548)] = 71744,
  [SMALL_STATE(1549)] = 71791,
  [SMALL_STATE(1550)] = 71852,
  [SMALL_STATE(1551)] = 71913,
  [SMALL_STATE(1552)] = 71964,
  [SMALL_STATE(1553)] = 72025,
  [SMALL_STATE(1554)] = 72082,
  [SMALL_STATE(1555)] = 72129,
  [SMALL_STATE(1556)] = 72182,
  [SMALL_STATE(1557)] = 72229,
  [SMALL_STATE(1558)] = 72276,
  [SMALL_STATE(1559)] = 72323,
  [SMALL_STATE(1560)] = 72408,
  [SMALL_STATE(1561)] = 72461,
  [SMALL_STATE(1562)] = 72512,
  [SMALL_STATE(1563)] = 72559,
  [SMALL_STATE(1564)] = 72606,
  [SMALL_STATE(1565)] = 72653,
  [SMALL_STATE(1566)] = 72700,
  [SMALL_STATE(1567)] = 72783,
  [SMALL_STATE(1568)] = 72830,
  [SMALL_STATE(1569)] = 72877,
  [SMALL_STATE(1570)] = 72924,
  [SMALL_STATE(1571)] = 72971,
  [SMALL_STATE(1572)] = 73018,
  [SMALL_STATE(1573)] = 73065,
  [SMALL_STATE(1574)] = 73112,
  [SMALL_STATE(1575)] = 73161,
  [SMALL_STATE(1576)] = 73208,
  [SMALL_STATE(1577)] = 73255,
  [SMALL_STATE(1578)] = 73346,
  [SMALL_STATE(1579)] = 73393,
  [SMALL_STATE(1580)] = 73440,
  [SMALL_STATE(1581)] = 73487,
  [SMALL_STATE(1582)] = 73578,
  [SMALL_STATE(1583)] = 73625,
  [SMALL_STATE(1584)] = 73680,
  [SMALL_STATE(1585)] = 73727,
  [SMALL_STATE(1586)] = 73776,
  [SMALL_STATE(1587)] = 73823,
  [SMALL_STATE(1588)] = 73870,
  [SMALL_STATE(1589)] = 73917,
  [SMALL_STATE(1590)] = 73964,
  [SMALL_STATE(1591)] = 74047,
  [SMALL_STATE(1592)] = 74094,
  [SMALL_STATE(1593)] = 74141,
  [SMALL_STATE(1594)] = 74232,
  [SMALL_STATE(1595)] = 74323,
  [SMALL_STATE(1596)] = 74370,
  [SMALL_STATE(1597)] = 74417,
  [SMALL_STATE(1598)] = 74466,
  [SMALL_STATE(1599)] = 74549,
  [SMALL_STATE(1600)] = 74596,
  [SMALL_STATE(1601)] = 74651,
  [SMALL_STATE(1602)] = 74706,
  [SMALL_STATE(1603)] = 74753,
  [SMALL_STATE(1604)] = 74800,
  [SMALL_STATE(1605)] = 74849,
  [SMALL_STATE(1606)] = 74896,
  [SMALL_STATE(1607)] = 74943,
  [SMALL_STATE(1608)] = 74990,
  [SMALL_STATE(1609)] = 75073,
  [SMALL_STATE(1610)] = 75120,
  [SMALL_STATE(1611)] = 75167,
  [SMALL_STATE(1612)] = 75226,
  [SMALL_STATE(1613)] = 75273,
  [SMALL_STATE(1614)] = 75330,
  [SMALL_STATE(1615)] = 75413,
  [SMALL_STATE(1616)] = 75462,
  [SMALL_STATE(1617)] = 75519,
  [SMALL_STATE(1618)] = 75566,
  [SMALL_STATE(1619)] = 75613,
  [SMALL_STATE(1620)] = 75664,
  [SMALL_STATE(1621)] = 75711,
  [SMALL_STATE(1622)] = 75758,
  [SMALL_STATE(1623)] = 75809,
  [SMALL_STATE(1624)] = 75858,
  [SMALL_STATE(1625)] = 75905,
  [SMALL_STATE(1626)] = 75964,
  [SMALL_STATE(1627)] = 76011,
  [SMALL_STATE(1628)] = 76094,
  [SMALL_STATE(1629)] = 76177,
  [SMALL_STATE(1630)] = 76224,
  [SMALL_STATE(1631)] = 76309,
  [SMALL_STATE(1632)] = 76356,
  [SMALL_STATE(1633)] = 76413,
  [SMALL_STATE(1634)] = 76460,
  [SMALL_STATE(1635)] = 76507,
  [SMALL_STATE(1636)] = 76553,
  [SMALL_STATE(1637)] = 76619,
  [SMALL_STATE(1638)] = 76665,
  [SMALL_STATE(1639)] = 76729,
  [SMALL_STATE(1640)] = 76775,
  [SMALL_STATE(1641)] = 76821,
  [SMALL_STATE(1642)] = 76867,
  [SMALL_STATE(1643)] = 76913,
  [SMALL_STATE(1644)] = 77001,
  [SMALL_STATE(1645)] = 77089,
  [SMALL_STATE(1646)] = 77157,
  [SMALL_STATE(1647)] = 77223,
  [SMALL_STATE(1648)] = 77269,
  [SMALL_STATE(1649)] = 77315,
  [SMALL_STATE(1650)] = 77361,
  [SMALL_STATE(1651)] = 77407,
  [SMALL_STATE(1652)] = 77453,
  [SMALL_STATE(1653)] = 77517,
  [SMALL_STATE(1654)] = 77563,
  [SMALL_STATE(1655)] = 77609,
  [SMALL_STATE(1656)] = 77697,
  [SMALL_STATE(1657)] = 77743,
  [SMALL_STATE(1658)] = 77789,
  [SMALL_STATE(1659)] = 77835,
  [SMALL_STATE(1660)] = 77881,
  [SMALL_STATE(1661)] = 77935,
  [SMALL_STATE(1662)] = 77981,
  [SMALL_STATE(1663)] = 78045,
  [SMALL_STATE(1664)] = 78091,
  [SMALL_STATE(1665)] = 78137,
  [SMALL_STATE(1666)] = 78183,
  [SMALL_STATE(1667)] = 78229,
  [SMALL_STATE(1668)] = 78275,
  [SMALL_STATE(1669)] = 78321,
  [SMALL_STATE(1670)] = 78367,
  [SMALL_STATE(1671)] = 78413,
  [SMALL_STATE(1672)] = 78459,
  [SMALL_STATE(1673)] = 78505,
  [SMALL_STATE(1674)] = 78573,
  [SMALL_STATE(1675)] = 78653,
  [SMALL_STATE(1676)] = 78699,
  [SMALL_STATE(1677)] = 78745,
  [SMALL_STATE(1678)] = 78791,
  [SMALL_STATE(1679)] = 78837,
  [SMALL_STATE(1680)] = 78883,
  [SMALL_STATE(1681)] = 78951,
  [SMALL_STATE(1682)] = 78997,
  [SMALL_STATE(1683)] = 79043,
  [SMALL_STATE(1684)] = 79089,
  [SMALL_STATE(1685)] = 79135,
  [SMALL_STATE(1686)] = 79201,
  [SMALL_STATE(1687)] = 79247,
  [SMALL_STATE(1688)] = 79293,
  [SMALL_STATE(1689)] = 79359,
  [SMALL_STATE(1690)] = 79405,
  [SMALL_STATE(1691)] = 79451,
  [SMALL_STATE(1692)] = 79519,
  [SMALL_STATE(1693)] = 79565,
  [SMALL_STATE(1694)] = 79611,
  [SMALL_STATE(1695)] = 79657,
  [SMALL_STATE(1696)] = 79703,
  [SMALL_STATE(1697)] = 79757,
  [SMALL_STATE(1698)] = 79803,
  [SMALL_STATE(1699)] = 79849,
  [SMALL_STATE(1700)] = 79895,
  [SMALL_STATE(1701)] = 79941,
  [SMALL_STATE(1702)] = 79987,
  [SMALL_STATE(1703)] = 80051,
  [SMALL_STATE(1704)] = 80097,
  [SMALL_STATE(1705)] = 80143,
  [SMALL_STATE(1706)] = 80195,
  [SMALL_STATE(1707)] = 80241,
  [SMALL_STATE(1708)] = 80287,
  [SMALL_STATE(1709)] = 80341,
  [SMALL_STATE(1710)] = 80395,
  [SMALL_STATE(1711)] = 80441,
  [SMALL_STATE(1712)] = 80487,
  [SMALL_STATE(1713)] = 80533,
  [SMALL_STATE(1714)] = 80590,
  [SMALL_STATE(1715)] = 80649,
  [SMALL_STATE(1716)] = 80706,
  [SMALL_STATE(1717)] = 80769,
  [SMALL_STATE(1718)] = 80832,
  [SMALL_STATE(1719)] = 80891,
  [SMALL_STATE(1720)] = 80954,
  [SMALL_STATE(1721)] = 81021,
  [SMALL_STATE(1722)] = 81086,
  [SMALL_STATE(1723)] = 81143,
  [SMALL_STATE(1724)] = 81202,
  [SMALL_STATE(1725)] = 81259,
  [SMALL_STATE(1726)] = 81318,
  [SMALL_STATE(1727)] = 81378,
  [SMALL_STATE(1728)] = 81440,
  [SMALL_STATE(1729)] = 81502,
  [SMALL_STATE(1730)] = 81564,
  [SMALL_STATE(1731)] = 81624,
  [SMALL_STATE(1732)] = 81682,
  [SMALL_STATE(1733)] = 81744,
  [SMALL_STATE(1734)] = 81804,
  [SMALL_STATE(1735)] = 81862,
  [SMALL_STATE(1736)] = 81908,
  [SMALL_STATE(1737)] = 81966,
  [SMALL_STATE(1738)] = 82026,
  [SMALL_STATE(1739)] = 82084,
  [SMALL_STATE(1740)] = 82142,
  [SMALL_STATE(1741)] = 82202,
  [SMALL_STATE(1742)] = 82260,
  [SMALL_STATE(1743)] = 82318,
  [SMALL_STATE(1744)] = 82376,
  [SMALL_STATE(1745)] = 82434,
  [SMALL_STATE(1746)] = 82492,
  [SMALL_STATE(1747)] = 82554,
  [SMALL_STATE(1748)] = 82612,
  [SMALL_STATE(1749)] = 82672,
  [SMALL_STATE(1750)] = 82730,
  [SMALL_STATE(1751)] = 82790,
  [SMALL_STATE(1752)] = 82843,
  [SMALL_STATE(1753)] = 82910,
  [SMALL_STATE(1754)] = 82963,
  [SMALL_STATE(1755)] = 83016,
  [SMALL_STATE(1756)] = 83065,
  [SMALL_STATE(1757)] = 83114,
  [SMALL_STATE(1758)] = 83183,
  [SMALL_STATE(1759)] = 83236,
  [SMALL_STATE(1760)] = 83289,
  [SMALL_STATE(1761)] = 83342,
  [SMALL_STATE(1762)] = 83415,
  [SMALL_STATE(1763)] = 83488,
  [SMALL_STATE(1764)] = 83553,
  [SMALL_STATE(1765)] = 83620,
  [SMALL_STATE(1766)] = 83689,
  [SMALL_STATE(1767)] = 83754,
  [SMALL_STATE(1768)] = 83827,
  [SMALL_STATE(1769)] = 83892,
  [SMALL_STATE(1770)] = 83965,
  [SMALL_STATE(1771)] = 84034,
  [SMALL_STATE(1772)] = 84083,
  [SMALL_STATE(1773)] = 84132,
  [SMALL_STATE(1774)] = 84185,
  [SMALL_STATE(1775)] = 84252,
  [SMALL_STATE(1776)] = 84325,
  [SMALL_STATE(1777)] = 84378,
  [SMALL_STATE(1778)] = 84431,
  [SMALL_STATE(1779)] = 84484,
  [SMALL_STATE(1780)] = 84551,
  [SMALL_STATE(1781)] = 84624,
  [SMALL_STATE(1782)] = 84697,
  [SMALL_STATE(1783)] = 84750,
  [SMALL_STATE(1784)] = 84823,
  [SMALL_STATE(1785)] = 84890,
  [SMALL_STATE(1786)] = 84943,
  [SMALL_STATE(1787)] = 84996,
  [SMALL_STATE(1788)] = 85049,
  [SMALL_STATE(1789)] = 85102,
  [SMALL_STATE(1790)] = 85171,
  [SMALL_STATE(1791)] = 85220,
  [SMALL_STATE(1792)] = 85289,
  [SMALL_STATE(1793)] = 85354,
  [SMALL_STATE(1794)] = 85427,
  [SMALL_STATE(1795)] = 85492,
  [SMALL_STATE(1796)] = 85534,
  [SMALL_STATE(1797)] = 85594,
  [SMALL_STATE(1798)] = 85664,
  [SMALL_STATE(1799)] = 85726,
  [SMALL_STATE(1800)] = 85786,
  [SMALL_STATE(1801)] = 85856,
  [SMALL_STATE(1802)] = 85920,
  [SMALL_STATE(1803)] = 85980,
  [SMALL_STATE(1804)] = 86050,
  [SMALL_STATE(1805)] = 86120,
  [SMALL_STATE(1806)] = 86168,
  [SMALL_STATE(1807)] = 86228,
  [SMALL_STATE(1808)] = 86288,
  [SMALL_STATE(1809)] = 86348,
  [SMALL_STATE(1810)] = 86427,
  [SMALL_STATE(1811)] = 86506,
  [SMALL_STATE(1812)] = 86585,
  [SMALL_STATE(1813)] = 86640,
  [SMALL_STATE(1814)] = 86719,
  [SMALL_STATE(1815)] = 86798,
  [SMALL_STATE(1816)] = 86877,
  [SMALL_STATE(1817)] = 86917,
  [SMALL_STATE(1818)] = 86967,
  [SMALL_STATE(1819)] = 87017,
  [SMALL_STATE(1820)] = 87067,
  [SMALL_STATE(1821)] = 87107,
  [SMALL_STATE(1822)] = 87147,
  [SMALL_STATE(1823)] = 87187,
  [SMALL_STATE(1824)] = 87227,
  [SMALL_STATE(1825)] = 87277,
  [SMALL_STATE(1826)] = 87327,
  [SMALL_STATE(1827)] = 87372,
  [SMALL_STATE(1828)] = 87410,
  [SMALL_STATE(1829)] = 87448,
  [SMALL_STATE(1830)] = 87486,
  [SMALL_STATE(1831)] = 87524,
  [SMALL_STATE(1832)] = 87562,
  [SMALL_STATE(1833)] = 87602,
  [SMALL_STATE(1834)] = 87652,
  [SMALL_STATE(1835)] = 87704,
  [SMALL_STATE(1836)] = 87758,
  [SMALL_STATE(1837)] = 87814,
  [SMALL_STATE(1838)] = 87852,
  [SMALL_STATE(1839)] = 87890,
  [SMALL_STATE(1840)] = 87930,
  [SMALL_STATE(1841)] = 87968,
  [SMALL_STATE(1842)] = 88006,
  [SMALL_STATE(1843)] = 88044,
  [SMALL_STATE(1844)] = 88082,
  [SMALL_STATE(1845)] = 88136,
  [SMALL_STATE(1846)] = 88176,
  [SMALL_STATE(1847)] = 88214,
  [SMALL_STATE(1848)] = 88252,
  [SMALL_STATE(1849)] = 88304,
  [SMALL_STATE(1850)] = 88356,
  [SMALL_STATE(1851)] = 88394,
  [SMALL_STATE(1852)] = 88441,
  [SMALL_STATE(1853)] = 88488,
  [SMALL_STATE(1854)] = 88535,
  [SMALL_STATE(1855)] = 88582,
  [SMALL_STATE(1856)] = 88629,
  [SMALL_STATE(1857)] = 88676,
  [SMALL_STATE(1858)] = 88723,
  [SMALL_STATE(1859)] = 88770,
  [SMALL_STATE(1860)] = 88817,
  [SMALL_STATE(1861)] = 88864,
  [SMALL_STATE(1862)] = 88911,
  [SMALL_STATE(1863)] = 88958,
  [SMALL_STATE(1864)] = 89005,
  [SMALL_STATE(1865)] = 89052,
  [SMALL_STATE(1866)] = 89099,
  [SMALL_STATE(1867)] = 89146,
  [SMALL_STATE(1868)] = 89193,
  [SMALL_STATE(1869)] = 89240,
  [SMALL_STATE(1870)] = 89288,
  [SMALL_STATE(1871)] = 89330,
  [SMALL_STATE(1872)] = 89378,
  [SMALL_STATE(1873)] = 89426,
  [SMALL_STATE(1874)] = 89474,
  [SMALL_STATE(1875)] = 89522,
  [SMALL_STATE(1876)] = 89570,
  [SMALL_STATE(1877)] = 89626,
  [SMALL_STATE(1878)] = 89662,
  [SMALL_STATE(1879)] = 89699,
  [SMALL_STATE(1880)] = 89752,
  [SMALL_STATE(1881)] = 89805,
  [SMALL_STATE(1882)] = 89850,
  [SMALL_STATE(1883)] = 89903,
  [SMALL_STATE(1884)] = 89952,
  [SMALL_STATE(1885)] = 90001,
  [SMALL_STATE(1886)] = 90043,
  [SMALL_STATE(1887)] = 90085,
  [SMALL_STATE(1888)] = 90127,
  [SMALL_STATE(1889)] = 90169,
  [SMALL_STATE(1890)] = 90211,
  [SMALL_STATE(1891)] = 90253,
  [SMALL_STATE(1892)] = 90295,
  [SMALL_STATE(1893)] = 90337,
  [SMALL_STATE(1894)] = 90379,
  [SMALL_STATE(1895)] = 90421,
  [SMALL_STATE(1896)] = 90463,
  [SMALL_STATE(1897)] = 90505,
  [SMALL_STATE(1898)] = 90547,
  [SMALL_STATE(1899)] = 90589,
  [SMALL_STATE(1900)] = 90631,
  [SMALL_STATE(1901)] = 90673,
  [SMALL_STATE(1902)] = 90715,
  [SMALL_STATE(1903)] = 90757,
  [SMALL_STATE(1904)] = 90799,
  [SMALL_STATE(1905)] = 90841,
  [SMALL_STATE(1906)] = 90883,
  [SMALL_STATE(1907)] = 90925,
  [SMALL_STATE(1908)] = 90967,
  [SMALL_STATE(1909)] = 91001,
  [SMALL_STATE(1910)] = 91043,
  [SMALL_STATE(1911)] = 91085,
  [SMALL_STATE(1912)] = 91115,
  [SMALL_STATE(1913)] = 91147,
  [SMALL_STATE(1914)] = 91179,
  [SMALL_STATE(1915)] = 91211,
  [SMALL_STATE(1916)] = 91240,
  [SMALL_STATE(1917)] = 91267,
  [SMALL_STATE(1918)] = 91296,
  [SMALL_STATE(1919)] = 91322,
  [SMALL_STATE(1920)] = 91346,
  [SMALL_STATE(1921)] = 91370,
  [SMALL_STATE(1922)] = 91391,
  [SMALL_STATE(1923)] = 91412,
  [SMALL_STATE(1924)] = 91433,
  [SMALL_STATE(1925)] = 91462,
  [SMALL_STATE(1926)] = 91489,
  [SMALL_STATE(1927)] = 91510,
  [SMALL_STATE(1928)] = 91531,
  [SMALL_STATE(1929)] = 91560,
  [SMALL_STATE(1930)] = 91581,
  [SMALL_STATE(1931)] = 91611,
  [SMALL_STATE(1932)] = 91653,
  [SMALL_STATE(1933)] = 91681,
  [SMALL_STATE(1934)] = 91723,
  [SMALL_STATE(1935)] = 91751,
  [SMALL_STATE(1936)] = 91793,
  [SMALL_STATE(1937)] = 91821,
  [SMALL_STATE(1938)] = 91863,
  [SMALL_STATE(1939)] = 91905,
  [SMALL_STATE(1940)] = 91947,
  [SMALL_STATE(1941)] = 91970,
  [SMALL_STATE(1942)] = 92005,
  [SMALL_STATE(1943)] = 92042,
  [SMALL_STATE(1944)] = 92077,
  [SMALL_STATE(1945)] = 92112,
  [SMALL_STATE(1946)] = 92147,
  [SMALL_STATE(1947)] = 92182,
  [SMALL_STATE(1948)] = 92207,
  [SMALL_STATE(1949)] = 92242,
  [SMALL_STATE(1950)] = 92265,
  [SMALL_STATE(1951)] = 92300,
  [SMALL_STATE(1952)] = 92335,
  [SMALL_STATE(1953)] = 92360,
  [SMALL_STATE(1954)] = 92396,
  [SMALL_STATE(1955)] = 92418,
  [SMALL_STATE(1956)] = 92450,
  [SMALL_STATE(1957)] = 92486,
  [SMALL_STATE(1958)] = 92514,
  [SMALL_STATE(1959)] = 92546,
  [SMALL_STATE(1960)] = 92578,
  [SMALL_STATE(1961)] = 92604,
  [SMALL_STATE(1962)] = 92640,
  [SMALL_STATE(1963)] = 92672,
  [SMALL_STATE(1964)] = 92704,
  [SMALL_STATE(1965)] = 92740,
  [SMALL_STATE(1966)] = 92776,
  [SMALL_STATE(1967)] = 92812,
  [SMALL_STATE(1968)] = 92844,
  [SMALL_STATE(1969)] = 92876,
  [SMALL_STATE(1970)] = 92908,
  [SMALL_STATE(1971)] = 92927,
  [SMALL_STATE(1972)] = 92948,
  [SMALL_STATE(1973)] = 92967,
  [SMALL_STATE(1974)] = 92986,
  [SMALL_STATE(1975)] = 93007,
  [SMALL_STATE(1976)] = 93026,
  [SMALL_STATE(1977)] = 93045,
  [SMALL_STATE(1978)] = 93066,
  [SMALL_STATE(1979)] = 93085,
  [SMALL_STATE(1980)] = 93108,
  [SMALL_STATE(1981)] = 93127,
  [SMALL_STATE(1982)] = 93146,
  [SMALL_STATE(1983)] = 93165,
  [SMALL_STATE(1984)] = 93184,
  [SMALL_STATE(1985)] = 93203,
  [SMALL_STATE(1986)] = 93220,
  [SMALL_STATE(1987)] = 93239,
  [SMALL_STATE(1988)] = 93258,
  [SMALL_STATE(1989)] = 93277,
  [SMALL_STATE(1990)] = 93300,
  [SMALL_STATE(1991)] = 93319,
  [SMALL_STATE(1992)] = 93338,
  [SMALL_STATE(1993)] = 93359,
  [SMALL_STATE(1994)] = 93380,
  [SMALL_STATE(1995)] = 93399,
  [SMALL_STATE(1996)] = 93418,
  [SMALL_STATE(1997)] = 93437,
  [SMALL_STATE(1998)] = 93456,
  [SMALL_STATE(1999)] = 93475,
  [SMALL_STATE(2000)] = 93494,
  [SMALL_STATE(2001)] = 93513,
  [SMALL_STATE(2002)] = 93532,
  [SMALL_STATE(2003)] = 93553,
  [SMALL_STATE(2004)] = 93572,
  [SMALL_STATE(2005)] = 93591,
  [SMALL_STATE(2006)] = 93610,
  [SMALL_STATE(2007)] = 93629,
  [SMALL_STATE(2008)] = 93648,
  [SMALL_STATE(2009)] = 93667,
  [SMALL_STATE(2010)] = 93684,
  [SMALL_STATE(2011)] = 93705,
  [SMALL_STATE(2012)] = 93726,
  [SMALL_STATE(2013)] = 93747,
  [SMALL_STATE(2014)] = 93765,
  [SMALL_STATE(2015)] = 93799,
  [SMALL_STATE(2016)] = 93833,
  [SMALL_STATE(2017)] = 93855,
  [SMALL_STATE(2018)] = 93875,
  [SMALL_STATE(2019)] = 93909,
  [SMALL_STATE(2020)] = 93939,
  [SMALL_STATE(2021)] = 93959,
  [SMALL_STATE(2022)] = 93983,
  [SMALL_STATE(2023)] = 94003,
  [SMALL_STATE(2024)] = 94037,
  [SMALL_STATE(2025)] = 94071,
  [SMALL_STATE(2026)] = 94105,
  [SMALL_STATE(2027)] = 94139,
  [SMALL_STATE(2028)] = 94173,
  [SMALL_STATE(2029)] = 94207,
  [SMALL_STATE(2030)] = 94241,
  [SMALL_STATE(2031)] = 94272,
  [SMALL_STATE(2032)] = 94303,
  [SMALL_STATE(2033)] = 94328,
  [SMALL_STATE(2034)] = 94359,
  [SMALL_STATE(2035)] = 94376,
  [SMALL_STATE(2036)] = 94407,
  [SMALL_STATE(2037)] = 94432,
  [SMALL_STATE(2038)] = 94463,
  [SMALL_STATE(2039)] = 94482,
  [SMALL_STATE(2040)] = 94499,
  [SMALL_STATE(2041)] = 94530,
  [SMALL_STATE(2042)] = 94561,
  [SMALL_STATE(2043)] = 94578,
  [SMALL_STATE(2044)] = 94595,
  [SMALL_STATE(2045)] = 94626,
  [SMALL_STATE(2046)] = 94657,
  [SMALL_STATE(2047)] = 94688,
  [SMALL_STATE(2048)] = 94709,
  [SMALL_STATE(2049)] = 94734,
  [SMALL_STATE(2050)] = 94765,
  [SMALL_STATE(2051)] = 94796,
  [SMALL_STATE(2052)] = 94827,
  [SMALL_STATE(2053)] = 94846,
  [SMALL_STATE(2054)] = 94877,
  [SMALL_STATE(2055)] = 94900,
  [SMALL_STATE(2056)] = 94931,
  [SMALL_STATE(2057)] = 94950,
  [SMALL_STATE(2058)] = 94981,
  [SMALL_STATE(2059)] = 95006,
  [SMALL_STATE(2060)] = 95037,
  [SMALL_STATE(2061)] = 95062,
  [SMALL_STATE(2062)] = 95093,
  [SMALL_STATE(2063)] = 95118,
  [SMALL_STATE(2064)] = 95143,
  [SMALL_STATE(2065)] = 95165,
  [SMALL_STATE(2066)] = 95187,
  [SMALL_STATE(2067)] = 95209,
  [SMALL_STATE(2068)] = 95229,
  [SMALL_STATE(2069)] = 95251,
  [SMALL_STATE(2070)] = 95273,
  [SMALL_STATE(2071)] = 95293,
  [SMALL_STATE(2072)] = 95317,
  [SMALL_STATE(2073)] = 95339,
  [SMALL_STATE(2074)] = 95359,
  [SMALL_STATE(2075)] = 95379,
  [SMALL_STATE(2076)] = 95400,
  [SMALL_STATE(2077)] = 95417,
  [SMALL_STATE(2078)] = 95442,
  [SMALL_STATE(2079)] = 95463,
  [SMALL_STATE(2080)] = 95480,
  [SMALL_STATE(2081)] = 95497,
  [SMALL_STATE(2082)] = 95514,
  [SMALL_STATE(2083)] = 95539,
  [SMALL_STATE(2084)] = 95564,
  [SMALL_STATE(2085)] = 95589,
  [SMALL_STATE(2086)] = 95614,
  [SMALL_STATE(2087)] = 95639,
  [SMALL_STATE(2088)] = 95664,
  [SMALL_STATE(2089)] = 95689,
  [SMALL_STATE(2090)] = 95714,
  [SMALL_STATE(2091)] = 95731,
  [SMALL_STATE(2092)] = 95756,
  [SMALL_STATE(2093)] = 95781,
  [SMALL_STATE(2094)] = 95798,
  [SMALL_STATE(2095)] = 95813,
  [SMALL_STATE(2096)] = 95826,
  [SMALL_STATE(2097)] = 95851,
  [SMALL_STATE(2098)] = 95876,
  [SMALL_STATE(2099)] = 95901,
  [SMALL_STATE(2100)] = 95926,
  [SMALL_STATE(2101)] = 95951,
  [SMALL_STATE(2102)] = 95976,
  [SMALL_STATE(2103)] = 96001,
  [SMALL_STATE(2104)] = 96018,
  [SMALL_STATE(2105)] = 96031,
  [SMALL_STATE(2106)] = 96056,
  [SMALL_STATE(2107)] = 96079,
  [SMALL_STATE(2108)] = 96096,
  [SMALL_STATE(2109)] = 96121,
  [SMALL_STATE(2110)] = 96146,
  [SMALL_STATE(2111)] = 96171,
  [SMALL_STATE(2112)] = 96188,
  [SMALL_STATE(2113)] = 96213,
  [SMALL_STATE(2114)] = 96238,
  [SMALL_STATE(2115)] = 96255,
  [SMALL_STATE(2116)] = 96268,
  [SMALL_STATE(2117)] = 96281,
  [SMALL_STATE(2118)] = 96298,
  [SMALL_STATE(2119)] = 96323,
  [SMALL_STATE(2120)] = 96348,
  [SMALL_STATE(2121)] = 96369,
  [SMALL_STATE(2122)] = 96386,
  [SMALL_STATE(2123)] = 96407,
  [SMALL_STATE(2124)] = 96432,
  [SMALL_STATE(2125)] = 96457,
  [SMALL_STATE(2126)] = 96470,
  [SMALL_STATE(2127)] = 96485,
  [SMALL_STATE(2128)] = 96506,
  [SMALL_STATE(2129)] = 96531,
  [SMALL_STATE(2130)] = 96556,
  [SMALL_STATE(2131)] = 96581,
  [SMALL_STATE(2132)] = 96594,
  [SMALL_STATE(2133)] = 96611,
  [SMALL_STATE(2134)] = 96636,
  [SMALL_STATE(2135)] = 96661,
  [SMALL_STATE(2136)] = 96682,
  [SMALL_STATE(2137)] = 96707,
  [SMALL_STATE(2138)] = 96728,
  [SMALL_STATE(2139)] = 96753,
  [SMALL_STATE(2140)] = 96778,
  [SMALL_STATE(2141)] = 96803,
  [SMALL_STATE(2142)] = 96828,
  [SMALL_STATE(2143)] = 96853,
  [SMALL_STATE(2144)] = 96870,
  [SMALL_STATE(2145)] = 96895,
  [SMALL_STATE(2146)] = 96920,
  [SMALL_STATE(2147)] = 96945,
  [SMALL_STATE(2148)] = 96962,
  [SMALL_STATE(2149)] = 96979,
  [SMALL_STATE(2150)] = 96991,
  [SMALL_STATE(2151)] = 97007,
  [SMALL_STATE(2152)] = 97029,
  [SMALL_STATE(2153)] = 97051,
  [SMALL_STATE(2154)] = 97069,
  [SMALL_STATE(2155)] = 97091,
  [SMALL_STATE(2156)] = 97109,
  [SMALL_STATE(2157)] = 97125,
  [SMALL_STATE(2158)] = 97141,
  [SMALL_STATE(2159)] = 97161,
  [SMALL_STATE(2160)] = 97183,
  [SMALL_STATE(2161)] = 97199,
  [SMALL_STATE(2162)] = 97221,
  [SMALL_STATE(2163)] = 97243,
  [SMALL_STATE(2164)] = 97265,
  [SMALL_STATE(2165)] = 97277,
  [SMALL_STATE(2166)] = 97299,
  [SMALL_STATE(2167)] = 97321,
  [SMALL_STATE(2168)] = 97337,
  [SMALL_STATE(2169)] = 97353,
  [SMALL_STATE(2170)] = 97373,
  [SMALL_STATE(2171)] = 97395,
  [SMALL_STATE(2172)] = 97411,
  [SMALL_STATE(2173)] = 97433,
  [SMALL_STATE(2174)] = 97445,
  [SMALL_STATE(2175)] = 97461,
  [SMALL_STATE(2176)] = 97477,
  [SMALL_STATE(2177)] = 97499,
  [SMALL_STATE(2178)] = 97517,
  [SMALL_STATE(2179)] = 97539,
  [SMALL_STATE(2180)] = 97555,
  [SMALL_STATE(2181)] = 97571,
  [SMALL_STATE(2182)] = 97587,
  [SMALL_STATE(2183)] = 97605,
  [SMALL_STATE(2184)] = 97621,
  [SMALL_STATE(2185)] = 97643,
  [SMALL_STATE(2186)] = 97659,
  [SMALL_STATE(2187)] = 97679,
  [SMALL_STATE(2188)] = 97701,
  [SMALL_STATE(2189)] = 97723,
  [SMALL_STATE(2190)] = 97741,
  [SMALL_STATE(2191)] = 97759,
  [SMALL_STATE(2192)] = 97775,
  [SMALL_STATE(2193)] = 97797,
  [SMALL_STATE(2194)] = 97819,
  [SMALL_STATE(2195)] = 97841,
  [SMALL_STATE(2196)] = 97863,
  [SMALL_STATE(2197)] = 97883,
  [SMALL_STATE(2198)] = 97905,
  [SMALL_STATE(2199)] = 97923,
  [SMALL_STATE(2200)] = 97945,
  [SMALL_STATE(2201)] = 97963,
  [SMALL_STATE(2202)] = 97985,
  [SMALL_STATE(2203)] = 98007,
  [SMALL_STATE(2204)] = 98029,
  [SMALL_STATE(2205)] = 98045,
  [SMALL_STATE(2206)] = 98063,
  [SMALL_STATE(2207)] = 98085,
  [SMALL_STATE(2208)] = 98107,
  [SMALL_STATE(2209)] = 98129,
  [SMALL_STATE(2210)] = 98145,
  [SMALL_STATE(2211)] = 98165,
  [SMALL_STATE(2212)] = 98183,
  [SMALL_STATE(2213)] = 98205,
  [SMALL_STATE(2214)] = 98223,
  [SMALL_STATE(2215)] = 98245,
  [SMALL_STATE(2216)] = 98263,
  [SMALL_STATE(2217)] = 98285,
  [SMALL_STATE(2218)] = 98305,
  [SMALL_STATE(2219)] = 98321,
  [SMALL_STATE(2220)] = 98343,
  [SMALL_STATE(2221)] = 98365,
  [SMALL_STATE(2222)] = 98387,
  [SMALL_STATE(2223)] = 98409,
  [SMALL_STATE(2224)] = 98427,
  [SMALL_STATE(2225)] = 98449,
  [SMALL_STATE(2226)] = 98461,
  [SMALL_STATE(2227)] = 98477,
  [SMALL_STATE(2228)] = 98489,
  [SMALL_STATE(2229)] = 98507,
  [SMALL_STATE(2230)] = 98529,
  [SMALL_STATE(2231)] = 98551,
  [SMALL_STATE(2232)] = 98573,
  [SMALL_STATE(2233)] = 98591,
  [SMALL_STATE(2234)] = 98611,
  [SMALL_STATE(2235)] = 98629,
  [SMALL_STATE(2236)] = 98645,
  [SMALL_STATE(2237)] = 98663,
  [SMALL_STATE(2238)] = 98685,
  [SMALL_STATE(2239)] = 98707,
  [SMALL_STATE(2240)] = 98723,
  [SMALL_STATE(2241)] = 98745,
  [SMALL_STATE(2242)] = 98763,
  [SMALL_STATE(2243)] = 98785,
  [SMALL_STATE(2244)] = 98807,
  [SMALL_STATE(2245)] = 98829,
  [SMALL_STATE(2246)] = 98851,
  [SMALL_STATE(2247)] = 98869,
  [SMALL_STATE(2248)] = 98891,
  [SMALL_STATE(2249)] = 98909,
  [SMALL_STATE(2250)] = 98929,
  [SMALL_STATE(2251)] = 98951,
  [SMALL_STATE(2252)] = 98969,
  [SMALL_STATE(2253)] = 98991,
  [SMALL_STATE(2254)] = 99003,
  [SMALL_STATE(2255)] = 99025,
  [SMALL_STATE(2256)] = 99047,
  [SMALL_STATE(2257)] = 99069,
  [SMALL_STATE(2258)] = 99091,
  [SMALL_STATE(2259)] = 99107,
  [SMALL_STATE(2260)] = 99129,
  [SMALL_STATE(2261)] = 99151,
  [SMALL_STATE(2262)] = 99167,
  [SMALL_STATE(2263)] = 99189,
  [SMALL_STATE(2264)] = 99211,
  [SMALL_STATE(2265)] = 99230,
  [SMALL_STATE(2266)] = 99247,
  [SMALL_STATE(2267)] = 99266,
  [SMALL_STATE(2268)] = 99281,
  [SMALL_STATE(2269)] = 99296,
  [SMALL_STATE(2270)] = 99315,
  [SMALL_STATE(2271)] = 99330,
  [SMALL_STATE(2272)] = 99341,
  [SMALL_STATE(2273)] = 99360,
  [SMALL_STATE(2274)] = 99377,
  [SMALL_STATE(2275)] = 99388,
  [SMALL_STATE(2276)] = 99405,
  [SMALL_STATE(2277)] = 99416,
  [SMALL_STATE(2278)] = 99435,
  [SMALL_STATE(2279)] = 99450,
  [SMALL_STATE(2280)] = 99465,
  [SMALL_STATE(2281)] = 99476,
  [SMALL_STATE(2282)] = 99495,
  [SMALL_STATE(2283)] = 99506,
  [SMALL_STATE(2284)] = 99517,
  [SMALL_STATE(2285)] = 99528,
  [SMALL_STATE(2286)] = 99539,
  [SMALL_STATE(2287)] = 99554,
  [SMALL_STATE(2288)] = 99569,
  [SMALL_STATE(2289)] = 99588,
  [SMALL_STATE(2290)] = 99599,
  [SMALL_STATE(2291)] = 99618,
  [SMALL_STATE(2292)] = 99637,
  [SMALL_STATE(2293)] = 99652,
  [SMALL_STATE(2294)] = 99667,
  [SMALL_STATE(2295)] = 99682,
  [SMALL_STATE(2296)] = 99693,
  [SMALL_STATE(2297)] = 99712,
  [SMALL_STATE(2298)] = 99723,
  [SMALL_STATE(2299)] = 99742,
  [SMALL_STATE(2300)] = 99753,
  [SMALL_STATE(2301)] = 99764,
  [SMALL_STATE(2302)] = 99775,
  [SMALL_STATE(2303)] = 99786,
  [SMALL_STATE(2304)] = 99805,
  [SMALL_STATE(2305)] = 99816,
  [SMALL_STATE(2306)] = 99827,
  [SMALL_STATE(2307)] = 99838,
  [SMALL_STATE(2308)] = 99849,
  [SMALL_STATE(2309)] = 99868,
  [SMALL_STATE(2310)] = 99879,
  [SMALL_STATE(2311)] = 99890,
  [SMALL_STATE(2312)] = 99901,
  [SMALL_STATE(2313)] = 99920,
  [SMALL_STATE(2314)] = 99931,
  [SMALL_STATE(2315)] = 99942,
  [SMALL_STATE(2316)] = 99953,
  [SMALL_STATE(2317)] = 99964,
  [SMALL_STATE(2318)] = 99975,
  [SMALL_STATE(2319)] = 99986,
  [SMALL_STATE(2320)] = 99997,
  [SMALL_STATE(2321)] = 100012,
  [SMALL_STATE(2322)] = 100023,
  [SMALL_STATE(2323)] = 100034,
  [SMALL_STATE(2324)] = 100045,
  [SMALL_STATE(2325)] = 100064,
  [SMALL_STATE(2326)] = 100075,
  [SMALL_STATE(2327)] = 100086,
  [SMALL_STATE(2328)] = 100097,
  [SMALL_STATE(2329)] = 100116,
  [SMALL_STATE(2330)] = 100135,
  [SMALL_STATE(2331)] = 100154,
  [SMALL_STATE(2332)] = 100171,
  [SMALL_STATE(2333)] = 100190,
  [SMALL_STATE(2334)] = 100201,
  [SMALL_STATE(2335)] = 100218,
  [SMALL_STATE(2336)] = 100229,
  [SMALL_STATE(2337)] = 100248,
  [SMALL_STATE(2338)] = 100267,
  [SMALL_STATE(2339)] = 100286,
  [SMALL_STATE(2340)] = 100305,
  [SMALL_STATE(2341)] = 100316,
  [SMALL_STATE(2342)] = 100335,
  [SMALL_STATE(2343)] = 100346,
  [SMALL_STATE(2344)] = 100365,
  [SMALL_STATE(2345)] = 100376,
  [SMALL_STATE(2346)] = 100395,
  [SMALL_STATE(2347)] = 100414,
  [SMALL_STATE(2348)] = 100429,
  [SMALL_STATE(2349)] = 100448,
  [SMALL_STATE(2350)] = 100467,
  [SMALL_STATE(2351)] = 100486,
  [SMALL_STATE(2352)] = 100497,
  [SMALL_STATE(2353)] = 100516,
  [SMALL_STATE(2354)] = 100527,
  [SMALL_STATE(2355)] = 100546,
  [SMALL_STATE(2356)] = 100565,
  [SMALL_STATE(2357)] = 100580,
  [SMALL_STATE(2358)] = 100591,
  [SMALL_STATE(2359)] = 100602,
  [SMALL_STATE(2360)] = 100613,
  [SMALL_STATE(2361)] = 100624,
  [SMALL_STATE(2362)] = 100643,
  [SMALL_STATE(2363)] = 100662,
  [SMALL_STATE(2364)] = 100677,
  [SMALL_STATE(2365)] = 100688,
  [SMALL_STATE(2366)] = 100707,
  [SMALL_STATE(2367)] = 100724,
  [SMALL_STATE(2368)] = 100739,
  [SMALL_STATE(2369)] = 100750,
  [SMALL_STATE(2370)] = 100769,
  [SMALL_STATE(2371)] = 100788,
  [SMALL_STATE(2372)] = 100803,
  [SMALL_STATE(2373)] = 100814,
  [SMALL_STATE(2374)] = 100833,
  [SMALL_STATE(2375)] = 100852,
  [SMALL_STATE(2376)] = 100863,
  [SMALL_STATE(2377)] = 100874,
  [SMALL_STATE(2378)] = 100885,
  [SMALL_STATE(2379)] = 100896,
  [SMALL_STATE(2380)] = 100915,
  [SMALL_STATE(2381)] = 100930,
  [SMALL_STATE(2382)] = 100941,
  [SMALL_STATE(2383)] = 100952,
  [SMALL_STATE(2384)] = 100963,
  [SMALL_STATE(2385)] = 100978,
  [SMALL_STATE(2386)] = 100993,
  [SMALL_STATE(2387)] = 101004,
  [SMALL_STATE(2388)] = 101015,
  [SMALL_STATE(2389)] = 101026,
  [SMALL_STATE(2390)] = 101037,
  [SMALL_STATE(2391)] = 101056,
  [SMALL_STATE(2392)] = 101067,
  [SMALL_STATE(2393)] = 101078,
  [SMALL_STATE(2394)] = 101089,
  [SMALL_STATE(2395)] = 101100,
  [SMALL_STATE(2396)] = 101111,
  [SMALL_STATE(2397)] = 101122,
  [SMALL_STATE(2398)] = 101133,
  [SMALL_STATE(2399)] = 101144,
  [SMALL_STATE(2400)] = 101163,
  [SMALL_STATE(2401)] = 101174,
  [SMALL_STATE(2402)] = 101185,
  [SMALL_STATE(2403)] = 101196,
  [SMALL_STATE(2404)] = 101215,
  [SMALL_STATE(2405)] = 101226,
  [SMALL_STATE(2406)] = 101237,
  [SMALL_STATE(2407)] = 101248,
  [SMALL_STATE(2408)] = 101261,
  [SMALL_STATE(2409)] = 101276,
  [SMALL_STATE(2410)] = 101287,
  [SMALL_STATE(2411)] = 101304,
  [SMALL_STATE(2412)] = 101319,
  [SMALL_STATE(2413)] = 101338,
  [SMALL_STATE(2414)] = 101357,
  [SMALL_STATE(2415)] = 101372,
  [SMALL_STATE(2416)] = 101391,
  [SMALL_STATE(2417)] = 101402,
  [SMALL_STATE(2418)] = 101413,
  [SMALL_STATE(2419)] = 101424,
  [SMALL_STATE(2420)] = 101435,
  [SMALL_STATE(2421)] = 101446,
  [SMALL_STATE(2422)] = 101461,
  [SMALL_STATE(2423)] = 101480,
  [SMALL_STATE(2424)] = 101499,
  [SMALL_STATE(2425)] = 101510,
  [SMALL_STATE(2426)] = 101525,
  [SMALL_STATE(2427)] = 101536,
  [SMALL_STATE(2428)] = 101555,
  [SMALL_STATE(2429)] = 101566,
  [SMALL_STATE(2430)] = 101577,
  [SMALL_STATE(2431)] = 101588,
  [SMALL_STATE(2432)] = 101599,
  [SMALL_STATE(2433)] = 101610,
  [SMALL_STATE(2434)] = 101621,
  [SMALL_STATE(2435)] = 101632,
  [SMALL_STATE(2436)] = 101643,
  [SMALL_STATE(2437)] = 101654,
  [SMALL_STATE(2438)] = 101665,
  [SMALL_STATE(2439)] = 101676,
  [SMALL_STATE(2440)] = 101687,
  [SMALL_STATE(2441)] = 101698,
  [SMALL_STATE(2442)] = 101709,
  [SMALL_STATE(2443)] = 101720,
  [SMALL_STATE(2444)] = 101731,
  [SMALL_STATE(2445)] = 101742,
  [SMALL_STATE(2446)] = 101761,
  [SMALL_STATE(2447)] = 101772,
  [SMALL_STATE(2448)] = 101783,
  [SMALL_STATE(2449)] = 101802,
  [SMALL_STATE(2450)] = 101813,
  [SMALL_STATE(2451)] = 101824,
  [SMALL_STATE(2452)] = 101835,
  [SMALL_STATE(2453)] = 101846,
  [SMALL_STATE(2454)] = 101865,
  [SMALL_STATE(2455)] = 101876,
  [SMALL_STATE(2456)] = 101891,
  [SMALL_STATE(2457)] = 101902,
  [SMALL_STATE(2458)] = 101921,
  [SMALL_STATE(2459)] = 101940,
  [SMALL_STATE(2460)] = 101953,
  [SMALL_STATE(2461)] = 101968,
  [SMALL_STATE(2462)] = 101983,
  [SMALL_STATE(2463)] = 101998,
  [SMALL_STATE(2464)] = 102017,
  [SMALL_STATE(2465)] = 102028,
  [SMALL_STATE(2466)] = 102047,
  [SMALL_STATE(2467)] = 102058,
  [SMALL_STATE(2468)] = 102075,
  [SMALL_STATE(2469)] = 102086,
  [SMALL_STATE(2470)] = 102097,
  [SMALL_STATE(2471)] = 102116,
  [SMALL_STATE(2472)] = 102127,
  [SMALL_STATE(2473)] = 102146,
  [SMALL_STATE(2474)] = 102157,
  [SMALL_STATE(2475)] = 102170,
  [SMALL_STATE(2476)] = 102185,
  [SMALL_STATE(2477)] = 102200,
  [SMALL_STATE(2478)] = 102219,
  [SMALL_STATE(2479)] = 102230,
  [SMALL_STATE(2480)] = 102245,
  [SMALL_STATE(2481)] = 102256,
  [SMALL_STATE(2482)] = 102267,
  [SMALL_STATE(2483)] = 102280,
  [SMALL_STATE(2484)] = 102293,
  [SMALL_STATE(2485)] = 102308,
  [SMALL_STATE(2486)] = 102323,
  [SMALL_STATE(2487)] = 102339,
  [SMALL_STATE(2488)] = 102355,
  [SMALL_STATE(2489)] = 102369,
  [SMALL_STATE(2490)] = 102383,
  [SMALL_STATE(2491)] = 102393,
  [SMALL_STATE(2492)] = 102409,
  [SMALL_STATE(2493)] = 102425,
  [SMALL_STATE(2494)] = 102441,
  [SMALL_STATE(2495)] = 102457,
  [SMALL_STATE(2496)] = 102473,
  [SMALL_STATE(2497)] = 102489,
  [SMALL_STATE(2498)] = 102505,
  [SMALL_STATE(2499)] = 102521,
  [SMALL_STATE(2500)] = 102537,
  [SMALL_STATE(2501)] = 102553,
  [SMALL_STATE(2502)] = 102569,
  [SMALL_STATE(2503)] = 102583,
  [SMALL_STATE(2504)] = 102599,
  [SMALL_STATE(2505)] = 102613,
  [SMALL_STATE(2506)] = 102627,
  [SMALL_STATE(2507)] = 102637,
  [SMALL_STATE(2508)] = 102653,
  [SMALL_STATE(2509)] = 102669,
  [SMALL_STATE(2510)] = 102683,
  [SMALL_STATE(2511)] = 102699,
  [SMALL_STATE(2512)] = 102715,
  [SMALL_STATE(2513)] = 102727,
  [SMALL_STATE(2514)] = 102743,
  [SMALL_STATE(2515)] = 102759,
  [SMALL_STATE(2516)] = 102775,
  [SMALL_STATE(2517)] = 102789,
  [SMALL_STATE(2518)] = 102801,
  [SMALL_STATE(2519)] = 102813,
  [SMALL_STATE(2520)] = 102829,
  [SMALL_STATE(2521)] = 102845,
  [SMALL_STATE(2522)] = 102859,
  [SMALL_STATE(2523)] = 102875,
  [SMALL_STATE(2524)] = 102891,
  [SMALL_STATE(2525)] = 102907,
  [SMALL_STATE(2526)] = 102923,
  [SMALL_STATE(2527)] = 102939,
  [SMALL_STATE(2528)] = 102955,
  [SMALL_STATE(2529)] = 102971,
  [SMALL_STATE(2530)] = 102985,
  [SMALL_STATE(2531)] = 103001,
  [SMALL_STATE(2532)] = 103015,
  [SMALL_STATE(2533)] = 103029,
  [SMALL_STATE(2534)] = 103045,
  [SMALL_STATE(2535)] = 103061,
  [SMALL_STATE(2536)] = 103077,
  [SMALL_STATE(2537)] = 103093,
  [SMALL_STATE(2538)] = 103109,
  [SMALL_STATE(2539)] = 103123,
  [SMALL_STATE(2540)] = 103139,
  [SMALL_STATE(2541)] = 103151,
  [SMALL_STATE(2542)] = 103167,
  [SMALL_STATE(2543)] = 103183,
  [SMALL_STATE(2544)] = 103197,
  [SMALL_STATE(2545)] = 103213,
  [SMALL_STATE(2546)] = 103227,
  [SMALL_STATE(2547)] = 103241,
  [SMALL_STATE(2548)] = 103257,
  [SMALL_STATE(2549)] = 103273,
  [SMALL_STATE(2550)] = 103287,
  [SMALL_STATE(2551)] = 103303,
  [SMALL_STATE(2552)] = 103319,
  [SMALL_STATE(2553)] = 103335,
  [SMALL_STATE(2554)] = 103351,
  [SMALL_STATE(2555)] = 103367,
  [SMALL_STATE(2556)] = 103383,
  [SMALL_STATE(2557)] = 103399,
  [SMALL_STATE(2558)] = 103415,
  [SMALL_STATE(2559)] = 103431,
  [SMALL_STATE(2560)] = 103445,
  [SMALL_STATE(2561)] = 103459,
  [SMALL_STATE(2562)] = 103475,
  [SMALL_STATE(2563)] = 103491,
  [SMALL_STATE(2564)] = 103507,
  [SMALL_STATE(2565)] = 103523,
  [SMALL_STATE(2566)] = 103537,
  [SMALL_STATE(2567)] = 103553,
  [SMALL_STATE(2568)] = 103569,
  [SMALL_STATE(2569)] = 103585,
  [SMALL_STATE(2570)] = 103601,
  [SMALL_STATE(2571)] = 103617,
  [SMALL_STATE(2572)] = 103629,
  [SMALL_STATE(2573)] = 103643,
  [SMALL_STATE(2574)] = 103659,
  [SMALL_STATE(2575)] = 103675,
  [SMALL_STATE(2576)] = 103689,
  [SMALL_STATE(2577)] = 103705,
  [SMALL_STATE(2578)] = 103721,
  [SMALL_STATE(2579)] = 103733,
  [SMALL_STATE(2580)] = 103749,
  [SMALL_STATE(2581)] = 103765,
  [SMALL_STATE(2582)] = 103779,
  [SMALL_STATE(2583)] = 103793,
  [SMALL_STATE(2584)] = 103807,
  [SMALL_STATE(2585)] = 103823,
  [SMALL_STATE(2586)] = 103839,
  [SMALL_STATE(2587)] = 103853,
  [SMALL_STATE(2588)] = 103869,
  [SMALL_STATE(2589)] = 103885,
  [SMALL_STATE(2590)] = 103901,
  [SMALL_STATE(2591)] = 103915,
  [SMALL_STATE(2592)] = 103931,
  [SMALL_STATE(2593)] = 103945,
  [SMALL_STATE(2594)] = 103959,
  [SMALL_STATE(2595)] = 103975,
  [SMALL_STATE(2596)] = 103985,
  [SMALL_STATE(2597)] = 103999,
  [SMALL_STATE(2598)] = 104013,
  [SMALL_STATE(2599)] = 104027,
  [SMALL_STATE(2600)] = 104043,
  [SMALL_STATE(2601)] = 104059,
  [SMALL_STATE(2602)] = 104075,
  [SMALL_STATE(2603)] = 104089,
  [SMALL_STATE(2604)] = 104105,
  [SMALL_STATE(2605)] = 104121,
  [SMALL_STATE(2606)] = 104133,
  [SMALL_STATE(2607)] = 104149,
  [SMALL_STATE(2608)] = 104165,
  [SMALL_STATE(2609)] = 104179,
  [SMALL_STATE(2610)] = 104193,
  [SMALL_STATE(2611)] = 104207,
  [SMALL_STATE(2612)] = 104219,
  [SMALL_STATE(2613)] = 104232,
  [SMALL_STATE(2614)] = 104241,
  [SMALL_STATE(2615)] = 104254,
  [SMALL_STATE(2616)] = 104267,
  [SMALL_STATE(2617)] = 104280,
  [SMALL_STATE(2618)] = 104293,
  [SMALL_STATE(2619)] = 104306,
  [SMALL_STATE(2620)] = 104319,
  [SMALL_STATE(2621)] = 104332,
  [SMALL_STATE(2622)] = 104345,
  [SMALL_STATE(2623)] = 104354,
  [SMALL_STATE(2624)] = 104367,
  [SMALL_STATE(2625)] = 104380,
  [SMALL_STATE(2626)] = 104393,
  [SMALL_STATE(2627)] = 104406,
  [SMALL_STATE(2628)] = 104419,
  [SMALL_STATE(2629)] = 104432,
  [SMALL_STATE(2630)] = 104441,
  [SMALL_STATE(2631)] = 104452,
  [SMALL_STATE(2632)] = 104461,
  [SMALL_STATE(2633)] = 104474,
  [SMALL_STATE(2634)] = 104487,
  [SMALL_STATE(2635)] = 104500,
  [SMALL_STATE(2636)] = 104509,
  [SMALL_STATE(2637)] = 104522,
  [SMALL_STATE(2638)] = 104533,
  [SMALL_STATE(2639)] = 104546,
  [SMALL_STATE(2640)] = 104555,
  [SMALL_STATE(2641)] = 104568,
  [SMALL_STATE(2642)] = 104581,
  [SMALL_STATE(2643)] = 104594,
  [SMALL_STATE(2644)] = 104607,
  [SMALL_STATE(2645)] = 104620,
  [SMALL_STATE(2646)] = 104633,
  [SMALL_STATE(2647)] = 104646,
  [SMALL_STATE(2648)] = 104659,
  [SMALL_STATE(2649)] = 104672,
  [SMALL_STATE(2650)] = 104685,
  [SMALL_STATE(2651)] = 104698,
  [SMALL_STATE(2652)] = 104707,
  [SMALL_STATE(2653)] = 104718,
  [SMALL_STATE(2654)] = 104731,
  [SMALL_STATE(2655)] = 104744,
  [SMALL_STATE(2656)] = 104757,
  [SMALL_STATE(2657)] = 104770,
  [SMALL_STATE(2658)] = 104783,
  [SMALL_STATE(2659)] = 104796,
  [SMALL_STATE(2660)] = 104807,
  [SMALL_STATE(2661)] = 104816,
  [SMALL_STATE(2662)] = 104825,
  [SMALL_STATE(2663)] = 104836,
  [SMALL_STATE(2664)] = 104845,
  [SMALL_STATE(2665)] = 104858,
  [SMALL_STATE(2666)] = 104867,
  [SMALL_STATE(2667)] = 104876,
  [SMALL_STATE(2668)] = 104889,
  [SMALL_STATE(2669)] = 104898,
  [SMALL_STATE(2670)] = 104911,
  [SMALL_STATE(2671)] = 104920,
  [SMALL_STATE(2672)] = 104933,
  [SMALL_STATE(2673)] = 104946,
  [SMALL_STATE(2674)] = 104959,
  [SMALL_STATE(2675)] = 104968,
  [SMALL_STATE(2676)] = 104981,
  [SMALL_STATE(2677)] = 104994,
  [SMALL_STATE(2678)] = 105007,
  [SMALL_STATE(2679)] = 105020,
  [SMALL_STATE(2680)] = 105033,
  [SMALL_STATE(2681)] = 105046,
  [SMALL_STATE(2682)] = 105059,
  [SMALL_STATE(2683)] = 105068,
  [SMALL_STATE(2684)] = 105077,
  [SMALL_STATE(2685)] = 105086,
  [SMALL_STATE(2686)] = 105099,
  [SMALL_STATE(2687)] = 105112,
  [SMALL_STATE(2688)] = 105121,
  [SMALL_STATE(2689)] = 105134,
  [SMALL_STATE(2690)] = 105147,
  [SMALL_STATE(2691)] = 105156,
  [SMALL_STATE(2692)] = 105167,
  [SMALL_STATE(2693)] = 105180,
  [SMALL_STATE(2694)] = 105189,
  [SMALL_STATE(2695)] = 105198,
  [SMALL_STATE(2696)] = 105207,
  [SMALL_STATE(2697)] = 105220,
  [SMALL_STATE(2698)] = 105233,
  [SMALL_STATE(2699)] = 105246,
  [SMALL_STATE(2700)] = 105259,
  [SMALL_STATE(2701)] = 105272,
  [SMALL_STATE(2702)] = 105285,
  [SMALL_STATE(2703)] = 105298,
  [SMALL_STATE(2704)] = 105311,
  [SMALL_STATE(2705)] = 105322,
  [SMALL_STATE(2706)] = 105335,
  [SMALL_STATE(2707)] = 105348,
  [SMALL_STATE(2708)] = 105359,
  [SMALL_STATE(2709)] = 105368,
  [SMALL_STATE(2710)] = 105379,
  [SMALL_STATE(2711)] = 105392,
  [SMALL_STATE(2712)] = 105401,
  [SMALL_STATE(2713)] = 105414,
  [SMALL_STATE(2714)] = 105423,
  [SMALL_STATE(2715)] = 105436,
  [SMALL_STATE(2716)] = 105449,
  [SMALL_STATE(2717)] = 105462,
  [SMALL_STATE(2718)] = 105473,
  [SMALL_STATE(2719)] = 105484,
  [SMALL_STATE(2720)] = 105497,
  [SMALL_STATE(2721)] = 105510,
  [SMALL_STATE(2722)] = 105523,
  [SMALL_STATE(2723)] = 105534,
  [SMALL_STATE(2724)] = 105547,
  [SMALL_STATE(2725)] = 105556,
  [SMALL_STATE(2726)] = 105569,
  [SMALL_STATE(2727)] = 105580,
  [SMALL_STATE(2728)] = 105589,
  [SMALL_STATE(2729)] = 105602,
  [SMALL_STATE(2730)] = 105611,
  [SMALL_STATE(2731)] = 105622,
  [SMALL_STATE(2732)] = 105631,
  [SMALL_STATE(2733)] = 105644,
  [SMALL_STATE(2734)] = 105653,
  [SMALL_STATE(2735)] = 105666,
  [SMALL_STATE(2736)] = 105675,
  [SMALL_STATE(2737)] = 105688,
  [SMALL_STATE(2738)] = 105701,
  [SMALL_STATE(2739)] = 105714,
  [SMALL_STATE(2740)] = 105727,
  [SMALL_STATE(2741)] = 105740,
  [SMALL_STATE(2742)] = 105749,
  [SMALL_STATE(2743)] = 105762,
  [SMALL_STATE(2744)] = 105775,
  [SMALL_STATE(2745)] = 105788,
  [SMALL_STATE(2746)] = 105801,
  [SMALL_STATE(2747)] = 105810,
  [SMALL_STATE(2748)] = 105823,
  [SMALL_STATE(2749)] = 105834,
  [SMALL_STATE(2750)] = 105847,
  [SMALL_STATE(2751)] = 105860,
  [SMALL_STATE(2752)] = 105873,
  [SMALL_STATE(2753)] = 105886,
  [SMALL_STATE(2754)] = 105899,
  [SMALL_STATE(2755)] = 105908,
  [SMALL_STATE(2756)] = 105921,
  [SMALL_STATE(2757)] = 105930,
  [SMALL_STATE(2758)] = 105943,
  [SMALL_STATE(2759)] = 105956,
  [SMALL_STATE(2760)] = 105965,
  [SMALL_STATE(2761)] = 105978,
  [SMALL_STATE(2762)] = 105991,
  [SMALL_STATE(2763)] = 106002,
  [SMALL_STATE(2764)] = 106015,
  [SMALL_STATE(2765)] = 106028,
  [SMALL_STATE(2766)] = 106041,
  [SMALL_STATE(2767)] = 106054,
  [SMALL_STATE(2768)] = 106067,
  [SMALL_STATE(2769)] = 106080,
  [SMALL_STATE(2770)] = 106093,
  [SMALL_STATE(2771)] = 106106,
  [SMALL_STATE(2772)] = 106119,
  [SMALL_STATE(2773)] = 106132,
  [SMALL_STATE(2774)] = 106141,
  [SMALL_STATE(2775)] = 106154,
  [SMALL_STATE(2776)] = 106167,
  [SMALL_STATE(2777)] = 106180,
  [SMALL_STATE(2778)] = 106193,
  [SMALL_STATE(2779)] = 106206,
  [SMALL_STATE(2780)] = 106219,
  [SMALL_STATE(2781)] = 106232,
  [SMALL_STATE(2782)] = 106245,
  [SMALL_STATE(2783)] = 106254,
  [SMALL_STATE(2784)] = 106263,
  [SMALL_STATE(2785)] = 106276,
  [SMALL_STATE(2786)] = 106285,
  [SMALL_STATE(2787)] = 106298,
  [SMALL_STATE(2788)] = 106311,
  [SMALL_STATE(2789)] = 106324,
  [SMALL_STATE(2790)] = 106333,
  [SMALL_STATE(2791)] = 106346,
  [SMALL_STATE(2792)] = 106355,
  [SMALL_STATE(2793)] = 106368,
  [SMALL_STATE(2794)] = 106377,
  [SMALL_STATE(2795)] = 106385,
  [SMALL_STATE(2796)] = 106395,
  [SMALL_STATE(2797)] = 106405,
  [SMALL_STATE(2798)] = 106415,
  [SMALL_STATE(2799)] = 106423,
  [SMALL_STATE(2800)] = 106433,
  [SMALL_STATE(2801)] = 106443,
  [SMALL_STATE(2802)] = 106453,
  [SMALL_STATE(2803)] = 106463,
  [SMALL_STATE(2804)] = 106473,
  [SMALL_STATE(2805)] = 106483,
  [SMALL_STATE(2806)] = 106491,
  [SMALL_STATE(2807)] = 106501,
  [SMALL_STATE(2808)] = 106511,
  [SMALL_STATE(2809)] = 106521,
  [SMALL_STATE(2810)] = 106531,
  [SMALL_STATE(2811)] = 106541,
  [SMALL_STATE(2812)] = 106549,
  [SMALL_STATE(2813)] = 106559,
  [SMALL_STATE(2814)] = 106569,
  [SMALL_STATE(2815)] = 106577,
  [SMALL_STATE(2816)] = 106587,
  [SMALL_STATE(2817)] = 106595,
  [SMALL_STATE(2818)] = 106605,
  [SMALL_STATE(2819)] = 106615,
  [SMALL_STATE(2820)] = 106623,
  [SMALL_STATE(2821)] = 106631,
  [SMALL_STATE(2822)] = 106641,
  [SMALL_STATE(2823)] = 106651,
  [SMALL_STATE(2824)] = 106659,
  [SMALL_STATE(2825)] = 106669,
  [SMALL_STATE(2826)] = 106679,
  [SMALL_STATE(2827)] = 106689,
  [SMALL_STATE(2828)] = 106699,
  [SMALL_STATE(2829)] = 106707,
  [SMALL_STATE(2830)] = 106717,
  [SMALL_STATE(2831)] = 106727,
  [SMALL_STATE(2832)] = 106735,
  [SMALL_STATE(2833)] = 106745,
  [SMALL_STATE(2834)] = 106755,
  [SMALL_STATE(2835)] = 106765,
  [SMALL_STATE(2836)] = 106775,
  [SMALL_STATE(2837)] = 106785,
  [SMALL_STATE(2838)] = 106795,
  [SMALL_STATE(2839)] = 106803,
  [SMALL_STATE(2840)] = 106811,
  [SMALL_STATE(2841)] = 106821,
  [SMALL_STATE(2842)] = 106831,
  [SMALL_STATE(2843)] = 106841,
  [SMALL_STATE(2844)] = 106851,
  [SMALL_STATE(2845)] = 106861,
  [SMALL_STATE(2846)] = 106869,
  [SMALL_STATE(2847)] = 106877,
  [SMALL_STATE(2848)] = 106887,
  [SMALL_STATE(2849)] = 106895,
  [SMALL_STATE(2850)] = 106903,
  [SMALL_STATE(2851)] = 106913,
  [SMALL_STATE(2852)] = 106923,
  [SMALL_STATE(2853)] = 106931,
  [SMALL_STATE(2854)] = 106941,
  [SMALL_STATE(2855)] = 106949,
  [SMALL_STATE(2856)] = 106959,
  [SMALL_STATE(2857)] = 106969,
  [SMALL_STATE(2858)] = 106979,
  [SMALL_STATE(2859)] = 106989,
  [SMALL_STATE(2860)] = 106999,
  [SMALL_STATE(2861)] = 107009,
  [SMALL_STATE(2862)] = 107019,
  [SMALL_STATE(2863)] = 107029,
  [SMALL_STATE(2864)] = 107039,
  [SMALL_STATE(2865)] = 107049,
  [SMALL_STATE(2866)] = 107057,
  [SMALL_STATE(2867)] = 107067,
  [SMALL_STATE(2868)] = 107077,
  [SMALL_STATE(2869)] = 107087,
  [SMALL_STATE(2870)] = 107097,
  [SMALL_STATE(2871)] = 107107,
  [SMALL_STATE(2872)] = 107115,
  [SMALL_STATE(2873)] = 107123,
  [SMALL_STATE(2874)] = 107131,
  [SMALL_STATE(2875)] = 107141,
  [SMALL_STATE(2876)] = 107151,
  [SMALL_STATE(2877)] = 107161,
  [SMALL_STATE(2878)] = 107171,
  [SMALL_STATE(2879)] = 107181,
  [SMALL_STATE(2880)] = 107191,
  [SMALL_STATE(2881)] = 107199,
  [SMALL_STATE(2882)] = 107209,
  [SMALL_STATE(2883)] = 107219,
  [SMALL_STATE(2884)] = 107229,
  [SMALL_STATE(2885)] = 107237,
  [SMALL_STATE(2886)] = 107245,
  [SMALL_STATE(2887)] = 107253,
  [SMALL_STATE(2888)] = 107263,
  [SMALL_STATE(2889)] = 107273,
  [SMALL_STATE(2890)] = 107283,
  [SMALL_STATE(2891)] = 107293,
  [SMALL_STATE(2892)] = 107301,
  [SMALL_STATE(2893)] = 107311,
  [SMALL_STATE(2894)] = 107319,
  [SMALL_STATE(2895)] = 107329,
  [SMALL_STATE(2896)] = 107337,
  [SMALL_STATE(2897)] = 107347,
  [SMALL_STATE(2898)] = 107357,
  [SMALL_STATE(2899)] = 107367,
  [SMALL_STATE(2900)] = 107377,
  [SMALL_STATE(2901)] = 107387,
  [SMALL_STATE(2902)] = 107397,
  [SMALL_STATE(2903)] = 107407,
  [SMALL_STATE(2904)] = 107417,
  [SMALL_STATE(2905)] = 107427,
  [SMALL_STATE(2906)] = 107437,
  [SMALL_STATE(2907)] = 107447,
  [SMALL_STATE(2908)] = 107457,
  [SMALL_STATE(2909)] = 107465,
  [SMALL_STATE(2910)] = 107475,
  [SMALL_STATE(2911)] = 107483,
  [SMALL_STATE(2912)] = 107493,
  [SMALL_STATE(2913)] = 107501,
  [SMALL_STATE(2914)] = 107511,
  [SMALL_STATE(2915)] = 107521,
  [SMALL_STATE(2916)] = 107531,
  [SMALL_STATE(2917)] = 107541,
  [SMALL_STATE(2918)] = 107551,
  [SMALL_STATE(2919)] = 107561,
  [SMALL_STATE(2920)] = 107569,
  [SMALL_STATE(2921)] = 107579,
  [SMALL_STATE(2922)] = 107589,
  [SMALL_STATE(2923)] = 107599,
  [SMALL_STATE(2924)] = 107609,
  [SMALL_STATE(2925)] = 107619,
  [SMALL_STATE(2926)] = 107629,
  [SMALL_STATE(2927)] = 107639,
  [SMALL_STATE(2928)] = 107647,
  [SMALL_STATE(2929)] = 107657,
  [SMALL_STATE(2930)] = 107667,
  [SMALL_STATE(2931)] = 107677,
  [SMALL_STATE(2932)] = 107687,
  [SMALL_STATE(2933)] = 107697,
  [SMALL_STATE(2934)] = 107707,
  [SMALL_STATE(2935)] = 107715,
  [SMALL_STATE(2936)] = 107725,
  [SMALL_STATE(2937)] = 107735,
  [SMALL_STATE(2938)] = 107745,
  [SMALL_STATE(2939)] = 107755,
  [SMALL_STATE(2940)] = 107763,
  [SMALL_STATE(2941)] = 107773,
  [SMALL_STATE(2942)] = 107783,
  [SMALL_STATE(2943)] = 107793,
  [SMALL_STATE(2944)] = 107803,
  [SMALL_STATE(2945)] = 107811,
  [SMALL_STATE(2946)] = 107821,
  [SMALL_STATE(2947)] = 107829,
  [SMALL_STATE(2948)] = 107839,
  [SMALL_STATE(2949)] = 107849,
  [SMALL_STATE(2950)] = 107859,
  [SMALL_STATE(2951)] = 107867,
  [SMALL_STATE(2952)] = 107877,
  [SMALL_STATE(2953)] = 107887,
  [SMALL_STATE(2954)] = 107897,
  [SMALL_STATE(2955)] = 107907,
  [SMALL_STATE(2956)] = 107915,
  [SMALL_STATE(2957)] = 107925,
  [SMALL_STATE(2958)] = 107935,
  [SMALL_STATE(2959)] = 107945,
  [SMALL_STATE(2960)] = 107955,
  [SMALL_STATE(2961)] = 107965,
  [SMALL_STATE(2962)] = 107975,
  [SMALL_STATE(2963)] = 107985,
  [SMALL_STATE(2964)] = 107995,
  [SMALL_STATE(2965)] = 108003,
  [SMALL_STATE(2966)] = 108011,
  [SMALL_STATE(2967)] = 108021,
  [SMALL_STATE(2968)] = 108031,
  [SMALL_STATE(2969)] = 108039,
  [SMALL_STATE(2970)] = 108047,
  [SMALL_STATE(2971)] = 108057,
  [SMALL_STATE(2972)] = 108067,
  [SMALL_STATE(2973)] = 108075,
  [SMALL_STATE(2974)] = 108083,
  [SMALL_STATE(2975)] = 108093,
  [SMALL_STATE(2976)] = 108101,
  [SMALL_STATE(2977)] = 108111,
  [SMALL_STATE(2978)] = 108121,
  [SMALL_STATE(2979)] = 108131,
  [SMALL_STATE(2980)] = 108139,
  [SMALL_STATE(2981)] = 108147,
  [SMALL_STATE(2982)] = 108157,
  [SMALL_STATE(2983)] = 108167,
  [SMALL_STATE(2984)] = 108177,
  [SMALL_STATE(2985)] = 108187,
  [SMALL_STATE(2986)] = 108197,
  [SMALL_STATE(2987)] = 108207,
  [SMALL_STATE(2988)] = 108217,
  [SMALL_STATE(2989)] = 108227,
  [SMALL_STATE(2990)] = 108237,
  [SMALL_STATE(2991)] = 108247,
  [SMALL_STATE(2992)] = 108257,
  [SMALL_STATE(2993)] = 108267,
  [SMALL_STATE(2994)] = 108277,
  [SMALL_STATE(2995)] = 108287,
  [SMALL_STATE(2996)] = 108297,
  [SMALL_STATE(2997)] = 108307,
  [SMALL_STATE(2998)] = 108317,
  [SMALL_STATE(2999)] = 108327,
  [SMALL_STATE(3000)] = 108337,
  [SMALL_STATE(3001)] = 108347,
  [SMALL_STATE(3002)] = 108357,
  [SMALL_STATE(3003)] = 108367,
  [SMALL_STATE(3004)] = 108377,
  [SMALL_STATE(3005)] = 108387,
  [SMALL_STATE(3006)] = 108395,
  [SMALL_STATE(3007)] = 108403,
  [SMALL_STATE(3008)] = 108411,
  [SMALL_STATE(3009)] = 108421,
  [SMALL_STATE(3010)] = 108429,
  [SMALL_STATE(3011)] = 108436,
  [SMALL_STATE(3012)] = 108443,
  [SMALL_STATE(3013)] = 108450,
  [SMALL_STATE(3014)] = 108457,
  [SMALL_STATE(3015)] = 108464,
  [SMALL_STATE(3016)] = 108471,
  [SMALL_STATE(3017)] = 108478,
  [SMALL_STATE(3018)] = 108485,
  [SMALL_STATE(3019)] = 108492,
  [SMALL_STATE(3020)] = 108499,
  [SMALL_STATE(3021)] = 108506,
  [SMALL_STATE(3022)] = 108513,
  [SMALL_STATE(3023)] = 108520,
  [SMALL_STATE(3024)] = 108527,
  [SMALL_STATE(3025)] = 108534,
  [SMALL_STATE(3026)] = 108541,
  [SMALL_STATE(3027)] = 108548,
  [SMALL_STATE(3028)] = 108555,
  [SMALL_STATE(3029)] = 108562,
  [SMALL_STATE(3030)] = 108569,
  [SMALL_STATE(3031)] = 108576,
  [SMALL_STATE(3032)] = 108583,
  [SMALL_STATE(3033)] = 108590,
  [SMALL_STATE(3034)] = 108597,
  [SMALL_STATE(3035)] = 108604,
  [SMALL_STATE(3036)] = 108611,
  [SMALL_STATE(3037)] = 108618,
  [SMALL_STATE(3038)] = 108625,
  [SMALL_STATE(3039)] = 108632,
  [SMALL_STATE(3040)] = 108639,
  [SMALL_STATE(3041)] = 108646,
  [SMALL_STATE(3042)] = 108653,
  [SMALL_STATE(3043)] = 108660,
  [SMALL_STATE(3044)] = 108667,
  [SMALL_STATE(3045)] = 108674,
  [SMALL_STATE(3046)] = 108681,
  [SMALL_STATE(3047)] = 108688,
  [SMALL_STATE(3048)] = 108695,
  [SMALL_STATE(3049)] = 108702,
  [SMALL_STATE(3050)] = 108709,
  [SMALL_STATE(3051)] = 108716,
  [SMALL_STATE(3052)] = 108723,
  [SMALL_STATE(3053)] = 108730,
  [SMALL_STATE(3054)] = 108737,
  [SMALL_STATE(3055)] = 108744,
  [SMALL_STATE(3056)] = 108751,
  [SMALL_STATE(3057)] = 108758,
  [SMALL_STATE(3058)] = 108765,
  [SMALL_STATE(3059)] = 108772,
  [SMALL_STATE(3060)] = 108779,
  [SMALL_STATE(3061)] = 108786,
  [SMALL_STATE(3062)] = 108793,
  [SMALL_STATE(3063)] = 108800,
  [SMALL_STATE(3064)] = 108807,
  [SMALL_STATE(3065)] = 108814,
  [SMALL_STATE(3066)] = 108821,
  [SMALL_STATE(3067)] = 108828,
  [SMALL_STATE(3068)] = 108835,
  [SMALL_STATE(3069)] = 108842,
  [SMALL_STATE(3070)] = 108849,
  [SMALL_STATE(3071)] = 108856,
  [SMALL_STATE(3072)] = 108863,
  [SMALL_STATE(3073)] = 108870,
  [SMALL_STATE(3074)] = 108877,
  [SMALL_STATE(3075)] = 108884,
  [SMALL_STATE(3076)] = 108891,
  [SMALL_STATE(3077)] = 108898,
  [SMALL_STATE(3078)] = 108905,
  [SMALL_STATE(3079)] = 108912,
  [SMALL_STATE(3080)] = 108919,
  [SMALL_STATE(3081)] = 108926,
  [SMALL_STATE(3082)] = 108933,
  [SMALL_STATE(3083)] = 108940,
  [SMALL_STATE(3084)] = 108947,
  [SMALL_STATE(3085)] = 108954,
  [SMALL_STATE(3086)] = 108961,
  [SMALL_STATE(3087)] = 108968,
  [SMALL_STATE(3088)] = 108975,
  [SMALL_STATE(3089)] = 108982,
  [SMALL_STATE(3090)] = 108989,
  [SMALL_STATE(3091)] = 108996,
  [SMALL_STATE(3092)] = 109003,
  [SMALL_STATE(3093)] = 109010,
  [SMALL_STATE(3094)] = 109017,
  [SMALL_STATE(3095)] = 109024,
  [SMALL_STATE(3096)] = 109031,
  [SMALL_STATE(3097)] = 109038,
  [SMALL_STATE(3098)] = 109045,
  [SMALL_STATE(3099)] = 109052,
  [SMALL_STATE(3100)] = 109059,
  [SMALL_STATE(3101)] = 109066,
  [SMALL_STATE(3102)] = 109073,
  [SMALL_STATE(3103)] = 109080,
  [SMALL_STATE(3104)] = 109087,
  [SMALL_STATE(3105)] = 109094,
  [SMALL_STATE(3106)] = 109101,
  [SMALL_STATE(3107)] = 109108,
  [SMALL_STATE(3108)] = 109115,
  [SMALL_STATE(3109)] = 109122,
  [SMALL_STATE(3110)] = 109129,
  [SMALL_STATE(3111)] = 109136,
  [SMALL_STATE(3112)] = 109143,
  [SMALL_STATE(3113)] = 109150,
  [SMALL_STATE(3114)] = 109157,
  [SMALL_STATE(3115)] = 109164,
  [SMALL_STATE(3116)] = 109171,
  [SMALL_STATE(3117)] = 109178,
  [SMALL_STATE(3118)] = 109185,
  [SMALL_STATE(3119)] = 109192,
  [SMALL_STATE(3120)] = 109199,
  [SMALL_STATE(3121)] = 109206,
  [SMALL_STATE(3122)] = 109213,
  [SMALL_STATE(3123)] = 109220,
  [SMALL_STATE(3124)] = 109227,
  [SMALL_STATE(3125)] = 109234,
  [SMALL_STATE(3126)] = 109241,
  [SMALL_STATE(3127)] = 109248,
  [SMALL_STATE(3128)] = 109255,
  [SMALL_STATE(3129)] = 109262,
  [SMALL_STATE(3130)] = 109269,
  [SMALL_STATE(3131)] = 109276,
  [SMALL_STATE(3132)] = 109283,
  [SMALL_STATE(3133)] = 109290,
  [SMALL_STATE(3134)] = 109297,
  [SMALL_STATE(3135)] = 109304,
  [SMALL_STATE(3136)] = 109311,
  [SMALL_STATE(3137)] = 109318,
  [SMALL_STATE(3138)] = 109325,
  [SMALL_STATE(3139)] = 109332,
  [SMALL_STATE(3140)] = 109339,
  [SMALL_STATE(3141)] = 109346,
  [SMALL_STATE(3142)] = 109353,
  [SMALL_STATE(3143)] = 109360,
  [SMALL_STATE(3144)] = 109367,
  [SMALL_STATE(3145)] = 109374,
  [SMALL_STATE(3146)] = 109381,
  [SMALL_STATE(3147)] = 109388,
  [SMALL_STATE(3148)] = 109395,
  [SMALL_STATE(3149)] = 109402,
  [SMALL_STATE(3150)] = 109409,
  [SMALL_STATE(3151)] = 109416,
  [SMALL_STATE(3152)] = 109423,
  [SMALL_STATE(3153)] = 109430,
  [SMALL_STATE(3154)] = 109437,
  [SMALL_STATE(3155)] = 109444,
  [SMALL_STATE(3156)] = 109451,
  [SMALL_STATE(3157)] = 109458,
  [SMALL_STATE(3158)] = 109465,
  [SMALL_STATE(3159)] = 109472,
  [SMALL_STATE(3160)] = 109479,
  [SMALL_STATE(3161)] = 109486,
  [SMALL_STATE(3162)] = 109493,
  [SMALL_STATE(3163)] = 109500,
  [SMALL_STATE(3164)] = 109507,
  [SMALL_STATE(3165)] = 109514,
  [SMALL_STATE(3166)] = 109521,
  [SMALL_STATE(3167)] = 109528,
  [SMALL_STATE(3168)] = 109535,
  [SMALL_STATE(3169)] = 109542,
  [SMALL_STATE(3170)] = 109549,
  [SMALL_STATE(3171)] = 109556,
  [SMALL_STATE(3172)] = 109563,
  [SMALL_STATE(3173)] = 109570,
  [SMALL_STATE(3174)] = 109577,
  [SMALL_STATE(3175)] = 109584,
  [SMALL_STATE(3176)] = 109591,
  [SMALL_STATE(3177)] = 109598,
  [SMALL_STATE(3178)] = 109605,
  [SMALL_STATE(3179)] = 109612,
  [SMALL_STATE(3180)] = 109619,
  [SMALL_STATE(3181)] = 109626,
  [SMALL_STATE(3182)] = 109633,
  [SMALL_STATE(3183)] = 109640,
  [SMALL_STATE(3184)] = 109647,
  [SMALL_STATE(3185)] = 109654,
  [SMALL_STATE(3186)] = 109661,
  [SMALL_STATE(3187)] = 109668,
  [SMALL_STATE(3188)] = 109675,
  [SMALL_STATE(3189)] = 109682,
  [SMALL_STATE(3190)] = 109689,
  [SMALL_STATE(3191)] = 109696,
  [SMALL_STATE(3192)] = 109703,
  [SMALL_STATE(3193)] = 109710,
  [SMALL_STATE(3194)] = 109717,
  [SMALL_STATE(3195)] = 109724,
  [SMALL_STATE(3196)] = 109731,
  [SMALL_STATE(3197)] = 109738,
  [SMALL_STATE(3198)] = 109745,
  [SMALL_STATE(3199)] = 109752,
  [SMALL_STATE(3200)] = 109759,
  [SMALL_STATE(3201)] = 109766,
  [SMALL_STATE(3202)] = 109773,
  [SMALL_STATE(3203)] = 109780,
  [SMALL_STATE(3204)] = 109787,
  [SMALL_STATE(3205)] = 109794,
  [SMALL_STATE(3206)] = 109801,
  [SMALL_STATE(3207)] = 109808,
  [SMALL_STATE(3208)] = 109815,
  [SMALL_STATE(3209)] = 109822,
  [SMALL_STATE(3210)] = 109829,
  [SMALL_STATE(3211)] = 109836,
  [SMALL_STATE(3212)] = 109843,
  [SMALL_STATE(3213)] = 109850,
  [SMALL_STATE(3214)] = 109857,
  [SMALL_STATE(3215)] = 109864,
  [SMALL_STATE(3216)] = 109871,
  [SMALL_STATE(3217)] = 109878,
  [SMALL_STATE(3218)] = 109885,
  [SMALL_STATE(3219)] = 109892,
  [SMALL_STATE(3220)] = 109899,
  [SMALL_STATE(3221)] = 109906,
  [SMALL_STATE(3222)] = 109913,
  [SMALL_STATE(3223)] = 109920,
  [SMALL_STATE(3224)] = 109927,
  [SMALL_STATE(3225)] = 109934,
  [SMALL_STATE(3226)] = 109941,
  [SMALL_STATE(3227)] = 109948,
  [SMALL_STATE(3228)] = 109955,
  [SMALL_STATE(3229)] = 109962,
  [SMALL_STATE(3230)] = 109969,
  [SMALL_STATE(3231)] = 109976,
  [SMALL_STATE(3232)] = 109983,
  [SMALL_STATE(3233)] = 109990,
  [SMALL_STATE(3234)] = 109997,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(758),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(129),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(649),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(407),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(725),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3181),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(151),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(644),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(961),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2082),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3229),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2255),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2254),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(374),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2804),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2807),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2740),
  [257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(112),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(341),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2809),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(36),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2810),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2812),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2707),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2704),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2814),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(161),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(217),
  [290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(537),
  [293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(54),
  [296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(137),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2028),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(474),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2098),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3219),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(739),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(227),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(374),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3218),
  [323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(801),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(356),
  [329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(284),
  [332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2547),
  [335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2551),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2241),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1497),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1497),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2700),
  [350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 83),
  [360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 83),
  [362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 83),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 83),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2844),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(413),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2853),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 80),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 80),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 80),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 80),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 131),
  [978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 131),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 131),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 131),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 131),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 131),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 131),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 131),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 138),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 138),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 138),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 138),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 118),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 118),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 118),
  [1016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 118),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 159),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 159),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 159),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 159),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 161),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 161),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 161),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 79),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 79),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 79),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 79),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 27),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 27),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 102),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 102),
  [1058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 102),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 102),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1),
  [1066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 1),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 29),
  [1078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 29),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 29),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 29),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 137),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 137),
  [1094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 137),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 137),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 110),
  [1102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 110),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 110),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 110),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [1170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [1176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [1212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(29),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [1225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [1238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [1335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1898),
  [1338] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1775),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [1348] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2853),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [1394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 107),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 107),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [1462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 16),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 16),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 3),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 3),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 4),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 4),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [1542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [1544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5),
  [1570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [1572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [1574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 2),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 2),
  [1582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [1584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [1586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [1588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 1),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 1),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 14),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 14),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [1638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1775),
  [1641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2853),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [1692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(194),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, .production_id = 49),
  [1712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, .production_id = 49),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 16),
  [1720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 16),
  [1722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 16), SHIFT(853),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [1741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1), SHIFT(853),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 107),
  [1749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(195),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [1764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 191),
  [1766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 191),
  [1768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 6, .production_id = 144),
  [1770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 6, .production_id = 144),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3),
  [1776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [1784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 45),
  [1786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 45),
  [1788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 172),
  [1794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 172),
  [1796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 171),
  [1798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 171),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 170),
  [1802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 170),
  [1804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 37),
  [1806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 37),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [1812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 118),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 118),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 38),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 38),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 160),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 160),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 131),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 131),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 131),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 131),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [1848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [1850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [1854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [1856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [1858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 118),
  [1860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 118),
  [1862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 29),
  [1868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 29),
  [1870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 39),
  [1872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 39),
  [1874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 103),
  [1876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 103),
  [1878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [1880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [1882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 80),
  [1884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 80),
  [1886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 79),
  [1888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 79),
  [1890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 101),
  [1892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 101),
  [1894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 181),
  [1896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 181),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [1900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [1902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 123),
  [1904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 123),
  [1906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [1908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 29),
  [1912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 29),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 159),
  [1916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 159),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [1920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 79),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 79),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [1940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [1942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [1944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [1946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 130),
  [1948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 130),
  [1950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 102),
  [1952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 102),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 44),
  [1956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 44),
  [1958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 137),
  [1960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 137),
  [1962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 132),
  [1964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 132),
  [1966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 147),
  [1968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 147),
  [1970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 133),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 133),
  [1974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [1976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 46),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 46),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 94),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 94),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 47),
  [2008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 47),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 48),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 48),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 48),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 48),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 138),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 138),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 162),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 162),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 143),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 143),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 163),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 163),
  [2042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 169),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 88),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 88),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 119),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 119),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 136),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 136),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 140),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 140),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 89),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 89),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 36),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 36),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 110),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 110),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 117),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 117),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 167),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 167),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 166),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 166),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 168),
  [2132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 168),
  [2134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 165),
  [2136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 165),
  [2138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4),
  [2140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4),
  [2142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 145),
  [2148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 145),
  [2150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 146),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 146),
  [2154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 148),
  [2156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 148),
  [2158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 149),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 149),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [2192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [2204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 16),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 16),
  [2214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(853),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [2219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(858),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 59),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 59),
  [2226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 59),
  [2229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 59),
  [2232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 59), REDUCE(sym_nested_type_identifier, 3, .production_id = 107),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 74),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 74),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 108),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 108),
  [2245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 23),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 23),
  [2249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 59), REDUCE(sym_nested_type_identifier, 3, .production_id = 107),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(215),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 115),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 115),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 134),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 134),
  [2277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [2297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [2311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [2359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1), SHIFT(402),
  [2362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [2367] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 16),
  [2371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 49),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2, .production_id = 49),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [2472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(949),
  [2475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 49),
  [2477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 49),
  [2479] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__rest_identifier, 2),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rest_identifier, 2),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(200),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [2645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__tuple_type_identifier, 1),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_identifier, 1),
  [2650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(2759),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [2723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [2747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [2755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [2757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [2841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [2876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [2878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [2880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [2882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [2890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [2892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [2894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [2896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 28),
  [2898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 28),
  [2900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [2902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [2906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 16), SHIFT(922),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 28),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 28),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [2921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [2924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(922),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [2950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [2954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(56),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [2979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 99),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 97),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(250),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 22),
  [3010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(203),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 107),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 135),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [3030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 61),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 62),
  [3040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(56),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 61),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 61),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 66),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 64),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 64),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 109),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 109),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [3139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 76), REDUCE(sym_assignment_expression, 3, .production_id = 22),
  [3142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 76),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 62),
  [3146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [3150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(58),
  [3153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2),
  [3161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 75),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 75),
  [3189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(58),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [3198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [3204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [3206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 52),
  [3208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 52),
  [3210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 51),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 51),
  [3214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 50),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 50),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [3222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [3254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 106),
  [3256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 106),
  [3258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 105),
  [3260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 105),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [3264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 104),
  [3270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 104),
  [3272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 139),
  [3274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 139),
  [3276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 13),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 13),
  [3280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 65), REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 65),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 98),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 98),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [3291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 26),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 26),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 25),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 112),
  [3301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 112),
  [3303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 76), REDUCE(sym_assignment_expression, 3, .production_id = 61),
  [3306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 66), REDUCE(sym_assignment_expression, 3, .production_id = 66),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 66),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 111),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 111),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 99),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 98),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 98),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 97),
  [3337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 96),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 96),
  [3341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(60),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 83),
  [3350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(866),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [3355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 135),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [3381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 16), SHIFT(866),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [3394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [3398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 57),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 57),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [3404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(53),
  [3407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(53),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [3414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 61),
  [3416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 66),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [3428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(60),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 61),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 22),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [3443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [3455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(55),
  [3470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(55),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [3475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [3493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [3509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(57),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 77),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [3516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(57),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [3533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [3545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 16), SHIFT(921),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [3552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1),
  [3554] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [3568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(207),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [3577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(206),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [3594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(921),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [3621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [3623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [3627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [3629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [3631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [3637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [3639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [3643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [3645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [3647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [3661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [3667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [3669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [3671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [3673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [3683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [3687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(377),
  [3690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [3698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [3712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [3714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [3728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(378),
  [3731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [3743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [3745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [3765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1985),
  [3778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1894),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(244),
  [3786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1739),
  [3789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1883),
  [3792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1760),
  [3795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3022),
  [3798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2570),
  [3801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2568),
  [3804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1939),
  [3807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2700),
  [3810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1728),
  [3813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1735),
  [3816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1716),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [3889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [3915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [3933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [3941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [3995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [4013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [4015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [4055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 59),
  [4057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 59),
  [4059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [4069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [4071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [4073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 142),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 142),
  [4077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 193),
  [4079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 193),
  [4081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 78),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 78),
  [4085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 102),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 102),
  [4089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [4093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [4107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [4111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [4117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 164),
  [4119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 164),
  [4121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 159),
  [4123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 159),
  [4125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 192),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 192),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [4133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [4139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 183),
  [4141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 183),
  [4143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 182),
  [4145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 182),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [4153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 197),
  [4155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 197),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [4161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [4173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [4175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21),
  [4177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 21), SHIFT_REPEAT(2700),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [4200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [4206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [4224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 73),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [4272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 124),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [4282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 158),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [4296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 73),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [4302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 16), REDUCE(sym_type_parameter, 1, .production_id = 16),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [4307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 16), SHIFT(956),
  [4310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 124),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [4318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 158),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [4332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 158),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 158),
  [4336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 124),
  [4338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 16),
  [4341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 124),
  [4343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2),
  [4345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 73),
  [4347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 73),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [4351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [4365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [4367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [4375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [4393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [4403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [4421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3),
  [4423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [4428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [4439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [4441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [4449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 130),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 128),
  [4453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 101),
  [4455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [4467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [4473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 151),
  [4475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [4477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [4483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2),
  [4485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 121),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [4497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 173),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [4503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 95),
  [4505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [4507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 178),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [4519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 186),
  [4521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 6, .production_id = 150),
  [4523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 16),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [4529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 199),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [4549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 194),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [4555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 187),
  [4557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 196),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [4567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3099),
  [4570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [4572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(193),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [4589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [4607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 19),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [4615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [4677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [4693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2205),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [4698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(236),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [4715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [4741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 68),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [4785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [4801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1012),
  [4804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [4816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [4818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 31),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 31),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [4830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 93),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 92),
  [4834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3),
  [4836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 91),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 126),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [4844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 84),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [4854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 126),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [4858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 84),
  [4860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [4874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [4876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 58),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4),
  [4880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 153),
  [4882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 155),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [4888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4),
  [4890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 153),
  [4892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 155),
  [4894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 42),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [4898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 175),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 180),
  [4910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 175),
  [4912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 180),
  [4914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 185),
  [4916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 41),
  [4918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 40),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 185),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [4926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 189),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [4934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 198),
  [4936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 189),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [4940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [4942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 91),
  [4944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [4950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [5008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(902),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [5035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3),
  [5053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 49),
  [5055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [5059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [5063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [5065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [5085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [5089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [5093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [5097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [5101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [5105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [5107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3, .production_id = 49),
  [5109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [5117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(154),
  [5120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2176),
  [5123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [5137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [5145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [5153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(145),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [5174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 16),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [5186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 1),
  [5188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(165),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [5199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [5201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2606),
  [5204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2606),
  [5207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [5209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2607),
  [5212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2607),
  [5215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [5217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [5219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 16),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [5225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 127),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [5245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_identifier, 1),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [5249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [5251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [5253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [5257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 73),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [5267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1881),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [5280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [5286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [5292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 114),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [5304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 130),
  [5306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 152),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [5310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 84),
  [5312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [5314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2), SHIFT_REPEAT(2072),
  [5317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2),
  [5319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 85),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [5325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 154),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [5331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 151),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 156),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [5339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 86),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [5347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 157),
  [5353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 85),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 87),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [5365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [5367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3144),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 125),
  [5385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 21), SHIFT_REPEAT(1803),
  [5388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 21),
  [5390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 101),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [5406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 173),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 174),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [5428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 176),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 177),
  [5434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2627),
  [5437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [5447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 178),
  [5449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 179),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [5455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_identifier, 2),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2913),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 184),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [5490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1674),
  [5493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [5501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 186),
  [5503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 188),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [5509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 190),
  [5511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2648),
  [5514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 114),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [5530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 195),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 81),
  [5534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 113),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [5540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 114),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 16),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_tuple_type_member, 2),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 43),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [5576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 120),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 122),
  [5582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 90),
  [5584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 90),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 141),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [5612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 70),
  [5614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [5622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 43),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [5638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [5668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [5682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 81),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [5702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [5704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 81),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [5710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [5714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3024),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 81),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [5928] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [5938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3146),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_ekscript_external_scanner_create(void);
void tree_sitter_ekscript_external_scanner_destroy(void *);
bool tree_sitter_ekscript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ekscript_external_scanner_serialize(void *, char *);
void tree_sitter_ekscript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ekscript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const uint16_t *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ekscript_external_scanner_create,
      tree_sitter_ekscript_external_scanner_destroy,
      tree_sitter_ekscript_external_scanner_scan,
      tree_sitter_ekscript_external_scanner_serialize,
      tree_sitter_ekscript_external_scanner_deserialize,
    },
    .field_count = FIELD_COUNT,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .field_names = ts_field_names,
    .large_state_count = LARGE_STATE_COUNT,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .state_count = STATE_COUNT,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
